# Braket.jl

**Braket.jl is not an officially supported AWS product.**

This package is a Julia implementation of the [Amazon Braket SDK](https://github.com/aws/amazon-braket-sdk-python) allowing customers to access [Quantum Hardware and Simulators](https://aws.amazon.com/braket/quantum-computers/). 

This is *experimental* software, and support may be discontinued in the future. For a fully supported SDK, please use
the [Python SDK](https://github.com/aws/amazon-braket-sdk-python). We may change, remove, or deprecate parts of the API when making new releases.
Please review the [CHANGELOG](CHANGELOG.md) for information about changes in each release. 

[![Stable docs](https://img.shields.io/badge/docs-stable-blue.svg)](https://amazon-braket.github.io/Braket.jl/stable)
[![Latest docs](https://img.shields.io/badge/docs-dev-blue.svg)](https://amazon-braket.github.io/Braket.jl/dev)
[![CI](https://github.com/amazon-braket/braket.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/amazon-braket/braket.jl/actions/workflows/CI.yml)
[![codecov](https://codecov.io/gh/amazon-braket/braket.jl/graph/badge.svg?token=xocMQMNqAN)](https://codecov.io/gh/amazon-braket/braket.jl)

## Installation & Prerequisites

You do *not* need a Python installation or the Python Amazon Braket SDK installed to use this package.
However, to use the Amazon Braket Analog Hamiltonian Simulation [Local Simulator](https://docs.aws.amazon.com/braket/latest/developerguide/braket-send-to-local-simulator.html)
you'll need to install the sub-package `PyBraket.jl`,
included in this repository. See its [`README`](PyBraket/README.md) for more information.

For *gate based* local simulations, with or without noise, see [`BraketSimulator.jl`](https://github.com/amazon-braket/braketsimulator.jl).

All necessary Julia packages will be installed for you when you run `Pkg.add("Braket")`
or `] instantiate` (if you're doing a [`dev`](https://pkgdocs.julialang.org/v1/managing-packages/#developing) install).

If you want to run tasks on Amazon Braket's [managed simulators or QPUs](https://docs.aws.amazon.com/braket/latest/developerguide/braket-devices.html) or run
[managed jobs](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-works.html),
you will need an AWS account and to have [onboarded](https://docs.aws.amazon.com/braket/latest/developerguide/braket-enable-overview.html) with the Amazon Braket service.
`Braket.jl` can load your AWS credentials from your environment variables or your `~/.aws/config` file thanks to the [`AWS.jl`](https://github.com/JuliaCloud/AWS.jl) package.

## Usage Notes

Keep in mind that the first qubit has index `0`, **not** index `1`.
Some Amazon Braket Hybrid Jobs return results as pickled objects, which are currently not decompressible using `Braket.jl`.
In such cases you may need to download and extract the results using `PyBraket.jl` and the Amazon Braket SDK.

## Examples

Constructing a simple circuit:

```julia
using Braket

c = Circuit()
c = H(c, 0) # qubits are 0-indexed
c = CNot(c, 0, 1)
c = Probability(c)
```

Measuring expectation values on a QPU:

```julia
using Braket, Braket.Observables

c = Circuit()
c = H(c, 0)
c = CNot(c, 0, 1)
c = Expectation(c, Observables.X()) # measure X on all qubits

dev = AwsDevice("arn:aws:braket:us-east-1::device/qpu/ionq/Harmony")
res = result(dev(c, shots=10))
```

Simulating a noisy circuit locally:

```julia
using BraketSimulator, Braket

c = Circuit()
c = H(c, 0) # qubits are 0-indexed
c = CNot(c, 0, 1)
c = BitFlip(c, 0, 0.1)
c = PhaseFlip(c, 1, 0.2)
c = Probability(c)

dev = LocalSimulator("braket_dm_v2")
res = result(simulate(dev, c, shots=200))
``` 

## TODO and development roadmap

As Amazon Braket expands its featureset, we welcome contributions and development from the Julia community.  

What's currently implemented in *pure* Julia:

- All of the [`Amazon Braket schemas`](https://github.com/aws/amazon-braket-schemas-python).
- Submitting [`Amazon Braket Hybrid Jobs`](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs.html)
- Abstract interface for `LocalSimulator`s
- Local jobs
- Building and submitting circuits to managed simulators and QPUs
- Reading results from managed simulators and QPUs
- Cancelling tasks and jobs
- Fetching quantum task and device information from AWS
- Searching device information and looking up availability windows
- Noise models
- Convenience `Circuit` features
- Pretty printing of `Circuit`s
- Cost tracking
- All gates and noise operations
- Analog Hamiltonian Simulation

**Features to add:**

- [Support for pickled jobs results](https://github.com/amazon-braket/Braket.jl/issues/18)
- More robust entry point verification for jobs
- [Pulse control](https://github.com/amazon-braket/Braket.jl/issues/15)

## Security

See [CONTRIBUTING](CONTRIBUTING.md#security-issue-notifications) for more information.

## License

This project is licensed under the Apache-2.0 License.

# PyBraket.jl

**PyBraket.jl is not an officially supported AWS product.**

This package provides Julia-Python interoperability between `Braket.jl` and Python features of the Amazon Braket SDK, such as the Amazon Braket [Local Simulators](https://docs.aws.amazon.com/braket/latest/developerguide/braket-send-to-local-simulator.html) and support for unpickling the [results of Braket Jobs](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-save-results.html).

This is *experimental* software, and support may be discontinued in the future. For a fully supported SDK, please use
the [Python SDK](https://github.com/aws/amazon-braket-sdk-python). We may change, remove, or deprecate parts of the API when making new releases.
Please review the [CHANGELOG](CHANGELOG.md) for information about changes in each release. 

## Installation & Prerequisites

You'll need [`PythonCall.jl`](https://cjdoris.github.io/PythonCall.jl) installed to use this package.

### Use `CondaPkg.jl`

`PyBraket.jl` now supports [`CondaPkg.jl`](https://github.com/cjdoris/CondaPkg.jl)! The package and its tests come with `CondaPkg.toml` files ready to go.
`CondaPkg.jl` will install all necessary dependencies for you.

### Use native Python installation

If you want to use an existing Python installation (a virtual environment you control, for example),
you will need a working installation of the [Amazon Braket SDK](https://github.com/aws/amazon-braket-sdk-python).
You can install the Amazon Braket SDK and all its dependencies through `pip` as documented on its [README](https://github.com/aws/amazon-braket-sdk-python/blob/main/README.md).
 
To use an existing installation through `PyBraket.jl` you will need to [turn off CondaPkg.jl](https://cjdoris.github.io/PythonCall.jl/stable/pythoncall/#If-you-don't-want-to-use-Conda).
In particular, if you already have the SDK and its dependencies installed, you can run:

`export JULIA_PYTHONCALL_EXE=path_to_your_python`

or add it to your `.bash_profile`/`.bashrc`/`.zsh_profile`/`.zshrc`/etc.
This will prevent `PythonCall.jl` and `CondaPkg.jl` from trying to reinstall the SDK and its dependencies.
Note that if you installed the Amazon Braket SDK in a Python virtual environment, you will need to set this environment variable *to the python executable associated with that virtual environment*. You can find the path to that python executable by activating the virtenv and running `which python` if you're on Linux or MacOS.

## Examples

Running a Local Job:

```julia
using PyBraket, Braket
sm = joinpath(@__DIR__, "algo_script", "algo_script.py")
job = LocalJob("local:braket/braket.local.qubit", source_module=sm)
@assert state(job) == "COMPLETED" 
```

Running an analog Hamiltonian simulation on the local AHS simulator:

```julia
using Braket, PyBraket
using Braket: AtomArrangement, AtomArrangementItem, TimeSeries, DrivingField, AwsDevice, AnalogHamiltonianSimulation, discretize, AnalogHamiltonianSimulationQuantumTaskResult

a = 5.5e-6

register = AtomArrangement()
push!(register, AtomArrangementItem((0.5, 0.5 + 1/√2) .* a))
push!(register, AtomArrangementItem((0.5 + 1/√2, 0.5) .* a))
push!(register, AtomArrangementItem((0.5 + 1/√2, -0.5) .* a))
push!(register, AtomArrangementItem((0.5, -0.5 - 1/√2) .* a))
push!(register, AtomArrangementItem((-0.5, -0.5 - 1/√2) .* a))
push!(register, AtomArrangementItem((-0.5 -1/√2, -0.5) .* a))
push!(register, AtomArrangementItem((-0.5 -1/√2, 0.5) .* a))
push!(register, AtomArrangementItem((-0.5, 0.5 + 1/√2) .* a))
# extracted from device paradigm
(C6, Ω_min, Ω_max, Ω_slope_max, Δ_min, Δ_max, time_max) = (5.42e-24, 0.0, 6.3e6, 2.5e14, -1.25e8, 1.25e8, 4.0e-6)

time_max     = Float64(time_max)
Δ_start      = -5 * Float64(Ω_max)
Δ_end        = 5 * Float64(Ω_max)
@test all(Δ_min <= Δ <= Δ_max for Δ in (Δ_start, Δ_end))

time_ramp = 1e-7  # seconds
@test Float64(Ω_max) / time_ramp < Ω_slope_max

Ω                       = TimeSeries()
Ω[0.0]                  = 0.0
Ω[time_ramp]            = Ω_max
Ω[time_max - time_ramp] = Ω_max
Ω[time_max]             = 0.0 

Δ                       = TimeSeries()
Δ[0.0]                  = Δ_start
Δ[time_ramp]            = Δ_start
Δ[time_max - time_ramp] = Δ_end
Δ[time_max]             = Δ_end

ϕ           = TimeSeries()
ϕ[0.0]      = 0.0
ϕ[time_max] = 0.0

drive                   = DrivingField(Ω, ϕ, Δ)
ahs_program             = AnalogHamiltonianSimulation(register, [drive])

ahs_local    = LocalSimulator("braket_ahs")
local_result = result(run(ahs_local, ahs_program, shots=1_000))
``` 

using Braket, Test, Mocking, OrderedCollections, Base64, JSON3
dev_arn = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"

Mocking.activate()
script_mode_dict = OrderedDict("s3Uri"=>"fake_uri", "entryPoint"=>"fake_entry", "compressionType"=>"fake_type")
@testset "Local Jobs" begin
    @test Braket.get_env_hyperparameters() == Dict("AMZN_BRAKET_HP_FILE"=>"/opt/braket/input/config/hyperparameters.json")
    @test Braket.get_env_input_data()      == Dict("AMZN_BRAKET_INPUT_DIR"=>"/opt/braket/input/data")
    @test Braket.get_env_script_mode_config(script_mode_dict) == Dict("AMZN_BRAKET_SCRIPT_S3_URI"=>"fake_uri", "AMZN_BRAKET_SCRIPT_ENTRY_POINT"=>"fake_entry", "AMZN_BRAKET_SCRIPT_COMPRESSION_TYPE"=>"fake_type")
    @test Braket.is_s3_dir("fake/", ["key"])
    @test Braket.is_s3_dir("fake", ["fake/key"])
    @test !Braket.is_s3_dir("fake", ["fakekey"])
    lj = LocalQuantumJob("local:job/fake", run_log="fake_log\n")
    @test Braket.run_log(lj) == "fake_log\n"
    @test arn(lj) == "local:job/fake"
    @test name(lj) == "fake"
    @test state(lj) == "COMPLETED"
    @test state(lj, Val(true)) == "COMPLETED"
    @test state(lj, Val(false)) == "COMPLETED"
    @test isnothing(cancel(lj))
    @test isnothing(metadata(lj))
    @test isnothing(metadata(lj, Val(true)))
    @test isnothing(Braket.download_result(lj))
    @test_throws ArgumentError LocalQuantumJob("notlocal:job/")
    @test_throws ErrorException LocalQuantumJob("local:job/fake")

    @test Braket.capture_docker_cmd(`echo hello`) == ("hello", "", 0)

    @testset "mocked local job" begin
        # do something bad here
        Braket.capture_docker_cmd(c::Cmd) = ("success", "", 0)
        creds = Braket.AWS.AWSCredentials("fake_access_key_id", "fake_secret_key", "fake_token")
        conf = Braket.AWS.AWSConfig(region="us-west-2", creds=creds)
        job_name = "fake_job_name"
        image_uri = Braket.retrieve_image(Braket.BASE, conf)
        token = "fake_token"
        @test occursin(".dkr.ecr.us-west-2.amazonaws.com/", image_uri)
        @testset "pull_image" begin
            resp_dict = Dict("authorizationData"=>[Dict("authorizationToken"=>base64encode(token))])
            f(http_backend, request, response_stream) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                Braket.pull_image(image_uri, conf)
            end
        end
        @testset "Successful input data download" begin
            args = (algo_spec=Dict("scriptModeConfig"=>script_mode_dict),
                    params=Dict(
                                "hyperParameters"=>Dict("cool"=>"beans"),
                                "checkpointConfig"=>Dict("localPath"=>"fake_local_path"),
                                "inputDataConfig"=>[Dict("channelName"=>"fake_channel",
                                                         "dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>"s3://fake_bucket/fake_input")))]
                               ),
                    job_name=job_name,
                    out_conf=Dict("s3Path"=>"s3://fake_s3_bucket/fake_s3_path"),
                    dev_conf=Dict("device"=>"fake_device")
                )
            function f(http_backend, request, response_stream)
                xml_str = """
                    <?xml version="1.0" encoding="UTF-8"?>
                    <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                        <Name>fake_bucket</Name>
                        <Prefix>fake_channel</Prefix>
                        <KeyCount>205</KeyCount>
                        <MaxKeys>1000</MaxKeys>
                        <IsTruncated>false</IsTruncated>
                        <Contents>
                            <Key>fake_input</Key>
                            <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                            <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                            <Size>434234</Size>
                            <StorageClass>STANDARD</StorageClass>
                        </Contents>
                    </ListBucketResult>
                    """
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                ljc = Braket.LocalJobContainer(image_uri, args, config=conf)
                @test name(ljc) == "success"
                ref_dict = Dict("AWS_ACCESS_KEY_ID"=>creds.access_key_id,
                                "AWS_SECRET_ACCESS_KEY"=>creds.secret_key,
                                "AWS_SESSION_TOKEN"=>creds.token,
                                "AWS_DEFAULT_REGION"=>Braket.AWS.region(conf),
                                "AMZN_BRAKET_JOB_NAME"=>job_name,
                                "AMZN_BRAKET_DEVICE_ARN"=>"fake_device",
                                "AMZN_BRAKET_JOB_RESULTS_DIR"=>"/opt/braket/model",
                                "AMZN_BRAKET_CHECKPOINT_DIR"=>"fake_local_path",
                                "AMZN_BRAKET_OUT_S3_BUCKET"=>"fake_s3_bucket",
                                "AMZN_BRAKET_TASK_RESULTS_S3_URI"=>"s3://fake_s3_bucket/jobs/$job_name/tasks",
                                "AMZN_BRAKET_JOB_RESULTS_S3_PATH"=>joinpath("fake_s3_path", job_name, "output"),
                                "AMZN_BRAKET_HP_FILE"=>"/opt/braket/input/config/hyperparameters.json",
                                "AMZN_BRAKET_SCRIPT_S3_URI"=>script_mode_dict["s3Uri"],
                                "AMZN_BRAKET_SCRIPT_ENTRY_POINT"=>script_mode_dict["entryPoint"],
                                "AMZN_BRAKET_SCRIPT_COMPRESSION_TYPE"=>script_mode_dict["compressionType"],
                                "AMZN_BRAKET_INPUT_DIR"=>"/opt/braket/input/data",
                            )
                for k in keys(ljc.env)
                    @test ljc.env[k] == ref_dict[k]
                end
                for k in keys(ref_dict)
                    @test ljc.env[k] == ref_dict[k]
                end
                @test ljc.env == ref_dict
                ljc = Braket.run_local_job!(ljc)
                @test ljc.run_log == "successsuccesssuccesssuccesssuccess"
            end
        end
        @testset "Successful input data download with force_update" begin
            args = (algo_spec=Dict("scriptModeConfig"=>script_mode_dict),
                    params=Dict("hyperParameters"=>Dict("cool"=>"beans"), "checkpointConfig"=>Dict("localPath"=>"fake_local_path"), "inputDataConfig"=>[Dict("channelName"=>"fake_channel", "dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>"s3://fake_bucket/fake_input")))]),
                    job_name=job_name,
                    out_conf=Dict("s3Path"=>"s3://fake_s3_bucket/fake_s3_path"),
                    dev_conf=Dict("device"=>"fake_device")
                )
            function f(http_backend, request, response_stream)
                xml_str = """
                    <?xml version="1.0" encoding="UTF-8"?>
                    <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                        <Name>fake_bucket</Name>
                        <Prefix>fake_channel</Prefix>
                        <KeyCount>205</KeyCount>
                        <MaxKeys>1000</MaxKeys>
                        <IsTruncated>false</IsTruncated>
                        <Contents>
                            <Key>fake_input</Key>
                            <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                            <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                            <Size>434234</Size>
                            <StorageClass>STANDARD</StorageClass>
                        </Contents>
                    </ListBucketResult>
                    """
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                ljc = Braket.LocalJobContainer(image_uri, args, config=conf, force_update=true)
                @test name(ljc) == "success"
                ref_dict = Dict("AWS_ACCESS_KEY_ID"=>creds.access_key_id,
                                "AWS_SECRET_ACCESS_KEY"=>creds.secret_key,
                                "AWS_SESSION_TOKEN"=>creds.token,
                                "AWS_DEFAULT_REGION"=>Braket.AWS.region(conf),
                                "AMZN_BRAKET_JOB_NAME"=>job_name,
                                "AMZN_BRAKET_DEVICE_ARN"=>"fake_device",
                                "AMZN_BRAKET_JOB_RESULTS_DIR"=>"/opt/braket/model",
                                "AMZN_BRAKET_CHECKPOINT_DIR"=>"fake_local_path",
                                "AMZN_BRAKET_OUT_S3_BUCKET"=>"fake_s3_bucket",
                                "AMZN_BRAKET_TASK_RESULTS_S3_URI"=>"s3://fake_s3_bucket/jobs/$job_name/tasks",
                                "AMZN_BRAKET_JOB_RESULTS_S3_PATH"=>joinpath("fake_s3_path", job_name, "output"),
                                "AMZN_BRAKET_HP_FILE"=>"/opt/braket/input/config/hyperparameters.json",
                                "AMZN_BRAKET_SCRIPT_S3_URI"=>script_mode_dict["s3Uri"],
                                "AMZN_BRAKET_SCRIPT_ENTRY_POINT"=>script_mode_dict["entryPoint"],
                                "AMZN_BRAKET_SCRIPT_COMPRESSION_TYPE"=>script_mode_dict["compressionType"],
                                "AMZN_BRAKET_INPUT_DIR"=>"/opt/braket/input/data",
                            )
                for k in keys(ljc.env)
                    @test ljc.env[k] == ref_dict[k]
                end
                for k in keys(ref_dict)
                    @test ljc.env[k] == ref_dict[k]
                end
                @test ljc.env == ref_dict
            end
        end
        @testset "Duplicate channel name" begin
            args = (algo_spec=Dict("scriptModeConfig"=>script_mode_dict),
                    params=Dict("hyperParameters"=>Dict("cool"=>"beans"), "checkpointConfig"=>Dict("localPath"=>"fake_local_path"),
                                "inputDataConfig"=>[Dict("channelName"=>"fake_channel", "dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>"s3://fake_bucket/fake_input"))), Dict("channelName"=>"fake_channel", "dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>"s3://fake_bucket/fake_input2")))]),
                    job_name=job_name,
                    out_conf=Dict("s3Path"=>"s3://fake_s3_bucket/fake_s3_path"),
                    dev_conf=Dict("device"=>"fake_device")
                )
            function f(http_backend, request, response_stream)
                xml_str = """
                    <?xml version="1.0" encoding="UTF-8"?>
                    <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                        <Name>fake_bucket</Name>
                        <Prefix>fake_channel</Prefix>
                        <KeyCount>205</KeyCount>
                        <MaxKeys>1000</MaxKeys>
                        <IsTruncated>false</IsTruncated>
                        <Contents>
                            <Key>fake_input</Key>
                            <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                            <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                            <Size>434234</Size>
                            <StorageClass>STANDARD</StorageClass>
                        </Contents>
                    </ListBucketResult>
                    """
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                @test_throws ErrorException("Duplicate channel names not allowed for input data: fake_channel") Braket.LocalJobContainer(image_uri, args, config=conf)
            end
        end
        @testset "run a facsimile LocalQuantumJob" begin
            function f(http_backend, request, response_stream)
                resp_dict = Dict("ListRolesResult"=>Dict("Roles"=>Dict("member"=>[Dict("RoleName"=>"AmazonBraketJobsExecutionRolenoMemberHere", "Arn"=>"fake_job_arn")])))
                if request.service == "s3"
                    xml_str = """
                        <?xml version="1.0" encoding="UTF-8"?>
                        <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                            <Name>fake_bucket</Name>
                            <Prefix>fake_channel</Prefix>
                            <KeyCount>205</KeyCount>
                            <MaxKeys>1000</MaxKeys>
                            <IsTruncated>false</IsTruncated>
                            <Contents>
                                <Key>fake_input</Key>
                                <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                                <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                                <Size>434234</Size>
                                <StorageClass>STANDARD</StorageClass>
                            </Contents>
                        </ListBucketResult>
                        """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                cd(mktempdir()) do
                    write("local_module.py", "print(1)\n")
                    lqj = LocalQuantumJob("local:fake_dev", "local_module.py", code_location="s3://fake_bucket/fake_code", checkpoint_config=Braket.CheckpointConfig("/opt/jobs/checkpoints", nothing), output_data_config=Braket.OutputDataConfig("s3://fake_bucket/fake_path"), config=conf)
                    @test state(lqj) == "COMPLETED"
                    mktemp() do f, io
                        redirect_stdout(io) do
                            Braket.logs(lqj)
                        end
                        seekstart(io)
                        str = read(io, String)
                        @test str == "successsuccesssuccesssuccesssuccesssuccesssuccess\n"
                    end
                    @testset "Metrics" begin
                        lqj.run_log = "Metrics - timestamp=\"2000-01-01T00:00:00\"; FakeKey=1;" * "\n" * "Metrics - timestamp=\"2000-01-01T00:01:00\"; FakeKey=2;\n"
                        mets = Braket.metrics(lqj)
                        @test mets["FakeKey"] == ["1", "2"]
                    end
                end
            end
        end
        @testset "results" begin
            @testset "successfully get results" begin
                res = """{
                    "braketSchemaHeader": {
                        "name": "braket.jobs_data.persisted_job_data",
                        "version": "1"
                    },
                    "dataDictionary": {"converged": true, "energy": -0.2},
                    "dataFormat": "plaintext"
                }"""
                buf = ""
                job_name = "fake_name"
                fake_arn = "local:job/"*job_name
                cd(mktempdir()) do
                    mkdir(job_name)
                    write(joinpath(job_name, "results.json"), res)
                    lj = LocalQuantumJob(fake_arn)
                    r   = result(lj)
                    raw = Braket.parse_raw_schema(res)
                    @test r == raw.dataDictionary
                end
            end
            @testset "unsuccessfully get results" begin
                res = """{
                    "braketSchemaHeader": {
                        "name": "braket.jobs_data.persisted_job_data",
                        "version": "1"
                    },
                    "dataDictionary": {"converged": true, "energy": -0.2},
                    "dataFormat": "plaintext"
                }"""
                buf = ""
                job_name = "fake_name"
                fake_arn = "local:job/"*job_name
                cd(mktempdir()) do
                    mkdir(job_name)
                    write(joinpath(job_name, "results.json"), res)
                    lj = LocalQuantumJob(fake_arn)
                    rm(joinpath(job_name, "results.json"))
                    @test_throws ErrorException("unable to find results in the local job directory $job_name.") result(lj)
                end
            end
        end
    end
    @testset "errors in run_local_job!" begin
        Braket.capture_docker_cmd(c::Cmd) = ("success", "", 0)
        creds = Braket.AWS.AWSCredentials("fake_access_key_id", "fake_secret_key", "fake_token")
        conf = Braket.AWS.AWSConfig(region="us-west-2", creds=creds)
        job_name = "fake_job_name"
        image_uri = Braket.retrieve_image(Braket.BASE, conf)
        token = "fake_token"
        args = (algo_spec=Dict("scriptModeConfig"=>script_mode_dict),
                    params=Dict("hyperParameters"=>Dict("cool"=>"beans"), "checkpointConfig"=>Dict("localPath"=>"fake_local_path"), "inputDataConfig"=>[Dict("channelName"=>"fake_channel", "dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>"s3://fake_bucket/fake_input")))]),
                    job_name=job_name,
                    out_conf=Dict("s3Path"=>"s3://fake_s3_bucket/fake_s3_path"),
                    dev_conf=Dict("device"=>"fake_device")
                )
        function f(http_backend, request, response_stream)
            xml_str = """
                <?xml version="1.0" encoding="UTF-8"?>
                <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                    <Name>fake_bucket</Name>
                    <Prefix>fake_channel</Prefix>
                    <KeyCount>205</KeyCount>
                    <MaxKeys>1000</MaxKeys>
                    <IsTruncated>false</IsTruncated>
                    <Contents>
                        <Key>fake_input</Key>
                        <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                        <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                        <Size>434234</Size>
                        <StorageClass>STANDARD</StorageClass>
                    </Contents>
                </ListBucketResult>
                """
            return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
        end
        ljc = nothing
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
        apply(req_patch) do
            ljc = Braket.LocalJobContainer(image_uri, args, config=conf)
            @test name(ljc) == "success"
        end
        Braket.capture_docker_cmd(c::Cmd) = ("braket_container.py", "sadness", 1)
        apply(req_patch) do
            ljc = Braket.run_local_job!(ljc)
            @test ljc.run_log == "successsuccesssuccesssuccessbraket_container.pyRun local job process exited with code: 1sadness"
        end
        @testset "errors in copying to/from container" begin
            ljc.run_log = ""
            Braket.capture_docker_cmd(c::Cmd) = ("", "copy_from sadness", 1)
            @test_throws ErrorException("copy_from sadness") Braket.copy_from_container!(ljc, "fake_src", "fake_dst")
            ljc.run_log = ""
            Braket.capture_docker_cmd(c::Cmd) = ("", "copy_to sadness", 1)
            @test_throws ErrorException("copy_to sadness") Braket.copy_to_container!(ljc, "fake_src", "fake_dir/fake_dst")
            ljc.run_log = ""
            Braket.capture_docker_cmd(c::Cmd) = c[2] == "cp" ? ("", "copy_to sadness", 1) : ("", "", 0)
            @test_throws ErrorException("copy_to sadness") Braket.copy_to_container!(ljc, "fake_src", "fake_dir/fake_dst")
        end
    end
    @testset "start_container" begin
        call_count = 0
        Braket.pull_image(image_uri::String, config::Braket.AWS.AWSConfig) = nothing
        function Braket.capture_docker_cmd(c::Cmd)
            if call_count == 0
                call_count += 1
                return ("", "", 0)
            elseif call_count == 1
                call_count += 1
                return ("fake_name", "", 0)
            elseif call_count == 2
                return ("fake_container_name", "", 0)
            else
                return ("", "", 0)
            end
        end
        job_name = "fake_job_name"
        args = (algo_spec=Dict("scriptModeConfig"=>script_mode_dict),
            params=Dict("hyperParameters"=>Dict("cool"=>"beans"),
                        "checkpointConfig"=>Dict("localPath"=>"fake_local_path")),
            job_name=job_name,
            out_conf=Dict("s3Path"=>"s3://fake_s3_bucket/fake_s3_path"),
            dev_conf=Dict("device"=>"fake_device")
        )
        ljc = Braket.LocalJobContainer("fake_uri", args)
        @test name(ljc) == "fake_container_name"
    end
end

using Braket, Test

get_tol(shots::Int) = return (shots > 0 ? Dict("atol"=> 0.1, "rtol"=>0.15) : Dict("atol"=>0.01, "rtol"=>0))
s3_destination_folder = Braket.default_task_bucket()

include("adjoint_gradient.jl")
include("create_local_quantum_job.jl")
include("create_quantum_job.jl")
include("job_macro.jl")
include("measure.jl")
include("cost_tracking.jl")
include("device_creation.jl")
include("queue_information.jl")
include("density_matrix_simulator.jl")
include("simulator_quantum_task.jl")
include("tensor_network_simulator.jl")

using Braket, Test

@testset "Quera device" begin
    @testset "Ahs paradigm properties" begin
        ir_gen() = """{
        "braketSchemaHeader": {
            "name": "braket.device_schema.quera.quera_ahs_paradigm_properties",
            "version": "1"
        },
        "qubitCount": 256,
        "lattice": {
            "area": {
                "width": 100.0e-6,
                "height": 100.0e-6
            },
            "geometry": {
                "spacingRadialMin": 4.0e-6,
                "spacingVerticalMin": 2.5e-6,
                "positionResolution": 1e-7,
                "numberSitesMax": 256
            }
        },
        "rydberg": {
            "c6Coefficient": $(2 * pi * 862690),
            "rydbergGlobal": {
                "rabiFrequencyRange": [0, $(2 * pi * 4.0e6)],
                "rabiFrequencyResolution": 400,
                "rabiFrequencySlewRateMax": $(2 * pi * 4e6 / 100e-9),
                "detuningRange": [$(-2 * pi * 20.0e6), $(2 * pi * 20.0e6)],
                "detuningResolution": 0.2,
                "detuningSlewRateMax": $(2 * pi * 40.0e6 / 100e-9),
                "phaseRange": [-99, 99],
                "phaseResolution": 5e-7,
                "phaseSlewRateMax": $(2 * pi / 100e-9),
                "timeResolution": 1e-9,
                "timeDeltaMin": 1e-8,
                "timeMax": 4.0e-6,
                "timeMin": 0
            },
            "rydbergLocal": {
                "detuningRange": [0, $(2 * pi * 50.0e6)],
                "commonDetuningResolution": 2000,
                "localDetuningResolution": 0.01,
                "detuningSlewRateMax": $(1 / 100e-9),
                "numberLocalDetuningSites": 256,
                "spacingRadialMin": 5e-6,
                "timeResolution": 1e-9,
                "timeDeltaMin": 1e-8
            }
        },
        "performance": {
            "lattice": {
                "positionErrorAbs": 0.025e-6
            },
            "rydberg": {
                "rydbergGlobal": {
                    "rabiFrequencyErrorRel": 0.01,
                    "rabiFrequencyHomogeneityRel": 0.05,
                    "rabiFrequencyHomogeneityAbs": 60e3,
                    "detuningErrorAbs": $(2 * pi * 10.0e3),
                    "phaseErrorAbs": $(2 * pi / 1000),
                    "omegaTau": 10,
                    "singleQubitFidelity": 0.95,
                    "twoQubitFidelity": 0.95,
                    "timeMax": 4.0e-6,
                    "timeMin": 0
                },
                "rydbergLocal": {
                    "detuningDynamicRange": 10,
                    "detuningErrorRel": 0.01,
                    "detuningHomogeneity": 0.02,
                    "detuningScaleErrorRel": 0.01,
                    "darkErrorRete": 1e3,
                    "brightErrorRate": 3e6
                }
            },
            "detection": {
                "atomDetectionFidelity": 0.99,
                "vacancyDetectionFidelity": 0.999,
                "groundStateDetectionFidelity": 0.99,
                "rydbergStateDetectionFidelity": 0.99
            },
            "sorting": {
                "moveFidelity": 0.98,
                "patternFidelitySquare": 1e-4
            }
        }
    }
    """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.QueraAhsParadigmProperties
    end
    @testset "Device capabilities" begin
        ir_gen() = """{
        "braketSchemaHeader": {
            "name": "braket.device_schema.quera.quera_device_capabilities",
            "version": "1"
        },
        "service": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.device_service_properties",
                "version": "1"
            },
            "executionWindows": [
                {
                    "executionDay": "Everyday",
                    "windowStartHour": "09:00",
                    "windowEndHour": "10:00"
                }
            ],
            "shotsRange": [1, 10000],
            "deviceCost": {"price": 0.25, "unit": "minute"},
            "deviceDocumentation": {
                "imageUrl": "image_url",
                "summary": "Summary on the device",
                "externalDocumentationUrl": "external doc link"
            },
            "deviceLocation": "us-east-1",
            "updatedAt": "2022-04-16T19:28:02.869136"
        },
        "action": {
            "braket.ir.ahs.program": {
                "actionType": "braket.ir.ahs.program",
                "version": ["1"]
            }
        },
        "deviceParameters": {},
        "paradigm": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.quera.quera_ahs_paradigm_properties",
                "version": "1"
            },
            "qubitCount": 256,
            "lattice": {
                "area": {
                    "width": 100.0e-6,
                    "height": 100.0e-6
                },
                "geometry": {
                    "spacingRadialMin": 4.0e-6,
                    "spacingVerticalMin": 2.5e-6,
                    "positionResolution": 1e-7,
                    "numberSitesMax": 256
                }
            },
            "rydberg": {
                "c6Coefficient": $(2 * pi * 862690),
                "timeMax": 4.0e-6,
                "rydbergGlobal": {
                    "rabiFrequencyRange": [0, $(2 * pi * 4.0e6)],
                    "rabiFrequencyResolution": 400,
                    "rabiFrequencySlewRateMax": $(2 * pi * 4e6 / 100e-9),
                    "detuningRange": [$(-2 * pi * 20.0e6), $(2 * pi * 20.0e6)],
                    "detuningResolution": 0.2,
                    "detuningSlewRateMax": $(2 * pi * 40.0e6 / 100e-9),
                    "phaseRange": [-99, 99],
                    "phaseResolution": 5e-7,
                    "phaseSlewRateMax": $(2 * pi / 100e-9),
                    "timeResolution": 1e-9,
                    "timeDeltaMin": 1e-8,
                    "timeMax": 4.0e-6,
                    "timeMin": 0
                },
                "rydbergLocal": {
                    "detuningRange": [0, $(2 * pi * 50.0e6)],
                    "commonDetuningResolution": 2000,
                    "localDetuningResolution": 0.01,
                    "detuningSlewRateMax": $(1 / 100e-9),
                    "numberLocalDetuningSites": 256,
                    "spacingRadialMin": 5e-6,
                    "timeResolution": 1e-9,
                    "timeDeltaMin": 1e-8
                }
            },
            "performance": {
                "lattice": {
                    "positionErrorAbs": 0.025e-6
                },
                "rydberg": {
                    "rydbergGlobal": {
                        "rabiFrequencyErrorRel": 0.01,
                        "rabiFrequencyHomogeneityRel": 0.05,
                        "rabiFrequencyHomogeneityAbs": 60e3,
                        "detuningErrorAbs": $(2 * pi * 10.0e3),
                        "phaseErrorAbs": $(2 * pi / 1000),
                        "omegaTau": 10,
                        "singleQubitFidelity": 0.95,
                        "twoQubitFidelity": 0.95,
                        "timeMax": 4.0e-6,
                        "timeMin": 0
                    },
                    "rydbergLocal": {
                        "detuningDynamicRange": 10,
                        "detuningErrorRel": 0.01,
                        "detuningHomogeneity": 0.02,
                        "detuningScaleErrorRel": 0.01,
                        "darkErrorRete": 1e3,
                        "brightErrorRate": 3e6
                    }
                },
                "detection": {
                    "atomDetectionFidelity": 0.99,
                    "vacancyDetectionFidelity": 0.999,
                    "groundStateDetectionFidelity": 0.99,
                    "rydbergStateDetectionFidelity": 0.99
                },
                "sorting": {
                    "moveFidelity": 0.98,
                    "patternFidelitySquare": 1e-4
                }
            }
        }
    }
    """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.QueraDeviceCapabilities
    end
end

using Braket, Test, JSON3, StructTypes, Mocking, UUIDs, DecFP

Mocking.activate()

struct MockRydbergLocal
    timeResolution::Dec128
    commonDetuningResolution::Dec128
    localDetuningResolution::Dec128
end

struct MockRydberg
    c6coefficient::Dec128
    rydbergGlobal::Braket.RydbergGlobal
    rydbergLocal::MockRydbergLocal
end

struct MockAhsParadigmProperties
    lattice::Braket.Lattice
    rydberg::MockRydberg
end

struct MockAhsDeviceCapabilities
    action::Dict{Union{Braket.DeviceActionType, String}, Braket.DeviceActionProperties}
    paradigm::MockAhsParadigmProperties
end

@testset "AHS" begin
    @testset "AHS program translation" begin
        json_str = """{"braketSchemaHeader": {"name": "braket.ir.ahs.program", "version": "1"},
        "setup": {"ahs_register": {"sites": [[0, 0],
            [0, 4e-06],
            [5e-06, 0],
            [5e-06, 4e-06]],
        "filling": [1, 0, 1, 0]}},
        "hamiltonian": {"drivingFields": [{"amplitude": {"pattern": "uniform",
            "time_series": {"times": [0, 1e-07, 3.9e-06, 4e-06],
            "values": [0, 12566400.0, 12566400.0, 0]}},
            "phase": {"pattern": "uniform",
            "time_series": {"times": [0, 1e-07, 3.9e-06, 4e-06],
            "values": [0, 0, -16.0832, -16.0832]}},
            "detuning": {"pattern": "uniform",
            "time_series": {"times": [0, 1e-07, 3.9e-06, 4e-06],
            "values": [-125000000, -125000000, 125000000, 125000000]}}}],
        "shiftingFields": [{"magnitude": {"time_series": {"times": [0, 4e-06],
            "values": [0, 125000000]},
            "pattern": [0.0, 1.0, 0.5, 0.0]}}]}
        }"""
        parsed = Braket.parse_raw_schema(json_str)
        arrange = [Dec128.(["0.0", "0.0"]), Dec128.(["0.0", "4e-6"]), Dec128.(["5e-6", "0.0"]), Dec128.(["5e-6", "4e-6"])]
        @test parsed.setup.ahs_register == Braket.IR.AtomArrangement(arrange, [1, 0, 1, 0])
        @test StructTypes.constructfrom(Braket.AbstractProgram, JSON3.read(json_str)) == parsed
    end

    @testset "AHS result translation" begin
        fi = read(joinpath(@__DIR__, "analog_task_result.json"), String)
        # dict-like
        raw = JSON3.read(fi)
        for m in raw[:measurements]
            mtd = StructTypes.constructfrom(Braket.AnalogHamiltonianSimulationShotMetadata, m[:shotMetadata])

            s = StructTypes.constructfrom(Braket.AnalogHamiltonianSimulationShotMeasurement, m)
            @test s isa Braket.AnalogHamiltonianSimulationShotMeasurement
        end
        AHS_r = Braket.parse_raw_schema(fi)
        @test AHS_r isa Braket.AnalogHamiltonianSimulationTaskResult
        qtr = Braket.format_result(AHS_r)
        @test qtr isa Braket.AnalogHamiltonianSimulationQuantumTaskResult
        @test sprint(show, qtr) == "AnalogHamiltonianSimulationQuantumTaskResult\n"
        @testset for inst in instances(Braket.AnalogHamiltonianSimulationShotStatus)
            @test string(inst) == inst
            @test inst == string(inst)
        end
        @testset "Reading AnalogHamiltonianSimulationQuantumTaskResult" begin
            @test JSON3.read("""{"status": "partial_success"}""", Braket.ShotResult) == Braket.ShotResult(Braket.partial_success, nothing, nothing)
            task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 100, "arn1", nothing, nothing, nothing, nothing, nothing)
            @test JSON3.read("""{"task_metadata": $(JSON3.write(task_metadata))}""", Braket.AnalogHamiltonianSimulationQuantumTaskResult) == Braket.AnalogHamiltonianSimulationQuantumTaskResult(task_metadata, nothing)
        end
    end
    @testset "TimeSeries" begin
        t1 = TimeSeries()
        for (t, v) in [(3.0e-7, 2.51327e7), (3.0e-6, 0.0), (2.7e-6, 2.51327e7), (0.0, 0.0)]
            t1[t] = v
        end
        @test !issorted(t1)
        sort!(t1)
        @test issorted(t1)
        t2 = JSON3.read("{}", Braket.TimeSeries)
        @test issorted(t2)
        @test t2.largest_time == -1
        @test isempty(t2.series)
    end
    @testset "Field" begin
        f = JSON3.read("""{"time_series": {}}""", Braket.Field)
        @test isnothing(f.pattern)
    end
    @testset "AHS task creation" begin
        aa = map(AtomArrangementItem, [(0.0, 0.0), (0.0, 3.0e-6), (0.0, 6.0e-6), (3.0e-6, 0.0), (3.0e-6, 3.0e-6)])
        register = AtomArrangement(aa)
        push!(register, (3.0e-6, 3.0e-6), vacant)
        push!(register, (3.0e-6, 6.0e-6), vacant)

        t1 = TimeSeries()
        t2 = TimeSeries()
        t3 = TimeSeries()
        for (t, v) in [(0.0, 0.0), (3.0e-7, 2.51327e7), (2.7e-6, 2.51327e7), (3.0e-6, 0.0)]
            t1[t] = v
        end
        for (t, v) in [(0.0, 0), (3.0e-6, 0)]
            t2[t] = v
        end
        for (t, v) in [(0.0, -1.25664e8), (3.0e-7, -1.25664e8), (2.7e-6, 1.25664e8), (3.0e-6, 1.25664e8)]
            t3[t] = v
        end
        df = DrivingField(t1, t2, t3)
        ts = TimeSeries()
        for (t, v) in [(0.0, -1.25664e8), (3.0e-6, 1.25664e8)]
            ts[t] = v
        end
        pt = Pattern([0.5, 1.0, 0.5, 0.5, 0.5, 0.5])
        sf = ShiftingField(Field(ts, pt))
        H = AnalogHamiltonianSimulation(register, [df, sf])
        prog = ir(H)
        @test JSON3.read(JSON3.write(prog), Braket.AHSProgram) == prog

        @test vacant == "vacant"
        @test "filled" == filled

        shots = 100
        device_params = Dict("fake_param_1"=>2, "fake_param_2"=>"hello")
        s3_folder = ("fake_bucket", "fake_folder")
        arn_str = "arn:fake:quera"
        task_args = Braket.prepare_task_input(H, arn_str, s3_folder, shots, device_params)
        @test task_args[:action] == JSON3.write(ir(H))
        @test task_args[:device_arn] == arn_str
        @test UUID(task_args[:client_token]) isa UUID
        @test task_args[:shots] == shots
        @test task_args[:outputS3Bucket] == s3_folder[1]
        @test task_args[:outputS3KeyPrefix] == s3_folder[2]
        @test task_args[:extra_opts] == Dict{String, Any}("deviceParameters"=>"{}", "tags"=>Dict{String, String}())

        # test that AwsDevice functor accepts AnalogHamiltonianSimulations
        fake_device = AwsDevice(_arn=arn_str)
        resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            t = fake_device(H, s3_destination_folder=("fake_bucket", "fake_prefix"), shots=100)
            @test arn(t) == "arn/fake"
        end
    end
    @testset "discretize" begin
        aa = map(AtomArrangementItem, [(0.0, 0.0), (0.0, 3.0e-6), (0.0, 6.0e-6), (3.0e-6, 0.0), (3.0e-6, 3.0e-6)])
        register = AtomArrangement(aa)
        push!(register, (Dec128("3.0e-6"), Dec128("3.0e-6")), vacant)
        push!(register, (Dec128("3.0e-6"), Dec128("6.0e-6")), vacant)

        t1 = TimeSeries()
        t2 = TimeSeries()
        t3 = TimeSeries()
        for (t, v) in [(0.0, 0.0), (Dec128("3.0e-7"), Dec128("2.51327e7")), (Dec128("2.7e-6"), Dec128("2.51327e7")), (Dec128("3.0e-6"), 0.0)]
            t1[t] = v
        end
        for (t, v) in [(0.0, 0), (Dec128("3.0e-6"), 0)]
            t2[t] = v
        end
        for (t, v) in [(0.0, Dec128("-1.25664e8")), (Dec128("3.0e-7"), Dec128("-1.25664e8")), (Dec128("2.7e-6"), Dec128("1.25664e8")), (Dec128("3.0e-6"), Dec128("1.25664e8"))]
            t3[t] = v
        end
        df = DrivingField(t1, t2, t3)
        ts = TimeSeries()
        for (t, v) in [(0.0, Dec128("-1.25664e8")), (Dec128("3.0e-6"), Dec128("1.25664e8"))]
            ts[t] = v
        end
        pt = Pattern(Dec128.(["0.5", "1.0", "0.5", "0.5", "0.5", "0.5"]))
        sf = ShiftingField(Field(ts, pt))
        ahs = AnalogHamiltonianSimulation(register, [df, sf])
        rl = MockRydbergLocal(Dec128("1e-9"), Dec128("2000.0"), Dec128("0.01"))
        rg = Braket.RydbergGlobal((Dec128("1.0"), Dec128("1e6")), Dec128("400.0"), Dec128("0.2"), (Dec128("1.0"), Dec128("1e6")), Dec128("0.2"), Dec128("0.2"), (Dec128("1.0"), Dec128("1e6")), Dec128("5e-7"), Dec128("1e-9"), Dec128("1e-5"), Dec128("0.0"), Dec128("100.0"))
        dev = Braket.AwsDevice(_arn="arn:fake_device")
        para_props = MockAhsParadigmProperties(
            Braket.Lattice(Braket.Area(Dec128("1e-3"), Dec128("1e-3")), Braket.Geometry(Dec128("1e-7"), Dec128("1e-7"), Dec128("1e-7"), 200)),
            MockRydberg(Dec128("1e-6"), rg, rl),
        )
        dev._properties = MockAhsDeviceCapabilities(Dict("braket.ir.ahs.program"=>Braket.GenericDeviceActionProperties(["1"], "braket.ir.ahs.program")), para_props)
        disc_ahs = Braket.discretize(ahs, dev)

        disc_ir  = ir(disc_ahs)
        read_in  = JSON3.read(JSON3.write(disc_ir), Dict)
        @test read_in["setup"]["ahs_register"]["filling"] == [1, 1, 1, 1, 1, 0, 0]
        for (site, expected) in zip(read_in["setup"]["ahs_register"]["sites"], [[0.0, 0.0], [0.0, 3e-06], [0.0, 6e-06], [3e-06, 0.0], [3e-06, 3e-06], [3e-06, 3e-06], [3e-06, 6e-06]])
            @test Dec128.(site) == Dec128.(string.(expected))
        end

        @test read_in["hamiltonian"]["drivingFields"][1]["amplitude"]["pattern"] == "uniform"
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["amplitude"]["time_series"]["times"])  ≈ [0.0, 3e-07, 2.7e-06, 3e-06] atol=eps(Float64)
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["amplitude"]["time_series"]["values"]) ≈ [0, 25132800, 25132800, 0] atol=eps(Float64)

        @test read_in["hamiltonian"]["drivingFields"][1]["phase"]["pattern"] == "uniform"
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["phase"]["time_series"]["times"])  ≈ [0.0, 3e-06] atol=eps(Float64)
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["phase"]["time_series"]["values"]) ≈ [0.0, 0.0] atol=eps(Float64)

        @test read_in["hamiltonian"]["drivingFields"][1]["detuning"]["pattern"] == "uniform"
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["detuning"]["time_series"]["times"])  ≈ [0.0, 3e-07, 2.7e-06, 3e-06] atol=eps(Float64)
        @test Dec128.(read_in["hamiltonian"]["drivingFields"][1]["detuning"]["time_series"]["values"]) ≈ [-125664000.0, -125664000.0, 125664000.0, 125664000.0] atol=eps(Float64)
        
        @test Dec128.(read_in["hamiltonian"]["shiftingFields"][1]["magnitude"]["pattern"]) == [0.5, 1.0, 0.5, 0.5, 0.5, 0.5]
        @test Dec128.(read_in["hamiltonian"]["shiftingFields"][1]["magnitude"]["time_series"]["times"])  ≈ [0.0, 3e-06] atol=eps(Float64)
        @test Dec128.(read_in["hamiltonian"]["shiftingFields"][1]["magnitude"]["time_series"]["values"]) ≈ [-125664000.0, 125664000.0] atol=eps(Float64)

        dev._properties = MockAhsDeviceCapabilities(Dict("bad_program"=>Braket.GenericDeviceActionProperties(["1"], "braket.ir.ahs.program")), para_props)
        @test_throws ErrorException Braket.discretize(ahs, dev)
    end
end

"""
    AwsQuantumJob

Struct representing an Amazon Braket Hybrid Job.
"""
mutable struct AwsQuantumJob <: Job
    arn::String
    _metadata::Dict
    AwsQuantumJob(arn::String) = new(arn, Dict())
end
"""
    arn(j::AwsQuantumJob)

Returns the ARN identifying the job `j`. This ARN can be used to
reconstruct the job after the session that launched it has exited.
"""
arn(j::AwsQuantumJob)    = j.arn
"""
    name(j::AwsQuantumJob)

Returns the name of the job `j`.
"""
name(j::AwsQuantumJob)   = String(split(arn(j), "job/")[end])
"""
    cancel(j::AwsQuantumJob)

Cancels the job `j`.
"""
cancel(j::AwsQuantumJob) = (r = BRAKET.cancel_job(HTTP.escapeuri(arn(j))); return nothing)

function describe_log_streams(log_group::String, stream_prefix::String, limit::Int=-1, next_token::String="")
    args = Dict{String, Any}("logGroupName"=>log_group, "logStreamNamePrefix"=>stream_prefix, "orderBy"=>"LogStreamName")
    limit > 0 && (args["limit"] = limit)
    !isempty(next_token) && (args["nextToken"] = next_token)
    return CLOUDWATCH_LOGS.describe_log_streams(args) 
end

"""
    log_metric(metric_name::String, value::Union{Float64, Int}; timestamp=time(), iteration_number=nothing)

Within a job script, log a metric with name `metric_name` and value `value` which can later be fetched
*outside the job* with [`metrics`](@ref). A metric might be, for example, the loss of a training algorithm
at each epoch, or similar.
"""
function log_metric(metric_name::String, value::Union{Float64, Int}; timestamp=time(), iteration_number=nothing)
    metric_line = "Metrics - timestamp=$timestamp; $metric_name=$value;"
    if !isnothing(iteration_number)
        metric_line *= " iteration_number=$iteration_number;"
    end
    println(metric_line)
    return
end

function queue_position(j::AwsQuantumJob)
    md =  metadata(j)
    response = md["queueInfo"]
    queue_position = get(response, "position", "None") == "None" ? "" : get(response, "position", "")
    message = get(response, "message", "")
    return HybridJobQueueInfo(queue_position, message)
end

function log_stream(ch::Channel, log_group::String, stream_name::String, start_time::Int=0, skip::Int=0)
    next_token = nothing
    event_count = 1
    while event_count > 0
        response = CLOUDWATCH_LOGS.get_log_events(stream_name, Dict("logGroupName"=>log_group, "startTime"=>start_time, "nextToken"=>next_token, "startFromHead"=>true))
        next_token = response["nextForwardToken"]
        events = response["events"]
        event_count = length(events)
        if event_count > skip
            events = events[skip+1:end]
            skip = 0
        else
            skip = skip - event_count
            events = []
        end
        for ev in events
            put!(ch, ev)
        end
    end
    return
end

function multi_stream(log_group::String, streams::Vector{String}, positions::Dict{String, NamedTuple})
    chs = [Channel(Inf) for _ in 1:length(streams)]
    for (i, s) in enumerate(streams)
        if VERSION >= v"1.7"
            errormonitor(@async log_stream(chs[i], log_group, s, positions[s][:timestamp], positions[s][:skip]))
        else
            @async log_stream(chs[i], log_group, s, positions[s][:timestamp], positions[s][:skip])
        end
    end
    sleep(5) # let the events get populated
    events = Channel() do ch
        while any(isready, chs)
            ex, next_i = findmin(x->(isready(x) ? fetch(x)["timestamp"] : Inf), chs)
            ex = take!(chs[next_i])
            put!(ch, (next_i, ex))
        end
    end
    return events
end

function flush_log_streams(log_group::String, stream_prefix::String, stream_names::Vector{String}, positions::Dict{String, NamedTuple}, stream_count::Int, has_streams::Bool; wait::Bool=false)
    while length(stream_names) < stream_count
        streams = describe_log_streams(log_group, stream_prefix, stream_count)
        new_streams = [s["logStreamName"] for s in filter(x->x["logStreamName"]∉stream_names, streams["logStreams"])]
        append!(stream_names, new_streams)
        for s in setdiff(stream_names, keys(positions))
            positions[s] = (timestamp=0, skip=0)
        end
        # TODO fix
        length(stream_names) < stream_count && sleep(5)
        !wait && break
    end
    if length(stream_names) > 0
        if !has_streams
            println()
            has_streams = true
        end
        for (idx, event) in collect(multi_stream(log_group, stream_names, positions))
            Base.printstyled(event["message"]*"\n", color=stream_colors[idx])
            ts, count = positions[stream_names[idx]]
            if event["timestamp"] == ts
                positions[stream_names[idx]] = (timestamp=ts, skip=count+1)
            else
                positions[stream_names[idx]] = (timestamp=event["timestamp"], skip=1)
            end
        end
    else
        print(".")
    end
    return has_streams
end

"""
    logs(j::AwsQuantumJob; wait::Bool=false, poll_interval_seconds::Int=5)

Fetches the logs of job `j`. If `wait` is `true`, blocks until `j` has entered a terminal state
(`"COMPLETED"`, `"FAILED"`, or `"CANCELLED"`). Polls every `poll_interval_seconds` for new log data.
"""
function logs(j::AwsQuantumJob; wait::Bool=false, poll_interval_seconds::Int=5)
    already_done = state(j) ∈ JOB_TERMINAL_STATES
    log_state = (wait && !already_done) ? TAILING : COMPLETE
    log_group = LOG_GROUP
    stream_prefix = name(j) * "/"
    stream_names = String[]
    stream_positions = Dict{String, NamedTuple}()
    instance_count = metadata(j, Val(true))["instanceConfig"]["instanceCount"]
    has_streams = false
    while true
        sleep(poll_interval_seconds)
        has_streams = flush_log_streams(log_group, stream_prefix, stream_names, stream_positions, instance_count, has_streams, wait=(log_state==COMPLETE))
        log_state == COMPLETE && break
        if log_state == JOB_COMPLETE
            log_state = COMPLETE
        elseif state(j) ∈ JOB_TERMINAL_STATES
            log_state = JOB_COMPLETE
        end
    end
end

function _parse_result(result_line)
    msg_ix = findfirst(elem->(elem["field"] == "@message"), result_line)
    isnothing(msg_ix) && return (timestamp="", message="")

    msg = result_line[msg_ix]["value"]
    ts_ix = findfirst(elem->(elem["field"] == "@timestamp"), result_line)
    ts = result_line[ts_ix]["value"]
    return (timestamp=ts, message=msg)
end

function _parse_query_results(results::Vector, metric_type::String=TIMESTAMP, statistic::String="MAX")
    parsed = filter(x->!isempty(x.message), map(_parse_result, results))
    metrics_dict = Dict{String, Vector}()
    sortby = metric_type
    for p in parsed
        parsed_metrics = Dict{String, Any}()
        for m in eachmatch(METRIC_DEFINITIONS, p.message)
            !isempty(p.timestamp) && TIMESTAMP ∉ m.captures && (parsed_metrics[TIMESTAMP] = [p.timestamp])
            ITERATION_NUMBER ∈ m.captures && (parsed_metrics[ITERATION_NUMBER] = [String(m.captures[end])])
            node_match = match(NODE_TAG, p.message)
            !isnothing(node_match) && (parsed_metrics[NODE_ID] = [String(node_match.captures)])
            sorter = get(parsed_metrics, sortby, [getfield(p, Symbol(string(sortby)))])[1]
            parsed_metrics[String(m[1])] = [(sorter, String(m[2]))]
        end
        mergewith!(vcat, metrics_dict, parsed_metrics)
    end
    @debug "results: $results, metrics_dict: $metrics_dict"
    p = sortperm(metrics_dict[sortby])
    expanded_metrics_dict = Dict{String, Vector}(sortby=>metrics_dict[sortby][p])
    for k in filter(k->k!=sortby, keys(metrics_dict))
        expanded_metrics_dict[k] = []
        for ind in expanded_metrics_dict[sortby]
            ix = findfirst(local_ind -> local_ind == ind, first.(metrics_dict[k]))
            val = popat!(metrics_dict[k], ix, (missing,))
            push!(expanded_metrics_dict[k], last(val))
        end
    end
    return expanded_metrics_dict
end

function _get_metrics_results_sync(query_id::String)
    timeout_time = time() + QUERY_POLL_TIMEOUT_SECONDS
    while time() < timeout_time
        response = CLOUDWATCH_LOGS.get_query_results(query_id)
        query_status = response["status"]
        query_status ∈ ["Failed", "Cancelled"] && throw(ErrorException("Query $query_id failed with status $query_status"))
        query_status == "Complete" && return response["results"]
        sleep(QUERY_POLL_INTERVAL_SECONDS)
    end
    @warn "Timed out waiting for query $query_id"
    return []
end

function _get_metrics_for_job(job_name::String, metric_type::String="TIMESTAMP", statistic::String="MAX", job_start_time=nothing, job_end_time=nothing)
    query_end_time   = isnothing(job_end_time) ? Dates.datetime2unix(Dates.now()) : job_end_time
    query_start_time = isnothing(job_start_time) ? query_end_time - QUERY_DEFAULT_JOB_DURATION : job_start_time
    query    = """fields @timestamp, @message | filter @logStream like /^$job_name\\// | filter @message like /Metrics - /"""
    response = CLOUDWATCH_LOGS.start_query(query_end_time, query, query_start_time, Dict("logGroupName"=>LOG_GROUP, "limit"=>10_000))
    query_id = response["queryId"]
    results  = _get_metrics_results_sync(query_id)
    return isempty(results) ? results : _parse_query_results(results)
end

"""
    metrics(j::AwsQuantumJob; metric_type="timestamp", statistic="max") 

Fetches the metrics for job `j`. Metrics are generated by [`log_metric`](@ref)
within the job script.
"""
function metrics(j::AwsQuantumJob; metric_type="timestamp", statistic="max")
    mtd       = metadata(j, Val(true))
    job_name  = mtd["jobName"]
    job_start = nothing 
    if haskey(mtd, "startedAt")
        job_start = Dates.datetime2unix(DateTime(split(mtd["startedAt"], '.')[1]))
    end
    job_end   = nothing
    if state(j) ∈ JOB_TERMINAL_STATES && haskey(mtd, "endedAt")
        job_end = Dates.datetime2unix(DateTime(split(mtd["endedAt"], '.')[1]))
    end
    return _get_metrics_for_job(job_name, metric_type, statistic, job_start, job_end)
end

"""
    state(j::AwsQuantumJob, ::Val{true})
    state(j::AwsQuantumJob, ::Val{false})
    state(j::AwsQuantumJob)

Fetch the state for job `j`. Possible states are `"CANCELLED"`, `"FAILED"`, `"COMPLETED"`, `"QUEUED"`, and `"RUNNING"`.
If the second argument is `::Val{true}`, use previously cached metadata, if available, otherwise fetch it
from the Braket service. If the second argument is `::Val{false}` (default), do not use previously cached metadata,
and fetch fresh metadata from the Braket service.
"""
state(j::AwsQuantumJob, v) = metadata(j, v)["status"]
state(j::AwsQuantumJob)    = state(j, Val(false))

"""
    metadata(j::AwsQuantumJob, ::Val{true})
    metadata(j::AwsQuantumJob, ::Val{false})
    metadata(j::AwsQuantumJob)

Fetch metadata for job `j`. If the second argument is `::Val{true}`,
use previously cached metadata, if available, otherwise fetch it from
the Braket service. If the second argument is `::Val{false}` (default),
do not use previously cached metadata, and fetch fresh metadata from the Braket service.
"""
metadata(j::AwsQuantumJob, ::Val{false}) = parse(get_job(j))
metadata(j::AwsQuantumJob, ::Val{true})  = !isempty(j._metadata) ? j._metadata : metadata(j, Val(false))
metadata(j::AwsQuantumJob) = metadata(j, Val(false)) 

function _attempt_results_download(j::AwsQuantumJob, output_bucket_uri::String, output_s3_path::String, dl_dir::String)
    bucket, key = parse_s3_uri(output_bucket_uri)
    stream = s3_get(bucket, key, raw=true)
    out_name = joinpath(dl_dir, RESULTS_TAR_FILENAME)
    write(out_name, stream)
    return out_name
end

_extract_tar_file(extract_path::String) = (run(`tar -xf $RESULTS_TAR_FILENAME -C $extract_path`); return extract_path)

"""
    download_result(j::AwsQuantumJob; kwargs...)

Download and extract the results of job `j`. Valid `kwargs` are:
  - `extract_to::String` - the local folder to extract the results to. Default is the current working directory.
  - `poll_timeout_seconds::Int` - the maximum number of seconds to wait while polling for results. Default: $JOB_DEFAULT_RESULTS_POLL_TIMEOUT
  - `poll_interval_seconds::Int` - how many seconds to wait between download attempts. Default: $JOB_DEFAULT_RESULTS_POLL_INTERVAL
"""
function download_result(j::AwsQuantumJob; extract_to=pwd(), poll_timeout_seconds::Int=JOB_DEFAULT_RESULTS_POLL_TIMEOUT, poll_interval_seconds::Int=JOB_DEFAULT_RESULTS_POLL_INTERVAL)
    timeout_time = time() + poll_timeout_seconds
    job_response = metadata(j, Val(true))
    while time() < timeout_time
        job_response = metadata(j, Val(true))
        job_state = state(j)
        if job_state ∈ JOB_TERMINAL_STATES
            output_s3_path = job_response["outputDataConfig"]["s3Path"]
            output_s3_uri  = output_s3_path * "/output/model.tar.gz"
            _attempt_results_download(j, output_s3_uri, output_s3_path, extract_to)
            ex_to = joinpath(extract_to, job_response["jobName"])
            !ispath(ex_to) && mkdir(ex_to)
            ex_path = cd(extract_to) do
                _extract_tar_file(job_response["jobName"])
            end
            return joinpath(extract_to, ex_path)
        else
            sleep(poll_interval_seconds)
        end
    end
    return ""
end

function _read_and_deserialize_results(j::AwsQuantumJob, loc::String)
    try
        open(joinpath(loc, RESULTS_FILENAME), "r") do f
            f_dat = read(f, String)
            persisted_data = parse_raw_schema(f_dat)
            deserialized_data = deserialize_values(persisted_data.dataDictionary, persisted_data.dataFormat)
            return deserialized_data
        end
    catch e
        e isa SystemError && return []
        throw(e)
    end
end

"""
    result(j::AwsQuantumJob; kwargs...)

Download, extract, and deserialize the results of job `j`. Valid `kwargs` are:
  - `poll_timeout_seconds::Int` - the maximum number of seconds to wait while polling for results. Default: $JOB_DEFAULT_RESULTS_POLL_TIMEOUT
  - `poll_interval_seconds::Int` - how many seconds to wait between download attempts. Default: $JOB_DEFAULT_RESULTS_POLL_INTERVAL
"""
function result(j::AwsQuantumJob; poll_timeout_seconds::Int=JOB_DEFAULT_RESULTS_POLL_TIMEOUT, poll_interval_seconds::Int=JOB_DEFAULT_RESULTS_POLL_INTERVAL)
    mktempdir() do d
        try
            fn = download_result(j, extract_to=d, poll_timeout_seconds=poll_timeout_seconds, poll_interval_seconds=poll_interval_seconds)
            return _read_and_deserialize_results(j, fn)
        catch e
            e isa AWS.AWSException && e.cause.status == 404 && return Dict() 
            throw(e)
        end
    end
end

function _generate_default_job_name(image_uri::String="")
    job_type = "-default"
    if !isempty(image_uri)
        re1 = r"/amazon-braket-(.*)-jobs:"
        re2 = r"/amazon-braket-([^:/]*)"
        job_type_match = isnothing(match(re1, image_uri)) ? match(re2, image_uri) : match(re1, image_uri)
        job_type = isnothing(job_type_match) ? "" : "-$(job_type_match[1])"
    end
    t = convert(Int, trunc(time()*1000))
    return "braket-job" * job_type * "-" * string(t)
end

function _process_s3_source_module(source_module::String, entry_point::String, code_location::String)
    isempty(entry_point) && throw(ArgumentError("if source_module ($source_module) is an S3 URI, entry_point must be provided."))
    !endswith(lowercase(source_module), ".tar.gz") && throw(ArgumentError("if source_module ($source_module) is an S3 URI, it must point to a tar.gz file."))
    src_bucket, src_path = parse_s3_uri(source_module)
    dst_bucket, dst_path = parse_s3_uri(code_location * "/source.tar.gz")
    s3_copy(src_bucket, src_path, to_bucket=dst_bucket, to_path=dst_path)
    return
end

function _validate_entry_point_python(source_module_path::String, entry_point::String)
    importable, method = occursin(":", entry_point) ? split(entry_point, ":") : (entry_point, "main")
    return 
end

function _validate_entry_point_julia(source_module_path::String, entry_point::String)
    # check that entry_point parses as valid Julia
    # this will raise an error if there is a syntax issue
    path =  isfile(source_module_path) ? source_module_path : joinpath(source_module_path, entry_point)
    Meta.parse(join(["quote", read(path, String), "end"], ";"))
    return
end

function _process_local_source_module(source_module::String, entry_point::String, code_location::String)
    ispath(source_module) || throw(ArgumentError("source_module ($source_module) not found."))
    if isempty(entry_point)
        entry_point = splitdir(abspath(source_module))[end]
        if !endswith(entry_point, "jl")
            entry_point = String(splitext(entry_point)[1])
        end
    end
    if splitext(source_module)[end] == ".jl" || splitext(entry_point)[end] == ".jl"
        _validate_entry_point_julia(abspath(source_module), entry_point)
    else
        _validate_entry_point_python(abspath(source_module), entry_point)
    end
    _tar_and_upload(abspath(source_module), code_location)
    return entry_point
end

function _tar_and_upload(source_module_path::String, code_location::String)
    mktempdir() do d
        loc = joinpath(d, "source.tar.gz")
        Tar.create(dirname(source_module_path), pipeline(`gzip -9`, loc))
        upload_to_s3(loc, code_location * "/source.tar.gz")
    end
    return
end

function _process_input_data(input_data::Dict, job_name::String)
    @debug "_process_input_data Input data: $input_data"
    processed_input_data = Dict{String, Any}()
    for (k, v) in filter(x->!(x.second isa S3DataSourceConfig), input_data)
        processed_input_data[k] = _process_channel(v, job_name, k)
    end
    return [merge(Dict("channelName"=>k), v.config) for (k,v) in processed_input_data] 
end
_process_input_data(input_data, job_name::String) = _process_input_data(Dict{String, Any}("input_data"=>input_data), job_name)

function _process_channel(loc::String, job_name::String, channel_name::String)
    is_s3_uri(loc) && return S3DataSourceConfig(loc)
    loc_name = splitdir(loc)[2]
    s3_prefix = construct_s3_uri(default_bucket(), "jobs", job_name, "data", channel_name, loc_name)
    @debug "Uploading input data for channel $channel_name from $loc to s3 $s3_prefix with loc_name $loc_name"
    upload_local_data(loc, s3_prefix)
    suffixed_prefix = isdir(loc) ? s3_prefix * "/" : s3_prefix
    return S3DataSourceConfig(suffixed_prefix)
end

function _get_default_jobs_role()
    params = Dict("PathPrefix"=>"/service-role/")
    global_conf = global_aws_config()
    response = IAM.list_roles(params, aws_config=AWS.AWSConfig(creds=global_conf.credentials, region="us-east-1", output=global_conf.output))
    roles = response["ListRolesResult"]["Roles"]["member"]
    for role in roles
        startswith(role["RoleName"], "AmazonBraketJobsExecutionRole") && return role["Arn"]
    end
    throw(ErrorException("No default jobs roles found. Please create a role using the Amazon Braket console or supply a custom role."))
end

function prepare_quantum_job(device::String, source_module::String, j_opts::JobsOptions)
    hyperparams     = Dict(zip(keys(j_opts.hyperparameters), map(string, values(j_opts.hyperparameters))))
    @debug "Job input data: $(j_opts.input_data)"
    @debug "\n\n"
    input_data_list = _process_input_data(j_opts.input_data, j_opts.job_name)
    entry_point = j_opts.entry_point
    if is_s3_uri(source_module)
        _process_s3_source_module(source_module, j_opts.entry_point, j_opts.code_location)
    else
        entry_point = _process_local_source_module(source_module, j_opts.entry_point, j_opts.code_location)
    end
    algo_spec = Dict("scriptModeConfig"=>OrderedDict("entryPoint"=>entry_point,
                                                     "s3Uri"=>j_opts.code_location*"/source.tar.gz",
                                                     "compressionType"=>"GZIP"))

    !isempty(j_opts.image_uri) && setindex!(algo_spec, Dict("uri"=>j_opts.image_uri), "containerImage")
    if !isempty(j_opts.copy_checkpoints_from_job)
        checkpoints_to_copy = get_job(j_opts.copy_checkpoints_from_job)["checkpointConfig"]["s3Uri"]
        copy_s3_directory(checkpoints_to_copy, j_opts.checkpoint_config.s3Uri)
    end
    if j_opts.distribution == "data_parallel"
        merge!(hyperparams, Dict("sagemaker_distributed_dataparallel_enabled"=>"true",
                                 "sagemaker_instance_type"=>j_opts.instance_config.instanceType))
    end

    params = OrderedDict(
                  "checkpointConfig"=>Dict(j_opts.checkpoint_config),
                  "hyperParameters"=>hyperparams,
                  "inputDataConfig"=>input_data_list,
                  "stoppingCondition"=>Dict(j_opts.stopping_condition),
                  "tags"=>j_opts.tags,
                 )
    token     = string(uuid1())
    dev_conf  = Dict(DeviceConfig(device))
    inst_conf = Dict(j_opts.instance_config)
    out_conf  = Dict(j_opts.output_data_config)
    return (algo_spec=algo_spec, token=token, dev_conf=dev_conf, inst_conf=inst_conf, job_name=j_opts.job_name, out_conf=out_conf, role_arn=j_opts.role_arn, params=params)
end

function AwsQuantumJob(device::String, source_module::String, job_opts::JobsOptions)
    args      = prepare_quantum_job(device, source_module, job_opts)
    algo_spec = args[:algo_spec]
    token     = args[:token]
    dev_conf  = args[:dev_conf]
    inst_conf = args[:inst_conf]
    job_name  = args[:job_name]
    out_conf  = args[:out_conf]
    role_arn  = args[:role_arn]
    params    = args[:params]
    response  = BRAKET.create_job(algo_spec, token, dev_conf, inst_conf, job_name, out_conf, role_arn, params)
    job       = AwsQuantumJob(response["jobArn"])
    job_opts.wait_until_complete && logs(job, wait=true)
    return job
end

"""
    AwsQuantumJob(device::Union{String, BraketDevice}, source_module::String; kwargs...)

Create and launch an `AwsQuantumJob` which will use device `device` (a managed simulator, a QPU, or an [embedded simulator](https://docs.aws.amazon.com/braket/latest/developerguide/pennylane-embedded-simulators.html))
and will run the code (either a single file, or a Julia package, or a Python module) located at `source_module`. The keyword arguments
`kwargs` control the launch configuration of the job. `device` can be either the device's ARN as a `String`, or a [`BraketDevice`](@ref). 

# Keyword Arguments
  - `entry_point::String` - the function to run in `source_module` if `source_module` is a Python module/Julia package. Defaults to an empty string, in which case
    the behavior depends on the code language. In Python, the job will attempt to find a function called `main` in `source_module` and run it. In Julia,
    `source_module` will be loaded and run with Julia's [`include`](https://docs.julialang.org/en/v1/base/base/#Base.include).
  - `image_uri::String` - the URI of the Docker image in ECR to run the Job on. Defaults to an empty string, in which case the [base container](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-script-environment.html)
    is used.
  - `job_name::String` - the name for the job, which will be displayed in the [jobs console](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-first.html).
    The default is a combination of the container image name and the current time.
  - `code_location::String` - the S3 prefix URI to which code will be uploaded. The default is `default_bucket()/jobs/<job_name>/script`
  - `role_arn::String` - the IAM role ARN to use to run the job. The default is to use the default jobs role.
  - `wait_until_complete::Bool` - whether to block until the job is complete, displaying log information as
    it arrives (`true`) or to run the job asynchronously (`false`, default).
  - `hyperparameters::Dict{String, Any}` - hyperparameters to provide to the job which will be available from an environment variable when the job is run.
    See the [Amazon Braket documentation](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-hyperparameters.html) for more.
  - `input_data::Union{String, Dict}` - information about the training/input data to provide to the job.
    A `Dict` should map channel names to local paths or S3 URIs. Contents found at any local paths encoded as `String`s will be uploaded to S3 at
    `s3://{default_bucket_name}/jobs/{job_name}/data/{channel_name}`. If a local path or S3 URI is provided, it will be given a default
    channel name `"input"`. The default is `Dict()`.
  - `instance_config::InstanceConfig` - the instance configuration to use to run the job. See the [Amazon Braket documentation](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-configure-job-instance-for-script.html)
    for more information about available instance types. The default is `InstanceConfig("ml.m5.large", 1, 30)`.
  - `distribution::String` - specifies how the job should be distributed. If set to `"data_parallel"`, the hyperparameters
    for the job will be set to use data parallelism features for PyTorch or TensorFlow.
  - `stopping_condition::StoppingCondition` - the maximum length of time, in seconds, that a job
    can run before being forcefully stopped. The default is `StoppingCondition(5 * 24 * 60 * 60)`.
  - `output_data_config::OutputDataConfig` - specifies the location for the output of the job.
    Any data stored here will be available to [`download_result`](@ref) and [`results`](@ref). The default is
    `OutputDataConfig("s3://{default_bucket_name}/jobs/{job_name}/data")`.
  - `copy_checkpoints_from_job::String` - specifies the job ARN whose checkpoint is to be used in the current job.
    Specifying this value will copy over the checkpoint data from `use_checkpoints_from_job`'s `checkpoint_config`
    S3 URI to the current job's `checkpoint_config` S3 URI, making it available at `checkpoint_config.localPath` during
    the job execution. The default is not to copy any checkpoints (an empty string).
  - `checkpoint_config::CheckpointConfig` - specifies the location where
    checkpoint data for *this* job is to be stored.
    The default is `CheckpointConfig("/opt/jobs/checkpoints", "s3://{default_bucket_name}/jobs/{job_name}/checkpoints")`.
  - `tags::Dict{String, String}` - specifies the key-value pairs for tagging this job.
"""
AwsQuantumJob(device::String, source_module::String; kwargs...) = AwsQuantumJob(device, source_module, JobsOptions(; kwargs...))
AwsQuantumJob(device::BraketDevice, source_module::String; kwargs...) = AwsQuantumJob(convert(String, device), source_module, JobsOptions(; kwargs...))

@enum QueueType Normal Priority
QueueTypeDict = Dict("Normal"=>Normal, "Priority"=>Priority)
QueueType(s::String) = QueueTypeDict[s]

struct QueueDepthInfo
    quantum_tasks::Dict{QueueType, String}
    jobs::String
end
Base.:(==)(ix::QueueDepthInfo, iy::QueueDepthInfo) = (ix.jobs == iy.jobs && ix.quantum_tasks == iy.quantum_tasks) 

mutable struct QuantumTaskQueueInfo
    queue_type::QueueType
    queue_position::String
    message::String
end
QuantumTaskQueueInfo(queue_type::QueueType) = QuantumTaskQueueInfo(queue_type, "", "")

mutable struct HybridJobQueueInfo
    queue_position::String
    message::String
end
HybridJobQueueInfo() = HybridJobQueueInfo("", "")

for N in (:Kraus, :BitFlip, :PhaseFlip, :PauliChannel, :AmplitudeDamping, :PhaseDamping, :Depolarizing, :TwoQubitDephasing, :TwoQubitDepolarizing, :GeneralizedAmplitudeDamping, :MultiQubitPauliChannel)
    @eval $N(c::Circuit) = throw(ArgumentError("noise applied to a circuit must have targets and arguments."))
end
MultiQubitPauliChannel{N}(c::Circuit) where {N} = throw(ArgumentError("noise applied to a circuit must have targets and arguments."))
(::Type{N})(c::Circuit, args...) where {N<:Noise} = apply_noise!(n_targets(N), n_probabilities(N), N, c, args...)
apply_noise!(::Type{N}, c::Circuit, args...) where {N<:Noise} = apply_noise!(n_targets(N), n_probabilities(N), N, c, args...)
Kraus(c::Circuit, args...) = apply_noise!(Kraus, c, args...)

apply_noise!(::Val{1}, ::Val{1}, ::Type{N}, c::Circuit, arg::IntOrQubit, prob::Float64) where {N<:Noise} = add_instruction!(c, Instruction(N(prob), arg))
apply_noise!(::Val{1}, ::Val{2}, ::Type{N}, c::Circuit, arg::IntOrQubit, prob_a::Float64, prob_b::Float64) where {N<:Noise} = add_instruction!(c, Instruction(N(prob_a, prob_b), arg))
apply_noise!(::Val{1}, ::Val{3}, ::Type{N}, c::Circuit, arg::IntOrQubit, prob_a::Float64, prob_b::Float64, prob_c::Float64) where {N<:Noise} = add_instruction!(c, Instruction(N(prob_a, prob_b, prob_c), arg))
apply_noise!(::Val{1}, ::Val{2}, ::Type{N}, c::Circuit, arg::IntOrQubit, probs::Vector{Float64}) where {N<:Noise} = add_instruction!(c, Instruction(N(probs...), arg))
apply_noise!(::Val{1}, ::Val{3}, ::Type{N}, c::Circuit, arg::IntOrQubit, probs::Vector{Float64}) where {N<:Noise} = add_instruction!(c, Instruction(N(probs...), arg))
apply_noise!(::Val{1}, ::Val{NP}, ::Type{N}, c::Circuit, probs::Vector{Float64}) where {N<:Noise, NP} = (foreach(q->add_instruction!(c, Instruction(N(probs...), q)), qubits(c)); return c)
apply_noise!(::Val{1}, ::Val{NP}, ::Type{N}, c::Circuit, probs::Vararg{Float64}) where {N<:Noise, NP} = (foreach(q->add_instruction!(c, Instruction(N(probs...), q)), qubits(c)); return c)
apply_noise!(::Val{2}, ::Val{1}, ::Type{N}, c::Circuit, targ_a::IntOrQubit, targ_b::Int, prob::Float64) where {N<:Noise} = add_instruction!(c, Instruction(N(prob), [targ_a, targ_b]))
apply_noise!(::Val{2}, ::Val{1}, ::Type{N}, c::Circuit, args...) where {N<:Noise} = add_instruction!(c, Instruction(N(args[end]), args[1:end-1]))
apply_noise!(::Type{Kraus}, c::Circuit, args...) = add_instruction!(c, Instruction(Kraus(args[end]), args[1:end-1]))

using PythonCall, Braket, Braket.IR
import Braket.IR: IRObservable, AbstractProgramResult, AbstractProgram, AbstractIR
import Braket: ResultTypeValue

function union_convert(::Type{IRObservable}, x)
    PythonCall.pyisinstance(x, PythonCall.pybuiltins.str) && return pyconvert(String, x)
    x_vec = Union{String, Vector{Vector{Vector{Float64}}}}[PythonCall.pyisinstance(x_, PythonCall.pybuiltins.str) ? pyconvert(String, x_) : pyconvert(Vector{Vector{Vector{Float64}}}, x_) for x_ in x] 
    return x_vec
end

function union_convert(union_type, x)
    union_ts = union_type isa Union ? Type[] : [union_type]
    union_t = union_type
    while union_t isa Union
        union_t.a != Nothing && push!(union_ts, union_t.a)
        !(union_t.b isa Union) && push!(union_ts, union_t.b)
        union_t = union_t.b
    end
    arg = nothing
    for t_ in union_ts
        try
            if pyisinstance(x, PythonCall.pybuiltins.list) && t_ <: Vector
                return [union_convert(Union{eltype(t_)}, attr_) for attr_ in x]
            elseif pyisinstance(x, pybuiltins.str) && t_ <: Integer
                return tryparse(t_, pyconvert(String, x))
            elseif t_ == ResultTypeValue
                if pyhasattr(x, "value")
                    typ = jl_convert(AbstractProgramResult, pygetattr(x, "type"))
                    val = union_convert(Union{Dict{String, ComplexF64}, Float64, Vector}, pygetattr(x, "value"))
                    return PythonCall.pyconvert_return(ResultTypeValue(typ, val))
                else
                    rt = jl_convert(AbstractProgramResult, x)
                    return PythonCall.pyconvert_return(ResultTypeValue(rt, 0.0))
                end
            else
                return pyconvert(t_, x)
            end
        catch e
        end
    end
    arg isa Vector{Nothing} && (arg = nothing)
    return arg
end

function jl_convert_attr(n, t, attr)
    if !(t isa Union)
        if pyisinstance(attr, PythonCall.pybuiltins.list)
            if eltype(t) isa Union
                return [union_convert(eltype(t), attr_) for attr_ in attr]
            else
                return [pyconvert(eltype(t), attr_) for attr_ in attr]
            end
        else
            return pyconvert(t, attr)
        end
    else
        PythonCall.pyis(attr, PythonCall.pybuiltins.None) && return nothing
        return union_convert(t, attr)
    end
end

function jl_convert(::Type{T}, x::Py) where {T}
    fts = fieldtypes(T)
    fns = fieldnames(T)
    args = Any[]
    for (n, t) in zip(fns, fts)
        attr = pygetattr(x, string(n))
        arg = jl_convert_attr(n, t, attr)
        push!(args, arg)
    end
    PythonCall.pyconvert_return(T(args...))
end

function jl_convert(::Type{T}, x::Py) where {T<:AbstractIR}
    fts = fieldtypes(T)[1:end-1]
    fns = fieldnames(T)[1:end-1]
    args = Any[]
    for (n, t) in zip(fns, fts)
        attr = pygetattr(x, string(n))
        arg = jl_convert_attr(n, t, attr)
        push!(args, arg)
    end
    PythonCall.pyconvert_return(T(args..., pyconvert(String, pygetattr(x, "type"))))
end

### A Pluto.jl notebook ###
# v0.19.40

using Markdown
using InteractiveUtils

# ╔═╡ c37cf3fd-ba64-4b66-9da1-c67ca4752803
using Braket, PyBraket, DataStructures, Braket.DecFP

# ╔═╡ c84d1362-a92f-4688-97d9-03e5f197e242
using Plots

# ╔═╡ 7568667e-7592-11ed-1f75-33a9f6228b6c
md"
# Measuring the Rabi oscillation frequency of a Rydberg atom
"

# ╔═╡ 9cb745ac-8a69-4cd3-ad7a-450558e072d8
md"
In this notebook, we'll run an analog Hamiltonian simulation (AHS) program using just one atom to verify that we correctly measure the Rabi frequency we set in the simulation.
"

# ╔═╡ 91485d04-a80e-46cd-a67c-d3571c61fb4d
md"
We first create a register with a single atom
"

# ╔═╡ 58152bdb-1a5d-4b48-8cfa-aa6dc1ab27ad
begin
	# create an AtomArrangement with just one atom
	register = AtomArrangement()
	push!(register, AtomArrangementItem((0, 0)))
end

# ╔═╡ d34c696e-54af-414b-b916-f3e73b3e116c
"""
Aggregates state counts from AHS shot results.
Strings of length = # of atoms are returned, where
each character denotes the state of an atom (site):
   - `'e'`: empty site
   - `'g'`: ground state atom
   - `'r'`: Rydberg state atom
    
Returns an `Accumulator` containing the number of times each state configuration is measured.
"""
function get_counts(result)
    state_counts = Accumulator{String, Int}()
    states = ["e", "r", "g"]
    for shot in result.measurements
        pre       = convert(Vector{Int}, shot.pre_sequence)
        post      = convert(Vector{Int}, shot.post_sequence)
        state_idx = (pre .* (1 .+ post)) .+ 1
        state     = prod([states[s_idx] for s_idx in state_idx])
        inc!(state_counts, state)
    end
    return state_counts
end

# ╔═╡ 9c150de3-2076-4895-803c-891d077e21cc
md"Now we set the maximum amplitude in the driving field -- this should be the Rabi frequency we measure from the atom's oscillation."

# ╔═╡ 456fa9bb-904d-4065-8e5d-c4492c381385
Ω_max = Dec128("2.5e6")

# ╔═╡ c5587822-e315-45d2-beaf-017c245af5f3
md"
Here we create an AHS program that drives the atom with constant Rabi frequency. The resultant oscillation will have period $2\pi/\Omega_{max}$, hence by measuring the probability of the Rydberg state as a function of time, we can infer the magnitude of the driving field.
"

# ╔═╡ ef8051a1-69ec-4719-9f51-54d07d0e71fa
# set the time range for the fields
trange = range(0, 4π/Ω_max, length=21)[2:end]

# ╔═╡ b974749f-54e8-4bb4-b1f9-48baa778a0d9
"""
Generate the AHS program to be run. This program turns on a constant driving field consisting only of the "amplitude" component.
"""
function get_program(register, t_max)
    Ω = TimeSeries()
    Ω[0.0] = Ω_max
    Ω[t_max] = Ω_max

    ϕ = TimeSeries()
    ϕ[0.0] = 0.0
    ϕ[t_max] = 0.0

    Δ = TimeSeries()
    Δ[0.0] = 0.0 
    Δ[t_max] = 0.0 
    
    drive = DrivingField(Ω, ϕ, Δ)
        
    return AnalogHamiltonianSimulation(register, drive)
end

# ╔═╡ 313b80ed-7549-4992-a791-bc47ed3a042f
programs = [get_program(register, t) for t in trange]

# ╔═╡ 412e20a7-0fbc-46de-94f0-0a852a589277
md"Now we'll run each program on the AHS local simulator with 1000 shots."

# ╔═╡ 52a96f4d-2621-4fda-bfcf-22449ee51f95
device = PyBraket.LocalSimulator("braket_ahs")

# ╔═╡ 14a896f6-f218-43e4-9278-3de94c88cd32
local_results = [result(simulate(device, program, shots=1000)) for program in programs]

# ╔═╡ 229b0550-6bd0-4f81-b37a-5a0b8e33a9b1
state_counts = local_results .|> get_counts

# ╔═╡ f5764bba-bb57-42d7-a68e-52913eb32b18
md"Finally we plot the number of shots resulting in the atom being in its groundstate compared with the total program length. We should be able to see the Rabi oscillation at the correct frequency in this plot."

# ╔═╡ b4270f21-7a9f-45d6-9255-5606b62247ff
begin
	p = plot(trange,
	     	[state_count["g"] for state_count in state_counts],
	     	marker=:circle,
	     	ylabel="No. of shots with atom in the groundstate",
	     	xlabel="Time (s)",
	     	label="Groundstate density")
	vline!([2π/Ω_max], label="Inverse Rabi frequency")
end

# ╔═╡ 75b92907-eeb8-44c4-b0e8-10c9403e19a9
md"Indeed, the oscillation period is exactly at $2\pi/\Omega_{max}$, as we expected."

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
DataStructures = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
Plots = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"

[compat]
Braket = "~0.1.0"
DataStructures = "~0.18.13"
Plots = "~1.37.0"
PyBraket = "~0.1.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.4"
manifest_format = "2.0"
project_hash = "ac7dca929cd60db1dda885b8c2ba99e143ab5e29"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "19ed52e8e3cc91a85c73c1bd514fd24a3e5bef06"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.78.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "e753f872313928ea3ecbc415ae99ab18c8de10bc"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.1.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "Tables", "Unicode", "WeakRefStrings"]
git-tree-sha1 = "873fb188a4b9d76549b81465b1f75c82aaf59238"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.4"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "e7ff6cadf743c098e08fca25c91103ee4303c9bb"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.6"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "ded953804d019afa9a3f98981d99b33e3db7b6da"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.0"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random", "SnoopPrecompile"]
git-tree-sha1 = "aa3edc8f8dea6cbfa176ee12f7c2fc82f0608ed3"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.20.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "d08c20eef1f2cbc6e60fd3612ac4340b89fea322"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.9"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "417b0ed7b8b838aa6ca0a87aadf1bb9eb111ce40"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.8"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "3ca828fe1b75fa84b021a7860bd039eaea84d2f2"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.3.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.5+0"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "341e3ce7ddd8d57dc7be27146bd1c072000d485a"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.14"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.DataAPI]]
git-tree-sha1 = "e08915633fcb3ea83bf9d6126292e5bc5c739922"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.13.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
git-tree-sha1 = "9e2f36d3c96a820c678f2f1f1782582fcf685bae"
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"
version = "1.9.1"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "c36550cb29cbe373e95b3f40486b9a4148f89ffd"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.2"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GR]]
deps = ["Artifacts", "Base64", "DelimitedFiles", "Downloads", "GR_jll", "HTTP", "JSON", "Libdl", "LinearAlgebra", "Pkg", "Preferences", "Printf", "Random", "Serialization", "Sockets", "TOML", "Tar", "Test", "UUIDs", "p7zip_jll"]
git-tree-sha1 = "051072ff2accc6e0e87b708ddee39b18aa04a0bc"
uuid = "28b8d3ca-fb5f-59d9-8090-bfdbd6d07a71"
version = "0.71.1"

[[deps.GR_jll]]
deps = ["Artifacts", "Bzip2_jll", "Cairo_jll", "FFMPEG_jll", "Fontconfig_jll", "GLFW_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Pixman_jll", "Pkg", "Qt5Base_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "501a4bf76fd679e7fcd678725d5072177392e756"
uuid = "d2c73de3-f751-5644-a686-071e5b155ba9"
version = "0.71.1+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "08ee34cdc529bd4e631f661595c2eb695515bdbc"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.1"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "fb83fbe02fe57f2c068013aa94bcdf6760d3a7a7"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+1"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "4abede886fcba15cd5fd041fef776b230d004cee"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.4.0"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "0cf92ec945125946352f3d46c96976ab972bde6f"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.3.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLFzf]]
deps = ["Pipe", "REPL", "Random", "fzf_jll"]
git-tree-sha1 = "f377670cda23b6b7c1c0b3893e37451c5c1a2185"
uuid = "1019f520-868f-41f5-a6de-eb00f4b6a39c"
version = "0.1.5"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "65edf3850efb9cb4ca3b0bf488e29c6c38a23d2d"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.11.1"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.Latexify]]
deps = ["Formatting", "InteractiveUtils", "LaTeXStrings", "MacroTools", "Markdown", "OrderedCollections", "Printf", "Requires"]
git-tree-sha1 = "ab9aa169d2160129beb241cb2750ca499b4e90e9"
uuid = "23fbe1c1-3f47-55db-b15f-69d7ec21a316"
version = "0.15.17"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.4"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "8.4.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.11.0+1"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "6f73d1dd803986947b2c750138528a999a6c7733"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.6.0+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "42b62845d70a619f063a7da093d995ec8e15e778"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+1"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "Pkg", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "3eb79b0ca5764d4799c06699573fd8f533259713"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.4.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "946607f84feb96220f480e0422d3484c49c00239"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.19"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "5d4d2d9904227b8bd66386c1138cf4d5ffa826bf"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "0.4.9"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.2+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch"]
git-tree-sha1 = "b49f11c4f9272fcbd66816ab8c3128d39982966c"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.9"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "bf210ce90b6c9eed32d25dbcae1ebc565df2687f"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.0.2"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["ExprTools"]
git-tree-sha1 = "748f6e1e4de814b101911e64cc12d83a6af66782"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.2"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "17eeb975b00de066fb343aa8d56884f51d4a651c"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.1"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+4"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "df6830e37943c7aaa10023471ca47fb3065cc3c4"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.2"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+0"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "b64719e8b4504983c7fca6cc9db3ebc8acc2a4d6"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.1"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pipe]]
git-tree-sha1 = "6842804e7867b115ca9de748a0cf6b364523c16d"
uuid = "b98c9c47-44ae-5843-9183-064241ee97a0"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.2"

[[deps.PlotThemes]]
deps = ["PlotUtils", "Statistics"]
git-tree-sha1 = "1f03a2d339f42dca4a4da149c7e15e9b896ad899"
uuid = "ccf2f8ad-2431-5c83-bf29-c5338b663b6a"
version = "3.1.0"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "5b7690dd212e026bbab1860016a6601cb077ab66"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.2"

[[deps.Plots]]
deps = ["Base64", "Contour", "Dates", "Downloads", "FFMPEG", "FixedPointNumbers", "GR", "JLFzf", "JSON", "LaTeXStrings", "Latexify", "LinearAlgebra", "Measures", "NaNMath", "Pkg", "PlotThemes", "PlotUtils", "Preferences", "Printf", "REPL", "Random", "RecipesBase", "RecipesPipeline", "Reexport", "RelocatableFolders", "Requires", "Scratch", "Showoff", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "UUIDs", "UnicodeFun", "Unzip"]
git-tree-sha1 = "7c5d624a2cb080c2bf41dc5da8fbb837c427048a"
uuid = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
version = "1.37.0"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PyBraket]]
deps = ["AWS", "Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "MicroMamba", "PythonCall", "StructTypes"]
git-tree-sha1 = "362553bc151177fbcbf71efe9e13221ba34d73b9"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.1.0"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "10b3f7d8e91b55754f6e614496104cc74ebd49fb"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.7"

[[deps.Qt5Base_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Fontconfig_jll", "Glib_jll", "JLLWrappers", "Libdl", "Libglvnd_jll", "OpenSSL_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libxcb_jll", "Xorg_xcb_util_image_jll", "Xorg_xcb_util_keysyms_jll", "Xorg_xcb_util_renderutil_jll", "Xorg_xcb_util_wm_jll", "Zlib_jll", "xkbcommon_jll"]
git-tree-sha1 = "0c03844e2231e12fda4d0086fd7cbe4098ee8dc5"
uuid = "ea2cea3b-5b76-57ae-a6ef-0a8af62496e1"
version = "5.15.3+2"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "18c35ed630d7229c5584b945641a73ca83fb5213"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.2"

[[deps.RecipesPipeline]]
deps = ["Dates", "NaNMath", "PlotUtils", "RecipesBase", "SnoopPrecompile"]
git-tree-sha1 = "e974477be88cb5e3040009f3767611bc6357846f"
uuid = "01d81517-befc-4cb6-b9ec-a95719d0359c"
version = "0.6.11"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "efd23b378ea5f2db53a55ae53d3133de4e080aa9"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.16"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SnoopPrecompile]]
git-tree-sha1 = "f604441450a3c0569830946e5b33b78c928e1a85"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.1"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "a4ada03f999bd01b3a25dcaa30b2d929fe537e00"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.1.0"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "ffc098086f35909741f71ce21d03dadf0d2bfa76"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.11"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+6"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "e4bdc63f5c6d62e80eb1c0043fcc0360d5950ff7"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.10"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.Unzip]]
git-tree-sha1 = "ca0969166a028236229f63514992fc073799bb78"
uuid = "41fe7b60-77ed-43a1-b4f0-825fd5a5650d"
version = "0.2.0"

[[deps.Wayland_jll]]
deps = ["Artifacts", "Expat_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "3e61f0b86f90dacb0bc0e73a0c5a83f6a8636e23"
uuid = "a2964d1f-97da-50d4-b82a-358c7fce9d89"
version = "1.19.0+0"

[[deps.Wayland_protocols_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4528479aa01ee1b3b4cd0e6faef0e04cf16466da"
uuid = "2381bf8a-dfd0-557d-9999-79630e7b1b91"
version = "1.25.0+0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "58443b63fb7e465a8a7210828c91c08b92132dff"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.9.14+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_libxkbfile_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "926af861744212db0eb001d9e40b5d16292080b2"
uuid = "cc61e674-0454-545c-8b26-ed2c68acab7a"
version = "1.1.0+4"

[[deps.Xorg_xcb_util_image_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "0fab0a40349ba1cba2c1da699243396ff8e94b97"
uuid = "12413925-8142-5f55-bb0e-6d7ca50bb09b"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll"]
git-tree-sha1 = "e7fd7b2881fa2eaa72717420894d3938177862d1"
uuid = "2def613f-5ad1-5310-b15b-b15d46f528f5"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_keysyms_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "d1151e2c45a544f32441a567d1690e701ec89b00"
uuid = "975044d2-76e6-5fbe-bf08-97ce7c6574c7"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_renderutil_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "dfd7a8f38d4613b6a575253b3174dd991ca6183e"
uuid = "0d47668e-0667-5a69-a72c-f761630bfb7e"
version = "0.3.9+1"

[[deps.Xorg_xcb_util_wm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "e78d10aab01a4a154142c5006ed44fd9e8e31b67"
uuid = "c22f9ab0-d5fe-5066-847c-f4bb1cd4e361"
version = "0.4.1+1"

[[deps.Xorg_xkbcomp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxkbfile_jll"]
git-tree-sha1 = "4bcbf660f6c2e714f87e960a171b119d06ee163b"
uuid = "35661453-b289-5fab-8a00-3d9160c6a3a4"
version = "1.4.2+4"

[[deps.Xorg_xkeyboard_config_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xkbcomp_jll"]
git-tree-sha1 = "5c8424f8a67c3f2209646d4425f3d415fee5931d"
uuid = "33bec58e-1273-512f-9401-5d533626f822"
version = "2.27.0+4"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e45044cd873ded54b6a5bac0eb5c971392cf1927"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.2+0"

[[deps.fzf_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "868e669ccb12ba16eaf50cb2957ee2ff61261c56"
uuid = "214eeab7-80f7-51ab-84ad-2988db7cef09"
version = "0.29.0+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.8.0+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.52.0+1"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"

[[deps.xkbcommon_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Wayland_jll", "Wayland_protocols_jll", "Xorg_libxcb_jll", "Xorg_xkeyboard_config_jll"]
git-tree-sha1 = "9ebfc140cc56e8c2156a15ceac2f0302e327ac0a"
uuid = "d8fb68d0-12a3-5cfd-a85a-d49703b185fd"
version = "1.4.1+0"
"""

# ╔═╡ Cell order:
# ╟─7568667e-7592-11ed-1f75-33a9f6228b6c
# ╟─9cb745ac-8a69-4cd3-ad7a-450558e072d8
# ╠═c37cf3fd-ba64-4b66-9da1-c67ca4752803
# ╟─91485d04-a80e-46cd-a67c-d3571c61fb4d
# ╠═58152bdb-1a5d-4b48-8cfa-aa6dc1ab27ad
# ╠═d34c696e-54af-414b-b916-f3e73b3e116c
# ╟─9c150de3-2076-4895-803c-891d077e21cc
# ╠═456fa9bb-904d-4065-8e5d-c4492c381385
# ╟─c5587822-e315-45d2-beaf-017c245af5f3
# ╠═ef8051a1-69ec-4719-9f51-54d07d0e71fa
# ╠═b974749f-54e8-4bb4-b1f9-48baa778a0d9
# ╠═313b80ed-7549-4992-a791-bc47ed3a042f
# ╟─412e20a7-0fbc-46de-94f0-0a852a589277
# ╠═52a96f4d-2621-4fda-bfcf-22449ee51f95
# ╠═14a896f6-f218-43e4-9278-3de94c88cd32
# ╠═229b0550-6bd0-4f81-b37a-5a0b8e33a9b1
# ╟─f5764bba-bb57-42d7-a68e-52913eb32b18
# ╠═c84d1362-a92f-4688-97d9-03e5f197e242
# ╠═b4270f21-7a9f-45d6-9255-5606b62247ff
# ╟─75b92907-eeb8-44c4-b0e8-10c9403e19a9
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

using Braket, Test, Mocking, Random, Dates, Tar, JSON3
Mocking.activate()

Base.parse(d::Dict) = d

dev_arn = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"

@testset "Jobs" begin
    @testset "deserialization errors" begin
        @test_throws ArgumentError Braket.deserialize_values(Dict{String, Any}(), Braket.pickled_v4)
        mktempdir() do d
            job = Braket.AwsQuantumJob("arn:fake")
            @test Braket._read_and_deserialize_results(job, d) == []
            pjd = Braket.PersistedJobData(Braket.header_dict[Braket.PersistedJobData], Dict{String, Any}(), Braket.pickled_v4)
            write(joinpath(d, Braket.RESULTS_FILENAME), JSON3.write(pjd))
            @test_throws ArgumentError Braket._read_and_deserialize_results(job, d)
        end
    end
    @testset "logs" begin
        statuses = ["RUNNING", "COMPLETED", "COMPLETED", "COMPLETED"]
        event_dict = Dict("arn:fake/0" => [Dict("timestamp"=>1,"message"=>"0-message1"), Dict("timestamp"=>2,"message"=>"0-message2")],
                          "arn:fake/1" => [Dict("timestamp"=>1,"message"=>"1-message1"), Dict("timestamp"=>2,"message"=>"1-message2")])

        function events_get(str)
            dict = JSON3.read(str, Dict)
            return haskey(dict, "logStreamName") && !isempty(event_dict[dict["logStreamName"]]) ? [popfirst!(event_dict[dict["logStreamName"]])] : []
        end
        resp_dict(r) = JSON3.write(
                        Dict("instanceConfig"=>Dict("instanceCount"=>2),
                         "logStreams"=>[Dict("logStreamName"=>"arn:fake/0"),
                                        Dict("logStreamName"=>"arn:fake/1")],
                         "nextForwardToken"=>"000000",
                         "events"=>events_get(r),
                         "status"=>isempty(statuses) ? "COMPLETED" : popfirst!(statuses),
                        ))
        req_patch  = @patch Braket.AWS._http_request(a, r, b) = return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(resp_dict(r.content)))
        mktemp() do f, io
            redirect_stdout(io) do
                apply(req_patch) do
                    job = Braket.AwsQuantumJob("job/arn:fake")
                    Braket.logs(job, wait=true, poll_interval_seconds=1)
                end
            end
            seekstart(io)
            str = read(io, String)
            for msg in ["0-message1", "0-message2", "1-message1", "1-message2"]
                @test occursin(msg, str)
            end
        end
    end
    @testset "S3 source module" begin
        log_streams = [Dict("logStreamName"=>"fake_name")]
        events      = []
        resp_dict   = Dict("jobArn"=>"arn:job/fake", "status"=>"COMPLETED", "instanceConfig"=>Dict("instanceCount"=>1), "logStreams"=>log_streams, "nextForwardToken"=>"0", "events"=>events, "GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
        sm          = "s3://fake_bucket/fake_module" # to avoid tar and upload
        code_loc    = Braket.construct_s3_uri("fake_bucket", "fake_dir")
        @test_throws ArgumentError Braket._process_s3_source_module(sm, "", code_loc) #no entry point
        @test_throws ArgumentError Braket._process_s3_source_module(sm, "a", code_loc) #no tar.gz ending
        sm *= ".tar.gz"
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            output_dc = Braket.OutputDataConfig("s3://fake_bucket/fake_output")
            checkpoint_cf = Braket.CheckpointConfig(nothing, "s3://fake_bucket/fake_checkpoints")
            job = Braket.AwsQuantumJob(dev_arn, sm, entry_point="fake_entry.py", role_arn="arn:fake:role", code_location=code_loc, hyperparameters=Dict("blah"=>1), output_data_config=output_dc, checkpoint_config=checkpoint_cf, wait_until_complete=true)
            @test arn(job) == resp_dict["jobArn"]
            @test name(job) == "fake"
        end
    end
    @testset "local source module" begin
        log_streams = [Dict("logStreamName"=>"fake_name")]
        events      = []
        resp_dict   = Dict("jobArn"=>"arn:job/fake",
                           "status"=>"COMPLETED",
                           "instanceConfig"=>Dict("instanceCount"=>1),
                           "logStreams"=>log_streams,
                           "nextForwardToken"=>"0",
                           "events"=>events,
                           "GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000")
                        )
        @testset for sm in [joinpath(@__DIR__, "fake_code.jl"), joinpath(@__DIR__, "fake_code.py")]
            code_loc = Braket.construct_s3_uri("fake_bucket", "fake_dir")
            bad_path = randstring(10)
            @test_throws ArgumentError Braket._process_local_source_module(bad_path, sm, code_loc) # is not path
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer())
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                output_dc = Braket.OutputDataConfig("s3://fake_bucket/fake_output")
                checkpoint_cf = Braket.CheckpointConfig(nothing, "s3://fake_bucket/fake_checkpoints")
                job = Braket.AwsQuantumJob(dev_arn, sm, entry_point="", role_arn="arn:fake:role", code_location=code_loc, hyperparameters=Dict("blah"=>1), output_data_config=output_dc, checkpoint_config=checkpoint_cf, wait_until_complete=true)
                @test arn(job)  == resp_dict["jobArn"]
                @test name(job) == "fake"
            end
        end
    end
    @testset "input data handling" begin
        withenv("AWS_DEFAULT_REGION"=>"fake_region") do 
            log_streams = [Dict("logStreamName"=>"fake_name")]
            events      = []
            resp_dict   = Dict("jobArn"=>"arn:job/fake", "status"=>"COMPLETED", "instanceConfig"=>Dict("instanceCount"=>1), "logStreams"=>log_streams, "nextForwardToken"=>"0", "events"=>events, "GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
            sm = joinpath(@__DIR__, "fake_code.jl")
            code_loc = Braket.construct_s3_uri("fake_bucket", "fake_dir")
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    xml_str = """
                        <ListAllMyBucketsResult>
                            <Buckets>
                                <Bucket>
                                    <CreationDate>2000:01:01T00:00:00</CreationDate>
                                    <Name>"amazon-braket-fake_region-000000"</Name>
                                </Bucket>
                            </Buckets>
                            <Owner>
                                <DisplayName>"fake_name"</DisplayName>
                                <ID>000000</ID>
                            </Owner>
                        </ListAllMyBucketsResult>
                    """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO; kwargs...) = f(http_backend, request, response_stream)
            input_data = relpath(joinpath(pkgdir(Braket), "test", "fake_code.py"), @__DIR__)
            apply(req_patch) do
                output_dc = Braket.OutputDataConfig("s3://fake_bucket/fake_output")
                checkpoint_cf = Braket.CheckpointConfig(nothing, "s3://fake_bucket/fake_checkpoints")
                job = Braket.AwsQuantumJob(dev_arn, sm, entry_point="", input_data=input_data, role_arn="arn:fake:role", code_location=code_loc, hyperparameters=Dict("blah"=>1), output_data_config=output_dc, checkpoint_config=checkpoint_cf, wait_until_complete=true)
                @test arn(job) == "arn:job/fake"
            end
        end
    end
    @testset "status" begin
        resp_dict = Dict("status"=>"COMPLETED")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            job = Braket.AwsQuantumJob("arn:fake")
            @test state(job) == "COMPLETED"
            @test state(job, Val(true)) == "COMPLETED"
        end
    end
    @testset "_get_default_jobs_role" begin
        resp_dict = Dict("ListRolesResult"=>Dict("Roles"=>Dict("member"=>[Dict("RoleName"=>"noMemberHere")])))
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            @test_throws ErrorException Braket._get_default_jobs_role()
        end
    end
    @testset "cancel" begin
        resp_dict = Dict("cancellationStatus"=>"CANCELLED", "quantumJobArn"=>"arn:fake")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            t = AwsQuantumJob("arn:fake")
            @test isnothing(Braket.cancel(t))
        end
    end
    @testset "metrics" begin
        # empty metrics
        j = Braket.AwsQuantumJob("arn:fake")
        resp_dict = Dict("status"=>"Complete", "jobName"=>"fake_job", "queryId"=>"00000", "results"=>[])
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            @test metrics(j) == []
        end
        # not empty
        result_dicts = [Dict("field"=>"@message", "value"=>"Metrics - timestamp=\"2000-01-01T00:00:00\"; FakeKey=1;"),
                        Dict("field"=>"@timestamp", "value"=>"2000-01-01T00:00:00")]
        function f(http_backend, request, response_stream)
            stat = request.service == "braket" ? "COMPLETED" : "Complete"
            resp_dict = Dict("status"=>stat, "jobName"=>"fake_job", "queryId"=>"00000", "startedAt"=>"2000-01-01T00:00:00.0", "endedAt"=>"2000-01-01T10:00:00.0", "results"=>[result_dicts])
            return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request, response_stream) = f(http_backend, request, response_stream)
        apply(req_patch) do
            @test metrics(j) == Dict{String, Vector}("timestamp" => ["2000-01-01T00:00:00"], "FakeKey"=>["1"])
        end
        if VERSION >= v"1.7"
            # test timeout
            resp_dict = Dict("status"=>"Running", "jobName"=>"fake_job", "queryId"=>"00000")
            req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            apply(req_patch) do
                @test_warn "Timed out waiting for query $(resp_dict["queryId"])" metrics(j)
            end
        end
        # test failure
        resp_dict = Dict("status"=>"Failed", "jobName"=>"fake_job", "queryId"=>"00000")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            @test_throws ErrorException metrics(j)
        end
    end
    @testset "log_metric" begin
        str = mktemp() do fname, f
            redirect_stdout(f) do
                Braket.log_metric("fake_name", 0.01, timestamp="2000:01:01T00:00:00", iteration_number=1)
            end
            seekstart(f)
            read(f, String)
        end
        @test str == "Metrics - timestamp=2000:01:01T00:00:00; fake_name=0.01; iteration_number=1;\n"
    end
    @testset "results" begin
        @testset "successfully get results" begin
            res = """{
                "braketSchemaHeader": {
                    "name": "braket.jobs_data.persisted_job_data",
                    "version": "1"
                },
                "dataDictionary": {"converged": true, "energy": -0.2},
                "dataFormat": "plaintext"
            }"""
            buf = ""
            mktempdir() do d
                mkdir(joinpath(d, "results"))
                write(joinpath(d, "results", "results.json"), res)
                Tar.create(joinpath(d, "results"), pipeline(`gzip -9`, joinpath(d, "model.tar.gz")))
                buf = read(joinpath(d, "model.tar.gz"))
            end
            resp_dict = Dict("status"=>"COMPLETED", "jobName" => "fake_name", "outputDataConfig"=>Dict("s3Path"=>"s3://fake_path"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(buf))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                job = Braket.AwsQuantumJob("arn:fake")
                r   = result(job)
                raw = Braket.parse_raw_schema(res)
                @test r == raw.dataDictionary
            end
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = throw(Braket.HTTP.StatusError(404, "", "", Braket.HTTP.Response(404)))
        apply(req_patch) do
            job = Braket.AwsQuantumJob("arn:fake")
            r = result(job)
            @test r == Dict()
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = throw(ErrorException("badness"))
        apply(req_patch) do
            job = Braket.AwsQuantumJob("arn:fake")
            @test_throws ErrorException result(job)
        end
        @testset "job result timeout" begin
            resp_dict = Dict("status"=>"RUNNING", "jobName" => "fake_name", "outputDataConfig"=>Dict("s3Path"=>"s3://fake_path"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(buf))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                job = Braket.AwsQuantumJob("arn:fake")
                r   = result(job, poll_timeout_seconds=5, poll_interval_seconds=1)
                @test r == []
            end
        end
    end
    @testset "metadata" begin
        resp_dict = Dict("status"=>"COMPLETED")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            job = Braket.AwsQuantumJob("arn:fake")
            @test metadata(job) == resp_dict
        end
    end
    @testset "copying checkpoints" begin
        resp_dict = Dict("status"=>"COMPLETED", "jobArn"=>"job/fake:arn2", "checkpointConfig"=>Dict("s3Uri"=>"s3://fake_old_bucket/fake_path"))
        list_buf = """
        <?xml version="1.0" encoding="UTF-8"?>
        <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
            <Name>fake_old_bucket</Name>
            <Prefix/>
            <KeyCount>1</KeyCount>
            <MaxKeys>1000</MaxKeys>
            <IsTruncated>false</IsTruncated>
            <Contents>
                <Key>my_fake_file.dat</Key>
                <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                <Size>434234</Size>
                <StorageClass>STANDARD</StorageClass>
            </Contents>
            <Contents>
            ...
            </Contents>
            ...
        </ListBucketResult>
        """
        copy_buf = """
        <?xml version="1.0" encoding="UTF-8"?>
        <CopyObjectResult>
            <LastModified>2009-10-12T17:50:30.000Z</LastModified>
            <ETag>"9b2cf535f27731c974343645a3985328"</ETag>
        </CopyObjectResult>
        """
        function f(http_backend, request, response_stream)
            if request.service == "s3"
                if request.request_method == "GET"
                    buf = list_buf
                else
                    buf = copy_buf
                end
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(buf))
            else
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            end
        end
        req_patch  = @patch Braket.AWS._http_request(a, r, b) = f(a, r, b)
        apply(req_patch) do
            sm          = "s3://fake_bucket/fake_module.tar.gz" # to avoid tar and upload
            code_loc    = Braket.construct_s3_uri("fake_bucket", "fake_dir")
            output_dc   = Braket.OutputDataConfig("s3://fake_bucket/fake_output")
            checkpoint_cf = Braket.CheckpointConfig(nothing, "s3://fake_new_bucket/fake_checkpoints")
            job = Braket.AwsQuantumJob(dev_arn, sm, entry_point="fake_entry.py", role_arn="arn:fake:role", code_location=code_loc, copy_checkpoints_from_job="fake:arn", output_data_config=output_dc, checkpoint_config=checkpoint_cf)
            @test arn(job) == "job/fake:arn2"
        end
    end
    @testset "CheckpointConfig" begin
        cc = Braket.CheckpointConfig()
        @test cc.localPath == "/opt/jobs/checkpoints"
        @test isnothing(cc.s3Uri)
        withenv("AWS_DEFAULT_REGION"=>"fake_region") do 
            resp_dict = Dict("GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    xml_str = """
                    <ListAllMyBucketsResult>
                        <Buckets>
                            <Bucket>
                                <CreationDate>2000:01:01T00:00:00</CreationDate>
                                <Name>"amazon-braket-fake_region-000000"</Name>
                            </Bucket>
                        </Buckets>
                        <Owner>
                            <DisplayName>"fake_name"</DisplayName>
                            <ID>000000</ID>
                        </Owner>
                    </ListAllMyBucketsResult>
                    """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                cf = Braket.CheckpointConfig("fake_job_name")
                s3path = Braket.construct_s3_uri("amazon-braket-fake_region-000000", "jobs", "fake_job_name", "checkpoints")
                @test cf == Braket.CheckpointConfig("/opt/jobs/checkpoints", s3path)
                read_in = JSON3.read(JSON3.write(cf), Braket.CheckpointConfig)
                @test read_in isa Braket.CheckpointConfig
                @test read_in.localPath == cf.localPath
                @test read_in.s3Uri == cf.s3Uri
            end
        end
    end
    @testset "OutputDataConfig" begin
        odc = Braket.OutputDataConfig()
        @test isnothing(odc.s3Path)
        withenv("AWS_DEFAULT_REGION"=>"fake_region") do 
            resp_dict = Dict("GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    xml_str = """
                    <ListAllMyBucketsResult>
                        <Buckets>
                            <Bucket>
                                <CreationDate>2000:01:01T00:00:00</CreationDate>
                                <Name>"amazon-braket-fake_region-000000"</Name>
                            </Bucket>
                        </Buckets>
                        <Owner>
                            <DisplayName>"fake_name"</DisplayName>
                            <ID>000000</ID>
                        </Owner>
                    </ListAllMyBucketsResult>
                    """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                odc = Braket.OutputDataConfig(job_name="fake_job_name")
                s3path = Braket.construct_s3_uri("amazon-braket-fake_region-000000", "jobs", "fake_job_name", "data")
                @test odc == Braket.OutputDataConfig(s3path)
                read_in = JSON3.read("""{"s3Path": "$s3path"}""", Braket.OutputDataConfig)
                @test read_in isa Braket.OutputDataConfig
                @test read_in.s3Path == s3path 
            end
        end
    end
    @testset "S3DataSourceConfig" begin
        s3d = Braket.S3DataSourceConfig("s3://fake_bucket/fake_prefix", "fake_type")
        @test s3d.config["contentType"] == "fake_type"
        @test s3d.config["dataSource"]["s3DataSource"]["s3Uri"] == "s3://fake_bucket/fake_prefix"
        @test Dict(s3d) == Dict("config"=>s3d.config)
        read_in = JSON3.read("""{"config": $(JSON3.write(s3d.config))}""", Braket.S3DataSourceConfig)
        @test read_in isa Braket.S3DataSourceConfig
        @test read_in.config == s3d.config
    end
    @testset "DeviceConfig" begin
        dc = Braket.DeviceConfig("local:lightning")
        read_in = JSON3.read("""{"device": "local:lightning"}""", Braket.DeviceConfig)
        @test read_in.device == dc.device
    end
    @testset "StoppingCondition" begin
        sc = Braket.StoppingCondition(100)
        read_in = JSON3.read("""{"maxRuntimeInSeconds": 100}""", Braket.StoppingCondition)
        @test read_in isa Braket.StoppingCondition
        @test read_in.maxRuntimeInSeconds == sc.maxRuntimeInSeconds
    end
    @testset "InstanceConfig" begin
        ic = Braket.InstanceConfig("ml.m5.large", 30, 2)
        read_in = JSON3.read(JSON3.write(ic), Braket.InstanceConfig)
        @test read_in isa Braket.InstanceConfig
        @test read_in.instanceType == ic.instanceType
        @test read_in.volumeSizeInGb == ic.volumeSizeInGb
        @test read_in.instanceCount == ic.instanceCount
    end
end

using Braket, Braket.Observables, Test

function _mixed_states(n_qubits::Int)::Circuit
    noise = PhaseFlip(0.2)
    circ = Circuit()
    for qubit in 0:3:(n_qubits - 2)
        circ([(X, qubit), (Y, qubit + 1), (CNot, qubit, qubit + 2), (X, qubit + 1), (Z, qubit + 2)])
        apply_gate_noise!(circ, noise, [qubit, qubit + 2])
    end

    # attach the result types
    circ(Probability)
    circ(Expectation, Observables.Z(), 0)
    return circ
end

@testset "Density Matrix Simulator" begin
    SHOTS = 1000
    DM1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/dm1"
    num_qubits = 10
    for simulator_arn in (DM1_ARN,)
        circuit = _mixed_states(num_qubits)
        device = AwsDevice(simulator_arn)

        tol = get_tol(SHOTS)
        t = AwsQuantumTask(arn(device), circuit, shots=SHOTS, s3_destination_folder=s3_destination_folder)
        res = result(t)
        probabilities = res.measurement_probabilities
        probability_sum = 0
        for bitstring in keys(probabilities)
            @test probabilities[bitstring] >= 0
            probability_sum += probabilities[bitstring]
        end
        @test isapprox(probability_sum, 1, rtol=tol["rtol"], atol=tol["atol"])
        @test length(res.measurements) == SHOTS
    end
end

using Braket, Test

SHOTS = 1000
TN1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/tn1"
SIMULATOR_ARNS = [TN1_ARN]
get_tol(shots::Int) = return (shots > 0 ? Dict("atol"=> 0.1, "rtol"=>0.15) : Dict("atol"=>0.01, "rtol"=>0))
s3_destination_folder = Braket.default_task_bucket()

bell_circ() = Circuit([(H, 0), (CNot, 0, 1)])

function _ghz(num_qubits)
    circuit = Circuit([(H, 0)])
    for qubit in 0:num_qubits - 2
        circuit(CNot, qubit, qubit + 1)
    end
    return circuit
end

function _qft(circuit, num_qubits)
    for i in 0:num_qubits-1
        circuit(H, i)
        for j in 1:num_qubits - i-1
            circuit(CPhaseShift, i + j, i, π/(2^j))
        end
    end
    for qubit in 0:div(num_qubits, 2)-1
        circuit(Swap, qubit, num_qubits - qubit - 1)
    end
    return circuit
end


function _inverse_qft(circuit, num_qubits)
    for qubit in 0:div(num_qubits, 2)-1
        circuit(Swap, qubit, num_qubits - qubit - 1)
    end
    for i in reverse(0:num_qubits-1)
        for j in reverse(1:num_qubits - i - 1)
            circuit(CPhaseShift, i + j, i, -π/(2^j))
        end
        circuit(H, i)
    end
    return circuit
end

@testset "Tensor network simulator" begin
    @testset "GHZ" begin 
        num_qubits = 50
        circuit = _ghz(num_qubits)
        expected = Dict(prod("0" for q in 1:num_qubits)=>0.5, prod("1" for q in 1:num_qubits)=>0.5)
        @testset for simulator_arn in SIMULATOR_ARNS
            device = AwsDevice(_arn=simulator_arn)
            shots = SHOTS
            tol = get_tol(shots)
            res = result(device(circuit, shots=shots, s3_destination_folder=s3_destination_folder))
            probabilities = res.measurement_probabilities
            
            for (bitstring, val) in probabilities
                @test isapprox(val, expected[bitstring], rtol=tol["rtol"], atol=tol["atol"])
            end
            @test length(res.measurements) == shots
        end
    end
    @testset "H + QFT + iQFT" begin
        num_qubits = 24
        h_qubit = rand(0:num_qubits - 1)
        circuit = _inverse_qft(_qft(Circuit([(H, h_qubit)]), num_qubits), num_qubits)
        h_qubit_str = falses(num_qubits)
        h_qubit_str[h_qubit+1] = true
        h_qubit_str = join(string.(Int.(h_qubit_str)), "")
        expected = Dict(prod("0" for q in 1:num_qubits)=>0.5, h_qubit_str=>0.5)
        @testset for simulator_arn in SIMULATOR_ARNS
            device = AwsDevice(_arn=simulator_arn)
            shots = SHOTS
            tol = get_tol(shots)
            res = result(device(circuit, shots=shots, s3_destination_folder=s3_destination_folder))
            probabilities = res.measurement_probabilities
            for (bitstring, val) in probabilities
                @test isapprox(val, expected[bitstring], rtol=tol["rtol"], atol=tol["atol"])
            end
            @test length(res.measurements) == shots
        end
    end
    @testset "No result types Bell pair OpenQASM" begin
        expected = Dict("00"=>0.5, "11"=>0.5)
        openqasm_string = """
            OPENQASM 3;
            qubit[2] q;
            bit[2] c;
            h q[0];
            cnot q[0], q[1];
            c[0] = measure q[0];
            c[1] = measure q[1];
            """
        hardcoded_openqasm = OpenQasmProgram(Braket.header_dict[OpenQasmProgram], openqasm_string, nothing)
        circuit = bell_circ()
        generated_openqasm = ir(circuit, Val(:OpenQASM))
        @testset for simulator_arn in SIMULATOR_ARNS, program in (hardcoded_openqasm, generated_openqasm)
            device = AwsDevice(_arn=simulator_arn)
            tol = get_tol(SHOTS)
            res = result(device(program, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            probabilities = res.measurement_probabilities
            for (bitstring, val) in probabilities
                @test isapprox(val, expected[bitstring], rtol=tol["rtol"], atol=tol["atol"])
            end
            @test length(res.measurements) == SHOTS
        end
    end
end

(::Type{G})(c::Circuit) where {G<:Gate} = throw(ArgumentError("gate applied to a circuit must have targets.")) 
(::Type{G})(c::Circuit, args...) where {G<:Gate} = apply_gate!(Val(n_angles(G)), n_controls(G), n_targets(G), G, c, args...)
(::Type{Unitary})(c::Circuit, args...) = apply_gate!(Unitary, c, args...)
apply_gate!(::Type{G}, c::Circuit, args...) where {G<:Gate} = apply_gate!(Val(n_angles(G)), n_controls(G), n_targets(G), G, c, args...)

apply_gate!(::Val{N}, ::Val{0}, ::Val{1}, ::Type{G}, c::Circuit, args...) where {G<:Gate, N} = (foreach(i->add_instruction!(c, Instruction{G}(G(args[end-(N-1):end]), i)), args[1:end-N]); return c)
apply_gate!(::Val{0}, ::Val{0}, ::Val{1}, ::Type{G}, c::Circuit, args::IntOrQubit...) where {G<:Gate} = (foreach(i->add_instruction!(c, Instruction{G}(G(), i)), args); return c)
apply_gate!(::Val{0}, ::Val{0}, ::Val{1}, ::Type{G}, c::Circuit, args::VecOrQubitSet) where {G<:Gate} = (foreach(i->add_instruction!(c, Instruction{G}(G(), i)), args); return c)
apply_gate!(::Val{N}, ::Val{0}, ::Val{1}, ::Type{G}, c::Circuit, args::VecOrQubitSet, angles::Union{Real, FreeParameter}...) where {N, G<:Gate} = (foreach(i->add_instruction!(c, Instruction{G}(G(tuple(angles[1:N]...)), i)), args); return c)

apply_gate!(::Val{N}, ::Val{0}, ::Val{2}, ::Type{G}, c::Circuit, t1::IntOrQubit, t2::IntOrQubit, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), [t1, t2]))
apply_gate!(::Val{N}, ::Val{0}, ::Val{2}, ::Type{G}, c::Circuit, args::VecOrQubitSet, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), args[1:2]))
apply_gate!(::Val{N}, ::Val{0}, ::Val{2}, ::Type{G}, c::Circuit, args::NTuple{2, Ti}, angle::Union{Real, FreeParameter}...) where {G<:Gate, N, Ti} = add_instruction!(c, Instruction{G}(G(angle), args[1:2]))

apply_gate!(::Val{N}, ::Val{1}, ::Val{1}, ::Type{G}, c::Circuit, ci::IntOrQubit, ti::IntOrQubit, angles::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angles), [ci, ti]))
apply_gate!(::Val{N}, ::Val{1}, ::Val{1}, ::Type{G}, c::Circuit, args::VecOrQubitSet, angles::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angles), args[1:2]))
apply_gate!(::Val{N}, ::Val{1}, ::Val{1}, ::Type{G}, c::Circuit, args::NTuple{2, Ti}, angles::Union{Real, FreeParameter}...) where {G<:Gate, N, Ti} = add_instruction!(c, Instruction{G}(G(angles), [args...]))

apply_gate!(::Val{N}, ::Val{1}, ::Val{2}, ::Type{G}, c::Circuit, ci::IntOrQubit, t1::IntOrQubit, t2::IntOrQubit, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), [ci, t1, t2]))
apply_gate!(::Val{N}, ::Val{1}, ::Val{2}, ::Type{G}, c::Circuit, args::VecOrQubitSet, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), args[1:3]))
apply_gate!(::Val{N}, ::Val{1}, ::Val{2}, ::Type{G}, c::Circuit, args::NTuple{3, Ti}, angle::Union{Real, FreeParameter}...) where {G<:Gate, N, Ti} = add_instruction!(c, Instruction{G}(G(angle), [args...]))

apply_gate!(::Val{N}, ::Val{2}, ::Val{1}, ::Type{G}, c::Circuit, c1::IntOrQubit, c2::IntOrQubit, ti::IntOrQubit, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), [c1, c2, ti]))
apply_gate!(::Val{N}, ::Val{2}, ::Val{1}, ::Type{G}, c::Circuit, args::VecOrQubitSet, angle::Union{Real, FreeParameter}...) where {G<:Gate, N} = add_instruction!(c, Instruction{G}(G(angle), args[1:3]))
apply_gate!(::Val{N}, ::Val{2}, ::Val{1}, ::Type{G}, c::Circuit, args::NTuple{3, Ti}, angle::Union{Real, FreeParameter}...) where {G<:Gate, N, Ti} = add_instruction!(c, Instruction{G}(G(angle), [args...]))

apply_gate!(::Type{Unitary}, c::Circuit, v::VecOrQubitSet, m::Matrix{ComplexF64}) = add_instruction!(c, Instruction{Unitary}(Unitary(m), v))
apply_gate!(::Type{Unitary}, c::Circuit, args...) = add_instruction!(c, Instruction{Unitary}(Unitary(args[end]), [args[1:end-1]...]))

"""
    Operator

Abstract type representing operations that can be applied to a [`Circuit`](@ref).
Subtypes include [`Gate`](@ref), [`Noise`](@ref), [`Observable`](@ref Braket.Observables.Observable),
and [`CompilerDirective`](@ref).
"""
abstract type Operator end

"""
    QuantumOperator < Operator

Abstract type representing *quantum* operations that can be applied to a [`Circuit`](@ref).
Subtypes include [`Gate`](@ref) and [`Noise`](@ref).
"""
abstract type QuantumOperator <: Operator end
ir(o::Operator, t::Vector{T}, ::Val{V}; kwargs...) where {T<:IntOrQubit, V} = ir(o, QubitSet(t), Val(V); kwargs...)
ir(o::Operator, t::Vector{T}; kwargs...) where {T<:IntOrQubit} = ir(o, QubitSet(t), Val(IRType[]); kwargs...)
ir(o::Operator, t::QubitSet; kwargs...)  = ir(o, t, Val(IRType[]); kwargs...)
ir(o::Operator, t::IntOrQubit; kwargs...)          = ir(o, QubitSet(t), Val(IRType[]); kwargs...)
ir(o::Operator, t::IntOrQubit, args...; kwargs...) = ir(o, QubitSet(t), args...; kwargs...)

abstract type Parametrizable end
struct Parametrized end 
struct NonParametrized end 

struct PauliEigenvalues{N}
    coeff::Float64
    PauliEigenvalues{N}(coeff::Float64=1.0) where {N} = new(coeff)
end
PauliEigenvalues(::Val{N}, coeff::Float64=1.0) where {N} = PauliEigenvalues{N}(coeff)
Base.length(p::PauliEigenvalues{N}) where {N} = 2^N
function Base.iterate(p::PauliEigenvalues{N}, ix::Int=1) where {N}
    return ix <= length(p) ? (p[ix], ix+1) : nothing
end

Base.getindex(p::PauliEigenvalues{1}, i::Int)::Float64 = getindex((p.coeff, -p.coeff), i)
function Base.getindex(p::PauliEigenvalues{N}, i::Int)::Float64 where N
    i_block = div(i-1, 2)
    split = div(2^(N-1)-1, 2)
    if N < 5
        total_evs = 2^N
        is_front = !isodd(mod(i-1, 2))
        ev = is_front ? p.coeff : -p.coeff
        mi = mod(i_block, 2)
        di = div(i_block, 2)
        if i_block <= split
            return isodd(mi) ⊻ isodd(di) ? -ev : ev
        else
            mi = mod(i_block - split - 1, 2)
            di = div(i_block - split - 1, 2)
            return isodd(mi) ⊻ isodd(di) ? ev : -ev
        end
    else
        new_i = i > 2^(N-1) ? i - 2^(N-1) : i
	one_down_pe = PauliEigenvalues(Val(N-1))
	one_down = one_down_pe[new_i]
        return i_block <= split ? one_down : -one_down
    end
end
Base.getindex(p::PauliEigenvalues{N}, ix::Vector{Int}) where {N} = [p[i] for i in ix]

"""
    Measure(index) <: QuantumOperator

Represents a measurement operation on targeted qubit, stored in the classical register at `index`.
"""
struct Measure <: QuantumOperator
    index::Int
end
Measure() = Measure(-1)
Parametrizable(m::Measure) = NonParametrized()
chars(::Type{Measure}) = ("M",)
chars(m::Measure) = ("M",)
qubit_count(::Type{Measure}) = 1
ir(m::Measure, target::QubitSet, ::Val{:JAQCD}; kwargs...) = error("measure instructions are not supported with JAQCD.") 
function ir(m::Measure, target::QubitSet, ::Val{:OpenQASM}; serialization_properties=OpenQASMSerializationProperties())
    instructions = Vector{String}(undef, length(target))
    for (idx, qubit) in enumerate(target)
        bit_index = m.index > 0 && length(targets) == 1 ? m.index : idx - 1
        t = format_qubits(qubit, serialization_properties)
        instructions[idx] = "b[$bit_index] = measure $t;"
    end
    return join(instructions, "\n")
end

using Braket, BraketSimulator, LinearAlgebra, SparseArrays, NLopt, Random
using Graphs, SimpleWeightedGraphs, GraphMakie

nv = 5
desired_hops = 4

adj_mat = triu(sprand(nv, nv, 0.75), 1)
#adj_mat = triu([0 5 5 0; 5 0 2 2; 5 2 0 10; 0 2 10 0])
cₑ = sum(adj_mat)
adj_mat += adj_mat'

α = cₑ

function build_hop_Q(s::Int, t::Int, nv::Int, hops::Int, α, A::AbstractMatrix)
    nq = nv * hops
    Q  = zeros(nv*hops, nv*hops) 

    # each vi, vj block is a SymTridiagonal
    @views for vi in 1:nv, vj in vi:nv
        if vi == vj
            #block_mat = diagm(0=>fill(-α, hops), 1=>fill(α, hops-1))
            block_mat = diagm(0=>fill(-α, hops))
            Q[((vi-1)*hops + 1):(vi*hops), ((vi-1)*hops + 1):(vi*hops)] = block_mat[:,:]
        else
            fill_term = A[vi, vj] > 0 ? A[vi, vj] : α 
            block_mat = diagm(-1=>fill(fill_term, hops-1), 0=>fill(α, hops), 1=>fill(fill_term, hops-1))
            Q[((vi-1)*hops + 1):(vi*hops), ((vj-1)*hops + 1):(vj*hops)] = block_mat[:,:]
        end
    end
    # s should be first, t should be last
    # incentivize them and penalize others
    #=for v in 1:nv
        Q[(v-1)*hops + 1, (v-1)*hops + 1] = α
        Q[v*hops, v*hops] = α
    end=#
    Q[(s-1)*hops + 1, (s-1)*hops + 1] = -2α
    Q[t*hops, t*hops] = -2α
    return Q
end

function ZZgate(q1, q2, γ)
    circ_zz = Circuit()
    cnot(circ_zz, q1, q2)
    rz(circ_zz, q2, γ)
    cnot(circ_czz, q1, q2)
    return circ_zz
end

function cost_circuit(γ, nqubits, device, ising)
    cost    = Circuit()
    I, J, V = findnz(sparse(ising))
    for (i, j, int) in zip(I, J, V)
        if i != j
            if device.name == "Rigetti"
                append!(cost, ZZgate(i-1, j-1, γ*int))
            else
                zz(cost, i-1, j-1, -2γ*int)
            end
        end
    end
    return cost
end

function driver_circuit(β, nqubits)
    driver = Circuit()
    for qubit in 1:nqubits
        rx(driver, qubit-1, 2β)
    end
    return driver
end

function qaoa_circuit(params, device, nqubits, ising)
    depth = div(length(params), 2)
    γs    = params[depth+1:end]
    βs    = params[1:depth]

    circ = Circuit() |> (c->x(c, 0:nqubits-1)) |> (c->Braket.h(c, 0:nqubits-1))

    for layer in 1:depth
        cost_circ = cost_circuit(γs[layer], nqubits, device, ising)
        append!(circ, cost_circ)
        driver_circ = driver_circuit(βs[layer], nqubits)
        append!(circ, driver_circ)
    end
    return circ
end

# initializing the optimization
function init_opt(qaoa_depth::Int, n_qubits::Int)
    global_min   = 1e8
    global_state = zeros(n_qubits)
    # initialize with random parameters
    βs           = rand(qaoa_depth)
    γs           = rand(qaoa_depth)
    params       = vcat(βs, γs)
    # tracker for optimization process
    tracker      = Dict("costs"=>[],
                        "params"=>[],
                        "optimal_energy"=>global_min, # best energy so far
                        "optimal_state"=>global_state, # best configuration so far
                        "opt_energies"=>Float64[], # track lowest eigenvalue at every iteration
                        "opt_states"=>[] # track configuration associated with lowest eigenvalue at every iteration
                        )
    return params, tracker
end

# generating the loss & finding the best configuration at each iteration
function apply_qaoa(qaoa_circ, ising, device, nshots::Int)
    task = run(device, qaoa_circ, shots=nshots)
    # the managed simulators store results in Amazon S3
    #    task = device.run(qaoa_circ, s3_folder, nshots)

    # matrix of dimension (nshots, num_qubits)
    result     = Results(task)

    # result comes back as 0s and 1s
    meas_ising = result.measurements
    # but Ising hamiltonian expects values of -1 or 1
    meas_ising = meas_ising

    # generate the energies
    J   = triu(ising)
    xQx = diag(meas_ising * J * transpose(meas_ising)) # computes <x | Q | x> for every result configuration
    all_energies = xQx
    loss = sum(all_energies) / nshots

    # select the best energy
    energy_min    = minimum(all_energies)
    # find the configuration that had that energy
    min_index     = findfirst(x->x==energy_min, all_energies)
    optimal_state = meas_ising[min_index, :]

    return loss, energy_min, optimal_state
end

function train(nqubits::Int, ising, device; depth::Int=3, iterations::Int=100, nshots::Int=100, s3_folder=nothing)
    params, tracker = init_opt(depth, nqubits)
    function f(params, grad)
        # create the circuit
        qaoa_circ = qaoa_circuit(params, device, nqubits, ising)
        loss, energy_min, optimal_state = apply_qaoa(qaoa_circ, ising, device, nshots)

        # update the tracker
        push!(tracker["opt_energies"], energy_min)
        push!(tracker["opt_states"],    optimal_state)
        if energy_min < tracker["optimal_energy"]
            tracker["optimal_energy"] = energy_min
            tracker["optimal_state"]  = optimal_state
        end
        tracker["count"] = tracker["count"] + 1
        push!(tracker["params"], params)


        push!(tracker["costs"], loss)
        return loss
    end

    opt = Opt(:LN_COBYLA, length(params))
    min_objective!(opt, f)
    maxeval!(opt, iterations)
    for i in 1:iterations
        loss, params, info = optimize(opt, params)
    end
    return tracker
end

DEPTH   = 2
SHOTS   = 500

#s, t = shuffle(1:nv)[1:2]
s, t = 1, 4
Q = build_hop_Q(s, t, nv, desired_hops, α, adj_mat)

device  = LocalSimulator("braket_sv_v2")

tracker = train(nv*desired_hops, Q, device; depth=DEPTH, nshots=SHOTS) #s3_folder = (bucket, folder) if using managed simulator
@show s, t 
pvs = collect(1:nv*desired_hops)[Bool.(tracker["optimal_state"])]
path = zeros(Int, desired_hops) 
for pv in pvs
    v = div(pv-1, desired_hops) + 1
    h = mod(pv-1, desired_hops) + 1
    path[h] = v
end
display(Q)
println()
@show nv, desired_hops

display(adj_mat)
println()

@show tracker["optimal_state"]
@show unique(path)

g = SimpleWeightedGraph(adj_mat)
classical_path = enumerate_paths(dijkstra_shortest_paths(g, s), t)
@show classical_path

using Braket, Test

sv1_arn() = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
@testset "Adjoint Gradient" begin
    @testset "with nested targets" begin
        θ = FreeParameter(:theta)
        inputs = Dict("theta"=>0.2)
        obs = (-2*Braket.Observables.Y()) * (3*Braket.Observables.I()) + 0.75 * Braket.Observables.Y() * Braket.Observables.Z()
        circ = Circuit([(Rx, 0, θ), (AdjointGradient, obs, [[0, 1], [2, 3]], ["theta"])])

        expected_openqasm = """
        OPENQASM 3.0;
        input float theta;
        qubit[4] q;
        rx(theta) q[0];
        #pragma braket result adjoint_gradient expectation(-6.0 * y(q[0]) @ i(q[1]) + 0.75 * y(q[2]) @ z(q[3])) theta"""
        gradient_task = Braket.AwsQuantumTask(sv1_arn(), circ, s3_destination_folder=s3_destination_folder, shots=0, inputs=inputs)
        res = result(gradient_task)
        @test res.additional_metadata.action.source == expected_openqasm
        @test res.values == [Dict(:expectation=>1.1920159847703675, :gradient=>Dict(:theta=>5.880399467047451))]
        @test first(res.result_types).type.observable == "-6.0 * y @ i + 0.75 * y @ z"
        @test res.additional_metadata.action.inputs == inputs
    end
    @testset "with standard observable terms" begin
        θ = FreeParameter(:theta)
        inputs = Dict("theta"=>0.2)
        obs = 2*Braket.Observables.X() + 3*Braket.Observables.Y() - Braket.Observables.Z()
        circ = Circuit([(Rx, 0, θ), (AdjointGradient, obs, [[0], [1], [2]], ["theta"])])

        expected_openqasm = """
        OPENQASM 3.0;
        input float theta;
        qubit[3] q;
        rx(theta) q[0];
        #pragma braket result adjoint_gradient expectation(2.0 * x(q[0]) + 3.0 * y(q[1]) - 1.0 * z(q[2])) theta"""

        gradient_task = Braket.AwsQuantumTask(sv1_arn(), circ, s3_destination_folder=s3_destination_folder, shots=0, inputs=inputs)
        res = result(gradient_task)
        @test res.additional_metadata.action.source == expected_openqasm
        @test res.values == [Dict(:expectation=>-1, :gradient=>Dict(:theta=>0))]
        @test first(res.result_types).type.observable == "2.0 * x + 3.0 * y - 1.0 * z"
        @test res.additional_metadata.action.inputs == inputs
    end
    @testset "with batch" begin
        θ = FreeParameter(:theta)
        inputs = Dict("theta"=>0.2)
        obs1 = 2*Braket.Observables.Y() * 3 * Braket.Observables.I()
        obs2 = -2*Braket.Observables.Y() * 3 * Braket.Observables.I() + 0.75 * Braket.Observables.Y() * Braket.Observables.Z()
        circ1 = Circuit([(Rx, 0, θ), (AdjointGradient, obs1, [0, 1], ["theta"])])
        circ2 = Circuit([(Rx, 0, θ), (AdjointGradient, obs2, [[0, 1], [0, 1]], ["theta"])])
        expected_openqasm = [
            """OPENQASM 3.0;
            input float theta;
            qubit[2] q;
            rx(theta) q[0];
            #pragma braket result adjoint_gradient expectation(6.0 * y(q[0]) @ i(q[1])) theta""",
            """OPENQASM 3.0;
            input float theta;
            qubit[2] q;
            rx(theta) q[0];
            #pragma braket result adjoint_gradient expectation(-6.0 * y(q[0]) @ i(q[1]) + 0.75 * y(q[0]) @ z(q[1])) theta"""
            ,
        ]
        expected_result_values = [
          [Dict(:expectation=>-1.1920159847703675, :gradient=>Dict(:theta=>-5.880399467047451))],
          [Dict(:expectation=>1.0430139866740715, :gradient=>Dict(:theta=>5.145349533666519))],
        ]
        expected_observables = ["6.0 * y @ i", "-6.0 * y @ i + 0.75 * y @ z"]
    
        gradient_batch_tasks = Braket.AwsQuantumTaskBatch(sv1_arn(),
                                                          [circ1, circ2],
                                                          s3_destination_folder=s3_destination_folder,
                                                          shots=0,
                                                          inputs=inputs
                                                         )
        for i in 1:length(Braket.tasks(gradient_batch_tasks))
            res = result(Braket.tasks(gradient_batch_tasks)[i])
            @test res.additional_metadata.action.source == expected_openqasm[i]
            @test res.values == expected_result_values[i]
            @test first(res.result_types).type.observable == expected_observables[i]
            @test res.additional_metadata.action.inputs == inputs
        end
    end
end

using CodeTracking, JLD2

"""Sanitize forbidden characters from hyperparameter strings"""
function _sanitize(hyperparameter::String)
    # replace forbidden characters with close matches
    # , not technically forbidden, but to avoid mismatched parens
    if VERSION >= v"1.7"
        sanitized = replace(hyperparameter, "\n"=>" ", "\$"=>"?", "("=>"{", "&"=>"+", "`"=>"'", ")"=>"}")
    else
        sanitized = deepcopy(hyperparameter)
        for pat in ["\n"=>" ", "\$"=>"?", "("=>"{", "&"=>"+", "`"=>"'", ")"=>"}"] 
            sanitized = replace(sanitized, pat)
        end
    end
    # max allowed length for a hyperparameter is 2500
    # show as much as possible, including the final 20 characters
    length(sanitized) > 2500 && return "$(sanitized[1:2500-23])...$(sanitized[end-19:end])"
    return sanitized
end


function _kwarg_to_string(kw)
    val = kw[2] isa String ? "\""*kw[2]*"\"" : string(kw[2])
    return string(kw[1])*"="*val
end

"""
Captures the arguments and keyword arguments of
`entry_point` as hyperparameters for the Job.
"""
function _log_hyperparameters(f_args, f_kwargs)
    # dummy function, as we are now using the input data JLD2 file for this 
    hyperparams = Dict{String, String}()
    #sanitized_hyperparameters = Dict{String, String}(name=>_sanitize(param) for (name, param) in hyperparams)
    return hyperparams 
end

function matches(prefix::String)
    possible_paths = readdir(dirname(abspath(prefix)))
    possible_paths = isabspath(prefix) ? [joinpath(dirname(abspath(prefix)), path) for path in possible_paths] : possible_paths
    prefixed_paths = filter(path->startswith(path, prefix), possible_paths)
    @debug "Possible paths: $possible_paths"
    @debug "Prefix: $prefix, Prefixed paths: $prefixed_paths"
    @debug "\n\n"
    return prefixed_paths
end
is_prefix(path::String) = length(matches(path)) > 1 || !ispath(path)
is_prefix(path) = false
function _process_input_data(input_data::Union{String, Dict})
    isempty(input_data) && (input_data = Dict())
    input_data isa Dict || (input_data = Dict("input"=>input_data))
    prefix_channels = Set{String}()
    directory_channels = Set{String}()
    file_channels = Set{String}()
    @debug "All input data channels: $(collect(keys(input_data)))"
    for (channel, data) in input_data
        @debug "Channel $channel, data $data"
        if is_s3_uri(string(data))
            channel_arg = channel != "input" ? "channel=$channel" : ""
            @warn "Input data channels mapped to an S3 source will not be available in the working directory. Use `get_input_data_dir($channel_arg)` to read input data from S3 source inside the job container."
        elseif is_prefix(data)
            @debug "prefix channel"
            union!(prefix_channels, [channel])
        elseif isdir(data)
            @debug "dir channel"
            union!(directory_channels, [channel])
        else
            @debug "file channel"
            union!(file_channels, [channel])
        end
    end
    @debug "Generating prefix matches"
    for channel in prefix_channels
        @debug "Channel: $channel"
        @debug "Data: $(input_data[channel])"
        @debug "Matches: $( matches(input_data[channel]) )" 
    end
    prefix_matches = Dict(channel=>matches(input_data[channel]) for channel in prefix_channels)
    prefix_matches_str = "{" * join(["$k: $v" for (k,v) in prefix_matches] , ", ")  * "}"
    @debug "Prefix matches: $prefix_matches"
    @debug "Prefix matches string: $prefix_matches_str"

    prefix_channels_str = "{" * join(prefix_channels, ", ") * "}"
    directory_channels_str = "{" * join(["\"" * d * "\"" for d in directory_channels], ", ") * "}"
    @debug "Directory channels: $directory_channels"
    @debug "Directory channels string: $directory_channels_str"
    input_data_items = [(channel, relpath(input_data[channel])) for channel in filter(ch->ch∈union(prefix_channels, directory_channels, file_channels), collect(keys(input_data)))]
    @debug "Input data items: $input_data_items"
    @debug "\n\n"
    input_data_items_str = "[" * join(string.(input_data_items), ", ") * "]"
    return """ 
    from pathlib import Path
    from braket.jobs import get_input_data_dir


    \"\"\"Create symlink from input_link_path to input_data_path.\"\"\"
    def make_link(input_link_path, input_data_path, links):
        input_link_path.parent.mkdir(parents=True, exist_ok=True)
        input_link_path.symlink_to(input_data_path)
        print(input_link_path, '->', input_data_path)
        links[input_link_path] = input_data_path


    def link_input():
        links = {}
        dirs = set()
        # map of data sources to lists of matched local files
        prefix_matches = $prefix_matches_str

        for channel, data in $input_data_items_str:

            if channel in $prefix_channels_str:
                # link all matched files
                for input_link_name in prefix_matches[channel]:
                    input_link_path = Path(input_link_name)
                    input_data_path = Path(get_input_data_dir(channel)) / input_link_path.name
                    make_link(input_link_path, input_data_path, links)

            else:
                input_link_path = Path(data)
                if channel in $directory_channels_str:
                    # link directory source directly to input channel directory
                    input_data_path = Path(get_input_data_dir(channel))
                else:
                    # link file source to file within input channel directory
                    input_data_path = Path(get_input_data_dir(channel), Path(data).name)

                make_link(input_link_path, input_data_path, links)

        return links


    def clean_links(links):
        for link, target in links.items():
            if link.is_symlink and link.readlink() == target:
                link.unlink()

            if link.is_relative_to(Path()):
                for dir in link.parents[:-1]:
                    try:
                        dir.rmdir()
                    except:
                        # directory not empty
                        pass
    """
end

function _serialize_function(f_name::String, f_source::String, included_pkgs::Union{String, Vector{String}}="", included_jl_files::Union{String, Vector{String}}="")
    using_list  = isempty(included_pkgs) ? "JLD2, Braket" : join(vcat(included_pkgs, ["JLD2", "Braket"]), ", ")
    included_jl_files = included_jl_files isa String ? [included_jl_files] : included_jl_files
    return """
import os
import json
from juliacall import Main as jl
from juliacall import Pkg as jlPkg
from braket.jobs import get_results_dir, save_job_result
from braket.jobs_data import PersistedJobDataFormat

jlPkg.activate(".")
jlPkg.instantiate()
jl.seval(f'using $using_list')

input_file_dir = get_input_data_dir("jl_include_files")
for fi in os.listdir(input_file_dir):
    full_path = input_file_dir + '/' + fi
    jl.seval(f'include("{full_path}")')

# set working directory to results dir
results_dir = get_results_dir()
os.chdir(results_dir)

# create symlinks to input data
links = link_input()

def main():
    result = None
    # load and run serialized entry point
    hyperparams = {}
    hp_file = os.environ.get("AMZN_BRAKET_HP_FILE")
    if hp_file:
        with open(hp_file, "r") as f:
            hyperparams = json.load(f)
    hyperparams = hyperparams or {}
    try:
        jl.seval('$f_source\\n')
        load_str_loc = get_input_data_dir("jl_args") + '/job_f_args.jld2'
        load_str = f'j_args = load("{load_str_loc}")'
        jl.seval(load_str)
        jl_func_str = f'$f_name(j_args["jl_args"]...; j_args["jl_kwargs"]...)'
        result = jl.seval(jl_func_str)
    except Exception as e:
        print('An exception occured running the Julia code: ', e, flush=True)
        raise e
    finally:
        clean_links(links)
    if result is not None:
        save_job_result(result, data_format=PersistedJobDataFormat.PICKLED_V4)
    return result

if __name__ == "__main__":
    main()
"""
end

function parse_macro_args(args)
    has_device = length(args) != 0 && occursin("=", string(args[1]))
    device     = has_device ? string(args[1]) : ""
    raw_kwargs = has_device ? args : args[2:end]
    return device, raw_kwargs
end

function _process_call_args(args)
    n_arguments = length(args)
    code = quote end

    splatted_args = [Meta.isexpr(arg, :(...)) for arg in args]
    new_args = [splatted_args[a_ix] ? args[a_ix].args[1] : args[a_ix] for a_ix in 1:n_arguments]
    new_kwargs = filter(arg->Meta.isexpr(arg, :kw), new_args)
    new_args = filter(arg->!Meta.isexpr(arg, :kw), new_args)
    # handle kwargs
    new_kwargs = [(arg.args[1], arg.args[2]) for arg in new_kwargs]

    # match arguments with variables
    vars = [gensym() for v_ix in 1:length(new_args)]
    for v_ix in 1:length(new_args)
        push!(code.args, :($(vars[v_ix]) = $(new_args[v_ix])))
    end
    kw_vars = [gensym() for v_ix in 1:length(new_kwargs)]
    for v_ix in 1:length(new_kwargs)
        push!(code.args, :($(kw_vars[v_ix]) = $(new_kwargs[v_ix])))
    end
    # convert the arguments
    # while keeping the original arguments alive
    var_expressions = [splatted_args[v_ix] ? Expr(:(...), vars[v_ix]) : vars[v_ix] for v_ix in 1:length(new_args)] 
    kw_var_expressions = [kw_vars[v_ix] for v_ix in 1:length(new_kwargs)]
    return code, vars, var_expressions, kw_var_expressions
end

function jobify_f(f, job_f_types, job_f_arguments, job_f_kwargs, device; jl_dependencies="", py_dependencies="", as_local=false, include_modules="", using_jl_pkgs="", include_jl_files="", job_opts_kwargs...)
    mktempdir(pwd(), prefix="decorator_job_") do temp_path
        j_opts = Braket.JobsOptions(; job_opts_kwargs...)
        entry_point_file = joinpath(temp_path, "entry_point.py")
        # create JLD2 file with function arguments and kwargs
        save(joinpath(temp_path, "job_f_args.jld2"), "jl_args", job_f_arguments, "jl_kwargs", Dict(kw[1]=>kw[2] for kw in job_f_kwargs))

        included_jl_files_vec = include_jl_files isa String ? [include_jl_files] : include_jl_files
        jl_files_dict = Dict{String, String}()
        if !isempty(include_jl_files)
            mkdir(joinpath(temp_path, "jl_input_files"))
            for fi in included_jl_files_vec
                dest_fi = isabspath(fi) ? basename(fi) : fi
                cp(fi, joinpath(temp_path, "jl_input_files", dest_fi))
            end
            jl_files_dict["jl_include_files"] = joinpath(temp_path, "jl_input_files")
        end
        raw_input_data = Dict{String, Any}()
        if j_opts.input_data isa String
            raw_input_data = Dict("input"=>j_opts.input_data, "jl_args"=>joinpath(temp_path, "job_f_args.jld2"))
        else
            raw_input_data = merge(j_opts.input_data, Dict("jl_args"=>joinpath(temp_path, "job_f_args.jld2")))
        end
        merge!(raw_input_data , jl_files_dict)
        j_opts.input_data = raw_input_data
        input_data = _process_input_data(raw_input_data)
        
        f_source = code_string(f, job_f_types)
        if isempty(f_source)
            t = precompile(f, job_f_types)
            f_source = code_string(f, job_f_types)
        end
        isempty(f_source) && error("no method instance for $f found with types $job_f_types")
        f_source = String(escape_string(f_source))
        serialized_f = _serialize_function(string(Symbol(f)), f_source, using_jl_pkgs, include_jl_files)
        file_contents = join((input_data, serialized_f), "\n")
        write(entry_point_file, file_contents)
        
        if !isempty(py_dependencies)
            cp(py_dependencies, joinpath(temp_path, "requirements.txt"))
        else
            write(joinpath(temp_path, "requirements.txt"), "juliacall")
        end
        if !isempty(jl_dependencies)
            cp(jl_dependencies, joinpath(temp_path, "Project.toml"))
        else
            write(joinpath(temp_path, "Project.toml"), "[deps]\nBraket = \"19504a0f-b47d-4348-9127-acc6cc69ef67\"\nJLD2 = \"033835bb-8acc-5ee8-8aae-3f567f8a3819\"\n")
        end
        device = isempty(device) ? "local:none/none" : string(device)
        hyperparams = _log_hyperparameters(job_f_arguments, job_f_kwargs)
        j_opts.hyperparameters = hyperparams
        j_opts.entry_point = "$(relpath(temp_path)).entry_point"
        T = as_local ? LocalQuantumJob : AwsQuantumJob
        return T(device, relpath(temp_path), j_opts)
    end
end

"""
    @hybrid_job [device] [job_creation_kwargs] job_function(args...; kwargs..)

Run `job_function` inside an [Amazon Braket Job](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs.html), launching
the job with creation arguments defined by `job_creation_kwargs`, and reserving device `device` (may be empty, in which case
`local:local/none` is used). `device` should be either a [valid AWS device ARN](https://docs.aws.amazon.com/braket/latest/developerguide/braket-devices.html)
or use the format `local:<simulator_provider>/<simulator_name>` (see the developer guide on [embedded simulators](https://docs.aws.amazon.com/braket/latest/developerguide/pennylane-embedded-simulators.html)).

Valid job creation keyword arguments are:
    - `jl_dependencies::String`: a path to a `Project.toml` containing the Julia packages needed to run `job_function`. Can be `""` (default).
    - `py_dependencies::String`: a path to a `requirements.txt` containing the Python packages needed to run `job_function`. Can be `""` (default).
    - `as_local::Bool`: whether to run the job in [local mode](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-local-mode.html). Default is `false`, running as a Hybrid, non-local Job.
    - `include_modules`: unused but reserved argument.
    - `using_jl_pkgs::Union{String, Vector{String}}`: Julia packages to load with `using [pkgs]` before the `job_function` is called within the job.
    - `include_jl_files::Union{String, Vector{String}}`: path(s) to Julia file(s) to load with `include(file)` before `job_function` is called within the job.
    - creation arguments for [`AwsQuantumJob`](@ref)

Currently, `args` and `kwargs` to `job_function` must be serializable by `JLD2.jl`. `job_function` must be a Julia function, not Python.

!!! note
    The paths to include files and dependencies are resolved from the *call location* of this macro - to ensure your paths will resolve correctly, use absolute, not relative, paths.

# Examples
```julia
function my_job_func(a, b::Int; c=0, d::Float64=1.0, kwargs...)
    Braket.save_job_result(job_helper())
    py_reqs = read(joinpath(Braket.get_input_data_dir(), "requirements.txt"), String)
    hyperparameters = Braket.get_hyperparameters()
    write("test/output_file.txt", "hello")
    return 0
end

py_deps = joinpath(@__DIR__, "requirements.txt")
jl_deps = joinpath(@__DIR__, "JobProject.toml")
input_data = joinpath(@__DIR__, "requirements")
include_jl_files = joinpath(@__DIR__, "job_test_script.jl")

j = @hybrid_job Braket.SV1() wait_until_complete=true as_local=false include_modules="job_test_script" using_jl_pkgs="LinearAlgebra" include_jl_files=include_jl_files py_dependencies=py_deps jl_dependencies=jl_deps input_data=input_data my_job_func(MyStruct(), 2, d=5.0, extra_kwarg="extra_value")
```
"""
macro hybrid_job(args...)
    # peel apart `args`
    entry_point = args[end]
    Meta.isexpr(entry_point, :call) || throw(ArgumentError("final argument to @hybrid_job must be a function call"))
    device, jobify_kwargs = parse_macro_args(args[1:end-1])
    f = entry_point.args[1]
    f_args = entry_point.args[2:end]
    # need to transform f to launch as a Job
    # and transform its arguments to be properly passed to the new call
    code, vars, var_expressions, kw_var_expressions = _process_call_args(f_args)
    @gensym job_f job_f_args job_f_kwargs job_f_types wrapped_f
    # now build up the actual call
    push!(code.args,
            quote
                $job_f_args = ($(var_expressions...),)
                $job_f_kwargs = ($(kw_var_expressions...),)
                $job_f_types = tuple(map(Core.Typeof, $job_f_args)...)
                $wrapped_f = $jobify_f($f, $job_f_types, $job_f_args, $job_f_kwargs, $device; $(jobify_kwargs...))
                $wrapped_f
            end
           )
    # use this let block to avoid leaking out of scope
    return esc(quote
        let
            $code
        end
    end)
end

using Braket, Mocking, Random, JSON3, Test

Mocking.activate()

@testset "utils" begin
    @testset "parse_s3_uri" begin
        @test Braket.parse_s3_uri("s3://fake_bucket/fake_path") == ("fake_bucket", "fake_path")
        @test Braket.parse_s3_uri("https://fake_bucket.s3.fake_bucket/fake_path") == ("fake_bucket", "fake_path")
        @test_throws ErrorException Braket.parse_s3_uri("s3:/fake/bad")
    end
    @testset "copy_s3_directory" begin
        function f(http_backend, request, response_stream)
            xml_str = ""
            if request.request_method == "GET"
                xml_str = """
                <?xml version="1.0" encoding="UTF-8"?>
                    <ListBucketResult xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                        <Name>bucket</Name>
                        <Prefix/>
                        <KeyCount>205</KeyCount>
                        <MaxKeys>1000</MaxKeys>
                        <IsTruncated>false</IsTruncated>
                        <Contents>
                            <Key>my_blob.dat</Key>
                            <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                            <ETag>"fba9dede5f27731c9771645a39863328"</ETag>
                            <Size>434234</Size>
                            <StorageClass>STANDARD</StorageClass>
                        </Contents>
                    </ListBucketResult>
                """
            else
                xml_str = """
                <?xml version="1.0" encoding="UTF-8"?>
                <CopyObjectResult>
                   <LastModified>2009-10-12T17:50:30.000Z</LastModified>
                   <ETag>"9b2cf535f27731c974343645a3985328"</ETag>
                </CopyObjectResult>
                """
            end
            return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
        apply(req_patch) do
            r = Braket.copy_s3_directory("s3://fake_source/my_blob", "s3://fake_dest/my_blob")
            @test isnothing(r)
        end
    end
    @testset "is_s3_uri" begin
        @test Braket.is_s3_uri("s3://fake_bucket/fake_path")
        @test !Braket.is_s3_uri("not.a.real.uri")
    end
    @testset "default_bucket" begin
        withenv("AWS_DEFAULT_REGION"=>"fake_region") do 
            resp_dict = Dict("GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    xml_str = """
                    <ListAllMyBucketsResult>
                        <Buckets>
                            <Bucket>
                                <CreationDate>2000:01:01T00:00:00</CreationDate>
                                <Name>"amazon-braket-fake_region-000000"</Name>
                            </Bucket>
                        </Buckets>
                        <Owner>
                            <DisplayName>"fake_name"</DisplayName>
                            <ID>000000</ID>
                        </Owner>
                    </ListAllMyBucketsResult>
                    """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                db = Braket.default_bucket()
                @test db == "amazon-braket-fake_region-000000"
            end
        end
    end
    @testset "upload_to_s3" begin
        mktemp() do fn, f
            uri = "s3://fake_bucket/fake_path"
            write(f, "blah")
            req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer())
            apply(req_patch) do
                r = Braket.upload_to_s3(fn, uri)
                @test isnothing(r)
            end
        end
    end
    @testset "upload_local_data" begin
        @testset "directory prefix" begin
            to_upload = ["input.csv", "input-2.csv", joinpath("input", "data.txt"), joinpath("input-dir", "data.csv")]
            no_upload = ["my-input.csv", joinpath("my-dir", "input.csv")]
            upload_uri = ["s3://my-bucket/dir/input.csv", "s3://my-bucket/dir/input-2.csv", "s3://my-bucket/dir/input/data.txt", "s3://my-bucket/dir/input-dir/data.csv"]
            s3_prefix  = "s3://my-bucket/dir/input"
            cd(mktempdir()) do
                mkdir("input")
                mkdir("input-dir")
                mkdir("my-dir")
                write("input.csv", "a,b,c\n")
                write("input-2.csv", "d,e,f\n")
                write(joinpath("input","data.txt"), "my_data\n")
                write(joinpath("input-dir", "data.csv"), "g,h,i\n")
                write("my-input.csv", "j,k,l\n")
                write(joinpath("my-dir", "input.csv"), "m,n,o\n")
                @testset "local path" begin
                    all_counted = 0
                    req_patch   = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = ("s3:/"*request.resource ∈ upload_uri && (all_counted += 1); return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer()))
                    apply(req_patch) do
                        Braket.upload_local_data("input", s3_prefix)
                    end
                    @test all_counted == length(upload_uri)
                end
                @testset "absolute path" begin
                    all_counted = 0
                    req_patch   = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = ("s3:/"*request.resource ∈ upload_uri && (all_counted += 1); return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer()))
                    apply(req_patch) do
                        Braket.upload_local_data(joinpath(pwd(), "input"), s3_prefix)
                    end
                    @test all_counted == length(upload_uri)
                end
            end
        end
        @testset "file prefix" begin
            to_upload = ["input.py"]
            no_upload = [joinpath("input", "input.py"), "input.csv"]
            upload_uri = ["s3://my-bucket/dir/input.py"]
            s3_prefix  = "s3://my-bucket/dir/input.py"
            cd(mktempdir()) do
                mkdir("input")
                write("input.py", "print('hello world')\n")
                write(joinpath("input", "input.py"), "print('hello world2')\n")
                @testset "local path" begin
                    all_counted = 0
                    req_patch   = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = ("s3:/"*request.resource ∈ upload_uri && (all_counted += 1); return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer()))
                    apply(req_patch) do
                        Braket.upload_local_data("input.py", s3_prefix)
                    end
                    @test all_counted == length(upload_uri)
                end
                @testset "absolute path" begin
                    all_counted = 0
                    req_patch   = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = ("s3:/"*request.resource ∈ upload_uri && (all_counted += 1); return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer()))
                    apply(req_patch) do
                        Braket.upload_local_data(joinpath(pwd(), "input.py"), s3_prefix)
                    end
                    @test all_counted == length(upload_uri)
                end
            end
        end
        @testset "error" begin
            prefix = joinpath("/", randstring(10), randstring(10))
            @test_throws ErrorException Braket.upload_local_data(prefix, randstring(10))
        end
    end
end

const MIN_SIMULATOR_DURATION = Millisecond(3000)
const price_url = "https://pricing.us-east-1.amazonaws.com/offers/v1.0/aws/AmazonBraket/current/index.csv"

mutable struct Pricing
    _price_list::Vector
end
Base.summary(io::IO, p::Pricing) = print(io, "Pricing(" * string(length(p._price_list)) * ")")
function Base.show(io::IO, p::Pricing)
    summary(io, p)
    if length(p._price_list) > 0
        println(io)
        println(io, "Keys:")
        show(io, collect(keys(p._price_list[1])))
        println(io)
        foreach(l->println(io, collect(values(l))), p._price_list)
    end
end

function get_prices!(p::Pricing=Prices[])
    http_response = Downloads.download(price_url)
    csv_file = CSV.File(http_response, skipto=6)
    p._price_list = [OrderedDict(zip(csv_file[1], csv_file[ii])) for ii in 2:length(csv_file)]
    return p
end

function price_search(p::Pricing; kwargs...)
    isempty(p._price_list) && get_prices!(p)
    return filter(p._price_list) do entry
        all([haskey(entry, string(k)) && !ismissing(entry[string(k)]) && entry[string(k)] == v for (k, v) in kwargs])
    end
end
price_search(; kwargs...) = price_search(Prices[]; kwargs...)

abstract type TrackingEvent end

struct TaskCreationEvent <: TrackingEvent
    arn::String
    shots::Int
    is_job_task::Bool
    device::String
end

struct TaskCompletionEvent <: TrackingEvent
    arn::String
    status::String
    execution_duration::Union{Nothing, Float64}
end

struct TaskStatusEvent <: TrackingEvent
    arn::String
    status::String
end

mutable struct Tracker
    _resources::Dict{String}
    _context
    function Tracker(_resources::Dict{String}, ctx)
        t = new(_resources, ctx)
        push!(ctx, t)
        return t
    end
end

Base.haskey(t::Tracker, k::String) = haskey(t._resources, k)
tracked_resources(t::Tracker) = collect(keys(t._resources))
context(t::Tracker) = t._context

mutable struct TrackerContext
    _trackers::Set{Tracker}
    TrackerContext(s::Set{Tracker}) = new(s)
end
TrackerContext() = TrackerContext(Set{Tracker}())
Tracker(tc::TrackerContext) = Tracker(Dict{String, Any}(), tc)
Tracker() = Tracker(GlobalTrackerContext[])

Base.length(tc::TrackerContext) = length(tc._trackers)
Base.push!(tc::TrackerContext, t::Tracker) = (push!(tc._trackers, t); return tc)
Base.setdiff!(tc::TrackerContext, t::Tracker) = (setdiff!(tc._trackers, t); return tc)
broadcast_event!(tc::TrackerContext, e::TrackingEvent) = (foreach(t->receive!(t, e), tc._trackers); return tc)
broadcast_event!(e::TrackingEvent) = broadcast_event!(GlobalTrackerContext[], e)

active_trackers(tc::TrackerContext) = t._trackers

function qpu_tasks_cost(t::Tracker)
    total_cost = Dec128(0)
    for (task_arn, details) in Iterators.filter(x->occursin("qpu", x[2]["device"]), t._resources)
        total_cost += _get_qpu_task_cost(task_arn, details)
    end
    return total_cost
end

function simulator_tasks_cost(t::Tracker)
    total_cost = Dec128(0)
    for (task_arn, details) in Iterators.filter(x->occursin("simulator", x[2]["device"]), t._resources)
        total_cost += _get_simulator_task_cost(task_arn, details)
    end
    return total_cost
end

function quantum_task_statistics(t::Tracker)
    stats = Dict{String, Any}()
    for details in values(t._resources)
        device_stats = get(stats, details["device"], Dict{String, Any}())
        shots = get(device_stats, "shots", 0) + details["shots"]
        device_stats["shots"] = shots

        task_states = get(device_stats, "tasks", Dict{String, Any}())
        task_states[details["status"]] = get(task_states, details["status"], 0) + 1
        device_stats["tasks"] = task_states
        if haskey(details, "execution_duration")
            duration = get(device_stats, "execution_duration", Microsecond(0)) + details["execution_duration"]
            billed_duration = get(device_stats, "billed_execution_duration", Microsecond(0)) + details["billed_duration"]
            device_stats["execution_duration"] = duration
            device_stats["billed_execution_duration"] = billed_duration
        end
        stats[details["device"]] = device_stats
    end
    return stats
end

function _get_qpu_task_cost(arn::String, details::Dict{String})
    details["status"] ∈ ("FAILED", "CANCELLED") && return Dec128(0)

    task_region = String(split(arn, ':')[4])
    search_dict = Dict(Symbol("Region Code")=>task_region)

    device_name = uppercasefirst(String(split(details["device"], '/')[end]))
    occursin("2000Q", device_name) && (device_name = "2000Q")
    occursin("Advantage_system", device_name) && (device_name = "Advantage_system")
    
    if details["job_task"]
        search_dict[Symbol("Device Name")] = device_name
        shot_product_family = "Braket Managed Jobs QPU Task Shot"
        task_product_family = "Braket Managed Jobs QPU Task"
    else
        search_dict[Symbol("DeviceName")] = device_name
        shot_product_family = "Quantum Task-Shot"
        task_product_family = "Quantum Task"
    end
    shot_prices = price_search(; namedtuple(search_dict)...)

    search_dict[Symbol("Product Family")] = shot_product_family
    shot_prices = price_search(; namedtuple(search_dict)...)
    search_dict[Symbol("Product Family")] = task_product_family
    task_prices = price_search(; namedtuple(search_dict)...)
    length(shot_prices) != 1 && throw(ErrorException("found $(length(shot_prices)) products matching $search_dict"))
    length(task_prices) != 1 && throw(ErrorException("found $(length(task_prices)) products matching $search_dict"))

    shot_price = first(shot_prices)
    task_price = first(task_prices)
    for price in (shot_price, task_price)
        price["Currency"] != "USD" && throw(ErrorException("expected USD, found currency $(price["Currency"])"))
    end
    shot_cost = Dec128(shot_price["PricePerUnit"]) * details["shots"]
    task_cost = Dec128(task_price["PricePerUnit"]) * 1
    return shot_cost + task_cost
end

const duration_dict = Dict("minutes"=>Minute, "seconds"=>Second, "hours"=>Hour, "milliseconds"=>Millisecond, "microsecond"=>Microsecond)

function _get_simulator_task_cost(arn::String, details::Dict{String})
    (!haskey(details, "billed_duration") || iszero(details["billed_duration"])) && return Dec128(0)

    task_region = String(split(arn, ':')[4])

    device_name = uppercase(String(split(details["device"], '/')[end]))
    
    search_dict = Dict(Symbol("Device name")=>device_name)
    if details["job_task"]
        product_family = "Braket Managed Jobs Simulator Task"
        operation = "Managed-Jobs"
    else
        product_family = "Simulator Task"
        operation = "CompleteTask"
        details["status"] == "FAILED" && device_name == "TN1" && (operation = "FailedTask")
    end
    search_dict = Dict(Symbol("Region Code")=>task_region, :Version=>device_name, Symbol("Product Family")=>product_family, :operation=>operation)
    duration_prices = price_search(; namedtuple(search_dict)...)
    length(duration_prices) != 1 && throw(ErrorException("found $(length(duration_prices)) products matching $search_dict"))
    duration_price = first(duration_prices)
    duration_price["Currency"] != "USD" && throw(ErrorException("expected USD, found currency $(duration_price["Currency"])"))
    ppu                     = Dec128(duration_price["PricePerUnit"])
    duration_in_millis      = Dec128(@compat details["billed_duration"] / Millisecond(1))
    unit_duration_in_millis = Dec128(@compat duration_dict[duration_price["Unit"]](1) / Millisecond(1))
    duration_cost = ppu * (duration_in_millis / unit_duration_in_millis)
    return duration_cost 
end

function receive!(t::Tracker, e::TaskCreationEvent)
    t._resources[e.arn] = Dict("shots"=>e.shots, "device"=>e.device, "status"=>"CREATED", "job_task"=>e.is_job_task)
    return t
end

function receive!(t::Tracker, e::TaskStatusEvent)
    haskey(t._resources, e.arn) && setindex!(t._resources[e.arn], e.status, "status")
    return t
end

function receive!(t::Tracker, e::TaskCompletionEvent)
    if haskey(t._resources, e.arn)
        t._resources[e.arn]["status"] = e.status
        if !isnothing(e.execution_duration)
            duration = Millisecond(e.execution_duration)
            t._resources[e.arn]["execution_duration"] = duration
            t._resources[e.arn]["billed_duration"] = max(duration, MIN_SIMULATOR_DURATION)
        end
    end
    return t
end

using AWS, AWSS3, Braket, JSON3, Test

@service S3 use_response_type=true

@testset "Quantum Job Creation" begin
    region = aws_get_region()
    account_id = aws_account_number(global_aws_config())
    # Asserts the job is failed with the output, checkpoints,
    # tasks not created in bucket and only input is uploaded to s3. Validate the
    # results/download results have the response raising RuntimeError. Also,
    # check if the logs displays the Assertion Error.
    @testset "Failed Quantum Job" begin
        job = AwsQuantumJob(
            "arn:aws:braket:::device/quantum-simulator/amazon/sv1",
            joinpath(@__DIR__, "job_test_script.py"),
            entry_point="job_test_script:start_here",
            wait_until_complete=true,
            hyperparameters=Dict("test_case"=>"failed"),
        )

        job_name = name(job)
        pattern = Regex("^arn:aws:braket:$region:\\d12:job/$(job_name)")
        pattern_match = match(pattern, arn(job))

        # Check job is in failed state.
        @test state(job) == "FAILED"

        # Check whether the respective folder with files are created for script,
        # output, tasks and checkpoints.
        s3_bucket = "amazon-braket-$region-$(account_id)"
        keys = collect(s3_list_keys(s3_bucket, "jobs/$(job_name)/script/"))
        @test keys == ["jobs/$(job_name)/script/source.tar.gz"]

        # no results saved
        @test result(job) == Dict()

        mktempdir() do temp_dir
            redirect_stdio(stdout=joinpath(temp_dir, "out.txt"), stderr=joinpath(temp_dir, "err.txt")) do
                logs(job, wait=true)
            end
            log_data = read(joinpath(temp_dir, "out.txt"), String)
            errors = read(joinpath(temp_dir, "err.txt"), String)
            @test errors == ""
            logs_to_validate = [
                "Invoking script with the following command:",
                "braket_container.py",
                "Running Code As Process",
                "Test job started!!!!!",
                "AssertionError",
                "Code Run Finished",
                "\"user_entry_point\": \"braket_container.py\"",
            ]
            for data in logs_to_validate
                @test occursin(data, log_data)
            end
        end
        @test startswith(metadata(job)["failureReason"], "AlgorithmError: AssertionError, exit code: 1")
    end
    # Asserts the job is completed with the output, checkpoints, tasks and
    # script folder created in S3 for respective job. Validate the results are
    # downloaded and results are what we expect. Also, assert that logs contains all the
    # necessary steps for setup and running the job and is displayed to the user.
    @testset "Completed Quantum Job" begin
        job = AwsQuantumJob(
            "arn:aws:braket:::device/quantum-simulator/amazon/sv1",
            joinpath(@__DIR__, "job_test_script.py"),
            entry_point="job_test_script:start_here",
            wait_until_complete=true,
            hyperparameters=Dict("test_case"=>"completed"),
        )
        job_name = name(job)
        pattern = Regex("^arn:aws:braket:$region:\\d12:job/$(job_name)")
        pattern_match = match(pattern, arn(job))

        # check job is in completed state.
        @test state(job) == "COMPLETED"

        # Check whether the respective folder with files are created for script,
        # output, tasks and checkpoints.
        s3_bucket = "amazon-braket-$region-$(account_id)"
        for (prefix, expected_key) in [
            ("jobs/$(job_name)/script/", Regex("jobs/$(job_name)/script/source.tar.gz")),
            ("jobs/$(job_name)/data/output/", Regex("jobs/$(job_name)/data/output/model.tar.gz")),
            #Regex("jobs/$(job_name)/tasks/[^/]*/results.json"),
            ("jobs/$(job_name)/checkpoints/", Regex("jobs/$(job_name)/checkpoints/$(job_name)_plain_data.json")),
            ("jobs/$(job_name)/checkpoints/", Regex("jobs/$(job_name)/checkpoints/$(job_name).json")),
        ]
            s3_keys = s3_list_keys(s3_bucket, prefix)
            @test any(!isnothing(match(expected_key, key)) for key in s3_keys)
        end

        # Check if checkpoint is uploaded in requested format.
        for (s3_key, expected_data) in [
            (
                "jobs/$(job_name)/checkpoints/$(job_name)_plain_data.json",
                """{
                    "braketSchemaHeader": {
                        "name": "braket.jobs_data.persisted_job_data",
                        "version": "1"
                    },
                    "dataDictionary": {"some_data": "abc"},
                    "dataFormat": "plaintext"
                }"""
            ),
            (
                "jobs/$(job_name)/checkpoints/$(job_name).json",
                """{
                    "braketSchemaHeader": {
                        "name": "braket.jobs_data.persisted_job_data",
                        "version": "1"
                    },
                    "dataDictionary": {"some_data": "gASVBwAAAAAAAACMA2FiY5Qu\n"},
                    "dataFormat": "pickled_v4"
                }"""
            ),
        ]
            @test JSON3.read(s3_get(s3_bucket, s3_key), Dict) == JSON3.read(expected_data, Dict)
        end
        # Check downloaded results exists in the file system after the call.
        downloaded_result = joinpath(job_name, Braket.RESULTS_FILENAME)
        current_dir = pwd()

        cd(mktempdir()) do
            download_result(job)
            @test isfile(Braket.RESULTS_TAR_FILENAME) && ispath(downloaded_result)
            # Check results match the expectations.
            @test result(job) == Dict("converged"=>true, "energy"=>-0.2)
        end
        mktempdir() do temp_dir
            redirect_stdio(stdout=joinpath(temp_dir, "out.txt"), stderr=joinpath(temp_dir, "err.txt")) do
                logs(job, wait=true)
            end
            log_data = read(joinpath(temp_dir, "out.txt"), String)
            errors = read(joinpath(temp_dir, "err.txt"), String)
            @test errors == ""
            logs_to_validate = [
                "Invoking script with the following command:",
                "braket_container.py",
                "Running Code As Process",
                "Test job started!!!!!",
                "Test job completed!!!!!",
                "Code Run Finished",
                "\"user_entry_point\": \"braket_container.py\"",
                "Reporting training SUCCESS",
            ]
            for data in logs_to_validate
                @test occursin(data, log_data)
            end
        end 
    end
end

@enum QubitReferenceType VIRTUAL PHYSICAL
import Dates: format

abstract type SerializationProperties end
"""
    OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL)

Contains information about how to serialize qubits when outputting
to OpenQASM IR. The `qubit_reference_type` argument may be one of
`VIRTUAL` or `PHYSICAL`.
"""
Base.@kwdef struct OpenQASMSerializationProperties <: SerializationProperties
    qubit_reference_type::QubitReferenceType=VIRTUAL
end

format(target::Int, sps::OpenQASMSerializationProperties)   = sps.qubit_reference_type == VIRTUAL ? "q[$target]" : "\$$target"
format(target::Qubit, sps::OpenQASMSerializationProperties) = format(Int(target), sps)
format_qubits(qubits, sps::OpenQASMSerializationProperties) = join(map(q->format(q, sps), vcat(qubits...)), ", ")
function format_complex(n::Number)
    iszero(real(n)) && iszero(imag(n)) && return 0
    isreal(n) && return real(n)
    iszero(real(n)) && return """$(imag(n))im"""
    return n
end

function format_matrix(m::Matrix{<:ComplexF64})
    m_strs = format_complex.(m)
    arr_strs = ["[" * join(map(n->n isa String ? n : repr(n), m_strs[:, i]), ", ") * "]" for i in 1:size(m_strs, 2)]
    return "["*join(arr_strs, ", ")*"]"
end

using Braket, Test

@testset "Queue Information" begin
    @testset "Task Queue Position" begin
        device = AwsDevice(Braket.SV1())
        bell = Circuit([(H, 0), (CNot, 0, 1)])
        task = device(bell, shots=10)

        # call the queue_position method.
        queue_information = queue_position(task)

        # data type validations
        @test queue_information isa Braket.QuantumTaskQueueInfo
        @test queue_information.queue_type isa QueueType
        @test queue_information.queue_position isa String

        # test queue priority
        @test queue_information.queue_type ∈ (Normal, Priority)

        # test message
        if isempty(queue_information.queue_position)
            @test !isempty(queue_information.message)
            @test queue_information.message isa String
        else
            @test isempty(queue_information.message)
        end
    end

    @testset "Job queue position" begin
        job = AwsQuantumJob(
            Braket.SV1(),
            joinpath(@__DIR__, "job_test_script.py"),
            entry_point="job_test_script:start_here",
            wait_until_complete=true,
            hyperparameters=Dict("test_case"=>"completed"),
        )

        # call the queue_position method.
        queue_information = queue_position(job)

        # data type validations
        @test queue_information isa Braket.HybridJobQueueInfo

        # test message
        @test isempty(queue_information.queue_position)
        @test queue_information.message isa String
    end

    @testset "Queue Depth" begin
        device = AwsDevice(Braket.SV1())

        # call the queue_depth method.
        queue_information = queue_depth(device)

        # data type validations
        @test queue_information isa QueueDepthInfo
        @test queue_information.quantum_tasks isa Dict{QueueType, String}
        @test queue_information.jobs isa String

        for (k,v) in queue_information.quantum_tasks
            @test k isa QueueType
            @test v isa String
        end
    end
end

using Distributed, Statistics, Logging, UUIDs, HTTP
using LinearAlgebra: eigvals

const DEFAULT_SHOTS = 1000
const DEFAULT_RESULTS_POLL_TIMEOUT = 432000
const DEFAULT_RESULTS_POLL_INTERVAL = 1

"""
    AwsQuantumTask

Struct representing a task run on an Amazon-managed device.
"""
mutable struct AwsQuantumTask
    arn::String 
    client_token::String
    poll_timeout_seconds::Int
    poll_interval_seconds::Int
    _future::Union{Future, Nothing}
    _config::AbstractAWSConfig
    _metadata::Dict{String, Any}
    _logger::AbstractLogger
    _result::Union{Nothing, AbstractQuantumTaskResult}
    function AwsQuantumTask(arn::String;
                   client_token::String=string(uuid1()),
                   poll_timeout_seconds::Int=DEFAULT_RESULTS_POLL_TIMEOUT,
                   poll_interval_seconds::Int=DEFAULT_RESULTS_POLL_INTERVAL,
                   logger=global_logger(),
                   config::AWSConfig=global_aws_config())
        new(arn, client_token, poll_timeout_seconds, poll_interval_seconds, nothing, config, Dict(), logger, nothing)
    end
end
Base.show(io::IO, t::AwsQuantumTask) = println(io, "AwsQuantumTask(\"id/taskArn\":\"$(arn(t))\")")
id(t::AwsQuantumTask) = t.arn
"""
    arn(t::AwsQuantumTask) -> String

Returns the ARN identifying the task `t`. This ARN can be used to 
reconstruct the task after the session that launched it has exited.
"""
arn(t::AwsQuantumTask) = t.arn

function AwsQuantumTask(args::NamedTuple)
    action       = args[:action]
    client_token = args[:client_token]
    device_arn   = args[:device_arn]
    s3_bucket    = args[:outputS3Bucket]
    s3_key_prefix = args[:outputS3KeyPrefix]
    shots        = args[:shots]
    extra_opts   = args[:extra_opts]
    config       = args[:config]
    job_token    = get(ENV, "AMZN_BRAKET_JOB_TOKEN", nothing)
    !isnothing(job_token) && merge!(extra_opts, Dict("jobToken"=>job_token))
    timeout_seconds  = get(args, :poll_timeout_seconds, DEFAULT_RESULTS_POLL_TIMEOUT)
    interval_seconds = get(args, :poll_interval_seconds, DEFAULT_RESULTS_POLL_INTERVAL)
    merge!(AWS.AWSServices.braket.service_specific_headers, AWS.LittleDict("Braket-Trackers"=>string(length(GlobalTrackerContext[]))))
    response         = BRAKET.create_quantum_task(action, client_token, device_arn, s3_bucket, s3_key_prefix, shots, extra_opts, aws_config=config)
    pop!(AWS.AWSServices.braket.service_specific_headers, "Braket-Trackers")
    broadcast_event!(TaskCreationEvent(response["quantumTaskArn"], shots, !isnothing(job_token), device_arn))
    return AwsQuantumTask(response["quantumTaskArn"]; client_token=client_token, poll_timeout_seconds=timeout_seconds, poll_interval_seconds=interval_seconds, config=config)
end

function default_task_bucket()
    haskey(ENV, "AMZN_BRAKET_TASK_RESULTS_S3_URI") && return parse_s3_uri(ENV["AMZN_BRAKET_TASK_RESULTS_S3_URI"])
    return (default_bucket(), "tasks")
end

"""
    AwsQuantumTask(device_arn::String, task_spec; kwargs...)

Launches an [`AwsQuantumTask`](@ref) based on `task_spec` on the device associated with `device_arn`.

`task_spec` must be one of:
  - `OpenQASMProgram`
  - `BlackbirdProgram`
  - `Problem`
  - `Program`
  - [`Circuit`](@ref)
  - `AHSProgram`
  - [`AnalogHamiltonianSimulation`](@ref)

Valid `kwargs` are:
  - `s3_destination_folder::Tuple{String, String}`, with default value `default_task_bucket()`.
  - `shots::Int` - the number of shots to run, with default value $DEFAULT_SHOTS. Value must be between `0` and `MAX_SHOTS` for the specific device.
  - `device_params::Dict{String, Any}` - device specific parameters. Currently only used for DWave devices and simulators.
  - `disable_qubit_rewiring::Bool` - whether to allow qubit rewiring in the compilation stage. Default is `false`.
  - `poll_timeout_seconds::Int` - maximum number of seconds to wait while polling for results. Default: $DEFAULT_RESULTS_POLL_TIMEOUT
  - `poll_interval_seconds::Int` - default number of seconds to wait between attempts while polling for results. Default: $DEFAULT_RESULTS_POLL_INTERVAL
  - `tags::Dict{String, String}` - tags for the `AwsQuantumTask`
  - `inputs::Dict{String, Float64}` - input values for any free parameters in the `task_spec`
"""
function AwsQuantumTask(device_arn::String,
                        task_spec::Union{AbstractProgram, Circuit, AnalogHamiltonianSimulation};
                        s3_destination_folder::Tuple{String, String}=default_task_bucket(),
                        shots::Int=DEFAULT_SHOTS,
                        device_params::Dict{String,<:Any}=Dict{String,Any}(),
                        disable_qubit_rewiring::Bool=false,
                        poll_timeout_seconds::Int=DEFAULT_RESULTS_POLL_TIMEOUT,
                        poll_interval_seconds::Int=DEFAULT_RESULTS_POLL_INTERVAL,
                        tags::Dict{String, String}=Dict{String, String}(),
                        inputs::Dict{String,Float64}=Dict{String, Float64}(),
                        config::AbstractAWSConfig=global_aws_config())
    args = prepare_task_input(task_spec, device_arn, s3_destination_folder, shots, device_params, disable_qubit_rewiring, tags=tags, poll_timeout_seconds=poll_timeout_seconds, poll_interval_seconds=poll_interval_seconds, inputs=inputs, config=config)
    return AwsQuantumTask(args)
end

function _create_annealing_device_params(device_params::Dict{Symbol, Any}, device_arn::String)
    if occursin("Advantage", device_arn)
        T = DwaveAdvantageDeviceParameters
        TL = DwaveAdvantageDeviceLevelParameters
    elseif occursin("2000Q", device_arn)
        T = Dwave2000QDeviceParameters
        TL = Dwave2000QDeviceLevelParameters
    else
        throw(ArgumentError("Amazon Braket could not find a device with the ARN: $device_arn. To continue, make sure that the value of the device_arn parameter corresponds to a valid QPU."))
    end
    device_level_parameters = haskey(device_params, :deviceLevelParameters) ? convert(Dict{Symbol, Any}, device_params[:deviceLevelParameters]) : convert(Dict{Symbol, Any}, get(device_params, :providerLevelParameters, Dict{Symbol, Any}()))
    device_level_parameters = delete!(device_level_parameters, :braketSchemaHeader) # in case of old version
    defaults = merge(Dict(zip(fieldnames(TL), fill(nothing, nfields(TL)))), StructTypes.defaults(TL))
    sym_dlps = Dict(zip(Symbol.(keys(device_level_parameters)), values(device_level_parameters)))
    dlps     = merge(defaults, sym_dlps)
    dlps[:braketSchemaHeader] = Braket.header_dict[TL]
    device_level_parameters = StructTypes.constructfrom(TL, dlps)
    return T(Braket.header_dict[T], device_level_parameters) 
end
_create_annealing_device_params(device_params, device_arn) = _create_annealing_device_params(convert(Dict{Symbol, Any}, JSON3.read(JSON3.write(device_params))), device_arn)

function _create_common_params(device_arn::String, s3_destination_folder::Tuple{String, String}, shots::Int; kwargs...)
    timeout_seconds  = get(kwargs, :poll_timeout_seconds, DEFAULT_RESULTS_POLL_TIMEOUT)
    interval_seconds = get(kwargs, :poll_interval_seconds, DEFAULT_RESULTS_POLL_INTERVAL)
    config           = get(kwargs, :config, global_aws_config())
    return (device_arn=device_arn, outputS3Bucket=s3_destination_folder[1],  outputS3KeyPrefix=s3_destination_folder[2], shots=shots, poll_timeout_seconds=timeout_seconds, poll_interval_seconds=interval_seconds, config=config)
end

function _device_parameters_from_dict(device_parameters::Dict{String,<:Any}, device_arn::String, paradigm_parameters::GateModelParameters)
    error_mitigation = get(device_parameters, "errorMitigation", nothing)
    processed_em = error_mitigation isa ErrorMitigation ? ir(error_mitigation) : error_mitigation
    occursin("ionq", device_arn) && return IonqDeviceParameters(header_dict[IonqDeviceParameters], paradigm_parameters, processed_em)
    occursin("rigetti", device_arn) && return RigettiDeviceParameters(header_dict[RigettiDeviceParameters], paradigm_parameters)
    occursin("oqc", device_arn) && return OqcDeviceParameters(header_dict[OqcDeviceParameters], paradigm_parameters)
    occursin("iqm", device_arn) && return IqmDeviceParameters(header_dict[IqmDeviceParameters], paradigm_parameters)
    return GateModelSimulatorDeviceParameters(header_dict[GateModelSimulatorDeviceParameters], paradigm_parameters)
end

function prepare_task_input(problem::Problem, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Union{Dict{String,<:Any}, DwaveDeviceParameters, DwaveAdvantageDeviceParameters, Dwave2000QDeviceParameters}, disable_qubit_rewiring::Bool=false; kwargs...)
    device_parameters = _create_annealing_device_params(device_params, device_arn)
    common = _create_common_params(device_arn, s3_folder, shots; kwargs...)
    client_token = string(uuid1())
    action     = JSON3.write(problem)
    dev_params = JSON3.write(device_parameters)
    tags       = get(kwargs, :tags, Dict{String,String}())
    extra_opts = Dict("deviceParameters"=>dev_params, "tags"=>tags)
    return merge((action=action, client_token=client_token, extra_opts=extra_opts), common)
end

function prepare_task_input(ahs::AnalogHamiltonianSimulation, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Dict{String,<:Any}, disable_qubit_rewiring::Bool=false; kwargs...)
    return prepare_task_input(ir(ahs), device_arn, s3_folder, shots, device_params, disable_qubit_rewiring; kwargs...)
end

function prepare_task_input(program::OpenQasmProgram, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Dict{String,<:Any}, disable_qubit_rewiring::Bool=false; kwargs...)
    common       = _create_common_params(device_arn, s3_folder, shots; kwargs...)
    client_token = string(uuid1())
    tags         = get(kwargs, :tags, Dict{String,String}())
    device_parameters = !isempty(device_params) ? _device_parameters_from_dict(device_params, device_arn, GateModelParameters(header_dict[GateModelParameters], 0, false)) : Dict{String, Any}() 
    dev_params   = JSON3.write(device_parameters)
    extra_opts   = Dict("deviceParameters"=>dev_params, "tags"=>tags)
    
    inputs = get(kwargs, :inputs, Dict{String, Float64}())
    if !isempty(inputs)
        prog_inputs = isnothing(program.inputs) ? Dict{String, Float64}() : program.inputs
        inputs_merged = merge(prog_inputs, inputs)
        program_ = OpenQasmProgram(program.braketSchemaHeader, program.source, inputs_merged)
        action   = JSON3.write(program_)
    else
        action   = JSON3.write(program)
    end
    return merge((action=action, client_token=client_token, extra_opts=extra_opts), common)
end

function prepare_task_input(program::Union{AHSProgram, BlackbirdProgram}, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Dict{String, Any}, disable_qubit_rewiring::Bool=false; kwargs...)
    device_parameters = Dict{String, Any}() # not currently used
    common = _create_common_params(device_arn, s3_folder, shots; kwargs...)
    client_token = string(uuid1())
    action     = JSON3.write(program)
    dev_params = JSON3.write(device_parameters)
    tags       = get(kwargs, :tags, Dict{String,String}())
    extra_opts = Dict("deviceParameters"=>dev_params, "tags"=>tags)
    return merge((action=action, client_token=client_token, extra_opts=extra_opts), common)
end

function prepare_task_input(circuit::Circuit, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Dict{String, Any}, disable_qubit_rewiring::Bool=false; kwargs...)
    validate_circuit_and_shots(circuit, shots)
    common = _create_common_params(device_arn, s3_folder, shots; kwargs...)
    paradigm_parameters = GateModelParameters(header_dict[GateModelParameters], qubit_count(circuit), disable_qubit_rewiring)
    qubit_reference_type = VIRTUAL
    if disable_qubit_rewiring || Instruction(StartVerbatimBox()) in circuit.instructions
        #|| any(instruction.operator isa PulseGate for instruction in circuit.instructions)
        qubit_reference_type = QubitReferenceType.PHYSICAL
    end
    serialization_properties = OpenQASMSerializationProperties(qubit_reference_type=qubit_reference_type)
    oq3_program = ir(circuit, Val(:OpenQASM), serialization_properties=serialization_properties)
    inputs = get(kwargs, :inputs, Dict{String, Float64}())
    program_inputs = isnothing(oq3_program.inputs) ? Dict{String, Float64}() : oq3_program.inputs
    inputs_merged = !isempty(inputs) ? merge(program_inputs, inputs) : oq3_program.inputs
    oq3_program = OpenQasmProgram(oq3_program.braketSchemaHeader, oq3_program.source, inputs_merged)

    device_parameters = _device_parameters_from_dict(device_params, device_arn, paradigm_parameters) 
    client_token = string(uuid1())
    action       = JSON3.write(oq3_program)
    dev_params   = JSON3.write(device_parameters)
    tags         = get(kwargs, :tags, Dict{String,String}())
    extra_opts   = Dict("deviceParameters"=>dev_params, "tags"=>tags)
    return merge((action=action, client_token=client_token, extra_opts=extra_opts), common)
end

function prepare_task_input(circuit::Program, device_arn::String, s3_folder::Tuple{String, String}, shots::Int, device_params::Dict{String, Any}, disable_qubit_rewiring::Bool=false; kwargs...)
    common = _create_common_params(device_arn, s3_folder, shots; kwargs...)
    paradigm_parameters = GateModelParameters(header_dict[GateModelParameters], qubit_count(circuit), disable_qubit_rewiring)
    client_token = string(uuid1())
    action       = JSON3.write(circuit)
    device_parameters = _device_parameters_from_dict(device_params, device_arn, paradigm_parameters) 
    dev_params   = JSON3.write(device_parameters)
    tags         = get(kwargs, :tags, Dict{String,String}())
    extra_opts   = Dict("deviceParameters"=>dev_params, "tags"=>tags)
    return merge((action=action, client_token=client_token, extra_opts=extra_opts), common)
end

function queue_position(t::AwsQuantumTask)
    response = metadata(t)["queueInfo"]
    queue_type = QueueType(response["queuePriority"])
    queue_position = get(response, "position", "None") == "None" ? "" : response["position"]
    message = get(response, "message", "")
    return QuantumTaskQueueInfo(queue_type, queue_position, message)
end

"""
    cancel(t::AwsQuantumTask)

Cancels the task `t`.
"""
function cancel(t::AwsQuantumTask)
    #!isnothing(t._future) && cancel(t.future)
    resp = BRAKET.cancel_quantum_task(t.client_token, HTTP.escapeuri(t.arn), aws_config=t._config)
    broadcast_event!(TaskStatusEvent(t.arn, resp["cancellationStatus"]))
    return
end

"""
    metadata(t::AwsQuantumTask, ::Val{false})
    metadata(t::AwsQuantumTask, ::Val{true})

Fetch metadata for task `t`.
If the second argument is `::Val{true}`, use previously cached
metadata, if available, otherwise fetch it from the Braket service.
If the second argument is `::Val{false}` (default), do not use previously cached
metadata, and fetch fresh metadata from the Braket service.
"""
function metadata(t::AwsQuantumTask, ::Val{false})
    uri = HTTP.escapeuri(t.arn) * "?additionalAttributeNames=QueueInfo"
    resp = BRAKET.get_quantum_task(uri)
    payload = parse(resp)
    broadcast_event!(TaskStatusEvent(t.arn, payload["status"]))
    return payload
end
metadata(t::AwsQuantumTask, ::Val{true})  = !isempty(t._metadata) ? t._metadata : metadata(t, Val(false))
metadata(t::AwsQuantumTask) = metadata(t, Val(false))

"""
    state(t::AwsQuantumTask, ::Val{false}) -> String
    state(t::AwsQuantumTask, ::Val{true}) -> String
    state(t::AwsQuantumTask) -> String

Fetch the state for task `t`.
Possible states are `"CANCELLED"`, `"FAILED"`, `"COMPLETED"`, `"QUEUED"`, and `"RUNNING"`.
If the second argument is `::Val{true}`, use previously cached
metadata, if available, otherwise fetch it from the Braket service.
If the second argument is `::Val{false}` (default), do not use previously cached
metadata, and fetch fresh metadata from the Braket service.
"""
function state(t::AwsQuantumTask, ::Val{false})
    mtd = metadata(t, Val(false))
    status = mtd["status"]
    if status ∈ ["FAILED", "CANCELLED"]
        with_logger(t._logger) do
            @warn "Task is in terminal state $status and no result is available."
            if status == "FAILED"
                failure_reason = get(mtd, "failureReason", "unknown")
                @warn "Task failure reason is: $failure_reason."
            end
        end
    end
    return status
end

function state(t::AwsQuantumTask, ::Val{true})
    mtd = metadata(t, Val(true))
    status = mtd["status"]
    return status
end

state(t::AwsQuantumTask) = state(t, Val(false))

"""
    result(t::AwsQuantumTask)

Fetches the result of task `t`, if available. Blocks until a result
is available, in which case the result is returned, or the task enters a
terminal state without a result (`"FAILED"` or `"CANCELLED"`) or exceeds its
its polling timeout (set at task creation), in which case `nothing` is returned.
"""
function result(t::AwsQuantumTask)
    if !isnothing(t._result) || (!isempty(t._metadata) && state(t, Val(true)) ∈ ["FAILED", "CANCELLED"])
        return t._result
    end
    if !isempty(t._metadata) && state(t, Val(true)) ∈ ["COMPLETED"]
        return _download_result(t)
    end
    start = time()
    while state(t, Val(true)) ∉ ["FAILED", "CANCELLED", "COMPLETED"] && time() - start < t.poll_timeout_seconds
        sleep(t.poll_interval_seconds)
    end
    state(t, Val(false)) == "COMPLETED" && return _download_result(t)
    return nothing
end

retrieve_result_from_s3(bucket::String, location::String) = String(AWSS3.s3_get(bucket, location))

function _download_result(t::AwsQuantumTask)
    current_meta = metadata(t, Val(true))
    result_string = retrieve_result_from_s3(current_meta["outputS3Bucket"], current_meta["outputS3Directory"] * "/results.json")
    res = parse_raw_schema(result_string)
    t._result = format_result(res)
    execution_duration = nothing
    try
        execution_duration = res.additionalMetadata.simulatorMetadata.executionDuration
    catch
        @warn "execution duration not found"
    end
    broadcast_event!(TaskCompletionEvent(t.arn, state(t, Val(true)), execution_duration))
    return t._result
end

Base.:(==)(t1::AwsQuantumTask, t2::AwsQuantumTask) = (id(t1) == id(t2))
Base.hash(t::AwsQuantumTask, h::UInt) = hash(id(t), h)

function count_tasks_with_status(device_arn::String, status::Vector{String}; token=nothing)
    token_ = token
    task_count = 0
    for status_ in status
        filters = [Dict("name"=>"status", "operator"=>"EQUAL", "values"=>[status_]), Dict("name"=>"deviceArn", "operator"=>"EQUAL", "values"=>[device_arn])]
        response = BRAKET.search_quantum_tasks(filters)
        token_ = response["nextToken"]
        status_count = length(response["quantumTasks"])
        task_count += length(response["quantumTasks"])
    end
    return task_count
end
count_tasks_with_status(device_arn::String, status::String) = count_tasks_with_status(device_arn, [status])

Base.show(io::IO, r::GateModelQuantumTaskResult) = println(io, "GateModelQuantumTaskResult")
Base.show(io::IO, r::PhotonicModelQuantumTaskResult) = println(io, "PhotonicModelQuantumTaskResult")
Base.show(io::IO, r::AnnealingQuantumTaskResult) = println(io, "AnnealingQuantumTaskResult")
Base.show(io::IO, r::AnalogHamiltonianSimulationQuantumTaskResult) = println(io, "AnalogHamiltonianSimulationQuantumTaskResult")

function measurement_counts(measurements::Vector)
    bitstrings = String[]
    for j in 1:length(measurements)
        push!(bitstrings, prod(string(qi) for qi in measurements[j]))
    end
    return counter(bitstrings)
end

function measurement_probabilities(measurement_counts::Accumulator)
    shots = sum(values(measurement_counts))
    probs = Dict{String, Float64}(key=>count/shots for (key, count) in measurement_counts)
    return probs
end

function _measurements(probs::Dict{String, Float64}, shots::Int)
    measurements = Vector{Int}[]
    for (bitstring, prob) in probs
        int_list = [tryparse(Int, string(b)) for b in bitstring]
        measurement = [int_list for ii in 1:convert(Int, round(prob*shots))]
        append!(measurements, measurement)
    end
    return measurements
end

function _selected_measurements(measurements::Matrix{Int}, measured_qubits, targets)
    (isnothing(targets) || targets == measured_qubits) && return measurements
    cols = [findfirst(q->q==t, measured_qubits) for t in targets]
    return @view measurements[:, cols]
end
_selected_measurements(measurements::Vector{Vector{Int}}, measured_qubits, targets) = _selected_measurements(mapreduce(permutedims, vcat, measurements), measured_qubits, targets)

function _measurements_base_10(measurements)
    two_powers = [2^i for i in reverse(0:size(measurements)[end]-1)]
    return measurements * two_powers
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.StandardObservable, targets::Vector{Int}, ::Val{:sample})
    measurements = _selected_measurements(measurements, measured_qubits, targets)
    return (-2.0 .* vec(measurements)) .+ 1.0
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.TensorProduct, targets::Vector{Int}, ::Val{:sample})
    measurements = _selected_measurements(measurements, measured_qubits, targets)
    ixs = _measurements_base_10(measurements) .+ 1
    evs = eigvals(observable)
    return real.(evs[ixs])
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.Observable, targets::Vector{Int}, ::Val{:sample})
    measurements = _selected_measurements(measurements, measured_qubits, targets)
    ixs = _measurements_base_10(measurements) .+ 1
    evs = eigvals(observable)
    return real.(evs[ixs])
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.Observable, targets::Vector{Int}, ::Val{:variance})
    samples = _calculate_for_targets(measurements, measured_qubits, observable, targets, Val(:sample))
    return var(samples)
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.Observable, targets::Vector{Int}, ::Val{:expectation})
    samples = _calculate_for_targets(measurements, measured_qubits, observable, targets, Val(:sample))
    return mean(samples)
end

function _calculate_for_targets(measurements, measured_qubits, observable::Observables.Observable, targets, ::Val{V}) where {V}
    return [_calculate_for_targets(measurements, measured_qubits, observable::Observables.Observable, [q], Val(V)) for q in measured_qubits]
end

function _calculate_for_targets(measurements, measured_qubits, targets, ::Val{:probability})
    _measurements = _selected_measurements(measurements, measured_qubits, targets)
    shots, num_measured_qubits = size(_measurements)
    ixs   = _measurements_base_10(_measurements)
    count = counter(ixs)
    probabilities = zeros(Float64, 2^num_measured_qubits)
    for (b, v) in count
        probabilities[b+1] = v / shots
    end
    return probabilities
end

function calculate_result_types(ir_obj, measurements, measured_qubits::Vector{Int})
    result_types = ResultTypeValue[]
    (!haskey(ir_obj, :results) || isnothing(ir_obj[:results])) && return result_types
    for result_type in ir_obj[:results]
        ir_obs = get(result_type, :observable, nothing)
        rt     = JSON3.read(JSON3.write(result_type), AbstractProgramResult)
        obs    = isnothing(ir_obs) ? nothing : StructTypes.constructfrom(Observables.Observable, rt.observable)
        targs  = rt.targets
        typ    = result_type[:type]
        if typ == "probability"
            val = _calculate_for_targets(measurements, measured_qubits, targs, Val(Symbol(typ)))
            push!(result_types, ResultTypeValue(rt, val))
        elseif typ ∈ ["sample", "expectation", "variance"]
            val = _calculate_for_targets(measurements, measured_qubits, obs, targs, Val(Symbol(typ)))
            push!(result_types, ResultTypeValue(rt, val))
        else
            throw(ErrorException("unknown result type $typ"))
        end
    end
    return result_types
end

function computational_basis_sampling(::Type{GateModelQuantumTaskResult}, r::GateModelTaskResult)
    task_mtd = r.taskMetadata
    addl_mtd = r.additionalMetadata
    if !isnothing(r.measurements)
        measurements = convert(Vector{Vector{Int}}, r.measurements)
        m_counts = measurement_counts(measurements)
        m_probs  = measurement_probabilities(m_counts)
        measurements_copied_from_device = true
        m_counts_copied_from_device = true
        m_probs_copied_from_device = true
    elseif !isnothing(r.measurementProbabilities)
        shots = task_mtd.shots
        m_probs  = r.measurementProbabilities
        measurements = _measurements(m_probs, shots)
        m_counts = measurement_counts(measurements) 
        measurements_copied_from_device = false
        m_counts_copied_from_device = false
        m_probs_copied_from_device = true
    else
        throw(ErrorException("One of `measurements` or `measurementProbabilities` must be populated in the result object."))
    end
    measured_qubits = r.measuredQubits
    if isnothing(r.resultTypes) || isempty(r.resultTypes)
        # do this in case we have custom gates in the IR
        json_          = hasproperty(addl_mtd.action, :results) ? Dict("results"=>[rt for rt in addl_mtd.action.results]) : addl_mtd.action
        rebuilt_action = JSON3.read(JSON3.write(json_))
        result_types   = calculate_result_types(rebuilt_action, measurements, measured_qubits)
    else
        if !isempty(r.resultTypes) && !isnothing(r.resultTypes[1])
            json_          = Dict("results"=>[rt.type for rt in r.resultTypes])
            rebuilt_action = JSON3.read(JSON3.write(json_))
            result_types   = calculate_result_types(rebuilt_action, measurements, measured_qubits)
        else
            result_types = r.resultTypes
        end
    end
    vals = [rt.value for rt in result_types]
    return GateModelQuantumTaskResult(task_mtd, addl_mtd, result_types, vals, measurements, measured_qubits, m_counts, m_probs, measurements_copied_from_device, m_counts_copied_from_device, m_probs_copied_from_device, nothing)
end

function from_dict(::Type{GateModelQuantumTaskResult}, r::GateModelTaskResult)
    task_mtd = r.taskMetadata
    addi_mtd = r.additionalMetadata
    rts      = r.resultTypes
    vals = map(rts) do rt
        !(rt.type isa IR.Amplitude) && return rt.value
        val_keys = string.(keys(rt.value))
        val_vals = [complex(v...) for v in values(rt.value)]
        return Dict{String, ComplexF64}(zip(val_keys, val_vals))
    end
    return GateModelQuantumTaskResult(task_mtd, addi_mtd, rts, vals, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
end

function format_result(r::GateModelTaskResult)
    if r.taskMetadata.shots > 0
        return computational_basis_sampling(GateModelQuantumTaskResult, r)
    else
        return from_dict(GateModelQuantumTaskResult, r)
    end
end

function format_result(r::AnnealingTaskResult)
    solutions = convert(Vector{Vector{Int}}, r.solutions)
    values    = convert(Vector{Float64}, r.values)
    solution_counts = isnothing(r.solutionCounts) ? ones(Int, length(solutions)) : convert(Vector{Int}, r.solutionCounts)
    n_solutions = length(solutions)
    n_variables = length(solutions[1])
    record_array = AxisArray(hcat(solutions, values, solution_counts), 1:n_solutions, [:solution, :value, :solution_count])
    problem_type = JSON3.read("\"$(r.additionalMetadata.action.type)\"", ProblemType)
    return AnnealingQuantumTaskResult(record_array, n_variables, problem_type, r.taskMetadata, r.additionalMetadata) 
end

function format_result(r::PhotonicModelTaskResult)
    task_mtd = r.taskMetadata
    addi_mtd = r.additionalMetadata
    measurements = !isnothing(r.measurements) ? convert(Vector{Vector{Vector{Int}}}, r.measurements) : nothing
    return PhotonicModelQuantumTaskResult(task_mtd, addi_mtd, measurements)
end

function get_measurements(r::AnalogHamiltonianSimulationTaskResult)
    meas = map(r.measurements) do m
        status = AnalogHamiltonianSimulationShotStatusDict[lowercase(m.shotMetadata.shotStatus)]
        pre_sequence = !isnothing(m.shotResult.preSequence) ? convert(Array{Int}, m.shotResult.preSequence) : nothing
        post_sequence = !isnothing(m.shotResult.postSequence) ? convert(Array{Int}, m.shotResult.postSequence) : nothing
        return ShotResult(status, pre_sequence, post_sequence)
    end
    return meas
end

function format_result(r::AnalogHamiltonianSimulationTaskResult)
    isnothing(r.measurements) && return AnalogHamiltonianSimulationQuantumTaskResult(r.taskMetadata, nothing)
    return AnalogHamiltonianSimulationQuantumTaskResult(r.taskMetadata, get_measurements(r))
end

using Braket, Test, Random, Dates, Tar, JSON3
using Mocking
Mocking.activate()

@testset "Job macro" begin
    @testset "Macro defaults" begin
        resp_dict = Dict("jobArn"=>"arn:job/fake", "GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"), "ListRolesResult"=>Dict("Roles"=>Dict("member"=>[Dict("RoleName"=>"AmazonBraketJobsExecutionRoleFake", "Arn"=>"fake_arn")])))
        function f(http_backend, request, response_stream)
            if request.service == "s3"
                xml_str = """
                    <ListAllMyBucketsResult>
                        <Buckets>
                            <Bucket>
                                <CreationDate>2000:01:01T00:00:00</CreationDate>
                                <Name>"amazon-braket-fake_region-000000"</Name>
                            </Bucket>
                        </Buckets>
                        <Owner>
                            <DisplayName>"fake_name"</DisplayName>
                            <ID>000000</ID>
                        </Owner>
                    </ListAllMyBucketsResult>
                """
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
            else
                return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            end
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO; kwargs...) = f(http_backend, request, response_stream)
        apply(req_patch) do
            function my_job_func(a, b; c)
                println(2)
                return 0
            end
            ENV["AMZN_BRAKET_OUT_S3_BUCKET"] = "fake_bucket"
            j = @hybrid_job my_job_func(0, 1, c=1)
            delete!(ENV, "AMZN_BRAKET_OUT_S3_BUCKET")
            @test arn(j) == "arn:job/fake"
        end
    end
    @testset "Hyperparameter sanitization" for (hyperparameter, expected) in (("with\nnewline", "with newline"),
                                                                              ("with weird chars: (&\$`)", "with weird chars: {+?'}"),
                                                                              (repeat('?', 2600), repeat('?', 2477)*"..."*repeat('?', 20)))
        @test Braket._sanitize(hyperparameter) == expected
    end
end

using Braket, Test
using Braket: Instruction, VIRTUAL, PHYSICAL, OpenQASMSerializationProperties 

@testset "Measure operator" begin
    @test Measure() isa Braket.QuantumOperator
    @testset "Equality" begin
        measure1 = Measure()
        measure2 = Measure()
        non_measure = "non measure"
        @test measure1 == measure2
        @test measure1 != non_measure
    end
    @test Braket.chars(Measure()) == ("M",)

    @testset "To IR" begin
        @testset "Invalid ir_type $ir_type" for (ir_type, message) in ((:JAQCD, "measure instructions are not supported with JAQCD."),
                                                                      )
            @test_throws ErrorException(message) ir(Measure(), QubitSet([0]), Val(ir_type))
        end
        @testset "OpenQASM, target $target, serialization properties $sps" for (target, sps, expected_ir) in (
                                                                                                              ([0], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "b[0] = measure q[0];"),
                                                                                                              ([4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "b[0] = measure \$4;"),
                                                                                                         )

                    
            @test ir(Instruction(Measure(), target), Val(:OpenQASM); serialization_properties=sps) == expected_ir
        end
    end
end

module Braket

export Circuit, QubitSet, Qubit, Device, AwsDevice, AwsQuantumTask, AwsQuantumTaskBatch
export metadata, status, Observable, Result, FreeParameter, Job, AwsQuantumJob, LocalQuantumJob, LocalSimulator
export Tracker, simulator_tasks_cost, qpu_tasks_cost
export arn, cancel, state, result, results, name, download_result, id, ir, isavailable, search_devices, get_devices
export provider_name, properties, type
export apply_gate_noise!, apply
export logs, log_metric, metrics, @hybrid_job
export depth, qubit_count, qubits, ir, IRType, OpenQASMSerializationProperties
export OpenQasmProgram, Measure, measure
export simulate
export QueueDepthInfo, QueueType, Normal, Priority, queue_depth, queue_position

export AdjointGradient, Expectation, Sample, Variance, Amplitude, Probability, StateVector, DensityMatrix, Result

using AWSS3
using AWS
using AWS: @service, AWSConfig, global_aws_config, apply
import AWS.Mocking: apply
@service BRAKET use_response_type=true
@service IAM use_response_type=true
@service EcR use_response_type=true
@service CLOUDWATCH_LOGS use_response_type=true

using Base64
using Compat
using CSV
using Dates
using Downloads
using DecFP
using Graphs
using HTTP
using StaticArrays
using JSON3, StructTypes
using LinearAlgebra
using DataStructures
using NamedTupleTools
using OrderedCollections
using Tar

include("utils.jl")
"""
    IRType

A `Ref{Symbol}` which records which IR output format to use by default.
Currently, two formats are supported:
  - `:JAQCD`, the Amazon Braket IR
  - `:OpenQASM`, the OpenQASM3 representation

By default, `IRType` is initialized to use `:OpenQASM`, although this may change
in the future. The current default value can be checked by calling `IRType[]`.
To change the default IR format, set `IRType[]`.

# Examples
```jldoctest
julia> IRType[]
:OpenQASM

julia> IRType[] = :JAQCD;

julia> IRType[]
:JAQCD

julia> IRType[] = :OpenQASM;
```
"""
const IRType = Ref{Symbol}()
include("tracker.jl")
const Prices = Ref{Pricing}()
const GlobalTrackerContext = Ref{TrackerContext}()
abstract type AbstractBraketSimulator end

"""
    _simulator_devices

A `Ref{Dict}` which records the `id`s of registered
[`LocalSimulator`](@ref) backends so that they can be
retrieved by this `id`. A new simulator backend
should register itself in `_simulator_devices`
in its module's `__init__` function.
"""
const _simulator_devices = Ref{Dict}()

function __init__()
    downloader = Downloads.Downloader()
    downloader.easy_hook = (easy, info) -> Downloads.Curl.setopt(easy, Downloads.Curl.CURLOPT_LOW_SPEED_TIME, 60)
    AWS.DEFAULT_BACKEND[] = AWS.DownloadsBackend()
    AWS.AWS_DOWNLOADER[] = downloader
    IRType[] = :OpenQASM
    Prices[] = Pricing([])
    GlobalTrackerContext[] = TrackerContext()
    _simulator_devices[] = Dict()
end

qubit_count(o) = throw(MethodError(qubit_count, (o,)))

"""
    Device

Abstract type representing a generic device which tasks (local or managed) may be run on.
"""
abstract type Device end


#qubit_count(t) = throw(MethodError(qubit_count, t))
chars(t) = (string(t),) 

include("qubit_set.jl")
include("raw_schema.jl")
ir(p::Union{AHSProgram, BlackbirdProgram, OpenQasmProgram}) = p
using .IR
include("raw_jobs_config.jl")
include("raw_task_result_types.jl")
include("operators.jl")
include("irtypes.jl")
ir(x, ::Val{:JAQCD}; kwargs...) = StructTypes.lower(x)
ir(x) = ir(x, Val(IRType[]))
include("observables.jl")
using .Observables
"""
    FreeParameter
    FreeParameter(name::Symbol) -> FreeParameter

Struct representing a free parameter, which may be used to initialize
to a parametrized [`Gate`](@ref) or [`Noise`](@ref) and then given a
fixed value later by supplying a mapping to a [`Circuit`](@ref).
"""
struct FreeParameter
    name::Symbol
    FreeParameter(name::Symbol) = new(name)
    FreeParameter(name::String) = new(Symbol(name))
end
Base.copy(fp::FreeParameter) = fp
Base.show(io::IO, fp::FreeParameter) = print(io, string(fp.name))

include("compiler_directive.jl")
include("gates.jl")
include("noises.jl")
include("error_mitigation.jl")
include("results.jl")
include("schemas.jl")
include("moments.jl")
include("circuit.jl")
include("noise_model.jl")
include("ahs.jl")
include("queue_information.jl")
include("device.jl")
include("local_simulator.jl")
include("gate_applicators.jl")
include("noise_applicators.jl")
include("jobs.jl")
include("job_macro.jl")
include("aws_jobs.jl")
include("local_jobs.jl")
include("task.jl")
include("task_batch.jl")
end # module

using Braket, JSON3, Test

@testset "AnnealingQuantumTaskResult" begin
    solutions = [[-1, -1, -1, -1], [1, -1, 1, 1], [1, -1, -1, 1]]
    values = [0.0, 1.0, 2.0]
    variable_count = 4
    solution_counts = [3, 2, 4]
    problem_type = Braket.ising
    task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 100, "arn1", nothing, nothing, nothing, nothing, nothing)
    dwave_metadata = Braket.DwaveMetadata(Braket.header_dict[Braket.DwaveMetadata],
        [0],
        Braket.DwaveTiming(
            100,
            20,
            274,
            10917,
            3382,
            9342,
            21,
            117,
            117,
            10917,
            1575,
            20,
            274,
        ),
    )
    problem = Braket.Problem(Braket.header_dict[Braket.Problem],
        problem_type,
        Dict(0=>0.3333, 1=>-0.333, 4=>-0.333, 5=>0.333),
        Dict("0,4"=> 0.667, "0,5"=> -1, "1,4"=> 0.667, "1,5"=> 0.667),
    )
    additional_metadata = Braket.AdditionalMetadata(problem, dwave_metadata, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    function result_str_1()
        result = Braket.AnnealingTaskResult(Braket.header_dict[Braket.AnnealingTaskResult],
            solutions,
            solution_counts,
            values,
            variable_count,
            task_metadata,
            additional_metadata,
        )
        return JSON3.write(result)
    end
    function result_str_2()
        result = Braket.AnnealingTaskResult(Braket.header_dict[Braket.AnnealingTaskResult],
            solutions=solutions,
            variableCount=variable_count,
            values=values,
            taskMetadata=task_metadata,
            additionalMetadata=additional_metadata,
        )
        return JSON3.write(result)
    end
    function result_str_3()
        result = Braket.AnnealingTaskResult(Braket.header_dict[Braket.AnnealingTaskResult],
            solutionCounts=[],
            solutions=solutions,
            variableCount=variable_count,
            values=values,
            taskMetadata=task_metadata,
            additionalMetadata=additional_metadata,
        )
        return JSON3.write(result)
    end
    result = Braket.format_result(Braket.parse_raw_schema(result_str_1()))
    @test result.variable_count == variable_count
    @test result.problem_type == problem_type 
    @test result.task_metadata == task_metadata
    @test result.additional_metadata.action == additional_metadata.action
    @test result.additional_metadata.dwaveMetadata == additional_metadata.dwaveMetadata
    @test result.record_array[:, :solution] == solutions 
    @test result.record_array[:, :value] == values 
    @test result.record_array[:, :solution_count] == solution_counts
    @test sprint(show, result) == "AnnealingQuantumTaskResult\n"
    read_in = JSON3.read(JSON3.write(result), Braket.AnnealingQuantumTaskResult)
    # record array needs some JSON3 TLC
    @test read_in.additional_metadata == result.additional_metadata
    @test read_in.variable_count == result.variable_count
    @test read_in.problem_type == result.problem_type
    @test read_in.task_metadata == result.task_metadata
    @test_broken read_in == result
end

using Test, Braket, JSON3, LinearAlgebra
using Braket: Instruction, VIRTUAL, PHYSICAL, OpenQASMSerializationProperties

struct CustomNoise <: Braket.Noise end

@testset "Noises" begin
    @testset for noise in (BitFlip, PhaseFlip, AmplitudeDamping, PhaseDamping, Depolarizing)
        n = noise(0.1)
        @test qubit_count(n) == 1
        ix = Instruction(n, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset "noise = PauliChannel" begin
        n = PauliChannel(0.1, 0.2, 0.1)
        @test qubit_count(n) == 1
        ix = Instruction(n, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset "noise = MultiQubitPauliChannel{1}" begin
        n = MultiQubitPauliChannel{1}(Dict("X"=>0.1, "Y"=>0.2))
        @test qubit_count(n) == 1
        ix = Instruction(n, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset "noise = TwoQubitPauliChannel" begin
        n = TwoQubitPauliChannel(Dict("XX"=>0.1, "YY"=>0.2))
        @test qubit_count(n) == 2
        ix = Instruction(n, [0, 1])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset for noise in (TwoQubitDephasing, TwoQubitDepolarizing)
        n = noise(0.4)
        @test qubit_count(n) == 2
        ix = Instruction(n, [0, 1])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset "noise = GeneralizedAmplitudeDamping" begin
        n = GeneralizedAmplitudeDamping(0.1, 0.2)
        @test qubit_count(n) == 1
        ix = Instruction(n, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.Parametrized()
    end
    @testset "noise = Kraus" begin
        mat = complex([0 1; 1 0])
        n = Kraus([mat])
        @test qubit_count(n) == 1
        ix = Instruction(n, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(n) == Braket.NonParametrized()
    end
    @testset "fallback" begin
        n = CustomNoise()
        @test Braket.bind_value!(n, Dict(:theta=>0.1)) === n
        @test Braket.parameters(n) == Braket.FreeParameter[]
        @test Braket.Parametrizable(n) == Braket.NonParametrized()
    end
    @test Braket.StructTypes.StructType(Noise) == Braket.StructTypes.AbstractType()
    @testset "OpenQASM" begin
        kraus_1 = [diagm(fill(√0.9, 4)), √0.1 * kron(diagm(ones(Float64, 2)), [0.0 1.0; 1.0 0.0])]
        kraus_2 = [[0.9486833im 0.0; 0.0 0.9486833im], [0.0 0.31622777; 0.31622777 0.0]]
        @testset for ir_bolus in [
            (BitFlip(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise bit_flip(0.5) q[3]",),
            (BitFlip(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise bit_flip(0.5) \$3",),
            (PhaseFlip(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise phase_flip(0.5) q[3]",),
            (PhaseFlip(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise phase_flip(0.5) \$3",),
            (PauliChannel(0.1, 0.2, 0.3), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise pauli_channel(0.1, 0.2, 0.3) q[3]",),
            (PauliChannel(0.1, 0.2, 0.3), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise pauli_channel(0.1, 0.2, 0.3) \$3",),
            (Depolarizing(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise depolarizing(0.5) q[3]",),
            (Depolarizing(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise depolarizing(0.5) \$3",),
            (TwoQubitDepolarizing(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 5], "#pragma braket noise two_qubit_depolarizing(0.5) q[3], q[5]",),
            (TwoQubitDepolarizing(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 5], "#pragma braket noise two_qubit_depolarizing(0.5) \$3, \$5",),
            (TwoQubitDephasing(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 5], "#pragma braket noise two_qubit_dephasing(0.5) q[3], q[5]",),
            (TwoQubitDephasing(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 5], "#pragma braket noise two_qubit_dephasing(0.5) \$3, \$5",),
            (AmplitudeDamping(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise amplitude_damping(0.5) q[3]",),
            (AmplitudeDamping(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise amplitude_damping(0.5) \$3",),
            (GeneralizedAmplitudeDamping(0.5, 0.1), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise generalized_amplitude_damping(0.5, 0.1) q[3]",),
            (GeneralizedAmplitudeDamping(0.5, 0.1), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise generalized_amplitude_damping(0.5, 0.1) \$3",),
            (PhaseDamping(0.5), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "#pragma braket noise phase_damping(0.5) q[3]",),
            (PhaseDamping(0.5), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "#pragma braket noise phase_damping(0.5) \$3",),
            (Kraus(kraus_1), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 5],
                "#pragma braket noise kraus([" *
                "[0.9486832980505138, 0, 0, 0], " *
                "[0, 0.9486832980505138, 0, 0], " *
                "[0, 0, 0.9486832980505138, 0], " *
                "[0, 0, 0, 0.9486832980505138]], [" *
                "[0, 0.31622776601683794, 0, 0], " *
                "[0.31622776601683794, 0, 0, 0], " *
                "[0, 0, 0, 0.31622776601683794], " *
                "[0, 0, 0.31622776601683794, 0]]) q[3], q[5]",
            ),
            (Kraus(kraus_1), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 5],
                "#pragma braket noise kraus([" *
                "[0.9486832980505138, 0, 0, 0], " *
                "[0, 0.9486832980505138, 0, 0], " *
                "[0, 0, 0.9486832980505138, 0], " *
                "[0, 0, 0, 0.9486832980505138]], [" *
                "[0, 0.31622776601683794, 0, 0], " *
                "[0.31622776601683794, 0, 0, 0], " *
                "[0, 0, 0, 0.31622776601683794], " *
                "[0, 0, 0.31622776601683794, 0]]) \$3, \$5",
            ),
            (Kraus(kraus_2), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3],
                "#pragma braket noise kraus([" *
                "[0.9486833im, 0], [0, 0.9486833im]], [" *
                "[0, 0.31622777], [0.31622777, 0]]) q[3]",
            ),
            (Kraus(kraus_2), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3],
                "#pragma braket noise kraus([" *
                "[0.9486833im, 0], [0, 0.9486833im]], [" *
                "[0, 0.31622777], [0.31622777, 0]]) \$3",
            ),
        ]
            n, sps, targets, expected_ir = ir_bolus
            @test ir(n, targets, Val(:OpenQASM); serialization_properties=sps) == expected_ir
        end
    end
end

using Braket, Braket.Observables, Test, JSON3

using Braket: NoiseModel, add_noise!, insert_noise!, remove_noise!, from_filter, GateCriteria, QubitInitializationCriteria, UnitaryGateCriteria, ObservableCriteria
import Braket: I as I

h_unitary() = (1/√2).*[1.0 1.0; 1.0 -1.0]

function default_noise_model()
    noise_list = []
    criteria_list = []
    noise_model = NoiseModel()
    for i in 0:2
        noise = BitFlip(0.1)
        criteria = GateCriteria(X, 1)
        add_noise!(noise_model, noise, criteria)
        push!(noise_list, noise)
        push!(criteria_list, criteria)
    end
    return noise_model, noise_list, criteria_list
end

@testset "Noise models" begin
    @testset "Simple noise model" begin
        noise_model = NoiseModel()
        @test length(noise_model.instructions) == 0
        n = BitFlip(0.1)
        c = GateCriteria(X, 1)
        add_noise!(noise_model, n, c)
        noise_list = noise_model.instructions
        @test length(noise_list) == 1
        @test n == noise_list[1].noise
        @test c == noise_list[1].criteria
    end
    @testset "criteria equality" begin
        @test GateCriteria(H) != GateCriteria(H, [0, 2])
        @test GateCriteria(H) != UnitaryGateCriteria(Unitary(h_unitary()), nothing)
        @test QubitInitializationCriteria([0,1]) != QubitInitializationCriteria([0])
    end
    @testset "insert noise" begin
        noise_model, noise_list, criteria_list = default_noise_model()
        listed_noise = noise_model.instructions
        @test length(listed_noise) == 3

        n = PhaseFlip(0.1)
        c = GateCriteria(Y, 1)

        insert_noise!(noise_model, 2, n, c)

        listed_noise = noise_model.instructions
        @test length(listed_noise) == 4
        @test listed_noise[1].noise == noise_list[1]
        @test listed_noise[1].criteria == criteria_list[1]
        @test listed_noise[2].noise == n
        @test listed_noise[2].criteria == c
        @test listed_noise[3].noise == noise_list[2]
        @test listed_noise[3].criteria == criteria_list[2]
        @test listed_noise[4].noise == noise_list[3]
        @test listed_noise[4].criteria == criteria_list[3]
    end
    @testset "remove noise" begin
        noise_model, noise_list, _ = default_noise_model()
        listed_noise = noise_model.instructions
        @test length(listed_noise) == 3

        remove_noise!(noise_model, 2)

        listed_noise = noise_model.instructions
        @test length(listed_noise) == 2
        @test listed_noise[1].noise == noise_list[1]
        @test listed_noise[2].noise == noise_list[3]
    end
    @testset "from filter" begin
        noise_model = NoiseModel()
        add_noise!(noise_model, PauliChannel(0.01, 0.02, 0.03), GateCriteria(Braket.I, [0, 1]))
        add_noise!(noise_model, Depolarizing(0.04), GateCriteria(H))
        add_noise!(noise_model, Depolarizing(0.05), GateCriteria(CNot, [0, 1]))
        add_noise!(noise_model, PauliChannel(0.06, 0.07, 0.08), GateCriteria(H, [0, 1]))
        add_noise!(noise_model, Depolarizing(0.09), GateCriteria(nothing, 0))
        add_noise!(noise_model, Depolarizing(0.10), QubitInitializationCriteria([0, 1]))
        @testset for filter ∈ [
            (nothing, nothing, nothing, nothing, 6),
            (nothing, nothing, PauliChannel, nothing, 2),
            (H, nothing, nothing, nothing, 3),
            (CNot, nothing, nothing, nothing, 2),
            (nothing, 0, nothing, nothing, 5),
            # (nothing, (0, 1), nothing, nothing, 1), # TODO: I'm not sure of the best way to fix this.
            (CNot, [0, 1], nothing, nothing, 1),
            (CNot, [1, 0], nothing, nothing, 0),
            (H, 2, nothing, nothing, 1),
            (H, nothing, Depolarizing, nothing, 2),
        ]
            gate, qubit, noise, noise_type, expected_length = filter
            result_model = from_filter(noise_model, qubit=qubit, gate=gate, noise=noise)
            @test length(result_model.instructions) == expected_length
        end
    end
    @testset "serialization" begin
        noise_model = NoiseModel()
        add_noise!(noise_model, PauliChannel(0.01, 0.02, 0.03), GateCriteria(I, [0, 1]))
        add_noise!(noise_model, Depolarizing(0.04), GateCriteria(H))
        add_noise!(noise_model, Depolarizing(0.05), GateCriteria(CNot, [0, 1]))
        add_noise!(noise_model, PauliChannel(0.06, 0.07, 0.08), GateCriteria(H, [0, 1]))
        add_noise!(noise_model, BitFlip(0.01), UnitaryGateCriteria(Unitary(h_unitary()), 0))
        add_noise!(noise_model, PhaseFlip(0.02), ObservableCriteria(Observables.Y, 1))
        serialized_model = Dict(noise_model)

        deserialized_model = NoiseModel(serialized_model)
        @test length(deserialized_model.instructions) == length(noise_model.instructions)
        for (idx, deserialized_item) in enumerate(deserialized_model.instructions)
            @test noise_model.instructions[idx].noise == deserialized_item.noise
            @test noise_model.instructions[idx].criteria == deserialized_item.criteria
        end
        @test !isnothing(deserialized_model)
    end
    @testset "apply" begin
        noise_model = NoiseModel()
        add_noise!(noise_model, PauliChannel(0.01, 0.02, 0.03), GateCriteria(I, [0, 1]))
        add_noise!(noise_model, Depolarizing(0.04), GateCriteria(H))
        add_noise!(noise_model, TwoQubitDepolarizing(0.05), GateCriteria(CNot, [0, 1]))
        add_noise!(noise_model, PauliChannel(0.06, 0.07, 0.08), GateCriteria(H, [0, 1]))
        add_noise!(noise_model, Depolarizing(0.10), UnitaryGateCriteria(Unitary(h_unitary()), 0))
        add_noise!(noise_model, Depolarizing(0.06), ObservableCriteria(Observables.Z, 0))
        add_noise!(noise_model, Depolarizing(0.09), QubitInitializationCriteria(0))
        layer1 = Sample(CNot(H(Circuit(), 0), 0, 1), Observables.Z(), 0)
        layer2 = Unitary(Circuit(), 0, h_unitary())
        circuit = append!(layer1, layer2)
        noisy_circuit_from_circuit = circuit(noise_model)
        expected_circuit = CNot(PauliChannel(Depolarizing(H(Depolarizing(Circuit(), 0, 0.09), 0), 0, 0.04), 0, 0.06, 0.07, 0.08), 0, 1)
        expected_circuit = Depolarizing(Unitary(TwoQubitDepolarizing(expected_circuit, 0, 1, 0.05), 0, h_unitary()), 0, 0.10)
        Braket.apply_readout_noise!(expected_circuit, Depolarizing(0.06), [0])
        expected_circuit = Sample(expected_circuit, Observables.Z(), 0)
        @test noisy_circuit_from_circuit.instructions == expected_circuit.instructions
        @test noisy_circuit_from_circuit.result_types == expected_circuit.result_types
    end
    @testset for problem_set in [
        (
            # model with noise on all gates
            add_noise!(NoiseModel(), Depolarizing(0.01), GateCriteria()),
            # input circuit
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has noise on all gates
            Depolarizing(Depolarizing(CNot(Depolarizing(H(Circuit(), 0), 0, 0.01), 0, 1), 0, 0.01), 1, 0.01)
        ),
        (
            # model with noise on H(0)
            add_noise!(NoiseModel(), Depolarizing(0.01), GateCriteria(H, 0)),
            # input circuit has an H gate on qubit 0
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has noise on qubit 0
            CNot(Depolarizing(H(Circuit(), 0), 0, 0.01), 0, 1)
        ),
        (
            # model with noise on H(0)
            add_noise!(NoiseModel(), Depolarizing(0.01), GateCriteria(H, 0)),
            # input circuit has two H gates on qubit 0
            CNot(H(H(Circuit(), 0), 0), 0, 1),
            # expected circuit has noise on qubit 0
            CNot(Depolarizing(H(Depolarizing(H(Circuit(), 0), 0, 0.01), 0), 0, 0.01), 0, 1)
        ),
        (
            # model with noise on all gates, on qubits 0, 1
            add_noise!(NoiseModel(), Depolarizing(0.01), GateCriteria(nothing, [0, 1])),
            # input circuit
            CNot(H(H(Circuit(), 0), 1), 0, 1),
            # expected circuit has noise on qubit 0
            CNot(Depolarizing(H(Depolarizing(H(Circuit(), 0), 0, 0.01), 1), 1, 0.01), 0, 1)
        ),
        (
            # model with noise on all gates, on qubits [0, 1]
            add_noise!(NoiseModel(), Depolarizing(0.01), GateCriteria(nothing, [[0, 1]])),
            # input circuit
            CNot(H(H(Circuit(), 0), 1), 0, 1),
            # expected circuit has noise on the CNot gate
            Depolarizing(Depolarizing(CNot(H(H(Circuit(), 0), 1), 0, 1), 0, 0.01), 1, 0.01)
        ),
        (
            # model with noise on all gates, on qubits [0, 1]
            add_noise!(NoiseModel(), TwoQubitDepolarizing(0.01), GateCriteria(nothing, [[0, 1]])),
            # input circuit
            CNot(H(H(Circuit(), 0), 1), 0, 1),
            # expected circuit has noise on the CNot gate
            TwoQubitDepolarizing(CNot(H(H(Circuit(), 0), 1), 0, 1), 0, 1, 0.01)
        ),
        (
            # model with noise on a unitary H(0)
            add_noise!(NoiseModel(), Depolarizing(0.01), UnitaryGateCriteria(Unitary(h_unitary()), 0)),
            # input circuit has a unitary H gate on qubit 0
            CNot(Unitary(Circuit(), 0, h_unitary()), 0, 1),
            # expected circuit has noise on qubit 0
            CNot(Depolarizing(Unitary(Circuit(), 0, h_unitary()), 0, 0.01), 0, 1),
        ),
        (
            # model
            add_noise!(NoiseModel(), Depolarizing(0.01), QubitInitializationCriteria(0)),
            # input circuit has no explicit observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no noise applied
            CNot(H(Depolarizing(Circuit(), 0, 0.01), 0), 0, 1),
        ),
        (
            # model
            add_noise!(NoiseModel(), Depolarizing(0.01), QubitInitializationCriteria([0, 1])),
            # input circuit has no explicit observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no noise applied
            CNot(H(Depolarizing(Depolarizing(Circuit(), 0, 0.01), 1, 0.01), 0), 0, 1),
        ),
        (
            # model
            NoiseModel(),
            # input circuit has no explicit observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no noise applied
            CNot(H(Circuit(), 0), 0, 1),
        ),
        (
            # model has observable criteria only on one qubit
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.Z, 0)),
            # input circuit has no explicit observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no noise applied
            CNot(H(Circuit(), 0), 0, 1),
        ),
        (
            # model
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.Z, nothing)),
            # input circuit has explicit explicit observables
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.Z(), 0),
            # expected circuit has noise applied
            Sample(Depolarizing(CNot(H(Circuit(), 0), 0, 1), 0, 0.01), Observables.Z(), 0),
        ),
        (
            # model
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.X, 0)),
            # input circuit doesn't contain observable X
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no change.
            CNot(H(Circuit(), 0), 0, 1),
        ),
        (
            # model
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.X, 0)),
            # input circuit contains observable X
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
            # expected circuit noise applied.
            Sample(Depolarizing(CNot(H(Circuit(), 0), 0, 1), 0, 0.01), Observables.X(), 0),
        ),
        (
            # model only has an observable on Z
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.Z, 0)),
            # input circuit contains observable X
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
            # expected circuit has no change
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
        ),
        (
            # model has observables on both X and Z
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria([Observables.X, Observables.Z], 0)),
            # input circuit contains observable X
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
            # expected circuit has noise applied
            Sample(Depolarizing(CNot(H(Circuit(), 0), 0, 1), 0, 0.01), Observables.X(), 0),
        ),
        (
            # model uses qubit criteria
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(nothing, nothing)),
            # input circuit doesn't contain observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no noise applied
            CNot(H(Circuit(), 0), 0, 1),
        ),
        (
            # model uses qubit criteria on non-related qubits
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(nothing, [2, 3])),
            # input circuit doesn't contain observables
            CNot(H(Circuit(), 0), 0, 1),
            # expected circuit has no change
            CNot(H(Circuit(), 0), 0, 1),
        ),
        (
            # model uses qubit criteria
            add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(nothing, [0, 1])),
            # input circuit contains observable X
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
            # expected circuit noise applied.
            Sample(Depolarizing(CNot(H(Circuit(), 0), 0, 1), 0, 0.01), Observables.X(), 0),
        ),
        (
            # model uses observable and qubit criteria
            add_noise!(add_noise!(NoiseModel(), Depolarizing(0.01), ObservableCriteria(Observables.X, 0)), Depolarizing(0.02), ObservableCriteria(nothing, [0, 1])),
            # input circuit contains observable X
            Sample(CNot(H(Circuit(), 0), 0, 1), Observables.X(), 0),
            # expected circuit noise applied.
            Sample(Depolarizing(Depolarizing(CNot(H(Circuit(), 0), 0, 1), 0, 0.01), 0, 0.02), Observables.X(), 0),
        ),
        (
            # model uses observable criteria with any observable/qubit.
            add_noise!(NoiseModel(), BitFlip(0.01), ObservableCriteria(nothing, nothing)),
            # input circuit contains many different types of result types for qubit 0
            Variance(Sample(Expectation(Probability(Probability(CNot(H(Circuit(), 0), 0, 1), [0, 1]), [0]), Observables.Z(), 0), Observables.X(), 0), Observables.Z(), 0),
            # expected circuit only applies BitFlip once to qubit 0
            Braket.apply_readout_noise!(Variance(Sample(Expectation(Probability(Probability(CNot(H(Circuit(), 0), 0, 1), [0, 1]), [0]), Observables.Z(), 0), Observables.X(), 0), Observables.Z(), 0), BitFlip(0.01), [0])
        ),
        (
            # model uses observable criteria with any observable/qubit.
            add_noise!(NoiseModel(), BitFlip(0.01), ObservableCriteria(nothing, nothing)),
            # input circuit only has a probability result type
            Probability(Probability(CNot(H(Circuit(), 0), 0, 1), [0, 1]), [0]),
            # expected circuit has no noise applied
            Probability(Probability(CNot(H(Circuit(), 0), 0, 1), [0, 1]), [0])
        ),

    ]
        noise_model, input_circuit, expected_circuit = problem_set
        result_circuit = Braket.apply(noise_model, input_circuit)
        @test result_circuit.instructions == expected_circuit.instructions
        @test result_circuit == expected_circuit
    end
end

using Braket, Braket.IR, Test, JSON3, UUIDs, Mocking
using Braket: ResultTypeValue

Mocking.activate()

zero_shots_result(task_mtd, add_mtd) = Braket.GateModelTaskResult(
    Braket.header_dict[Braket.GateModelTaskResult],
    nothing,
    nothing,
    [
        ResultTypeValue(IR.Probability([0], "probability"), [0.5, 0.5]),
        ResultTypeValue(IR.Expectation(["y"], [0], "expectation"), 0.0),
        ResultTypeValue(IR.Variance(["y"], [0], "variance"), 0.1),
    ],
    [0,1],
    task_mtd,
    add_mtd,
)
@testset "Tasks" begin
    @testset "Task basics" begin
        t1 = AwsQuantumTask("arn:fake1")
        t2 = AwsQuantumTask("arn:fake2")
        @test id(t1) == "arn:fake1"
        @test t1 != t2
        @test t1 == t1
        t1._metadata = Dict("status"=>"fake_state")
        @test metadata(t1, Val(true)) == Dict("status"=>"fake_state")
        @test state(t1, Val(true)) == "fake_state"
        t1._metadata["status"] == "COMPLETED"
        withenv("AMZN_BRAKET_TASK_RESULTS_S3_URI"=>"s3://fake/bucket") do
            @test Braket.default_task_bucket() == ("fake", "bucket")
        end
        @test sprint(show, t1) == """AwsQuantumTask("id/taskArn":"arn:fake1")\n"""
        
        # test creation from NamedTuple and from Circuit
        resp_dict = Dict("quantumTaskArn"=>"arn/fake")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            args = (action="", client_token="", device_arn="", outputS3Bucket="", outputS3KeyPrefix="", shots=0, extra_opts=Dict{String, Any}(), config=Braket.AWS.global_aws_config())
            @test AwsQuantumTask(args) == AwsQuantumTask("arn/fake", client_token="", config=Braket.AWS.global_aws_config())
            c = CNot(Circuit(), 0, 1)
            @test AwsQuantumTask("arn/fake_dev", c, s3_destination_folder=("", "")) == AwsQuantumTask("arn/fake")
        end

        # test count_tasks_with_status
        resp_dict = Dict("quantumTasks"=>["a", "b", "c"], "nextToken"=>"0000")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            @test Braket.count_tasks_with_status("fake_arn", "RUNNING") == length(resp_dict["quantumTasks"])
        end

        # test non-cached metadata
        resp_dict = Dict("status"=>"FAILED", "failureReason"=>"badness")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            t = AwsQuantumTask("fake_arn")
            @test metadata(t, Val(false)) == resp_dict
            if VERSION >= v"1.7"
                @test_warn "Task is in terminal state FAILED and no result is available." state(t, Val(false))
                @test_warn "Task failure reason is: badness." state(t, Val(false))
            end
            @test state(t) == "FAILED"
        end

        c = CNot(Circuit(), 0, 1)
        action = Braket.Program(c)
        task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 0, "arn1", nothing, nothing, nothing, nothing, nothing)
        additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
        s3_req_str = JSON3.write(zero_shots_result(task_metadata, additional_metadata))
        req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(s3_req_str))
        apply(req_patch) do
            t = AwsQuantumTask("fake_arn")
            t._metadata = Dict("status"=>"COMPLETED", "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_prefix")
            res1 = result(t)
            @test res1 isa Braket.GateModelQuantumTaskResult
            # test getting cached result
            res2 = result(t)
            @test res2.values == res1.values
        end
        # test result timeout
        resp_dict = Dict("status"=>"RUNNING")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            timeout_secs = 5
            t = AwsQuantumTask("fake_arn", poll_timeout_seconds=timeout_secs)
            start = time()
            r = result(t)
            stop = time()
            @test isnothing(r)
            @test stop-start > timeout_secs
        end
        # test cancel
        resp_dict = Dict("cancellationStatus"=>"CANCELLED", "quantumTaskArn"=>"arn:fake")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            t = AwsQuantumTask("arn:fake", client_token="", config=Braket.AWS.global_aws_config())
            @test isnothing(Braket.cancel(t))
        end
    end

    problem() = Braket.Problem(Braket.header_dict[Braket.Problem], Braket.ising, Dict(1=>3.14), Dict("(1, 2)"=>10.08))
    bell_qasm = """
    OPENQASM 3;

    qubit[2] q;
    bit[2] c;

    h q[0];
    cnot q[0], q[1];

    c = measure q;
    """
    oq3_program() = Braket.OpenQasmProgram(Braket.header_dict[Braket.OpenQasmProgram], bell_qasm, nothing)
    bell_circ()   = (c = Circuit(); c=H(c, 0); c=CNot(c, 0, 1); return c)
    bell_prog()   = Braket.Program(bell_circ())
    RIGETTI_ARN = "arn:aws:braket:::device/qpu/rigetti/Aspen-M-3"
    IONQ_ARN = "arn:aws:braket:::device/qpu/ionq/ionQdevice"
    SV1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
    IQM_ARN = "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet"
    @testset for program in (bell_circ, bell_prog), arn in (SV1_ARN, IQM_ARN, RIGETTI_ARN, IONQ_ARN)
        shots = 100
        device_params = Dict("fake_param_1"=>2, "fake_param_2"=>"hello")
        s3_folder = ("fake_bucket", "fake_folder")
        task_args = Braket.prepare_task_input(program(), arn, s3_folder, shots, device_params)
        @test task_args[:action] == JSON3.write(ir(program()))
        @test task_args[:device_arn] == arn
        @test UUID(task_args[:client_token]) isa UUID
        @test task_args[:shots] == shots
        @test task_args[:outputS3Bucket] == s3_folder[1]
        @test task_args[:outputS3KeyPrefix] == s3_folder[2]
    end

    @testset "Error Mitigation" for em in (Braket.DeBias(), ir(Braket.DeBias())) 
        shots = 21
        s3_folder = ("fake_bucket", "fake_folder")
        device_params = Braket.IonqDeviceParameters(Braket.header_dict[Braket.IonqDeviceParameters], Braket.GateModelParameters(Braket.header_dict[Braket.GateModelParameters], 0, false), [Braket.Debias(StructTypes.defaults(Braket.Debias)[:type])])
        task_args = Braket.prepare_task_input(oq3_program(), IONQ_ARN, s3_folder, shots, Dict("errorMitigation"=>em))
        @test task_args[:action] == JSON3.write(ir(oq3_program()))
        @test task_args[:device_arn] == IONQ_ARN
        @test UUID(task_args[:client_token]) isa UUID
        @test task_args[:shots] == shots
        @test task_args[:outputS3Bucket] == s3_folder[1]
        @test task_args[:outputS3KeyPrefix] == s3_folder[2]
        @test task_args[:extra_opts]["deviceParameters"] == JSON3.write(device_params)
    end

    @testset for program in (oq3_program,), arn in (SV1_ARN,)
        shots = 100
        device_params = Dict("fake_param_1"=>2, "fake_param_2"=>"hello")
        s3_folder = ("fake_bucket", "fake_folder")
        task_args = Braket.prepare_task_input(program(), arn, s3_folder, shots, device_params)
        @test task_args[:action] == JSON3.write(ir(program()))
        @test task_args[:device_arn] == arn
        @test UUID(task_args[:client_token]) isa UUID
        @test task_args[:shots] == shots
        @test task_args[:outputS3Bucket] == s3_folder[1]
        @test task_args[:outputS3KeyPrefix] == s3_folder[2]
        # TODO test device parameters
        @test task_args[:extra_opts]["tags"] == Dict{String, String}()
        tags = Dict("fake_tag"=>"fake_val")
        task_args = Braket.prepare_task_input(program(), arn, s3_folder, shots, device_params, tags=tags)
        @test task_args[:extra_opts]["tags"] == tags
    end

    ADVANTAGE_4_ARN = "arn:aws:braket:::device/qpu/d-wave/Advantage_system4"
    ADVANTAGE_6_ARN = "arn:aws:braket:us-west-2::device/qpu/d-wave/Advantage_system6"
    DWAVE_2000Q_ARN = "arn:aws:braket:::device/qpu/d-wave/DW_2000Q_6"
    @testset for (prob, arn) in zip((problem, problem, problem), (ADVANTAGE_4_ARN, ADVANTAGE_6_ARN, DWAVE_2000Q_ARN))
        shots = 100
        device_params = Dict("fake_param_1"=>2, "fake_param_2"=>"hello")
        s3_folder = ("fake_bucket", "fake_folder")
        task_args = Braket.prepare_task_input(prob(), arn, s3_folder, shots, device_params)
        @test task_args[:action] == JSON3.write(prob())
        @test task_args[:device_arn] == arn
        @test UUID(task_args[:client_token]) isa UUID
        @test task_args[:shots] == shots
        @test task_args[:outputS3Bucket] == s3_folder[1]
        @test task_args[:outputS3KeyPrefix] == s3_folder[2]
        # device params handled below
        @test task_args[:extra_opts]["tags"] == Dict{String, String}()
        tags = Dict("fake_tag"=>"fake_val")
        task_args = Braket.prepare_task_input(prob(), arn, s3_folder, shots, device_params, tags=tags)
        @test task_args[:extra_opts]["tags"] == tags 
    end

    @testset "_create_annealing_parameters" begin
        adv_1 = ("""{
                    "providerLevelParameters": {
                        "postprocessingType": "optimization",
                        "annealingOffsets": [3.67, 6.123],
                        "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
                        "annealingDuration": 1,
                        "autoScale": false,
                        "beta": 0.2,
                        "chains": [[0, 1, 5], [6]],
                        "compensateFluxDrift": false,
                        "fluxBiases": [1.1, 2.2, 3.3, 4.4],
                        "initialState": [1, 3, 0, 1],
                        "maxResults": 1,
                        "programmingThermalizationDuration": 625,
                        "readoutThermalizationDuration": 256,
                        "reduceIntersampleCorrelation": false,
                        "reinitializeState": true,
                        "resultFormat": "raw",
                        "spinReversalTransformCount": 100}
                    }""", "arn:aws:braket:::device/qpu/d-wave/Advantage_system1")
        q2k = ("""{
                    "deviceLevelParameters": {
                        "postprocessingType": "optimization",
                        "beta": 0.2,
                        "annealingOffsets": [3.67, 6.123],
                        "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
                        "annealingDuration": 1,
                        "autoScale": false,
                        "chains": [[0, 1, 5], [6]],
                        "compensateFluxDrift": false,
                        "fluxBiases": [1.1, 2.2, 3.3, 4.4],
                        "initialState": [1, 3, 0, 1],
                        "maxResults": 1,
                        "programmingThermalizationDuration": 625,
                        "readoutThermalizationDuration": 256,
                        "reduceIntersampleCorrelation": false,
                        "reinitializeState": true,
                        "resultFormat": "raw",
                        "spinReversalTransformCount": 100}
                    }""", "arn:aws:braket:::device/qpu/d-wave/DW_2000Q_6")
        adv_2 = ("""{
                    "deviceLevelParameters": {
                        "postprocessingType": "optimization",
                        "beta": 0.2,
                        "annealingOffsets": [3.67, 6.123],
                        "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
                        "annealingDuration": 1,
                        "autoScale": false,
                        "chains": [[0, 1, 5], [6]],
                        "compensateFluxDrift": false,
                        "fluxBiases": [1.1, 2.2, 3.3, 4.4],
                        "initialState": [1, 3, 0, 1],
                        "maxResults": 1,
                        "programmingThermalizationDuration": 625,
                        "readoutThermalizationDuration": 256,
                        "reduceIntersampleCorrelation": false,
                        "reinitializeState": true,
                        "resultFormat": "raw",
                        "spinReversalTransformCount": 100}
                    }""", "arn:aws:braket:::device/qpu/d-wave/Advantage_system1")
        @testset for pair in (adv_1, q2k, adv_2)
            dev_params = convert(Dict{Symbol, Any}, JSON3.read(pair[1]))
            annealing_params = Braket._create_annealing_device_params(dev_params, pair[2])
            @test Braket.parse_raw_schema(JSON3.write(annealing_params)) == annealing_params
        end
        @test_throws ArgumentError Braket._create_annealing_device_params(Dict{String, Any}(), "arn:fake")
    end

    @testset "default_task_bucket" begin
        withenv("AWS_DEFAULT_REGION"=>"fake_region") do 
            resp_dict = Dict("GetCallerIdentityResult"=>Dict("Arn"=>"fake_arn", "Account"=>"000000"))
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    xml_str = """
                    <ListAllMyBucketsResult>
                        <Buckets>
                            <Bucket>
                                <CreationDate>2000:01:01T00:00:00</CreationDate>
                                <Name>"amazon-braket-fake_region-000000"</Name>
                            </Bucket>
                        </Buckets>
                        <Owner>
                            <DisplayName>"fake_name"</DisplayName>
                            <ID>000000</ID>
                        </Owner>
                    </ListAllMyBucketsResult>
                    """
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/xml"]), IOBuffer(xml_str))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                db = Braket.default_task_bucket()
                @test db == ("amazon-braket-fake_region-000000", "tasks")
            end
        end
    end
    @testset "inputs" begin
        dev = SV1_ARN
        α = FreeParameter(:α)
        c_params = Circuit([(H, [0, 1]), (CNot, 0, 1), (Rx, 0, α)])
        @testset for prog in (c_params, ir(c_params, Val(:OpenQASM)))
            resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
            req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            apply(req_patch) do
                t = Braket.AwsQuantumTask(dev, prog, s3_destination_folder=("fake_bucket", "fake_prefix"), inputs=Dict("α"=>0.2))
                @test arn(t) == "arn/fake"
            end
        end
    end
end

using Braket, Test

@testset "Xanadu device" begin
    @testset "Device capabilities" begin
        ir_gen() = """{
        "braketSchemaHeader": {
            "name": "braket.device_schema.xanadu.xanadu_device_capabilities",
            "version": "1"
        },
        "service": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.device_service_properties",
                "version": "1"
            },
            "executionWindows": [
                {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
            ],
            "shotsRange": [1, 10],
            "deviceCost": {"price": 0.25, "unit": "minute"},
            "deviceDocumentation": {
                "imageUrl": "image_url",
                "summary": "Summary on the device",
                "externalDocumentationUrl": "exter doc link"
            },
            "deviceLocation": "us-east-1",
            "updatedAt": "2020-06-16T19:28:02.869136"
        },
        "action": {
            "braket.ir.blackbird.program": {
                "actionType": "braket.ir.blackbird.program",
                "version": ["1"],
                "supportedOperations": ["x", "y"],
                "supportedResultTypes": []
            }
        },
        "paradigm": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.continuous_variable_qpu_paradigm_properties",
                "version": "1"
            },
            "modes": {"spatial": 1, "concurrent": 44, "temporal_max": 331},
            "layout": "Some layout",
            "compiler": ["borealis"],
            "supportedLanguages": ["blackbird:1.0"],
            "compilerDefault": "borealis",
            "nativeGateSet": ["XGate"],
            "gateParameters": {
                "s": [[0.0, 2.0]],
                "r0": [[-1.5707963267948966, 1.5707963267948966]]
            },
            "target": "borealis"
        },
        "deviceParameters": {}
    }
    """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.XanaduDeviceCapabilities
    end
    @testset "Device parameters" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.xanadu.xanadu_device_parameters",
                "version": "1"
            },
            "paradigmParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.photonic_model_parameters",
                    "version": "1"
                }
            }
        }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.XanaduDeviceParameters
    end
    @testset "Provider properties" begin
        ir_gen() = """{
        "braketSchemaHeader": {
            "name": "braket.device_schema.xanadu.xanadu_provider_properties",
            "version": "1"
        },
        "loopPhases": [0.06293596790273215, 0.15291642690139806, -1.5957742826142312],
        "schmidtNumber": 1.1240597475954237,
        "commonEfficiency": 0.42871142768980564,
        "loopEfficiencies": [0.9106461685832691, 0.8904556756334581, 0.8518902619448591],
        "squeezingParametersMean": {
            "low": 0.6130577606615072,
            "high": 1.0635796125448667,
            "medium": 0.893051739389763
        },
        "relativeChannelEfficiencies": [
            0.9305010775397536,
            0.9648681625753431,
            0.9518909571324008,
            0.9486638084844965,
            0.8987246282353925,
            0.9726334999710303,
            0.9489037154275138,
            0.9727238556532112,
            1.0,
            0.973400900408643,
            0.8771940466934924,
            0.9271209514090495,
            0.9595068270114586,
            0.9002874120338067,
            0.911213274548878,
            0.9752842185805198
        ]
    }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.XanaduProviderProperties
    end
end

using Braket, Braket.Observables, Test, JSON3, StructTypes, LinearAlgebra
using Braket: VIRTUAL, PHYSICAL, OpenQASMSerializationProperties, PauliEigenvalues, IRObservable
using LinearAlgebra: eigvals

@testset "Observables" begin
    Braket.IRType[] = :JAQCD
    @testset "pauli eigenvalues" begin
        z = [1.0 0.0; 0.0 -1.0]
        for n in 2:6
            pe  = PauliEigenvalues(Val(n))
            mat = kron(ntuple(i->diag(z), n)...)
            for ix in 1:2^n
                @test pe[ix] == mat[ix]
            end
        end
    end
    @testset "Hermitian" begin
        m = [1. -im; im -1.]
        o = Observables.HermitianObservable(m)
        @test qubit_count(o) == 1
        rt = Expectation(o, [0])
        read_rt = JSON3.read(JSON3.write(rt), Braket.Result)
        @test read_rt == rt
        @test ir(o) isa IRObservable
        mult_h = 2.0 * o
        @test mult_h.matrix == 2.0 * m
    end
    @testset "TensorProduct" begin
        tp = Observables.TensorProduct(["x", "y", "z"])
        @test ir(tp) == ["x", "y", "z"]
        @test JSON3.write(tp) == JSON3.write(ir(tp))
        @test qubit_count(tp) == 3
        rt = Expectation(tp, [0, 1, 2])
        @test JSON3.read(JSON3.write(rt), Braket.Result) == rt
        str = """{"observable": ["x", 1, "z"], "targets": [0, 1, 2], "type": "variance"}"""
        @test_throws ArgumentError JSON3.read(str, Braket.Result)
        tp2 = 2.0 * tp
        @test Braket.Observables.unscaled(tp) == tp
    end
    @testset "TensorProduct of Hermitians" begin
        m = [1. -im; im -1.]
        o = Observables.HermitianObservable(m)
        tp = Observables.TensorProduct([o, o])
        @test qubit_count(tp) == 2
        rt = Expectation(tp, [0, 2])
        @test JSON3.read(JSON3.write(rt), Braket.Result) == rt
        @test ir(tp) isa IRObservable
    end
    @testset "TensorProduct mixed types" begin
        m = [1. -im; im -1.]
        o = Observables.HermitianObservable(m)
        tp = Observables.TensorProduct([Observables.X(), o, Observables.Z()])
        @test qubit_count(tp) == 3
        rt = Expectation(tp, [0, 1, 2])
        @test ir(tp) isa IRObservable
        @test JSON3.read(JSON3.write(rt), Braket.Result) == rt
    end
    @testset "TensorProduct doesn't accept Sum" begin
        s = 2.0 * Observables.X() * Observables.X() + 3.0 * Observables.Z() * Observables.Z()
        @test_throws ArgumentError Observables.TensorProduct([Observables.X(), s])
    end
    @testset "Sum" begin
        s = 2.0 * Observables.X() * Observables.X() + 3.0 * Observables.Z() * Observables.Z()
        @test length(s) == 2
        @test s.summands[1].coefficient == 2.0
        @test s.summands[2].coefficient == 3.0
        @test_throws ErrorException ir(s, [1, 2], Val(:JAQCD))
        @test_throws ErrorException ir(s, [QubitSet(1, 2)], Val(:JAQCD))
        @test Braket.chars(s) == ("Sum",)
        s2 = -1.0 * s
        @test length(s2) == 2
        @test s2.summands[1].coefficient == -2.0
        @test s2.summands[2].coefficient == -3.0
        s3 = Observables.Y() * Observables.Y() + s
        @test length(s3) == 3
        s4 = Observables.Y() * Observables.Y() + 2.0 * Observables.X() * Observables.X() + 3.0 * Observables.Z() * Observables.Z()
        @test s3 == s4
        s5 = Observables.Sum([Observables.X()])
        @test s5 == Observables.X()
        @test Observables.X() == s5
    end
    @test_throws ErrorException StructTypes.constructfrom(Observables.Observable, ["x", 1, "z"])
    m = [1 -im; im -1]
    HO = Observables.HermitianObservable(m)
    @test Braket.chars(HO) == ("Hermitian",)
    HO_ir = ir(HO)
    @test JSON3.write(HO) == JSON3.write(ir(HO)) 
    @test StructTypes.constructfrom(Observables.Observable, convert(IRObservable, HO_ir)) == HO
    @test copy(HO) == HO
    for (typ, char) in zip((Observables.H, Observables.I, Observables.Z, Observables.X, Observables.Y), ("H", "I", "Z", "X", "Y"))
        @test copy(typ()) == typ()
        @test JSON3.write(typ()) == JSON3.write(ir(typ()))
        @test ishermitian(typ())
        @test Braket.chars(typ()) == (char,)
    end
    Braket.IRType[] = :OpenQASM
    @testset "eigenvalues" begin
        mat = [1.0 1.0 - im; 1.0 + 1im -1.0]
        h = Observables.HermitianObservable(mat)
        @test eigvals(h) ≈ [-√3, √3]
        ho = Observables.HermitianObservable(convert(Matrix{Float64}, [-1 0 0 0; 0 -1 0 0; 0 0 1 0; 0 0 0 1]))
        @testset for (tp, evs) in (
            (Observables.TensorProduct(["x", "y"]), [1, -1, -1, 1]),
            (Observables.TensorProduct(["x", "y", "z"]),[1, -1, -1, 1, -1, 1, 1, -1]),
            (Observables.TensorProduct(["x", "y", "i"]),[1, 1, -1, -1, -1, -1, 1, 1]),
            (Observables.TensorProduct([Observables.X(), ho, Observables.Y()]),[-1, 1, -1, 1, 1, -1, 1, -1, 1, -1, 1, -1, -1, 1, -1, 1])
        )
            for ix in 1:length(evs)
                @test eigvals(tp)[ix] == convert(Float64, evs[ix])
            end
        end
        @testset for typ in (Observables.H(), Observables.X(), Observables.Y(), Observables.Z())
            @test eigvals(typ)[[1, 2]] == [1.0, -1.0]
        end
        @testset for (mat, evs) in [([1.0 0.0; 0.0 1.0], [1, 1]), ([0 -im; im 0], [-1.0, 1.0]), ([1 1-im; 1+im -1], [-sqrt(3), sqrt(3)])]
            @test eigvals(Observables.HermitianObservable(mat)) ≈ evs
        end
    end
    @testset "OpenQASM" begin
        @testset for ir_bolus in [
            ( Observables.I(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "i(q[3])"),
            ( Observables.I(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "i(\$3)"),
            ( Observables.I(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "i all"),
            ( Observables.X(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "x(q[3])"),
            ( Observables.X(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "x(\$3)"),
            ( Observables.X(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "x all"),
            ( Observables.Y(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "y(q[3])"),
            ( Observables.Y(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "y(\$3)"),
            ( Observables.Y(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "y all"),
            ( Observables.Z(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "z(q[3])"),
            ( Observables.Z(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "z(\$3)"),
            ( Observables.Z(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "z all"),
            ( Observables.H(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3], "h(q[3])"),
            ( Observables.H(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3], "h(\$3)"),
            ( Observables.H(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "h all"),
            ( 2.0 * Observables.H() - 5.0 * Observables.Z() * Observables.X(), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [[2], [3, 4]], "2.0 * h(\$2) - 5.0 * z(\$3) @ x(\$4)"),
            ( 2.0 * Observables.H() - 5.0 * Observables.Z() * Observables.X(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [[2], [3, 4]], "2.0 * h(q[2]) - 5.0 * z(q[3]) @ x(q[4])"),
            ( Observables.HermitianObservable(diagm(ones(Int64, 4))), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [1, 2], "hermitian([[1+0im, 0im, 0im, 0im], [0im, 1+0im, 0im, 0im], [0im, 0im, 1+0im, 0im], [0im, 0im, 0im, 1+0im]]) q[1], q[2]"),
            ( Observables.HermitianObservable(diagm(ones(Int64, 4))), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [1, 2], "hermitian([[1+0im, 0im, 0im, 0im], [0im, 1+0im, 0im, 0im], [0im, 0im, 1+0im, 0im], [0im, 0im, 0im, 1+0im]]) \$1, \$2"),
            ( Observables.HermitianObservable(diagm(ones(Int64, 2))), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "hermitian([[1+0im, 0im], [0im, 1+0im]]) all"),
            ( Observables.HermitianObservable([1 1-im; 1+im 1]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), nothing, "hermitian([[1+0im, 1-1im], [1+1im, 1+0im]]) all"),
            ( Observables.TensorProduct([Observables.H(), Observables.Z()]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 0], "h(q[3]) @ z(q[0])"),
            ( Observables.TensorProduct([Observables.H(), Observables.Z()]), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 0], "h(\$3) @ z(\$0)"),
            ( Observables.TensorProduct([Observables.H(), Observables.Z(), Observables.I()]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 0, 1], "h(q[3]) @ z(q[0]) @ i(q[1])"),
            ( Observables.TensorProduct([Observables.H(), Observables.Z(), Observables.I()]), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 0, 1], "h(\$3) @ z(\$0) @ i(\$1)"),
            ( Observables.TensorProduct([Observables.HermitianObservable(diagm(ones(Int64, 4))), Observables.I()]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), [3, 0, 1], "hermitian([[1+0im, 0im, 0im, 0im], [0im, 1+0im, 0im, 0im], [0im, 0im, 1+0im, 0im], [0im, 0im, 0im, 1+0im]]) q[3], q[0] @ i(q[1])"),
            ( Observables.TensorProduct([Observables.I(), Observables.HermitianObservable(diagm(ones(Int64, 4)))]), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), [3, 0, 1], "i(\$3) @ hermitian([[1+0im, 0im, 0im, 0im], [0im, 1+0im, 0im, 0im], [0im, 0im, 1+0im, 0im], [0im, 0im, 0im, 1+0im]]) \$0, \$1"),
        ]
            obs, sps, target, expected_ir = ir_bolus
            @test ir(obs, target, Val(:OpenQASM); serialization_properties=sps) == expected_ir
        end
    end
end

using Dates, NamedTupleTools, AxisArrays, DataStructures
import StructTypes

abstract type AbstractQuantumTaskResult <: BraketSchemaBase end

@enum AnalogHamiltonianSimulationShotStatus success partial_success failure
AnalogHamiltonianSimulationShotStatusDict = Dict(string(inst)=>inst for inst in instances(AnalogHamiltonianSimulationShotStatus))
Base.:(==)(x::AnalogHamiltonianSimulationShotStatus, y::String) = string(x) == y
Base.:(==)(x::String, y::AnalogHamiltonianSimulationShotStatus) = string(y) == x
struct ShotResult <: BraketSchemaBase
    status::AnalogHamiltonianSimulationShotStatus
    pre_sequence::Union{Nothing, Array}
    post_sequence::Union{Nothing, Array}
end
StructTypes.StructType(::Type{ShotResult}) = StructTypes.UnorderedStruct()

StructTypes.defaults(::Type{ShotResult}) = Dict{Symbol, Any}(:pre_sequence => nothing, :post_sequence => nothing)
Base.:(==)(r1::ShotResult, r2::ShotResult) = all(getproperty(r1, fn) == getproperty(r2, fn) for fn in fieldnames(ShotResult))
struct AnalogHamiltonianSimulationQuantumTaskResult <: AbstractQuantumTaskResult
    task_metadata::TaskMetadata
    measurements::Union{Nothing, Vector{ShotResult}}
end
StructTypes.StructType(::Type{AnalogHamiltonianSimulationQuantumTaskResult}) = StructTypes.UnorderedStruct()

StructTypes.defaults(::Type{AnalogHamiltonianSimulationQuantumTaskResult}) = Dict{Symbol, Any}(:measurements => nothing)
Base.:(==)(r1::AnalogHamiltonianSimulationQuantumTaskResult, r2::AnalogHamiltonianSimulationQuantumTaskResult) = all(getproperty(r1, fn) == getproperty(r2, fn) for fn in fieldnames(AnalogHamiltonianSimulationQuantumTaskResult))
struct AnnealingQuantumTaskResult <: AbstractQuantumTaskResult
    record_array::AxisArray
    variable_count::Int
    problem_type::ProblemType
    task_metadata::TaskMetadata
    additional_metadata::AdditionalMetadata
end
StructTypes.StructType(::Type{AnnealingQuantumTaskResult}) = StructTypes.UnorderedStruct()

Base.:(==)(r1::AnnealingQuantumTaskResult, r2::AnnealingQuantumTaskResult) = all(getproperty(r1, fn) == getproperty(r2, fn) for fn in fieldnames(AnnealingQuantumTaskResult))
struct GateModelQuantumTaskResult <: AbstractQuantumTaskResult
    task_metadata::TaskMetadata
    additional_metadata::AdditionalMetadata
    result_types::Union{Nothing, Vector{ResultTypeValue}}
    values::Union{Nothing, Vector{Any}}
    measurements::Union{Nothing, Matrix{Int}, Vector{Vector{Int}}}
    measured_qubits::Union{Nothing, Vector{Int}}
    measurement_counts::Union{Nothing, Accumulator}
    measurement_probabilities::Union{Nothing, Dict{String, Float64}}
    measurements_copied_from_device::Union{Nothing, Bool}
    measurement_counts_copied_from_device::Union{Nothing, Bool}
    measurement_probabilities_copied_from_device::Union{Nothing, Bool}
    _result_types_indices::Union{Nothing, Dict{String, Int}}
end
StructTypes.StructType(::Type{GateModelQuantumTaskResult}) = StructTypes.UnorderedStruct()

StructTypes.defaults(::Type{GateModelQuantumTaskResult}) = Dict{Symbol, Any}(:values => nothing, :measurements => nothing, :measurement_counts => nothing, :measured_qubits => nothing, :measurement_probabilities => nothing, :measurement_counts_copied_from_device => nothing, :measurement_probabilities_copied_from_device => nothing, :measurements_copied_from_device => nothing, :result_types => nothing, :_result_types_indices => nothing)
Base.:(==)(r1::GateModelQuantumTaskResult, r2::GateModelQuantumTaskResult) = all(getproperty(r1, fn) == getproperty(r2, fn) for fn in fieldnames(GateModelQuantumTaskResult))
struct PhotonicModelQuantumTaskResult <: AbstractQuantumTaskResult
    task_metadata::TaskMetadata
    additional_metadata::AdditionalMetadata
    measurements::Union{Nothing, Array}
end
StructTypes.StructType(::Type{PhotonicModelQuantumTaskResult}) = StructTypes.UnorderedStruct()

StructTypes.defaults(::Type{PhotonicModelQuantumTaskResult}) = Dict{Symbol, Any}(:measurements => nothing)
Base.:(==)(r1::PhotonicModelQuantumTaskResult, r2::PhotonicModelQuantumTaskResult) = all(getproperty(r1, fn) == getproperty(r2, fn) for fn in fieldnames(PhotonicModelQuantumTaskResult))
type_dict["braket.task_result.gate_model_quantum_task_result_v1"] = GateModelQuantumTaskResult
type_dict["braket.task_result.annealing_quantum_task_result_v1"] = AnnealingQuantumTaskResult
type_dict["braket.task_result.photonic_model_quantum_task_result_v1"] = PhotonicModelQuantumTaskResult
header_dict[GateModelQuantumTaskResult] = braketSchemaHeader("braket.task_result.gate_model_quantum_task_result", "1")
header_dict[AnnealingQuantumTaskResult] = braketSchemaHeader("braket.task_result.annealing_quantum_task_result", "1")
header_dict[PhotonicModelQuantumTaskResult] = braketSchemaHeader("braket.task_result.photonic_model_quantum_task_result", "1")

abstract type CriteriaKey end
struct GateCriteriaKey <: CriteriaKey end
struct QubitCriteriaKey <: CriteriaKey end
struct UnitaryGateCriteriaKey <: CriteriaKey end
struct ObservableCriteriaKey <: CriteriaKey end

abstract type CriteriaKeyResult end
struct KeyResultAll <: CriteriaKeyResult end

abstract type Criteria end
abstract type InitializationCriteria <: Criteria end
abstract type ResultTypeCriteria <: Criteria end
abstract type CircuitInstructionCriteria <: Criteria end
StructTypes.subtypes(::Type{Criteria}) = (GateCriteria=GateCriteria, UnitaryGateCriteria=UnitaryGateCriteria, ObservableCriteria=ObservableCriteria, QubitInitializationCriteria=QubitInitializationCriteria)
Base.keys(c::Criteria, ::Type{<:CriteriaKey}) = Set()
function Base.:(==)(c1::C, c2::C) where {C<:Criteria}
    applicable_key_types(c1) != applicable_key_types(c2) && return false
    !all(keys(c1, kt) == keys(c2, kt) for kt in applicable_key_types(c1)) && return false
    return true
end

function Criteria(d::Dict{String})
    crit_t = StructTypes.subtypes(Criteria)[Symbol(d["type"])]
    return crit_t([d[string(fn)] for fn in fieldnames(crit_t)]...)
end

function _check_target_in_qubits(qubits, target)
    (isnothing(qubits) || isempty(qubits)) && return true
    target_ = Int.(target)
    length(target_) == 1 && return first(target_) ∈ qubits
    return target_ ∈ qubits
end

function _parse_operator_input(ops::Vector)
    isempty(ops) && return []
    qcs = unique(map(qubit_count, ops))
    length(qcs) != 1 && throw(ErrorException("all operators in a criteria must operate on the same number of qubits."))
    return collect(unique(ops))
end
_parse_operator_input(G::Type{<:Operator}) = [G]
_parse_operator_input(::Nothing) = []

function _parse_qubit_input(qubits, expected_qubit_count::Int=0)
    isempty(qubits) && return Int[]
    qubit_count = expected_qubit_count > 0 ? expected_qubit_count : 1
    if (first(qubits) isa Vector || first(qubits) isa QubitSet)
        qubit_count = expected_qubit_count > 0 ? expected_qubit_count : length(first(qubits))
        target_set_all_same = all(length(item) == qubit_count for item in qubits)
        !target_set_all_same && throw(ErrorException("Qubits must all target $qubit_count-qubit operations."))
        qubit_count == 1 && return [first(item) for item in qubits]
        return [collect(item) for item in qubits]
    end
    qubit_count > 1 && return [collect(qubits)]
    return collect(unique(qubits))
end
_parse_qubit_input(q::Int, expected_qubit_count::Int=0) = _parse_qubit_input([q], expected_qubit_count)
_parse_qubit_input(::Nothing, expected_qubit_count::Int=0) = Int[]

struct GateCriteria <: CircuitInstructionCriteria
    gates::Vector{Type{<:Gate}}
    qubits::Vector{Union{Int, Vector{Int}}}
    GateCriteria(gates::Vector{Type{<:Gate}}, qubits::Vector{Union{Int, Vector{Int}}}) = new(gates, qubits)
    function GateCriteria(gates, qubits)
        _gates = _parse_operator_input(gates)
        expected_qc = isempty(_gates) ? 0 : qubit_count(first(_gates))
        _qubit = _parse_qubit_input(qubits, expected_qc)
        new(_gates, _qubit)
    end
end
GateCriteria(gates::Union{Type{<:Gate}, Vector{Type{<:Gate}}}) = GateCriteria(gates, Int[])
GateCriteria() = GateCriteria([], [])
Base.Dict(gc::GateCriteria) = Dict("type"=>"GateCriteria", "gates"=>gc.gates, "qubits"=>gc.qubits)
Base.keys(gc::GateCriteria, ::Type{GateCriteriaKey})  = isempty(gc.gates)  ? KeyResultAll() : gc.gates
Base.keys(gc::GateCriteria, ::Type{QubitCriteriaKey}) = isempty(gc.qubits) ? KeyResultAll() : gc.qubits
applicable_key_types(::Type{GateCriteria}) = [QubitCriteriaKey, GateCriteriaKey]
applicable_key_types(gc::GateCriteria)     = applicable_key_types(GateCriteria)

function instruction_matches(gc::GateCriteria, ix::Instruction)
    ix.operator isa Gate || return false
    !isempty(gc.gates) && typeof(ix.operator) ∉ gc.gates && return false
    target_in = _check_target_in_qubits(gc.qubits, ix.target)
    return target_in
end

struct UnitaryGateCriteria <: CircuitInstructionCriteria
    unitary::Unitary
    qubits::Vector
    function UnitaryGateCriteria(unitary::Unitary, qubits)
        _qubit = _parse_qubit_input(qubits, qubit_count(unitary))
        new(unitary, _qubit)
    end
end
Base.Dict(ugc::UnitaryGateCriteria) = Dict("type"=>"UnitaryGateCriteria", "unitary"=>ugc.unitary, "qubits"=>ugc.qubits)
Base.keys(gc::UnitaryGateCriteria, ::Type{UnitaryGateCriteriaKey}) = gc.unitary.matrix
Base.keys(gc::UnitaryGateCriteria, ::Type{QubitCriteriaKey})       = isempty(gc.qubits) ? KeyResultAll() : gc.qubits
applicable_key_types(::Type{UnitaryGateCriteria}) = [QubitCriteriaKey, UnitaryGateCriteriaKey]
applicable_key_types(gc::UnitaryGateCriteria)     = applicable_key_types(UnitaryGateCriteria)

function instruction_matches(ugc::UnitaryGateCriteria, ix::Instruction)
    !(ix.operator isa Unitary) && return false
    ix.operator != ugc.unitary && return false
    return _check_target_in_qubits(ugc.qubits, ix.target) 
end

struct QubitInitializationCriteria <: InitializationCriteria
    qubits::Vector{Int}
    QubitInitializationCriteria(qubits) = new(_parse_qubit_input(qubits))
end
applicable_key_types(::Type{QubitInitializationCriteria}) = [QubitCriteriaKey]
applicable_key_types(qi::QubitInitializationCriteria)     = applicable_key_types(QubitInitializationCriteria)
Base.keys(qi::QubitInitializationCriteria, ::Type{QubitCriteriaKey}) = isempty(qi.qubits) ? KeyResultAll() : collect(unique(qi.qubits))
qubit_intersection(qi::QubitInitializationCriteria, qubits) = isempty(qi.qubits) ? qubits : collect(intersect(qi.qubits, qubits))

struct ObservableCriteria <: ResultTypeCriteria
    observables::Vector
    qubits::Vector
    function ObservableCriteria(observables, qubits)
        _observables = _parse_operator_input(observables)
        _qubit = _parse_qubit_input(qubits, 1)
        new(_observables, _qubit)
    end
end
Base.Dict(oc::ObservableCriteria) = Dict("type"=>"ObservableCriteria", "observables"=>oc.observables, "qubits"=>oc.qubits)
applicable_key_types(::Type{ObservableCriteria}) = [ObservableCriteriaKey, QubitCriteriaKey]
applicable_key_types(qi::ObservableCriteria)     = applicable_key_types(ObservableCriteria)
Base.keys(oc::ObservableCriteria, ::Type{ObservableCriteriaKey}) = isempty(oc.observables) ? KeyResultAll() : oc.observables
Base.keys(oc::ObservableCriteria, ::Type{QubitCriteriaKey}) = isempty(oc.qubits) ? KeyResultAll() : oc.qubits
function result_type_matches(oc::ObservableCriteria, rt::Result)
    rt isa ObservableResult || return false
    !isempty(oc.observables) && typeof(rt.observable) ∉ oc.observables && return false
    isempty(oc.qubits) && return true
    isempty(rt.targets) && return true
    targs = [rt.targets]
    first(targs) ⊆ oc.qubits && return true
end

struct NoiseModelInstruction
    noise::Noise
    criteria::Criteria
end
function NoiseModelInstruction(d::Dict{String})
    n = StructTypes.construct(Noise, d["noise"])
    c = StructTypes.construct(Criteria, d["criteria"])
    return NoiseModelInstruction(n, c)
end

struct NoiseModelInstructions
    initialization_noise::Vector{NoiseModelInstruction}
    gate_noise::Vector{NoiseModelInstruction}
    readout_noise::Vector{NoiseModelInstruction}
end

mutable struct NoiseModel
    instructions::Vector{NoiseModelInstruction}
    NoiseModel(ixs::Vector{NoiseModelInstruction}) = new(ixs)
end
NoiseModel(d::Dict{String}) = NoiseModel([NoiseModelInstruction(ix) for ix in d["instructions"]])
NoiseModel() = NoiseModel(NoiseModelInstruction[])
Base.Dict(nmi::NoiseModelInstruction) = Dict("noise"=>Dict(nmi.noise), "criteria"=>Dict(nmi.criteria))
Base.Dict(nm::NoiseModel) = Dict("instructions"=>Dict.(nm.instructions))

add_noise!(nm::NoiseModel, noise::Noise, criteria::Criteria) = (push!(nm.instructions, NoiseModelInstruction(noise, criteria)); return nm)
insert_noise!(nm::NoiseModel, ix::Int, noise::Noise, criteria::Criteria) = insert!(nm.instructions, ix, NoiseModelInstruction(noise, criteria))
remove_noise!(nm::NoiseModel, ix::Int) = deleteat!(nm.instructions, ix)

function from_filter(noise_model::NoiseModel; qubit=nothing, gate=nothing, noise=nothing)
    new_model = NoiseModel()
    for ix in noise_model.instructions
        !isnothing(noise) && !(ix.noise isa noise) && continue
        if !isnothing(gate)
            gate_keys = keys(ix.criteria, GateCriteriaKey)
            gate_keys != KeyResultAll() && gate ∉ gate_keys && continue
        end
        if !isnothing(qubit)
            qubit_keys = keys(ix.criteria, QubitCriteriaKey)
            qubit_keys != KeyResultAll() && qubit ∉ qubit_keys && continue
        end
        add_noise!(new_model, ix.noise, ix.criteria)
    end
    return new_model
end

function instructions_by_type(nm::NoiseModel)
    init_noise = filter(ix->ix.criteria isa InitializationCriteria, nm.instructions)
    gate_noise = filter(ix->ix.criteria isa CircuitInstructionCriteria, nm.instructions)
    rout_noise = filter(ix->ix.criteria isa ResultTypeCriteria, nm.instructions)
    return NoiseModelInstructions(init_noise, gate_noise, rout_noise)
end

function apply_gate_noise!(c::Circuit, ixs::Vector{NoiseModelInstruction})
    n_c = Circuit()
    for c_ix in c.instructions
        n_c = add_instruction!(n_c, c_ix)
        t_qs = c_ix.target isa Int ? [c_ix.target] : c_ix.target
        for ix in ixs
            if instruction_matches(ix.criteria, c_ix)
                if qubit_count(ix.noise) == length(t_qs)
                    add_instruction!(n_c, Instruction(ix.noise, t_qs))
                else
                    for q in t_qs
                        add_instruction!(n_c, Instruction(ix.noise, q))
                    end
                end
            end
        end
    end
    for rt in c.result_types
        add_result_type!(n_c, rt)
    end
    return n_c
end

function apply_initialization_noise!(c::Circuit, ixs::Vector{NoiseModelInstruction})
    isempty(ixs) && return c
    for ix in ixs
        qubits = qubit_intersection(ix.criteria, 0:qubit_count(c)-1)
        length(qubits) > 0 && apply_initialization_noise!(c, ix.noise, collect(qubits))
    end
    return c
end

function apply_readout_noise!(c::Circuit, ixs::Vector{NoiseModelInstruction})
    isempty(ixs) && return c
    rts = c.result_types
    noise_to_apply = Dict{Int, Vector{Int}}()
    for rt in rts
        if rt isa ObservableResult
            target_qubits = rt.targets isa Int ? [rt.targets] : rt.targets
            for (iix, ix) in enumerate(ixs)
                if result_type_matches(ix.criteria, rt)
                    for target_qubit in target_qubits
                        if haskey(noise_to_apply, target_qubit)
                            push!(noise_to_apply[target_qubit], iix)
                        else
                            noise_to_apply[target_qubit] = [iix]
                        end
                    end
                end
            end
        end
    end
    for (qubit, v) in noise_to_apply
        for noise_iix in unique(v)
            ix = ixs[noise_iix]
            apply_readout_noise!(c, ix.noise, [qubit])
        end
    end
    return c
end

function apply(nm::NoiseModel, c::Circuit)
    ixs = instructions_by_type(nm)
    n_c = apply_gate_noise!(c, ixs.gate_noise)
    n_c = apply_initialization_noise!(n_c, ixs.initialization_noise)
    n_c = apply_readout_noise!(n_c, ixs.readout_noise)
    return n_c
end
(c::Circuit)(nm::NoiseModel) = apply(nm, c)

using Braket, JSON3, Test

bell_qasm = """
OPENQASM 3;

qubit[2] q;
bit[2] c;

h q[0];
cnot q[0], q[1];

c = measure q;
"""
oq3_program() = Braket.OpenQasmProgram(Braket.header_dict[Braket.OpenQasmProgram], bell_qasm, nothing)

@testset "OQ3ProgramResult" begin
    task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 100, "arn1", nothing, nothing, nothing, nothing, nothing)
    additional_metadata = Braket.AdditionalMetadata(oq3_program(), nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    read_in = JSON3.read("""{"taskMetadata": $(JSON3.write(task_metadata)), "additionalMetadata": $(JSON3.write(additional_metadata))}""", Braket.OQ3ProgramResult)
    @test read_in isa Braket.OQ3ProgramResult
    @test read_in.taskMetadata == task_metadata
    @test read_in.additionalMetadata == additional_metadata
    @test isnothing(read_in.resultTypes)
    @test isnothing(read_in.outputVariables)
    @test isnothing(read_in.measurements)
    @test isnothing(read_in.measuredQubits)
end

"""
    Result

Abstract type representing a measurement to perform on
a [`Circuit`](@ref).

See also: [`Expectation`](@ref), [`Variance`](@ref),
[`Sample`](@ref), [`Probability`](@ref),
[`DensityMatrix`](@ref), and [`Amplitude`](@ref).
"""
abstract type Result end

union_obs_typ = @NamedTuple{observable::IRObservable, targets::Vector{Int}, type::String}

for (typ, ir_typ, label) in ((:Expectation, :(Braket.IR.Expectation), "expectation"), (:Variance, :(Braket.IR.Variance), "variance"), (:Sample, :(Braket.IR.Sample), "sample"))
    @eval begin
        @doc """
            $($typ) <: Result
        
        Struct which represents a $($label) measurement on a [`Circuit`](@ref). 
        """
        struct $typ <: Result
            observable::Observables.Observable
            targets::QubitSet
            $typ(observable::Observables.Observable, targets::QubitSet) = new(observable, targets)
        end
        @doc """
            $($typ)(o, targets) -> $($typ)
            $($typ)(o) -> $($typ)
        
        Constructs a $($typ) of an observable `o` on qubits `targets`.
        
        `o` may be one of:
          - Any [`Observable`](@ref Braket.Observables.Observable)
          - A `String` corresponding to an `Observable` (e.g. `\"x\"``)
          - A `Vector{String}` in which each element corresponds to an `Observable`

        `targets` may be one of:
          - A [`QubitSet`](@ref)
          - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
          - An `Int` or `Qubit`
          - Absent, in which case the observable `o` will be applied to all qubits provided it is a single qubit observable.
        """ $typ(o, targets) = $typ(o, QubitSet(targets))
        function $typ(o::String, targets::QubitSet)
            return if !isempty(targets)
                $typ(Observables.TensorProduct([o for ii in 1:length(targets)]), targets)
            else
                $typ(StructTypes.constructfrom(Observable, o), targets)
            end
        end
        $typ(o::Vector{String}, targets::QubitSet) = $typ(Observables.TensorProduct(o), targets)
        $typ(o::Union{Observables.Observable, String, Vector{String}}) = $typ(o, QubitSet())
        Base.:(==)(e1::$typ, e2::$typ) = (e1.observable == e2.observable && e1.targets == e2.targets)
        StructTypes.StructType(::Type{$typ}) = StructTypes.CustomStruct()
        StructTypes.lower(x::$typ) = $ir_typ(StructTypes.lower(x.observable), (isempty(x.targets) ? nothing : Int.(x.targets)), $label)
        StructTypes.lowertype(::Type{$typ}) = union_obs_typ
        function ir(r::$typ, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
            obs_ir = ir(r.observable, r.targets, Val(:OpenQASM); serialization_properties=serialization_properties)
            return "#pragma braket result " * $label * " $obs_ir"
        end
        $typ(x::union_obs_typ) = $typ(StructTypes.constructfrom(Observables.Observable, x.observable), QubitSet(x.targets))
        chars(x::$typ) = (uppercasefirst($label) * "(" * chars(x.observable)[1] * ")",) 
    end
end


for (typ, ir_typ, label) in ((:Probability, :(Braket.IR.Probability), "probability"), (:DensityMatrix, :(Braket.IR.DensityMatrix), "densitymatrix"))
    @eval begin
        @doc """
            $($typ) <: Result
        
        Struct which represents a $($label) measurement on a [`Circuit`](@ref). 
        """
        struct $typ <: Result
            targets::QubitSet
            $typ(targets::QubitSet) = new(targets)
        end
        Base.:(==)(p1::$typ, p2::$typ) = (p1.targets == p2.targets)
        $typ()  = $typ(QubitSet())
        @doc """
            $($typ)(targets) -> $($typ)
            $($typ)() -> $($typ)

        Constructs a $($typ) on qubits `targets`.

        `targets` may be one of:
          - A [`QubitSet`](@ref)
          - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
          - An `Int` or `Qubit`
          - Absent, in which case the measurement will be applied to all qubits.
        """ $typ(targets) = $typ(QubitSet(targets))
        $typ(targets::Vararg{IntOrQubit}) = $typ(QubitSet(targets...))
        StructTypes.StructType(::Type{$typ}) = StructTypes.CustomStruct()
        StructTypes.lower(x::$typ) = $ir_typ(isempty(x.targets) ? nothing : Int.(x.targets), $label)
        StructTypes.lowertype(::Type{$typ}) = @NamedTuple{targets::Union{Nothing, Vector{Int}}, type::String}
        $typ(x::@NamedTuple{targets::Union{Nothing, Vector{Int}}, type::String}) = $typ(x.targets)
        chars(x::$typ) = (uppercasefirst($label),) 
    end
end

function ir(p::Probability, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    (isnothing(p.targets) || isempty(p.targets)) && return "#pragma braket result probability all"
    t = format_qubits(p.targets, serialization_properties)
    return "#pragma braket result probability $t"
end
function ir(dm::DensityMatrix, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    isempty(dm.targets) && return "#pragma braket result density_matrix"
    t = format_qubits(dm.targets, serialization_properties)
    return "#pragma braket result density_matrix $t"
end
"""
    AdjointGradient <: Result

Struct which represents a gradient computation using the adjoint differentiation method on a [`Circuit`](@ref). 
"""
struct AdjointGradient <: Result
    observable::Observable
    targets::Vector{QubitSet}
    parameters::Vector{String}
    function AdjointGradient(observable::Observable, targets::Vector{QubitSet}, parameters::Vector{String}=["all"])
        if observable isa Sum
            length(targets) == length(observable) || throw(DimensionMismatch("length of targets ($(length(targets))) must be the same as number of summands ($(length(observable)))."))
            all(length(term_target) == qubit_count(summand) for (term_target, summand) in zip(targets, observable.summands)) || throw(DimensionMismatch("each target must be the same size as the qubit count of its corresponding term."))
        else
            (length(targets) == 1 && length(targets[1]) == qubit_count(observable)) || throw(DimensionMismatch("targets $targets must have only one element if adjoint gradient observable is not a Sum."))
        end
        new(observable, targets, parameters)
    end
end

"""
    AdjointGradient(o::Observable, targets, parameters::Vector) -> AdjointGradient
    AdjointGradient(o::Observable, targets) -> AdjointGradient

Constructs an `AdjointGradient` with respect to the expectation value of
an observable `o` on qubits `targets`. The gradient will be calculated by
computing partial derivatives with respect to `parameters`. If `parameters`
is not present, is empty, or is `["all"]`, all parameters in the circuit
will be used. 

`targets` may be one of:
  - A [`QubitSet`](@ref)
  - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
  - An `Int` or `Qubit`

`AdjointGradient` supports using [`Sum`](@ref) observables. If `o` is a `Sum`,
`targets` should be a nested vector of target qubits, such that the `n`-th term of
`targets` has the same length as the `n`-th term of `o`.

# Examples
```jldoctest
julia> α = FreeParameter(:alpha);

julia> c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)]);

julia> op = 2.0 * Braket.Observables.X() * Braket.Observables.X();

julia> c = AdjointGradient(c, op, [QubitSet(0, 1)], [α]);
```

Using a `Sum`:

```jldoctest
julia> α = FreeParameter(:alpha);

julia> c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)]);

julia> op1 = 2.0 * Braket.Observables.X() * Braket.Observables.X();

julia> op2 = -3.0 * Braket.Observables.Y() * Braket.Observables.Y();

julia> c = AdjointGradient(c, op1 + op2, [QubitSet(0, 1), QubitSet(0, 2)], [α]);
```
"""
function AdjointGradient(observable::Observable, targets::Vector{QubitSet}, parameters::Vector)
    isempty(parameters) && return AdjointGradient(observable, targets, ["all"])
    return AdjointGradient(observable, targets, string.(parameters))
end
AdjointGradient(observable::Observable, targets::QubitSet, parameters) = AdjointGradient(observable, [targets], parameters)
AdjointGradient(observable::Observable, targets::Vector{Vector{T}}, args...) where {T} = AdjointGradient(observable, [QubitSet(t) for t in targets], args...)
AdjointGradient(observable::Observable, targets::Vector{<:IntOrQubit}, args...) = AdjointGradient(observable, [QubitSet(targets)], args...)
AdjointGradient(observable::Observable, targets::IntOrQubit, args...) = AdjointGradient(observable, [QubitSet(targets)], args...)

function ir(ag::AdjointGradient, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    isempty(ag.parameters) && (ag.parameters = ["all"])
    if ag.observable isa Sum
        obs_str = ir(ag.observable, ag.targets, Val(:OpenQASM), serialization_properties=serialization_properties)
    else
        obs_str = ir(ag.observable, first(ag.targets), Val(:OpenQASM), serialization_properties=serialization_properties)
    end
    term_str = replace(obs_str, "+ -"=>"- ")
    return "#pragma braket result adjoint_gradient expectation($term_str) $(join(ag.parameters, ", "))"
end
StructTypes.StructType(::Type{AdjointGradient}) = StructTypes.CustomStruct()
function StructTypes.lower(x::AdjointGradient)
    lowered_obs     = StructTypes.lower(x.observable)
    lowered_targets = (isempty(x.targets) ? nothing : convert(Vector{Vector{Int}}, x.targets))
    Braket.IR.AdjointGradient(x.parameters, lowered_obs, lowered_targets, "adjoint_gradient")
end
StructTypes.lowertype(::Type{AdjointGradient}) = @NamedTuple{parameters::Union{Nothing, Vector{String}}, observable::IRObservable, targets::Union{Nothing, Vector{Vector{Int}}}, type::String}
function AdjointGradient(x::@NamedTuple{parameters::Union{Nothing, Vector{String}}, observable::IRObservable, targets::Union{Nothing, Vector{Vector{Int}}}, type::String})
    params = isnothing(x.parameters) || isempty(x.parameters) ? ["all"] : x.parameters
    obs = StructTypes.constructfrom(Observables.Observable, x.observable)
    targets = isnothing(x.targets) || isempty(x.targets) ? QubitSet[] : [QubitSet(t) for t in x.targets]
    return AdjointGradient(obs, targets, params)
end
chars(x::AdjointGradient) = ("AdjointGradient(H)",) 


"""
    Amplitude <: Result

Struct which represents an amplitude measurement on a [`Circuit`](@ref). 
"""
struct Amplitude <: Result
    states::Vector{String}
end
"""
    Amplitude(states) -> Amplitude

Constructs an Amplitude measurement of `states`.

`states` may be one of:
  - A `Vector{String}`
  - A `String`
All elements of `states` must be `'0'` or `'1'`.
"""
Amplitude(s::String) = Amplitude([s])
Base.:(==)(a1::Amplitude, a2::Amplitude) = (a1.states == a2.states)
function ir(a::Amplitude, ::Val{:OpenQASM}; kwargs...)
    states = join(repr.(a.states), ", ")
    return "#pragma braket result amplitude $states"
end
chars(x::Amplitude) = ("Amplitude(" * join(x.states, ", ") * ")",)

"""
    StateVector <: Result

Struct which represents a state vector measurement on a [`Circuit`](@ref). 
"""
struct StateVector <: Result end
ir(s::StateVector, ::Val{:OpenQASM}; kwargs...) = "#pragma braket result state_vector"
Base.:(==)(sv1::StateVector, sv2::StateVector) = true
chars(x::StateVector) = ("StateVector",)

const ObservableResult = Union{Expectation, Variance, Sample}
const ObservableParameterResult = Union{AdjointGradient,}

remap(rt::R, mapping::Dict{<:Integer, <:Integer}) where {R<:ObservableResult} = R(copy(rt.observable), [mapping[q] for q in rt.targets])
remap(rt::R, mapping::Dict{<:Integer, <:Integer}) where {R<:Result} = R([mapping[q] for q in rt.targets])
remap(rt::R, target) where {R<:ObservableResult} = R(copy(rt.observable), QubitSet(target[ii] for ii in 1:length(rt.targets)))
remap(rt::R, target) where {R<:Result} = R(QubitSet(target[ii] for ii in 1:length(rt.targets)))

StructTypes.StructType(::Type{Amplitude}) = StructTypes.CustomStruct()
StructTypes.lower(x::Amplitude) = Braket.IR.Amplitude(x.states, "amplitude")
StructTypes.lowertype(::Type{Amplitude}) = @NamedTuple{states::Vector{String}, type::String}
Amplitude(x::@NamedTuple{states::Vector{String}, type::String}) = Amplitude(x.states)


StructTypes.StructType(::Type{StateVector}) = StructTypes.CustomStruct()
StructTypes.lower(x::StateVector) = Braket.IR.StateVector("statevector")
StructTypes.lowertype(::Type{StateVector}) = @NamedTuple{type::String}
StateVector(x::@NamedTuple{type::String}) = StateVector()

ir(r::Result, ::Val{:JAQCD}; kwargs...) = StructTypes.lower(r)
ir(r::Result; kwargs...) = ir(r, Val(IRType[]); kwargs...)
StructTypes.StructType(::Type{Result}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Result}) = (amplitude=Amplitude, expectation=Expectation, probability=Probability, statevector=StateVector, variance=Variance, sample=Sample, densitymatrix=DensityMatrix, adjoint_gradient=AdjointGradient)

function StructTypes.constructfrom(::Type{R}, obj) where {R<:Result}
    return R((getproperty(obj, fn) for fn in fieldnames(R))...)
end

function StructTypes.constructfrom(::Type{R}, obj) where {R<:ObservableResult}
    obs = StructTypes.constructfrom(Observables.Observable, obj.observable)
    return R(obs, obj.targets)
end

function StructTypes.constructfrom(::Type{Result}, r::Braket.IR.AbstractProgramResult)
    typ = StructTypes.subtypes(Result)[Symbol(r.type)]
    StructTypes.constructfrom(typ, r)
end

function Base.getindex(r::GateModelQuantumTaskResult, rt::AdjointGradient)
    # only one AdjointGradient result per circuit
    ix = findfirst(rt_->rt_.type isa IR.AdjointGradient, r.result_types)
    isnothing(ix) && throw(KeyError(rt))
    return r.values[ix]
end

function Base.getindex(r::GateModelQuantumTaskResult, rt::Result)
    ix = findfirst(rt_->rt_.type==ir(rt, Val(:JAQCD)), r.result_types)
    isnothing(ix) && throw(KeyError(rt))
    return r.values[ix]
end

using Braket, Braket.AWS, Dates, Test
using AWS: @service, AWSConfig, global_aws_config
@service BRAKET use_response_type=true

@testset "Cost tracking" begin
    @testset "QPU tracking" begin
        circuit = Circuit([(H, 0)])
        t = Braket.Tracker()
        n_available = 0
        for arn = ("arn:aws:braket:eu-west-2::device/qpu/oqc/Lucy", "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet", "arn:aws:braket:us-west-1::device/qpu/rigetti/Aspen-M-3", "arn:aws:braket:us-east-1::device/qpu/ionq/Harmony")
            d = AwsDevice(arn)
            if Braket.isavailable(d)
                d(circuit, shots=10)
                n_available += 1
            end
        end
        if n_available > 0
            @test qpu_tasks_cost(t) > 0.0
        else
            @test qpu_tasks_cost(t) == 0.0
        end
    end
    @testset "Simulator tracking" begin
        circuit = Circuit([(H, 0), (CNot, 0, 1)])
        device = AwsDevice("arn:aws:braket:::device/quantum-simulator/amazon/sv1")

        let t = Braket.Tracker()
            task0 = device(circuit, shots=100)
            task1 = device(circuit, shots=100)
            @test Braket.quantum_task_statistics(t) == Dict("arn:aws:braket:::device/quantum-simulator/amazon/sv1"=>Dict("shots"=>200, "tasks"=>Dict("CREATED"=>2)))
            result(task0)
            result(task1)

            task = device(circuit, shots=100)
            cancel(task)
            quantum_stats = Braket.quantum_task_statistics(t)[arn(device)]
            @test quantum_stats["shots"] == 300
            @test quantum_stats["tasks"] == Dict("COMPLETED"=>2, "CANCELLING"=>1)
            @test quantum_stats["execution_duration"] > Millisecond(0)
            @test quantum_stats["billed_execution_duration"] >= quantum_stats["execution_duration"]
            @test quantum_stats["billed_execution_duration"] >= 2 * Braket.MIN_SIMULATOR_DURATION

            @test qpu_tasks_cost(t) == 0
            @test simulator_tasks_cost(t) > 0
        end
    end
    @testset "All devices price search" begin
        devices = get_devices(statuses=["ONLINE", "OFFLINE"])
        tasks = Dict{String, Any}()
        for region in Braket.REGIONS
            withenv("AWS_DEFAULT_REGION" => region) do
                for device in devices
                    try
                        config = Braket.AWS.global_aws_config()
                        region_config = Braket.AWS.AWSConfig(config.credentials, region, config.output)
                        d = BRAKET.get_device(Braket.HTTP.escapeuri(arn(device)), aws_config=region_config)
                        # If we are here, device can create tasks in region
                        details = Dict{String, Any}(
                            "shots"=>100,
                            "device"=>arn(device),
                            "billed_duration"=>Braket.MIN_SIMULATOR_DURATION,
                            "job_task"=>false,
                            "status"=>"COMPLETED",
                        )
                        tasks["task:for:$(name(device)):$region"] = copy(details)
                        details["job_task"] = true
                        tasks["jobtask:for:$(name(device)):$region"] = details
                    catch
                        # device does not exist in region, so nothing to test
                        continue
                    end
                end
            end
        end
        t = Braket.Tracker()
        t._resources = tasks
        @test qpu_tasks_cost(t) + simulator_tasks_cost(t) > 0
    end
end

using Braket, Test

@testset "IQM device schema" begin
    @testset "Device capabilities" begin
        props = """{
                    "braketSchemaHeader": {
                        "name": "braket.device_schema.standardized_gate_model_qpu_device_properties",
                        "version": "1"
                    },
                    "oneQubitProperties": {
                        "0": {
                            "T1": {"value": 28.9, "standardError": 0.01, "unit": "us"},
                            "T2": {"value": 44.5, "standardError": 0.02, "unit": "us"},
                            "oneQubitFidelity": [
                                {
                                    "fidelityType": {"name": "readout"},
                                    "fidelity": 0.9993,
                                    "standardError": null
                                },
                                {
                                    "fidelityType": {"name": "randomized_benchmarking"},
                                    "fidelity": 0.903,
                                    "standardError": null
                                }
                            ]
                        }
                    },
                    "twoQubitProperties": {
                        "0-1": {
                            "twoQubitGateFidelity": [
                                {
                                    "direction": {"control": 0, "target": 1},
                                    "gateName": "cnot",
                                    "fidelity": 0.877,
                                    "fidelityType": {"name": "interleaved_randomized_benchmarking"}
                                }
                            ]
                        }
                    }
                }"""
        jaqcd() = """{
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.iqm.iqm_device_capabilities",
                            "version": "1"
                        },
                        "service": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.device_service_properties",
                                "version": "1"
                            },
                            "executionWindows": [
                                {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                            ],
                            "shotsRange": [1, 10],
                            "deviceCost": {"price": 0.25, "unit": "minute"},
                            "deviceDocumentation": {
                                "imageUrl": "image_url",
                                "summary": "Summary on the device",
                                "externalDocumentationUrl": "exter doc link"
                            },
                            "deviceLocation": "eu-west-2",
                            "updatedAt": "2020-06-16T19:28:02.869136"
                        },
                        "action": {
                            "braket.ir.jaqcd.program": {
                                "actionType": "braket.ir.jaqcd.program",
                                "version": ["1"],
                                "supportedOperations": ["x", "y"],
                                "supportedResultTypes": [
                                    {
                                        "name": "resultType1",
                                        "observables": ["observable1"],
                                        "minShots": 2,
                                        "maxShots": 4
                                    }
                                ]
                            }
                        },
                        "paradigm": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                                "version": "1"
                            },
                            "qubitCount": 32,
                            "nativeGateSet": ["ccnot", "cy"],
                            "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
                        },
                        "deviceParameters": {}
                    }
        """
        openqasm() = """{
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.iqm.iqm_device_capabilities",
                            "version": "1"
                        },
                        "service": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.device_service_properties",
                                "version": "1"
                            },
                            "executionWindows": [
                                {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                            ],
                            "shotsRange": [1, 10],
                            "deviceCost": {"price": 0.25, "unit": "minute"},
                            "deviceDocumentation": {
                                "imageUrl": "image_url",
                                "summary": "Summary on the device",
                                "externalDocumentationUrl": "exter doc link"
                            },
                            "deviceLocation": "us-east-1",
                            "updatedAt": "2020-06-16T19:28:02.869136"
                        },
                        "action": {
                            "braket.ir.openqasm.program": {
                                "actionType": "braket.ir.openqasm.program",
                                "version": ["1"],
                                "supportedOperations": ["x", "y"],
                                "supportedResultTypes": [
                                    {
                                        "name": "resultType1",
                                        "observables": ["observable1"],
                                        "minShots": 2,
                                        "maxShots": 4
                                    }
                                ],
                                "supportPhysicalQubits": false,
                                "supportedPragmas": ["braket_noise_bit_flip"],
                                "forbiddenPragmas": ["braket_unitary_matrix"],
                                "forbiddenArrayOperations": ["concatenation", "range", "slicing"],
                                "requireAllQubitsMeasurement": false,
                                "requireContiguousQubitIndices": false,
                                "supportsPartialVerbatimBox": false,
                                "supportsUnassignedMeasurements": false
                            }
                        },
                        "paradigm": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                                "version": "1"
                            },
                            "qubitCount": 32,
                            "nativeGateSet": ["ccnot", "cy"],
                            "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
                        },
                        "deviceParameters": {},
                        "standardized": $props
                    }
        """
        @testset for format in [jaqcd, openqasm]
            @test Braket.parse_raw_schema(format()) isa Braket.IqmDeviceCapabilities
        end
    end
    @testset "Device parameters" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.iqm.iqm_device_parameters",
                "version": "1"
            },
            "paradigmParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.gate_model_parameters",
                    "version": "1"
                },
                "qubitCount": 1
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.IqmDeviceParameters
    end
    @testset "Provider properties" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.iqm.iqm_provider_properties",
                "version": "1"
            },
            "properties": {
                "one_qubit": {
                    "0": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "1": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "2": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "3": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "4": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "5": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "6": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    },
                    "7": {
                        "T1": 12.2,
                        "T2": 13.5,
                        "fRO": 0.99,
                        "fRB": 0.98,
                        "native_gate_fidelities": [
                            {"native_gate": "rz", "CLf": 0.99},
                            {"native_gate": "sx", "CLf": 0.99},
                            {"native_gate": "x", "CLf": 0.99}
                        ],
                        "EPE": 0.001
                    }
                },
                "two_qubit": {
                    "0-1": {
                        "coupling": {"control_qubit": 0, "target_qubit": 1},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "1-2": {
                        "coupling": {"control_qubit": 1, "target_qubit": 2},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "2-3": {
                        "coupling": {"control_qubit": 2, "target_qubit": 3},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "3-4": {
                        "coupling": {"control_qubit": 3, "target_qubit": 4},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "4-5": {
                        "coupling": {"control_qubit": 4, "target_qubit": 5},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "5-6": {
                        "coupling": {"control_qubit": 5, "target_qubit": 6},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "6-7": {
                        "coupling": {"control_qubit": 6, "target_qubit": 7},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    },
                    "7-0": {
                        "coupling": {"control_qubit": 7, "target_qubit": 0},
                        "CLf": 0.99,
                        "ECR_f": 0.99
                    }
                }
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.IqmProviderProperties
    end
end

const JOB_DEFAULT_RESULTS_POLL_TIMEOUT = 864000
const JOB_DEFAULT_RESULTS_POLL_INTERVAL = 5
const JOB_TERMINAL_STATES = ["COMPLETED", "FAILED", "CANCELLED"]
const RESULTS_FILENAME = "results.json"
const RESULTS_TAR_FILENAME = "model.tar.gz"
const LOG_GROUP = "/aws/braket/jobs"
const stream_colors = [34, 35, 32, 36, 33]
const QUERY_DEFAULT_JOB_DURATION = 3 * 60 * 60
const QUERY_POLL_TIMEOUT_SECONDS = 10
const QUERY_POLL_INTERVAL_SECONDS = 1
const METRIC_DEFINITIONS = r"(\w+)\s*=\s*([^;]+)\s*;"
const TIMESTAMP = "timestamp"
const ITERATION_NUMBER = "iteration_number"
const NODE_ID = "node_id"
const NODE_TAG = r"^\[([^\]]*)\]"
const ECR_URI_PATTERN = r"^((\d+)\.dkr\.ecr\.([^.]+)\.[^/]*)/([^:]*):(.*)$"

@enum LogState TAILING JOB_COMPLETE COMPLETE
@enum Framework BASE PL_TENSORFLOW PL_PYTORCH

"""
    Job

Abstract type representing a Braket Job.
"""
abstract type Job end

get_job(j::Job) = get_job(arn(j))
get_job(arn::String) = startswith(arn, "local") ? LocalQuantumJob(arn) : BRAKET.get_job(HTTP.escapeuri(arn) * "?additionalAttributeNames=QueueInfo")

config_fname(f::Framework) = joinpath(@__DIR__, "image_uri_config", lowercase(string(f))*".json")
config_for_framework(f::Framework) = JSON3.read(read(config_fname(f), String), Dict)

function registry_for_region(config::Dict{String, Any}, region::String)
    registry_config = config["registries"]
    haskey(registry_config, region) || throw(ErrorException("unsupported region $region. You may need to update your SDK version for newer regions. Supported regions: $(collect(keys(registry_config)))."))
    return registry_config[region]
end

function retrieve_image(f::Framework, config::AWSConfig)
    aws_region = AWS.region(config)
    conf = config_for_framework(f)
    framework_version = maximum(version for version in keys(conf["versions"]))
    version_config = conf["versions"][framework_version]
    registry = registry_for_region(version_config, aws_region)
    tag = if f == BASE
        string(version_config["repository"]) * ":" * "latest"
    elseif f == PL_TENSORFLOW
        string(version_config["repository"]) * ":" * "latest"
    elseif f == PL_PYTORCH
        string(version_config["repository"]) * ":" * "latest"
    end
    return string(registry) * ".dkr.ecr.$aws_region.amazonaws.com/$tag"
end

function get_input_data_dir(channel::String="input")
    input_dir = get(ENV, "AMZN_BRAKET_INPUT_DIR", ".")
    return input_dir == "." ? input_dir : joinpath(input_dir, channel)
end
get_job_name() = get(ENV, "AMZN_BRAKET_JOB_NAME", "")
get_job_device_arn() = get(ENV, "AMZN_BRAKET_DEVICE_ARN", "local:none/none")
get_results_dir() = get(ENV, "AMZN_BRAKET_JOB_RESULTS_DIR", ".")
get_checkpoint_dir() = get(ENV, "AMZN_BRAKET_CHECKPOINT_DIR", ".")
function get_hyperparameters()
    haskey(ENV, "AMZN_BRAKET_HP_FILE") || return Dict{String, Any}()
    return JSON3.read(read(ENV["AMZN_BRAKET_HP_FILE"], String), Dict{String, Any}) 
end

function serialize_values(data_dictionary::Dict{String, Any}, data_format::PersistedJobDataFormat)
    data_format == pickled_v4 && throw(ArgumentError("pickling data not yet supported!"))
    return data_dictionary
end

function deserialize_values(data_dictionary::Dict{String, Any}, data_format::PersistedJobDataFormat)
    data_format == plaintext && return data_dictionary
    throw(ArgumentError("unpickling results not yet supported!"))
end
deserialize_values(data_dictionary::Dict{String, Any}, data_format::String) = deserialize_values(data_dictionary, PersistedJobDataFormatDict[data_format])

function _load_persisted_data(filename::String="")
    isempty(filename) && (filename = joinpath(get_results_dir(), "results.json"))
    try    
        return JSON3.read(read(filename, String), Dict{String, Any})
    catch
        return PersistedJobData(header_dict[PersistedJobData], Dict{String, Any}(), plaintext)
    end
end

function save_job_result(result_data::Dict{String, Any}, data_format::PersistedJobDataFormat=plaintext)
    # can't handle pickled data yet
    current_persisted_data = _load_persisted_data()
    current_results = deserialize_values(current_persisted_data.dataDictionary, current_persisted_data.dataFormat)
    updated_results = merge(current_results, result_data)
    result_path = joinpath(get_results_dir(), "results.json")
    serialized_data = serialize_values(updated_results, data_format)
    persisted_data = PersistedJobData(header_dict[PersistedJobData], serialized_data, data_format)
    write(result_path, JSON3.write(persisted_data))
    return
end
save_job_result(result_data, data_format::PersistedJobDataFormat=plaintext) = save_job_result(Dict{String, Any}("result"=>result_data), data_format)

Base.@kwdef mutable struct JobsOptions
    entry_point::String=""
    image_uri::String=""
    job_name::String=_generate_default_job_name(image_uri)
    code_location::String=construct_s3_uri(default_bucket(), "jobs", job_name, "script")
    role_arn::String=get(ENV, "BRAKET_JOBS_ROLE_ARN", _get_default_jobs_role())
    wait_until_complete::Bool=false
    hyperparameters::Dict{String, <:Any}=Dict{String, Any}()
    input_data::Union{String, Dict} = Dict()
    instance_config::InstanceConfig = InstanceConfig()
    distribution::String=""
    stopping_condition::StoppingCondition = StoppingCondition()
    output_data_config::OutputDataConfig = OutputDataConfig(job_name=job_name)
    copy_checkpoints_from_job::String=""
    checkpoint_config::CheckpointConfig = CheckpointConfig(job_name)
    tags::Dict{String, String}=Dict{String, String}()
end

using Braket, Test, Mocking, JSON3
Mocking.activate()

mock_result(c) = Braket.GateModelTaskResult(
            Braket.header_dict[Braket.GateModelTaskResult],
            nothing,
            nothing,
            [Braket.ResultTypeValue(Braket.IR.Amplitude(["011000"], "amplitude"), Dict("011000"=>0.9999999999999982))],
            collect(0:5),
            Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 0, "arn1", nothing, nothing, nothing, nothing, nothing),
            Braket.AdditionalMetadata(Braket.Program(c), nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
        )

RIGETTI_ARN = "arn:aws:braket:::device/qpu/rigetti/Aspen-M-3"
IONQ_ARN = "arn:aws:braket:::device/qpu/ionq/ionQdevice"
SV1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
IQM_ARN = "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet"
XANADU_ARN = "arn:aws:braket:us-east-1::device/qpu/xanadu/Borealis"

@testset "Batched tasks" begin
    c = CNot(Circuit(), 0, 1)
    @testset for dev in (SV1_ARN,) 
        resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            t = Braket.AwsQuantumTaskBatch(dev, [c, c], s3_destination_folder=("fake_bucket", "fake_prefix"))
            @test arn.(Braket.tasks(t)) == ["arn/fake", "arn/fake"]
            @test t isa Braket.AwsQuantumTaskBatch
            @test length(t) == 2
        end
    end
    @testset "inputs" begin
        dev = SV1_ARN
        α = FreeParameter(:α)
        c_params = Circuit([(H, [0, 1]), (CNot, 0, 1), (Rx, 0, α)])
        @testset "one dict for multiple circuits" begin
            resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
            req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            apply(req_patch) do
                t = Braket.AwsQuantumTaskBatch(dev, [c, c], s3_destination_folder=("fake_bucket", "fake_prefix"), inputs=Dict("α"=>0.2))
                @test arn.(Braket.tasks(t)) == ["arn/fake", "arn/fake"]
                @test t isa Braket.AwsQuantumTaskBatch
                @test length(t) == 2
            end
        end
        @testset "one dict per circuit" begin
            resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
            req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
            apply(req_patch) do
                t = Braket.AwsQuantumTaskBatch(dev, [c, c], s3_destination_folder=("fake_bucket", "fake_prefix"), inputs=[Dict("α"=>0.2), Dict("α"=>0.1)])
                @test arn.(Braket.tasks(t)) == ["arn/fake", "arn/fake"]
                @test t isa Braket.AwsQuantumTaskBatch
                @test length(t) == 2
            end
        end
        @testset "wrong vector of dicts length" begin
            @test_throws DimensionMismatch Braket.AwsQuantumTaskBatch(dev, [c, c], s3_destination_folder=("fake_bucket", "fake_prefix"), inputs=[Dict("α"=>0.2), Dict("α"=>0.1),  Dict("α"=>0.1)])
        end
        @testset "invalid inputs" begin
            @test_throws ArgumentError Braket.AwsQuantumTaskBatch(dev, [c, c], s3_destination_folder=("fake_bucket", "fake_prefix"), inputs=Set(1))
        end
    end
    @testset "unfinished" begin
        resp_dict = Dict("status"=>"RUNNING")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            n_tasks = 10
            tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
            specs = [c for ix in 1:n_tasks]
            t = Braket.AwsQuantumTaskBatch(tasks, nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 10, 1, 10)
            @test Braket.unfinished(t) == Set(arn.(tasks))
        end
    end
    @testset "unsuccessful" begin
        resp_dict = Dict("status"=>"FAILED")
        req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            n_tasks = 10
            tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
            specs = [c for ix in 1:n_tasks]
            t = Braket.AwsQuantumTaskBatch(tasks, nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 10, 1, 10)
            @test isempty(Braket.unsuccessful(t))
            _ = Braket.unfinished(t)
            @test Braket.unsuccessful(t) == Set(arn.(tasks))
            @test_throws ErrorException Braket.retry_unsuccessful_tasks(t)
        end
    end
    @testset "retry_unsuccessful_tasks" begin
        n_tasks = 10
        raw_tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
        specs = [c for ix in 1:n_tasks]
        t = Braket.AwsQuantumTaskBatch(copy(raw_tasks), nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 100, 1, 10)
        t._results = fill("fake_result", n_tasks)
        @test isnothing(Braket.retry_unsuccessful_tasks(t))
        t._results = convert(Vector{Any}, fill(nothing, n_tasks))
        t._results[2] = "hello"
        t._results[5] = "world"
        new_arns = ["arn:fake:$i" for i in n_tasks+1:2*n_tasks+1]
        function f(http_backend, request, response_stream)
            if request.service == "s3"
                return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(JSON3.write(mock_result(c))))
            else
                if request.request_method == "POST"
                    mtd_dict = Dict("quantumTaskArn"=>popfirst!(new_arns), "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                elseif request.request_method == "GET"
                    mtd_dict = Dict("status"=>"COMPLETED", "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                end
            end
        end
        req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
        apply(req_patch) do
            Braket.retry_unsuccessful_tasks(t)
            @test isempty(t._unsuccessful)
            @test arn(Braket.tasks(t)[2]) == "arn:fake:2"
            @test arn(Braket.tasks(t)[5]) == "arn:fake:5"
            for ix in [1, 3, 4, 6, 7, 8, 9, 10]
                @test arn(Braket.tasks(t)[ix]) ∉ arn.(raw_tasks)
            end
        end
    end
    @testset "result" begin
        @testset "success" begin
            mtd_dict = Dict("status"=>"COMPLETED", "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(JSON3.write(mock_result(c))))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                n_tasks = 10
                tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
                specs = [c for ix in 1:n_tasks]
                t = Braket.AwsQuantumTaskBatch(tasks, nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 0, 1, 10)
                rs = Braket.results(t)
                @test length(rs) == n_tasks
                @test all(r isa Braket.GateModelQuantumTaskResult for r in rs)
                for r in rs
                    raw = Braket.format_result(Braket.parse_raw_schema(JSON3.write(mock_result(c))))
                    @test r.values == raw.values
                end
            end
        end
        @testset "failure" begin
            mtd_dict = Dict("status"=>"FAILED", "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(JSON3.write(mock_result(c))))
                else
                    return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                n_tasks = 10
                tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
                specs = [c for ix in 1:n_tasks]
                t = Braket.AwsQuantumTaskBatch(tasks, nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 0, 1, 10)
                @test_throws ErrorException Braket.results(t, max_retries=0, fail_unsuccessful=true)
                @test Braket.results(t, max_retries=0, fail_unsuccessful=false) == fill(nothing, 10)
            end
        end
        @testset "retries" begin
            n_tasks = 10
            # test retries
            new_arns = ["arn:fake:$i" for i in n_tasks+1:2*n_tasks+1]
            function f(http_backend, request, response_stream)
                if request.service == "s3"
                    return Braket.AWS.Response(Braket.HTTP.Response(200), IOBuffer(JSON3.write(mock_result(c))))
                else
                    if request.request_method == "POST"
                        mtd_dict = Dict("quantumTaskArn"=>popfirst!(new_arns), "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
                        return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                    elseif request.request_method == "GET"
                        mtd_dict = Dict("status"=>"FAILED", "outputS3Bucket"=>"fake_bucket", "outputS3Directory"=>"fake_dir")
                        return Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(mtd_dict)))
                    end
                end
            end
            req_patch  = @patch Braket.AWS._http_request(http_backend, request::Braket.AWS.Request, response_stream::IO) = f(http_backend, request, response_stream)
            apply(req_patch) do
                tasks = [Braket.AwsQuantumTask("arn:fake:$i") for i in 1:n_tasks]
                specs = [c for ix in 1:n_tasks]
                t = Braket.AwsQuantumTaskBatch(tasks, nothing, Set{String}(), "fake_device", specs, ("fake_bucket", "fake_prefix"), 100, 1, 10)
                @test Braket.results(t, max_retries=1) == fill(nothing, 10)
            end
        end
    end
end

using Braket, PyBraket, Test
using Braket: AtomArrangement, AtomArrangementItem, TimeSeries, DrivingField, AwsDevice, AnalogHamiltonianSimulation, discretize, AnalogHamiltonianSimulationQuantumTaskResult

@testset "AHS" begin
    a = 5.5e-6

    register = AtomArrangement()
    push!(register, AtomArrangementItem((0.5, 0.5 + 1/√2) .* a))
    push!(register, AtomArrangementItem((0.5 + 1/√2, 0.5) .* a))
    push!(register, AtomArrangementItem((0.5 + 1/√2, -0.5) .* a))
    push!(register, AtomArrangementItem((0.5, -0.5 - 1/√2) .* a))
    push!(register, AtomArrangementItem((-0.5, -0.5 - 1/√2) .* a))
    push!(register, AtomArrangementItem((-0.5 -1/√2, -0.5) .* a))
    push!(register, AtomArrangementItem((-0.5 -1/√2, 0.5) .* a))
    push!(register, AtomArrangementItem((-0.5, 0.5 + 1/√2) .* a))
    # extracted from device paradigm
    (C6, Ω_min, Ω_max, Ω_slope_max, Δ_min, Δ_max, time_max) = (5.42e-24, 0.0, 6.3e6, 2.5e14, -1.25e8, 1.25e8, 4.0e-6)

    time_max     = Float64(time_max)
    Δ_start      = -5 * Float64(Ω_max)
    Δ_end        = 5 * Float64(Ω_max)
    @test all(Δ_min <= Δ <= Δ_max for Δ in (Δ_start, Δ_end))

    time_ramp = 1e-7  # seconds
    @test Float64(Ω_max) / time_ramp < Ω_slope_max

    Ω                       = TimeSeries()
    Ω[0.0]                  = 0.0
    Ω[time_ramp]            = Ω_max
    Ω[time_max - time_ramp] = Ω_max
    Ω[time_max]             = 0.0 

    Δ                       = TimeSeries()
    Δ[0.0]                  = Δ_start
    Δ[time_ramp]            = Δ_start
    Δ[time_max - time_ramp] = Δ_end
    Δ[time_max]             = Δ_end

    ϕ           = TimeSeries()
    ϕ[0.0]      = 0.0
    ϕ[time_max] = 0.0

    drive                   = DrivingField(Ω, ϕ, Δ)
    ahs_program             = AnalogHamiltonianSimulation(register, drive)

    ahs_local    = LocalSimulator(PyLocalSimulator("braket_ahs"))
    local_result = result(simulate(ahs_local, ahs_program, shots=1_000))
    @test length(local_result.measurements) == 1_000

    
    #=if !haskey(ENV, "GITLAB_CI")
        aquila_qpu   = AwsDevice("arn:aws:braket:us-east-1::device/qpu/quera/Aquila")
        drive                   = DrivingField(Ω, ϕ, Δ)
        ahs_program             = AnalogHamiltonianSimulation(register, drive)
        discretized_ahs_program = discretize(ahs_program, aquila_qpu)
        local_result = result(run(ahs_local, discretized_ahs_program, shots=1_000))
        @test length(local_result.measurements) == 1_000
    end=#
end


@testset "AHS_Local_simulator" begin
    a = 5.5e-6

    register = AtomArrangement()
    push!(register, AtomArrangementItem((0, 0) .* a))
    
    Ω_max = 2.5e6
    t_max = 2π/(Ω_max)
    Ω = TimeSeries()
    Ω[0.0] = Ω_max
    Ω[t_max] = Ω_max

    ϕ = TimeSeries()
    ϕ[0.0] = 0.0
    ϕ[t_max] = 0.0

    Δ = TimeSeries()
    Δ[0.0] = 0.0
    Δ[t_max] = 0.0

    drive                   = DrivingField(Ω, ϕ, Δ)
    ahs_program             = AnalogHamiltonianSimulation(register, drive)

    ahs_local    = LocalSimulator(PyLocalSimulator("braket_ahs"))
    local_result = result(simulate(ahs_local, ahs_program, shots=1_000))
    
    g_count = 0
    for meas in local_result.measurements
        g_count += meas.post_sequence[1]
    end

    @test g_count == 1_000

end

### A Pluto.jl notebook ###
# v0.19.16

using Markdown
using InteractiveUtils

# ╔═╡ b7719166-12c4-47a6-b501-7bacd7662dd0
using Braket, PyBraket

# ╔═╡ dd486f0e-cc45-41b7-b7db-42ad83121194
using Braket: AtomArrangement, AtomArrangementItem, TimeSeries, DrivingField, AwsDevice, AnalogHamiltonianSimulation, discretize, AnalogHamiltonianSimulationQuantumTaskResult

# ╔═╡ c8e43644-4faf-4ea2-96f4-796451f04db0
using DataStructures, Statistics, Plots

# ╔═╡ 1a35d23d-2eb0-45a5-b7a6-bbd73e3e7552
md"
# Hello AHS: Run your first Analog Hamiltonian Simulation

Analog Hamiltonian simulation (AHS) is a paradigm of quantum computing different from quantum circuits: instead of a sequence of gates, each acting only on a couple of qubits at a time, an AHS program is defined by the time- and space-dependent parameters of the Hamiltonian in question. 

As an example, in this notebook, we will consider a ring of eight spins, each of which can be in the “up” and “down” state. We will show how to prepare a so-called anti-ferromagnetic order, where consecutive spins point in opposite directions.

Note: to run this notebook you'll need the `Braket.jl` package installed (it comes along with a sub-package, `PyBraket.jl`, for interfacing with Python where necessary).
"

# ╔═╡ 9e2fcfb3-8d7d-4757-8bfe-8db98c36e409
md"
## Register

The first component of an AHS program is the register. In this example, we will use one neutral atom to stand for each spin, and the “up” and “down” spin states will be encoded in excited Rydberg state and ground state of the atoms, respectively. Let us first create a ring consists of eight atoms.
"

# ╔═╡ 388585cc-4417-11ed-3e99-af78d6112c38
begin
	a = 5.5e-6
	
	register = AtomArrangement()
	push!(register, AtomArrangementItem((0.5, 0.5 + 1/√2) .* a))
	push!(register, AtomArrangementItem((0.5 + 1/√2, 0.5) .* a))
	push!(register, AtomArrangementItem((0.5 + 1/√2, -0.5) .* a))
	push!(register, AtomArrangementItem((0.5, -0.5 - 1/√2) .* a))
	push!(register, AtomArrangementItem((-0.5, -0.5 - 1/√2) .* a))
	push!(register, AtomArrangementItem((-0.5 -1/√2, -0.5) .* a))
	push!(register, AtomArrangementItem((-0.5 -1/√2, 0.5) .* a))
	push!(register, AtomArrangementItem((-0.5, 0.5 + 1/√2) .* a))
end

# ╔═╡ 062c38f4-07d9-4a3c-ab88-590afb00ae74
md"
## Hamiltonian

The second component of an AHS program is the Hamiltonian. At the beginning of the AHS program, all spins (by default) start in their “down” state, they are in a so-called ferromagnetic phase. Our goal is to specify a time-dependent Hamiltonian that smoothly transitions the spins from this state to a many-body state where the “up” states are preferred. 

We will work with the following Hamiltonian
```math
\begin{align}
H(t) = \sum_{k=1}^NH_\text{drive, k}(t) + \sum_{j=1}^N\sum_{k=j+1}^NH_\text{vdW, j, k}
\end{align}
```
where $N$ is the number of atoms in the register. Here the first term is the driving field for the atoms
```math
\begin{align}
H_\text{drive, k}(t) = \frac{\Omega(t)}{2}[e^{i\phi(t)}|g_k\rangle\langle r_k|+h.c.]-\Delta(t)|r_k\rangle\langle r_k|
\end{align}
```
and the second term is the van de Waals interaction between all pairs of atoms. An AHS program consists of the time series for the time-dependent coefficients $\Omega(t)$, $\phi(t)$ and $\Delta(t)$, which are specified below.


"

# ╔═╡ dbd73541-e918-48e2-b590-c07f44e3e711
begin
	time_max                = 4e-6  # seconds
	time_ramp               = 1e-7  # seconds
	Ω_max                   = 6300000.0  # rad / sec
	Δ_start                 = -5 * Ω_max
	Δ_end                   = 5 * Ω_max
	
	Ω                       = TimeSeries()
	Ω[0.0]                  = 0.0
	Ω[time_ramp]            = Ω_max
	Ω[time_max - time_ramp] = Ω_max
	Ω[time_max]             = 0.0
	
	Δ                       = TimeSeries()
	Δ[0.0]                  = Δ_start
	Δ[time_ramp]            = Δ_start
	Δ[time_max - time_ramp] = Δ_end
	Δ[time_max]             = Δ_end
	
	ϕ           = TimeSeries()
	ϕ[0.0]      = 0.0
	ϕ[time_max] = 0.0
end

# ╔═╡ 3b6c8e8c-7114-4754-bf64-4949ce62b8b8
md"
## AHS program

We can assemble the defined register and Hamiltonian to an AHS program, as shown below. 
"

# ╔═╡ c63adffa-2d10-4e0a-8702-ea85cfc4b7ea
begin
	drive                   = DrivingField(Ω, ϕ, Δ)
	ahs_program             = AnalogHamiltonianSimulation(register, drive)
end

# ╔═╡ de36f5be-e8fe-4e6a-9cec-a0cae8ff0148
md"
## Running AHS program on the local simulator

Before submitting the AHS program to an AHS-compatible QPU, we can run it on the local AHS simulator which comes along with `PyBraket.jl`. 
"

# ╔═╡ ba9eb8dc-31ea-473f-aa44-870e4161924d
begin
	local_sim    = LocalSimulator("braket_ahs")
	local_result = result(run(local_sim, ahs_program, shots=1_000_000))
end

# ╔═╡ 4e1a8a8d-ef9a-4bea-8dac-00c1e39f26b4
md"
## Analyzing simulator results

We can aggregate the shot results with the following function that infers the state of each spin (which may be “d” for “down”, “u” for “up”, or “e” for empty site), and counts how many times each configuration occurred across the shots. 
"

# ╔═╡ 98eb475f-07a7-453c-8df4-4f3f3b0ffee2
"""
    get_counts(result)

Aggregates state counts from AHS shot results.
Strings of length = # of atoms are returned, where
each character denotes the state of an atom (site):
   e: empty site
   g: ground state atom
   r: Rydberg state atom

Returns an `Accumulator` containing the number of times each state configuration is measured.
"""
function get_counts(result::AnalogHamiltonianSimulationQuantumTaskResult)
    state_counts = Accumulator{String, Int}()
    states = ["e", "r", "g"]
    for shot in result.measurements
        pre       = convert(Vector{Int}, shot.pre_sequence)
        post      = convert(Vector{Int}, shot.post_sequence)
        state_idx = (pre .* (1 .+ post)) .+ 1
        state     = prod([states[s_idx] for s_idx in state_idx])
        inc!(state_counts, state)
    end
    return state_counts
end

# ╔═╡ 921cb466-6049-4897-ac35-f9a669596004
counts = get_counts(local_result)

# ╔═╡ 4b8fff35-40b4-4670-8df6-92a496c66676
md"
Here `counts` is a dictionary that counts the number of times each state configuration is observed across the shots. We can also visualize them with the following code.
"


# ╔═╡ 25e25003-873f-4d09-8df2-c723871a3c00
function has_neighboring_rydberg_states(state::String)
    occursin("rr", state) && return true
    first(state) == 'r' && state[end] == 'r' && return true
    return false
end

# ╔═╡ 6018b50e-ff73-435c-bf7c-fc1cf8eaaa3a
begin
	number_of_rydberg_states(state::String) = counter(state)['r']
	non_blockaded                           = []
	blockaded                               = []
	
	for (state, count) in counts
	    collection = has_neighboring_rydberg_states(state) ? blockaded : non_blockaded
	    push!(collection, (state, count, number_of_rydberg_states(state)))
	end
end

# ╔═╡ 9b89d73d-e257-40d6-bc11-f6ffc0ec9dcc
md"
We can print out the number of occurrence for the states that respect and violate the Rydberg blockade. Upon comparing the results below, we indeed see that the latter has much less chance to appear.
"


# ╔═╡ c72408bc-901d-47a9-9fdf-3be2aac424a0
begin
	println("non-blockaded states:")
	println(join(["#r", "state", "\tshot_count"], '\t'))
	for (state, count, _) in sort(non_blockaded, by=(x->first(x)), rev=true)
	    println(join([string(number_of_rydberg_states(state)), string(state), string(count)], '\t'))
	end
end

# ╔═╡ 60304f9b-0821-4ba6-a80a-dd5d35fecc71
begin
	println()
	println("blockaded states:")
	println(join(["#r", "state", "\tshot_count"], '\t'))
	for (state, count, _) in sort(blockaded, by=(x->first(x)), rev=true)
	    println(join([string(number_of_rydberg_states(state)), string(state), string(count)], '\t'))
	end
end

# ╔═╡ 8d9cbc4d-7bad-444a-8b06-744620ef119a
md"
We can further calculate other observables which quantify the state arrived. Below, we calculate
1. The marginal probabilities of each atom being in the Rydberg state, which are expected to be uniform because of the $D_8$ symmetry of the atom arrangement.
2. The Matthews correlation coefficient, which are expected to alternate between negative and positive values and tend to zero with increasing distance

The results below indeed confirm our expectations for the simulation results. 
"


# ╔═╡ 175d2e0f-582a-4dc2-95c1-25bf7e233b23
function marginals(counts)
    total_counts = sum(values(counts))
    atoms = fill(0, length(first(keys(counts))))
    for (state, count) in counts
        for (atom_idx, atom_state) in enumerate(state)
            atom_state == 'r' && (atoms[atom_idx] += count)
        end
    end
    return atoms ./ total_counts
end

# ╔═╡ c6e7bd83-1b88-454c-9684-1ae893a6684f
bar(1:length(register), marginals(counts), xlabel="atom index", ylabel="probability of\nRydberg state", ylim=[0, 1])

# ╔═╡ 490eb0e1-4d8e-47c1-9ce6-6c8aa43e72d6
# computing pairwise Matthews coefficient
function pairwise_matthews_phi(counts)
    # ref: https://en.wikipedia.org/wiki/Phi_coefficient
    atoms = length(first(keys(counts)))
    ϕs    = zeros(atoms, atoms)
    for j in 1:atoms, k in 1:atoms
        Ngg = 0
        Nrr = 0
        Nrg = 0
        Ngr = 0
        Ng_ = 0
        Nr_ = 0
        N_g = 0
        N_r = 0
        for (state, count) in counts
            state[j] == 'r' && (Nr_ += count)
            state[j] == 'g' && (Ng_ += count)
            state[k] == 'r' && (N_r += count)
            state[k] == 'g' && (N_g += count)
            (state[j] == 'r') && (state[k] == 'r') && (Nrr += count)
            (state[j] == 'r') && (state[k] == 'g') && (Nrg += count)
            (state[j] == 'g') && (state[k] == 'r') && (Ngr += count)
            (state[j] == 'g') && (state[k] == 'g') && (Ngg += count)
        end
        ϕ = (Nrr * Ngg - Nrg * Ngr) / √(Int128(Nr_) * Int128(Ng_) * Int128(N_r) * Int128(N_g))
        ϕs[j, k] = ϕ
    end
    return ϕs
end

# ╔═╡ bc250627-06ed-4380-aea0-250834192907
ϕs = pairwise_matthews_phi(counts)

# ╔═╡ 3d6d9440-2068-4c23-bd2e-3027473648fe
function correlation_function(ϕs)
    atoms    = size(ϕs, 1)
    ϕ_1d     = Float64[]
    distance = -div(atoms, 2):div(atoms, 2)
    for d in distance
        ϕ_d = zeros(Float64, atoms)
        for atom_idx in 0:atoms-1
            j = atom_idx + d < 0 ? mod(atom_idx+d+atoms, atoms) + 1 : mod(atom_idx+d, atoms) + 1
            ϕ_d[atom_idx+1] = ϕs[atom_idx+1, j]
        end
        push!(ϕ_1d, mean(ϕ_d))
    end
    return distance, ϕ_1d
end

# ╔═╡ b0d3f31c-52f6-4a24-9ebc-f9af151a23a9
distance, ϕ_1d = correlation_function(ϕs)

# ╔═╡ fbee7ea7-398c-4344-adb6-ecf9bf04d967
bar(distance, ϕ_1d, ylim=[-1.05, 1.05], xlabel="separation\n(in units of nearest neighbor distance)", ylabel="Matthews\ncorrelation coefficient")

# ╔═╡ 98b60cdb-639f-4e26-a9d4-ec3e009b810c
md"
## Running AHS program on QuEra's Aquila QPU

After we confirm that the AHS program produces the expected result, one could run the AHS program with larger registers (up to 256 atoms) on QuEra's Aquila QPU. Here, we choose to run the same AHS program with eight atoms for illustration purpose. 
"

# ╔═╡ 4b14e404-2ec9-4b34-b96d-31d5c1b9fb51
aquila_qpu   = AwsDevice("arn:aws:braket:us-east-1::device/qpu/quera/Aquila")

# ╔═╡ 41d51f88-2044-412f-ac49-d7c0f5639fe4
md"
Before submitting the program, we need to discretize the program so that it is suitable to run on Aquia. This is basically rounding all values to comply with the levels of precision allowed by the QPU.
"

# ╔═╡ 8ac55598-1c18-43aa-a439-208c7f1767f2
discretized_ahs_program = discretize(ahs_program, aquila_qpu)

# ╔═╡ f44b23d4-3f28-4fba-a050-fcf829e6ead3
md"
We are ready to submit the first AHS program to Aquila. After the result is returned from the QPU, one could analyze the result with the same method as shown above. 

Note: running the following cell will incur a cost of $0.01 per shot and $0.30 per task. Only uncomment the following cell if you are comfortable with the cost.
"

# ╔═╡ b27fad62-1062-482a-8e79-69ab84f4fbf9
# qpu_result = result(run(aquila_qpu, discretized_ahs_program, shots=100))

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
DataStructures = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
Plots = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"
Statistics = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"

[compat]
Braket = "~0.1.0"
DataStructures = "~0.18.13"
Plots = "~1.37.0"
PyBraket = "~0.1.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.8.2"
manifest_format = "2.0"
project_hash = "c837e636395cc458569faad3958f7fc171e4d04f"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "19ed52e8e3cc91a85c73c1bd514fd24a3e5bef06"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.78.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "e753f872313928ea3ecbc415ae99ab18c8de10bc"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.1.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "Tables", "Unicode", "WeakRefStrings"]
git-tree-sha1 = "873fb188a4b9d76549b81465b1f75c82aaf59238"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.4"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "e7ff6cadf743c098e08fca25c91103ee4303c9bb"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.6"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "ded953804d019afa9a3f98981d99b33e3db7b6da"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.0"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random", "SnoopPrecompile"]
git-tree-sha1 = "aa3edc8f8dea6cbfa176ee12f7c2fc82f0608ed3"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.20.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "d08c20eef1f2cbc6e60fd3612ac4340b89fea322"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.9"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "417b0ed7b8b838aa6ca0a87aadf1bb9eb111ce40"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.8"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "3ca828fe1b75fa84b021a7860bd039eaea84d2f2"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.3.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "0.5.2+0"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "341e3ce7ddd8d57dc7be27146bd1c072000d485a"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.14"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.DataAPI]]
git-tree-sha1 = "e08915633fcb3ea83bf9d6126292e5bc5c739922"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.13.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "c36550cb29cbe373e95b3f40486b9a4148f89ffd"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.2"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GR]]
deps = ["Artifacts", "Base64", "DelimitedFiles", "Downloads", "GR_jll", "HTTP", "JSON", "Libdl", "LinearAlgebra", "Pkg", "Preferences", "Printf", "Random", "Serialization", "Sockets", "TOML", "Tar", "Test", "UUIDs", "p7zip_jll"]
git-tree-sha1 = "051072ff2accc6e0e87b708ddee39b18aa04a0bc"
uuid = "28b8d3ca-fb5f-59d9-8090-bfdbd6d07a71"
version = "0.71.1"

[[deps.GR_jll]]
deps = ["Artifacts", "Bzip2_jll", "Cairo_jll", "FFMPEG_jll", "Fontconfig_jll", "GLFW_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Pixman_jll", "Pkg", "Qt5Base_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "501a4bf76fd679e7fcd678725d5072177392e756"
uuid = "d2c73de3-f751-5644-a686-071e5b155ba9"
version = "0.71.1+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "08ee34cdc529bd4e631f661595c2eb695515bdbc"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.1"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "fb83fbe02fe57f2c068013aa94bcdf6760d3a7a7"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+1"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "4abede886fcba15cd5fd041fef776b230d004cee"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.4.0"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "0cf92ec945125946352f3d46c96976ab972bde6f"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.3.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLFzf]]
deps = ["Pipe", "REPL", "Random", "fzf_jll"]
git-tree-sha1 = "f377670cda23b6b7c1c0b3893e37451c5c1a2185"
uuid = "1019f520-868f-41f5-a6de-eb00f4b6a39c"
version = "0.1.5"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "65edf3850efb9cb4ca3b0bf488e29c6c38a23d2d"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.11.1"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.Latexify]]
deps = ["Formatting", "InteractiveUtils", "LaTeXStrings", "MacroTools", "Markdown", "OrderedCollections", "Printf", "Requires"]
git-tree-sha1 = "ab9aa169d2160129beb241cb2750ca499b4e90e9"
uuid = "23fbe1c1-3f47-55db-b15f-69d7ec21a316"
version = "0.15.17"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "6f73d1dd803986947b2c750138528a999a6c7733"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.6.0+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "42b62845d70a619f063a7da093d995ec8e15e778"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+1"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "Pkg", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "3eb79b0ca5764d4799c06699573fd8f533259713"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.4.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "946607f84feb96220f480e0422d3484c49c00239"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.19"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "5d4d2d9904227b8bd66386c1138cf4d5ffa826bf"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "0.4.9"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch"]
git-tree-sha1 = "b49f11c4f9272fcbd66816ab8c3128d39982966c"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.9"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "bf210ce90b6c9eed32d25dbcae1ebc565df2687f"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.0.2"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["ExprTools"]
git-tree-sha1 = "748f6e1e4de814b101911e64cc12d83a6af66782"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.2"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.2.1"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "17eeb975b00de066fb343aa8d56884f51d4a651c"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.1"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.20+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "df6830e37943c7aaa10023471ca47fb3065cc3c4"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.2"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.40.0+0"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "b64719e8b4504983c7fca6cc9db3ebc8acc2a4d6"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.1"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pipe]]
git-tree-sha1 = "6842804e7867b115ca9de748a0cf6b364523c16d"
uuid = "b98c9c47-44ae-5843-9183-064241ee97a0"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.8.0"

[[deps.PlotThemes]]
deps = ["PlotUtils", "Statistics"]
git-tree-sha1 = "1f03a2d339f42dca4a4da149c7e15e9b896ad899"
uuid = "ccf2f8ad-2431-5c83-bf29-c5338b663b6a"
version = "3.1.0"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "5b7690dd212e026bbab1860016a6601cb077ab66"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.2"

[[deps.Plots]]
deps = ["Base64", "Contour", "Dates", "Downloads", "FFMPEG", "FixedPointNumbers", "GR", "JLFzf", "JSON", "LaTeXStrings", "Latexify", "LinearAlgebra", "Measures", "NaNMath", "Pkg", "PlotThemes", "PlotUtils", "Preferences", "Printf", "REPL", "Random", "RecipesBase", "RecipesPipeline", "Reexport", "RelocatableFolders", "Requires", "Scratch", "Showoff", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "UUIDs", "UnicodeFun", "Unzip"]
git-tree-sha1 = "7c5d624a2cb080c2bf41dc5da8fbb837c427048a"
uuid = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
version = "1.37.0"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PyBraket]]
deps = ["AWS", "Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "MicroMamba", "PythonCall", "StructTypes"]
git-tree-sha1 = "362553bc151177fbcbf71efe9e13221ba34d73b9"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.1.0"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "10b3f7d8e91b55754f6e614496104cc74ebd49fb"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.7"

[[deps.Qt5Base_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Fontconfig_jll", "Glib_jll", "JLLWrappers", "Libdl", "Libglvnd_jll", "OpenSSL_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libxcb_jll", "Xorg_xcb_util_image_jll", "Xorg_xcb_util_keysyms_jll", "Xorg_xcb_util_renderutil_jll", "Xorg_xcb_util_wm_jll", "Zlib_jll", "xkbcommon_jll"]
git-tree-sha1 = "0c03844e2231e12fda4d0086fd7cbe4098ee8dc5"
uuid = "ea2cea3b-5b76-57ae-a6ef-0a8af62496e1"
version = "5.15.3+2"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "18c35ed630d7229c5584b945641a73ca83fb5213"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.2"

[[deps.RecipesPipeline]]
deps = ["Dates", "NaNMath", "PlotUtils", "RecipesBase", "SnoopPrecompile"]
git-tree-sha1 = "e974477be88cb5e3040009f3767611bc6357846f"
uuid = "01d81517-befc-4cb6-b9ec-a95719d0359c"
version = "0.6.11"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "efd23b378ea5f2db53a55ae53d3133de4e080aa9"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.16"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SnoopPrecompile]]
git-tree-sha1 = "f604441450a3c0569830946e5b33b78c928e1a85"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.1"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "a4ada03f999bd01b3a25dcaa30b2d929fe537e00"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.1.0"

[[deps.SparseArrays]]
deps = ["LinearAlgebra", "Random"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "ffc098086f35909741f71ce21d03dadf0d2bfa76"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.11"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.0"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.1"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "e4bdc63f5c6d62e80eb1c0043fcc0360d5950ff7"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.10"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.Unzip]]
git-tree-sha1 = "ca0969166a028236229f63514992fc073799bb78"
uuid = "41fe7b60-77ed-43a1-b4f0-825fd5a5650d"
version = "0.2.0"

[[deps.Wayland_jll]]
deps = ["Artifacts", "Expat_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "3e61f0b86f90dacb0bc0e73a0c5a83f6a8636e23"
uuid = "a2964d1f-97da-50d4-b82a-358c7fce9d89"
version = "1.19.0+0"

[[deps.Wayland_protocols_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4528479aa01ee1b3b4cd0e6faef0e04cf16466da"
uuid = "2381bf8a-dfd0-557d-9999-79630e7b1b91"
version = "1.25.0+0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "58443b63fb7e465a8a7210828c91c08b92132dff"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.9.14+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_libxkbfile_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "926af861744212db0eb001d9e40b5d16292080b2"
uuid = "cc61e674-0454-545c-8b26-ed2c68acab7a"
version = "1.1.0+4"

[[deps.Xorg_xcb_util_image_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "0fab0a40349ba1cba2c1da699243396ff8e94b97"
uuid = "12413925-8142-5f55-bb0e-6d7ca50bb09b"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll"]
git-tree-sha1 = "e7fd7b2881fa2eaa72717420894d3938177862d1"
uuid = "2def613f-5ad1-5310-b15b-b15d46f528f5"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_keysyms_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "d1151e2c45a544f32441a567d1690e701ec89b00"
uuid = "975044d2-76e6-5fbe-bf08-97ce7c6574c7"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_renderutil_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "dfd7a8f38d4613b6a575253b3174dd991ca6183e"
uuid = "0d47668e-0667-5a69-a72c-f761630bfb7e"
version = "0.3.9+1"

[[deps.Xorg_xcb_util_wm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "e78d10aab01a4a154142c5006ed44fd9e8e31b67"
uuid = "c22f9ab0-d5fe-5066-847c-f4bb1cd4e361"
version = "0.4.1+1"

[[deps.Xorg_xkbcomp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxkbfile_jll"]
git-tree-sha1 = "4bcbf660f6c2e714f87e960a171b119d06ee163b"
uuid = "35661453-b289-5fab-8a00-3d9160c6a3a4"
version = "1.4.2+4"

[[deps.Xorg_xkeyboard_config_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xkbcomp_jll"]
git-tree-sha1 = "5c8424f8a67c3f2209646d4425f3d415fee5931d"
uuid = "33bec58e-1273-512f-9401-5d533626f822"
version = "2.27.0+4"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.12+3"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e45044cd873ded54b6a5bac0eb5c971392cf1927"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.2+0"

[[deps.fzf_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "868e669ccb12ba16eaf50cb2957ee2ff61261c56"
uuid = "214eeab7-80f7-51ab-84ad-2988db7cef09"
version = "0.29.0+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl", "OpenBLAS_jll"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.1.1+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"

[[deps.xkbcommon_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Wayland_jll", "Wayland_protocols_jll", "Xorg_libxcb_jll", "Xorg_xkeyboard_config_jll"]
git-tree-sha1 = "9ebfc140cc56e8c2156a15ceac2f0302e327ac0a"
uuid = "d8fb68d0-12a3-5cfd-a85a-d49703b185fd"
version = "1.4.1+0"
"""

# ╔═╡ Cell order:
# ╟─1a35d23d-2eb0-45a5-b7a6-bbd73e3e7552
# ╠═b7719166-12c4-47a6-b501-7bacd7662dd0
# ╠═dd486f0e-cc45-41b7-b7db-42ad83121194
# ╠═c8e43644-4faf-4ea2-96f4-796451f04db0
# ╟─9e2fcfb3-8d7d-4757-8bfe-8db98c36e409
# ╠═388585cc-4417-11ed-3e99-af78d6112c38
# ╟─062c38f4-07d9-4a3c-ab88-590afb00ae74
# ╠═dbd73541-e918-48e2-b590-c07f44e3e711
# ╟─3b6c8e8c-7114-4754-bf64-4949ce62b8b8
# ╠═c63adffa-2d10-4e0a-8702-ea85cfc4b7ea
# ╟─de36f5be-e8fe-4e6a-9cec-a0cae8ff0148
# ╠═ba9eb8dc-31ea-473f-aa44-870e4161924d
# ╟─4e1a8a8d-ef9a-4bea-8dac-00c1e39f26b4
# ╠═98eb475f-07a7-453c-8df4-4f3f3b0ffee2
# ╠═921cb466-6049-4897-ac35-f9a669596004
# ╟─4b8fff35-40b4-4670-8df6-92a496c66676
# ╠═25e25003-873f-4d09-8df2-c723871a3c00
# ╠═6018b50e-ff73-435c-bf7c-fc1cf8eaaa3a
# ╟─9b89d73d-e257-40d6-bc11-f6ffc0ec9dcc
# ╠═c72408bc-901d-47a9-9fdf-3be2aac424a0
# ╠═60304f9b-0821-4ba6-a80a-dd5d35fecc71
# ╟─8d9cbc4d-7bad-444a-8b06-744620ef119a
# ╠═175d2e0f-582a-4dc2-95c1-25bf7e233b23
# ╠═c6e7bd83-1b88-454c-9684-1ae893a6684f
# ╠═490eb0e1-4d8e-47c1-9ce6-6c8aa43e72d6
# ╠═bc250627-06ed-4380-aea0-250834192907
# ╠═3d6d9440-2068-4c23-bd2e-3027473648fe
# ╠═b0d3f31c-52f6-4a24-9ebc-f9af151a23a9
# ╠═fbee7ea7-398c-4344-adb6-ecf9bf04d967
# ╟─98b60cdb-639f-4e26-a9d4-ec3e009b810c
# ╠═4b14e404-2ec9-4b34-b96d-31d5c1b9fb51
# ╠═41d51f88-2044-412f-ac49-d7c0f5639fe4
# ╠═8ac55598-1c18-43aa-a439-208c7f1767f2
# ╟─f44b23d4-3f28-4fba-a050-fcf829e6ead3
# ╠═b27fad62-1062-482a-8e79-69ab84f4fbf9
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

using Braket, JSON3, Test

@testset "PhotonicQuantumTaskResult" begin
    task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 100, "arn1", nothing, nothing, nothing, nothing, nothing)
    xanadu_metadata = Braket.XanaduMetadata(Braket.header_dict[Braket.XanaduMetadata], "DECLARE ro BIT[2];")
    blackbird_program = Braket.BlackbirdProgram(Braket.header_dict[Braket.BlackbirdProgram], "Vac | q[0]")
    additional_metadata = Braket.AdditionalMetadata(blackbird_program, nothing, nothing, nothing, nothing, nothing, xanadu_metadata, nothing, nothing)
    measurements = [[[1, 2, 3, 4]], [[4, 3, 2, 1]], [[0, 0, 0, 0]]]
    function result_1()
        Braket.PhotonicModelTaskResult(Braket.header_dict[Braket.PhotonicModelTaskResult], measurements, task_metadata, additional_metadata)
    end
    result = Braket.format_result(Braket.parse_raw_schema(JSON3.write(result_1())))
    @test result.task_metadata == task_metadata
    @test result.additional_metadata == additional_metadata
    @test result.measurements == measurements
    @test sprint(show, result) == "PhotonicModelQuantumTaskResult\n"
    result = Braket.PhotonicModelQuantumTaskResult(task_metadata, additional_metadata, nothing)
    @test JSON3.read("""{"task_metadata": $(JSON3.write(task_metadata)), "additional_metadata": $(JSON3.write(additional_metadata))}""", Braket.PhotonicModelQuantumTaskResult) == result
end

module PySchema

include("py_type_conversion.jl")
import Braket: OneQubitProperties, TwoQubitProperties, CoherenceTime, FidelityType, Geometry, AnalogHamiltonianSimulationShotResult, DeviceActionProperties, Direction, DeviceActionType, BraketSchemaBase, PersistedJobDataFormat, DeviceDocumentation, TaskMetadata, AnalogHamiltonianSimulationTaskResult, DeviceConnectivity, Rydberg, RydbergGlobal, AnalogHamiltonianSimulationShotMeasurement, QueraAhsParadigmProperties, Lattice, PersistedJobData, Area, ResultType, ResultFormat, AnalogHamiltonianSimulationShotMetadata, braketSchemaHeader, AbstractProgram
import Braket.IR: Setup, PhysicalField

const analog_hamiltonian_simulation_task_result_v1 = PythonCall.pynew()
const device_execution_window = PythonCall.pynew()
const shifting_field = PythonCall.pynew()
const atom_arrangement = PythonCall.pynew()
const analog_hamiltonian_simulation_task_result_v1 = PythonCall.pynew()
const driving_field = PythonCall.pynew()
const device_action_properties = PythonCall.pynew()
const schema_base = PythonCall.pynew()
const persisted_job_data_v1 = PythonCall.pynew()
const time_series = PythonCall.pynew()
const task_metadata_v1 = PythonCall.pynew()
const physical_field = PythonCall.pynew()
const result_type = PythonCall.pynew()
const hamiltonian = PythonCall.pynew()
const shared_models = PythonCall.pynew()
const schema_header = PythonCall.pynew()
const program_v1 = PythonCall.pynew()

function jl_convert(::Type{AbstractProgram}, x::Py)
    T = Braket.lookup_type(pyconvert(braketSchemaHeader, pygetattr(x, "braketSchemaHeader")))
    return PythonCall.pyconvert_return(pyconvert(T, x))
end

function __init__()
    PythonCall.pycopy!(shifting_field, pyimport("braket.ir.ahs.shifting_field"))
    PythonCall.pycopy!(atom_arrangement, pyimport("braket.ir.ahs.atom_arrangement"))
    PythonCall.pycopy!(analog_hamiltonian_simulation_task_result_v1, pyimport("braket.task_result.analog_hamiltonian_simulation_task_result_v1"))
    PythonCall.pycopy!(driving_field, pyimport("braket.ir.ahs.driving_field"))
    PythonCall.pycopy!(device_action_properties, pyimport("braket.device_schema.device_action_properties"))
    PythonCall.pycopy!(schema_base, pyimport("braket.schema_common.schema_base"))
    PythonCall.pycopy!(persisted_job_data_v1, pyimport("braket.jobs_data.persisted_job_data_v1"))
    PythonCall.pycopy!(time_series, pyimport("braket.ir.ahs.time_series"))
    PythonCall.pycopy!(program_v1, pyimport("braket.ir.ahs.program_v1"))
    PythonCall.pycopy!(task_metadata_v1, pyimport("braket.task_result.task_metadata_v1"))
    PythonCall.pycopy!(physical_field, pyimport("braket.ir.ahs.physical_field"))
    PythonCall.pycopy!(hamiltonian, pyimport("braket.ir.ahs.hamiltonian"))
    PythonCall.pycopy!(shared_models, pyimport("braket.ir.jaqcd.shared_models"))
    PythonCall.pycopy!(schema_header, pyimport("braket.schema_common.schema_header"))
    PythonCall.pyconvert_add_rule("braket.ir.ahs.shifting_field:ShiftingField", ShiftingField, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.atom_arrangement:AtomArrangement", AtomArrangement, jl_convert)
    PythonCall.pyconvert_add_rule("braket.task_result.analog_hamiltonian_simulation_task_result_v1:AnalogHamiltonianSimulationShotResult", AnalogHamiltonianSimulationShotResult, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.driving_field:DrivingField", DrivingField, jl_convert)
    PythonCall.pyconvert_add_rule("braket.device_schema.device_action_properties:DeviceActionType", DeviceActionType, jl_convert)
    PythonCall.pyconvert_add_rule("braket.schema_common.schema_base:BraketSchemaBase", BraketSchemaBase, jl_convert)
    PythonCall.pyconvert_add_rule("braket.jobs_data.persisted_job_data_v1:PersistedJobDataFormat", PersistedJobDataFormat, jl_convert)
    PythonCall.pyconvert_add_rule("braket.device_schema.device_service_properties_v1:DeviceDocumentation", DeviceDocumentation, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.time_series:TimeSeries", TimeSeries, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.program_v1:AHSProgram", AHSProgram, jl_convert)
    PythonCall.pyconvert_add_rule("braket.task_result.task_metadata_v1:TaskMetadata", TaskMetadata, jl_convert)
    PythonCall.pyconvert_add_rule("braket.task_result.analog_hamiltonian_simulation_task_result_v1:AnalogHamiltonianSimulationTaskResult", AnalogHamiltonianSimulationTaskResult, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.program_v1:Setup", Setup, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.physical_field:PhysicalField", PhysicalField, jl_convert)
    PythonCall.pyconvert_add_rule("braket.task_result.analog_hamiltonian_simulation_task_result_v1:AnalogHamiltonianSimulationShotMeasurement", AnalogHamiltonianSimulationShotMeasurement, jl_convert)
    PythonCall.pyconvert_add_rule("braket.jobs_data.persisted_job_data_v1:PersistedJobData", PersistedJobData, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.hamiltonian:Hamiltonian", Hamiltonian, jl_convert)
    PythonCall.pyconvert_add_rule("braket.task_result.analog_hamiltonian_simulation_task_result_v1:AnalogHamiltonianSimulationShotMetadata", AnalogHamiltonianSimulationShotMetadata, jl_convert)
    PythonCall.pyconvert_add_rule("braket.schema_common.schema_header:BraketSchemaHeader", braketSchemaHeader, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.program_v1:AHSProgram", AbstractProgram, jl_convert)
    PythonCall.pyconvert_add_rule("braket.ir.ahs.program_v1:Program", AbstractProgram, jl_convert)
end

end #module

using Test, Braket

@testset "Ionq Device Schema" begin
    @testset "Device capabilities" begin
        jaqcd() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.ionq.ionq_device_capabilities",
                "version": "1"
            },
            "service": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.device_service_properties",
                    "version": "1"
                },
                "executionWindows": [
                    {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                ],
                "shotsRange": [1, 10],
                "deviceCost": {"price": 0.25, "unit": "minute"},
                "deviceDocumentation": {
                    "imageUrl": "image_url",
                    "summary": "Summary on the device",
                    "externalDocumentationUrl": "exter doc link"
                },
                "deviceLocation": "us-east-1",
                "updatedAt": "2020-06-16T19:28:02.869136"
            },
            "action": {
                "braket.ir.jaqcd.program": {
                    "actionType": "braket.ir.jaqcd.program",
                    "version": ["1"],
                    "supportedOperations": ["x", "y"],
                    "supportedResultTypes": [
                        {
                            "name": "resultType1",
                            "observables": ["observable1"],
                            "minShots": 2,
                            "maxShots": 4
                        }
                    ]
                }
            },
            "paradigm": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                    "version": "1"
                },
                "qubitCount": 11,
                "nativeGateSet": ["ccnot", "cy"],
                "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
            },
            "deviceParameters": {}
        }"""

        openqasm() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.ionq.ionq_device_capabilities",
                "version": "1"
            },
            "service": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.device_service_properties",
                    "version": "1"
                },
                "executionWindows": [
                    {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                ],
                "shotsRange": [1, 10],
                "deviceCost": {"price": 0.25, "unit": "minute"},
                "deviceDocumentation": {
                    "imageUrl": "image_url",
                    "summary": "Summary on the device",
                    "externalDocumentationUrl": "exter doc link"
                },
                "deviceLocation": "us-east-1",
                "updatedAt": "2020-06-16T19:28:02.869136"
            },
            "action": {
                "braket.ir.openqasm.program": {
                    "actionType": "braket.ir.openqasm.program",
                    "version": ["1"],
                    "supportedOperations": ["x", "y"],
                    "supportedResultTypes": [
                        {
                            "name": "resultType1",
                            "observables": ["observable1"],
                            "minShots": 2,
                            "maxShots": 4
                        }
                    ],
                    "supportPhysicalQubits": false,
                    "supportedPragmas": ["braket_noise_bit_flip"],
                    "forbiddenPragmas": ["braket_unitary_matrix"],
                    "forbiddenArrayOperations": ["concatenation", "range", "slicing"],
                    "requiresAllQubitsMeasurement": false,
                    "requiresContiguousQubitIndices": false,
                    "supportsPartialVerbatimBox": false,
                    "supportsUnassignedMeasurements": false
                }
            },
            "paradigm": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                    "version": "1"
                },
                "qubitCount": 11,
                "nativeGateSet": ["ccnot", "cy"],
                "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
            },
            "deviceParameters": {}
        }
        """
        @testset for format in [openqasm, jaqcd]
            @test Braket.parse_raw_schema(format()) isa Braket.IonqDeviceCapabilities
        end
    end
    @testset "Device parameters" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.ionq.ionq_device_parameters",
                "version": "1"
            },
            "paradigmParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.gate_model_parameters",
                    "version": "1"
                },
                "qubitCount": 1
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.IonqDeviceParameters 
    end
    @testset "Provider properties" begin
        ir_gen() = """
        {
            "braketSchemaHeader": {
                "name": "braket.device_schema.ionq.ionq_provider_properties",
                "version": "1"
            },
            "fidelity": {"1Q": {"mean": 0.99717}, "2Q": {"mean": 0.9696}, "spam": {"mean": 0.9961}},
            "timing": {
                "T1": 10000000000,
                "T2": 500000,
                "1Q": 1.1e-05,
                "2Q": 0.00021,
                "readout": 0.000175,
                "reset": 3.5e-05
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.IonqProviderProperties
    end
end

"""
    LocalQuantumTask(id::String, result::Union{GateModelQuantumTaskResult, AnalogHamiltonianSimulationQuantumTaskResult})

A quantum task which has been run *locally* using a [`LocalSimulator`](@ref).
The `state` of a `LocalQuantumTask` is always `"COMPLETED"` as the task object
is only created once the loca simulation has finished.
"""
struct LocalQuantumTask
    id::String
    result::Union{GateModelQuantumTaskResult, AnalogHamiltonianSimulationQuantumTaskResult}
end
state(b::LocalQuantumTask)  = "COMPLETED"
id(b::LocalQuantumTask)     = b.id
result(b::LocalQuantumTask) = b.result

"""
    LocalQuantumTaskBatch(ids::Vector{String}, results::Vector{GateModelQuantumTaskResult})

A *batch* of quantum tasks which has been run *locally* using a
[`LocalSimulator`](@ref). 
"""
struct LocalQuantumTaskBatch
    ids::Vector{String}
    results::Vector{GateModelQuantumTaskResult}
end
results(lqtb::LocalQuantumTaskBatch) = lqtb.results

"""
    LocalSimulator(backend::Union{String, AbstractBraketSimulator})

A quantum simulator which runs *locally* rather than sending the circuit(s)
to the cloud to be executed on-demand. A `LocalSimulator` must be created with
a backend -- either a handle, in the form of a `String`, which uniquely identifies
a simulator backend registered in [`_simulator_devices`](@ref Braket._simulator_devices), or an already instantiated
simulator object.

`LocalSimulator`s should implement their own method for [`simulate`](@ref) if needed. They
can process single tasks or task batches.
"""
struct LocalSimulator <: Device
    backend::String
    _delegate
    function LocalSimulator(backend)
        backend_name = device_id(backend)
        haskey(_simulator_devices[], backend_name) && return new(backend_name, _simulator_devices[][backend_name](0,0))
        !isdefined(Main, Symbol(backend_name)) && throw(ArgumentError("no local simulator with name $backend_name is loaded!"))
        return new(backend_name, Symbol(backend_name)(0, 0))
    end
end
name(s::LocalSimulator) = name(s._delegate)
device_id(s::String) = s

"""
    simulate(d::LocalSimulator, task_spec::Union{Circuit, AbstractProgram}, args...; shots::Int=0, inputs::Dict{String, Float64} = Dict{String, Float64}(), kwargs...)

Simulate the execution of `task_spec` using the backend of [`LocalSimulator](@ref) `d`.
`args` are additional arguments to be provided to the backend. `inputs` is used to set
the value of any [`FreeParameter`](@ref) in `task_spec` and will override the existing
`inputs` field of an `OpenQasmProgram`. Other `kwargs` will be passed to the backend
simulator. Returns a [`LocalQuantumTask`](@ref Braket.LocalQuantumTask).
"""
function simulate(d::LocalSimulator, task_spec::Union{Circuit, AnalogHamiltonianSimulation, AbstractProgram}, args...; shots::Int=0, inputs::Dict{String, Float64} = Dict{String, Float64}(), kwargs...)
    sim = d._delegate
    local_result = _run_internal(sim, task_spec, args...; inputs=inputs, shots=shots, kwargs...)
    return LocalQuantumTask(local_result.task_metadata.id, local_result)
end

"""
    simulate(d::LocalSimulator, task_specs::Vector{T}, args...; kwargs...) where {T}

Simulate the execution of a *batch* of tasks specified by `task_specs`
using the backend of [`LocalSimulator](@ref) `d`.
`args` are additional arguments to be provided to the backend.

`kwargs` used by the `LocalSimulator` are:
  - `shots::Int` - the number of shots to run for all tasks in `task_specs`. Default is `0`.
  - `max_parallel::Int` - the maximum number of simulations to execute simultaneously. Default is `32`.
  - `inputs::Union{Vector{Dict{String, Float64}}, Dict{String, Float64}}` - used to set
    the value of any [`FreeParameter`](@ref) in each task specification. It must either be a
    `Dict` or a single-element `Vector` (in which case the same parameter values are used for
    all elements of `task_specs` *or* of the same length as `task_specs` (in which case the `i`-th 
    specification is paired with the `i`-th input dictionary). Default is an empty dictionary. 

Other `kwargs` are passed through to the backend simulator. Returns a [`LocalQuantumTaskBatch`](@ref Braket.LocalQuantumTaskBatch).

!!! note
    Because Julia uses dynamic threading and `Task`s can migrate between threads, each simulation is a `Task`
    which itself can spawn many more `Task`s, as the internal implementation of [`LocalSimulator`](@ref)'s backend
    may use threading where appropriate. On systems with many CPU cores, spawning too many `Task`s may overwhelm
    the Julia scheduler and degrade performance. "Too many" depends on the particulars of your hardware, so on
    many-core systems you may need to tune this value for best performance.
"""
function simulate(d::LocalSimulator, task_specs::Vector{T}, args...; shots::Int=0, max_parallel::Int=-1, inputs::Union{Vector{Dict{String, Float64}}, Dict{String, Float64}} = Dict{String, Float64}(), kwargs...) where {T}
    is_single_task  = length(task_specs) == 1
    is_single_input = inputs isa Dict{String, Float64} || length(inputs) == 1
    if is_single_input
        if is_single_task
            inputs = inputs isa Vector ? first(inputs) : inputs
            local_task = d(task_specs[1], args...; shots=shots, inputs=inputs, kwargs...)
            return LocalQuantumTaskBatch([local_task.result.task_metadata.id], [local_task.result])
        elseif inputs isa Dict{String, Float64}
            inputs = [deepcopy(inputs) for ix in 1:length(task_specs)]
        else
            inputs = [deepcopy(inputs[1]) for ix in 1:length(task_specs)]
        end
    end
    !is_single_task && !is_single_input && length(task_specs) != length(inputs) && throw(ArgumentError("number of inputs ($(length(inputs))) and task specifications ($(length(task_specs))) must be equal."))
    tasks_and_inputs = zip(1:length(task_specs), task_specs, inputs)
    # is this actually faster?
    todo_tasks_ch = Channel(length(tasks_and_inputs))
    for (ix, spec, input) in tasks_and_inputs
        if spec isa Circuit
            param_names = Set(string(param.name) for param in spec.parameters)
            unbounded_params = setdiff(param_names, collect(keys(input)))
            !isempty(unbounded_params) && throw(ErrorException("cannot execute circuit with unbound parameters $unbounded_params."))
        end
        put!(todo_tasks_ch, (ix, spec, input))
    end
    @debug "batch size is $(length(task_specs)). Starting run..."
    n_task_threads = 32
    stats = @timed begin
	    done_tasks_ch = Channel(length(tasks_and_inputs)) do ch
		function task_processor(input_tup)
		    ix, spec, input = input_tup
		    sim = copy(d._delegate)
		    res = _run_internal(sim, spec, args...; inputs=input, shots=shots, kwargs...)
		    put!(ch, (ix, res))
		end
		Threads.foreach(task_processor, todo_tasks_ch, ntasks=n_task_threads)
	    end
	    r_ix = 1
	    results = Vector{GateModelQuantumTaskResult}(undef, length(task_specs))
	    while r_ix <= length(task_specs)
            ix, res = take!(done_tasks_ch)
            results[ix] = res
            r_ix += 1
	    end
    end
    @debug "batch size is $(length(task_specs)). Time to run internally: $(stats.time). GC time: $(stats.gctime)."
    return LocalQuantumTaskBatch([local_result.task_metadata.id for local_result in results], results)
end
(d::LocalSimulator)(args...; kwargs...) = simulate(d, args...; kwargs...)

function _run_internal(simulator, circuit::Circuit, args...; shots::Int=0, inputs::Dict{String, Float64}=Dict{String, Float64}(), kwargs...)
    if haskey(properties(simulator).action, "braket.ir.openqasm.program")
        validate_circuit_and_shots(circuit, shots)
        program      = ir(circuit, Val(:OpenQASM))
        full_inputs  = isnothing(program.inputs) ? inputs : merge(program.inputs, inputs)
        full_program = OpenQasmProgram(program.braketSchemaHeader, program.source, full_inputs) 
        r            = simulate(simulator, full_program, shots; kwargs...)
        return format_result(r) 
    elseif haskey(properties(simulator).action, "braket.ir.jaqcd.program")
        validate_circuit_and_shots(circuit, shots)
        program = ir(circuit, Val(:JAQCD))
        qubits  = qubit_count(circuit)
        r       = simulate(simulator, program, qubits, shots; inputs=inputs, kwargs...)
        return format_result(r)
    else
        throw(ErrorException("$(typeof(simulator)) does not support qubit gate-based programs."))
    end
end
function _run_internal(simulator, program::OpenQasmProgram, args...; shots::Int=0, inputs::Dict{String, Float64}=Dict{String, Float64}(), kwargs...)
    if haskey(properties(simulator).action, "braket.ir.openqasm.program")
        r = simulate(simulator, program, shots; inputs=inputs, kwargs...)
        return format_result(r)
    else
        throw(ErrorException("$(typeof(simulator)) does not support qubit gate-based programs."))
    end
end
function _run_internal(simulator, program::Program, args...; shots::Int=0, inputs::Dict{String, Float64}=Dict{String, Float64}(), kwargs...)
    if haskey(properties(simulator).action, "braket.ir.jaqcd.program")
        qubits  = qubit_count(program)
        r = simulate(simulator, program, qubits, shots; inputs=inputs, kwargs...)
        return format_result(r)
    else
        throw(ErrorException("$(typeof(simulator)) does not support qubit gate-based programs."))
    end
end

using AWS, AWSS3, Braket, JSON3, Test

struct MyStruct
    attribute::String
end
MyStruct() = MyStruct("value")
Base.show(io::IO, s::MyStruct) = print(io, "MyStruct($(s.attribute))")

@testset "Job creation macro" begin
    @testset "Local" for local_mode ∈ (true, false)
        function my_job_func(a, b::Int; c=0, d::Float64=1.0, kwargs...)
            Braket.save_job_result(job_helper())
            py_reqs = read(joinpath(Braket.get_input_data_dir(), "requirements.txt"), String)
            @assert occursin("pytest", py_reqs)
            @assert a.attribute == "value"
            @assert b == 2
            @assert c == 0
            @assert d == 5
            @assert kwargs[:extra_kwarg] == "extra_value"
            # ensure using LinearAlgebra worked
            @assert size(triu(rand(2,2))) == (2,2)

            hyperparameters = Braket.get_hyperparameters()
            @assert isempty(hyperparameters)
            write("test/output_file.txt", "hello")
            return 0
        end

        py_deps = joinpath(@__DIR__, "requirements.txt")
        jl_deps = joinpath(@__DIR__, "JobProject.toml")
        input_data = joinpath(@__DIR__, "requirements")
        include_jl_files = joinpath(@__DIR__, "job_test_script.jl")
        j = @hybrid_job Braket.SV1() wait_until_complete=true as_local=local_mode include_modules="job_test_script" using_jl_pkgs="LinearAlgebra" include_jl_files=include_jl_files py_dependencies=py_deps jl_dependencies=jl_deps input_data=input_data my_job_func(MyStruct(), 2, d=5.0, extra_kwarg="extra_value")
        logs(j)
        @test_broken result(j)["status"] == "SUCCESS"
        try
            j_res = download_result(j)
            @test isdir(name(j))
            cd(name(j)) do
                res_str = read(joinpath("test", "output_file.txt"), String)
                @test res_str == "hello"
                @test ispath("results.json")
                @test ispath("test")
                @test_broken ispath(joinpath("test", "integ_tests"))
            end
         finally
            rm(name(j), recursive=true)
         end
     end
end

using Braket, Braket.IR, Test, JSON3, StructTypes

@testset "Schemas" begin
    @testset "NativeQuilMetadata" begin
        nqm = Braket.NativeQuilMetadata([32, 21], 5, 6, 1, 300.1, 0.8989, 191.21, 0)
        read_result = JSON3.read(JSON3.write(nqm), Braket.NativeQuilMetadata)
        for fn in fieldnames(Braket.NativeQuilMetadata)
            @test getproperty(read_result, fn) == getproperty(nqm, fn)
        end
    end

    @testset "Braket Schema Base headers" begin
        @testset for T in values(StructTypes.subtypes(Braket.BraketSchemaBase))
            @test StructTypes.defaults(T)[:braketSchemaHeader] == Braket.header_dict[T]
        end
    end

    @testset "AbstractProgram bad construction" begin
        @test_throws ErrorException StructTypes.constructfrom(Braket.AbstractProgram, Dict(:braketSchemaHeader=>Dict(:name=>"not_a_program")))
    end

    @testset "Reading and writing JAQCD instructions" begin
        for T in (IR.I, IR.X, IR.Y, IR.Z, IR.H, IR.S, IR.Si, IR.V, IR.Vi, IR.T, IR.Ti)
            targ = 0
            raw_str = """{"target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.Rx, IR.Ry, IR.Rz, IR.PhaseShift)
            targ = 0
            angle = rand()
            raw_str = """{"target": $targ, "angle": $angle}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.angle == angle
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.CNot, IR.CY, IR.CZ, IR.CV)
            targ = 0
            ctrl = 1
            raw_str = """{"control": $ctrl, "target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.control == ctrl
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.CPhaseShift, IR.CPhaseShift00, IR.CPhaseShift10, IR.CPhaseShift01)
            targ = 0
            ctrl = 1
            angle = rand()
            raw_str = """{"control": $ctrl, "target": $targ, "angle": $angle}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.control == ctrl
            @test read_T.angle == angle
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.Swap, IR.ISwap, IR.ECR)
            targs = [0, 1]
            raw_str = """{"targets": $targs}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.XX, IR.XY, IR.YY, IR.ZZ, IR.PSwap)
            targs = [0, 1]
            angle = rand()
            raw_str = """{"targets": $targs, "angle": $angle}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test read_T.angle == angle
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.CSwap,)
            targs = [0, 1]
            ctrl = 2
            raw_str = """{"targets": $targs, "control": $ctrl}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test read_T.control == ctrl
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.CCNot,)
            ctrls = [0, 1]
            targ = 2
            raw_str = """{"target": $targ, "controls": $ctrls}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.controls == ctrls
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.Expectation, IR.Sample, IR.Variance)
            targs = [0, 1]
            obs = ["h"]
            raw_str = """{"targets": $targs, "observable": $obs}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test read_T.observable == obs
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.Probability, IR.DensityMatrix)
            targs = [0, 1]
            raw_str = """{"targets": $targs}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.StateVector,)
            raw_str = """{}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.GeneralizedAmplitudeDamping,)
            prob  = rand()
            gamma = rand()
            targ  = 0
            raw_str = """{"probability": $prob, "gamma": $gamma, "target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.probability == prob
            @test read_T.gamma == gamma
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.PhaseDamping, IR.AmplitudeDamping)
            gamma = rand()
            targ  = 0
            raw_str = """{"gamma": $gamma, "target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.gamma == gamma
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.BitFlip, IR.PhaseFlip, IR.Depolarizing)
            prob  = rand()
            targ  = 0
            raw_str = """{"probability": $prob, "target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.probability == prob
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.TwoQubitDepolarizing, IR.TwoQubitDephasing)
            prob  = rand()
            targs = [0, 1]
            raw_str = """{"probability": $prob, "targets": $targs}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test read_T.probability == prob
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.PauliChannel,)
            probx = rand()
            proby = rand()
            probz = rand()
            targ  = 0
            raw_str = """{"probX": $probx, "probY": $proby, "probZ": $probz, "target": $targ}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.target == targ
            @test read_T.probX == probx
            @test read_T.probY == proby
            @test read_T.probZ == probz
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.MultiQubitPauliChannel,)
            targs = [0, 1]
            probs = Dict("XX"=>rand(), "YY"=>rand())
            raw_str = """{"probabilities": $(JSON3.write(probs)), "targets": $targs}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == targs
            @test read_T.probabilities == probs
            @test JSON3.read(JSON3.write(read_T), Braket.IR.AbstractIR) == read_T
        end
        for T in (IR.Kraus, IR.Unitary)
            mat = complex([0. 1.; 1. 0.])
            targ = 0
            vec = Braket.complex_matrix_to_ir(mat)
            raw_str = T == IR.Kraus ? """{"matrices": [$(JSON3.write(vec))], "targets": [$targ]}""" : """{"matrix": $(JSON3.write(vec)), "targets": [$targ]}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test read_T.targets == [targ]
            @test vec == ((read_T.type == "kraus") ? read_T.matrices[1] : read_T.matrix)
        end
        for T in (IR.StartVerbatimBox, IR.EndVerbatimBox)
            raw_str = """{}"""
            read_T = JSON3.read(raw_str, T)
            @test read_T isa T
            @test JSON3.read(JSON3.write(read_T), Braket.IR.CompilerDirective) == read_T
        end
    end

    @testset "Device metadata" begin
        @testset for T in (Braket.IqmMetadata, Braket.RigettiMetadata)
            raw = """{"compiledProgram": "fake_program"}"""
            read_in = JSON3.read(raw, T)
            @test read_in isa T
            @test read_in.compiledProgram == "fake_program"
        end
        @testset "T = Braket.SimulatorMetadata" begin
            duration = 100
            T = Braket.SimulatorMetadata
            raw = """{"executionDuration": $duration}"""
            read_in = JSON3.read(raw, T)
            @test read_in isa T
            @test read_in.executionDuration == duration
        end
    end

    @testset "OpenQASMDeviceActionProperties" begin
        input = """{
            "actionType": "braket.ir.openqasm.program",
            "version": ["1"],
            "supportedOperations": ["x", "y"],
            "supportedResultTypes": [
                {"name": "resultType1", "observables": ["observable1"], "minShots": 2, "maxShots": 4}
            ],
            "supportPhysicalQubits": true,
            "supportedPragmas": ["braket_bit_flip_noise"],
            "forbiddenPragmas": ["braket_kraus_operator"],
            "forbiddenArrayOperations": ["concatenation", "range", "slicing"],
            "requiresAllQubitsMeasurement": false,
            "requiresContiguousQubitIndices": false,
            "supportsPartialVerbatimBox": true
        }"""
        read_in = JSON3.read(input, Braket.DeviceActionProperties)
        @test read_in isa Braket.OpenQASMDeviceActionProperties
    end

    @testset "Reading BraketSchemaBase" begin
        t = Braket.GateModelParameters(Braket.header_dict[Braket.GateModelParameters], 10, false)
        str = JSON3.write(t)
        read_in = JSON3.read(str, Braket.BraketSchemaBase)
        @test read_in isa Braket.GateModelParameters
    end
end

using Braket, Test, JSON3
using Braket: Instruction, OpenQASMSerializationProperties

@testset "Compiler directives basics" begin
    @test Braket.counterpart(Braket.StartVerbatimBox()) == Braket.EndVerbatimBox()
    @test Braket.counterpart(Braket.EndVerbatimBox())   == Braket.StartVerbatimBox()
    @testset for (cd, expected_ir) in ((Braket.StartVerbatimBox(), "#pragma braket verbatim\nbox{",), (Braket.EndVerbatimBox(), "}"))
        ix = Instruction(cd, Int[])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test ir(cd, Val(:OpenQASM), serialization_properties=OpenQASMSerializationProperties()) == expected_ir
        @test ir(cd) == expected_ir
    end
end

### A Pluto.jl notebook ###
# v0.19.40

using Markdown
using InteractiveUtils

# ╔═╡ 5ba10044-c01a-486a-b6bd-bad198bf1960
# Braket imports
using Braket, BraketSimulator, SparseArrays, NLopt

# ╔═╡ ec25630f-2ca7-421a-8559-3046144dd236
using Graphs, GraphMakie, Colors, Cairo, Compose, LinearAlgebra

# ╔═╡ 7112d37e-9f1e-11ed-313d-11843dc0a14e
md"""
### Introduction to QAOA and Graph Coloring
"""

# ╔═╡ 12feb970-e7e0-4e96-b537-5afe8e82ac17
md"""
In this notebook, we'll introduce the problem of graph coloring and the quantum approximate optimization algorithm (QAOA). We'll write the graph coloring problem in a form that is amenable to running on a quantum device and use a simulator to run some small examples.
"""

# ╔═╡ 318db32f-e76c-4a46-9557-bd93a660505a
md"""
## Graph coloring: what and why?

Many optimization problems in the real world can be modeled in terms of "graph coloring". In such a problem, we have a set of vertices connected by edges (a graph) and would like to place each vertex in one of a set of bins such that no adjacent vertices are in the same bin. You might have heard of this problem in the context of coloring a map - we don't want neighboring countries on a map to have the same color or it will be hard to tell them apart. But there are other problems that are naturally expressible as a graph coloring problem, such as:
- Scheduling tasks to run on GPU workers
- Creating exam schedules for university students
- Assigning gates to aircraft at the airport
- In general, any scheduling problem in which many clients/workers (students, CPU threads, airplanes) contend for scarce resources (exam slots, exclusive control over a GPU, aircraft gates) and conflicts may occur (simultaneous exams, threads getting blocked, planes running into each other)
"""

# ╔═╡ 3023c427-e656-4468-951e-669952b3124b
md"""
## Introduction to QAOA

There are many existing algorithms developed to solve graph coloring problems. Why would we want another?

The quantum approximate optimization algorithm (QAOA) was developed to make use of near term quantum devices. Quantum computers today don't have a large number of qubits, but we would still like to use them to solve real-world problems. QAOA is based on the concept of *hybrid computations* -- accelerating a classical workload using a quantum processor. Similar to computing using a GPU or TPU, we hope to offload the hard part of the computation to a quantum device which acts as an accelerator.

QAOA is designed to solve "QUBO" problems: quadratic unconstrained binary optimization. A QUBO problem is one that can be formulated as:

Find the vector $\vec{y}$ which minimizes $\langle\vec{z} , Q \vec{z}\rangle$.

`Q` is a matrix which encodes the optimization problem/cost function. To understand the basics of QAOA, let's start with a quantum formulation of the QUBO form above by replacing `z^T Q z` with a Hamiltonian `\hat{H}` such that:

$\hat{H} = \sum_{i,j} J_{i,j} \hat{\sigma}^z_i \hat{\sigma}^z_j$

The sum runs over all pairs of sites in the system. This is an Ising model of magnetism of quantum spins, and we can use a quantum computer to solve it. If we find the ground state of this quantum system we have solved the associated QUBO problem. The ground state is the eigenvector of the matrix `H` associated with the lowest-lying eigenvalue. QAOA attempts to do this by applying a series of circuits, each of which takes a variational parameter, and optimizing the parameters.
"""

# ╔═╡ b71a0897-b1e3-4ea7-89e0-53ff4aca5e57
md"""
### Writing the building blocks of QAOA

In QAOA we apply two sub-circuits in each layer: the "cost" circuit and the "driver" circuit. The cost circuit has parameter γ associated with it, and the driver has parameter β. These parameters are optimized as the algorithm runs to arrive at a good solution to the optimization problem. The classical computer handles the parameter updates and the quantum device handles the preparation and computation of $\langle \psi | \hat{H} | \psi \rangle$. We'll first build a generic interface to create the cost and driver circuits:
"""

# ╔═╡ a1592cdc-0f2e-4794-96f7-328347b27481
"""
	ZZgate(q1, q2, γ) -> Circuit

Implementation of `ZZ` gate with native gates for QPUs (Rigetti) that do not
support the `ZZ` gate.
"""
function ZZgate(q1, q2, γ)
    circ_zz = Circuit([(CNot, q1, q2), (Rz, q2, γ), (CNot, q1, q2)])
    return circ_zz
end

# ╔═╡ c32edfaf-5191-4428-b86f-4077222b1b06
"""
	cost_circuit(γ, nqubits::Int, device::Device, ising::SparseMatrixCSC) -> Circuit

Builds the cost portion of the QAOA circuit. If the device supports the `ZZ` gate natively, that is used, otherwise use a compiled version.
"""
function cost_circuit(γ, nqubits::Int, device::Device, ising::SparseMatrixCSC)
    cost    = Circuit()
    I, J, V = findnz(ising)
    for (i, j, v) in zip(I, J, V)
        if i != j
            if name(device) == "Rigetti"
                append!(cost, ZZgate(i-1, j-1, γ*v))
            else
                cost(ZZ, i-1, j-1, -2γ*v)
            end
        end
    end
    return cost
end

# ╔═╡ 03970aa4-a5e1-44cf-b06f-dfabe28913d8
"""
	driver_circuit(β, nqubits::Int) -> Circuit

Builds the driver portion of the QAOA circuit.
"""
function driver_circuit(β, nqubits::Int)
    driver = Circuit()
    for qubit in 0:nqubits-11
        driver(Rx, qubit, 2β)
    end
    return driver
end

# ╔═╡ fd229791-a4a5-4b59-8ca5-e694a25d698d
"""
	qaoa_circuit(params::AbstractVector, device::Device, nqubits::Int, ising::SparseMatrixCSC) -> Circuit

Builds the full QAOA circuit using `params` applied to `cost_circuit` and `driver_circuit`. The number of layers is inferred from the size of `params`.
"""
function qaoa_circuit(params::AbstractVector, device::Device, nqubits::Int, ising::SparseMatrixCSC)
    depth = div(length(params), 2)
    γs    = params[depth+1:end]
    βs    = params[1:depth]

    circ = Circuit([(X, collect(0:nqubits-1)), (H, collect(0:nqubits-1))])

    for layer in 1:depth
        cost_circ = cost_circuit(γs[layer], nqubits, device, ising)
        append!(circ, cost_circ)
        driver_circ = driver_circuit(βs[layer], nqubits)
        append!(circ, driver_circ)
    end
    return circ
end

# ╔═╡ 0c3a53af-ff93-4a96-9cf4-375fbdde92d7
md"""
We then *train* the variational parameters. For a QAOA circuit with `n` layers, we have `2n` variational parameters: `n` β for the drivers and `n` γ for the costs. We'll use `NLOpt.jl` to perform the optimization of these parameters. This `train` function can be used for any Ising Hamiltonian that describes a QUBO problem -- we just need to generate an appropriate Hamiltonian.

In this case we will run on the `LocalSimulator`, which is free to use. The number of qubits we'll need to solve the problem is `nv * k`, where `nv` is the number of vertices in the graph and `k` is the number of colors. The `LocalSimulator` runs locally on hardware you control (e.g. your laptop, a notebook instance) and as such will only be efficient up to about 18 qubits or so on most personal computers. For this reason, we'll look at graphs with 6 vertices and try to color them with 3 colors. If you want to try larger graphs and/or more colors, some options are:

- Try with only 2 colors and use more qubits
- Run the training for longer -- more qubits will take more time & memory
- Switch from the local simulator to one of Braket's [on-demand simulators](https://docs.aws.amazon.com/braket/latest/developerguide/braket-devices.html)
- Run the local simulator on a computer with more RAM
"""

# ╔═╡ 0794c4fe-4ba6-4f8f-9cdc-fadd1a4d19a1
md"""
## Building a training function

In this section, we'll build a function to train the variational parameters $\beta$ and $\gamma$ for each layer of the QAOA circuit using `NLopt.jl` and the input Ising Hamiltonian we generate. Our training function will be *agnostic* of the specific Hamiltonian, so we can worry about generating one appropriate to our specific problem later on.

To write the training function, we'll need:
- a function `f` which takes arguments `params` and `grad` (`params` will be variational parameters $\beta$ and $\gamma$)
- a way to initialize our parameters
- a way to compute losses at each training step
- a way to track the losses and current best solution at each training iteration
"""

# ╔═╡ 3a776e14-85cc-49e7-8413-eb3891894aff
# initializing the optimization
function init_opt(qaoa_depth::Int, n_qubits::Int)
    global_min   = 1e8
    global_state = zeros(n_qubits)
    # initialize with random parameters
    βs           = rand(qaoa_depth)
    γs           = rand(qaoa_depth)
    params       = vcat(βs, γs)
    # tracker for optimization process
    tracker      = Dict("costs"=>[],
                        "params"=>[],
                        "count"=>1,
                        "optimal_energy"=>global_min, # best energy so far
                        "optimal_state"=>global_state, # best configuration so far
                        "opt_energies"=>Float64[], # track lowest eigenvalue at every iteration
                        "opt_states"=>[] # track configuration associated with lowest eigenvalue at every iteration
                        )
    return params, tracker
end

# ╔═╡ 49742693-693e-4957-ba26-c6e5774e6611
# generating the loss & finding the best configuration at each iteration
function apply_qaoa(qaoa_circ::Circuit, ising::SparseMatrixCSC, device::Device, nshots::Int)
    task = device(qaoa_circ, shots=nshots)
    res  = result(task)

    # result comes back as 0s and 1s
    meas_ising = Matrix{Int}(undef, nshots, size(ising, 1))
	@views for shot in 1:nshots
		meas_ising[shot, :] = res.measurements[shot][:]
	end
    # but Ising hamiltonian expects values of -1 or 1
    meas_ising = map( x -> x == 0 ? -1 : 1, meas_ising)

    # generate the energies
    J   = triu(ising, 1)
    xQx = diag(meas_ising * J * transpose(meas_ising)) # computes <x | Q | x> for every result configuration
    all_energies = xQx
    loss = sum(all_energies) / nshots

    # select the best energy
    energy_min    = minimum(all_energies)
    # find the configuration that had that energy
    min_index     = findfirst(x->x==energy_min, all_energies)
    optimal_state = meas_ising[min_index, :]

    return loss, energy_min, optimal_state
end

# ╔═╡ 0308eba7-ba4a-41f0-88f0-07fb89d99330
function train(nqubits::Int, ising::SparseMatrixCSC, device::Device; depth::Int=3, iterations::Int=10, nshots::Int=1000)
    params, tracker = init_opt(depth, nqubits)
    function f(params, grad)
        # create the circuit
        qaoa_circ = qaoa_circuit(params, device, nqubits, ising)
        loss, energy_min, optimal_state = apply_qaoa(qaoa_circ, ising, device, nshots)
        # update the tracker
        push!(tracker["opt_energies"], energy_min)
        push!(tracker["opt_states"],    optimal_state)
        if energy_min < tracker["optimal_energy"]
            tracker["optimal_energy"] = energy_min
            tracker["optimal_state"]  = optimal_state
        end
        tracker["count"] = tracker["count"] + 1
        push!(tracker["params"], params)
        push!(tracker["costs"], loss)
        return loss
    end

    opt = Opt(:LN_COBYLA, length(params))
    min_objective!(opt, f)
    maxeval!(opt, iterations)
    for i in 1:iterations
		@info "Iteration $i"
        loss, params, info = optimize(opt, params)
    end
    return tracker
end

# ╔═╡ 8f65c483-9044-4f63-ba3a-22e03a3c35eb
md"""
## Constructing the QUBO Hamiltonian

Now that we have a generic training function we can use to perform QAOA in Julia, we can turn our attention to generating the specific Ising Hamiltonian we'll need to encode the graph coloring problem we would like to solve. Again, our training function is *not unique* and could be deployed with any QUBO problem.

We can use `Graphs.jl` to generate a random graph and try to color it. We'll start off with 6 vertices and 3 colors so that the problem is tractable using the `LocalSimulator`:
"""

# ╔═╡ b4435686-5dd2-433e-ae5d-bc3cba44a4f5
nv = 6 #number of vertices

# ╔═╡ 690fe577-2bbe-4ccb-bdcd-b0c9df268b83
ne = 7 #number of edges

# ╔═╡ 28381a00-9a9d-4261-b91f-641c26416374
G  = erdos_renyi(nv, ne)

# ╔═╡ 33866077-cbec-45f6-a88e-5c787ede69cb
k  = 3 #number of colors

# ╔═╡ 647c5d92-70ff-4dad-a7ca-bff2c4ca6e68
graphplot(G)

# ╔═╡ 2afde0f1-3e70-4748-9288-72e9fdfe618b
md"""
Now we need to generate an Ising Hamiltonian to represent the constraints in the problem. In order to color the graph with `k` colors, each vertex should have a different color from all its neighbors. Thus we will encode the problem in `nv * k` variables `x_{v,q}` - each one encodes whether the vertex `v` has color `q`.

For example, if we have 4 colors and two vertices, then `{x_1, x_2, x_3, x_4, x_5, x_6, x_7, x_8} = {1, 0, 0, 0, 0, 0, 1, 0}` would mean that we had colored the first vertex with color 1 and the second with color 3. The first four variables encode the presence of each of the 4 colors on the first vertex.

We'll determine the final values of these variables by representing them as qubits and performing the QAOA algorithm. We have two sets of constraints to combine:
1. Each vertex must have one color - ($x_{v,1} + x_{v,2} + \ldots + x_{v,k}$ = 1)
2. Adjacent vertices must have different colors ($x_{v,q} + x_{w,q} \leq 1$ iff $v, w$ are adjacent)

We'll encode the constraints into an `nv * k` by `nv * k` matrix that will serve as the Hamiltonian for QAOA. By finding the lowest lying eigenstate of this Hamiltonian using the training function we already wrote, we will solve the problem.

Where does the "quadratic" part arise? Following [this QUBO guide](http://leeds-faculty.colorado.edu/glover/511%20-%20QUBO%20Tutorial%20-%20updated%20version%20-%20May%204,%202019.pdf), we want to solve:

```math
\begin{align*}
\mathrm{min} y =& x^T C x \\
Ax =& b \\
\end{align*}
```

given that $x$ is equal to either $0$ or $1$. Then we can notice that:
```math
\begin{align*}
(Ax - b) =& 0 \\
(Ax - b)^T (Ax - b) =& 0 \\
\end{align*}
```

Thus, if $x$ can only take values $0$ or $1$, we can make the problem quadratic by computing this product to generate:
```math
\begin{align*}
\mathrm{min} y =& x^T C x + P_1 (Ax - b)^T (Ax - b) \\
=& x^T C x + x^T B x + c \\
=& x^T Q x + c \end{align*}
```

This will represent the optimization problem before we account for the constraints from the adjacency rules. We pick a "penalty" for each constraint ($P1$ and $P2$). These penalties are arbitrary. In our case, we need to compute:
$P_1 (x - 1)^T(x - 1)$
"""

# ╔═╡ 7bff0a07-01a3-4fae-8a47-7e8b1abd227b
# enforce that each vertex has only one color
P1 = 8

# ╔═╡ 51f4c337-5028-4f4e-b5c4-2b0d72511705
begin
	# add the P1 (x_{v,1} + ... + x_{v, k} - 1)^2 constraint
	J  = sparse(Diagonal(fill(P1,nv*k)))
	for v in 1:nv # for each vertex
	    for i in 1:k 
	        for j in i+1:k
	            J[k*(v-1) + i, k*(v-1) + j] = P1
	            J[k*(v-1) + j, k*(v-1) + i] = P1
	        end
	    end
	end
end

# ╔═╡ 9c67e81e-ba70-444c-84db-7f0bf3390c03
P2 = 8

# ╔═╡ 85a8ca28-45ef-4107-8c02-d3d04e2b7d7c
adj_mat = adjacency_matrix(G)

# ╔═╡ 5dfb5219-8e52-474a-9cad-08759092ecd2
begin
	iis, jjs, vs = findnz(triu(adj_mat))
	for (i,j) in zip(iis, jjs)
	    for color in 1:k
	        J[k*(i-1) + color, k*(j-1) + color] = P2/2
	        J[k*(j-1) + color, k*(i-1) + color] = P2/2
	    end
	end
end

# ╔═╡ d8464a8d-93d0-4919-8065-e184f6844806
md"""
## Running QAOA

Now we will run the QAOA algorithm on this graph and attempt to color it. At the end of the optimization we'll print out a trace of the best energy found at each step and a numerical representation of the solution:
"""

# ╔═╡ cb5203c6-18dd-4f4d-831f-367d46780ab5
DEPTH   = 2

# ╔═╡ 02aea1f5-67f9-4486-ad10-5946afce4fb9
SHOTS   = 1000

# ╔═╡ 27f74c2b-8f88-444c-a270-4e1c30cc9b70
device = LocalSimulator("braket_sv_v2")

# ╔═╡ a20ffdbb-f006-408e-a8a1-fc4dc1c4c7b5
tracker = train(nv*k, J, device; depth=DEPTH, nshots=SHOTS)

# ╔═╡ 1c871074-ba8e-44f2-a3db-108b8c84fd67
md"""
Let's inspect the optimal solution found and see if it is a valid coloring:
"""

# ╔═╡ c936cf70-968c-467f-9587-899d938466ef
opt_state = tracker["optimal_state"]

# ╔═╡ e6e5cb2a-a0cd-4232-9d62-25ca0b74a6ee
nodefillc = distinguishable_colors(k, colorant"green")

# ╔═╡ d0d2bbc8-df71-4824-b86e-f0cf6b537278
# color of each node based on encoding in opt_state
color_inds = [Int(findfirst(x->x>0, opt_state[(k*(v-1) + 1):k*v])) for v in 1:nv]

# ╔═╡ cea94f06-91ab-4a51-8b9e-b148e37ef359
graphplot(G, nodefillc=nodefillc[color_inds])

# ╔═╡ ca80e6c1-ec90-40ab-8422-ba056ca499eb
md"""
## Summing up

What we covered in this section:
- Many important optimization problems can be formulated in a quantum unconstrained binary optimization (QUBO) format
- These QUBO problems are amenable to acceleration with a hybrid classical-quantum approach.
- One such hybrid algorithm is QAOA, which we implemented above

This is a lot to take in! If it doesn't all make sense, try going through the procedure outlined above for another QUBO-type problem (max cut is a good choice, as it's a special case of graph colouring).

You might well ask, what's the point of doing all this for so few qubits? After all, extremely effective classical eigensolvers exist which could have easily found the groundstate of our Hamiltonian! For the size of problem we are considering, this is indeed true. However, we know that beyond a certain size, eigensolving is intractable even on the most advanced classical supercomputers. Our hope with algorithms like QAOA is to find techniques to make effective use of near term quantum devices (which have few qubits available), understand their performance and limitations, and prepare for a future in which we will have quantum computers with many hundreds or even thousands of qubits.
"""

# ╔═╡ 2eed0d35-7904-448c-bfe3-ab54c3207fea
md"""
### Suggestions for further exploration:
- How does the number of shots or number of layers (depth) affect the results?
- Try different types of random graphs. You can find a list of available generators in the [LightGraphs documentation](https://juliagraphs.org/LightGraphs.jl/latest/).
- Try a different QUBO problem. You can find a list of canonical examples and formulae for generating Hamiltonians from them [in this tutorial](http://leeds-faculty.colorado.edu/glover/511%20-%20QUBO%20Tutorial%20-%20updated%20version%20-%20May%204,%202019.pdf). Some suggestions are:
  - Minimum vertex cover
  - Quadratic knapsack problem
  - Max clique (you can find a formulation of this problem as QUBO [here](https://arxiv.org/pdf/1801.08649.pdf))
- Check out the [Amazon Braket QAOA tutorial](https://github.com/aws/amazon-braket-examples/blob/main/examples/hybrid_quantum_algorithms/QAOA/QAOA_braket.ipynb) for more examples
- There are graph colouring encodings for QAOA which use fewer than `nv * k` qubits -- see [this paper](https://arxiv.org/pdf/2009.07314.pdf) for an example. Can you implement their technique?
"""

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
Cairo = "159f3aea-2a34-519c-b102-8c37f9878175"
Colors = "5ae59095-9a9b-59fe-a467-6f913c188581"
Compose = "a81c6b42-2e10-5240-aca2-a61377ecd94b"
GraphMakie = "1ecd5474-83a3-4783-bb4f-06765db800d2"
Graphs = "86223c79-3864-5bf0-83f7-82e725a168b6"
LinearAlgebra = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"
NLopt = "76087f3c-5699-56af-9a33-bf431cd00edd"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"
SparseArrays = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[compat]
Braket = "~0.3.0"
Cairo = "~1.0.5"
Colors = "~0.12.10"
Compose = "~0.9.4"
GraphMakie = "~0.5.10"
Graphs = "~1.7.4"
NLopt = "~0.6.5"
PyBraket = "~0.3.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.4"
manifest_format = "2.0"
project_hash = "43c0b3cec6b9d40a1704e627cbaf9242c4a1fb50"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "SHA", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "487d6835da9876e0362a83aec169e390872eba64"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.81.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.AbstractFFTs]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "d92ad398961a3ed262d8bf04a1a2b8340f915fef"
uuid = "621f4979-c628-5d54-868e-fcf4e3e8185c"
version = "1.5.0"
weakdeps = ["ChainRulesCore", "Test"]

    [deps.AbstractFFTs.extensions]
    AbstractFFTsChainRulesCoreExt = "ChainRulesCore"
    AbstractFFTsTestExt = "Test"

[[deps.AbstractLattices]]
git-tree-sha1 = "222ee9e50b98f51b5d78feb93dd928880df35f06"
uuid = "398f06c4-4d28-53ec-89ca-5b2656b7603d"
version = "0.3.0"

[[deps.AbstractTrees]]
git-tree-sha1 = "2d9c9a55f9c93e8887ad391fbae72f8ef55e1177"
uuid = "1520ce14-60c1-5f80-bbc7-55ef81b5835c"
version = "0.4.5"

[[deps.Adapt]]
deps = ["LinearAlgebra", "Requires"]
git-tree-sha1 = "6a55b747d1812e699320963ffde36f1ebdda4099"
uuid = "79e6a3ab-5dfb-504d-930d-738a2a938a0e"
version = "4.0.4"
weakdeps = ["StaticArrays"]

    [deps.Adapt.extensions]
    AdaptStaticArraysExt = "StaticArrays"

[[deps.AliasTables]]
deps = ["Random"]
git-tree-sha1 = "82b912bb5215792fd33df26f407d064d3602af98"
uuid = "66dad0bd-aa9a-41b7-9441-69ab47430ed8"
version = "1.1.2"

[[deps.Animations]]
deps = ["Colors"]
git-tree-sha1 = "e81c509d2c8e49592413bfb0bb3b08150056c79d"
uuid = "27a7e980-b3e6-11e9-2bcd-0b925532e340"
version = "0.4.1"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrayInterface]]
deps = ["Adapt", "LinearAlgebra", "Requires", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "c5aeb516a84459e0318a02507d2261edad97eb75"
uuid = "4fba245c-0d91-5ea0-9b3e-6abc04ee57a9"
version = "7.7.1"

    [deps.ArrayInterface.extensions]
    ArrayInterfaceBandedMatricesExt = "BandedMatrices"
    ArrayInterfaceBlockBandedMatricesExt = "BlockBandedMatrices"
    ArrayInterfaceCUDAExt = "CUDA"
    ArrayInterfaceGPUArraysCoreExt = "GPUArraysCore"
    ArrayInterfaceStaticArraysCoreExt = "StaticArraysCore"
    ArrayInterfaceTrackerExt = "Tracker"

    [deps.ArrayInterface.weakdeps]
    BandedMatrices = "aae01518-5342-5314-be14-df237901396f"
    BlockBandedMatrices = "ffab5731-97b5-5995-9138-79e8c1846df0"
    CUDA = "052768ef-5323-5732-b1bb-66c8b64840ba"
    GPUArraysCore = "46192b85-c4d5-4398-a991-12ede77f4527"
    StaticArraysCore = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
    Tracker = "9f7883ad-71c0-57eb-9f7f-b5c9e6d3789c"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.Automa]]
deps = ["PrecompileTools", "TranscodingStreams"]
git-tree-sha1 = "588e0d680ad1d7201d4c6a804dcb1cd9cba79fbb"
uuid = "67c07d97-cdcb-5c2c-af73-a7f9c32a568b"
version = "1.0.3"

[[deps.AxisAlgorithms]]
deps = ["LinearAlgebra", "Random", "SparseArrays", "WoodburyMatrices"]
git-tree-sha1 = "01b8ccb13d68535d73d2b0c23e39bd23155fb712"
uuid = "13072b0f-2c55-5437-9ae7-d433b7a33950"
version = "1.1.0"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BenchmarkTools]]
deps = ["JSON", "Logging", "Printf", "Profile", "Statistics", "UUIDs"]
git-tree-sha1 = "d9a9701b899b30332bbcb3e1679c41cce81fb0e8"
uuid = "6e4b80f9-dd63-53aa-95a3-0cdb28fa8baf"
version = "1.3.2"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "f116c78dbaab8141c121a41962e28f442908051c"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.3.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CEnum]]
git-tree-sha1 = "389ad5c84de1ae7cf0e28e381131c98ea87d54fc"
uuid = "fa961155-64e5-5f13-b03f-caf6b980ea82"
version = "0.5.0"

[[deps.CRC32c]]
uuid = "8bf52ea8-c179-5cab-976a-9e18b702a9bc"

[[deps.CRlibm]]
deps = ["CRlibm_jll"]
git-tree-sha1 = "32abd86e3c2025db5172aa182b982debed519834"
uuid = "96374032-68de-5a5b-8d9e-752f78720389"
version = "1.0.1"

[[deps.CRlibm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e329286945d0cfc04456972ea732551869af1cfc"
uuid = "4e9b3aee-d8a1-5a3d-ad8b-7d824db253f0"
version = "1.0.1+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "SnoopPrecompile", "Tables", "Unicode", "WeakRefStrings", "WorkerUtilities"]
git-tree-sha1 = "c700cce799b51c9045473de751e9319bdd1c6e94"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.9"

[[deps.Cairo]]
deps = ["Cairo_jll", "Colors", "Glib_jll", "Graphics", "Libdl", "Pango_jll"]
git-tree-sha1 = "d0b3f8b4ad16cb0a2988c6788646a5e6a17b6b1b"
uuid = "159f3aea-2a34-519c-b102-8c37f9878175"
version = "1.0.5"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.Calculus]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f641eb0a4f00c343bbc32346e1217b86f3ce9dad"
uuid = "49dc2e85-a5d0-5ad3-a950-438e2897f1b9"
version = "0.5.1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c6d890a52d2c4d55d326439580c3b8d0875a77d9"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.7"

[[deps.CodecBzip2]]
deps = ["Bzip2_jll", "Libdl", "TranscodingStreams"]
git-tree-sha1 = "2e62a725210ce3c3c2e1a3080190e7ca491f18d7"
uuid = "523fee87-0ab8-5b00-afb7-3ecf72e48cfd"
version = "0.7.2"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "9c209fb7536406834aa938fb149964b985de6c83"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.1"

[[deps.ColorBrewer]]
deps = ["Colors", "JSON", "Test"]
git-tree-sha1 = "61c5334f33d91e570e1d0c3eb5465835242582c4"
uuid = "a2cac450-b92f-5266-8821-25eda20663c8"
version = "0.4.0"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "PrecompileTools", "Random"]
git-tree-sha1 = "67c1f244b991cad9b0aa4b7540fb758c2488b129"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.24.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "Requires", "Statistics", "TensorCore"]
git-tree-sha1 = "a1f44953f2382ebb937d60dafbe2deea4bd23249"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.10.0"
weakdeps = ["SpecialFunctions"]

    [deps.ColorVectorSpace.extensions]
    SpecialFunctionsExt = "SpecialFunctions"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "fc08e5930ee9a4e03f84bfb5211cb54e7769758a"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.10"

[[deps.Combinatorics]]
git-tree-sha1 = "08c8b6831dc00bfea825826be0bc8336fc369860"
uuid = "861a8166-3701-5b0c-9a16-15d98fcdc6aa"
version = "1.0.2"

[[deps.CommonSubexpressions]]
deps = ["MacroTools", "Test"]
git-tree-sha1 = "7b8a93dba8af7e3b42fecabf646260105ac373f7"
uuid = "bbf7d656-a473-5ed7-a52c-81e309532950"
version = "0.3.0"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "00a2cccc7f098ff3b66806862d275ca3db9e6e5a"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.5.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.5+0"

[[deps.Compose]]
deps = ["Base64", "Colors", "DataStructures", "Dates", "IterTools", "JSON", "LinearAlgebra", "Measures", "Printf", "Random", "Requires", "Statistics", "UUIDs"]
git-tree-sha1 = "d853e57661ba3a57abcdaa201f4c9917a93487a2"
uuid = "a81c6b42-2e10-5240-aca2-a61377ecd94b"
version = "0.9.4"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "64dd885fa25c61fdf6b27e90d6adedf564ae363a"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.15"

[[deps.ConstructionBase]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "260fd2400ed2dab602a7c15cf10c1933c59930a2"
uuid = "187b0558-2788-49d3-abe0-74a17ed4e7c9"
version = "1.5.5"
weakdeps = ["IntervalSets", "StaticArrays"]

    [deps.ConstructionBase.extensions]
    ConstructionBaseIntervalSetsExt = "IntervalSets"
    ConstructionBaseStaticArraysExt = "StaticArrays"

[[deps.Contour]]
git-tree-sha1 = "439e35b0b36e2e5881738abc8857bd92ad6ff9a8"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.3"

[[deps.DataAPI]]
git-tree-sha1 = "e8119c1a33d267e16108be441a287a6981ba1630"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.14.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelaunayTriangulation]]
deps = ["DataStructures", "EnumX", "ExactPredicates", "Random", "SimpleGraphs"]
git-tree-sha1 = "d4e9dc4c6106b8d44e40cd4faf8261a678552c7c"
uuid = "927a84f5-c5f4-47a5-9785-b46e178433df"
version = "0.8.12"

[[deps.DiffResults]]
deps = ["StaticArraysCore"]
git-tree-sha1 = "782dd5f4561f5d267313f23853baaaa4c52ea621"
uuid = "163ba53b-c6d8-5494-b064-1a9d43ac40c5"
version = "1.1.0"

[[deps.DiffRules]]
deps = ["IrrationalConstants", "LogExpFunctions", "NaNMath", "Random", "SpecialFunctions"]
git-tree-sha1 = "c5b6685d53f933c11404a3ae9822afe30d522494"
uuid = "b552c78f-8df3-52c6-915a-8e097449b14b"
version = "1.12.2"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.Distributions]]
deps = ["AliasTables", "FillArrays", "LinearAlgebra", "PDMats", "Printf", "QuadGK", "Random", "SpecialFunctions", "Statistics", "StatsAPI", "StatsBase", "StatsFuns"]
git-tree-sha1 = "22c595ca4146c07b16bcf9c8bea86f731f7109d2"
uuid = "31c24e10-a181-5473-b8eb-7969acd0382f"
version = "0.25.108"

    [deps.Distributions.extensions]
    DistributionsChainRulesCoreExt = "ChainRulesCore"
    DistributionsDensityInterfaceExt = "DensityInterface"
    DistributionsTestExt = "Test"

    [deps.Distributions.weakdeps]
    ChainRulesCore = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
    DensityInterface = "b429d917-457f-4dbc-8f4c-0cc954292b1d"
    Test = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "2fb1e02f2b635d0845df5d7c167fec4dd739b00d"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.3"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.DualNumbers]]
deps = ["Calculus", "NaNMath", "SpecialFunctions"]
git-tree-sha1 = "5837a837389fccf076445fce071c8ddaea35a566"
uuid = "fa6b7ba4-c1ee-5f82-b5fc-ecf0adba8f74"
version = "0.6.8"

[[deps.EarCut_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e3290f2d49e661fbd94046d7e3726ffcb2d41053"
uuid = "5ae413db-bbd1-5e63-b57d-d24a61df00f5"
version = "2.2.4+0"

[[deps.EnumX]]
git-tree-sha1 = "bdb1942cd4c45e3c678fd11569d5cccd80976237"
uuid = "4e289a0a-7415-4d19-859d-a7e5c4648b56"
version = "1.0.4"

[[deps.ErrorfreeArithmetic]]
git-tree-sha1 = "d6863c556f1142a061532e79f611aa46be201686"
uuid = "90fa49ef-747e-5e6f-a989-263ba693cf1a"
version = "0.5.2"

[[deps.ExactPredicates]]
deps = ["IntervalArithmetic", "Random", "StaticArraysCore"]
git-tree-sha1 = "499b1ca78f6180c8f8bdf1cabde2d39120229e5c"
uuid = "429591f6-91af-11e9-00e2-59fbe8cec110"
version = "2.2.6"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.Extents]]
git-tree-sha1 = "2140cd04483da90b2da7f99b2add0750504fc39c"
uuid = "411431e0-e8b7-467b-b5e0-f676ba4f2910"
version = "0.1.2"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FFTW]]
deps = ["AbstractFFTs", "FFTW_jll", "LinearAlgebra", "MKL_jll", "Preferences", "Reexport"]
git-tree-sha1 = "4820348781ae578893311153d69049a93d05f39d"
uuid = "7a1cc6ca-52ef-59f5-83cd-3a7055c09341"
version = "1.8.0"

[[deps.FFTW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c6033cc3892d0ef5bb9cd29b7f2f0331ea5184ea"
uuid = "f5851436-0d7a-5f13-b9de-f02708fd171a"
version = "3.3.10+0"

[[deps.FastRounding]]
deps = ["ErrorfreeArithmetic", "LinearAlgebra"]
git-tree-sha1 = "6344aa18f654196be82e62816935225b3b9abe44"
uuid = "fa42c844-2597-5d31-933b-ebd51ab2693f"
version = "0.3.1"

[[deps.FileIO]]
deps = ["Pkg", "Requires", "UUIDs"]
git-tree-sha1 = "82d8afa92ecf4b52d78d869f038ebfb881267322"
uuid = "5789e2e9-d7fb-5bc7-8068-2c6fae9b9549"
version = "1.16.3"

[[deps.FilePaths]]
deps = ["FilePathsBase", "MacroTools", "Reexport", "Requires"]
git-tree-sha1 = "919d9412dbf53a2e6fe74af62a73ceed0bce0629"
uuid = "8fc22ac5-c921-52a6-82fd-178b2807b824"
version = "0.8.3"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FillArrays]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "0653c0a2396a6da5bc4766c43041ef5fd3efbe57"
uuid = "1a297f60-69ca-5386-bcde-b61e274b549b"
version = "1.11.0"
weakdeps = ["PDMats", "SparseArrays", "Statistics"]

    [deps.FillArrays.extensions]
    FillArraysPDMatsExt = "PDMats"
    FillArraysSparseArraysExt = "SparseArrays"
    FillArraysStatisticsExt = "Statistics"

[[deps.FiniteDiff]]
deps = ["ArrayInterface", "LinearAlgebra", "Requires", "Setfield", "SparseArrays"]
git-tree-sha1 = "73d1214fec245096717847c62d389a5d2ac86504"
uuid = "6a86dc24-6348-571c-b903-95158fe2bd41"
version = "2.22.0"

    [deps.FiniteDiff.extensions]
    FiniteDiffBandedMatricesExt = "BandedMatrices"
    FiniteDiffBlockBandedMatricesExt = "BlockBandedMatrices"
    FiniteDiffStaticArraysExt = "StaticArrays"

    [deps.FiniteDiff.weakdeps]
    BandedMatrices = "aae01518-5342-5314-be14-df237901396f"
    BlockBandedMatrices = "ffab5731-97b5-5995-9138-79e8c1846df0"
    StaticArrays = "90137ffa-7385-5640-81b9-e52037218182"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Format]]
git-tree-sha1 = "9c68794ef81b08086aeb32eeaf33531668d5f5fc"
uuid = "1fa38f19-a742-5d3f-a2b9-30dd87b9d5f8"
version = "1.3.7"

[[deps.ForwardDiff]]
deps = ["CommonSubexpressions", "DiffResults", "DiffRules", "LinearAlgebra", "LogExpFunctions", "NaNMath", "Preferences", "Printf", "Random", "SpecialFunctions", "StaticArrays"]
git-tree-sha1 = "a69dd6db8a809f78846ff259298678f0d6212180"
uuid = "f6369f11-7733-5829-9624-2563aa707210"
version = "0.10.34"

[[deps.FreeType]]
deps = ["CEnum", "FreeType2_jll"]
git-tree-sha1 = "907369da0f8e80728ab49c1c7e09327bf0d6d999"
uuid = "b38be410-82b0-50bf-ab77-7b57e271db43"
version = "4.1.1"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FreeTypeAbstraction]]
deps = ["ColorVectorSpace", "Colors", "FreeType", "GeometryBasics"]
git-tree-sha1 = "2493cdfd0740015955a8e46de4ef28f49460d8bc"
uuid = "663a7486-cb36-511b-a19d-713bb74d65c9"
version = "0.10.3"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GeoInterface]]
deps = ["Extents"]
git-tree-sha1 = "801aef8228f7f04972e596b09d4dba481807c913"
uuid = "cf35fbd7-0cd7-5166-be24-54bfbe79505f"
version = "1.3.4"

[[deps.GeometryBasics]]
deps = ["EarCut_jll", "Extents", "GeoInterface", "IterTools", "LinearAlgebra", "StaticArrays", "StructArrays", "Tables"]
git-tree-sha1 = "b62f2b2d76cee0d61a2ef2b3118cd2a3215d3134"
uuid = "5c1252a2-5f33-56bf-86c9-59e7332b4326"
version = "0.4.11"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "5688002de970b9eee14b7af7bbbd1fdac10c9bbe"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.2"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "d3b3624125c1474292d0d8ed0f65554ac37ddb23"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+2"

[[deps.GraphMakie]]
deps = ["DataStructures", "GeometryBasics", "Graphs", "LinearAlgebra", "Makie", "NetworkLayout", "PolynomialRoots", "SimpleTraits", "StaticArrays"]
git-tree-sha1 = "bdddc4afd944ccc67afbd81791d88d944c36f410"
uuid = "1ecd5474-83a3-4783-bb4f-06765db800d2"
version = "0.5.10"

[[deps.Graphics]]
deps = ["Colors", "LinearAlgebra", "NaNMath"]
git-tree-sha1 = "d61890399bc535850c4bf08e4e0d3a7ad0f21cbd"
uuid = "a2bd30eb-e257-5431-a919-1863eab51364"
version = "1.1.2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.GridLayoutBase]]
deps = ["GeometryBasics", "InteractiveUtils", "Observables"]
git-tree-sha1 = "6f93a83ca11346771a93bbde2bdad2f65b61498f"
uuid = "3955a311-db13-416c-9275-1d80ed98e5e9"
version = "0.10.2"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "eb5aa5e3b500e191763d35198f859e4b40fff4a6"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.7.3"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.HypergeometricFunctions]]
deps = ["DualNumbers", "LinearAlgebra", "OpenLibm_jll", "SpecialFunctions"]
git-tree-sha1 = "f218fe3736ddf977e0e772bc9a586b2383da2685"
uuid = "34004b35-14d8-5ef3-9330-4cdb6864b03a"
version = "0.3.23"

[[deps.ImageAxes]]
deps = ["AxisArrays", "ImageBase", "ImageCore", "Reexport", "SimpleTraits"]
git-tree-sha1 = "2e4520d67b0cef90865b3ef727594d2a58e0e1f8"
uuid = "2803e5a7-5153-5ecf-9a86-9b4c37f5f5ac"
version = "0.6.11"

[[deps.ImageBase]]
deps = ["ImageCore", "Reexport"]
git-tree-sha1 = "eb49b82c172811fd2c86759fa0553a2221feb909"
uuid = "c817782e-172a-44cc-b673-b171935fbb9e"
version = "0.1.7"

[[deps.ImageCore]]
deps = ["ColorVectorSpace", "Colors", "FixedPointNumbers", "MappedArrays", "MosaicViews", "OffsetArrays", "PaddedViews", "PrecompileTools", "Reexport"]
git-tree-sha1 = "b2a7eaa169c13f5bcae8131a83bc30eff8f71be0"
uuid = "a09fc81d-aa75-5fe9-8630-4744c3626534"
version = "0.10.2"

[[deps.ImageIO]]
deps = ["FileIO", "IndirectArrays", "JpegTurbo", "LazyModules", "Netpbm", "OpenEXR", "PNGFiles", "QOI", "Sixel", "TiffImages", "UUIDs"]
git-tree-sha1 = "bca20b2f5d00c4fbc192c3212da8fa79f4688009"
uuid = "82e4d734-157c-48bb-816b-45c225c6df19"
version = "0.6.7"

[[deps.ImageMetadata]]
deps = ["AxisArrays", "ImageAxes", "ImageBase", "ImageCore"]
git-tree-sha1 = "355e2b974f2e3212a75dfb60519de21361ad3cb7"
uuid = "bc367c6b-8a6b-528e-b4bd-a4b897500b49"
version = "0.9.9"

[[deps.Imath_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "0936ba688c6d201805a83da835b55c61a180db52"
uuid = "905a6f67-0a94-5f89-b386-d35d92009cd1"
version = "3.1.11+0"

[[deps.IndirectArrays]]
git-tree-sha1 = "012e604e1c7458645cb8b436f8fba789a51b257f"
uuid = "9b13fd28-a010-5f03-acff-a1bbcff69959"
version = "1.0.0"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "9cc2baf75c6d09f9da536ddf58eb2f29dedaf461"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.4.0"

[[deps.IntegerMathUtils]]
git-tree-sha1 = "b8ffb903da9f7b8cf695a8bead8e01814aa24b30"
uuid = "18e54dd8-cb9d-406c-a71d-865a43cbb235"
version = "0.1.2"

[[deps.IntelOpenMP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "be50fe8df3acbffa0274a744f1a99d29c45a57f4"
uuid = "1d5cc7b8-4909-519e-a0f8-d0f5ad9712d0"
version = "2024.1.0+0"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.Interpolations]]
deps = ["Adapt", "AxisAlgorithms", "ChainRulesCore", "LinearAlgebra", "OffsetArrays", "Random", "Ratios", "Requires", "SharedArrays", "SparseArrays", "StaticArrays", "WoodburyMatrices"]
git-tree-sha1 = "88a101217d7cb38a7b481ccd50d21876e1d1b0e0"
uuid = "a98d9a8b-a2ab-59e6-89dd-64a1c18fca59"
version = "0.15.1"

    [deps.Interpolations.extensions]
    InterpolationsUnitfulExt = "Unitful"

    [deps.Interpolations.weakdeps]
    Unitful = "1986cc42-f94f-5a68-af5c-568840ba703d"

[[deps.IntervalArithmetic]]
deps = ["CRlibm", "EnumX", "FastRounding", "LinearAlgebra", "Markdown", "Random", "RecipesBase", "RoundingEmulator", "SetRounding", "StaticArrays"]
git-tree-sha1 = "f59e639916283c1d2e106d2b00910b50f4dab76c"
uuid = "d1acc4aa-44c8-5952-acd4-ba5d80a2a253"
version = "0.21.2"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.Isoband]]
deps = ["isoband_jll"]
git-tree-sha1 = "f9b6d97355599074dc867318950adaa6f9946137"
uuid = "f1662d9f-8043-43de-a69a-05efc1cc6ff4"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "84b10656a41ef564c39d2d477d7236966d2b5683"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.12.0"

[[deps.JpegTurbo]]
deps = ["CEnum", "FileIO", "ImageCore", "JpegTurbo_jll", "TOML"]
git-tree-sha1 = "fa6d0bcff8583bac20f1ffa708c3913ca605c611"
uuid = "b835a17e-a41a-41e7-81f0-2f016b05efe0"
version = "0.1.5"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "3336abae9a713d2210bb57ab484b1e065edd7d23"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "3.0.2+0"

[[deps.KernelDensity]]
deps = ["Distributions", "DocStringExtensions", "FFTW", "Interpolations", "StatsBase"]
git-tree-sha1 = "7d703202e65efa1369de1279c162b915e245eed1"
uuid = "5ab0869b-81aa-558d-bb23-cbf5423bbe9b"
version = "0.6.9"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "170b660facf5df5de098d866564877e119141cbd"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.2+0"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "50901ebc375ed41dbf8058da26f9de442febbbec"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.1"

[[deps.LazyArtifacts]]
deps = ["Artifacts", "Pkg"]
uuid = "4af54fe1-eca0-43a8-85a7-787d91b784e3"

[[deps.LazyModules]]
git-tree-sha1 = "a560dd966b386ac9ae60bdd3a3d3a326062d3c3e"
uuid = "8cdb02fc-e678-4876-92c5-9defec4f444e"
version = "0.3.1"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.4"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "8.4.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.11.0+1"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c7cb1f5d892775ba13767a87c7ada0b980ea0a71"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+2"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LightXML]]
deps = ["Libdl", "XML2_jll"]
git-tree-sha1 = "3a994404d3f6709610701c7dabfc03fed87a81f8"
uuid = "9c8b4983-aa76-5018-a973-4c85ecc9e179"
version = "0.9.1"

[[deps.LineSearches]]
deps = ["LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "Printf"]
git-tree-sha1 = "7bbea35cec17305fc70a0e5b4641477dc0789d9d"
uuid = "d3d80556-e9d4-5f37-9878-2ab0fcc64255"
version = "7.2.0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LinearAlgebraX]]
deps = ["LinearAlgebra", "Mods", "Primes", "SimplePolynomials"]
git-tree-sha1 = "d76cec8007ec123c2b681269d40f94b053473fcf"
uuid = "9b3f67b0-2d00-526e-9884-9e4938f8fb88"
version = "0.2.7"

[[deps.LogExpFunctions]]
deps = ["DocStringExtensions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "45b288af6956e67e621c5cbb2d75a261ab58300b"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.20"

    [deps.LogExpFunctions.extensions]
    ChainRulesCoreExt = "ChainRulesCore"
    ChangesOfVariablesExt = "ChangesOfVariables"
    InverseFunctionsExt = "InverseFunctions"

    [deps.LogExpFunctions.weakdeps]
    ChainRulesCore = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
    ChangesOfVariables = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
    InverseFunctions = "3587e190-3f89-42d0-90ee-14403ec27112"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "cedb76b37bc5a6c702ade66be44f831fa23c681e"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "1.0.0"

[[deps.MKL_jll]]
deps = ["Artifacts", "IntelOpenMP_jll", "JLLWrappers", "LazyArtifacts", "Libdl", "oneTBB_jll"]
git-tree-sha1 = "80b2833b56d466b3858d565adcd16a4a05f2089b"
uuid = "856f044c-d86e-5d09-b602-aeab76dc8ba7"
version = "2024.1.0+0"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Makie]]
deps = ["Animations", "Base64", "CRC32c", "ColorBrewer", "ColorSchemes", "ColorTypes", "Colors", "Contour", "DelaunayTriangulation", "Distributions", "DocStringExtensions", "Downloads", "FFMPEG_jll", "FileIO", "FilePaths", "FixedPointNumbers", "Format", "FreeType", "FreeTypeAbstraction", "GeometryBasics", "GridLayoutBase", "ImageIO", "InteractiveUtils", "IntervalSets", "Isoband", "KernelDensity", "LaTeXStrings", "LinearAlgebra", "MacroTools", "MakieCore", "Markdown", "MathTeXEngine", "Observables", "OffsetArrays", "Packing", "PlotUtils", "PolygonOps", "PrecompileTools", "Printf", "REPL", "Random", "RelocatableFolders", "Scratch", "ShaderAbstractions", "Showoff", "SignedDistanceFields", "SparseArrays", "Statistics", "StatsBase", "StatsFuns", "StructArrays", "TriplotBase", "UnicodeFun"]
git-tree-sha1 = "46ca613be7a1358fb93529726ea2fc28050d3ae0"
uuid = "ee78f7c6-11fb-53f2-987a-cfe4a2b5a57a"
version = "0.20.9"

[[deps.MakieCore]]
deps = ["Observables", "REPL"]
git-tree-sha1 = "248b7a4be0f92b497f7a331aed02c1e9a878f46b"
uuid = "20f20a25-4f0e-4fdf-b5d1-57303727442b"
version = "0.7.3"

[[deps.MappedArrays]]
git-tree-sha1 = "2dab0221fe2b0f2cb6754eaa743cc266339f527e"
uuid = "dbb5928d-eab1-5f90-85c2-b9b0edb7c900"
version = "0.4.2"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MathOptInterface]]
deps = ["BenchmarkTools", "CodecBzip2", "CodecZlib", "DataStructures", "ForwardDiff", "JSON", "LinearAlgebra", "MutableArithmetics", "NaNMath", "OrderedCollections", "Printf", "SnoopPrecompile", "SparseArrays", "SpecialFunctions", "Test", "Unicode"]
git-tree-sha1 = "b577d6c6b484f35fc27c1e767dc32458815da0e5"
uuid = "b8f27783-ece8-5eb3-8dc8-9495eed66fee"
version = "1.11.5"

[[deps.MathProgBase]]
deps = ["LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "9abbe463a1e9fc507f12a69e7f29346c2cdc472c"
uuid = "fdba3010-5040-5b88-9595-932c9decdf73"
version = "0.7.8"

[[deps.MathTeXEngine]]
deps = ["AbstractTrees", "Automa", "DataStructures", "FreeTypeAbstraction", "GeometryBasics", "LaTeXStrings", "REPL", "RelocatableFolders", "UnicodeFun"]
git-tree-sha1 = "96ca8a313eb6437db5ffe946c457a401bbb8ce1d"
uuid = "0a4f8689-d25c-4efe-a92b-7142dfc1aa53"
version = "0.5.7"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.2+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch", "micromamba_jll"]
git-tree-sha1 = "a6a4771aba1dc8942bc0f44ff9f8ee0f893ef888"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.12"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "ec4f7fbeab05d7747bdf98eb74d130a2a2ed298d"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.2.0"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["Compat", "ExprTools"]
git-tree-sha1 = "c272302b22479a24d1cf48c114ad702933414f80"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.5"

[[deps.Mods]]
git-tree-sha1 = "924f962b524a71eef7a21dae1e6853817f9b658f"
uuid = "7475f97c-0381-53b1-977b-4c60186c8d62"
version = "2.2.4"

[[deps.MosaicViews]]
deps = ["MappedArrays", "OffsetArrays", "PaddedViews", "StackViews"]
git-tree-sha1 = "7b86a5d4d70a9f5cdf2dacb3cbe6d251d1a61dbe"
uuid = "e94cdb99-869f-56ef-bcf0-1ae2bcbe0389"
version = "0.3.4"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.Multisets]]
git-tree-sha1 = "8d852646862c96e226367ad10c8af56099b4047e"
uuid = "3b2b4ff1-bcff-5658-a3ee-dbcf1ce5ac09"
version = "0.4.4"

[[deps.MutableArithmetics]]
deps = ["LinearAlgebra", "SparseArrays", "Test"]
git-tree-sha1 = "aa532179d4a643d4bd9f328589ca01fa20a0d197"
uuid = "d8a4904e-b15c-11e9-3269-09a3773c0cb0"
version = "1.1.0"

[[deps.NLSolversBase]]
deps = ["DiffResults", "Distributed", "FiniteDiff", "ForwardDiff"]
git-tree-sha1 = "a0b464d183da839699f4c79e7606d9d186ec172c"
uuid = "d41bc354-129a-5804-8e4c-c37616107c6c"
version = "7.8.3"

[[deps.NLopt]]
deps = ["MathOptInterface", "MathProgBase", "NLopt_jll"]
git-tree-sha1 = "5a7e32c569200a8a03c3d55d286254b0321cd262"
uuid = "76087f3c-5699-56af-9a33-bf431cd00edd"
version = "0.6.5"

[[deps.NLopt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9b1f15a08f9d00cdb2761dcfa6f453f5d0d6f973"
uuid = "079eb43e-fd8e-5478-9966-2cf3e3edb778"
version = "2.7.1+0"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "90914795fc59df44120fe3fff6742bb0d7adb1d0"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.3"

[[deps.Netpbm]]
deps = ["FileIO", "ImageCore", "ImageMetadata"]
git-tree-sha1 = "d92b107dbb887293622df7697a2223f9f8176fcd"
uuid = "f09324ee-3d7c-5217-9330-fc30815ba969"
version = "1.1.1"

[[deps.NetworkLayout]]
deps = ["GeometryBasics", "LinearAlgebra", "Random", "Requires", "StaticArrays"]
git-tree-sha1 = "91bb2fedff8e43793650e7a677ccda6e6e6e166b"
uuid = "46757867-2c16-5918-afeb-47bfcb05e46a"
version = "0.4.6"
weakdeps = ["Graphs"]

    [deps.NetworkLayout.extensions]
    NetworkLayoutGraphsExt = "Graphs"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Observables]]
git-tree-sha1 = "7438a59546cf62428fc9d1bc94729146d37a7225"
uuid = "510215fc-4207-5dde-b226-833fc4488ee2"
version = "0.5.5"

[[deps.OffsetArrays]]
git-tree-sha1 = "e64b4f5ea6b7389f6f046d13d4896a8f9c1ba71e"
uuid = "6fe1bfb0-de20-5000-8ca7-80f57d26f881"
version = "1.14.0"
weakdeps = ["Adapt"]

    [deps.OffsetArrays.extensions]
    OffsetArraysAdaptExt = "Adapt"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+4"

[[deps.OpenEXR]]
deps = ["Colors", "FileIO", "OpenEXR_jll"]
git-tree-sha1 = "327f53360fdb54df7ecd01e96ef1983536d1e633"
uuid = "52e1d378-f018-4a11-a4be-720524705ac7"
version = "0.3.2"

[[deps.OpenEXR_jll]]
deps = ["Artifacts", "Imath_jll", "JLLWrappers", "Libdl", "Zlib_jll"]
git-tree-sha1 = "8292dd5c8a38257111ada2174000a33745b06d4e"
uuid = "18a262bb-aa17-5467-a713-aee519bc75cb"
version = "3.2.4+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "6503b77492fd7fcb9379bf73cd31035670e3c509"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.3"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Optim]]
deps = ["Compat", "FillArrays", "ForwardDiff", "LineSearches", "LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "PositiveFactorizations", "Printf", "SparseArrays", "StatsBase"]
git-tree-sha1 = "01f85d9269b13fedc61e63cc72ee2213565f7a72"
uuid = "429524aa-4258-5aef-a3af-852621145aeb"
version = "1.7.8"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+0"

[[deps.PDMats]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "949347156c25054de2db3b166c52ac4728cbad65"
uuid = "90014a1f-27ba-587c-ab20-58faa44d9150"
version = "0.11.31"

[[deps.PNGFiles]]
deps = ["Base64", "CEnum", "ImageCore", "IndirectArrays", "OffsetArrays", "libpng_jll"]
git-tree-sha1 = "67186a2bc9a90f9f85ff3cc8277868961fb57cbd"
uuid = "f57f5aa1-a3ce-4bc8-8ab9-96f992907883"
version = "0.4.3"

[[deps.Packing]]
deps = ["GeometryBasics"]
git-tree-sha1 = "ec3edfe723df33528e085e632414499f26650501"
uuid = "19eb6ba3-879d-56ad-ad62-d5c202156566"
version = "0.5.0"

[[deps.PaddedViews]]
deps = ["OffsetArrays"]
git-tree-sha1 = "0fac6313486baae819364c52b4f483450a9d793f"
uuid = "5432bcbf-9aad-5242-b902-cca2824c8663"
version = "0.5.12"

[[deps.Pango_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "FriBidi_jll", "Glib_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "84a314e3926ba9ec66ac097e3635e270986b0f10"
uuid = "36c8627f-9965-5494-a995-c6b170f724f3"
version = "1.50.9+0"

[[deps.Parameters]]
deps = ["OrderedCollections", "UnPack"]
git-tree-sha1 = "34c0e9ad262e5f7fc75b10a9952ca7692cfc5fbe"
uuid = "d96e819e-fc66-5662-9728-84c9c7592b0a"
version = "0.12.3"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "8175fc2b118a3755113c8e68084dc1a9e63c61ee"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.3"

[[deps.Permutations]]
deps = ["Combinatorics", "LinearAlgebra", "Random"]
git-tree-sha1 = "4ca430561cf37c75964c8478eddae2d79e96ca9b"
uuid = "2ae35dd2-176d-5d53-8349-f30d82d94d4f"
version = "0.4.21"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.2"

[[deps.PkgVersion]]
deps = ["Pkg"]
git-tree-sha1 = "f9501cc0430a26bc3d156ae1b5b0c1b47af4d6da"
uuid = "eebad327-c553-4316-9ea0-9fa01ccd7688"
version = "0.3.3"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "PrecompileTools", "Printf", "Random", "Reexport", "Statistics"]
git-tree-sha1 = "7b1a9df27f072ac4c9c7cbe5efb198489258d1f5"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.4.1"

[[deps.PolygonOps]]
git-tree-sha1 = "77b3d3605fc1cd0b42d95eba87dfcd2bf67d5ff6"
uuid = "647866c9-e3ac-4575-94e7-e3d426903924"
version = "0.1.2"

[[deps.PolynomialRoots]]
git-tree-sha1 = "5f807b5345093487f733e520a1b7395ee9324825"
uuid = "3a141323-8675-5d76-9d11-e1df1406c778"
version = "1.0.0"

[[deps.Polynomials]]
deps = ["LinearAlgebra", "RecipesBase", "Setfield", "SparseArrays"]
git-tree-sha1 = "89620a0b5458dca4bf9ea96174fa6422b3adf6f9"
uuid = "f27b6e38-b328-58d1-80ce-0feddd5e7a45"
version = "4.0.8"
weakdeps = ["ChainRulesCore", "FFTW", "MakieCore", "MutableArithmetics"]

    [deps.Polynomials.extensions]
    PolynomialsChainRulesCoreExt = "ChainRulesCore"
    PolynomialsFFTWExt = "FFTW"
    PolynomialsMakieCoreExt = "MakieCore"
    PolynomialsMutableArithmeticsExt = "MutableArithmetics"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.PositiveFactorizations]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "17275485f373e6673f7e7f97051f703ed5b15b20"
uuid = "85a6dd25-e78a-55b7-8502-1745935b8125"
version = "0.2.4"

[[deps.PrecompileTools]]
deps = ["Preferences"]
git-tree-sha1 = "5aa36f7049a63a1528fe8f7c3f2113413ffd4e1f"
uuid = "aea7be01-6a6a-4083-8856-8a6e6704d82a"
version = "1.2.1"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Primes]]
deps = ["IntegerMathUtils"]
git-tree-sha1 = "cb420f77dc474d23ee47ca8d14c90810cafe69e7"
uuid = "27ebfcd6-29c5-5fa9-bf4b-fb8fc14df3ae"
version = "0.5.6"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.Profile]]
deps = ["Printf"]
uuid = "9abbd945-dff8-562f-b5e8-e1ebf5ef1b79"

[[deps.ProgressMeter]]
deps = ["Distributed", "Printf"]
git-tree-sha1 = "763a8ceb07833dd51bb9e3bbca372de32c0605ad"
uuid = "92933f4c-e287-5a05-a399-4b506db050ca"
version = "1.10.0"

[[deps.PyBraket]]
deps = ["Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "PythonCall", "Statistics", "StructTypes"]
git-tree-sha1 = "64f9f4e72ef170541eecbb9398906114a33b9a34"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.3.0"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "1052188e0a017d4f4f261f12307e1fa1b5b48588"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.10"

[[deps.QOI]]
deps = ["ColorTypes", "FileIO", "FixedPointNumbers"]
git-tree-sha1 = "18e8f4d1426e965c7b532ddd260599e1510d26ce"
uuid = "4b34888f-f399-49d4-9bb3-47ed5cae4e65"
version = "1.0.0"

[[deps.QuadGK]]
deps = ["DataStructures", "LinearAlgebra"]
git-tree-sha1 = "9b23c31e76e333e6fb4c1595ae6afa74966a729e"
uuid = "1fd47b50-473d-5c70-9696-f719f8f3bcdc"
version = "2.9.4"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.Ratios]]
deps = ["Requires"]
git-tree-sha1 = "1342a47bf3260ee108163042310d26f2be5ec90b"
uuid = "c84ed2f1-dad5-54f0-aa8e-dbefe2724439"
version = "0.4.5"
weakdeps = ["FixedPointNumbers"]

    [deps.Ratios.extensions]
    RatiosFixedPointNumbersExt = "FixedPointNumbers"

[[deps.RecipesBase]]
deps = ["PrecompileTools"]
git-tree-sha1 = "5c3d09cc4f31f5fc6af001c250bf1278733100ff"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.4"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "ffdaf70d81cf6ff22c2b6e733c900c3321cab864"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.1"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.RingLists]]
deps = ["Random"]
git-tree-sha1 = "f39da63aa6d2d88e0c1bd20ed6a3ff9ea7171ada"
uuid = "286e9d63-9694-5540-9e3c-4e6708fa07b2"
version = "0.2.8"

[[deps.Rmath]]
deps = ["Random", "Rmath_jll"]
git-tree-sha1 = "f65dcb5fa46aee0cf9ed6274ccbd597adc49aa7b"
uuid = "79098fc4-a85e-5d69-aa6a-4863f24498fa"
version = "0.7.1"

[[deps.Rmath_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6ed52fdd3382cf21947b15e8870ac0ddbff736da"
uuid = "f50d1b31-88e8-58de-be2c-1cc44531875f"
version = "0.4.0+0"

[[deps.RoundingEmulator]]
git-tree-sha1 = "40b9edad2e5287e05bd413a38f61a8ff55b9557b"
uuid = "5eaf0fd0-dfba-4ccb-bf02-d820a40db705"
version = "0.2.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "c02bd3c9c3fc8463d3591a62a378f90d2d8ab0f3"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.17"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SetRounding]]
git-tree-sha1 = "d7a25e439d07a17b7cdf97eecee504c50fedf5f6"
uuid = "3cc68bcd-71a2-5612-b932-767ffbe40ab0"
version = "0.2.1"

[[deps.Setfield]]
deps = ["ConstructionBase", "Future", "MacroTools", "StaticArraysCore"]
git-tree-sha1 = "e2cc6d8c88613c05e1defb55170bf5ff211fbeac"
uuid = "efcf1570-3423-57d1-acb7-fd33fddbac46"
version = "1.1.1"

[[deps.ShaderAbstractions]]
deps = ["ColorTypes", "FixedPointNumbers", "GeometryBasics", "LinearAlgebra", "Observables", "StaticArrays", "StructArrays", "Tables"]
git-tree-sha1 = "79123bc60c5507f035e6d1d9e563bb2971954ec8"
uuid = "65257c39-d410-5151-9873-9b3e5be5013e"
version = "0.4.1"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SignedDistanceFields]]
deps = ["Random", "Statistics", "Test"]
git-tree-sha1 = "d263a08ec505853a5ff1c1ebde2070419e3f28e9"
uuid = "73760f76-fbc4-59ce-8f25-708e95d2df96"
version = "0.4.0"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleGraphs]]
deps = ["AbstractLattices", "Combinatorics", "DataStructures", "IterTools", "LightXML", "LinearAlgebra", "LinearAlgebraX", "Optim", "Primes", "Random", "RingLists", "SimplePartitions", "SimplePolynomials", "SimpleRandom", "SparseArrays", "Statistics"]
git-tree-sha1 = "f65caa24a622f985cc341de81d3f9744435d0d0f"
uuid = "55797a34-41de-5266-9ec1-32ac4eb504d3"
version = "0.8.6"

[[deps.SimplePartitions]]
deps = ["AbstractLattices", "DataStructures", "Permutations"]
git-tree-sha1 = "e182b9e5afb194142d4668536345a365ea19363a"
uuid = "ec83eff0-a5b5-5643-ae32-5cbf6eedec9d"
version = "0.3.2"

[[deps.SimplePolynomials]]
deps = ["Mods", "Multisets", "Polynomials", "Primes"]
git-tree-sha1 = "7063828369cafa93f3187b3d0159f05582011405"
uuid = "cc47b68c-3164-5771-a705-2bc0097375a0"
version = "0.2.17"

[[deps.SimpleRandom]]
deps = ["Distributions", "LinearAlgebra", "Random"]
git-tree-sha1 = "3a6fb395e37afab81aeea85bae48a4db5cd7244a"
uuid = "a6525b86-64cd-54fa-8f65-62fc48bdc0e8"
version = "0.3.1"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.Sixel]]
deps = ["Dates", "FileIO", "ImageCore", "IndirectArrays", "OffsetArrays", "REPL", "libsixel_jll"]
git-tree-sha1 = "2da10356e31327c7096832eb9cd86307a50b1eb6"
uuid = "45858cf5-a6b0-47a3-bbea-62219f50df47"
version = "0.1.3"

[[deps.SnoopPrecompile]]
deps = ["Preferences"]
git-tree-sha1 = "e760a70afdcd461cf01a575947738d359234665c"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.3"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "66e0a8e672a0bdfca2c3f5937efb8538b9ddc085"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.2.1"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StackViews]]
deps = ["OffsetArrays"]
git-tree-sha1 = "46e589465204cd0c08b4bd97385e4fa79a0c770c"
uuid = "cae243ae-269e-4f55-b966-ac2d0dc13c15"
version = "0.1.1"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "6954a456979f23d05085727adb17c4551c19ecd1"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.12"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1ff449ad350c9c4cbc756624d6f8a8c3ef56d3ed"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.7.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "5cf7606d6cef84b543b483848d4ae08ad9832b21"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.34.3"

[[deps.StatsFuns]]
deps = ["HypergeometricFunctions", "IrrationalConstants", "LogExpFunctions", "Reexport", "Rmath", "SpecialFunctions"]
git-tree-sha1 = "cef0472124fab0695b58ca35a77c6fb942fdab8a"
uuid = "4c63d2b9-4356-54db-8cca-17b64c39e42c"
version = "1.3.1"

    [deps.StatsFuns.extensions]
    StatsFunsChainRulesCoreExt = "ChainRulesCore"
    StatsFunsInverseFunctionsExt = "InverseFunctions"

    [deps.StatsFuns.weakdeps]
    ChainRulesCore = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
    InverseFunctions = "3587e190-3f89-42d0-90ee-14403ec27112"

[[deps.StructArrays]]
deps = ["ConstructionBase", "DataAPI", "Tables"]
git-tree-sha1 = "f4dc295e983502292c4c3f951dbb4e985e35b3be"
uuid = "09ab397b-f2b6-538f-b94a-2f83cf4a842a"
version = "0.6.18"

    [deps.StructArrays.extensions]
    StructArraysAdaptExt = "Adapt"
    StructArraysGPUArraysCoreExt = "GPUArraysCore"
    StructArraysSparseArraysExt = "SparseArrays"
    StructArraysStaticArraysExt = "StaticArrays"

    [deps.StructArrays.weakdeps]
    Adapt = "79e6a3ab-5dfb-504d-930d-738a2a938a0e"
    GPUArraysCore = "46192b85-c4d5-4398-a991-12ede77f4527"
    SparseArrays = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"
    StaticArrays = "90137ffa-7385-5640-81b9-e52037218182"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse]]
deps = ["Libdl", "LinearAlgebra", "Serialization", "SparseArrays"]
uuid = "4607b0f0-06f3-5cda-b6b1-a6196a1729e9"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+6"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TiffImages]]
deps = ["ColorTypes", "DataStructures", "DocStringExtensions", "FileIO", "FixedPointNumbers", "IndirectArrays", "Inflate", "Mmap", "OffsetArrays", "PkgVersion", "ProgressMeter", "UUIDs"]
git-tree-sha1 = "7fd97bd1c5b1ff53a291cbd351d1d3d6ff4da5a5"
uuid = "731e570b-9d59-4bfa-96dc-6df516fadf69"
version = "0.6.7"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "94f38103c984f89cf77c402f2a68dbd870f8165f"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.11"

[[deps.TriplotBase]]
git-tree-sha1 = "4d4ed7f294cda19382ff7de4c137d24d16adc89b"
uuid = "981d1d27-644d-49a2-9326-4793e63143c3"
version = "0.1.0"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.UnPack]]
git-tree-sha1 = "387c1f73762231e86e0c9c5443ce3b4a0a9a0c2b"
uuid = "3a884ed6-31ef-47d7-9d2a-63182c4928ed"
version = "1.0.2"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.WoodburyMatrices]]
deps = ["LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c1a7aa6219628fcd757dede0ca95e245c5cd9511"
uuid = "efce3f68-66dc-5838-9240-27a6d6f5f9b6"
version = "1.0.0"

[[deps.WorkerUtilities]]
git-tree-sha1 = "cd1659ba0d57b71a464a29e64dbc67cfe83d54e7"
uuid = "76eceee3-57b5-4d4a-8e66-0e911cebbf60"
version = "1.6.1"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "93c41695bc1c08c46c5899f4fe06d6ead504bb73"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.10.3+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.isoband_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51b5eeb3f98367157a7a12a1fb0aa5328946c03c"
uuid = "9a68df92-36a6-505f-a73e-abb412b6bfb4"
version = "0.2.3+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.8.0+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsixel_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Pkg", "libpng_jll"]
git-tree-sha1 = "d4f63314c8aa1e48cd22aa0c17ed76cd1ae48c3c"
uuid = "075b6546-f08a-558a-be8f-8157d0f608a5"
version = "1.10.3+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.micromamba_jll]]
deps = ["Artifacts", "JLLWrappers", "LazyArtifacts", "Libdl", "Pkg"]
git-tree-sha1 = "80ddb5f510c650de288ecd548ebc3de557ffb3e2"
uuid = "f8abcde7-e9b7-5caa-b8af-a437887ae8e4"
version = "1.2.0+0"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.52.0+1"

[[deps.oneTBB_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "7d0ea0f4895ef2f5cb83645fa689e52cb55cf493"
uuid = "1317d2d5-d96f-522e-a858-c73665f53c3e"
version = "2021.12.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"
"""

# ╔═╡ Cell order:
# ╟─7112d37e-9f1e-11ed-313d-11843dc0a14e
# ╟─12feb970-e7e0-4e96-b537-5afe8e82ac17
# ╟─318db32f-e76c-4a46-9557-bd93a660505a
# ╟─3023c427-e656-4468-951e-669952b3124b
# ╟─b71a0897-b1e3-4ea7-89e0-53ff4aca5e57
# ╠═5ba10044-c01a-486a-b6bd-bad198bf1960
# ╠═a1592cdc-0f2e-4794-96f7-328347b27481
# ╠═c32edfaf-5191-4428-b86f-4077222b1b06
# ╠═03970aa4-a5e1-44cf-b06f-dfabe28913d8
# ╠═fd229791-a4a5-4b59-8ca5-e694a25d698d
# ╟─0c3a53af-ff93-4a96-9cf4-375fbdde92d7
# ╟─0794c4fe-4ba6-4f8f-9cdc-fadd1a4d19a1
# ╠═3a776e14-85cc-49e7-8413-eb3891894aff
# ╠═49742693-693e-4957-ba26-c6e5774e6611
# ╠═0308eba7-ba4a-41f0-88f0-07fb89d99330
# ╟─8f65c483-9044-4f63-ba3a-22e03a3c35eb
# ╠═ec25630f-2ca7-421a-8559-3046144dd236
# ╠═b4435686-5dd2-433e-ae5d-bc3cba44a4f5
# ╠═690fe577-2bbe-4ccb-bdcd-b0c9df268b83
# ╠═28381a00-9a9d-4261-b91f-641c26416374
# ╠═33866077-cbec-45f6-a88e-5c787ede69cb
# ╠═647c5d92-70ff-4dad-a7ca-bff2c4ca6e68
# ╟─2afde0f1-3e70-4748-9288-72e9fdfe618b
# ╠═7bff0a07-01a3-4fae-8a47-7e8b1abd227b
# ╠═51f4c337-5028-4f4e-b5c4-2b0d72511705
# ╠═9c67e81e-ba70-444c-84db-7f0bf3390c03
# ╠═85a8ca28-45ef-4107-8c02-d3d04e2b7d7c
# ╠═5dfb5219-8e52-474a-9cad-08759092ecd2
# ╟─d8464a8d-93d0-4919-8065-e184f6844806
# ╠═cb5203c6-18dd-4f4d-831f-367d46780ab5
# ╠═02aea1f5-67f9-4486-ad10-5946afce4fb9
# ╠═27f74c2b-8f88-444c-a270-4e1c30cc9b70
# ╠═a20ffdbb-f006-408e-a8a1-fc4dc1c4c7b5
# ╟─1c871074-ba8e-44f2-a3db-108b8c84fd67
# ╠═c936cf70-968c-467f-9587-899d938466ef
# ╠═e6e5cb2a-a0cd-4232-9d62-25ca0b74a6ee
# ╠═d0d2bbc8-df71-4824-b86e-f0cf6b537278
# ╠═cea94f06-91ab-4a51-8b9e-b148e37ef359
# ╟─ca80e6c1-ec90-40ab-8422-ba056ca499eb
# ╟─2eed0d35-7904-448c-bfe3-ab54c3207fea
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

using Braket, Braket.Observables, Test, LinearAlgebra, OrderedCollections, JSON3
using Braket: Instruction, Result, VIRTUAL, PHYSICAL, OpenQASMSerializationProperties, OpenQasmProgram

@testset "Circuit" begin
    @testset "Build basic circuit" begin
        @testset "with Int qubits" begin
            c = Circuit()
            H(c, 0)
            CNot(c, 0, 1)
            @test qubit_count(c) == 2
            @test depth(c) == 2
            c = Circuit()
            H(c, 0, 1, 2)
            Rx(c, 0, 1, 2, 0.5)
            @test qubit_count(c) == 3
            @test depth(c) == 2
            c = Circuit()
            CNot(c, [0, 1])
            CPhaseShift(c, [0, 1], 0.5)
            XX(c, [0, 1], 0.2)
            Swap(c, [0, 1])
            @test qubit_count(c) == 2
            @test depth(c) == 4
            c = Circuit()
            CSwap(c, [0, 1, 2])
            CCNot(c, [0, 1, 2])
            @test qubit_count(c) == 3
            @test depth(c) == 2
        end
        @testset "with Qubit qubits" begin
            c = Circuit()
            H(c, Qubit(0))
            CNot(c, Qubit(0), Qubit(1))
            @test qubit_count(c) == 2
            @test depth(c) == 2
            c = Circuit()
            H(c, Qubit(0), Qubit(1), Qubit(2))
            Rx(c, Qubit(0), Qubit(1), Qubit(2), 0.5)
            @test qubit_count(c) == 3
            @test depth(c) == 2
            c = Circuit()
            CNot(c, [Qubit(0), Qubit(1)])
            CPhaseShift(c, [Qubit(0), Qubit(1)], 0.5)
            XX(c, [Qubit(0), Qubit(1)], 0.2)
            Swap(c, [Qubit(0), Qubit(1)])
            @test qubit_count(c) == 2
            @test depth(c) == 4
            c = Circuit()
            CSwap(c, [Qubit(0), Qubit(1), Qubit(2)])
            CCNot(c, [Qubit(0), Qubit(1), Qubit(2)])
            @test qubit_count(c) == 3
            @test depth(c) == 2
        end
        @testset "with a mix" begin
            c = Circuit()
            H(c, Qubit(0))
            CNot(c, QubitSet([Qubit(0), 1]))
            @test qubit_count(c) == 2
            @test depth(c) == 2
            c = Circuit()
            H(c, QubitSet([Qubit(0), 1, Qubit(2)]))
            Rx(c, [Qubit(0), 1, Qubit(2)], 0.5)
            @test qubit_count(c) == 3
            @test depth(c) == 2
            c = Circuit()
            CNot(c, [Qubit(0), 1])
            CPhaseShift(c, QubitSet([Qubit(0), 1]), 0.5)
            XX(c, [Qubit(0), 1], 0.2)
            Swap(c, [Qubit(0), 1])
            @test qubit_count(c) == 2
            @test depth(c) == 4
            c = Circuit()
            CSwap(c, QubitSet([Qubit(0), 1, Qubit(2)]))
            CCNot(c, [Qubit(0), 1, Qubit(2)])
            @test qubit_count(c) == 3
            @test depth(c) == 2
        end
        @testset "with functors" begin
            c = Circuit()
            CSwap(c, QubitSet([Qubit(0), 1, Qubit(2)]))
            CCNot(c, [Qubit(0), 1, Qubit(2)])
            c1 = Circuit()
            c1(CSwap, QubitSet([Qubit(0), 1, Qubit(2)]))
            c1(CCNot, [Qubit(0), 1, Qubit(2)])
            @test c1 == c

            c = Circuit()
            CNot(c, [Qubit(0), 1])
            CPhaseShift(c, QubitSet([Qubit(0), 1]), 0.5)
            XX(c, [Qubit(0), 1], 0.2)
            Swap(c, [Qubit(0), 1])
            c1 = Circuit()
            c1(CNot, Qubit(0), 1)
            c1(CPhaseShift, QubitSet([Qubit(0), 1]), 0.5)
            c1(XX, [Qubit(0), 1], 0.2)
            c1(Swap, Qubit(0), 1)
            @test c == c1
            gate_list = [(CNot, Qubit(0), 1), (CPhaseShift, QubitSet([Qubit(0), 1]), 0.5), (XX, [Qubit(0), 1], 0.2), (Swap, Qubit(0), 1)]
            c2 = Circuit(gate_list)
            @test c2 == c

            c = Circuit()
            c(H, collect(0:10))
            @test qubits(c) == QubitSet(collect(0:10))
            @test length(c.instructions) == qubit_count(c)

            c = Circuit()
            c(X(), 0)
            c(StartVerbatimBox())
            @test qubits(c) == QubitSet(0)
            @test length(c.instructions) == 2
        end
    end

    @testset "Add circuits" begin
        c1 = Circuit()
        c1 = H(c1, 0)
        c1 = CNot(c1, 0, 1)
        c2 = Circuit()
        angle = rand()
        c2 = XX(c2, 1, 2, angle)
        c1 = append!(c1, c2)
        @test qubit_count(c1) == 3
        @test depth(c1) == 3

        c3 = Circuit()
        c3(H, 0)
        c3(CNot, 0, 1)
        c4 = Circuit([(XX, 1, 2, angle)])
        c3(c4)
        @test c3 == c1
    end

    @testset "Add circuits with targets" begin
        c1 = Circuit()
        c1 = H(c1, collect(0:10))
        c1 = CNot(c1, 0, 1)
        c2 = Circuit()
        c2 = XX(c2, 0, 1, rand())
        c1 = append!(c1, c2, QubitSet([5, 6]))
        c3 = Circuit()
        c3 = ZZ(c3, 1, 2, rand())
        c1 = append!(c1, c3, Dict(1=>4, 2=>1))
        @test qubit_count(c1) == 11
        @test depth(c1) == 3
        c1 = Circuit()
        c1 = Braket.add_instruction!(c1, Instruction(H(), 0), OrderedSet(0:10))
        c1 = Braket.add_instruction!(c1, Instruction(CNot(), [1, 2]), OrderedSet([5, 6]))
        @test collect(values(c1.moments))[1:end-1] == [Instruction(H(), q) for q in 0:10]
        @test collect(values(c1.moments))[end] == Instruction(CNot(), [5, 6])
    end

    @testset "Applying result types" begin
        c = Circuit()
        c = H(c, collect(0:10))
        states = [repeat("0", qubit_count(c)), repeat("1", qubit_count(c))]
        c = Amplitude(c, states)
        @test c.result_types == [Amplitude(states)]
        c = Probability(c, [1, 2])
        @test c.result_types == [Amplitude(states), Probability([1, 2])]
        c = Circuit()
        c = H(c, collect(0:10))
        c = DensityMatrix(c)
        @test c.result_types == [DensityMatrix()]
        c = Circuit()
        c = H(c, collect(0:10))
        c = DensityMatrix(c, 1, 2)
        @test c.result_types == [DensityMatrix(1, 2)]

        c = Circuit()
        c(H, collect(0:10))
        c(Amplitude, states)
        @test c.result_types == [Amplitude(states)]
        c(Probability([1, 2]))
        @test c.result_types == [Amplitude(states), Probability([1, 2])]

        c = Circuit()
        c(H, collect(0:10))
        c([(Amplitude, states), (Probability, 1, 2)])
        @test c.result_types == [Amplitude(states), Probability([1, 2])]
    end

    @testset "Observable Results" begin
        @testset "functor application of results" begin
            c = Circuit([(H, collect(0:10))])
            c([(Expectation, Braket.Observables.Z(), 0), (Expectation, Braket.Observables.X(), 1), (Expectation, ["X", "X"], [2, 3])])
            @test length(c.result_types) == 3
            @test c.observables_simultaneously_measureable
            c(Expectation, Braket.Observables.X(), 0)
            @test !c.observables_simultaneously_measureable
        end
        c = Circuit()
        c = H(c, collect(0:10))
        c = Expectation(c, Braket.Observables.Z(), 0)
        c = Expectation(c, Braket.Observables.X(), 1)
        c = Expectation(c, ["X", "X"], [2, 3])
        @test c.observables_simultaneously_measureable
        c = Expectation(c, Braket.Observables.X(), 0)
        @test !c.observables_simultaneously_measureable
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 1)
        c = Circuit()
        c = H(c, collect(0:10))
        c = Expectation(c, Braket.Observables.Z())
        @test c.observables_simultaneously_measureable
        c = Circuit()
        c = H(c, collect(0:10))
        c = Expectation(c, "Z")
        @test c.observables_simultaneously_measureable
        c = Circuit()
        c = H(c, collect(0:10))
        c = Expectation(c, "Z", 1)
        c = Expectation(c, "X", [3, 4, 5])
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        tp = Braket.Observables.TensorProduct([ho, ho])
        c = Variance(c, tp, [6, 7, 8, 9])
        @test c.observables_simultaneously_measureable
        c = Variance(c, Braket.Observables.X())
        @test !c.observables_simultaneously_measureable
        c = Circuit()
        c = H(c, collect(0:1))
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        c = Expectation(c, ho, [0, 1])
        c = Variance(c, ho, [0, 1])
        @test c.observables_simultaneously_measureable

        c = Circuit()
        c = H(c, collect(0:1))
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        c = Expectation(c, ho, [0, 1])
        c = Variance(c, ho, [0, 1])
        @test c.observables_simultaneously_measureable

        c = Circuit()
        c = H(c, collect(0:1))
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        c = Expectation(c, ho, [0, 1])
        c = Variance(c, ho, [0, 1])
        n = [1. -im; im -1.]
        no = Braket.Observables.HermitianObservable(kron(n,n,n))
        c = Z(c, 2)
        c = Variance(c, no, Int[])
        @test !c.observables_simultaneously_measureable

        c = Circuit()
        c = H(c, collect(0:1))
        m = [1. -im; im -1.]
        n = [-1. im; -im 1.]
        ho = Braket.Observables.HermitianObservable(kron(m, n))
        c = Expectation(c, ho, [0, 1])
        c = Expectation(c, ho, [1, 0])
        @test !c.observables_simultaneously_measureable

        c = Circuit()
        c = H(c, collect(0:1))
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        c = Expectation(c, ho, Int[])
        c = Variance(c, ho, Int[])
        @test c.observables_simultaneously_measureable

        tp = Braket.Observables.TensorProduct([ho, ho])
        c = Circuit()
        c = H(c, collect(0:3))
        c = Expectation(c, tp, [0, 1, 2, 3])
        c = Variance(c, tp, [0, 1, 2, 3])
        @test c.observables_simultaneously_measureable

        c = Circuit()
        c = H(c, collect(0:3))
        c = Expectation(c, Braket.Observables.Y(), [0])
        c = Probability(c)
        @test !c.observables_simultaneously_measureable
        c = Circuit()
        c = H(c, collect(0:3))
        c = Expectation(c, Braket.Observables.Z(), [0])
        c = Probability(c)
        @test c.observables_simultaneously_measureable
    end
    @testset "Adjoint gradient" begin
        α = FreeParameter(:alpha)
        op  = 2.0 * Braket.Observables.X() * Braket.Observables.X()
        op2 = 2.0 * Braket.Observables.Y() * Braket.Observables.Y()
        @testset for targets ∈ ([QubitSet(0, 1)], [[0, 1]], [0, 1], QubitSet(0, 1))
            c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)])
            c = AdjointGradient(c, op, targets, [α])
            @test length(c.result_types) == 1
            @test c.result_types[1] isa AdjointGradient
            @test c.result_types[1].observable == op
            @test c.result_types[1].targets == [QubitSet(0, 1)]
            @test c.result_types[1].parameters == ["alpha"]
            @test_throws ArgumentError AdjointGradient(c, op2, [QubitSet(0, 1)], [α])
        end

        c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)])
        op  = 2.0 * Braket.Observables.X() * Braket.Observables.X()
        @test_throws DimensionMismatch AdjointGradient(c, op, [QubitSet(0)], [α])
        op3 = op + op2
        @test_throws DimensionMismatch AdjointGradient(c, op3, [QubitSet(0, 1)], [α])
        
        op  = 2.0 * Braket.Observables.X()
        c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)])
        c = AdjointGradient(c, op, 0, [α])
        @test c.result_types[1].targets == [QubitSet(0)]

        # make sure qubit count is correct
        α = FreeParameter(:alpha)
        c = Circuit([(H, 0), (H, 1), (Rx, 0, α), (Rx, 1, α)])
        op  = 2.0 * Braket.Observables.X() * Braket.Observables.X()
        @test qubit_count(c) == 2
        c = AdjointGradient(c, op, [QubitSet(1, 2)], [α])
        @test qubit_count(c) == 3
    end
    @testset "Basis rotation instructions" begin
        @testset "Basic" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.X(), 0)
            p = Braket.Program(circ)
            expected_ixs = [Instruction(H(), 0), Instruction(CNot(), [0, 1])]
            expected_rts = [Braket.IR.Sample(["x"], [0], "sample")]
            expected_bris = [Instruction(H(), 0)]

            @test p.instructions == expected_ixs
            @test p.results == expected_rts
            @test p.basis_rotation_instructions == expected_bris
            
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.Y(), 0)
            p = Braket.Program(circ)
            expected_ixs = [Instruction(H(), 0), Instruction(CNot(), [0, 1])]
            expected_rts = [Braket.IR.Sample(["y"], [0], "sample")]
            expected_bris = [Instruction(Z(), 0), Instruction(S(), 0), Instruction(H(), 0)]

            @test p.instructions == expected_ixs
            @test p.results == expected_rts
            @test p.basis_rotation_instructions == expected_bris
            
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.Z(), 0)
            p = Braket.Program(circ)
            expected_ixs = [Instruction(H(), 0), Instruction(CNot(), [0, 1])]
            expected_rts = [Braket.IR.Sample(["z"], [0], "sample")]
            expected_bris = Instruction[]

            @test p.instructions == expected_ixs
            @test p.results == expected_rts
            @test p.basis_rotation_instructions == expected_bris

            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.I(), 0)
            p = Braket.Program(circ)
            expected_ixs = [Instruction(H(), 0), Instruction(CNot(), [0, 1])]
            expected_rts = [Braket.IR.Sample(["i"], [0], "sample")]
            expected_bris = Instruction[]

            @test p.instructions == expected_ixs
            @test p.results == expected_rts
            @test p.basis_rotation_instructions == expected_bris

            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.TensorProduct(["x", "h"]), 0, 1)
            p = Braket.Program(circ)
            expected_ixs = [Instruction(H(), 0), Instruction(CNot(), [0, 1])]
            expected_rts = [Braket.IR.Sample(["x", "h"], [0, 1], "sample")]
            expected_bris = [Instruction(H(), 0), Instruction(Ry(-π/4), 1)]

            @test p.instructions == expected_ixs
            @test p.results == expected_rts
            @test p.basis_rotation_instructions == expected_bris
        end
        @testset "Observable on all qubits" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.Y())
            expected = [
                Instruction(Z(), 0),
                Instruction(S(), 0),
                Instruction(H(), 0),
                Instruction(Z(), 1),
                Instruction(S(), 1),
                Instruction(H(), 1),
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "with target" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Expectation, Observables.X(), 0)
            expected = [Instruction(H(), 0)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "tensor product" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            obs =  Observables.X() * Observables.Y() * Observables.Y()
            circ(Expectation, obs, [0, 1, 2])
            expected = [
                Instruction(H(), 0),
                Instruction(Z(), 1),
                Instruction(S(), 1),
                Instruction(H(), 1),
                Instruction(Z(), 2),
                Instruction(S(), 2),
                Instruction(H(), 2),
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
            @test Braket.basis_rotation_gates(obs) == ((H(),), (Z(), S(), H()), (Z(), S(), H()))
        end
        @testset "tensor product with shared target" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Expectation, Observables.X() * Observables.Y() * Observables.Y(), [0, 1, 2])
            circ(Expectation, Observables.X() * Observables.Y(), [0, 1])
            expected = [
                Instruction(H(), 0),
                Instruction(Z(), 1),
                Instruction(S(), 1),
                Instruction(H(), 1),
                Instruction(Z(), 2),
                Instruction(S(), 2),
                Instruction(H(), 2),
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "identity" begin
            circ = Circuit([(H, 0), (CNot, 0, 1), (CNot, 1, 2), (CNot, 2, 3), (CNot, 3, 4)])
            circ(Expectation, Observables.X(), 0)
            circ(Expectation, Observables.I(), 2)
            circ(Expectation, Observables.I() * Observables.Y(), [1, 3])
            circ(Expectation, Observables.I(), 0)
            circ(Expectation, Observables.X() * Observables.I(), [1, 3])
            circ(Expectation, Observables.Y(), 2)
            expected = [
                Instruction(H(), 0),
                Instruction(H(), 1),
                Instruction(Z(), 2),
                Instruction(S(), 2),
                Instruction(H(), 2),
                Instruction(Z(), 3),
                Instruction(S(), 3),
                Instruction(H(), 3),
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types different targets" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Expectation, Observables.X(), 0)
            circ(Sample, Observables.H(), 1)
            expected = [Instruction(H(), 0), Instruction(Ry(-π/4), 1)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types same target" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            tp = Observables.H() * Observables.X()
            circ(Expectation, tp, [0, 1])
            circ(Sample, tp, [0, 1])
            circ(Variance, tp, [0, 1])
            expected = [Instruction(Ry(-π/4), 0), Instruction(H(), 1)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, all specified, same targets" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Expectation, Observables.H())
            circ(Sample, Observables.H(), 0)
            expected = [Instruction(Ry(-π/4), 0), Instruction(Ry(-π/4), 1)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, specified, all same targets" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            circ(Sample, Observables.H(), 0)
            circ(Expectation, Observables.H())            
            expected = [Instruction(Ry(-π/4), 0), Instruction(Ry(-π/4), 1)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, same targets, hermitian" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            mat = [1 0; 0 -1]
            ho = Observables.HermitianObservable(mat)
            circ(Sample, ho, 1)
            circ(Expectation, ho, 1)            
            expected = [Instruction(Unitary([0 1; 1 0]), 1)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, multiple targets, multiple hermitian" begin
            circ = Circuit([(H, 0), (CNot, 0, 1)])
            mat1 = [1 0; 0 -1]
            mat2 = [0 1; 1 0]
            ho1 = Observables.HermitianObservable(mat1)
            ho2 = Observables.HermitianObservable(mat2)
            circ(Sample, ho1, 1)
            circ(Expectation, ho2, 0)            
            expected = [
                Instruction(Unitary(1/√2 * [-1.0 1.0; 1.0 1.0]), 0),
                Instruction(Unitary([0 1; 1 0]), 1)
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, tensor product & hermitian" begin
            circ = Circuit([(H, 0), (CNot, 0, 1), (CNot, 1, 2)])
            mat1 = [1 0; 0 -1]
            mat2 = [0 1; 1 0]
            ho1 = Observables.HermitianObservable(mat1)
            ho2 = Observables.HermitianObservable(mat2)
            circ(Sample, ho1 * Observables.H(), [0, 1])
            circ(Variance, ho1 * Observables.H(), [0, 1])     
            circ(Expectation, ho2, 2)

            expected = [
                Instruction(Unitary([0 1; 1 0]), 0),
                Instruction(Ry(-π/4), 1),
                Instruction(Unitary(1/√2 * [-1.0 1.0; 1.0 1.0]), 2)
            ]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, tensor product & 2-qubit hermitian" begin
            circ = Circuit([(H, 0), (CNot, 0, 1), (CNot, 1, 2)])
            ho = Observables.HermitianObservable(diagm(ones(4)))
            circ(Expectation, Observables.I(), 1)
            circ(Sample, ho * Observables.H(), [0, 1, 2])
            circ(Variance, Observables.H(), 2)
            circ(Variance, ho, [0, 1])
            circ(Expectation, Observables.I(), 0)
            expected = [Instruction(Unitary(diagm(ones(4))), [0, 1]), Instruction(Ry(-π / 4), 2)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
        @testset "multiple result types, tensor product, probability" begin
            circ = Circuit([(H, 0), (CNot, 0, 1), (CNot, 1, 2)])
            circ(Probability, 0, 1)
            circ(Sample, Observables.Z() * Observables.Z() * Observables.H(), [0, 1, 2])
            circ(Variance, Observables.H(), 2)
            expected = [Instruction(Ry(-π / 4), 2)]
            Braket.basis_rotation_instructions!(circ)
            @test circ.basis_rotation_instructions == expected
        end
    end
    @testset "Circuit and shots validation" begin
        c = Circuit()
        c = H(c, collect(0:10))
        c = Expectation(c, Braket.Observables.Z(), 0)
        c = Expectation(c, Braket.Observables.X(), 1)
        c = Variance(c, ["X", "X"], [2, 3])
        @test c.observables_simultaneously_measureable
        c = Expectation(c, Braket.Observables.X(), 0)
        @test !c.observables_simultaneously_measureable
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 1)
        c = Circuit()
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 0)
        c = Circuit()
        c = H(c, collect(0:10))
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 0)
        c = Amplitude(c, prod("0" for q in 1:10))
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 10)
        c = Circuit()
        c = H(c, collect(0:10))
        c = StateVector(c)
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 10)
        c = Circuit()
        c = H(c, collect(0:41))
        c = Probability(c)
        @test_throws ErrorException Braket.validate_circuit_and_shots(c, 10)
    end

    @testset "Observables" begin
        @test JSON3.read(JSON3.write(StateVector()), Result) == StateVector()
        states = [repeat("0", 4)]
        @test JSON3.read(JSON3.write(Amplitude(states)), Result) == Amplitude(states)
        targs = [1, 2, 4]
        @test JSON3.read(JSON3.write(Probability(targs)), Result) == Probability(targs)
        @test JSON3.read(JSON3.write(DensityMatrix(targs)), Result) == DensityMatrix(targs)
        @testset for o in ("x", ["x", "y", "z"])
            @test JSON3.read(JSON3.write(Sample(o, targs)), Result) == Sample(o, targs)
            @test JSON3.read(JSON3.write(Expectation(o, targs)), Result) == Expectation(o, targs)
            @test JSON3.read(JSON3.write(Variance(o, targs)), Result) == Variance(o, targs)
        end
        @testset "remap" begin
            for o_typ in [Expectation, Variance, Sample]
                obs = ["x", "y"]
                o = o_typ(obs, [0, 1])
                new_o = Braket.remap(o, Dict(0=>5, 1=>3))
                @test new_o == o_typ(obs, [5, 3])
                new_o = Braket.remap(o, [5, 3])
                @test new_o == o_typ(obs, [5, 3])
                new_o = Braket.remap(o, QubitSet(Qubit(5), Qubit(3)))
                @test new_o == o_typ(obs, QubitSet(Qubit(5), Qubit(3)))
            end 
        end
    end

    @testset "Moments" begin
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        c = XX(c, 1, 2, rand())
        c = Braket.apply_initialization_noise!(c, [BitFlip(0.2), PhaseFlip(0.1)])
        c = Braket.apply_readout_noise!(c, [BitFlip(0.2), PhaseFlip(0.1)])
        ts = Braket.time_slices(c.moments)
        @test length(ts) == depth(c)
        s = sprint(show, c.moments)
        sd = sprint(show, c.moments._max_times)
        @test s == "Circuit moments:\nMax times: $sd\n"

        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        c = XX(c, 1, 2, rand())
        c = Braket.apply_initialization_noise!(c, BitFlip(0.2), 0)
        c = Braket.apply_readout_noise!(c, PhaseFlip(0.1), 0)
        ts = Braket.time_slices(c.moments)
        @test length(ts) == depth(c)
        s = sprint(show, c.moments)
        sd = sprint(show, c.moments._max_times)
        @test s == "Circuit moments:\nMax times: $sd\n"
    end

    @testset "Mapped result types" begin
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        c = CNot(c, 1, 2)
        c = Braket.add_result_type!(c, Probability([0, 1]), QubitSet([0, 2]))
        c = Braket.add_result_type!(c, DensityMatrix([0, 1]), Dict(0=>1, 1=>2))
        @test c.result_types == [Probability([0, 2]), DensityMatrix([1, 2])]
    end

    @testset "Noise" begin
        c = Circuit()
        c = H(c, collect(0:4))
        c = Braket.apply_initialization_noise!(c, [BitFlip(0.2), PhaseFlip(0.1)])
        expected = vcat([Instruction(BitFlip(0.2), q) for q in 0:4], [Instruction(PhaseFlip(0.1), q) for q in 0:4], [Instruction(H(), q) for q in 0:4])
        for (ixs, exs) in zip(values(c.moments), expected)
            @test ixs == exs
        end
        c = Circuit()
        c = H(c, collect(0:4))
        c = Braket.apply_initialization_noise!(c, BitFlip(0.2), [0, 4])
        @test collect(values(c.moments)) == vcat([Instruction(BitFlip(0.2), q) for q in [0,4]], [Instruction(H(), q) for q in 0:4])
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        angle = rand()
        c = XX(c, 1, 2, angle)
        c = Braket.apply_initialization_noise!(c, BitFlip(0.2))
        c = Braket.apply_readout_noise!(c, PhaseFlip(0.2))
        c = Braket.apply_gate_noise!(c, PauliChannel(0.2, 0.1, 0.2))
        c = Braket.apply_gate_noise!(c, BitFlip(0.2), XX(angle), 1)
        g_ns = [Instruction(H(), 0), Instruction(PauliChannel(0.2, 0.1, 0.2), 0), Instruction(CNot(), [0, 1]), Instruction(PauliChannel(0.2, 0.1, 0.2), 0), Instruction(PauliChannel(0.2, 0.1, 0.2), 1), Instruction(XX(angle), [1, 2]), Instruction(BitFlip(0.2), 1), Instruction(PauliChannel(0.2, 0.1, 0.2), 1), Instruction(PauliChannel(0.2, 0.1, 0.2), 2)]
        for (ix1, ix2) in zip(values(c.moments), vcat([Instruction(BitFlip(0.2), q) for q in qubits(c)], g_ns, [Instruction(PhaseFlip(0.2), q) for q in qubits(c)]))
            @test ix1 == ix2
        end
        ccz_mat = Matrix(Diagonal(ones(ComplexF64, 2^3)))
        ccz_mat[end,end] = -one(ComplexF64)
        c = Circuit()
        c = H(c, [0, 1, 2])
        c = Unitary(c, [0, 1, 2], ccz_mat)
        c = H(c, [0, 1, 2])
        c = Braket.apply_gate_noise!(c, BitFlip(0.2), ccz_mat)
        c = Braket.apply_gate_noise!(c, PhaseFlip(0.25), ccz_mat, 0)
        g_ns = [Instruction(H(), 0), Instruction(H(), 1), Instruction(H(), 2), Instruction(Unitary(ccz_mat), [0, 1, 2]), Instruction(PhaseFlip(0.25), 0), Instruction(BitFlip(0.2), 0), Instruction(BitFlip(0.2), 1),  Instruction(BitFlip(0.2), 2), Instruction(H(), 0), Instruction(H(), 1), Instruction(H(), 2)]
        for (ix1, ix2) in zip(values(c.moments), g_ns)
            @test ix1 == ix2
        end
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        angle = rand()
        c = XX(c, 1, 2, angle)
        c = Braket.apply_gate_noise!(c, TwoQubitDephasing(0.2), CNot())
        g_ns = [Instruction(H(), 0), Instruction(CNot(), [0, 1]), Instruction(TwoQubitDephasing(0.2), [0, 1]), Instruction(XX(angle), [1, 2])]
        for (ix1, ix2) in zip(values(c.moments), g_ns)
            @test ix1 == ix2
        end
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        c = CNot(c, 1, 2)
        c = Braket.apply_gate_noise!(c, TwoQubitDephasing(0.2), CNot(), [0, 1])
        g_ns = [Instruction(H(), 0), Instruction(CNot(), [0, 1]), Instruction(TwoQubitDephasing(0.2), [0, 1]), Instruction(CNot(), [1, 2])]
        for (ix1, ix2) in zip(values(c.moments), g_ns)
            @test ix1 == ix2
        end
        c = Circuit()
        c = H(c, 0)
        c = CNot(c, 0, 1)
        c = CNot(c, 1, 2)
        c = Braket.apply_gate_noise!(c, [BitFlip(0.1), TwoQubitDephasing(0.2)], CNot(), [0, 1])
        g_ns = [Instruction(H(), 0), Instruction(CNot(), [0, 1]), Instruction(BitFlip(0.1), 0), Instruction(BitFlip(0.1), 1), Instruction(TwoQubitDephasing(0.2), [0, 1]), Instruction(CNot(), [1, 2]), Instruction(BitFlip(0.1), 1)]
        @test collect(values(c.moments)) == g_ns
        g_ns = vcat([Instruction(TwoQubitDephasing(0.2), [0, 2])], g_ns)
        c = Braket.apply_initialization_noise!(c, TwoQubitDephasing(0.2), [0, 2])
        @test collect(values(c.moments)) == g_ns
        c = Braket.apply_readout_noise!(c, TwoQubitDephasing(0.15), [0, 2])
        g_ns = vcat(g_ns, [Instruction(TwoQubitDephasing(0.15), [0, 2])])
        @test collect(values(c.moments)) == g_ns
        c = Braket.apply_readout_noise!(c, [BitFlip(0.2), PhaseFlip(0.3)])
        g_ns = vcat(g_ns, [Instruction(BitFlip(0.2), q) for q in qubits(c)], [Instruction(PhaseFlip(0.3), q) for q in qubits(c)])
        for (ix1, ix2) in zip(values(c.moments), g_ns)
            @test ix1 == ix2
        end

        c = Circuit()
        c = H(c, collect(0:1))
        c = Braket.apply_initialization_noise!(c, BitFlip(0.2))
        c = Braket.apply_initialization_noise!(c, PhaseFlip(0.2))
        @test depth(c) == 1
    end

    @testset "Compiler Directives" begin
        c1 = H(Circuit(), 0)
        c2 = CNot(Circuit(), 0, 1)
        @test !c1.has_compiler_directives
        c1 = Braket.add_verbatim_box!(c1, c2)
        @test c1.instructions == [Instruction(H(), 0), Instruction(Braket.StartVerbatimBox(), Int[]), Instruction(CNot(), [0, 1]), Instruction(Braket.EndVerbatimBox(), Int[])]
        @test c1.has_compiler_directives
        c3 = Circuit([(H, 0)])
        c3(StartVerbatimBox)
        c3(CNot, 0, 1)
        c3(EndVerbatimBox)
        @test c3 == c1

        c2 = StateVector(c2) 
        @test_throws ErrorException Braket.add_verbatim_box!(c1, c2)
        c1 = H(Circuit(), collect(0:6))
        c2 = CNot(Circuit(), 0, 1)
        c1 = Braket.add_verbatim_box!(c1, c2, [5, 6])
        comp_ixs = vcat([Instruction(H(), q) for q in 0:6], Instruction(Braket.StartVerbatimBox(), Int[]), Instruction(CNot(), [5, 6]), Instruction(Braket.EndVerbatimBox(), Int[]))
        @test c1.instructions == comp_ixs
    end

    @testset "add_to_qubit_observable_mapping!" begin
        m = [1. -im; im -1.]
        ho = Braket.Observables.HermitianObservable(kron(m, m))
        tp = Braket.Observables.TensorProduct([ho, ho])
        @testset for o in [ho, tp], targets in [Int[], collect(0:qubit_count(o)-1)]
            c = H(Circuit(), collect(0:qubit_count(o)-1))
            for q in 0:qubit_count(c)-1
                c = Braket.add_result_type!(c, Expectation(Braket.Observables.Z(), [q]))
            end
            @test c.observables_simultaneously_measureable
            c = Braket.add_to_qubit_observable_mapping!(c, o, targets)
            @test isempty(c.qubit_observable_mapping)
            @test isempty(c.qubit_observable_target_mapping)
            @test !c.observables_simultaneously_measureable

            for q in 0:qubit_count(c)-1
                c = Braket.add_result_type!(c, Expectation(Braket.Observables.Z(), [q]))
            end
            xp = Braket.Observables.TensorProduct(fill(Braket.Observables.X(), qubit_count(o)))
            c = H(Circuit(), collect(0:qubit_count(o)-1))
            @test c.observables_simultaneously_measureable
            c = Braket.add_result_type!(c, Expectation(xp, targets))
            c = Braket.add_result_type!(c, Expectation(o, targets))
            @test !c.observables_simultaneously_measureable
        end
    end

    @testset "Result types & OpenQASM" begin
        sum_obs = 2.0 * Observables.H() - 5.0 * Observables.Z() * Observables.X()
        herm = Observables.HermitianObservable(diagm(ones(2)))
        @testset for ir_bolus in [
            (Expectation(Braket.Observables.I(), 0), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result expectation i(q[0])",),
            (Expectation(Braket.Observables.I()), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result expectation i all",),
            (StateVector(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result state_vector",),
            (DensityMatrix(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result density_matrix",),
            (DensityMatrix([0, 2]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result density_matrix q[0], q[2]",),
            (DensityMatrix(0), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "#pragma braket result density_matrix \$0",),
            (Amplitude(["01", "10"]), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "#pragma braket result amplitude \"01\", \"10\"",),
            (AdjointGradient(Observables.H(), 0, ["alpha"]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(h(q[0])) alpha",),
            (AdjointGradient(Observables.H(), 0), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(h(q[0])) all",),
            (AdjointGradient(Observables.X() * Observables.Y(), [0, 1], []), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(x(q[0]) @ y(q[1])) all",),
            (AdjointGradient(Observables.H(), 0, []), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(h(q[0])) all",),
            (AdjointGradient(sum_obs, [[0], [1, 2]], ["alpha"]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(2.0 * h(q[0]) - 5.0 * z(q[1]) @ x(q[2])) alpha",),
            (AdjointGradient(sum_obs, [[0], [1, 2]]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(2.0 * h(q[0]) - 5.0 * z(q[1]) @ x(q[2])) all",),
            (AdjointGradient(sum_obs, [[0], [1, 2]], []), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(2.0 * h(q[0]) - 5.0 * z(q[1]) @ x(q[2])) all",),
            (AdjointGradient(herm, 0, []), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result adjoint_gradient expectation(hermitian([[1.0+0im, 0im], [0im, 1.0+0im]]) q[0]) all",),
            (Probability(), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result probability all",),
            (Probability([0, 2]), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result probability q[0], q[2]",),
            (Probability(0), OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "#pragma braket result probability \$0",),
            (Sample(Braket.Observables.I(), 0), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result sample i(q[0])",),
            (Sample(Braket.Observables.I()), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result sample i all",),
            (Variance(Braket.Observables.I(), 0), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result variance i(q[0])",),
            (Variance(Braket.Observables.I()), OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "#pragma braket result variance i all",),
        ]
            rt, sps, expected_ir = ir_bolus
            @test ir(rt, Val(:OpenQASM); serialization_properties=sps) == expected_ir
        end
    end

    @testset "full Circuits to OpenQASM" begin
        @testset for ir_bolus in [
            (Rx(Rx(Circuit(), 0, 0.15), 1, 0.3), OpenQASMSerializationProperties(VIRTUAL),
            OpenQasmProgram(join( [ "OPENQASM 3.0;", "bit[2] b;", "qubit[2] q;", "rx(0.15) q[0];", "rx(0.3) q[1];", "b[0] = measure q[0];", "b[1] = measure q[1];", ], "\n"))),
            (Rx(Rx(Circuit(), 0, 0.15), 4, 0.3), OpenQASMSerializationProperties(PHYSICAL), OpenQasmProgram(join([ "OPENQASM 3.0;", "bit[2] b;", "rx(0.15) \$0;", "rx(0.3) \$4;", "b[0] = measure \$0;", "b[1] = measure \$4;"], "\n"))),
            (Expectation(Braket.add_verbatim_box!(Rx(Circuit(), 0, 0.15), Rx(Circuit(), 4, 0.3)), Braket.Observables.I()), OpenQASMSerializationProperties(PHYSICAL),
            OpenQasmProgram(join(["OPENQASM 3.0;", "rx(0.15) \$0;", "#pragma braket verbatim", "box{", "rx(0.3) \$4;", "}", "#pragma braket result expectation i all"], "\n"))),
            (Expectation(BitFlip(Rx(Rx(Circuit(), 0, 0.15), 4, 0.3), 3, 0.2), Braket.Observables.I(), 0), nothing,
            OpenQasmProgram(join(["OPENQASM 3.0;", "qubit[5] q;", "rx(0.15) q[0];", "rx(0.3) q[4];", "#pragma braket noise bit_flip(0.2) q[3]", "#pragma braket result expectation i(q[0])"], "\n")))
        ]
            c, sps, expected_ir = ir_bolus
            if !isnothing(sps)
                generated_ir = ir(c, Val(:OpenQASM), serialization_properties=sps)
                @test generated_ir == expected_ir
            else
                @test ir(c, Val(:OpenQASM)) == expected_ir
            end
        end
        @testset "with parameters" begin
            a = FreeParameter("a")
            b = FreeParameter("b")
            c = Circuit([(H, [0, 1, 2]), (Rx, 0, a), (Ry, 1, b)])
            props = OpenQASMSerializationProperties(PHYSICAL)
            expected_ir = OpenQasmProgram(join([ "OPENQASM 3.0;", "input float a;", "input float b;", "bit[3] b;", "h \$0;", "h \$1;", "h \$2;", "rx(a) \$0;", "ry(b) \$1;", "b[0] = measure \$0;", "b[1] = measure \$1;", "b[2] = measure \$2;"], "\n"))
            generated_ir = ir(c, Val(:OpenQASM), serialization_properties=props)
            @test generated_ir == expected_ir
        end
    end
    @testset "pretty-printing" begin
        @testset "Circuit with FreeParameter" begin
            a = FreeParameter("α")
            c = Circuit([(H, collect(0:10)), (CNot, 0, 1), (CNot, 1, 3), (H, 2), (H, 2), (Rx, 0, a), (Expectation, Braket.Observables.TensorProduct(["x", "y"]), [0, 2]), (Variance, Braket.Observables.TensorProduct(["z", "x"]), [2, 1]), (Amplitude, "1111"), (Probability,)])
            d = Circuit([(H, 0), (X, 1)])
            c = Braket.add_verbatim_box!(c, d)
            s = sprint((io, x)->show(io, "text/plain", x), c)
            known_s = """
            T   : |0|1|  2   |      3      |4|     5     |                 Result Types                 |
                                                                                                         
            q0  : -H-C--Rx(α)-StartVerbatim-H-EndVerbatim-Expectation(X @ Y)-----------------Probability-
                     |        |               |           |                                  |           
            q1  : -H-X-C--------------------X--------------------------------Variance(Z @ X)-Probability-
                       |      |               |           |                  |               |           
            q2  : -H-H--H---------------------------------Expectation(X @ Y)-Variance(Z @ X)-Probability-
                       |      |               |                                              |           
            q3  : -H---X---------------------------------------------------------------------Probability-
                              |               |                                              |           
            q4  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q5  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q6  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q7  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q8  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q9  : -H-------------------------------------------------------------------------Probability-
                              |               |                                              |           
            q10 : -H----------StartVerbatim---EndVerbatim------------------------------------Probability-
                                                                                                         
            T   : |0|1|  2   |      3      |4|     5     |                 Result Types                 |

            Additional result types: Amplitude(1111)

            Unassigned parameters: α
            """
            @test s == known_s
        end
        @testset "Circuit with Noise" begin
            c = Circuit([(H, collect(0:10)), (BitFlip, 0, 0.2), (AmplitudeDamping, 0, 0.1), (Swap, 5, 9), (TwoQubitDepolarizing, 3, 7, 0.1), (DensityMatrix, [3, 4, 5])])
            s = sprint((io, x)->show(io, "text/plain", x), c)
            @test s == """T   : |            0             | 1  |Result Types |\n                                                     \nq0  : -H-BF(0.2)-AD(0.1)-----------------------------\n                                                     \nq1  : -H---------------------------------------------\n                                                     \nq2  : -H---------------------------------------------\n                                                     \nq3  : -H----------------DEPO(0.1)------Densitymatrix-\n                        |              |             \nq4  : -H-------------------------------Densitymatrix-\n                        |              |             \nq5  : -H--------------------------SWAP-Densitymatrix-\n                        |         |                  \nq6  : -H---------------------------------------------\n                        |         |                  \nq7  : -H----------------DEPO(0.1)--------------------\n                                  |                  \nq8  : -H---------------------------------------------\n                                  |                  \nq9  : -H--------------------------SWAP---------------\n                                                     \nq10 : -H---------------------------------------------\n                                                     \nT   : |            0             | 1  |Result Types |\n"""

        end
        @testset "Circuit with 3 qubit gates" begin
            c = Circuit([(H, [0, 1, 2]), (CCNot, [0, 2, 1]), (CPhaseShift, 1, 0, 0.2), (XX, 0, 2, 0.1)])
            s = sprint((io, x)->show(io, "text/plain", x), c)
            known_s = "T  : |0|1|    2     |   3   |Result Types|\n                                          \nq0 : -H-C-PHASE(0.2)-XX(0.1)--------------\n        | |          |                    \nq1 : -H-X-C-------------------------------\n        |            |                    \nq2 : -H-C------------XX(0.1)--------------\n                                          \nT  : |0|1|    2     |   3   |Result Types|\n" 
            @test s == known_s
        end
        @testset "Circuit with Unitary and Kraus" begin

        end
        @testset "chars fallback" begin
            @test Braket.chars('a') == ("a",)
        end
    end
end

module Observables

using JSON3, StructTypes, LinearAlgebra

import ..Braket: ir, qubit_count, complex_matrix_from_ir, complex_matrix_to_ir, Operator, SerializationProperties, format_qubits, format, format_matrix, OpenQASMSerializationProperties, IRType, QubitSet, Qubit, IntOrQubit, IRObservable, chars, PauliEigenvalues
export Observable, TensorProduct, HermitianObservable, Sum

"""
    Observable <: Operator

Abstract type representing an observable to be measured. All `Observable`s
have `eigvals` defined.

See also: [`H`](@ref), [`I`](@ref), [`X`](@ref), [`Y`](@ref), [`Z`](@ref), [`TensorProduct`](@ref), [`HermitianObservable`](@ref).
"""
abstract type Observable <: Operator end
abstract type NonCompositeObservable <: Observable end
abstract type StandardObservable <: NonCompositeObservable end

LinearAlgebra.ishermitian(o::Observable) = true

coef(o::O) where {O<:Observable} = o.coefficient

for (typ, label, super) in ((:H, "h", :StandardObservable), (:X, "x", :StandardObservable), (:Y, "y", :StandardObservable), (:Z, "z", :StandardObservable), (:I, "i", :NonCompositeObservable))
    @eval begin
        @doc """
            $($typ) <: Observable
            $($typ)([coeff::Float64]) -> $($typ)

        Struct representing a `$($typ)` observable in a measurement. The observable
        may be scaled by `coeff`.
        """
        struct $typ <: $super
            coefficient::Float64
            $typ(coef::Float64=1.0) = new(coef)
        end
        StructTypes.StructType(::Type{$typ}) = StructTypes.CustomStruct()
        StructTypes.lower(x::$typ) = [$label]
        qubit_count(o::$typ) = 1
        qubit_count(::Type{$typ}) = 1
        unscaled(o::$typ) = $typ()
        Base.copy(o::$typ) = $typ(o.coefficient)
        function ir(o::$typ, target::QubitSet, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
            target_str = isempty(target) ? " all" : "(" * format_qubits(target, serialization_properties) * ")"
            coef_str = isone(o.coefficient) ? "" : string(o.coefficient) * " * "
            return coef_str * $label * target_str 
        end
        ir(o::$typ, target::Nothing, ::Val{:OpenQASM}; kwargs...) = ir(o, QubitSet(),  Val(:OpenQASM); kwargs...)
        Base.:(*)(o::$typ, n::Real) = $typ(Float64(n*o.coefficient))
        Base.:(==)(o1::$typ, o2::$typ) = (o1.coefficient ≈ o2.coefficient)
        Base.show(io::IO, o::$typ) = print(io, (isone(o.coefficient) ? "" : string(o.coefficient) * " * ") * uppercase($label))
        chars(o::$typ) = (uppercase($label),)
    end
end
LinearAlgebra.eigvals(o::I) = [o.coefficient, o.coefficient]
LinearAlgebra.eigvals(o::StandardObservable) = [o.coefficient, -o.coefficient]

"""
    HermitianObservable <: Observable
    HermitianObservable(matrix::Matrix) -> HermitianObservable

Struct representing an observable of an arbitrary complex Hermitian matrix.

# Examples
```jldoctest
julia> ho = Braket.Observables.HermitianObservable([0 1; 1 0])
HermitianObservable((2, 2))
```
"""
struct HermitianObservable <: NonCompositeObservable
    matrix::Matrix{<:Complex}
    coefficient::Float64
    function HermitianObservable(mat::Matrix{<:Number})
        ishermitian(mat) || throw(ArgumentError("input matrix to HermitianObservable must be Hermitian."))
        new(complex(mat), 1.0)
    end
end
HermitianObservable(v::Vector{Vector{Vector{T}}}) where {T<:Number} = HermitianObservable(complex_matrix_from_ir(v))
Base.copy(o::HermitianObservable) = HermitianObservable(copy(o.matrix))
StructTypes.StructType(::Type{HermitianObservable}) = StructTypes.CustomStruct()
StructTypes.lower(x::HermitianObservable) = Union{String, Vector{Vector{Vector{Float64}}}}[complex_matrix_to_ir(ComplexF64.(x.matrix))]
Base.:(==)(h1::HermitianObservable, h2::HermitianObservable) = (size(h1.matrix) == size(h2.matrix) && h1.matrix ≈ h2.matrix)
qubit_count(o::HermitianObservable) = convert(Int, log2(size(o.matrix, 1)))
LinearAlgebra.eigvals(o::HermitianObservable) = eigvals(Hermitian(o.matrix))
unscaled(o::HermitianObservable) = o
function ir(ho::HermitianObservable, target::QubitSet, ::Val{:OpenQASM}; serialization_properties=OpenQASMSerializationProperties())
    function c_str(x::Number)
        iszero(real(x)) && iszero(imag(x)) && return "0im"
        iszero(real(x)) && return string(imag(x))*"im"
        iszero(imag(x)) && return string(real(x))*"+0im"
        imag_sign = imag(x) < 0 ? "" : "+"
        return string(real(x)) * imag_sign * string(imag(x)) * "im"
    end
    m = "[" * join(["["*join(c_str.(ho.matrix[i, :]), ", ")*"]" for i in 1:size(ho.matrix, 1)], ", ") * "]"
    t = isempty(target) ? "all" : format_qubits(target, serialization_properties)
    return "hermitian($m) $t"
end
Base.:(*)(o::HermitianObservable, n::Real) = HermitianObservable(Float64(n) .* o.matrix)
Base.show(io::IO, ho::HermitianObservable) = print(io, "HermitianObservable($(size(ho.matrix)))")
ir(ho::HermitianObservable, target::Nothing, ::Val{:OpenQASM}; kwargs...) = ir(ho, QubitSet(), Val(:OpenQASM); kwargs...)
chars(o::HermitianObservable) = ("Hermitian",)

"""
    TensorProduct <: Observable
    TensorProduct(factors::Vector{<:Observable}) -> TensorProduct
    TensorProduct(factors::Vector{String}) -> TensorProduct

Struct representing a tensor product of smaller observables.

# Examples
```jldoctest
julia> Braket.Observables.TensorProduct(["x", "h"])
X @ H

julia> ho = Braket.Observables.HermitianObservable([0 1; 1 0]);

julia> Braket.Observables.TensorProduct([ho, Braket.Observables.Z()])
HermitianObservable((2, 2)) @ Z
```
"""
struct TensorProduct{O} <: Observable where {O<:Observable}
    factors::Vector{O}
    coefficient::Float64
    function TensorProduct{O}(v::Vector{O}, coefficient::Float64=1.0) where {O<:NonCompositeObservable}
        coeff = coefficient
        flattened_v = Vector{O}(undef, length(v))
        for (oi, o) in enumerate(v)
            flattened_v[oi] = unscaled(o)
            coeff *= coef(o)
        end
        return new(flattened_v, coeff)
    end
    function TensorProduct{O}(v::Vector{O}, coefficient::Float64=1.0) where {O<:Observable}
        any(v_->v_ isa Sum, v) && throw(ArgumentError("Sum observable not allowed in TensorProduct."))
        coeff = prod(coef, v, init=coefficient)
        if VERSION >= v"1.9.0"
            flattened_v = Iterators.flatmap(v) do o 
                if o isa TensorProduct
                    return (unscaled(o) for o in o.factors)
                else
                    return (unscaled(o),)
                end
            end
        else
            mapped_v = map(v) do o 
                if o isa TensorProduct
                    return (unscaled(o) for o in o.factors)
                else
                    return (unscaled(o),)
                end
            end
            flattened_v = Iterators.flatten(mapped_v)
        end
        flat_v = collect(flattened_v)
        return new(flat_v, coeff)
    end
end
TensorProduct(o::Vector{T}, coefficient::Float64=1.0) where {T<:Union{String, Observable}} = TensorProduct{T}(o, coefficient)
function TensorProduct(o::Vector{String}, coefficient::Float64=1.0)
    return TensorProduct([StructTypes.constructfrom(Observable, s) for s in o], coefficient)
end

Base.:(*)(o::TensorProduct, n::Real) = TensorProduct(deepcopy(o.factors), Float64(n*o.coefficient))
function ir(tp::TensorProduct, target::QubitSet, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    factors = []
    use_qubits = collect(target)
    coef_str = isone(tp.coefficient) ? "" : "$(tp.coefficient) * "
    for obs in tp.factors
        obs_target = QubitSet()
        num_qubits = qubit_count(obs)
        for qi in 0:num_qubits-1
            q = popfirst!(use_qubits)
            union!(obs_target, q)
        end
        push!(factors, ir(obs, obs_target, Val(:OpenQASM), serialization_properties=serialization_properties))
    end
    return coef_str * join(factors, " @ ")
end
ir(tp::TensorProduct; kwargs...) = ir(tp, Val(IRType[]); kwargs...)
unscaled(o::TensorProduct) = TensorProduct(o.factors, 1.0)
qubit_count(o::TensorProduct) = sum(qubit_count.(o.factors))
StructTypes.StructType(::Type{TensorProduct{O}}) where {O<:Observable} = StructTypes.CustomStruct()
StructTypes.lower(x::TensorProduct{O}) where {O<:Observable} = Union{String, Vector{Vector{Vector{Float64}}}}[convert(Union{String, Vector{Vector{Vector{Float64}}}}, o) for o in mapreduce(StructTypes.lower, vcat, x.factors)]
Base.:(==)(t1::TensorProduct, t2::TensorProduct) = t1.factors == t2.factors && t1.coefficient ≈ t2.coefficient
Base.copy(t::TensorProduct) = TensorProduct(deepcopy(t.factors), t.coefficient)
_evs(os::Vector{O}, coeff::Float64=1.0) where {O<:StandardObservable} = PauliEigenvalues(Val(length(os)), coeff)
_evs(os::Vector{O}, coeff::Float64=1.0) where {O<:Observable} = mapfoldl(eigvals, kron, os, init=[coeff])::Vector{Float64}
LinearAlgebra.eigvals(o::TensorProduct{O}) where {O} = return _evs(o.factors, o.coefficient)
function Base.show(io::IO, o::TensorProduct)
    coef_str = isone(o.coefficient) ? "" : string(o.coefficient) * " * "
    print(io, coef_str)
    for f in o.factors[1:end-1]
        print(io, f)
        print(io, " @ ")
    end
    print(io, o.factors[end])
    return
end
chars(o::TensorProduct) = (sprint(show, o),)


"""
    Sum <: Observable
    Sum(summands::Vector{<:Observable}) -> Sum 

Struct representing the sum of observables.

# Examples
```jldoctest
julia> o1 = 2.0 * Braket.Observables.I() * Braket.Observables.Z();

julia> o2 = 3.0 * Braket.Observables.X() * Braket.Observables.X();

julia> o = o1 + o2
Sum(2.0 * I @ Z, 3.0 * X @ X)
```
"""
struct Sum <: Observable
    summands::Vector{Observable}
    coefficient::Float64
    function Sum(v)
        if VERSION >= v"1.9.0"
            flattened_v = Iterators.flatmap(v) do obs
                obs isa Sum ? obs.summands : (obs,)
            end
        else
            mapped_v = map(v) do obs
                obs isa Sum ? obs.summands : (obs,)
            end
            flattened_v = Iterators.flatten(mapped_v)
        end
        new(collect(flattened_v), 1.0)
    end
end
Base.length(s::Sum) = length(s.summands)
Base.:(*)(s::Sum, n::Real) = Sum(Float64(n) .* deepcopy(s.summands))
function Base.:(==)(s1::Sum, s2::Sum)
    length(s1) != length(s2) && return false
    are_eq = true
    for (summand1, summand2) in zip(s1.summands, s2.summands)
        are_eq &= (summand1 == summand2)
        are_eq || return false
    end
    return true
end
function Base.:(==)(s::Sum, o::Observable)
    length(s) == 1 || return false
    return first(s.summands) == o
end
Base.:(==)(o::Observable, s::Sum) = s == o
function Base.show(io::IO, s::Sum)
    print(io, "Sum(")
    for summand in s.summands[1:end-1]
        print(io, summand)
        print(io, ", ")
    end
    print(io, s.summands[end])
    print(io, ")")
    return
end
StructTypes.lower(s::Sum) = [StructTypes.lower(summand) for summand in s.summands]
ir(s::Sum, target::Vector{QubitSet}, ::Val{:JAQCD}; kwargs...) = throw(ErrorException("Sum observables are not supported in JAQCD."))
ir(s::Sum, target::Vector{<:IntOrQubit}, ::Val{:JAQCD}; kwargs...) = throw(ErrorException("Sum observables are not supported in JAQCD."))
function ir(s::Sum, target::Vector{QubitSet}, ::Val{:OpenQASM}; kwargs...)
    length(s.summands) == length(target) || throw(DimensionMismatch("number of summands ($(length(s.summands))) must match length of targets vector ($(length(targets)))."))
    for (ii, (term, term_target)) in enumerate(zip(s.summands, target))
        length(term_target) == qubit_count(term) || throw(DimensionMismatch("qubit count of term $ii ($(qubit_count(term))) must match number of targets ($(length(term_target)))."))
    end
    summands_irs = [ir(obs, targ, Val(:OpenQASM); kwargs...) for (obs, targ) in zip(s.summands, target)]
    sum_str = replace(join(summands_irs, " + "), "+ -"=>"- ")
    return sum_str
end
ir(s::Sum, target::Vector{Vector{T}}, ::Val{:OpenQASM}; kwargs...) where {T} = ir(s, [QubitSet(t) for t in target], Val(:OpenQASM); kwargs...)
chars(s::Sum) = ("Sum",)


StructTypes.StructType(::Type{Observable}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Observable}) = (i=I, h=H, x=X, y=Y, z=Z)
StructTypes.lowertype(::Type{O}) where {O<:Observable} = IRObservable
function StructTypes.constructfrom(::Type{Observable}, obj::String)
    (obj == "i" || obj == "I") && return I()
    (obj == "x" || obj == "X") && return X()
    (obj == "y" || obj == "Y") && return Y()
    (obj == "z" || obj == "Z") && return Z()
    (obj == "h" || obj == "H") && return H()
    throw(ArgumentError("Observable of type \"$obj\" provided, only \"i\", \"x\", \"y\", \"z\", and \"h\" are valid."))
end
StructTypes.constructfrom(::Type{Observable}, obj::Vector{String}) = length(obj) == 1 ? StructTypes.constructfrom(Observable, first(obj)) : TensorProduct(obj)
StructTypes.constructfrom(::Type{Observable}, obj::Vector{Vector{Vector{Float64}}}) = HermitianObservable(obj)
StructTypes.constructfrom(::Type{Observable}, obj::Vector{Vector{Vector{Vector{Float64}}}}) = length(obj) == 1 ? HermitianObservable(obj[1]) : TensorProduct(obj)
function StructTypes.constructfrom(::Type{Observable}, obj::Vector{T}) where {T}
    length(obj) == 1 && return StructTypes.constructfrom(Observable, obj[1])
    return TensorProduct([StructTypes.constructfrom(Observable, o) for o in obj])
end

Base.:(*)(o1::O1, o2::O2) where {O1<:Observable, O2<:Observable} = TensorProduct([o1, o2], 1.0)
Base.:(*)(n::Real, o::Observable) = o*n 
Base.:(+)(o1::Observable, o2::Observable) = Sum([o1, o2])
Base.:(-)(o1::Observable, o2::Observable) = Sum([o1, -1.0 * o2])

end

struct PyLocalSimulator <: Braket.AbstractBraketSimulator
    o::Py
    PyLocalSimulator() = new(local_sim.LocalSimulator())
    PyLocalSimulator(backend::String) = new(local_sim.LocalSimulator(backend))
end
(ls::PyLocalSimulator)(nq::Int, shots::Int) = ls
Braket.name(ls::PyLocalSimulator) = pyconvert(String, ls.name)
Braket.device_id(ls::PyLocalSimulator) = pyconvert(String, ls._delegate.DEVICE_ID)
Braket.properties(ls::PyLocalSimulator) = ls.properties
function Braket.simulate(d::PyLocalSimulator, task_spec::Braket.IR.AHSProgram; shots::Int=0, kwargs...)
    py_ir = Py(task_spec)
    py_raw_result = d._delegate.run(py_ir, shots; kwargs...)
    return pyconvert(Braket.AnalogHamiltonianSimulationTaskResult, py_raw_result)
end
Braket.simulate(d::PyLocalSimulator, task_spec::Braket.AnalogHamiltonianSimulation; shots::Int=0, kwargs...) = simulate(d, ir(task_spec); shots=shots, kwargs...)

function Braket._run_internal(simulator::PyLocalSimulator, task_spec::AnalogHamiltonianSimulation, args...; kwargs...)
    raw_py_result = simulator.run(Py(ir(task_spec)), args...; kwargs...).result()
    jl_task_metadata = pyconvert(Braket.TaskMetadata, raw_py_result.task_metadata) 
    jl_measurements = map(raw_py_result.measurements) do m
        jl_status = pyconvert(String, pystr(m.status))
        status = if jl_status == "Success"
                     Braket.success
                 elseif jl_status == "Partial_success"
                     Braket.partial_success
                 else
                     Braket.failure
                 end
        Braket.ShotResult(status,
                          pyconvert(Any, m.pre_sequence),
                          pyconvert(Any, m.post_sequence)
                         )
    end
    return Braket.AnalogHamiltonianSimulationQuantumTaskResult(jl_task_metadata, jl_measurements) 
end

(ls::PyLocalSimulator)(task_spec; kwargs...) = simulate(ls, task_spec; kwargs...)

Py(d::PyLocalSimulator) = getfield(d, :o)
Base.getproperty(d::PyLocalSimulator, s::Symbol)             = getproperty(Py(d), s)
Base.getproperty(d::PyLocalSimulator, s::AbstractString)     = getproperty(Py(d), s)
Base.setproperty!(d::PyLocalSimulator, s::Symbol, x)         = setproperty!(Py(d), s, x)
Base.setproperty!(d::PyLocalSimulator, s::AbstractString, x) = setproperty!(Py(d), s, x)

function parse_s3_uri(s::String)
    m1 = match(r"^https://([^./]+).[sS]3.[^/]+/(.*)$", s)
    m2 = match(r"^[sS]3://([^./]+)/(.*)$", s)
    s3_uri_match = isnothing(m1) ? m2 : m1
    try
        isnothing(s3_uri_match) && throw(ErrorException(""))
        bucket, key = s3_uri_match[1], s3_uri_match[2]
        (isnothing(bucket) || isnothing(key)) && throw(ErrorException(""))
        return String(bucket), String(key)
    catch
        throw(ErrorException("$s is not a valid S3 URI."))
    end
end

function is_s3_uri(s::String)
    try
        parse_s3_uri(s)
        return true
    catch
        return false
    end
end

function construct_s3_uri(bucket::String, dirs::String...)
    isempty(dirs) && throw(ArgumentError("not a valid S3 location: s3://$bucket"))
    return "s3://" * bucket * "/" * chop(prod(d*"/" for d in dirs), tail=1)
end

function default_bucket()
    haskey(ENV, "AMZN_BRAKET_OUT_S3_BUCKET") && return ENV["AMZN_BRAKET_OUT_S3_BUCKET"]
    default = "amazon-braket-" * aws_get_region() * "-" * aws_account_number(global_aws_config())
    default ∉ s3_list_buckets() && s3_create_bucket(default)
    return default
end

function upload_to_s3(fn::String, s3_uri::String)
    bucket, key = parse_s3_uri(s3_uri)
    s3_put(bucket, key, read(fn), "application/octet-stream")
    return
end

function upload_local_data(local_prefix::String, s3_prefix::String)
    base_dir        = isabspath(local_prefix) ? joinpath(splitpath(local_prefix)[1:end-1]...) : pwd()
    relative_prefix = isabspath(local_prefix) ? relpath(local_prefix, base_dir) : local_prefix
    @debug "Uploading local data with relative prefix $relative_prefix and base_dir $base_dir"
    isfile(relative_prefix) && return upload_to_s3(relative_prefix, s3_prefix)
    isdir(base_dir) || throw(ErrorException("uploading data $local_prefix to $s3_prefix failed!"))
    for (root, dirs, files) in walkdir(base_dir)
        fn_to_uri = Dict{String, String}()
        if root == base_dir
            fns = filter(x->startswith(x, relative_prefix), files)
            for fn in fns
                fn_to_uri[joinpath(base_dir, fn)] = replace(fn, relative_prefix=>s3_prefix)
            end
        elseif startswith(relpath(root, base_dir), relative_prefix)
            fns = map(fn->joinpath(relpath(root, base_dir), fn), files)
            for fn in fns
                fn_to_uri[joinpath(base_dir, fn)] = replace(fn, relative_prefix=>s3_prefix)
            end
        end
        for (fn, uri) in fn_to_uri
            @debug "$fn, is file? $(isfile(fn))"
            if !Sys.iswindows()
                @debug "Uploading $fn to S3 URI $uri"
                upload_to_s3(fn, uri)
            else
                upload_to_s3(fn, replace(uri, "\\"=>"/"))
            end
        end
    end
end

function copy_s3_directory(src_path::String, dst_path::String)
    src_path == dst_path && return
    src_bucket, src_prefix = parse_s3_uri(src_path)
    dst_bucket, dst_prefix = parse_s3_uri(dst_path)

    for key in s3_list_keys(src_bucket, src_prefix)
        s3_copy(src_bucket, key, to_bucket=dst_bucket, to_path=replace(key, src_prefix=>dst_prefix, count=1))
    end
    return
end

function complex_matrix_to_ir(m::Matrix{T}) where {T<:Complex}
    mat = Vector{Vector{Vector{real(T)}}}(undef, size(m, 1))
    for row in 1:size(m, 1)
        mat[row] = Vector{Vector{T}}(undef, size(m, 2))
        for col in 1:size(m, 2)
            mat[row][col] = [real(m[row, col]), imag(m[row, col])]
        end
    end
    return mat
end

function complex_matrix_from_ir(mat::Vector{Vector{Vector{T}}}) where {T<:Number}
    m = zeros(complex(T), length(mat), length(mat))
    for ii in 1:length(mat), jj in 1:length(mat)
        m[ii,jj] = complex(mat[ii][jj][1], mat[ii][jj][2])
    end
    return m
end

function complex_matrix_from_ir(mat::Vector{Vector{Vector{Any}}})
    m = zeros(ComplexF64, length(mat), length(mat))
    for ii in 1:length(mat), jj in 1:length(mat)
        m[ii,jj] = complex(mat[ii][jj][1], mat[ii][jj][2])
    end
    return m
end

using Braket, Braket.Observables, Distributions, LinearAlgebra, Random, Statistics, Test
using Braket: I

SHOTS = 8000
SV1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
DM1_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/dm1"
SIMULATOR_ARNS = [SV1_ARN, DM1_ARN]
ARNS_WITH_SHOTS = [(SV1_ARN, SHOTS), (SV1_ARN, 0), (DM1_ARN, SHOTS), (DM1_ARN, 0)]

bell_circ() = Circuit([(H, 0), (CNot, 0, 1)])
three_qubit_circuit(θ::Float64, ϕ::Float64, φ::Float64, obs::Observables.Observable, obs_targets::Vector{Int}) = Circuit([(Rx, 0, θ), (Rx, 1, ϕ), (Rx, 2, φ), (CNot, 0, 1), (CNot, 1, 2), (Variance, obs, obs_targets), (Expectation, obs, obs_targets)])
function many_layers(n_qubits::Int, n_layers::Int)
    d       = Uniform(0, 2π)
    qubits  = collect(0:(n_qubits-1))
    circuit = Circuit()  # instantiate circuit object
    circuit(H, qubits)
    for layer in 0:n_layers-1
        if mod(layer + 1, 100) != 0
            for qubit in qubits
                angle = rand(d)
                gate = rand([Rx, Ry, Rz, H])
                if gate <: AngledGate{1}
                    circuit(gate, qubit, angle)
                else
                    circuit(gate, qubit)
                end
            end
        else
            for q in 0:2:(n_qubits-1)
                circuit(CNot, q, q + 1)
            end
            for q in 1:2:(n_qubits - 2)
                circuit(CNot, q, q + 1)
            end
        end
    end
    return circuit
end

@inline function variance_expectation_sample_result(res::Braket.GateModelQuantumTaskResult, shots::Int, expected_var::Float64, expected_mean::Float64, expected_eigs::Vector{Float64})
    tol = get_tol(shots)
    variance = res.values[1]
    expectation = res.values[2]
    if shots > 0
        samples = res.values[3]
        sign_fix(x) = iszero(x) ? 0.0 : x
        @test isapprox(sort(collect(unique(sign_fix, samples))), sort(collect(unique(sign_fix, expected_eigs))), rtol=tol["rtol"], atol=tol["atol"])
        @test isapprox(mean(samples), expected_mean, rtol=tol["rtol"], atol=tol["atol"])
        @test isapprox(var(samples), expected_var, rtol=tol["rtol"], atol=tol["atol"])
    end
    @test isapprox(expectation, expected_mean, rtol=tol["rtol"], atol=tol["atol"])
    @test isapprox(variance, expected_var, rtol=tol["rtol"], atol=tol["atol"])
end

@testset "Simulator Quantum Task" begin
    @testset "Creating and cancelling a task" begin
        @testset for simulator_arn in SIMULATOR_ARNS
            device = AwsDevice(simulator_arn)
            bell = bell_circ()
            task = device(bell, shots=SHOTS, s3_destination_folder=s3_destination_folder)
            # test that this actually works without throwing an error
            cancel(task)
        end
    end
    @testset "No result types Bell pair" begin
        @testset for simulator_arn in SIMULATOR_ARNS
            device = AwsDevice(simulator_arn)
            bell = bell_circ()
            bell_qasm = ir(bell, Val(:OpenQASM))
            for task in (bell, bell_qasm)
                tol = get_tol(SHOTS)
                res = result(device(task, shots=SHOTS, s3_destination_folder=s3_destination_folder))
                probabilities = res.measurement_probabilities
                expected = Dict("00"=>0.5, "11"=>0.5)
                for (bitstring, val) in probabilities
                    @test isapprox(val, expected[bitstring], rtol=tol["rtol"], atol=tol["atol"])
                end
                @test length(res.measurements) == SHOTS
            end
        end
    end
    @testset "qubit ordering" begin
        @testset for simulator_arn in SIMULATOR_ARNS
            device = AwsDevice(_arn=simulator_arn)
            state_110 = Circuit([(X, 0), (X, 1), (I, 2)])
            state_001 = Circuit([(I, 0), (I, 1), (X, 2)])
            @testset for (state, most_com) in ((state_110, "110"), (state_001, "001"))
                tasks = (state, ir(state, Val(:OpenQASM)))
                @testset for task in tasks
                    res = result(device(task, shots=SHOTS, s3_destination_folder=s3_destination_folder))
                    mc = argmax(res.measurement_counts)
                    @test mc == most_com
                end
            end
        end
    end
    @testset "Result types no shots" begin
        @testset for (simulator_arn, include_amplitude) in zip(SIMULATOR_ARNS, [true, false])
            circuit = bell_circ()
            circuit(Expectation, Observables.H() * Observables.X(), 0, 1)
            include_amplitude && circuit(Amplitude, ["01", "10", "00", "11"])
            tasks = (circuit, ir(circuit, Val(:OpenQASM)))
            @testset for task in tasks
                device = AwsDevice(_arn=simulator_arn)
                res = result(device(task, shots=0, s3_destination_folder=s3_destination_folder))
                @test length(res.result_types) == (include_amplitude ? 2 : 1)
                @test isapprox(res[Expectation(Observables.H() * Observables.X(), [0, 1])], 1/√2)
                if include_amplitude
                    amps = res[Amplitude(["01", "10", "00", "11"])]
                    @test isapprox(amps["01"], 0)
                    @test isapprox(amps["10"], 0)
                    @test isapprox(amps["00"], 1/√2)
                    @test isapprox(amps["11"], 1/√2)
                end
            end
        end
    end
    @testset "Bell pair nonzero shots" begin
        circuit = bell_circ()
        circuit(Expectation, Observables.H() * Observables.X(), [0, 1])
        circuit(Sample, Observables.H() * Observables.X(), [0, 1])
        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            @test length(res.result_types) == 2
            @test 0.6 < res[Expectation(Observables.H() * Observables.X(), [0, 1])] < 0.8
            @test length(res[Sample(Observables.H() * Observables.X(), [0, 1])]) == SHOTS
        end
    end
    @testset "Bell pair full probability" begin
        circuit = bell_circ()
        circuit(Probability)
        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        tol = get_tol(SHOTS)
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            @test length(res.result_types) == 1
            @test isapprox(res[Probability()], [0.5, 0.0, 0.0, 0.5], rtol=tol["rtol"], atol=tol["atol"])
        end
    end
    @testset "Bell pair marginal probability" begin
        circuit = bell_circ()
        circuit(Probability, 0)
        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        tol = get_tol(SHOTS)
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=SHOTS, s3_destination_folder=s3_destination_folder)) 
            @test length(res.result_types) == 1
            @test isapprox(res[Probability(0)], [0.5, 0.5], rtol=tol["rtol"], atol=tol["atol"])
        end
    end
    @testset "Result types x x y" begin
        θ = 0.432
        ϕ = 0.123
        φ = -0.543
        obs = Observables.X() * Observables.Y()
        obs_targets = [0, 2]
        circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
        expected_mean = sin(θ) * sin(ϕ) * sin(φ)
        expected_var = (8*sin(θ)^2 * cos(2φ) * sin(ϕ)^2 - cos(2(θ - ϕ))- cos(2(θ + ϕ)) + 2*cos(2θ) + 2*cos(2ϕ) + 14) / 16
        expected_eigs = [-1.0, 1.0]
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS
            device = AwsDevice(_arn=simulator_arn)
            circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
            shots > 0 && circuit(Sample, obs, obs_targets)
            tasks = (circuit, ir(circuit, Val(:OpenQASM)))
            for task in tasks
                res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
                variance_expectation_sample_result(res, shots, expected_var, expected_mean, expected_eigs)
            end
        end
    end
    @testset "Result types z x h x y" begin
        θ = 0.432
        ϕ = 0.123
        φ = -0.543
        obs = Observables.Z() * Observables.H() * Observables.Y()
        obs_targets = [0, 1, 2]
        circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
        expected_mean = -(cos(φ)*sin(ϕ)+sin(φ)*cos(θ))/√2
        expected_var = (3 + cos(2ϕ)*cos(φ)^2 - cos(2θ)*sin(φ)^2 - 2*cos(θ)*sin(ϕ)*sin(2φ)) / 4
        expected_eigs = [-1.0, 1.0]
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS
            device = AwsDevice(_arn=simulator_arn)
            circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
            shots > 0 && circuit(Sample, obs, obs_targets)
            tasks = (circuit, ir(circuit, Val(:OpenQASM)))
            for task in tasks
                res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
                variance_expectation_sample_result(res, shots, expected_var, expected_mean, expected_eigs)
            end
        end
    end
    @testset "Result types z x z" begin
        θ = 0.432
        ϕ = 0.123
        φ = -0.543
        obs = Observables.Z() * Observables.Z()
        obs_targets = [0, 2]
        circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
        expected_mean = 0.849694136476246
        expected_var = 0.27801987443788634
        expected_eigs = [-1.0, 1.0]
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS
            device = AwsDevice(_arn=simulator_arn)
            circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
            shots > 0 && circuit(Sample, obs, obs_targets)
            tasks = (circuit, ir(circuit, Val(:OpenQASM)))
            for task in tasks
                res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
                variance_expectation_sample_result(res, shots, expected_var, expected_mean, expected_eigs)
            end
        end
    end
    @testset "Result types tensor {y,z,Hermitian} x Hermitian" begin
        θ = 0.432
        ϕ = 0.123
        φ = -0.543
        ho_mat = [-6 2+im -3 -5+2im;
                  2-im 0 2-im -5+4im;
                  -3 2+im 0 -4+3im;
                  -5-2im -5-4im -4-3im -6]
        @test ishermitian(ho_mat)
        ho = Observables.HermitianObservable(ho_mat)
        ho_mat2 = [1 2; 2 4]
        ho2 = Observables.HermitianObservable(ho_mat2)

        meany = 1.4499810303182408
        meanz = 0.5 *(-6 * cos(θ) * (cos(φ) + 1) - 2 * sin(φ) * (cos(θ) + sin(ϕ) - 2 * cos(ϕ)) + 3 * cos(φ) * sin(ϕ) + sin(ϕ))
        meanh = -4.30215023196904

        vary = 74.03174647518193
        varz = (1057 - cos(2ϕ) + 12*(27 + cos(2ϕ))*cos(φ) - 2*cos(2φ)*sin(ϕ)*(16*cos(ϕ) + 21*sin(ϕ)) + 16*sin(2ϕ) - 8*(-17 + cos(2ϕ) + 2 * sin(2ϕ)) * sin(φ) - 8 * cos(2θ) * (3 + 3*cos(φ) + sin(φ))^2 - 24*cos(ϕ)*(cos(ϕ) + 2*sin(ϕ)) * sin(2φ) - 8*cos(θ)*(4*cos(ϕ)*(4 + 8*cos(φ) + cos(2φ) - (1 + 6*cos(φ))*sin(φ)) + sin(ϕ)*(15 + 8*cos(φ) - 11*cos(2φ) + 42*sin(φ) + 3*sin(2φ)))) / 16
        varh = 370.71292282796804

        y_array = [0 -im; im 0]
        z_array = diagm([1, -1])
        eigsy = eigvals(kron(y_array, ho_mat))
        eigsz = eigvals(kron(z_array, ho_mat))
        eigsh = [-70.90875406, -31.04969387, 0, 3.26468993, 38.693758]
        obs_targets = [0, 1, 2]
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS, (obs, expected_mean, expected_var, expected_eigs) in [(Observables.Y() * ho, meany, vary, eigsy),
                                                                                                                      (Observables.Z() * ho, meanz, varz, eigsz),
                                                                                                                      (ho2 * ho, meanh, varh, eigsh)]
            device = AwsDevice(_arn=simulator_arn)
            circuit = three_qubit_circuit(θ, ϕ, φ, obs, obs_targets)
            shots > 0 && circuit(Sample, obs, obs_targets)
            tasks = (circuit, ir(circuit, Val(:OpenQASM)))
            @testset for task in tasks
                res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
                variance_expectation_sample_result(res, shots, expected_var, expected_mean, expected_eigs)
            end
        end
    end
    @testset "Result types all selected" begin
        θ = 0.543
        ho_mat = [1 2im; -2im 0]
        ho = Observables.HermitianObservable(ho_mat)
        expected_mean = 2*sin(θ) + 0.5*cos(θ) + 0.5
        var_ = 0.25 * (sin(θ) - 4*cos(θ))^2
        expected_var = [var_, var_]
        expected_eigs = eigvals(Hermitian(ho_mat))
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS
            device = AwsDevice(_arn=simulator_arn)
            circuit = Circuit([(Rx, 0, θ), (Rx, 1, θ), (Variance, ho), (Expectation, ho, 0)])
            shots > 0 && circuit(Sample, ho, 1)
            for task in (circuit, ir(circuit, Val(:OpenQASM)))
                res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
                tol = get_tol(shots)
                variance = res.values[1]
                expectation = res.values[2]
                if shots > 0
                    samples = res.values[3]
                    @test isapprox(sort(collect(unique(samples))), sort(collect(unique(expected_eigs))), rtol=tol["rtol"], atol=tol["atol"])
                    @test isapprox(mean(samples), expected_mean, rtol=tol["rtol"], atol=tol["atol"])
                    @test isapprox(var(samples), var_, rtol=tol["rtol"], atol=tol["atol"])
                end
                @test isapprox(expectation, expected_mean, rtol=tol["rtol"], atol=tol["atol"])
                @test isapprox(variance, expected_var, rtol=tol["rtol"], atol=tol["atol"])
            end
        end
    end
    @testset "Result types noncommuting" begin
        shots = 0
        θ = 0.432
        ϕ = 0.123
        φ = -0.543
        ho_mat = [-6 2+im -3 -5+2im;
                  2-im 0 2-im -5+4im;
                  -3 2+im 0 -4+3im;
                  -5-2im -5-4im -4-3im -6]
        obs1 = Observables.X() * Observables.Y()
        obs1_targets = [0, 2]
        obs2 = Observables.Z() * Observables.Z()
        obs2_targets = [0, 2]
        obs3 = Observables.Y() * Observables.HermitianObservable(ho_mat)
        obs3_targets = [0, 1, 2]
        obs3_targets = [0, 1, 2]
        circuit = three_qubit_circuit(θ, ϕ, φ, obs1, obs1_targets)
        circuit(Expectation, obs2, obs2_targets)
        circuit(Expectation, obs3, obs3_targets)
            
        expected_mean1 = sin(θ) * sin(ϕ) * sin(φ)
        expected_var1 = (8*sin(θ)^2 * cos(2φ) * sin(ϕ)^2 - cos(2(θ - ϕ))- cos(2(θ + ϕ)) + 2*cos(2θ) + 2*cos(2ϕ) + 14) / 16
        expected_mean2 = 0.849694136476246
        expected_mean3 = 1.4499810303182408

        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
            @test isapprox(res.values[1], expected_var1)
            @test isapprox(res.values[2], expected_mean1)
            @test isapprox(res.values[3], expected_mean2)
            @test isapprox(res.values[4], expected_mean3)
        end
    end
    @testset "Result types noncommuting flipped targets" begin
        circuit = bell_circ()
        tp = Observables.TensorProduct(["h", "x"])
        circuit = Expectation(circuit, tp, [0, 1])
        circuit = Expectation(circuit, tp, [1, 0])
        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=0, s3_destination_folder=s3_destination_folder))
            @test isapprox(res.values[1], √2 / 2)
            @test isapprox(res.values[2], √2 / 2)
        end
    end
    @testset "Result types all noncommuting" begin
        circuit = bell_circ()
        ho = [1 2im; -2im 0]
        circuit(Expectation, Observables.HermitianObservable(ho))
        circuit(Expectation, Observables.X())
        tasks = (circuit, ir(circuit, Val(:OpenQASM)))
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=0, s3_destination_folder=s3_destination_folder))
            @test isapprox(res.values[1], [0.5, 0.5])
            @test isapprox(res.values[2], [0, 0])
        end
    end
    @testset "Result types observable not in instructions" begin
        bell = bell_circ()
        bell(Expectation, Observables.X(), 2)
        bell(Variance, Observables.Y(), 3)
        bell_qasm = ir(bell, Val(:OpenQASM))
        @test qubit_count(bell) == 4
        @testset for (simulator_arn, shots) in ARNS_WITH_SHOTS, task in (bell, bell_qasm)
            tol = get_tol(shots)
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(task, shots=shots, s3_destination_folder=s3_destination_folder))
            @test isapprox(res.values[1], 0, rtol=tol["rtol"], atol=tol["atol"])
            @test isapprox(res.values[2], 1, rtol=tol["rtol"], atol=tol["atol"])
        end
    end
    @testset "Multithreaded Bell pair" begin
        tol = get_tol(SHOTS)
        tasks = (bell_circ, (()->ir(bell_circ(), Val(:OpenQASM))))
        @testset for simulator_arn in SIMULATOR_ARNS, task in tasks
            device = AwsDevice(_arn=simulator_arn)
            run_circuit(circuit) = result(device(circuit, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            task_array = [task() for ii in 1:Threads.nthreads()]
            futures = [Threads.@spawn run_circuit(c) for c in task_array]
            future_results = fetch.(futures)
            for r in future_results
                @test isapprox(r.measurement_probabilities["00"], 0.5, rtol=tol["rtol"], atol=tol["atol"])
                @test isapprox(r.measurement_probabilities["11"], 0.5, rtol=tol["rtol"], atol=tol["atol"])
                @test length(r.measurements) == SHOTS
            end
        end
    end
    @testset "Batch Bell pair" begin
        circs = [bell_circ() for _ in 1:10]
        tasks_list = (circs, [ir(c, Val(:OpenQASM)) for c in circs])
        @testset for simulator_arn in SIMULATOR_ARNS, tasks in tasks_list
            device = AwsDevice(_arn=simulator_arn)
            batch = device(tasks, max_parallel=5, shots=SHOTS, s3_destination_folder=s3_destination_folder)
            res = results(batch)
            tol = get_tol(SHOTS)
            for r in res
                @test isapprox(r.measurement_probabilities["00"], 0.5, rtol=tol["rtol"], atol=tol["atol"])
                @test isapprox(r.measurement_probabilities["11"], 0.5, rtol=tol["rtol"], atol=tol["atol"])
                @test length(r.measurements) == SHOTS
            end
            @test [result(task) for task in batch._tasks] == res
        end
    end
    @testset "No result types Bell pair OpenQASM" begin
        expected = Dict("00"=>0.5, "11"=>0.5)
        openqasm_string = """
            OPENQASM 3;
            qubit[2] q;
            bit[2] c;
            h q[0];
            cnot q[0], q[1];
            c[0] = measure q[0];
            c[1] = measure q[1];
            """
        hardcoded_openqasm = OpenQasmProgram(Braket.header_dict[OpenQasmProgram], openqasm_string, nothing)
        circuit = bell_circ()
        generated_openqasm = ir(circuit, Val(:OpenQASM))
        @testset for simulator_arn in SIMULATOR_ARNS, program in (hardcoded_openqasm, generated_openqasm)
            device = AwsDevice(_arn=simulator_arn)
            tol = get_tol(SHOTS)
            res = result(device(program, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            probabilities = res.measurement_probabilities
            for (bitstring, val) in probabilities
                @test isapprox(val, expected[bitstring], rtol=tol["rtol"], atol=tol["atol"])
            end
            @test length(res.measurements) == SHOTS
        end
    end
    @testset "Bell pair OpenQASM results" begin
        openqasm_string = """
        OPENQASM 3;
        qubit[2] q;
        h q[0];
        cnot q[0], q[1];
        #pragma braket result expectation h(q[0]) @ x(q[1])
        #pragma braket result sample h(q[0]) @ x(q[1])
        """
        hardcoded_openqasm = OpenQasmProgram(Braket.header_dict[OpenQasmProgram], openqasm_string, nothing)
        circuit = bell_circ()
        tp = Observables.TensorProduct(["h", "x"])
        circuit = Expectation(circuit, tp, [0, 1])
        circuit = Sample(circuit, tp, [0, 1])
        generated_openqasm = ir(circuit, Val(:OpenQASM))
        @testset for simulator_arn in SIMULATOR_ARNS, program in (hardcoded_openqasm, generated_openqasm)
            device = AwsDevice(_arn=simulator_arn)
            res = result(device(program, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            @test length(res.result_types) == 2
            @test 0.6 < res[Expectation(tp, [0, 1])] < 0.8
            @test length(res[Sample(tp, [0, 1])]) == SHOTS
        end
    end
    @testset "OpenQASM probability results" begin
        device = AwsDevice(_arn="arn:aws:braket:::device/quantum-simulator/amazon/dm1")
        shots = SHOTS
        tol = get_tol(shots)
        openqasm_string = """
            OPENQASM 3;
            qubit[2] q;
            x q[0];
            x q[1];
            #pragma braket noise bit_flip(0.1) q[0]
            #pragma braket result probability q[0], q[1]
            """
        hardcoded_openqasm = OpenQasmProgram(Braket.header_dict[OpenQasmProgram], openqasm_string, nothing)
        circuit = Circuit([(X, 0), (X, 1), (BitFlip, 0, 0.1), (Probability, 0, 1)])
        generated_openqasm = ir(circuit, Val(:OpenQASM))
        for program in (hardcoded_openqasm, generated_openqasm)
            res = result(device(program, shots=shots, s3_destination_folder=s3_destination_folder))
            @test length(res.result_types) == 1
            @test isapprox(res.values[1], [0.0, 0.1, 0, 0.9], rtol=tol["rtol"], atol=tol["atol"])
        end
    end
    @testset "Many layers" begin
        @testset for simulator_arn in SIMULATOR_ARNS, num_layers in [50, 100, 500, 1000]
            num_qubits = 10
            circuit = many_layers(num_qubits, num_layers)
            device = AwsDevice(_arn=simulator_arn)

            tol = get_tol(SHOTS)
            res = result(device(circuit, shots=SHOTS, s3_destination_folder=s3_destination_folder))
            probabilities = res.measurement_probabilities
            probability_sum = 0
            for bitstring in keys(probabilities)
                @test probabilities[bitstring] >= 0
                probability_sum += probabilities[bitstring]
            end
            @test isapprox(probability_sum, 1, rtol=tol["rtol"], atol=tol["atol"])
            @test length(res.measurements) == SHOTS
        end
    end
end

using Braket, Test

@testset "Free parameters" begin
    α = FreeParameter(:alpha)
    θ = FreeParameter(:theta)
    @test_throws MethodError qubit_count(θ)
    circ = Circuit()
    circ = H(circ, 0)
    circ = Rx(circ, 1, α)
    circ = Ry(circ, 0, θ)
    circ = Probability(circ)
    new_circ = circ(theta=2.0, alpha=1.0)
    non_para_circ = Circuit() |> (ci->H(ci, 0)) |> (ci->Rx(ci, 1, 1.0)) |> (ci->Ry(ci, 0, 2.0)) |> Probability
    @test new_circ == non_para_circ
    new_circ = circ(1.0)
    non_para_circ = Circuit() |> (ci->H(ci, 0)) |> (ci->Rx(ci, 1, 1.0)) |> (ci->Ry(ci, 0, 1.0)) |> Probability
    @test new_circ == non_para_circ
    ϕ = FreeParameter(:phi)
    circ = apply_gate_noise!(circ, BitFlip(ϕ))
    circ = apply_gate_noise!(circ, PhaseFlip(0.1))
    new_circ = circ(theta=2.0, alpha=1.0, phi=0.2)
    non_para_circ = Circuit() |> (ci->H(ci, 0)) |> (ci->Rx(ci, 1, 1.0)) |> (ci->Ry(ci, 0, 2.0)) |> Probability |> (ci->apply_gate_noise!(ci, BitFlip(0.2))) |> (ci->apply_gate_noise!(ci, PhaseFlip(0.1)))
    @test new_circ == non_para_circ
    b = FreeParameter("b")
    @test b.name == :b
    @test copy(b) === b
end

using Test, Braket, JSON3, LinearAlgebra, StructTypes
using Braket: Instruction, OpenQASMSerializationProperties, QubitReferenceType, VIRTUAL, PHYSICAL, I

CCNot_mat = round.(reduce(hcat, [[1.0, 0, 0, 0, 0, 0, 0, 0],
             [0, 1.0, 0, 0, 0, 0, 0, 0],
             [0, 0, 1.0, 0, 0, 0, 0, 0],
             [0, 0, 0, 1.0, 0, 0, 0, 0],
             [0, 0, 0, 0, 1.0, 0, 0, 0],
             [0, 0, 0, 0, 0, 1.0, 0, 0],
             [0, 0, 0, 0, 0, 0, 0, 1.0],
             [0, 0, 0, 0, 0, 0, 1.0, 0]]), digits=8)
ECR_mat = round.(reduce(hcat, [[0, 0, 0.70710678, 0.70710678im],
                        [0, 0, 0.70710678im, 0.70710678],
                        [0.70710678, -0.70710678im, 0, 0],
                        [-0.70710678im, 0.70710678, 0, 0]]), digits=8)
T_mat = round.(reduce(hcat, [[1.0, 0], [0, 0.70710678 + 0.70710678im]]), digits=8)

@testset "Gates" begin
    @testset for g in (H(), Braket.I(), X(), Y(), Z(), S(), Si(), T(), Ti(), V(), Vi())
        @test qubit_count(g) == 1
        ix = Instruction(g, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(g) == Braket.NonParametrized()
        @test Braket.parameters(g) == Braket.FreeParameter[]
    end
    @testset for g in (H, Braket.I, X, Y, Z, S, Si, T, Ti, V, Vi)
        @test qubit_count(g) == 1
        c = Circuit()
        c = g(c, 0)
        @test c.instructions == [Instruction(g(), 0)]
        c = Circuit()
        c = g(c, [0, 1, 2])
        @test c.instructions == [Instruction(g(), 0), Instruction(g(), 1),  Instruction(g(), 2)]
    end
    @testset for g in (CNot(), Swap(), ISwap(), CV(), CY(), CZ(), ECR())
        @test qubit_count(g) == 2
        ix = Instruction(g, [0, 1])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(g) == Braket.NonParametrized()
        @test Braket.parameters(g) == Braket.FreeParameter[]
    end
    @testset for g in (CNot, Swap, ISwap, CV, CY, CZ, ECR)
        @test qubit_count(g) == 2
        c = Circuit()
        c = g(c, 0, 1)
        @test c.instructions == [Instruction(g(), [0, 1])]
        c = Circuit()
        c = g(c, 10, 1)
        @test c.instructions == [Instruction(g(), [10, 1])]
    end
    @testset for g in (CCNot(), CSwap())
        @test qubit_count(g) == 3
        ix = Instruction(g, [0, 1, 2])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        @test Braket.Parametrizable(g) == Braket.NonParametrized()
        @test Braket.parameters(g) == Braket.FreeParameter[]
    end
    @testset for g in (CCNot, CSwap)
        @test qubit_count(g) == 3
        c = Circuit()
        c = g(c, 0, 1, 2)
        @test c.instructions == [Instruction(g(), [0, 1, 2])]
        c = Circuit()
        c = g(c, 5, 1, 2)
        @test c.instructions == [Instruction(g(), [5, 1, 2])]
    end
    angle = rand()
    α = FreeParameter(:alpha)
    β = FreeParameter(:beta)
    γ = FreeParameter(:gamma)
    @testset for (angle1, angle2, angle3) in ((rand(), rand(), rand()), (π, rand(), rand()))
        @testset for g in (Rx(angle1), Ry(angle1), Rz(angle1), PhaseShift(angle1))
            @test qubit_count(g) == 1
            ix = Instruction(g, 0)
            @test Braket.Parametrizable(g) == Braket.Parametrized()
            @test Braket.parameters(g) == Braket.FreeParameter[]
        end
        @testset for g in (Rx, Ry, Rz, PhaseShift)
            @test qubit_count(g) == 1
            c = Circuit()
            c = g(c, 0, angle1)
            @test c.instructions == [Instruction(g(angle1), 0)]
            c = Circuit()
            c = g(c, [0, 1, 2], angle1)
            @test c.instructions == [Instruction(g(angle1), 0), Instruction(g(angle1), 1),  Instruction(g(angle1), 2)]
            pg = g(α)
            @test Braket.parameters(pg) == [α]
            ix = Instruction(g(angle1), 0)
            @test JSON3.read(JSON3.write(ix), Instruction) == Instruction(g(Float64(angle1)), 0)
        end
        @testset for g in (PSwap(angle1), XY(angle1), CPhaseShift(angle1), CPhaseShift00(angle1), CPhaseShift01(angle1), CPhaseShift10(angle1), XX(angle1), YY(angle1), ZZ(angle1))
            @test qubit_count(g) == 2
            @test Braket.Parametrizable(g) == Braket.Parametrized()
            @test Braket.parameters(g) == Braket.FreeParameter[]
        end
        @testset for g in (PSwap, XY, CPhaseShift, CPhaseShift00, CPhaseShift01, CPhaseShift10, XX, YY, ZZ)
            @test qubit_count(g) == 2
            c = Circuit()
            c = g(c, 0, 1, angle1)
            @test c.instructions == [Instruction(g(angle1), [0, 1])]
            c = Circuit()
            c = g(c, 10, 1, angle1)
            @test c.instructions == [Instruction(g(angle1), [10, 1])]
            pg = g(α)
            @test Braket.parameters(pg) == [α]
            ix = Instruction(g(angle1), [0, 1])
            @test JSON3.read(JSON3.write(ix), Instruction) == Instruction(g(Float64(angle1)), [0, 1])
        end
        @testset for g in (PRx(angle1, angle2),)
            @test qubit_count(g) == 1
            @test Braket.Parametrizable(g) == Braket.Parametrized()
            @test Braket.parameters(g) == Braket.FreeParameter[]
        end
        @testset for g in (PRx,)
            @test qubit_count(g) == 1
            c = Circuit()
            c = g(c, 0, angle1, angle2)
            @test c.instructions == [Instruction(g(angle1, angle2), 0)]
            c = Circuit()
            c = g(c, 10, angle1, angle2)
            @test c.instructions == [Instruction(g(angle1, angle2), 10)]
            pg = g(α, β)
            @test Braket.parameters(pg) == [α, β]
            pg = Braket.bind_value!(Braket.Parametrized(), pg, Dict(:alpha=>angle1, :beta=>angle2))
            @test pg == g(angle1, angle2)
        end
        @testset for g in (MS(angle1, angle2, angle3),)
            @test qubit_count(g) == 2
            @test Braket.Parametrizable(g) == Braket.Parametrized()
            @test Braket.parameters(g) == Braket.FreeParameter[]
        end
        @testset for g in (MS,)
            @test qubit_count(g) == 2
            c = Circuit()
            c = g(c, 0, 1, angle1, angle2, angle3)
            @test c.instructions == [Instruction(g(angle1, angle2, angle3), [0, 1])]
            c = Circuit()
            c = g(c, 10, 1, angle1, angle2, angle3)
            @test c.instructions == [Instruction(g(angle1, angle2, angle3), [10, 1])]
            pg = g(α, β, γ)
            @test Braket.parameters(pg) == [α, β, γ]
            pg = Braket.bind_value!(Braket.Parametrized(), pg, Dict(:alpha=>angle1, :beta=>angle2, :gamma=>angle3))
            @test pg == g(angle1, angle2, angle3)
        end
        @testset for g in (U(angle1, angle2, angle3),)
            @test qubit_count(g) == 1
            @test Braket.Parametrizable(g) == Braket.Parametrized()
            @test Braket.parameters(g) == Braket.FreeParameter[]
        end
        @testset for g in (U,)
            @test qubit_count(g) == 1
            c = Circuit()
            c = g(c, 0, angle1, angle2, angle3)
            @test c.instructions == [Instruction(g(angle1, angle2, angle3), 0)]
            c = Circuit()
            c = g(c, [0, 1, 2], angle1, angle2, angle3)
            @test c.instructions == [Instruction(g(angle1, angle2, angle3), 0), Instruction(g(angle1, angle2, angle3), 1),  Instruction(g(angle1, angle2, angle3), 2)]
            c = Circuit()
            c = g(c, 0, 1, 2, angle1, angle2, angle3)
            @test c.instructions == [Instruction(g(angle1, angle2, angle3), 0), Instruction(g(angle1, angle2, angle3), 1),  Instruction(g(angle1, angle2, angle3), 2)]
            pg = g(α, β, γ)
            @test Braket.parameters(pg) == [α, β, γ]
            pg = Braket.bind_value!(Braket.Parametrized(), pg, Dict(:alpha=>angle1, :beta=>angle2, :gamma=>angle3))
            @test pg == g(angle1, angle2, angle3)
        end
        @testset "Angled 3 qubit gates" begin
            # build some "fake" (for now) 3 qubit gates to test gate applicators
            struct CCPhaseShift <: Braket.AngledGate{1}
                angle::NTuple{1, Union{Real, FreeParameter}}
                CCPhaseShift(angle::T) where {T<:NTuple{1, Union{Real, FreeParameter}}} = new(angle)
            end
            struct CXX <: Braket.AngledGate{1}
                angle::NTuple{1, Union{Real, FreeParameter}}
                CXX(angle::T) where {T<:NTuple{1, Union{Real, FreeParameter}}} = new(angle)
            end
            c = Circuit()
            c = Braket.apply_gate!(Val(1), Val(2), Val(1), CCPhaseShift, c, 0, 1, 2, angle1)
            @test c.instructions == [Instruction(CCPhaseShift(angle1), [0, 1, 2])]
            c = Circuit()
            c = Braket.apply_gate!(Val(1), Val(2), Val(1), CCPhaseShift, c, [0, 1, 2], angle1)
            @test c.instructions == [Instruction(CCPhaseShift(angle1), [0, 1, 2])]
            c = Circuit()
            c = Braket.apply_gate!(Val(1), Val(1), Val(2), CXX, c, 0, 1, 2, angle1)
            @test c.instructions == [Instruction(CXX(angle1), [0, 1, 2])]
            c = Circuit()
            c = Braket.apply_gate!(Val(1), Val(1), Val(2), CXX, c, [0, 1, 2], angle1)
            @test c.instructions == [Instruction(CXX(angle1), [0, 1, 2])]
        end
    end
    @testset "g = Unitary" begin
        X = complex([0. 1.; 1. 0.])
        Y = [0. -im; im 0.]
        g = Unitary(X)
        @test qubit_count(g) == 1
        ix = Instruction(g, 0)
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        g = Unitary(kron(X, X))
        @test qubit_count(g) == 2
        ix = Instruction(g, [0, 1])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        g = Unitary(kron(Y, Y))
        @test qubit_count(g) == 2
        ix = Instruction(g, [0, 1])
        @test JSON3.read(JSON3.write(ix), Instruction) == ix
        c = Circuit()
        c = Unitary(c, 0, X)
        @test c.instructions == [Instruction(Unitary(X), 0)]
        c = Circuit()
        c = Unitary(c, 0, 1, kron(X, Y))
        @test c.instructions == [Instruction(Unitary(kron(X, Y)), [0, 1])]
    end
    @testset "OpenQASM IR" begin
        fp  = FreeParameter(:alpha)
        fp2 = FreeParameter(:beta)
        fp3 = FreeParameter(:gamma)
        @testset for ir_bolus in [
            (Rx(0.17), [Qubit(4)], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "rx(0.17) q[4];",),
            (Rx(0.17), [Qubit(4)], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "rx(0.17) \$4;",),
            (Rx(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "rx(0.17) q[4];",),
            (Rx(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "rx(0.17) \$4;",),
            (PRx(0.17, 3.45), [Qubit(4)], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "prx(0.17, 3.45) q[4];",),
            (PRx(0.17, 3.45), [Qubit(4)], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "prx(0.17, 3.45) \$4;",),
            (PRx(0.17, 3.45), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "prx(0.17, 3.45) q[4];",),
            (PRx(0.17, 3.45), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "prx(0.17, 3.45) \$4;",),
            (X(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "x q[4];",),
            (X(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "x \$4;",),
            (Z(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "z q[4];",),
            (Z(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "z \$4;",),
            (Y(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "y q[4];",),
            (Y(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "y \$4;",),
            (H(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "h q[4];",),
            (H(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "h \$4;",),
            (Ry(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "ry(0.17) q[4];",),
            (Ry(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "ry(0.17) \$4;",),
            (ZZ(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "zz(0.17) q[4], q[5];",),
            (ZZ(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "zz(0.17) \$4, \$5;",),
            (I(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "i q[4];",),
            (I(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "i \$4;",),
            (V(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "v q[4];",),
            (V(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "v \$4;",),
            (CY(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cy q[0], q[1];",),
            (CY(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cy \$0, \$1;",),
            (Rz(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "rz(0.17) q[4];",),
            (Rz(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "rz(0.17) \$4;",),
            (Rz(fp), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "rz(alpha) q[4];",),
            (Rz(fp), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "rz(alpha) \$4;",),
            (U(0.17, 0.2, 0.1), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "U(0.17, 0.2, 0.1) q[4];",),
            (U(0.17, 0.2, 0.1), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "U(0.17, 0.2, 0.1) \$4;",),
            (U(fp, fp2, fp3), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "U(alpha, beta, gamma) q[4];",),
            (U(fp, fp2, fp3), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "U(alpha, beta, gamma) \$4;",),
            (XX(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "xx(0.17) q[4], q[5];",),
            (XX(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "xx(0.17) \$4, \$5;",),
            (XX(fp), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "xx(alpha) q[4], q[5];",),
            (XX(fp), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "xx(alpha) \$4, \$5;",),
            (T(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "t q[4];",),
            (T(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "t \$4;",),
            (CZ(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cz \$0, \$1;",),
            (CZ(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cz q[0], q[1];",),
            (YY(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "yy(0.17) q[4], q[5];",),
            (YY(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "yy(0.17) \$4, \$5;",),
            (XY(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "xy(0.17) q[4], q[5];",),
            (XY(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "xy(0.17) \$4, \$5;",),
            (GPi(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "gpi(0.17) q[4];",),
            (GPi(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "gpi(0.17) \$4;",),
            (GPi2(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "gpi2(0.17) q[4];",),
            (GPi2(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "gpi2(0.17) \$4;",),
            (ISwap(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "iswap \$0, \$1;",),
            (ISwap(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "iswap q[0], q[1];",),
            (Swap(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "swap \$0, \$1;",),
            (Swap(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "swap q[0], q[1];",),
            (ECR(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "ecr \$0, \$1;",),
            (ECR(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "ecr q[0], q[1];",),
            (CV(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cv \$0, \$1;",),
            (CV(), [0, 1], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cv q[0], q[1];",),
            (Vi(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "vi q[4];",),
            (Vi(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "vi \$4;",),
            (CSwap(), [0, 1, 2], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cswap q[0], q[1], q[2];",),
            (CSwap(), [0, 1, 2], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cswap \$0, \$1, \$2;",),
            (CPhaseShift01(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cphaseshift01(0.17) q[4], q[5];",),
            (CPhaseShift01(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cphaseshift01(0.17) \$4, \$5;",),
            (CPhaseShift00(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cphaseshift00(0.17) q[4], q[5];",),
            (CPhaseShift00(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cphaseshift00(0.17) \$4, \$5;",),
            (CPhaseShift(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cphaseshift(0.17) q[4], q[5];",),
            (CPhaseShift(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cphaseshift(0.17) \$4, \$5;",),
            (S(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "s q[4];",),
            (S(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "s \$4;",),
            (Si(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "si q[4];",),
            (Si(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "si \$4;",),
            (Ti(), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "ti q[4];",),
            (Ti(), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "ti \$4;",),
            (PhaseShift(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "phaseshift(0.17) q[4];",),
            (PhaseShift(0.17), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "phaseshift(0.17) \$4;",),
            (MS(0.17, 0.2, 0.1), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "ms(0.17, 0.2, 0.1) q[4], q[5];",),
            (MS(0.17, 0.2, 0.1), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "ms(0.17, 0.2, 0.1) \$4, \$5;",),
            (CNot(), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cnot q[4], q[5];",),
            (CNot(), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cnot \$4, \$5;",),
            (PSwap(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "pswap(0.17) q[4], q[5];",),
            (PSwap(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "pswap(0.17) \$4, \$5;",),
            (CPhaseShift10(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "cphaseshift10(0.17) q[4], q[5];",),
            (CPhaseShift10(0.17), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "cphaseshift10(0.17) \$4, \$5;",),
            (CCNot(), [4, 5, 6], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL), "ccnot q[4], q[5], q[6];",),
            (CCNot(), [4, 5, 6], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL), "ccnot \$4, \$5, \$6;",),
            (Unitary(CCNot_mat), [4, 5, 6], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL),
                "#pragma braket unitary([" *
                "[1.0, 0, 0, 0, 0, 0, 0, 0], " *
                "[0, 1.0, 0, 0, 0, 0, 0, 0], " *
                "[0, 0, 1.0, 0, 0, 0, 0, 0], " *
                "[0, 0, 0, 1.0, 0, 0, 0, 0], " *
                "[0, 0, 0, 0, 1.0, 0, 0, 0], " *
                "[0, 0, 0, 0, 0, 1.0, 0, 0], " *
                "[0, 0, 0, 0, 0, 0, 0, 1.0], " *
                "[0, 0, 0, 0, 0, 0, 1.0, 0]" *
                "]) q[4], q[5], q[6]",
            ),
            (Unitary(CCNot_mat), [4, 5, 6], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL),
                "#pragma braket unitary([" *
                "[1.0, 0, 0, 0, 0, 0, 0, 0], " *
                "[0, 1.0, 0, 0, 0, 0, 0, 0], " *
                "[0, 0, 1.0, 0, 0, 0, 0, 0], " *
                "[0, 0, 0, 1.0, 0, 0, 0, 0], " *
                "[0, 0, 0, 0, 1.0, 0, 0, 0], " *
                "[0, 0, 0, 0, 0, 1.0, 0, 0], " *
                "[0, 0, 0, 0, 0, 0, 0, 1.0], " *
                "[0, 0, 0, 0, 0, 0, 1.0, 0]" *
                "]) \$4, \$5, \$6",
            ),
            (Unitary(ECR_mat), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL),
                "#pragma braket unitary([" *
                "[0, 0, 0.70710678, 0.70710678im], " *
                "[0, 0, 0.70710678im, 0.70710678], " *
                "[0.70710678, -0.70710678im, 0, 0], " *
                "[-0.70710678im, 0.70710678, 0, 0]" *
                "]) q[4], q[5]",
            ),
            (Unitary(ECR_mat), [4, 5], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL),
                "#pragma braket unitary([" *
                "[0, 0, 0.70710678, 0.70710678im], " *
                "[0, 0, 0.70710678im, 0.70710678], " *
                "[0.70710678, -0.70710678im, 0, 0], " *
                "[-0.70710678im, 0.70710678, 0, 0]" *
                "]) \$4, \$5",
            ),
            (Unitary(T_mat), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL),
                "#pragma braket unitary([[1.0, 0], [0, 0.70710678 + 0.70710678im]]) q[4]",
            ),
            (Unitary(T_mat), [4], OpenQASMSerializationProperties(qubit_reference_type=PHYSICAL),
                "#pragma braket unitary([[1.0, 0], [0, 0.70710678 + 0.70710678im]]) \$4",
            ),
            (Unitary(reduce(hcat, [[1.0, 0], [0, 0.70710678 - 0.70710678im]])), [4], OpenQASMSerializationProperties(qubit_reference_type=VIRTUAL),
                "#pragma braket unitary([[1.0, 0], [0, 0.70710678 - 0.70710678im]]) q[4]",
            )
        ]
            gate, target, s_props, expected_ir = ir_bolus
            generated_ir = ir(gate, target, Val(:OpenQASM); serialization_properties=s_props)
            @test generated_ir == expected_ir
        end
    end
    @test StructTypes.StructType(X) == StructTypes.Struct()
    @test StructTypes.StructType(Gate) == StructTypes.AbstractType()
    @test StructTypes.StructType(AngledGate) == StructTypes.AbstractType()
end

### A Pluto.jl notebook ###
# v0.19.22

using Markdown
using InteractiveUtils

# ╔═╡ 2feb54cc-abd3-11ed-08d0-89d3036b2224
using Braket, PyBraket, PyBraket.PythonCall, CondaPkg

# ╔═╡ 9cd02259-e77a-40d3-89fb-5aceb6c88855
using Braket.Observables: TensorProduct, Observable

# ╔═╡ 7fe2bb2d-4c6a-441d-9743-1471aec6f0b1
md"""
# Implementing TETRIS-ADAPT-VQE with PennyLane and Braket.jl
"""

# ╔═╡ 5a283f0e-76ec-4975-90f1-b824eae4350b
md"""
In this notebook, we demonstrate how to use PennyLane's `qchem` molecule in tandem with [`Braket.jl`](https://github.com/awslabs/Braket.jl), the experimental Julia SDK for Amazon Braket, to implement the [TETRIS-ADAPT-VQE](https://arxiv.org/abs/2209.10562) algorithm for quantum chemistry. First, we install and import the necessary packages. Since we'll be calling PennyLane, which is written in Python, we'll need `PythonCall.jl` which is provided as a dependency of `PyBraket.jl`.

**Note:** if you are using OSX, you may need to set the environment variable `KMP_DUPLICATE_LIB_OK=true` in order to avoid `pyscf` segfaulting. See [this GitHub issue](https://github.com/dmlc/xgboost/issues/1715) for more information. You can set this environment variable in this script by adding a new cell with `ENV["KMP_DUPLICATE_LIB_OK"] = true`.
"""

# ╔═╡ be0d2559-b555-4026-934a-ca4922edb9af
CondaPkg.add_pip("pennylane", version="==0.28.0")

# ╔═╡ d0e4e6bc-92e9-49a6-924d-999db1de14e3
CondaPkg.add_pip("pyscf", version="==2.1.1")

# ╔═╡ bd980a06-718f-4896-9b21-fcad0ec715e5
CondaPkg.add_pip("openfermion", version="==1.5.1")

# ╔═╡ fa7fafac-4529-4c22-9cbe-fc0dfdc15032
CondaPkg.add_pip("openfermionpyscf", version="==0.5")

# ╔═╡ 94712ed6-5489-4973-bc45-5d18017facd7
md"""
We'll also import some data structures from `Braket.jl` for ease of use:
"""

# ╔═╡ cc9358b3-f5f3-44e5-8ffb-078768c79c59
md"""
And of course we'll need PennyLane itself!
"""

# ╔═╡ 655e7ea1-8e68-40d0-8791-22f4addd70e3
# Python package imports
begin
	qml = pyimport("pennylane")
	qchem = pyimport("pennylane.qchem")
end

# ╔═╡ 28857109-96c1-4a34-b376-9dd2ee6c8d80
md"""
## Summary of TETRIS-ADAPT-VQE

TETRIS-ADAPT-VQE is an improvement upon [the original ADAPT-VQE algorithm](https://www.nature.com/articles/s41467-019-10988-2), developed by Grimsley et al., which defines a scheme to filter out molecular excitations so as to expend computational effort only on excitations which contribute significantly to the final groundstate. However, naive ADAPT-VQE can generate circuits which are very deep, which is problematic for near-term quantum devices. The quantum hardware of today has limited "quantum volume", and we expect to achieve better results with shallower rather than deeper circuits. TETRIS-ADAPT-VQE thus develops a method to address as many qubits as possible in each layer of the circuit to be run, decreasing the total parallel gate depth and making the circuits more amenable to be run on NISQ devices.

For an introduction to ADAPT-VQE, see [the PennyLane demo](https://pennylane.ai/qml/demos/tutorial_adaptive_circuits.html) on the algorithm.
"""

# ╔═╡ 09e0a358-fadb-467f-b2c4-3e25c9e711d1
md"""
We begin by choosing a molecule to study. In this notebook, we'll examine $\mathrm{C_2O_2}$, a linear molecule with 28 total electrons. By tuning the number of "active" electrons (those which are excitable), we can control how many qubits we need to perform the quantum chemistry simulation.
"""

# ╔═╡ d7508af5-a21e-4726-bdf5-e90c375bd1c0
begin
	structure = """
	4
	314937
	O         14.77020      -12.25000        0.00000
	O         18.66730      -10.00000        0.00000
	C         16.06920      -11.50000        0.00000
	C         17.36820      -10.75000        0.00000
	"""
	write("c2o2.xyz", structure)
	symbols, coordinates = qchem.read_structure("c2o2.xyz")
end

# ╔═╡ ad4759d4-7e75-4e32-bf9d-b7d50fab4366
n_electrons = 10 # to make the problem fit

# ╔═╡ e386fe38-6034-40e0-8d92-d7a505d717f9
md"""
Using PennyLane's `qchem` module in tandem with `PythonCall.jl`, we're able to generate the appropriate molecular Hamiltonian, which can be applied at the end of the circuit and used in a VQE training procedure.

**Note**: `PythonCall.jl`'s built-in Python package manager, `CondaPkg.jl`, can struggle to install the `openfermionpyscf` package. If this happens to you, install `openfermionpyscf` using `pip` from the command line and [tell `PythonCall.jl` to use your local install](https://cjdoris.github.io/PythonCall.jl/stable/pythoncall/#If-you-already-have-Python-and-required-Python-packages-installed).
"""

# ╔═╡ 24be5c3a-3bc6-4d61-96ee-28cfe0e98ddd
mol_H, n_qubits = qchem.molecular_hamiltonian(symbols, coordinates, method="pyscf", active_electrons=n_electrons, name="c2o2", convert_tol=1e-6)

# ╔═╡ 8d9402e6-a01d-4dc3-a86d-9710b34cd807
md"""
`mol_H` is a Python object. We can write some quick Julia code to convert it to the Julia objects used by `Braket.jl`:
"""

# ╔═╡ 2730bf2b-d010-4358-a176-1a3860bc28b7
"""
	translate_op(op::Py) -> Braket.Observables.Observable

Transform a PennyLane `operation` to a `Braket.jl` `Observable`.
"""
function translate_op(op::Py)
    if pyisinstance(op, qml.Identity)
        return Braket.Observables.I()
    elseif pyisinstance(op, qml.Hadamard)
        return Braket.Observables.H()
    elseif pyisinstance(op, qml.PauliZ)
        return Braket.Observables.Z()
    elseif pyisinstance(op, qml.PauliY)
        return Braket.Observables.Y()
    elseif pyisinstance(op, qml.PauliX)
        return Braket.Observables.X()
    end
end

# ╔═╡ cf977978-c4df-4ce1-9811-875d2832ec3a
"""
	translate_H(py_H::Py) -> (Braket.Observables.Sum, Vector{Vector{Int}})

Translate each term of the `qml.Hamiltonian` `py_H` to a Julia object and track which qubits (or wires, in PennyLane parlance) it applies to, returning a tuple of the `Sum` observable and the targets of each of its terms.
"""
function translate_H(py_H::Py)
    H_list  = Vector{Observable}(undef, length(py_H.ops))
    targets = Vector{Vector{Int}}(undef, length(py_H.ops))
    for (ii, (coeff, op)) in enumerate(zip(py_H.coeffs, py_H.ops))
        jl_coeff = pyconvert(Float64, coeff.numpy())
        H_list[ii] = if pyisinstance(op, qml.operation.Tensor)
            jl_coeff * TensorProduct(Observable[translate_op(o) for o in op.obs])
        else
            jl_coeff * translate_op(op)
        end
        targets[ii] = pyconvert(Vector{Int}, op.wires)
    end
    return sum(H_list[2:end], init=H_list[1]), targets
end

# ╔═╡ 10eaf3c1-2b5d-4346-835e-ccc32e11771d
jl_mol_H, targets = translate_H(mol_H);

# ╔═╡ 4c3496d3-8242-4815-8230-f8e014702740
"Number of H terms: $(length(jl_mol_H))"

# ╔═╡ 2ff67c3c-7317-4733-8f2f-485e827b9f8e
md"""
We can also generate the list of *single* (targeting one electron) and *double*  (targeting two electrons) excitations that can be applied to a given basis state. Each excitation is a list of qubits to which the excitation is applied, and we can convert them from Python lists to Julia `Vector`s.
"""

# ╔═╡ da11146b-75b3-4e19-a570-39c4341f95c4
singles, doubles = qchem.excitations(n_electrons, n_qubits);

# ╔═╡ 4ffe6fc3-864c-4e19-8456-63a27ccd651b
jl_doubles = pyconvert(Vector{Vector{Int}}, doubles);

# ╔═╡ 5aebff15-8762-490f-b893-00f245280397
"Number of double excitations: $(length(jl_doubles))"

# ╔═╡ 7cd6c6ef-13d8-4137-94d0-a2aecb84814e
jl_singles = pyconvert(Vector{Vector{Int}}, singles);

# ╔═╡ 38b27b66-bd39-47b2-a3ff-5a7a6cc0618c
"Number of single excitations: $(length(jl_singles))"

# ╔═╡ 653bea2d-0efd-467a-b03e-e6902cf22ae3
md"""
PennyLane can also be used to construct the initial Hartree-Fock state for the molecule, which can then be transformed into a Julia `Circuit`:
"""

# ╔═╡ e0a1e89c-b1e0-4bf5-978b-53683eaad434
hf_state = qchem.hf_state(n_electrons, n_qubits);

# ╔═╡ 0582402e-60ff-41ce-8494-ba0c8b0258ad
"""
Build a circuit which prepares the initial Hartree-Fock state `hf_state`.
"""
BasisState(hf_state::Vector{Int}) = Circuit([(X, collect(findall(i->i>0, hf_state)))])

# ╔═╡ 1c26a144-a2ed-4447-8fc3-0d342ccedca5
"""
Transform the Python representation of the Hartree-Fock state `hf_state` to Julia.
"""
BasisState(hf_state::Py) = BasisState(pyconvert(Vector{Int}, hf_state.numpy()))

# ╔═╡ 31cce126-1934-4abc-bec2-711f7edac6b5
md"""
We also build up some logic to implement the double and single excitations, given the qubits to which they apply.
"""

# ╔═╡ dd0b404b-e257-4198-b078-876b79ee379f
"""
	DoubleExcitation(phis::Tuple{FreeParameter, FreeParameter}) -> Circuit

Construct a `Circuit` representing the application of a double excitation. Two `FreeParameter`s `phis` are needed in order to account for the differing sign in several angled gates (`phi_2` will have the same value as `phi_1`, but negative sign), as the Braket simulator can't yet handle parameter arithmetic.
"""
function DoubleExcitation(phis::Tuple{FreeParameter, FreeParameter})
    phi_1, phi_2 = phis
    c = Circuit()
    c(CNot, 2, 3)
    c(CNot, 0, 2)
    c(H, 3)
    c(H, 0)
    c(CNot, 2, 3)
    c(CNot, 0, 1)
    c(Ry, 1, phi_1)
    c(Ry, 0, phi_2)
    c(CNot, 0, 3)
    c(H, 3)
    c(CNot, 3, 1)
    c(Ry, 1, phi_1)
    c(Ry, 0, phi_2)
    c(CNot, 2, 1)
    c(CNot, 2, 0)
    c(Ry, 1, phi_2)
    c(Ry, 0, phi_1)
    c(CNot, 3, 1)
    c(H, 3)
    c(CNot, 0, 3)
    c(Ry, 1, phi_2)
    c(Ry, 0, phi_1)
    c(CNot, 0, 1)
    c(CNot, 2, 0)
    c(H, 0)
    c(H, 3)
    c(CNot, 0, 2)
    c(CNot, 2, 3)
    return c
end

# ╔═╡ f61bc4cc-7cb4-483a-8454-da60fc824146
"""
	SingleExcitation(phis::Tuple{FreeParameter, FreeParameter}) -> Circuit

Construct a `Circuit` representing the application of a single excitation. Two `FreeParameter`s `phis` are needed in order to account for the differing sign in several angled gates (`phi_2` will have the same value as `phi_1`, but negative sign), as the Braket simulator can't yet handle parameter arithmetic.
"""
function SingleExcitation(phis::Tuple{FreeParameter, FreeParameter})
    phi_1, phi_2 = phis
    c = Circuit()
    c(CNot, 0, 1)
    c(Ry, 0, phi_1)
    c(CNot, 1, 0)
    c(Ry, 0, phi_2)
    c(CNot, 1, 0)
    c(CNot, 0, 1)
    return c
end

# ╔═╡ cb1a9a5c-0711-478a-a855-b988021f3155
begin
	doubles_dict = Dict("d_$ii"=>jl_doubles[ii] for ii in 1:length(jl_doubles));
	singles_dict = Dict("s_$jj"=>jl_singles[jj] for jj in 1:length(jl_singles));
	excitations_dict = merge(doubles_dict, singles_dict);
end

# ╔═╡ 6c2a52c9-4513-4aef-8d8f-1571f1284002
md"""
Now we are ready to build the circuit which applies **all** the single and double excitations and computes their partial derivatives with respect to the molecular Hamiltonian. We'll use these partial derivatives to filter out all the excitations which contribute little to the final groundstate. Since we plan to use the Braket on-demand simulator to filter out the less important excitations, we can use the `AdjointGradient` result type. To learn more about this result type and the benefits of using it, see [this PennyLane-Braket blog post](https://pennylane.ai/blog/2022/12/computing-adjoint-gradients-with-amazon-braket-sv1/).
"""

# ╔═╡ ca19b82b-138b-4470-8a71-e2328b53b9c8
"""
Helper function to map a single parameter to its two constituents in order to implement parameter arithmetic.
"""
map_param(p::FreeParameter) = (FreeParameter(string(p) * "_1"), FreeParameter(string(p) * "_2"))

# ╔═╡ 268e830b-f091-4e9f-8091-55d1c2bf5894
function full_circuit(hf_state, doubles::Vector{Vector{Int}}, singles::Vector{Vector{Int}}, mol_H, H_targets)
	# construct unmapped and mapped parameters
    double_params = (FreeParameter("d_$ii") for ii in 1:length(doubles))
    single_params = (FreeParameter("s_$ii") for ii in 1:length(singles))
    # each double and single param is mapped to two new parameters
    mapped_double_params = Dict(d=>map_param(d) for d in double_params)
    mapped_single_params = Dict(s=>map_param(s) for s in single_params)
	
    # build the initial HF basis state
    c = BasisState(hf_state)
    # apply the excitations
    for (double, param) in zip(doubles, double_params)
		mapped = mapped_double_params[param]
        ex = DoubleExcitation(mapped)
        append!(c, ex, double)
    end
    for (single, param) in zip(singles, single_params)
		mapped = mapped_single_params[param]
        ex = SingleExcitation(mapped)
        append!(c, ex, single)
    end
    params = merge(mapped_double_params, mapped_single_params)
    # add the gradient result type - which also computes the cost
	c(AdjointGradient, mol_H, H_targets, ["all"])
    return c, params
end

# ╔═╡ f5559131-87e5-4b44-80e7-d16d835385ac
c, mapper = full_circuit(hf_state, jl_doubles, jl_singles, jl_mol_H, targets)

# ╔═╡ f536ff35-1d8b-47fd-8802-2e6cdf683000
"Unfiltered parallel gate depth: $(depth(c))"

# ╔═╡ d90c2f51-a521-43f0-bca2-e0994ce80e30
init_params = Dict(string(p)=>0.0 for p in c.parameters)

# ╔═╡ 8e87389c-8dd7-4397-8283-aa4f10208162
md"""
We will run this circuit on the on-demand state vector simulator, SV1. We run in `shots=0` (exact) mode in order to be able to use the `AdjointGradient` result type. We also provide values for all the `FreeParameter`s in the circuit.
"""

# ╔═╡ 1aa3a21e-e968-41ec-a000-9424eb2634ba
dev = AwsDevice("arn:aws:braket:::device/quantum-simulator/amazon/sv1")

# ╔═╡ 661c6780-e3f6-482f-9a03-e38863ee88f7
md"""
**Warning**: This cell can run for about half an hour on SV1, and can incur charges to your AWS account. For this reason, it's been disabled in this notebook. If you want to run it, re-enable the cell.
"""

# ╔═╡ b53c4d8c-2b10-4cd2-8379-42738029f0a9
t = dev(c, shots=0, inputs=init_params)

# ╔═╡ ea21ca72-6d59-4aab-9882-353ee7fbdd3c
res = result(t)

# ╔═╡ 00f94b37-7aa0-4ac7-b842-009ef21e56c3
md"""
Now we need to reconstruct the unmapped gradients and filter those with partial derivative magnitudes less than some cutoff. In this case, we'll pick `1e-8` as the cutoff. Try experimenting with different cutoffs and see how this can affect your results!
"""

# ╔═╡ 69facee7-063e-443c-9e1f-a848b494fe0a
"""
	reconstruct_gradients(raw_gradients, parameter_mapper)

Given the list of *mapped* parameter names and their partial derivatives, reconstruct the *unmapped* parameter and partial derivative pairs, using the known relationships between `phi_1` and `phi_2` for double and single excitations.
"""
function reconstruct_gradients(raw_gradients, parameter_mapper::Dict)
    function rebuild(g, mapped_gs)
        g_name = string(g)
		g_1 = Symbol(g_name*"_1")
		g_2 = Symbol(g_name*"_2")
        p_grads = (raw_gradients[g_1], -raw_gradients[g_2])
        if startswith(g_name, "d")
            return g=>(sum(p_grads) / 8)
        else
            return g=>sum(p_grads)
        end
    end
    return Dict(rebuild(k, v) for (k, v) in parameter_mapper)
end

# ╔═╡ 105feeed-146f-43df-8019-2841fe9b9238
function filter_and_order_excitations(task_result::Braket.GateModelQuantumTaskResult, cutoff::Float64=1e-8)
    raw_grads     = first(res.values)[:gradient]
    rebuilt_grads = reconstruct_gradients(raw_grads, mapper)
	# sort the parameters by absolute value of their partial derivatives
    sorted_keys   = sort(collect(keys(rebuilt_grads)), by=k->abs(rebuilt_grads[k]))
	# filter out those with partial derivatives smaller than the cutoff
    filtered_keys = Iterators.filter(k->abs(rebuilt_grads[k]) > cutoff, sorted_keys)
	# return the corresponding excitations in sorted order
    return [excitations_dict[string(k)] for k in filtered_keys]
end

# ╔═╡ 0c91bbff-31d9-4813-80e8-17cbff3656d0
cutoff = 1e-8

# ╔═╡ 336e4732-20ee-43e7-a49d-1351f9d266a9
ordered_excitations = filter_and_order_excitations(res, cutoff)

# ╔═╡ 0b8ffdea-aeae-4060-a08f-7393086c389d
"Number of filtered excitations: $(length(ordered_excitations))"

# ╔═╡ 5e678047-aeb0-4084-a793-8955b1465868
md"""
## The power of TETRIS

With the excitations filtered and sorted based on their magnitudes, we are ready to try both the naive ADAPT-VQE approach and the TETRIS-ADAPT-VQE scheme. The *results* (energies) of both should be the same, but the circuit depth should be shallower when using the TETRIS-ADAPT-VQE technique.
"""

# ╔═╡ d9ea7c12-fd21-4873-8426-a7b7c5f51e95
"""
Helper function to apply the circuit corresponding to a given excitation to the circuit and map its parameters.
"""
function build_excitation_circ(ex::Vector{Int}, double_ix::Int, single_ix::Int)
    if length(ex) == 4
        d = FreeParameter("d_$(double_ix)")
        mapped = map_param(d)
        return DoubleExcitation(mapped), double_ix + 1, single_ix
    else
        s = FreeParameter("s_$(single_ix)")
        mapped = map_param(s)
        return SingleExcitation(mapped), double_ix, single_ix + 1
    end
end

# ╔═╡ c58eb369-14e1-4d76-88c4-c6b9e96070af
begin
	n_doubles = count(ex->length(ex)==4, ordered_excitations)
    n_singles = count(ex->length(ex)==2, ordered_excitations)
	
    double_ps = [FreeParameter("d_$ii") for ii in 1:n_doubles]
    single_ps = [FreeParameter("s_$ii") for ii in 1:n_singles]
    # each double and single param is mapped to two new parameters
	mapped_doubles = Dict(p=>map_param(p) for p in double_ps)
	mapped_singles = Dict(p=>map_param(p) for p in single_ps)
    mapped_ps = merge(mapped_doubles, mapped_singles)
end

# ╔═╡ f9b9df66-3a25-4e69-97c0-3c178d5a0602
"""
Builds the naive ADAPT-VQE circuit from the selected excitations and molecular Hamiltonian.
"""
function adapt_circuit(hf_state, ordered_excitations, mol_H, H_targets)
    c = BasisState(hf_state)
    d_ix = 1
    s_ix = 1
    for ex in ordered_excitations
        ex_c, d_ix, s_ix = build_excitation_circ(ex, d_ix, s_ix)
        append!(c, ex_c, ex)
    end
    # add the gradient result type - which also computes the cost
    return c(AdjointGradient, mol_H, H_targets, ["all"])
end

# ╔═╡ ef8fa936-359c-43f2-91b8-50f65324caa3
"""
Builds the TETRIS-ADAPT-VQE circuit from the selected excitations and molecular Hamiltonian.
"""
function tetris_circuit(hf_state, ordered_excitations, mol_H, H_targets)
    c = BasisState(hf_state)
    d_ix = 1
    s_ix = 1
    while length(ordered_excitations) > 0
		next_excitation_ind = 1
		touched_this_round = Set{Int}()
		# find the excitation with the next largest contribution which
		# will not increase the parallel gate depth
        next_excitation_ind = findfirst(ex->isdisjoint(ex, touched_this_round), ordered_excitations)
		# exit once as many qubits are addressed in this moment as possible
        while !isnothing(next_excitation_ind)
            next_ex = popat!(ordered_excitations, next_excitation_ind)
            ex_c, d_ix, s_ix = build_excitation_circ(next_ex, d_ix, s_ix)
            append!(c, ex_c, next_ex)
			
            union!(touched_this_round, next_ex)
			# will be nothing if there is no excitation left which doesn't
			# touch an already-touched-this-round qubit
            next_excitation_ind = findnext(ex->isdisjoint(ex, touched_this_round), ordered_excitations, next_excitation_ind)
        end
    end
    # add the gradient result type - which also computes the cost
    return c(AdjointGradient, mol_H, H_targets, ["all"])
end

# ╔═╡ d6b31724-8862-4c58-b6a5-b82814efb677
adapt_c = adapt_circuit(hf_state, ordered_excitations, jl_mol_H, targets)

# ╔═╡ 28762af7-1426-4ac5-acfe-d2628d68bfab
"Total parallel gate depth for naive ADAPT-VQE ansatz: $(depth(adapt_c))"

# ╔═╡ 9db4967c-46a6-4950-99f6-82b382d3530a
tetris_c = tetris_circuit(hf_state, copy(ordered_excitations), jl_mol_H, targets)

# ╔═╡ 0a8943ce-fb98-4838-b04c-55b5548c0184
"Total parallel gate depth for TETRIS-ADAPT-VQE ansatz: $(depth(tetris_c))"

# ╔═╡ dcf89cc2-e9b2-4cc2-8d2c-3c2f4b5c58f1
md"""
We can see that the TETRIS-ADAPT-VQE circuit is more shallow, rendering it more amenable to today's NISQ devices. If you run these two circuits (with the same parameter values!) on SV1, you'll see the energies are the same.
"""

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
CondaPkg = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"

[compat]
Braket = "~0.4.1"
CondaPkg = "~0.2.17"
PyBraket = "~0.4.1"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.0-beta3"
manifest_format = "2.0"
project_hash = "82b1b87d69a608f890b56fda571de2de0ee7a079"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "SHA", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "487d6835da9876e0362a83aec169e390872eba64"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.81.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "59aa23fae39bf1664fd698ef74b3a46650539b26"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.3"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "563d60f89fcb730668bd568ba3e752ee71dde023"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "2.0.2"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "f82715aca8dd4c9e87ac348e6ab204784b131f2b"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.4.1"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "SnoopPrecompile", "Tables", "Unicode", "WeakRefStrings", "WorkerUtilities"]
git-tree-sha1 = "c700cce799b51c9045473de751e9319bdd1c6e94"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.9"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c6d890a52d2c4d55d326439580c3b8d0875a77d9"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.7"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "9c209fb7536406834aa938fb149964b985de6c83"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.1"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "61fdd77467a5c3ad071ef8277ac6bd6af7dd4c04"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.6.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.2+0"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "4682a2d28f98aa83be1ed137c0bd7d053f85db79"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.17"

[[deps.DataAPI]]
git-tree-sha1 = "e8119c1a33d267e16108be441a287a6981ba1630"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.14.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "2fb1e02f2b635d0845df5d7c167fec4dd739b00d"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.3"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "5688002de970b9eee14b7af7bbbd1fdac10c9bbe"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.2"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "37e4657cd56b11abe3d10cd4a1ec5fbdb4180263"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.7.4"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "9cc2baf75c6d09f9da536ddf58eb2f29dedaf461"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.4.0"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "84b10656a41ef564c39d2d477d7236966d2b5683"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.12.0"

[[deps.LazyArtifacts]]
deps = ["Artifacts", "Pkg"]
uuid = "4af54fe1-eca0-43a8-85a7-787d91b784e3"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c7cb1f5d892775ba13767a87c7ada0b980ea0a71"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+2"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["DocStringExtensions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "680e733c3a0a9cea9e935c8c2184aea6a63fa0b5"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.21"

    [deps.LogExpFunctions.extensions]
    ChainRulesCoreExt = "ChainRulesCore"
    ChangesOfVariablesExt = "ChangesOfVariables"
    InverseFunctionsExt = "InverseFunctions"

    [deps.LogExpFunctions.weakdeps]
    ChainRulesCore = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
    ChangesOfVariables = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
    InverseFunctions = "3587e190-3f89-42d0-90ee-14403ec27112"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "cedb76b37bc5a6c702ade66be44f831fa23c681e"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "1.0.0"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch", "micromamba_jll"]
git-tree-sha1 = "a6a4771aba1dc8942bc0f44ff9f8ee0f893ef888"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.12"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["Compat", "ExprTools"]
git-tree-sha1 = "c272302b22479a24d1cf48c114ad702933414f80"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.5"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.NamedTupleTools]]
git-tree-sha1 = "90914795fc59df44120fe3fff6742bb0d7adb1d0"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.3"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "6503b77492fd7fcb9379bf73cd31035670e3c509"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.3"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9ff31d101d987eb9d66bd8b176ac7c277beccd09"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.20+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "6f4fbcd1ad45905a5dee3f4256fabb49aa2110c6"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.7"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.0"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PyBraket]]
deps = ["Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "PythonCall", "Statistics", "StructTypes"]
git-tree-sha1 = "ec53c19001d7a603658a750467d25f8c67750f01"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.4.1"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "1052188e0a017d4f4f261f12307e1fa1b5b48588"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.10"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "c02bd3c9c3fc8463d3591a62a378f90d2d8ab0f3"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.17"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SnoopPrecompile]]
deps = ["Preferences"]
git-tree-sha1 = "e760a70afdcd461cf01a575947738d359234665c"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.3"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "67d3e75e8af8089ea34ce96974d5468d4a008ca6"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.15"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+0"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "94f38103c984f89cf77c402f2a68dbd870f8165f"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.11"

[[deps.URIs]]
git-tree-sha1 = "074f993b0ca030848b897beff716d93aca60f06a"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.2"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.WorkerUtilities]]
git-tree-sha1 = "cd1659ba0d57b71a464a29e64dbc67cfe83d54e7"
uuid = "76eceee3-57b5-4d4a-8e66-0e911cebbf60"
version = "1.6.1"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "93c41695bc1c08c46c5899f4fe06d6ead504bb73"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.10.3+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.2.0+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.micromamba_jll]]
deps = ["Artifacts", "JLLWrappers", "LazyArtifacts", "Libdl"]
git-tree-sha1 = "f272e9232759cc692f9f4edb70440bcf832a3fe1"
uuid = "f8abcde7-e9b7-5caa-b8af-a437887ae8e4"
version = "1.3.1+0"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"
"""

# ╔═╡ Cell order:
# ╟─7fe2bb2d-4c6a-441d-9743-1471aec6f0b1
# ╟─5a283f0e-76ec-4975-90f1-b824eae4350b
# ╠═2feb54cc-abd3-11ed-08d0-89d3036b2224
# ╠═be0d2559-b555-4026-934a-ca4922edb9af
# ╠═d0e4e6bc-92e9-49a6-924d-999db1de14e3
# ╠═bd980a06-718f-4896-9b21-fcad0ec715e5
# ╠═fa7fafac-4529-4c22-9cbe-fc0dfdc15032
# ╟─94712ed6-5489-4973-bc45-5d18017facd7
# ╠═9cd02259-e77a-40d3-89fb-5aceb6c88855
# ╟─cc9358b3-f5f3-44e5-8ffb-078768c79c59
# ╠═655e7ea1-8e68-40d0-8791-22f4addd70e3
# ╟─28857109-96c1-4a34-b376-9dd2ee6c8d80
# ╟─09e0a358-fadb-467f-b2c4-3e25c9e711d1
# ╠═d7508af5-a21e-4726-bdf5-e90c375bd1c0
# ╠═ad4759d4-7e75-4e32-bf9d-b7d50fab4366
# ╟─e386fe38-6034-40e0-8d92-d7a505d717f9
# ╠═24be5c3a-3bc6-4d61-96ee-28cfe0e98ddd
# ╟─8d9402e6-a01d-4dc3-a86d-9710b34cd807
# ╠═2730bf2b-d010-4358-a176-1a3860bc28b7
# ╠═cf977978-c4df-4ce1-9811-875d2832ec3a
# ╠═10eaf3c1-2b5d-4346-835e-ccc32e11771d
# ╠═4c3496d3-8242-4815-8230-f8e014702740
# ╟─2ff67c3c-7317-4733-8f2f-485e827b9f8e
# ╠═da11146b-75b3-4e19-a570-39c4341f95c4
# ╠═4ffe6fc3-864c-4e19-8456-63a27ccd651b
# ╠═5aebff15-8762-490f-b893-00f245280397
# ╠═7cd6c6ef-13d8-4137-94d0-a2aecb84814e
# ╠═38b27b66-bd39-47b2-a3ff-5a7a6cc0618c
# ╟─653bea2d-0efd-467a-b03e-e6902cf22ae3
# ╠═e0a1e89c-b1e0-4bf5-978b-53683eaad434
# ╠═0582402e-60ff-41ce-8494-ba0c8b0258ad
# ╠═1c26a144-a2ed-4447-8fc3-0d342ccedca5
# ╟─31cce126-1934-4abc-bec2-711f7edac6b5
# ╠═dd0b404b-e257-4198-b078-876b79ee379f
# ╠═f61bc4cc-7cb4-483a-8454-da60fc824146
# ╠═cb1a9a5c-0711-478a-a855-b988021f3155
# ╟─6c2a52c9-4513-4aef-8d8f-1571f1284002
# ╠═ca19b82b-138b-4470-8a71-e2328b53b9c8
# ╠═268e830b-f091-4e9f-8091-55d1c2bf5894
# ╠═f5559131-87e5-4b44-80e7-d16d835385ac
# ╠═f536ff35-1d8b-47fd-8802-2e6cdf683000
# ╠═d90c2f51-a521-43f0-bca2-e0994ce80e30
# ╟─8e87389c-8dd7-4397-8283-aa4f10208162
# ╠═1aa3a21e-e968-41ec-a000-9424eb2634ba
# ╟─661c6780-e3f6-482f-9a03-e38863ee88f7
# ╠═b53c4d8c-2b10-4cd2-8379-42738029f0a9
# ╠═ea21ca72-6d59-4aab-9882-353ee7fbdd3c
# ╟─00f94b37-7aa0-4ac7-b842-009ef21e56c3
# ╠═69facee7-063e-443c-9e1f-a848b494fe0a
# ╠═105feeed-146f-43df-8019-2841fe9b9238
# ╠═0c91bbff-31d9-4813-80e8-17cbff3656d0
# ╠═336e4732-20ee-43e7-a49d-1351f9d266a9
# ╠═0b8ffdea-aeae-4060-a08f-7393086c389d
# ╟─5e678047-aeb0-4084-a793-8955b1465868
# ╠═d9ea7c12-fd21-4873-8426-a7b7c5f51e95
# ╠═c58eb369-14e1-4d76-88c4-c6b9e96070af
# ╠═f9b9df66-3a25-4e69-97c0-3c178d5a0602
# ╠═ef8fa936-359c-43f2-91b8-50f65324caa3
# ╠═d6b31724-8862-4c58-b6a5-b82814efb677
# ╠═28762af7-1426-4ac5-acfe-d2628d68bfab
# ╠═9db4967c-46a6-4950-99f6-82b382d3530a
# ╠═0a8943ce-fb98-4838-b04c-55b5548c0184
# ╟─dcf89cc2-e9b2-4cc2-8d2c-3c2f4b5c58f1
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

module PyBraket
    using PythonCall
    using DataStructures
    using Braket
    import Braket: Instruction
    using Braket.IR
    import Braket.IR: TimeSeries, AtomArrangement, DrivingField, PhysicalField, ShiftingField, Setup, Hamiltonian, AHSProgram
    export PyLocalSimulator
    import PythonCall: Py

    const awsbraket   = PythonCall.pynew()
    const local_sim   = PythonCall.pynew()
    const default_sim = PythonCall.pynew()
    const tasks       = PythonCall.pynew()
    const pyahs       = PythonCall.pynew()
    const pyopenqasm  = PythonCall.pynew()
    const collections = PythonCall.pynew()

    function __init__()
        # must set these when this code is actually loaded
        PythonCall.pycopy!(awsbraket,   pyimport("braket.aws"))
        PythonCall.pycopy!(local_sim,   pyimport("braket.devices.local_simulator"))
        PythonCall.pycopy!(default_sim, pyimport("braket.default_simulator"))
        PythonCall.pycopy!(pyopenqasm,  pyimport("braket.ir.openqasm"))
        PythonCall.pycopy!(pyahs,       pyimport("braket.ir.ahs"))
        PythonCall.pycopy!(tasks,       pyimport("braket.tasks"))
        PythonCall.pycopy!(collections, pyimport("collections"))
        PythonCall.pyconvert_add_rule("collections:Counter", Accumulator, counter_to_acc)
        Braket._simulator_devices[]["braket_ahs"] = PyLocalSimulator("braket_ahs") 
    end
    function counter_to_acc(::Type{Accumulator}, x::Py)
        return counter((pyconvert(Any, el) for el in  x.elements()))
    end
    function conv_multilevel_vec(v::Vector{T}) where {T}
        isbitstype(T) && return pylist(v)
        T == String && return pylist(pystr.(v))
        return pylist(conv_multilevel_vec.(v))
    end
    conv_multilevel_vec(t::String) = pystr(t)
    conv_multilevel_vec(t::IR.PhysicalField) = Py(t)
    conv_multilevel_vec(t::IR.DrivingField)  = Py(t)
    conv_multilevel_vec(t::IR.ShiftingField) = Py(t)

    function arg_gen(x::T, fns) where {T}
        args = map(fns) do fn
            val = getproperty(x, fn)
            isnothing(val) && return fn=>pybuiltins.None
            typeof(val) <: NTuple{1} && return fn=>Py(val[1])
            typeof(val) <: Vector{<:Number} && return fn=>pylist(Py(val))
            typeof(val) == Vector{String} && return fn=>pylist(pystr.(val))
            typeof(val) == Vector{Braket.IR.PhysicalField} && return fn=>pylist(Py.(val))
            typeof(val) == Vector{Braket.IR.DrivingField} && return fn=>pylist(Py.(val))
            typeof(val) <: Vector && return fn=>conv_multilevel_vec(val)
            typeof(val) <: Dict && return fn=>pydict(val)
            typeof(val) == String && return fn=>pystr(val)
            return fn=>Py(val)
        end
        return args
    end
    include("pyahs.jl")
    include("pyschema.jl")
    using .PySchema
    include("local_simulator.jl")
end

using Braket, Test, Mocking, JSON3, Dates, Graphs
using Braket: status
Mocking.activate()


MOCK_GATE_MODEL_QPU_CAPABILITIES_1 = """{
    "braketSchemaHeader": {
        "name": "braket.device_schema.rigetti.rigetti_device_capabilities",
        "version": "1"
    },
    "service": {
        "executionWindows": [
            {
                "executionDay": "Everyday",
                "windowStartHour": "11:00",
                "windowEndHour": "12:00"
            }
        ],
        "shotsRange": [1, 10]
    },
    "action": {
        "braket.ir.jaqcd.program": {
            "actionType": "braket.ir.jaqcd.program",
            "version": ["1"],
            "supportedOperations": ["H"]
        }
    },
    "paradigm": {
        "qubitCount": 30,
        "nativeGateSet": ["ccnot", "cy"],
        "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
    },
    "deviceParameters": {}
}"""

MOCK_GATE_MODEL_QPU_1() = """{
    "deviceName": "Aspen-10",
    "deviceType": "QPU",
    "providerName": "provider1",
    "deviceStatus": "OFFLINE",
    "deviceCapabilities": $MOCK_GATE_MODEL_QPU_CAPABILITIES_1,
    "deviceQueueInfo": [{"queue": "QUANTUM_TASKS_QUEUE", "queueSize": "19", "queuePriority": "Normal"}, {"queue": "QUANTUM_TASKS_QUEUE", "queueSize": "3", "queuePriority": "Priority"}, {"queue": "JOBS_QUEUE", "queueSize": "0 (3 prioritized job(s) running)"}]
}"""

MOCK_GATE_MODEL_QPU_CAPABILITIES_2 = """{
    "braketSchemaHeader": {
        "name": "braket.device_schema.rigetti.rigetti_device_capabilities",
        "version": "1"
    },
    "service": {
        "executionWindows": [
            {
                "executionDay": "Everyday",
                "windowStartHour": "11:00",
                "windowEndHour": "12:00"
            }
        ],
        "shotsRange": [1, 10]
    },
    "action": {
        "braket.ir.jaqcd.program": {
            "actionType": "braket.ir.jaqcd.program",
            "version": ["1"],
            "supportedOperations": ["H"]
        }
    },
    "paradigm": {
        "qubitCount": 30,
        "nativeGateSet": ["ccnot", "cy"],
        "connectivity": {"fullyConnected": true, "connectivityGraph": {}}
    },
    "deviceParameters": {}
}"""

MOCK_GATE_MODEL_QPU_2() = """{
    "deviceName": "Blah",
    "deviceType": "QPU",
    "providerName": "blahhhh",
    "deviceStatus": "OFFLINE",
    "deviceCapabilities": $MOCK_GATE_MODEL_QPU_CAPABILITIES_2
}"""

MOCK_DWAVE_QPU_CAPABILITIES = """{
    "braketSchemaHeader": {
        "name": "braket.device_schema.dwave.dwave_device_capabilities",
        "version": "1"
    },
    "provider": {
        "annealingOffsetStep": 1.45,
        "annealingOffsetStepPhi0": 1.45,
        "annealingOffsetRanges": [[1.45, 1.45], [1.45, 1.45]],
        "annealingDurationRange": [1, 2, 3],
        "couplers": [[1, 2], [2, 3]],
        "defaultAnnealingDuration": 1,
        "defaultProgrammingThermalizationDuration": 1,
        "defaultReadoutThermalizationDuration": 1,
        "extendedJRange": [1, 2, 3],
        "hGainScheduleRange": [1, 2, 3],
        "hRange": [1, 2, 3],
        "jRange": [1, 2, 3],
        "maximumAnnealingSchedulePoints": 1,
        "maximumHGainSchedulePoints": 1,
        "perQubitCouplingRange": [1, 2, 3],
        "programmingThermalizationDurationRange": [1, 2, 3],
        "qubits": [1, 2, 3],
        "qubitCount": 1,
        "quotaConversionRate": 1,
        "readoutThermalizationDurationRange": [1, 2, 3],
        "taskRunDurationRange": [1, 2, 3],
        "topology": {}
    },
    "service": {
        "executionWindows": [
            {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
        ],
        "shotsRange": [1, 10]
    },
    "action": {
        "braket.ir.annealing.problem": {
            "actionType": "braket.ir.annealing.problem",
            "version": ["1"]
        }
    },
    "deviceParameters": {}
}"""

MOCK_DWAVE_QPU() = """{
    "deviceName": "Advantage_system1.1",
    "deviceType": "QPU",
    "providerName": "provider1",
    "deviceStatus": "ONLINE",
    "deviceCapabilities": $MOCK_DWAVE_QPU_CAPABILITIES
}"""

@testset "Devices" begin
    dev = Braket.AwsDevice(_arn="fake:arn")
    dev._default_shots=10
    @test convert(String, dev) == "fake:arn"
    c = CNot(Circuit(), 0, 1)
    resp_dict = Dict("quantumTaskArn"=>"arn/fake", "status"=>"COMPLETED")
    req_patch  = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
    apply(req_patch) do
        t = dev(c, s3_destination_folder=("fake_bucket", "fake_prefix"))
        @test arn(t) == "arn/fake"
        t = dev([c, c], s3_destination_folder=("fake_bucket", "fake_prefix"))
        @test arn.(Braket.tasks(t)) == ["arn/fake", "arn/fake"]
    end
    resp_dict = Dict("deviceName"=>"fake_name", "deviceStatus"=>"fake_status", "deviceType"=>"fake_type", "providerName"=>"fake_provider", "deviceCapabilities"=>nothing)
    req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
    apply(req_patch) do
        Braket.refresh_metadata!(dev)
        @test arn(dev) == "fake:arn"
        @test dev._name == "fake_name"
        @test name(dev) == "fake_name"
        @test dev._status == "fake_status"
        @test status(dev) == "fake_status"
        @test dev._type == "fake_type"
        @test type(dev) == "fake_type"
        @test dev._provider_name == "fake_provider"
        @test provider_name(dev) == "fake_provider"
        @test isnothing(dev._properties)
        @test isnothing(properties(dev))
        @test sprint(show, dev) == "AwsDevice(arn=fake:arn)"
    end
    execution_window = Braket.DeviceExecutionWindow("everyday",Dates.Time("00:00:00"),Dates.Time("23:59:59"))
    dsp = Braket.DeviceServiceProperties(Braket.header_dict[Braket.DeviceServiceProperties], [execution_window], (0, 1000), nothing, nothing, nothing, nothing, nothing)
    paradigm = Braket.GateModelSimulatorParadigmProperties(Braket.header_dict[Braket.GateModelSimulatorParadigmProperties], 100)
    dev_capa = Braket.GateModelSimulatorDeviceCapabilities(dsp, Dict(), Dict(), Braket.header_dict[Braket.GateModelSimulatorDeviceCapabilities], paradigm)
    resp_dict = Dict{String, Any}("devices"=>[Dict{String, Any}(
        "deviceName"=>"fakeName",
        "deviceType"=>"fakeType",
        "deviceStatus"=>"fakeStatus",
        "providerName"=>"fakeProvider",
        "deviceCapabilities"=>JSON3.write(dev_capa),
    )])
    req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
    apply(req_patch) do
        r = Braket.search_devices(arns=["fakeName"])
        resp_dict["devices"][1]["deviceCapabilities"] = Braket.parse_raw_schema(resp_dict["devices"][1]["deviceCapabilities"])
        @test r == resp_dict["devices"]
    end
    @testset "isavailable" begin
        dev._properties = dev_capa
        dev._status = "ONLINE"
        @test isavailable(dev)
        dev._status = "OFFLINE"
        @test !isavailable(dev)
    end
    @testset "topology graphs" begin
        graphs = [SimpleDiGraph(Edge.([(1, 2), (1, 3)])), complete_digraph(30), SimpleDiGraph(Edge.([(1, 2), (2, 3)]))]
        @testset for (qpu, graph) in zip([MOCK_GATE_MODEL_QPU_1, MOCK_GATE_MODEL_QPU_2, MOCK_DWAVE_QPU], graphs)
            req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(qpu()))
            apply(req_patch) do
                dev = Braket.AwsDevice(_arn="fake_arn")
                Braket.refresh_metadata!(dev)
                qpu_dict = JSON3.read(qpu())
                @test dev._name == qpu_dict["deviceName"]
                @test dev._status == qpu_dict["deviceStatus"]
                @test dev._type == qpu_dict["deviceType"]
                @test dev._provider_name == qpu_dict["providerName"]
                @test dev._topology_graph == graph
            end
        end
    end
    @testset "construction and region search" begin
        SIMULATOR_ARN = "arn:aws:braket:::device/quantum-simulator/fake_provider/fake_sim"
        NO_REGION_QPU_ARN = "arn:aws:braket:::device/qpu/fake_provider/fake_qpu"
        REGION_QPU_ARN = "arn:aws:braket:fake-region::device/qpu/fake_provider/fake_qpu"
        
        resp_dict = Dict("deviceName"=>"fake_sim", "deviceStatus"=>"fake_status", "deviceType"=>"SIMULATOR", "providerName"=>"fake_provider", "deviceCapabilities"=>nothing)
        req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            dev = AwsDevice(SIMULATOR_ARN)
            @test name(dev) == "fake_sim"
            @test status(dev) == "fake_status"
            @test type(dev) == "SIMULATOR"
            @test provider_name(dev) == "fake_provider"
            @test isnothing(properties(dev))
            @test Braket.AWS.region(dev._config) == Braket.AWS.region(Braket.AWS.global_aws_config())
        end

        resp_dict = Dict("deviceName"=>"fake_qpu", "deviceStatus"=>"fake_status", "deviceType"=>"QPU", "providerName"=>"fake_provider", "deviceCapabilities"=>nothing)
        req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            dev = AwsDevice(REGION_QPU_ARN)
            @test name(dev) == "fake_qpu"
            @test status(dev) == "fake_status"
            @test type(dev) == "QPU"
            @test provider_name(dev) == "fake_provider"
            @test isnothing(properties(dev))
            @test Braket.AWS.region(dev._config) == "fake-region"
        end
        
        resp_dict = Dict("deviceName"=>"fake_qpu", "deviceStatus"=>"fake_status", "deviceType"=>"QPU", "providerName"=>"fake_provider", "deviceCapabilities"=>nothing)
        req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(JSON3.write(resp_dict)))
        apply(req_patch) do
            dev = AwsDevice(NO_REGION_QPU_ARN)
            @test name(dev) == "fake_qpu"
            @test status(dev) == "fake_status"
            @test type(dev) == "QPU"
            @test provider_name(dev) == "fake_provider"
            @test isnothing(properties(dev))
            @test Braket.AWS.region(dev._config) == Braket.AWS.region(Braket.AWS.global_aws_config())
        end

        # test fails
        msg = "Could not resolve host: braket.fake-region.amazonaws.com while requesting https://braket.fake-region.amazonaws.com/device/arn%3Aaws%3Abraket%3A%3A%3Adevice%2Fquantum_simulator%2Ffake_provider%2Ffake_sim"
        dl_ex  = Braket.Downloads.RequestError("", 404, msg, Braket.Downloads.Response("", "https://braket.fake-region.amazonaws.com/device/arn%3Aaws%3Abraket%3A%3A%3Adevice%2Fquantum_simulator%2Ffake_provider%2Ffake_sim", 404, msg, ["foo"=>"bar"])) 
        req_patch = @patch Braket.AWS._http_request(a...; b...) = throw(dl_ex)
        apply(req_patch) do
            current_region = Braket.AWS.region(Braket.AWS.global_aws_config())
            @test_throws ErrorException("Simulator $SIMULATOR_ARN not found in '$current_region'") AwsDevice(SIMULATOR_ARN)
        end
        
        msg = "Could not resolve host: braket.fake-region.amazonaws.com while requesting https://braket.fake-region.amazonaws.com/device/arn%3Aaws%3Abraket%3Afake-region%3A%3Adevice%2Fqpu%2Ffake_provider%2Ffake_qpu"
        dl_ex  = Braket.Downloads.RequestError("", 404, msg, Braket.Downloads.Response("", "https://braket.fake-region.amazonaws.com/device/arn%3Aaws%3Abraket%3Afake-region%3A%3Adevice%2Fqpu%2Ffake_provider%2Ffake_qpu", 404, msg, ["foo"=>"bar"])) 
        req_patch = @patch Braket.AWS._http_request(a...; b...) = throw(dl_ex)
        apply(req_patch) do
            @test_throws ErrorException("QPU arn:aws:braket:::device/qpu/fake_provider/fake_qpu not found") AwsDevice(NO_REGION_QPU_ARN)
        end
    end
    @testset "Queue depth" begin
        qpu = MOCK_GATE_MODEL_QPU_1
        req_patch = @patch Braket.AWS._http_request(a...; b...) = Braket.AWS.Response(Braket.HTTP.Response(200, ["Content-Type"=>"application/json"]), IOBuffer(qpu()))
        apply(req_patch) do
            dev = Braket.AwsDevice(_arn="fake_arn")
            @test queue_depth(dev) == QueueDepthInfo(Dict(Normal=>"19", Priority=>"3"), "0 (3 prioritized job(s) running)")
        end
    end
end

const MAX_RETRIES = 3
const CONCURRENT_TASK_LIMIT = 100

"""
    AwsQuantumTaskBatch

Struct representing a batch of tasks run concurrently on an Amazon-managed device.
"""
mutable struct AwsQuantumTaskBatch
    _tasks::Vector{AwsQuantumTask}
    _results::Union{Nothing, Vector}
    _unsuccessful::Set{String}
    _device_arn::String
    _task_specifications::Vector{<:Union{Circuit, Program, OpenQasmProgram}}
    _s3_destination_folder::Tuple{String, String}
    _shots::Int
    _poll_timeout_seconds::Int
    _poll_interval_seconds::Int
    _config::AbstractAWSConfig
    function AwsQuantumTaskBatch(tasks, results, unsuccessful, device_arn, task_specs, s3_dest, shots, timeout, interval, config=global_aws_config())
        length(tasks) != length(task_specs) && throw(ArgumentError("number of quantum tasks ($(length(tasks))) and task specifications ($(length(task_specs))) must be equal!"))
        new(tasks, results, unsuccessful, device_arn, task_specs, s3_dest, shots, timeout, interval, config)
    end
    @doc """
        AwsQuantumTaskBatch(device_arn::String, task_specs::Vector{<:Union{AbstractProgram, Circuit}}; kwargs...) -> AwsQuantumTaskBatch
    
    Launches a batch of concurrent tasks specified by `task_specs` on `device_arn`.

    Valid `kwargs` are:
      - `s3_destination_folder::Tuple{String, String}` - s3 bucket and prefix in which to store results. Default: `default_task_bucket()`
      - `shots::Int` - the number of shots to run each task with. Default: $DEFAULT_SHOTS
      - `poll_timeout_seconds::Int` - maximum number of seconds to wait while polling for results. Default: $DEFAULT_RESULTS_POLL_TIMEOUT
      - `poll_interval_seconds::Int` - default number of seconds to wait between attempts while polling for results. Default: $DEFAULT_RESULTS_POLL_INTERVAL
    """
    function AwsQuantumTaskBatch(device_arn::String, task_specs::Vector{<:Union{AbstractProgram, Circuit}}; s3_destination_folder::Tuple{String, String}=default_task_bucket(), shots::Int=DEFAULT_SHOTS, poll_timeout_seconds::Int=DEFAULT_RESULTS_POLL_TIMEOUT, poll_interval_seconds=DEFAULT_RESULTS_POLL_INTERVAL, inputs=Dict{String, Float64}(), config::AbstractAWSConfig=global_aws_config())
        tasks = launch_batch(device_arn, task_specs; s3_destination_folder=s3_destination_folder, shots=shots, poll_interval_seconds=poll_interval_seconds, inputs=inputs, config=config)
        new(tasks, nothing, Set(), device_arn, task_specs, s3_destination_folder, shots, poll_timeout_seconds, poll_interval_seconds, config)
    end
end

function launch_batch(device_arn::String, task_specs::Vector{<:Union{AbstractProgram, Circuit}}; disable_qubit_rewiring::Bool=false, kwargs...)
    tasks         = Vector{AwsQuantumTask}(undef, length(task_specs))
    s3_folder     = haskey(kwargs, :s3_destination_folder) ? kwargs[:s3_destination_folder] : default_task_bucket()
    shots         = get(kwargs, :shots, DEFAULT_SHOTS)
    device_params = get(kwargs, :device_params, Dict{String, Any}())
    input_dicts   = get(kwargs, :inputs, Dict{String, Float64}())
    if !isempty(input_dicts)
        if input_dicts isa Dict
            input = [prepare_task_input(ts, device_arn, s3_folder, shots, device_params, disable_qubit_rewiring; inputs=input_dicts, kwargs...) for ts in task_specs]
        elseif input_dicts isa Vector
            length(input_dicts) == length(task_specs) || throw(DimensionMismatch("number of input dictionaries $(length(input_dicts)) must equal number of task specifications $(length(task_specs))."))
            new_kwargs = delete(namedtuple(collect(kwargs)), :inputs)
            input = [prepare_task_input(ts, device_arn, s3_folder, shots, device_params, disable_qubit_rewiring; inputs=ts_input, new_kwargs...) for (ts, ts_input) in zip(task_specs, input_dicts)]
        else
            throw(ArgumentError("invalid inputs $input_dicts."))
        end
    else
        input = [prepare_task_input(ts, device_arn, s3_folder, shots, device_params, disable_qubit_rewiring; kwargs...) for ts in task_specs]
    end
    to_launch = Threads.Atomic{Int}(length(task_specs))
    tasks = Vector{AwsQuantumTask}(undef, length(task_specs))
    Threads.@threads for ii in 1:length(task_specs)
        tasks[ii] = AwsQuantumTask(input[ii])
        Threads.atomic_sub!(to_launch, 1)
        while to_launch[] > 0
            state(tasks[ii]) ∈ ["FAILED", "CANCELLED", "COMPLETED"] && break
            sleep(kwargs[:poll_interval_seconds])
        end
    end
    return tasks
end

function _retrieve_results(tasks::Vector{AwsQuantumTask})
    res_ = Vector{Any}(undef, length(tasks))
    Threads.@threads for ii in 1:length(tasks)
        res_[ii] = result(tasks[ii])
    end
    return res_
end

tasks(b::AwsQuantumTaskBatch) = b._tasks
Base.length(b::AwsQuantumTaskBatch) = length(b._tasks)

"""
    results(b::AwsQuantumTaskBatch; kwargs)

Valid `kwargs` are:
  - `fail_unsuccessful::Bool` - whether to throw an error if any tasks in the batch are unsuccessful after retries. Default: `false`
  - `max_retries::Int` - maximum number of times to retry a failed task. Default: $MAX_RETRIES
  - `use_cached_value::Bool` - whether to reuse previously downloaded results for tasks or download all results fresh. Default: `true`

Blocks and waits while retrieving results for every task in `b`.
"""
function results(b::AwsQuantumTaskBatch; fail_unsuccessful::Bool=false, max_retries::Int=MAX_RETRIES, use_cached_value::Bool=true)
    if isnothing(b._results) || !use_cached_value
        b._results = _retrieve_results(b._tasks)
        b._unsuccessful = Set(id(task) for task in findall(isnothing, Dict(zip(b._tasks, b._results))))
    end

    retries = 0
    while length(b._unsuccessful) > 0 && retries < max_retries
        retry_unsuccessful_tasks(b)
        retries += 1
    end
    fail_unsuccessful && length(b._unsuccessful) > 0 && throw(ErrorException("$(length(b._unsuccessful)) tasks failed to complete after $max_retries retries."))
    return b._results
end

function retry_unsuccessful_tasks(b::AwsQuantumTaskBatch)
    isnothing(b._results) && throw(ErrorException("results() should be called before attempting to retry"))

    unsuccessful_inds = findall(isnothing, b._results)
    isempty(unsuccessful_inds) && return

    retried_tasks = launch_batch(b._device_arn, b._task_specifications[unsuccessful_inds], s3_destination_folder=b._s3_destination_folder, shots=b._shots)
    b._tasks[unsuccessful_inds] = retried_tasks[:]
    retried_results = _retrieve_results(retried_tasks)
    b._results[unsuccessful_inds] = retried_results[:]
    b._unsuccessful = Set(id(task) for task in findall(isnothing, Dict(zip(b._tasks, b._results))))
    return
end

function unfinished(b::AwsQuantumTaskBatch)
    statuses = Vector{String}(undef, length(b))
    Threads.@threads for ii in 1:length(b)
        statuses[ii] = state(b._tasks[ii])
    end
    ts_pairs = Dict(zip(b._tasks, statuses))
    b._unsuccessful = Set(id(task) for task in findall(x->x∈["FAILED", "CANCELLED"], ts_pairs))
    unfinished = Set(id(task) for task in findall(x->x∈["QUEUED", "RUNNING"], ts_pairs))
    return unfinished
end

unsuccessful(b::AwsQuantumTaskBatch) = b._unsuccessful

using Dates, NamedTupleTools
import StructTypes

const GateFidelityType = Dict{String, Union{String, Float64}}
const OneQubitType     = Union{Float64, Vector{GateFidelityType}}
const TwoQubitType     = Dict{String, Union{Float64, Dict{String, Int}}}
const QubitType        = Dict{String, Union{OneQubitType, TwoQubitType}}


StructTypes.StructType(::Type{Dec128}) = StructTypes.CustomStruct()
StructTypes.lower(d::Dec128) = string(d)
StructTypes.lowertype(::Type{Dec128}) = String
StructTypes.constructfrom(::Type{Dec128}, x::Number) = Dec128(string(x))
StructTypes.constructfrom(s::StructTypes.CustomStruct, ::Type{Dec128}, x::String) = Dec128(x)
abstract type BraketSchemaBase end
StructTypes.StructType(::Type{BraketSchemaBase}) = StructTypes.AbstractType()
function bsh_f(raw_sym::Symbol)
    raw = String(raw_sym)
    v   = eval(Meta.parse(raw))
    bsh = v["name"] * "_v" * v["version"]
    return type_dict[bsh]
end
StructTypes.subtypes(::Type{BraketSchemaBase}) = StructTypes.SubTypeClosure(bsh_f)

StructTypes.subtypekey(::Type{BraketSchemaBase}) = :braketSchemaHeader

struct braketSchemaHeader
    name::String
    version::String
end
StructTypes.StructType(::Type{braketSchemaHeader}) = StructTypes.UnorderedStruct()

struct DwaveTiming
    qpuSamplingTime::Union{Nothing, Int}
    qpuAnnealTimePerSample::Union{Nothing, Int}
    qpuAccessTime::Union{Nothing, Int}
    qpuAccessOverheadTime::Union{Nothing, Int}
    qpuReadoutTimePerSample::Union{Nothing, Int}
    qpuProgrammingTime::Union{Nothing, Int}
    qpuDelayTimePerSample::Union{Nothing, Int}
    postProcessingOverheadTime::Union{Nothing, Int}
    totalPostProcessingTime::Union{Nothing, Int}
    totalRealTime::Union{Nothing, Int}
    runTimeChip::Union{Nothing, Int}
    annealTimePerRun::Union{Nothing, Int}
    readoutTimePerRun::Union{Nothing, Int}
end
StructTypes.StructType(::Type{DwaveTiming}) = StructTypes.UnorderedStruct()

@enum ProblemType qubo ising
ProblemTypeDict = Dict(string(inst)=>inst for inst in instances(ProblemType))
Base.:(==)(x::ProblemType, y::String) = string(x) == y
Base.:(==)(x::String, y::ProblemType) = string(y) == x
abstract type AbstractProgram <: BraketSchemaBase end
StructTypes.StructType(::Type{AbstractProgram}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{AbstractProgram}) = StructTypes.SubTypeClosure(bsh_f)
StructTypes.subtypekey(::Type{AbstractProgram}) = :braketSchemaHeader

struct NativeQuilMetadata
    finalRewiring::Vector{Int}
    gateDepth::Int
    gateVolume::Int
    multiQubitGateDepth::Int
    programDuration::Float64
    programFidelity::Float64
    qpuRuntimeEstimation::Float64
    topologicalSwaps::Int
end
StructTypes.StructType(::Type{NativeQuilMetadata}) = StructTypes.UnorderedStruct()

struct XanaduMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    compiledProgram::String
end
StructTypes.StructType(::Type{XanaduMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XanaduMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.xanadu_metadata", "1"))

struct IonQMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    sharpenedProbabilities::Union{Nothing, Dict{String, Float64}}
end
StructTypes.StructType(::Type{IonQMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IonQMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.ionq_metadata", "1"))

struct OqcMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    compiledProgram::String
end
StructTypes.StructType(::Type{OqcMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OqcMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.oqc_metadata", "1"))

struct IqmMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    compiledProgram::String
end
StructTypes.StructType(::Type{IqmMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IqmMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.iqm_metadata", "1"))

struct SimulatorMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    executionDuration::Int
end
StructTypes.StructType(::Type{SimulatorMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{SimulatorMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.simulator_metadata", "1"))

struct DwaveMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    activeVariables::Vector{Int}
    timing::DwaveTiming
end
StructTypes.StructType(::Type{DwaveMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.dwave_metadata", "1"))

struct RigettiMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    nativeQuilMetadata::Union{Nothing, NativeQuilMetadata}
    compiledProgram::String
end
StructTypes.StructType(::Type{RigettiMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{RigettiMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.rigetti_metadata", "1"))

struct QueraMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    numSuccessfulShots::Int
end
StructTypes.StructType(::Type{QueraMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{QueraMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.quera_metadata", "1"))

abstract type DeviceActionProperties <: BraketSchemaBase end
StructTypes.StructType(::Type{DeviceActionProperties}) = StructTypes.AbstractType()
function dap_f(raw_sym::Symbol)
    raw = String(raw_sym)
    occursin("jaqcd", raw) && return JaqcdDeviceActionProperties
    occursin("openqasm", raw) && return OpenQASMDeviceActionProperties
    occursin("blackbird", raw) && return BlackbirdDeviceActionProperties
    return GenericDeviceActionProperties
end
StructTypes.subtypes(::Type{DeviceActionProperties}) = StructTypes.SubTypeClosure(dap_f)
StructTypes.subtypekey(::Type{DeviceActionProperties}) = :actionType

struct TemplateWaveformArgument
    name::String
    value::Union{Nothing, Any}
    type::String
    optional::Bool
end
StructTypes.StructType(::Type{TemplateWaveformArgument}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{TemplateWaveformArgument}) = Dict{Symbol, Any}(:optional => false)

struct TemplateWaveform
    waveformId::String
    name::String
    arguments::Vector{TemplateWaveformArgument}
end
StructTypes.StructType(::Type{TemplateWaveform}) = StructTypes.UnorderedStruct()

struct ArbitraryWaveform
    waveformId::String
    amplitudes::Vector{Tuple{Float64, Float64}}
end
StructTypes.StructType(::Type{ArbitraryWaveform}) = StructTypes.UnorderedStruct()

module IR
import ..Braket: AbstractProgram, braketSchemaHeader, ProblemType, BraketSchemaBase
using DecFP, StructTypes

export Program, AHSProgram, AbstractIR, AbstractProgramResult, CompilerDirective, IRObservable

abstract type AbstractIR end
StructTypes.StructType(::Type{AbstractIR}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{AbstractIR})   = (z=Z, sample=Sample, cphaseshift01=CPhaseShift01, phase_damping=PhaseDamping, rz=Rz, generalized_amplitude_damping=GeneralizedAmplitudeDamping, xx=XX, zz=ZZ, phase_flip=PhaseFlip, vi=Vi, depolarizing=Depolarizing, variance=Variance, two_qubit_depolarizing=TwoQubitDepolarizing, densitymatrix=DensityMatrix, cphaseshift00=CPhaseShift00, ecr=ECR, ccnot=CCNot, unitary=Unitary, bit_flip=BitFlip, y=Y, swap=Swap, cz=CZ, cnot=CNot, adjoint_gradient=AdjointGradient, cswap=CSwap, ry=Ry, i=I, si=Si, amplitude_damping=AmplitudeDamping, statevector=StateVector, iswap=ISwap, h=H, xy=XY, yy=YY, t=T, ahsprogram=AHSProgram, two_qubit_dephasing=TwoQubitDephasing, x=X, ti=Ti, cv=CV, pauli_channel=PauliChannel, pswap=PSwap, expectation=Expectation, probability=Probability, phaseshift=PhaseShift, v=V, cphaseshift=CPhaseShift, s=S, rx=Rx, kraus=Kraus, amplitude=Amplitude, cphaseshift10=CPhaseShift10, multi_qubit_pauli_channel=MultiQubitPauliChannel, cy=CY, undefinedgate=UndefinedGate)

const IRObservable = Union{Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, String}
Base.convert(::Type{IRObservable}, v::Vector{String}) = convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, v)
Base.convert(::Type{IRObservable}, s::String)         = s
Base.convert(::Type{IRObservable}, v::Vector{Vector{Vector{Vector{Float64}}}}) = convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, v)
Base.:(==)(s::String, iro::IRObservable) = all(iro .== s)
Base.:(==)(iro::IRObservable, s::String) = all(iro .== s)

abstract type CompilerDirective <: AbstractIR end
StructTypes.StructType(::Type{CompilerDirective}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{CompilerDirective}) = (end_verbatim_box=EndVerbatimBox, start_verbatim_box=StartVerbatimBox)

abstract type AbstractProgramResult <: AbstractIR end
StructTypes.StructType(::Type{AbstractProgramResult}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{AbstractProgramResult}) = (amplitude=Amplitude, expectation=Expectation, probability=Probability, sample=Sample, statevector=StateVector, densitymatrix=DensityMatrix, variance=Variance, adjoint_gradient=AdjointGradient)

struct AtomArrangement <: AbstractIR
    sites::Vector{Vector{Dec128}}
    filling::Vector{Int}
end
StructTypes.StructType(::Type{AtomArrangement}) = StructTypes.UnorderedStruct()

struct TimeSeries <: AbstractIR
    values::Vector{Dec128}
    times::Vector{Dec128}
end
StructTypes.StructType(::Type{TimeSeries}) = StructTypes.UnorderedStruct()

struct PhysicalField <: AbstractIR
    time_series::TimeSeries
    pattern::Union{String, Vector{Dec128}}
end
StructTypes.StructType(::Type{PhysicalField}) = StructTypes.UnorderedStruct()

struct DrivingField <: AbstractIR
    amplitude::PhysicalField
    phase::PhysicalField
    detuning::PhysicalField
end
StructTypes.StructType(::Type{DrivingField}) = StructTypes.UnorderedStruct()

struct ShiftingField <: AbstractIR
    magnitude::PhysicalField
end
StructTypes.StructType(::Type{ShiftingField}) = StructTypes.UnorderedStruct()

struct Setup <: AbstractIR
    ahs_register::AtomArrangement
end
StructTypes.StructType(::Type{Setup}) = StructTypes.UnorderedStruct()

struct Hamiltonian <: AbstractIR
    drivingFields::Vector{DrivingField}
    shiftingFields::Vector{ShiftingField}
end
StructTypes.StructType(::Type{Hamiltonian}) = StructTypes.UnorderedStruct()

struct Z <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{Z}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Z}) = Dict{Symbol, Any}(:type => "z")

struct Si <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{Si}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Si}) = Dict{Symbol, Any}(:type => "si")

struct T <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{T}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{T}) = Dict{Symbol, Any}(:type => "t")

struct Program <: AbstractProgram
    braketSchemaHeader::braketSchemaHeader
    instructions::Vector{<:Any}
    results::Union{Nothing, Vector{AbstractProgramResult}}
    basis_rotation_instructions::Union{Nothing, Vector{<:Any}}
end
StructTypes.StructType(::Type{Program}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Program}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.ir.jaqcd.program", "1"))

struct AHSProgram <: AbstractProgram
    braketSchemaHeader::braketSchemaHeader
    setup::Setup
    hamiltonian::Hamiltonian
end
StructTypes.StructType(::Type{AHSProgram}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{AHSProgram}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.ir.ahs.program", "1"))

struct TwoQubitDepolarizing <: AbstractIR
    probability::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{TwoQubitDepolarizing}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{TwoQubitDepolarizing}) = Dict{Symbol, Any}(:type => "two_qubit_depolarizing")

struct CNot <: AbstractIR
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CNot}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CNot}) = Dict{Symbol, Any}(:type => "cnot")

struct Sample <: AbstractProgramResult
    observable::Union{Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, String}
    targets::Union{Nothing, Vector{Int}}
    type::String
end
StructTypes.StructType(::Type{Sample}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Sample}) = Dict{Symbol, Any}(:type => "sample")

struct Kraus <: AbstractIR
    targets::Vector{Int}
    matrices::Vector{Vector{Vector{Vector{Float64}}}}
    type::String
end
StructTypes.StructType(::Type{Kraus}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Kraus}) = Dict{Symbol, Any}(:type => "kraus")

struct CPhaseShift01 <: AbstractIR
    angle::Float64
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CPhaseShift01}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CPhaseShift01}) = Dict{Symbol, Any}(:type => "cphaseshift01")

struct DensityMatrix <: AbstractProgramResult
    targets::Union{Nothing, Vector{Int}}
    type::String
end
StructTypes.StructType(::Type{DensityMatrix}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DensityMatrix}) = Dict{Symbol, Any}(:type => "densitymatrix")

struct PSwap <: AbstractIR
    angle::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{PSwap}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PSwap}) = Dict{Symbol, Any}(:type => "pswap")

struct AmplitudeDamping <: AbstractIR
    gamma::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{AmplitudeDamping}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{AmplitudeDamping}) = Dict{Symbol, Any}(:type => "amplitude_damping")

struct TwoQubitDephasing <: AbstractIR
    probability::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{TwoQubitDephasing}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{TwoQubitDephasing}) = Dict{Symbol, Any}(:type => "two_qubit_dephasing")

struct Expectation <: AbstractProgramResult
    observable::Union{Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, String}
    targets::Union{Nothing, Vector{Int}}
    type::String
end
StructTypes.StructType(::Type{Expectation}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Expectation}) = Dict{Symbol, Any}(:type => "expectation")

struct BitFlip <: AbstractIR
    probability::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{BitFlip}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{BitFlip}) = Dict{Symbol, Any}(:type => "bit_flip")

struct Amplitude <: AbstractProgramResult
    states::Vector{String}
    type::String
end
StructTypes.StructType(::Type{Amplitude}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Amplitude}) = Dict{Symbol, Any}(:type => "amplitude")

struct X <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{X}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{X}) = Dict{Symbol, Any}(:type => "x")

struct CPhaseShift10 <: AbstractIR
    angle::Float64
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CPhaseShift10}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CPhaseShift10}) = Dict{Symbol, Any}(:type => "cphaseshift10")

struct PhaseDamping <: AbstractIR
    gamma::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{PhaseDamping}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PhaseDamping}) = Dict{Symbol, Any}(:type => "phase_damping")

struct CPhaseShift00 <: AbstractIR
    angle::Float64
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CPhaseShift00}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CPhaseShift00}) = Dict{Symbol, Any}(:type => "cphaseshift00")

struct Rz <: AbstractIR
    angle::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{Rz}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Rz}) = Dict{Symbol, Any}(:type => "rz")

struct MultiQubitPauliChannel <: AbstractIR
    probabilities::Dict{String, Float64}
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{MultiQubitPauliChannel}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{MultiQubitPauliChannel}) = Dict{Symbol, Any}(:type => "multi_qubit_pauli_channel")

struct CV <: AbstractIR
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CV}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CV}) = Dict{Symbol, Any}(:type => "cv")

struct Y <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{Y}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Y}) = Dict{Symbol, Any}(:type => "y")

struct Ti <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{Ti}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Ti}) = Dict{Symbol, Any}(:type => "ti")

struct StartVerbatimBox <: CompilerDirective
    directive::String
    type::String
end
StructTypes.StructType(::Type{StartVerbatimBox}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{StartVerbatimBox}) = Dict{Symbol, Any}(:directive => "StartVerbatimBox", :type => "start_verbatim_box")

struct Probability <: AbstractProgramResult
    targets::Union{Nothing, Vector{Int}}
    type::String
end
StructTypes.StructType(::Type{Probability}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Probability}) = Dict{Symbol, Any}(:type => "probability")

struct GeneralizedAmplitudeDamping <: AbstractIR
    probability::Float64
    gamma::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{GeneralizedAmplitudeDamping}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GeneralizedAmplitudeDamping}) = Dict{Symbol, Any}(:type => "generalized_amplitude_damping")

struct UndefinedGate <: AbstractIR
    angles
    controls::Vector{Int}
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{UndefinedGate}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{UndefinedGate}) = Dict{Symbol, Any}(:type => "undefined_gate")

struct ECR <: AbstractIR
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{ECR}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{ECR}) = Dict{Symbol, Any}(:type => "ecr")

struct PhaseShift <: AbstractIR
    angle::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{PhaseShift}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PhaseShift}) = Dict{Symbol, Any}(:type => "phaseshift")

struct V <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{V}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{V}) = Dict{Symbol, Any}(:type => "v")

struct AdjointGradient <: AbstractProgramResult
    parameters::Union{Nothing, Vector{String}}
    observable::Union{Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, String}
    targets::Union{Nothing, Vector{Vector{Int}}}
    type::String
end
StructTypes.StructType(::Type{AdjointGradient}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{AdjointGradient}) = Dict{Symbol, Any}(:type => "adjoint_gradient")

struct XX <: AbstractIR
    angle::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{XX}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XX}) = Dict{Symbol, Any}(:type => "xx")

struct StateVector <: AbstractProgramResult
    type::String
end
StructTypes.StructType(::Type{StateVector}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{StateVector}) = Dict{Symbol, Any}(:type => "statevector")

struct ZZ <: AbstractIR
    angle::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{ZZ}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{ZZ}) = Dict{Symbol, Any}(:type => "zz")

struct Swap <: AbstractIR
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{Swap}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Swap}) = Dict{Symbol, Any}(:type => "swap")

struct ISwap <: AbstractIR
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{ISwap}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{ISwap}) = Dict{Symbol, Any}(:type => "iswap")

struct CSwap <: AbstractIR
    control::Int
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{CSwap}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CSwap}) = Dict{Symbol, Any}(:type => "cswap")

struct PhaseFlip <: AbstractIR
    probability::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{PhaseFlip}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PhaseFlip}) = Dict{Symbol, Any}(:type => "phase_flip")

struct Vi <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{Vi}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Vi}) = Dict{Symbol, Any}(:type => "vi")

struct H <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{H}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{H}) = Dict{Symbol, Any}(:type => "h")

struct CPhaseShift <: AbstractIR
    angle::Float64
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CPhaseShift}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CPhaseShift}) = Dict{Symbol, Any}(:type => "cphaseshift")

struct XY <: AbstractIR
    angle::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{XY}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XY}) = Dict{Symbol, Any}(:type => "xy")

struct CY <: AbstractIR
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CY}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CY}) = Dict{Symbol, Any}(:type => "cy")

struct Ry <: AbstractIR
    angle::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{Ry}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Ry}) = Dict{Symbol, Any}(:type => "ry")

struct CCNot <: AbstractIR
    controls::Vector{Int}
    target::Int
    type::String
end
StructTypes.StructType(::Type{CCNot}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CCNot}) = Dict{Symbol, Any}(:type => "ccnot")

struct PauliChannel <: AbstractIR
    probX::Float64
    probY::Float64
    probZ::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{PauliChannel}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PauliChannel}) = Dict{Symbol, Any}(:type => "pauli_channel")

struct Unitary <: AbstractIR
    targets::Vector{Int}
    matrix::Vector{Vector{Vector{Float64}}}
    type::String
end
StructTypes.StructType(::Type{Unitary}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Unitary}) = Dict{Symbol, Any}(:type => "unitary")

struct I <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{I}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{I}) = Dict{Symbol, Any}(:type => "i")

struct S <: AbstractIR
    target::Int
    type::String
end
StructTypes.StructType(::Type{S}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{S}) = Dict{Symbol, Any}(:type => "s")

struct Depolarizing <: AbstractIR
    probability::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{Depolarizing}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Depolarizing}) = Dict{Symbol, Any}(:type => "depolarizing")

struct CZ <: AbstractIR
    control::Int
    target::Int
    type::String
end
StructTypes.StructType(::Type{CZ}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CZ}) = Dict{Symbol, Any}(:type => "cz")

struct EndVerbatimBox <: CompilerDirective
    directive::String
    type::String
end
StructTypes.StructType(::Type{EndVerbatimBox}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{EndVerbatimBox}) = Dict{Symbol, Any}(:directive => "EndVerbatimBox", :type => "end_verbatim_box")

struct YY <: AbstractIR
    angle::Float64
    targets::Vector{Int}
    type::String
end
StructTypes.StructType(::Type{YY}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{YY}) = Dict{Symbol, Any}(:type => "yy")

struct Rx <: AbstractIR
    angle::Float64
    target::Int
    type::String
end
StructTypes.StructType(::Type{Rx}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Rx}) = Dict{Symbol, Any}(:type => "rx")

struct Variance <: AbstractProgramResult
    observable::Union{Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, String}
    targets::Union{Nothing, Vector{Int}}
    type::String
end
StructTypes.StructType(::Type{Variance}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Variance}) = Dict{Symbol, Any}(:type => "variance")

Base.:(==)(o1::T, o2::T) where {T<:AbstractIR} = all(getproperty(o1, fn) == getproperty(o2, fn) for fn in fieldnames(T))

end # module

using .IR
@enum _CopyMode always if_needed never
_CopyModeDict = Dict(string(inst)=>inst for inst in instances(_CopyMode))
Base.:(==)(x::_CopyMode, y::String) = string(x) == y
Base.:(==)(x::String, y::_CopyMode) = string(y) == x
@enum Extra allow ignore forbid
ExtraDict = Dict(string(inst)=>inst for inst in instances(Extra))
Base.:(==)(x::Extra, y::String) = string(x) == y
Base.:(==)(x::String, y::Extra) = string(y) == x
@enum SafeUUID safe unsafe unknown
SafeUUIDDict = Dict(string(inst)=>inst for inst in instances(SafeUUID))
Base.:(==)(x::SafeUUID, y::String) = string(x) == y
Base.:(==)(x::String, y::SafeUUID) = string(y) == x
@enum PaymentCardBrand amex mastercard visa other
PaymentCardBrandDict = Dict(string(inst)=>inst for inst in instances(PaymentCardBrand))
Base.:(==)(x::PaymentCardBrand, y::String) = string(x) == y
Base.:(==)(x::String, y::PaymentCardBrand) = string(y) == x
@enum Protocol json pickle
ProtocolDict = Dict(string(inst)=>inst for inst in instances(Protocol))
Base.:(==)(x::Protocol, y::String) = string(x) == y
Base.:(==)(x::String, y::Protocol) = string(y) == x
@enum DeviceActionType openqasm jaqcd blackbird annealing ahs
DeviceActionTypeDict = Dict(string(inst)=>inst for inst in instances(DeviceActionType))
Base.:(==)(x::DeviceActionType, y::String) = string(x) == y
Base.:(==)(x::String, y::DeviceActionType) = string(y) == x
@enum ExecutionDay everyday weekdays weekends monday tuesday wednesday thursday friday saturday sunday
ExecutionDayDict = Dict(string(inst)=>inst for inst in instances(ExecutionDay))
Base.:(==)(x::ExecutionDay, y::String) = string(x) == y
Base.:(==)(x::String, y::ExecutionDay) = string(y) == x
@enum ExponentType int float
ExponentTypeDict = Dict(string(inst)=>inst for inst in instances(ExponentType))
Base.:(==)(x::ExponentType, y::String) = string(x) == y
Base.:(==)(x::String, y::ExponentType) = string(y) == x
@enum QubitDirection control target
QubitDirectionDict = Dict(string(inst)=>inst for inst in instances(QubitDirection))
Base.:(==)(x::QubitDirection, y::String) = string(x) == y
Base.:(==)(x::String, y::QubitDirection) = string(y) == x
@enum PostProcessingType sampling optimization
PostProcessingTypeDict = Dict(string(inst)=>inst for inst in instances(PostProcessingType))
Base.:(==)(x::PostProcessingType, y::String) = string(x) == y
Base.:(==)(x::String, y::PostProcessingType) = string(y) == x
@enum ResultFormat raw histogram
ResultFormatDict = Dict(string(inst)=>inst for inst in instances(ResultFormat))
Base.:(==)(x::ResultFormat, y::String) = string(x) == y
Base.:(==)(x::String, y::ResultFormat) = string(y) == x
@enum Direction tx rx
DirectionDict = Dict(string(inst)=>inst for inst in instances(Direction))
Base.:(==)(x::Direction, y::String) = string(x) == y
Base.:(==)(x::String, y::Direction) = string(y) == x
@enum PersistedJobDataFormat plaintext pickled_v4
PersistedJobDataFormatDict = Dict(string(inst)=>inst for inst in instances(PersistedJobDataFormat))
Base.:(==)(x::PersistedJobDataFormat, y::String) = string(x) == y
Base.:(==)(x::String, y::PersistedJobDataFormat) = string(y) == x
struct ResultType
    name::String
    observables::Union{Nothing, Vector{String}}
    minShots::Union{Nothing, Int}
    maxShots::Union{Nothing, Int}
end
StructTypes.StructType(::Type{ResultType}) = StructTypes.UnorderedStruct()

struct DeviceExecutionWindow
    executionDay::Union{ExecutionDay, String}
    windowStartHour::Dates.Time
    windowEndHour::Dates.Time
end
StructTypes.StructType(::Type{DeviceExecutionWindow}) = StructTypes.UnorderedStruct()

struct DeviceCost
    price::Float64
    unit::String
end
StructTypes.StructType(::Type{DeviceCost}) = StructTypes.UnorderedStruct()

struct DeviceDocumentation
    imageUrl::Union{Nothing, String}
    summary::Union{Nothing, String}
    externalDocumentationUrl::Union{Nothing, String}
end
StructTypes.StructType(::Type{DeviceDocumentation}) = StructTypes.UnorderedStruct()

struct DeviceConnectivity
    fullyConnected::Bool
    connectivityGraph::Dict
end
StructTypes.StructType(::Type{DeviceConnectivity}) = StructTypes.UnorderedStruct()

struct Control
    name::String
    max_qubits::Union{Nothing, Int}
end
StructTypes.StructType(::Type{Control}) = StructTypes.UnorderedStruct()

struct NegControl
    name::String
    max_qubits::Union{Nothing, Int}
end
StructTypes.StructType(::Type{NegControl}) = StructTypes.UnorderedStruct()

struct Power
    name::String
    exponent_types::Vector{ExponentType}
end
StructTypes.StructType(::Type{Power}) = StructTypes.UnorderedStruct()

struct Inverse
    name::String
end
StructTypes.StructType(::Type{Inverse}) = StructTypes.UnorderedStruct()

struct FidelityType
    name::String
    description::Union{Nothing, String}
end
StructTypes.StructType(::Type{FidelityType}) = StructTypes.UnorderedStruct()

struct GateFidelity2Q
    direction::Union{Nothing, Dict{QubitDirection, Int}}
    gateName::String
    fidelity::Float64
    standardError::Union{Nothing, Float64}
    fidelityType::FidelityType
end
StructTypes.StructType(::Type{GateFidelity2Q}) = StructTypes.UnorderedStruct()

struct TwoQubitProperties
    twoQubitGateFidelity::Vector{GateFidelity2Q}
end
StructTypes.StructType(::Type{TwoQubitProperties}) = StructTypes.UnorderedStruct()

struct Fidelity1Q
    fidelityType::FidelityType
    fidelity::Float64
    standardError::Union{Nothing, Float64}
end
StructTypes.StructType(::Type{Fidelity1Q}) = StructTypes.UnorderedStruct()

struct CoherenceTime
    value::Float64
    standardError::Union{Nothing, Float64}
    unit::String
end
StructTypes.StructType(::Type{CoherenceTime}) = StructTypes.UnorderedStruct()

struct OneQubitProperties
    T1::CoherenceTime
    T2::CoherenceTime
    oneQubitFidelity::Vector{Fidelity1Q}
end
StructTypes.StructType(::Type{OneQubitProperties}) = StructTypes.UnorderedStruct()

abstract type ErrorMitigationScheme end
StructTypes.StructType(::Type{ErrorMitigationScheme}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{ErrorMitigationScheme}) = (debias=Debias)

struct ErrorMitigationProperties
    minimumShots::Int
end
StructTypes.StructType(::Type{ErrorMitigationProperties}) = StructTypes.UnorderedStruct()

struct Frame
    frameId::String
    portId::String
    frequency::Float64
    centerFrequency::Union{Nothing, Float64}
    phase::Float64
    associatedGate::Union{Nothing, String}
    qubitMappings::Union{Nothing, Vector{Int}}
    qhpSpecificProperties::Union{Nothing, Dict{String, Any}}
end
StructTypes.StructType(::Type{Frame}) = StructTypes.UnorderedStruct()

struct Port
    portId::String
    direction::Direction
    portType::String
    dt::Float64
    qubitMappings::Union{Nothing, Vector{Int}}
    centerFrequencies::Union{Nothing, Set{Float64}}
    qhpSpecificProperties::Union{Nothing, Dict{String, Any}}
end
StructTypes.StructType(::Type{Port}) = StructTypes.UnorderedStruct()

struct PulseFunctionArgument
    name::String
    value::Union{Nothing, Any}
    type::String
    optional::Bool
end
StructTypes.StructType(::Type{PulseFunctionArgument}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PulseFunctionArgument}) = Dict{Symbol, Any}(:optional => false)

struct PulseFunction
    name::String
    arguments::Vector{PulseFunctionArgument}
end
StructTypes.StructType(::Type{PulseFunction}) = StructTypes.UnorderedStruct()
PulseFunction(name::Nothing, arguments::Vector{PulseFunctionArgument}) = PulseFunction("", arguments)

struct PulseInstructionArgument
    name::String
    value::Union{Nothing, Any}
    type::String
    optional::Bool
end
StructTypes.StructType(::Type{PulseInstructionArgument}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PulseInstructionArgument}) = Dict{Symbol, Any}(:optional => false)

struct PulseInstruction
    name::String
    arguments::Union{Nothing, Vector{PulseInstructionArgument}}
end
StructTypes.StructType(::Type{PulseInstruction}) = StructTypes.UnorderedStruct()

struct NativeGate
    name::String
    qubits::Vector{String}
    arguments::Vector{String}
    calibrations::Vector{Union{PulseInstruction, PulseFunction}}
end
StructTypes.StructType(::Type{NativeGate}) = StructTypes.UnorderedStruct()

struct Area
    width::Dec128
    height::Dec128
end
StructTypes.StructType(::Type{Area}) = StructTypes.UnorderedStruct()

struct Geometry
    spacingRadialMin::Dec128
    spacingVerticalMin::Dec128
    positionResolution::Dec128
    numberSitesMax::Int
end
StructTypes.StructType(::Type{Geometry}) = StructTypes.UnorderedStruct()

struct Lattice
    area::Area
    geometry::Geometry
end
StructTypes.StructType(::Type{Lattice}) = StructTypes.UnorderedStruct()

struct RydbergGlobal
    rabiFrequencyRange::Tuple{Dec128, Dec128}
    rabiFrequencyResolution::Dec128
    rabiFrequencySlewRateMax::Dec128
    detuningRange::Tuple{Dec128, Dec128}
    detuningResolution::Dec128
    detuningSlewRateMax::Dec128
    phaseRange::Tuple{Dec128, Dec128}
    phaseResolution::Dec128
    timeResolution::Dec128
    timeDeltaMin::Dec128
    timeMin::Dec128
    timeMax::Dec128
end
StructTypes.StructType(::Type{RydbergGlobal}) = StructTypes.UnorderedStruct()

struct Rydberg
    c6Coefficient::Dec128
    rydbergGlobal::RydbergGlobal
end
StructTypes.StructType(::Type{Rydberg}) = StructTypes.UnorderedStruct()

struct PerformanceLattice
    positionErrorAbs::Dec128
end
StructTypes.StructType(::Type{PerformanceLattice}) = StructTypes.UnorderedStruct()

struct PerformanceRydbergGlobal
    rabiFrequencyErrorRel::Dec128
end
StructTypes.StructType(::Type{PerformanceRydbergGlobal}) = StructTypes.UnorderedStruct()

struct PerformanceRydberg
    rydbergGlobal::PerformanceRydbergGlobal
end
StructTypes.StructType(::Type{PerformanceRydberg}) = StructTypes.UnorderedStruct()

struct Performance
    lattice::PerformanceLattice
    rydberg::PerformanceRydberg
end
StructTypes.StructType(::Type{Performance}) = StructTypes.UnorderedStruct()

struct AdditionalMetadata
    action::AbstractProgram
    dwaveMetadata::Union{Nothing, DwaveMetadata}
    ionqMetadata::Union{Nothing, IonQMetadata}
    rigettiMetadata::Union{Nothing, RigettiMetadata}
    oqcMetadata::Union{Nothing, OqcMetadata}
    iqmMetadata::Union{Nothing, IqmMetadata}
    xanaduMetadata::Union{Nothing, XanaduMetadata}
    queraMetadata::Union{Nothing, QueraMetadata}
    simulatorMetadata::Union{Nothing, SimulatorMetadata}
end
StructTypes.StructType(::Type{AdditionalMetadata}) = StructTypes.UnorderedStruct()

struct AnalogHamiltonianSimulationShotMetadata
    shotStatus::String
end
StructTypes.StructType(::Type{AnalogHamiltonianSimulationShotMetadata}) = StructTypes.UnorderedStruct()

struct AnalogHamiltonianSimulationShotResult
    preSequence::Union{Nothing, Vector{Int}}
    postSequence::Union{Nothing, Vector{Int}}
end
StructTypes.StructType(::Type{AnalogHamiltonianSimulationShotResult}) = StructTypes.UnorderedStruct()

struct AnalogHamiltonianSimulationShotMeasurement
    shotMetadata::AnalogHamiltonianSimulationShotMetadata
    shotResult::AnalogHamiltonianSimulationShotResult
end
StructTypes.StructType(::Type{AnalogHamiltonianSimulationShotMeasurement}) = StructTypes.UnorderedStruct()

struct ResultTypeValue
    type::AbstractProgramResult
    value::Union{Vector, Float64, Dict}
end
StructTypes.StructType(::Type{ResultTypeValue}) = StructTypes.UnorderedStruct()

struct BlackbirdDeviceActionProperties <: DeviceActionProperties
    version::Vector{String}
    actionType::String
    supportedOperations::Union{Nothing, Vector{String}}
    supportedResultTypes::Vector{ResultType}
end
StructTypes.StructType(::Type{BlackbirdDeviceActionProperties}) = StructTypes.UnorderedStruct()

struct JaqcdDeviceActionProperties <: DeviceActionProperties
    version::Vector{String}
    actionType::String
    supportedOperations::Union{Nothing, Vector{String}}
    supportedResultTypes::Union{Nothing, Vector{ResultType}}
    disabledQubitRewiringSupported::Union{Nothing, Bool}
end
StructTypes.StructType(::Type{JaqcdDeviceActionProperties}) = StructTypes.UnorderedStruct()

struct OpenQASMDeviceActionProperties <: DeviceActionProperties
    version::Vector{String}
    actionType::String
    supportedOperations::Union{Nothing, Vector{String}}
    supportedModifiers::Vector{Union{Control, NegControl, Power, Inverse}}
    supportedPragmas::Vector{String}
    forbiddenPragmas::Vector{String}
    maximumQubitArrays::Union{Nothing, Int}
    maximumClassicalArrays::Union{Nothing, Int}
    forbiddenArrayOperations::Vector{String}
    requiresAllQubitsMeasurement::Bool
    supportPhysicalQubits::Bool
    requiresContiguousQubitIndices::Bool
    supportsPartialVerbatimBox::Bool
    supportsUnassignedMeasurements::Bool
    disabledQubitRewiringSupported::Bool
    supportedResultTypes::Union{Nothing, Vector{ResultType}}
end
StructTypes.StructType(::Type{OpenQASMDeviceActionProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OpenQASMDeviceActionProperties}) = Dict{Symbol, Any}(:supportedModifiers => Any[], :supportsUnassignedMeasurements => true, :requiresAllQubitsMeasurement => false, :supportedPragmas => Any[], :supportPhysicalQubits => false, :supportsPartialVerbatimBox => true, :forbiddenPragmas => Any[], :requiresContiguousQubitIndices => false, :disabledQubitRewiringSupported => false, :forbiddenArrayOperations => Any[])

struct ContinuousVariableQpuParadigmProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    modes::Dict{String, Float64}
    layout::String
    compiler::Vector{String}
    supportedLanguages::Vector{String}
    compilerDefault::String
    nativeGateSet::Vector{String}
    gateParameters::Dict{String, Vector{Vector{Float64}}}
    target::String
end
StructTypes.StructType(::Type{ContinuousVariableQpuParadigmProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{ContinuousVariableQpuParadigmProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.continuous_variable_qpu_paradigm_properties", "1"))

struct DeviceServiceProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    executionWindows::Vector{DeviceExecutionWindow}
    shotsRange::Tuple{Int, Int}
    deviceCost::Union{Nothing, DeviceCost}
    deviceDocumentation::Union{Nothing, DeviceDocumentation}
    deviceLocation::Union{Nothing, String}
    updatedAt::Union{Nothing, String}
    getTaskPollIntervalMillis::Union{Nothing, Int}
end
StructTypes.StructType(::Type{DeviceServiceProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DeviceServiceProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.device_service_properties", "1"))

struct GateModelParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    qubitCount::Int
    disableQubitRewiring::Bool
end
StructTypes.StructType(::Type{GateModelParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.gate_model_parameters", "1"), :disableQubitRewiring => false)

struct GateModelQpuParadigmProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    connectivity::DeviceConnectivity
    qubitCount::Int
    nativeGateSet::Vector{String}
end
StructTypes.StructType(::Type{GateModelQpuParadigmProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelQpuParadigmProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.gate_model_qpu_paradigm_properties", "1"))

struct OpenQasmProgram <: AbstractProgram
    braketSchemaHeader::braketSchemaHeader
    source::String
    inputs::Union{Nothing, Dict{String, Union{String, Float64, Int, Vector{Union{String, Float64, Int}}}}}
end
StructTypes.StructType(::Type{OpenQasmProgram}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OpenQasmProgram}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.ir.openqasm.program", "1"))

struct StandardizedGateModelQpuDeviceProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    oneQubitProperties::Dict{String, OneQubitProperties}
    twoQubitProperties::Dict{String, TwoQubitProperties}
end
StructTypes.StructType(::Type{StandardizedGateModelQpuDeviceProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{StandardizedGateModelQpuDeviceProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.standardized_gate_model_qpu_device_properties", "1"))

struct DwaveProviderLevelParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    annealingOffsets::Union{Nothing, Vector{Float64}}
    annealingSchedule::Union{Nothing, Vector{Vector{Float64}}}
    annealingDuration::Union{Nothing, Int}
    autoScale::Union{Nothing, Bool}
    beta::Union{Nothing, Float64}
    chains::Union{Nothing, Vector{Vector{Int}}}
    compensateFluxDrift::Union{Nothing, Bool}
    fluxBiases::Union{Nothing, Vector{Float64}}
    initialState::Union{Nothing, Vector{Int}}
    maxResults::Union{Nothing, Int}
    postprocessingType::Union{Nothing, Union{PostProcessingType, String, Nothing}}
    programmingThermalizationDuration::Union{Nothing, Int}
    readoutThermalizationDuration::Union{Nothing, Int}
    reduceIntersampleCorrelation::Union{Nothing, Bool}
    reinitializeState::Union{Nothing, Bool}
    resultFormat::Union{Nothing, ResultFormat}
    spinReversalTransformCount::Union{Nothing, Int}
end
StructTypes.StructType(::Type{DwaveProviderLevelParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveProviderLevelParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_provider_level_parameters", "1"))

struct Dwave2000QDeviceLevelParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    annealingOffsets::Union{Nothing, Vector{Float64}}
    annealingSchedule::Union{Nothing, Vector{Vector{Float64}}}
    annealingDuration::Union{Nothing, Float64}
    autoScale::Union{Nothing, Bool}
    beta::Union{Nothing, Float64}
    chains::Union{Nothing, Vector{Vector{Int}}}
    compensateFluxDrift::Union{Nothing, Bool}
    fluxBiases::Union{Nothing, Vector{Float64}}
    initialState::Union{Nothing, Vector{Int}}
    maxResults::Union{Nothing, Int}
    postprocessingType::Union{Nothing, Union{PostProcessingType, String, Nothing}}
    programmingThermalizationDuration::Union{Nothing, Int}
    readoutThermalizationDuration::Union{Nothing, Int}
    reduceIntersampleCorrelation::Union{Nothing, Bool}
    reinitializeState::Union{Nothing, Bool}
    resultFormat::Union{Nothing, ResultFormat}
    spinReversalTransformCount::Union{Nothing, Int}
end
StructTypes.StructType(::Type{Dwave2000QDeviceLevelParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Dwave2000QDeviceLevelParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_2000Q_device_level_parameters", "1"))

struct Dwave2000QDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    deviceLevelParameters::Dwave2000QDeviceLevelParameters
end
StructTypes.StructType(::Type{Dwave2000QDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Dwave2000QDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_2000Q_device_parameters", "1"))

struct DwaveAdvantageDeviceLevelParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    annealingOffsets::Union{Nothing, Vector{Float64}}
    annealingSchedule::Union{Nothing, Vector{Vector{Float64}}}
    annealingDuration::Union{Nothing, Float64}
    autoScale::Union{Nothing, Bool}
    compensateFluxDrift::Union{Nothing, Bool}
    fluxBiases::Union{Nothing, Vector{Float64}}
    initialState::Union{Nothing, Vector{Int}}
    maxResults::Union{Nothing, Int}
    programmingThermalizationDuration::Union{Nothing, Int}
    readoutThermalizationDuration::Union{Nothing, Int}
    reduceIntersampleCorrelation::Union{Nothing, Bool}
    reinitializeState::Union{Nothing, Bool}
    resultFormat::Union{Nothing, ResultFormat}
    spinReversalTransformCount::Union{Nothing, Int}
end
StructTypes.StructType(::Type{DwaveAdvantageDeviceLevelParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveAdvantageDeviceLevelParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_advantage_device_level_parameters", "1"))

struct DwaveAdvantageDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    deviceLevelParameters::DwaveAdvantageDeviceLevelParameters
end
StructTypes.StructType(::Type{DwaveAdvantageDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveAdvantageDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_advantage_device_parameters", "1"))

struct DwaveProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    annealingOffsetStep::Float64
    annealingOffsetStepPhi0::Float64
    annealingOffsetRanges::Vector{Vector{Float64}}
    annealingDurationRange::Vector{Float64}
    couplers::Vector{Vector{Int}}
    defaultAnnealingDuration::Int
    defaultProgrammingThermalizationDuration::Int
    defaultReadoutThermalizationDuration::Int
    extendedJRange::Vector{Float64}
    hGainScheduleRange::Vector{Float64}
    hRange::Vector{Float64}
    jRange::Vector{Float64}
    maximumAnnealingSchedulePoints::Int
    maximumHGainSchedulePoints::Int
    perQubitCouplingRange::Vector{Float64}
    programmingThermalizationDurationRange::Vector{Int}
    qubits::Vector{Int}
    qubitCount::Int
    quotaConversionRate::Float64
    readoutThermalizationDurationRange::Vector{Int}
    taskRunDurationRange::Vector{Int}
    topology::Dict
end
StructTypes.StructType(::Type{DwaveProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_provider_properties", "1"))

struct DwaveDeviceCapabilities <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, DeviceActionProperties}
    deviceParameters::Dict
    provider::DwaveProviderProperties
end
StructTypes.StructType(::Type{DwaveDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_device_capabilities", "1"))

struct DwaveDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    providerLevelParameters::Union{Nothing, DwaveProviderLevelParameters}
    deviceLevelParameters::Union{Nothing, Union{DwaveAdvantageDeviceLevelParameters, Dwave2000QDeviceLevelParameters, Nothing}}
end
StructTypes.StructType(::Type{DwaveDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{DwaveDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.dwave.dwave_device_parameters", "1"))

struct IonqProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    fidelity::Dict{String, Dict{String, Float64}}
    timing::Dict{String, Float64}
    errorMitigation::Union{Nothing, Dict{ErrorMitigationScheme, ErrorMitigationProperties}}
end
StructTypes.StructType(::Type{IonqProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IonqProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.ionq.ionq_provider_properties", "1"))

struct IonqDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, Union{OpenQASMDeviceActionProperties, JaqcdDeviceActionProperties}}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::GateModelQpuParadigmProperties
    provider::Union{Nothing, IonqProviderProperties}
end
StructTypes.StructType(::Type{IonqDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IonqDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.ionq.ionq_device_capabilities", "1"))

struct IonqDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    paradigmParameters::GateModelParameters
    errorMitigation::Union{Nothing, Vector{ErrorMitigationScheme}}
end
StructTypes.StructType(::Type{IonqDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IonqDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.ionq.ionq_device_parameters", "1"))

struct OqcProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    properties::Dict{String, Dict{String, QubitType}}
end
StructTypes.StructType(::Type{OqcProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OqcProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.oqc.oqc_provider_properties", "1"))

struct PulseDeviceActionProperties <: DeviceActionProperties
    braketSchemaHeader::braketSchemaHeader
    supportedQhpTemplateWaveforms::Dict{String, PulseFunction}
    ports::Dict{String, Port}
    supportedFunctions::Dict{String, PulseFunction}
    frames::Union{Nothing, Dict{String, Frame}}
    supportsLocalPulseElements::Bool
    supportsDynamicFrames::Bool
    supportsNonNativeGatesWithPulses::Bool
    validationParameters::Union{Nothing, Dict{String, Float64}}
    nativeGateCalibrationsRef::Union{Nothing, String}
end
StructTypes.StructType(::Type{PulseDeviceActionProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PulseDeviceActionProperties}) = Dict{Symbol, Any}(:supportsNonNativeGatesWithPulses => false, :braketSchemaHeader => braketSchemaHeader("braket.device_schema.pulse.pulse_device_action_properties", "1"), :supportsDynamicFrames => true, :supportsLocalPulseElements => true)

struct OqcDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, Union{OpenQASMDeviceActionProperties, JaqcdDeviceActionProperties}}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::GateModelQpuParadigmProperties
    provider::Union{Nothing, OqcProviderProperties}
    standardized::Union{Nothing, StandardizedGateModelQpuDeviceProperties}
    pulse::Union{Nothing, PulseDeviceActionProperties}
end
StructTypes.StructType(::Type{OqcDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OqcDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.oqc.oqc_device_capabilities", "1"))

struct OqcDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    paradigmParameters::GateModelParameters
end
StructTypes.StructType(::Type{OqcDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{OqcDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.oqc.oqc_device_parameters", "1"))

struct IqmProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    properties::Dict{String, Dict{String, QubitType}}
end
StructTypes.StructType(::Type{IqmProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IqmProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.iqm.iqm_provider_properties", "1"))

struct IqmDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, Union{OpenQASMDeviceActionProperties, JaqcdDeviceActionProperties}}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::GateModelQpuParadigmProperties
    provider::Union{Nothing, IqmProviderProperties}
    standardized::Union{Nothing, StandardizedGateModelQpuDeviceProperties}
    pulse::Union{Nothing, PulseDeviceActionProperties}
end
StructTypes.StructType(::Type{IqmDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IqmDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.iqm.iqm_device_capabilities", "1"))

struct IqmDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    paradigmParameters::GateModelParameters
end
StructTypes.StructType(::Type{IqmDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{IqmDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.iqm.iqm_device_parameters", "1"))

struct NativeGateCalibrations <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    gates::Dict{String, Dict{String, Vector{NativeGate}}}
    waveforms::Dict{String, Union{TemplateWaveform, ArbitraryWaveform}}
end
StructTypes.StructType(::Type{NativeGateCalibrations}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{NativeGateCalibrations}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.pulse.native_gate_calibrations", "1"))

struct QueraAhsParadigmProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    qubitCount::Int
    lattice::Lattice
    rydberg::Rydberg
    performance::Performance
end
StructTypes.StructType(::Type{QueraAhsParadigmProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{QueraAhsParadigmProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.quera.quera_ahs_paradigm_properties", "1"))

struct QueraDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, DeviceActionProperties}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::QueraAhsParadigmProperties
end
StructTypes.StructType(::Type{QueraDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{QueraDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.quera.quera_device_capabilities", "1"))

struct RigettiProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    specs::Dict{String, Dict{String, Dict{String, Float64}}}
end
StructTypes.StructType(::Type{RigettiProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{RigettiProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.rigetti.rigetti_provider_properties", "1"))

struct RigettiDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, Union{OpenQASMDeviceActionProperties, JaqcdDeviceActionProperties}}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::GateModelQpuParadigmProperties
    provider::Union{Nothing, RigettiProviderProperties}
    standardized::Union{Nothing, StandardizedGateModelQpuDeviceProperties}
    pulse::Union{Nothing, PulseDeviceActionProperties}
end
StructTypes.StructType(::Type{RigettiDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{RigettiDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.rigetti.rigetti_device_capabilities", "1"))

struct RigettiDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    paradigmParameters::GateModelParameters
end
StructTypes.StructType(::Type{RigettiDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{RigettiDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.rigetti.rigetti_device_parameters", "1"))

struct GateModelSimulatorParadigmProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    qubitCount::Int
end
StructTypes.StructType(::Type{GateModelSimulatorParadigmProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelSimulatorParadigmProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_paradigm_properties", "1"))

struct GateModelSimulatorDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, Union{OpenQASMDeviceActionProperties, JaqcdDeviceActionProperties}}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::GateModelSimulatorParadigmProperties
end
StructTypes.StructType(::Type{GateModelSimulatorDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelSimulatorDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_device_capabilities", "1"))

struct GateModelSimulatorDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    paradigmParameters::GateModelParameters
end
StructTypes.StructType(::Type{GateModelSimulatorDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelSimulatorDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_device_parameters", "1"))

struct XanaduProviderProperties <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    loopPhases::Vector{Float64}
    schmidtNumber::Float64
    commonEfficiency::Float64
    squeezingParametersMean::Dict{String, Float64}
    relativeChannelEfficiencies::Vector{Float64}
    loopEfficiencies::Vector{Float64}
end
StructTypes.StructType(::Type{XanaduProviderProperties}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XanaduProviderProperties}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.xanadu.xanadu_provider_properties", "1"))

struct XanaduDeviceCapabilities <: BraketSchemaBase
    service::DeviceServiceProperties
    action::Dict{Union{DeviceActionType, String}, BlackbirdDeviceActionProperties}
    deviceParameters::Dict
    braketSchemaHeader::braketSchemaHeader
    paradigm::ContinuousVariableQpuParadigmProperties
    provider::Union{Nothing, XanaduProviderProperties}
end
StructTypes.StructType(::Type{XanaduDeviceCapabilities}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XanaduDeviceCapabilities}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.xanadu.xanadu_device_capabilities", "1"))

struct XanaduDeviceParameters <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
end
StructTypes.StructType(::Type{XanaduDeviceParameters}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{XanaduDeviceParameters}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.device_schema.xanadu.xanadu_device_parameters", "1"))

struct Problem <: AbstractProgram
    braketSchemaHeader::braketSchemaHeader
    type::Union{ProblemType, String}
    linear::Dict{Int, Float64}
    quadratic::Dict{String, Float64}
end
StructTypes.StructType(::Type{Problem}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Problem}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.ir.annealing.problem", "1"))

struct BlackbirdProgram <: AbstractProgram
    braketSchemaHeader::braketSchemaHeader
    source::String
end
StructTypes.StructType(::Type{BlackbirdProgram}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{BlackbirdProgram}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.ir.blackbird.program", "1"))

struct PersistedJobData <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    dataDictionary::Dict{String, Any}
    dataFormat::Union{PersistedJobDataFormat, String}
end
StructTypes.StructType(::Type{PersistedJobData}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PersistedJobData}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.jobs_data.persisted_job_data", "1"))

struct TaskMetadata <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    id::String
    shots::Int
    deviceId::String
    deviceParameters::Union{Nothing, Union{DwaveDeviceParameters, DwaveAdvantageDeviceParameters, Dwave2000QDeviceParameters, RigettiDeviceParameters, IonqDeviceParameters, OqcDeviceParameters, IqmDeviceParameters, GateModelSimulatorDeviceParameters, XanaduDeviceParameters, Nothing}}
    createdAt::Union{Nothing, String}
    endedAt::Union{Nothing, String}
    status::Union{Nothing, String}
    failureReason::Union{Nothing, String}
end
StructTypes.StructType(::Type{TaskMetadata}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{TaskMetadata}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.task_metadata", "1"))

struct AnalogHamiltonianSimulationTaskResult <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    taskMetadata::TaskMetadata
    measurements::Union{Nothing, Vector{AnalogHamiltonianSimulationShotMeasurement}}
    additionalMetadata::Union{Nothing, AdditionalMetadata}
end
StructTypes.StructType(::Type{AnalogHamiltonianSimulationTaskResult}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{AnalogHamiltonianSimulationTaskResult}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.analog_hamiltonian_simulation_task_result", "1"))

struct AnnealingTaskResult <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    solutions::Union{Nothing, Vector{Vector{Int}}}
    solutionCounts::Union{Nothing, Vector{Int}}
    values::Union{Nothing, Vector{Float64}}
    variableCount::Union{Nothing, Int}
    taskMetadata::TaskMetadata
    additionalMetadata::AdditionalMetadata
end
StructTypes.StructType(::Type{AnnealingTaskResult}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{AnnealingTaskResult}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.annealing_task_result", "1"))

struct GateModelTaskResult <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    measurements::Union{Nothing, Vector{Vector{Int}}}
    measurementProbabilities::Union{Nothing, Dict{String, Float64}}
    resultTypes::Union{Nothing, Vector{ResultTypeValue}}
    measuredQubits::Union{Nothing, Vector{Int}}
    taskMetadata::TaskMetadata
    additionalMetadata::AdditionalMetadata
end
StructTypes.StructType(::Type{GateModelTaskResult}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{GateModelTaskResult}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.gate_model_task_result", "1"))

struct PhotonicModelTaskResult <: BraketSchemaBase
    braketSchemaHeader::braketSchemaHeader
    measurements::Union{Nothing, Vector{Vector{Vector{Int}}}}
    taskMetadata::TaskMetadata
    additionalMetadata::AdditionalMetadata
end
StructTypes.StructType(::Type{PhotonicModelTaskResult}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{PhotonicModelTaskResult}) = Dict{Symbol, Any}(:braketSchemaHeader => braketSchemaHeader("braket.task_result.photonic_model_task_result", "1"))

struct Debias <: ErrorMitigationScheme
    type::String
end
StructTypes.StructType(::Type{Debias}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{Debias}) = Dict{Symbol, Any}(:type => "braket.device_schema.error_mitigation.debias.Debias")

struct GenericDeviceActionProperties <: DeviceActionProperties
    version::Vector{String}
    actionType::Union{DeviceActionType, String}
end
StructTypes.StructType(::Type{GenericDeviceActionProperties}) = StructTypes.UnorderedStruct()

const type_dict   = Dict{String, DataType}("braket.device_schema.gate_model_qpu_paradigm_properties_v1"=>GateModelQpuParadigmProperties, "braket.device_schema.oqc.oqc_device_capabilities_v1"=>OqcDeviceCapabilities, "braket.device_schema.iqm.iqm_device_capabilities_v1"=>IqmDeviceCapabilities, "braket.device_schema.dwave.dwave_advantage_device_level_parameters_v1"=>DwaveAdvantageDeviceLevelParameters, "braket.device_schema.ionq.ionq_device_capabilities_v1"=>IonqDeviceCapabilities, "braket.device_schema.ionq.ionq_device_parameters_v1"=>IonqDeviceParameters, "braket.device_schema.quera.quera_device_capabilities_v1"=>QueraDeviceCapabilities, "braket.device_schema.standardized_gate_model_qpu_device_properties_v1"=>StandardizedGateModelQpuDeviceProperties, "braket.device_schema.xanadu.xanadu_device_capabilities_v1"=>XanaduDeviceCapabilities, "braket.device_schema.dwave.dwave_device_parameters_v1"=>DwaveDeviceParameters, "braket.task_result.dwave_metadata_v1"=>DwaveMetadata, "braket.device_schema.dwave.dwave_2000Q_device_level_parameters_v1"=>Dwave2000QDeviceLevelParameters, "braket.task_result.quera_metadata_v1"=>QueraMetadata, "braket.device_schema.oqc.oqc_provider_properties_v1"=>OqcProviderProperties, "braket.device_schema.iqm.iqm_provider_properties_v1"=>IqmProviderProperties, "braket.device_schema.device_service_properties_v1"=>DeviceServiceProperties, "braket.device_schema.xanadu.xanadu_device_parameters_v1"=>XanaduDeviceParameters, "braket.ir.blackbird.program_v1"=>BlackbirdProgram, "braket.device_schema.dwave.dwave_provider_properties_v1"=>DwaveProviderProperties, "braket.device_schema.rigetti.rigetti_device_capabilities_v1"=>RigettiDeviceCapabilities, "braket.task_result.annealing_task_result_v1"=>AnnealingTaskResult, "braket.device_schema.dwave.dwave_provider_level_parameters_v1"=>DwaveProviderLevelParameters, "braket.device_schema.pulse.pulse_device_action_properties_v1"=>PulseDeviceActionProperties, "braket.device_schema.ionq.ionq_provider_properties_v1"=>IonqProviderProperties, "braket.task_result.photonic_model_task_result_v1"=>PhotonicModelTaskResult, "braket.device_schema.continuous_variable_qpu_paradigm_properties_v1"=>ContinuousVariableQpuParadigmProperties, "braket.device_schema.xanadu.xanadu_provider_properties_v1"=>XanaduProviderProperties, "braket.device_schema.pulse.native_gate_calibrations_v1"=>NativeGateCalibrations, "braket.device_schema.dwave.dwave_advantage_device_parameters_v1"=>DwaveAdvantageDeviceParameters, "braket.device_schema.rigetti.rigetti_device_parameters_v1"=>RigettiDeviceParameters, "braket.ir.ahs.program_v1"=>AHSProgram, "braket.ir.jaqcd.program_v1"=>Program, "braket.task_result.task_metadata_v1"=>TaskMetadata, "braket.task_result.analog_hamiltonian_simulation_task_result_v1"=>AnalogHamiltonianSimulationTaskResult, "braket.device_schema.simulators.gate_model_simulator_paradigm_properties_v1"=>GateModelSimulatorParadigmProperties, "braket.task_result.gate_model_task_result_v1"=>GateModelTaskResult, "braket.task_result.ionq_metadata_v1"=>IonQMetadata, "braket.device_schema.rigetti.rigetti_provider_properties_v1"=>RigettiProviderProperties, "braket.device_schema.oqc.oqc_device_parameters_v1"=>OqcDeviceParameters, "braket.device_schema.iqm.iqm_device_parameters_v1"=>IqmDeviceParameters, "braket.device_schema.simulators.gate_model_simulator_device_capabilities_v1"=>GateModelSimulatorDeviceCapabilities, "braket.task_result.xanadu_metadata_v1"=>XanaduMetadata, "braket.device_schema.gate_model_parameters_v1"=>GateModelParameters, "braket.device_schema.simulators.gate_model_simulator_device_parameters_v1"=>GateModelSimulatorDeviceParameters, "braket.task_result.oqc_metadata_v1"=>OqcMetadata, "braket.task_result.iqm_metadata_v1"=>IqmMetadata, "braket.device_schema.dwave.dwave_device_capabilities_v1"=>DwaveDeviceCapabilities, "braket.device_schema.quera.quera_ahs_paradigm_properties_v1"=>QueraAhsParadigmProperties, "braket.jobs_data.persisted_job_data_v1"=>PersistedJobData, "braket.task_result.rigetti_metadata_v1"=>RigettiMetadata, "braket.task_result.simulator_metadata_v1"=>SimulatorMetadata, "braket.ir.annealing.problem_v1"=>Problem, "braket.device_schema.dwave.dwave_2000Q_device_parameters_v1"=>Dwave2000QDeviceParameters, "braket.ir.openqasm.program_v1"=>OpenQasmProgram)
const header_dict = Dict{DataType, braketSchemaHeader}(GateModelQpuParadigmProperties=>braketSchemaHeader("braket.device_schema.gate_model_qpu_paradigm_properties", "1"), OqcDeviceCapabilities=>braketSchemaHeader("braket.device_schema.oqc.oqc_device_capabilities", "1"), IqmDeviceCapabilities=>braketSchemaHeader("braket.device_schema.iqm.iqm_device_capabilities", "1"), DwaveAdvantageDeviceLevelParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_advantage_device_level_parameters", "1"), IonqDeviceCapabilities=>braketSchemaHeader("braket.device_schema.ionq.ionq_device_capabilities", "1"), IonqDeviceParameters=>braketSchemaHeader("braket.device_schema.ionq.ionq_device_parameters", "1"), QueraDeviceCapabilities=>braketSchemaHeader("braket.device_schema.quera.quera_device_capabilities", "1"), StandardizedGateModelQpuDeviceProperties=>braketSchemaHeader("braket.device_schema.standardized_gate_model_qpu_device_properties", "1"), XanaduDeviceCapabilities=>braketSchemaHeader("braket.device_schema.xanadu.xanadu_device_capabilities", "1"), DwaveDeviceParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_device_parameters", "1"), DwaveMetadata=>braketSchemaHeader("braket.task_result.dwave_metadata", "1"), Dwave2000QDeviceLevelParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_2000Q_device_level_parameters", "1"), QueraMetadata=>braketSchemaHeader("braket.task_result.quera_metadata", "1"), OqcProviderProperties=>braketSchemaHeader("braket.device_schema.oqc.oqc_provider_properties", "1"), IqmProviderProperties=>braketSchemaHeader("braket.device_schema.iqm.iqm_provider_properties", "1"), DeviceServiceProperties=>braketSchemaHeader("braket.device_schema.device_service_properties", "1"), XanaduDeviceParameters=>braketSchemaHeader("braket.device_schema.xanadu.xanadu_device_parameters", "1"), BlackbirdProgram=>braketSchemaHeader("braket.ir.blackbird.program", "1"), DwaveProviderProperties=>braketSchemaHeader("braket.device_schema.dwave.dwave_provider_properties", "1"), RigettiDeviceCapabilities=>braketSchemaHeader("braket.device_schema.rigetti.rigetti_device_capabilities", "1"), AnnealingTaskResult=>braketSchemaHeader("braket.task_result.annealing_task_result", "1"), DwaveProviderLevelParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_provider_level_parameters", "1"), PulseDeviceActionProperties=>braketSchemaHeader("braket.device_schema.pulse.pulse_device_action_properties", "1"), IonqProviderProperties=>braketSchemaHeader("braket.device_schema.ionq.ionq_provider_properties", "1"), PhotonicModelTaskResult=>braketSchemaHeader("braket.task_result.photonic_model_task_result", "1"), ContinuousVariableQpuParadigmProperties=>braketSchemaHeader("braket.device_schema.continuous_variable_qpu_paradigm_properties", "1"), XanaduProviderProperties=>braketSchemaHeader("braket.device_schema.xanadu.xanadu_provider_properties", "1"), NativeGateCalibrations=>braketSchemaHeader("braket.device_schema.pulse.native_gate_calibrations", "1"), DwaveAdvantageDeviceParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_advantage_device_parameters", "1"), RigettiDeviceParameters=>braketSchemaHeader("braket.device_schema.rigetti.rigetti_device_parameters", "1"), AHSProgram=>braketSchemaHeader("braket.ir.ahs.program", "1"), Program=>braketSchemaHeader("braket.ir.jaqcd.program", "1"), TaskMetadata=>braketSchemaHeader("braket.task_result.task_metadata", "1"), AnalogHamiltonianSimulationTaskResult=>braketSchemaHeader("braket.task_result.analog_hamiltonian_simulation_task_result", "1"), GateModelSimulatorParadigmProperties=>braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_paradigm_properties", "1"), GateModelTaskResult=>braketSchemaHeader("braket.task_result.gate_model_task_result", "1"), IonQMetadata=>braketSchemaHeader("braket.task_result.ionq_metadata", "1"), RigettiProviderProperties=>braketSchemaHeader("braket.device_schema.rigetti.rigetti_provider_properties", "1"), OqcDeviceParameters=>braketSchemaHeader("braket.device_schema.oqc.oqc_device_parameters", "1"), IqmDeviceParameters=>braketSchemaHeader("braket.device_schema.iqm.iqm_device_parameters", "1"), GateModelSimulatorDeviceCapabilities=>braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_device_capabilities", "1"), XanaduMetadata=>braketSchemaHeader("braket.task_result.xanadu_metadata", "1"), GateModelParameters=>braketSchemaHeader("braket.device_schema.gate_model_parameters", "1"), GateModelSimulatorDeviceParameters=>braketSchemaHeader("braket.device_schema.simulators.gate_model_simulator_device_parameters", "1"), OqcMetadata=>braketSchemaHeader("braket.task_result.oqc_metadata", "1"), IqmMetadata=>braketSchemaHeader("braket.task_result.iqm_metadata", "1"), DwaveDeviceCapabilities=>braketSchemaHeader("braket.device_schema.dwave.dwave_device_capabilities", "1"), QueraAhsParadigmProperties=>braketSchemaHeader("braket.device_schema.quera.quera_ahs_paradigm_properties", "1"), PersistedJobData=>braketSchemaHeader("braket.jobs_data.persisted_job_data", "1"), RigettiMetadata=>braketSchemaHeader("braket.task_result.rigetti_metadata", "1"), SimulatorMetadata=>braketSchemaHeader("braket.task_result.simulator_metadata", "1"), Problem=>braketSchemaHeader("braket.ir.annealing.problem", "1"), Dwave2000QDeviceParameters=>braketSchemaHeader("braket.device_schema.dwave.dwave_2000Q_device_parameters", "1"), OpenQasmProgram=>braketSchemaHeader("braket.ir.openqasm.program", "1"))


lookup_type(header::braketSchemaHeader) = type_dict[header.name * "_v" * header.version]

function parse_raw_schema(x::String)
    obj = copy(JSON3.read(x))
    !haskey(obj, :braketSchemaHeader) && throw(ArgumentError("invalid schema!"))
    bSH = StructTypes.constructfrom(braketSchemaHeader, obj[:braketSchemaHeader])
    typ = lookup_type(bSH)
    return StructTypes.constructfrom(typ, obj)
end

function StructTypes.constructfrom(::Type{DeviceActionProperties}, obj)
    sub_ts = StructTypes.subtypes(DeviceActionProperties)
    T = haskey(obj, :actionType) ? sub_ts[Symbol(obj[:actionType])] : GenericDeviceActionProperties
    return StructTypes.constructfrom(T, obj)
end
function StructTypes.constructfrom(::Type{AbstractProgram}, obj)
    header = obj[:braketSchemaHeader]
    occursin("braket.ir.jaqcd", header[:name]) && return StructTypes.constructfrom(Program, obj)
    occursin("braket.ir.blackbird", header[:name]) && return StructTypes.constructfrom(BlackbirdProgram, obj)
    occursin("braket.ir.ahs", header[:name]) && return StructTypes.constructfrom(AHSProgram, obj)
    occursin("braket.ir.openqasm", header[:name]) && return StructTypes.constructfrom(OpenQasmProgram, obj)
    occursin("braket.ir.annealing", header[:name]) && return StructTypes.constructfrom(Problem, obj)

    throw(ErrorException("invalid program specification!"))
end
Base.:(==)(o1::T, o2::T) where {T<:BraketSchemaBase} = all(Base.getproperty(o1, fn) == Base.getproperty(o2, fn) for fn in fieldnames(T))
for T in (TaskMetadata, AdditionalMetadata)
    Base.:(==)(o1::T, o2::T) = all(Base.getproperty(o1, fn) == Base.getproperty(o2, fn) for fn in fieldnames(T))
end

function StructTypes.constructfrom(::Type{ErrorMitigationScheme}, x::Symbol)
    occursin("debias", string(x)) && return Debias("braket.device_schema.error_mitigation.debias.Debias")
end

using Braket, Test, JSON3

@testset "QubitSet and Qubit" begin
    @testset "ctors" begin
        @test Qubit(1) == Qubit(1.0)
        @test Qubit(BigFloat(1.0)) == Qubit(1.0)
        @test Qubit(Qubit(1)) == Qubit(1.0)
    end
    @testset "equality" begin
        @test Qubit(1) == Int8(1)
        @test BigInt(10) == Qubit(10)
        @test Qubit(10) == BigInt(10)
    end
    @testset "Convert to Int" begin
        @test Int(Qubit(1)) == 1
    end
    @testset "show" begin
        s = sprint(show, Qubit(1))
        @test s == "Qubit(1)"
    end
    @testset "QubitSet indexing" begin
        qs = QubitSet(0, 1, 2)
        @test length(qs) == 3
        @test lastindex(qs) == 3
        @test 3 ∉ qs
        @test !isempty(qs)
        o = popfirst!(qs)
        @test o == 0
        @test length(qs) == 2
    end
end

function Py(x::Braket.IR.AHSProgram)
    fns = filter(n->!(n==:braketSchemaHeader), fieldnames(IR.AHSProgram))
    args = arg_gen(x, fns)
    return pyahs.Program(; args...)
end

for (IRT, PYT) in (
                   (:(Braket.IR.TimeSeries), :(pyahs.TimeSeries)),
                   (:(Braket.IR.AtomArrangement), :(pyahs.AtomArrangement)),
                   (:(Braket.IR.ShiftingField), :(pyahs.ShiftingField)),
                   (:(Braket.IR.DrivingField), :(pyahs.DrivingField)),
                   (:(Braket.IR.PhysicalField), :(pyahs.PhysicalField)),
                   (:(Braket.IR.Hamiltonian), :(pyahs.Hamiltonian)),
                   (:(Braket.IR.Setup), :(pyahs.Setup))
                  )
    @eval begin
        function Py(x::$IRT)
            fns = fieldnames($IRT)
            args = arg_gen(x, fns)
            return $PYT(; args...)
        end
    end
end

using Pkg, Test, Aqua, Braket

in_ci = tryparse(Bool, get(ENV, "BRAKET_CI", "false"))
Aqua.test_all(Braket, ambiguities=false, piracies=false, stale_deps=!in_ci, deps_compat=!in_ci, persistent_tasks=!in_ci)
Aqua.test_ambiguities(Braket)
Aqua.test_piracies(Braket, treat_as_own=[Braket.DecFP.Dec128])

const GROUP = get(ENV, "GROUP", "Braket-unit")

function set_aws_creds(test_type)
    if test_type == "unit"
        creds = Braket.AWS.AWSCredentials("", "")
        config = Braket.AWS.AWSConfig(creds, "", "")
        Braket.AWS.global_aws_config(config)
    elseif test_type == "integ"
        # should pickup correct creds from envvars 
        Braket.AWS.global_aws_config()
    else
        throw(ArgumentError("invalid test_type $test_type, must be one of 'integ' or 'unit'"))
    end
end

groups = GROUP == "All" ? ["Braket-integ", "Braket-unit", "PyBraket-unit", "Examples-unit", "Examples-integ"] : GROUP
groups = (groups isa String ? [groups] : groups)
        
subpackage_path(subpackage::String) = joinpath(dirname(@__DIR__), subpackage)
develop_subpackage(subpackage::String) = (Pkg.activate(subpackage_path(subpackage)); Pkg.develop(Pkg.PackageSpec(; path=dirname(@__DIR__))))

for group in groups
    @info "Testing $group"
    pkg_name  = String(split(group, "-")[1])
    test_type = String(split(group, "-")[2])

    set_aws_creds(test_type)

    if pkg_name == "Braket"
        if test_type == "unit"
            include("ahs.jl")
            include("utils.jl")
            include("qubit_set.jl")
            include("dwave_device.jl")
            include("ionq_device.jl")
            include("rigetti_device.jl")
            include("simulator_device.jl")
            include("oqc_device.jl")
            include("iqm_device.jl")
            include("quera_device.jl")
            include("xanadu_device.jl")
            include("translation.jl")
            include("schemas_misc.jl")
            include("device.jl")
            include("circuits.jl")
            include("measure.jl")
            include("free_parameter.jl")
            include("gates.jl")
            include("observables.jl")
            include("noises.jl")
            include("noise_model.jl")
            include("compiler_directives.jl")
            include("gate_model_task_result.jl")
            include("photonic_task_result.jl")
            include("annealing_task_result.jl")
            include("tracker.jl")
            include("task.jl")
            include("task_batch.jl")
            include("local_jobs.jl")
            include("job_macro.jl")
            include("jobs.jl")
        elseif test_type == "integ"
            include(joinpath(@__DIR__, "integ_tests", "runtests.jl"))
        end
    elseif pkg_name == "Examples"
        Pkg.activate(joinpath(@__DIR__, "..", "examples"))
        Pkg.develop([PackageSpec(; path=joinpath(@__DIR__, "..")), PackageSpec(; path=joinpath(@__DIR__, "..", "PyBraket"))])
        Pkg.instantiate()
        if test_type == "unit"
            # test example notebooks that don't need AWS devices
            @testset "Local Examples" begin
                include(joinpath(@__DIR__, "..", "examples", "ahs_rabi.jl"))
                include(joinpath(@__DIR__, "..", "examples", "graph_coloring.jl"))
                include(joinpath(@__DIR__, "..", "examples", "qft.jl"))
            end
        elseif test_type == "integ"
            @testset "Examples-integ" begin
                # test example notebooks that do need AWS devices
                include(joinpath(@__DIR__, "..", "examples", "adjoint_gradient.jl"))
                include(joinpath(@__DIR__, "..", "examples", "ahs_nb.jl"))
                include(joinpath(@__DIR__, "..", "examples", "vqe_chemistry.jl"))
                include(joinpath(@__DIR__, "..", "examples", "tetris_vqe.jl"))
            end
        end
    else
        develop_subpackage(pkg_name)
        subpkg_path = subpackage_path(pkg_name)
        # this should inherit the GROUP envvar
        run_coverage = get(ENV, "COVERAGE", "false")
        Pkg.test(PackageSpec(; name=pkg_name, path=subpkg_path); coverage=(run_coverage=="true"))
    end
end

using AWS, Braket, Test

SHOTS = 8000

IONQ_ARN = "arn:aws:braket:us-east-1::device/qpu/ionq/Harmony"
SIMULATOR_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
OQC_ARN = "arn:aws:braket:eu-west-2::device/qpu/oqc/Lucy"
IQM_ARN = "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet"

@testset "Measure operator" begin
    @testset "Unsupported devices" begin
        @testset "Arn $arn" for arn in (IONQ_ARN, SIMULATOR_ARN)
            device = AwsDevice(arn)
            status(device) == "OFFLINE" && continue
            circ = Circuit([(H, 0), (CNot, 0, 1), (H, 2), (Measure, 0, 1)])
            # TODO check error message
            @test_throws AWS.AWSExceptions.AWSException device(circ, shots=1000)
        end
    end
    @testset "Supported devices" begin
        @testset "Arn $arn" for arn in (OQC_ARN, IQM_ARN)
            device = AwsDevice(arn)
            status(device) == "OFFLINE" && continue
            circ = Circuit([(H, 0), (CNot, 0, 1), (Measure, 0)])
            res  = result(device(circ, shots=SHOTS))
            @test all(m->length(m) == 1, res.measurements)
            @test res.measured_qubits == [0]
        end
    end
end

import StructTypes

struct CheckpointConfig
    localPath::Union{Nothing, String}
    s3Uri::Union{String, Nothing}
end
StructTypes.StructType(::Type{CheckpointConfig}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{CheckpointConfig})   = Dict{Symbol, Any}(:s3Uri => nothing, :localPath => "/opt/jobs/checkpoints")
function CheckpointConfig(job_name::String="")
    local_path = StructTypes.defaults(CheckpointConfig)[:localPath]
    isempty(job_name) && return CheckpointConfig(local_path, nothing)
    s3Uri = construct_s3_uri(default_bucket(), "jobs", job_name, "checkpoints")
    return CheckpointConfig(local_path, s3Uri)
end

struct DeviceConfig
    device::String
end
StructTypes.StructType(::Type{DeviceConfig}) = StructTypes.UnorderedStruct()

struct InstanceConfig
    instanceType::Union{Nothing, String}
    volumeSizeInGb::Union{Nothing, Int}
    instanceCount::Union{Nothing, Int}
end
StructTypes.StructType(::Type{InstanceConfig}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{InstanceConfig})   = Dict{Symbol, Any}(:instanceType => "ml.m5.large", :instanceCount => 1, :volumeSizeInGb => 30)
InstanceConfig() = InstanceConfig((StructTypes.defaults(InstanceConfig)[fn] for fn in fieldnames(InstanceConfig))...)


struct OutputDataConfig
    s3Path::Union{String, Nothing}
end
StructTypes.StructType(::Type{OutputDataConfig}) = StructTypes.UnorderedStruct()
function OutputDataConfig(; job_name::String="")
    isempty(job_name) && return OutputDataConfig(nothing)
    return OutputDataConfig(construct_s3_uri(default_bucket(), "jobs", job_name, "data"))
end

struct S3DataSourceConfig
    config::Dict
end
StructTypes.StructType(::Type{S3DataSourceConfig}) = StructTypes.UnorderedStruct()


struct StoppingCondition
    maxRuntimeInSeconds::Union{Nothing, Int}
end
StructTypes.StructType(::Type{StoppingCondition}) = StructTypes.UnorderedStruct()
StructTypes.defaults(::Type{StoppingCondition})   = Dict{Symbol, Any}(:maxRuntimeInSeconds => 432000)
StoppingCondition() = StoppingCondition((StructTypes.defaults(StoppingCondition)[fn] for fn in fieldnames(StoppingCondition))...)


function S3DataSourceConfig(s3_data::String, content_type::String="")
    config = Dict{String, Any}("dataSource"=>Dict("s3DataSource"=>Dict("s3Uri"=>s3_data)))
    if !isempty(content_type)
        config["contentType"] = content_type
    end
    return S3DataSourceConfig(config)
end
Base.Dict(x::CheckpointConfig) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(CheckpointConfig))
Base.Dict(x::DeviceConfig) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(DeviceConfig))
Base.Dict(x::InstanceConfig) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(InstanceConfig))
Base.Dict(x::OutputDataConfig) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(OutputDataConfig))
Base.Dict(x::S3DataSourceConfig) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(S3DataSourceConfig))
Base.Dict(x::StoppingCondition) = Dict{String, Any}(string(fn)=>getproperty(x, fn) for fn in fieldnames(StoppingCondition))

using Braket, Test

@testset "Rigetti device" begin
    @testset "Device capabilities" begin
        props = """{
                    "braketSchemaHeader": {
                        "name": "braket.device_schema.standardized_gate_model_qpu_device_properties",
                        "version": "1"
                    },
                    "oneQubitProperties": {
                        "0": {
                            "T1": {"value": 28.9, "standardError": 0.01, "unit": "us"},
                            "T2": {"value": 44.5, "standardError": 0.02, "unit": "us"},
                            "oneQubitFidelity": [
                                {
                                    "fidelityType": {"name": "readout"},
                                    "fidelity": 0.9993,
                                    "standardError": null
                                },
                                {
                                    "fidelityType": {"name": "randomized_benchmarking"},
                                    "fidelity": 0.903,
                                    "standardError": null
                                }
                            ]
                        }
                    },
                    "twoQubitProperties": {
                        "0-1": {
                            "twoQubitGateFidelity": [
                                {
                                    "direction": {"control": 0, "target": 1},
                                    "gateName": "cnot",
                                    "fidelity": 0.877,
                                    "fidelityType": {"name": "interleaved_randomized_benchmarking"}
                                }
                            ]
                        }
                    }
                }
                """
        jaqcd() = """{
                    "braketSchemaHeader": {
                        "name": "braket.device_schema.rigetti.rigetti_device_capabilities",
                        "version": "1"
                    },
                    "service": {
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.device_service_properties",
                            "version": "1"
                        },
                        "executionWindows": [
                            {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                        ],
                        "shotsRange": [1, 10],
                        "deviceCost": {"price": 0.25, "unit": "minute"},
                        "deviceDocumentation": {
                            "imageUrl": "image_url",
                            "summary": "Summary on the device",
                            "externalDocumentationUrl": "exter doc link"
                        },
                        "deviceLocation": "us-east-1",
                        "updatedAt": "2020-06-16T19:28:02.869136"
                    },
                    "action": {
                        "braket.ir.jaqcd.program": {
                            "actionType": "braket.ir.jaqcd.program",
                            "version": ["1"],
                            "supportedOperations": ["x", "y"],
                            "supportedResultTypes": [
                                {
                                    "name": "resultType1",
                                    "observables": ["observable1"],
                                    "minShots": 2,
                                    "maxShots": 4
                                }
                            ]
                        }
                    },
                    "paradigm": {
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                            "version": "1"
                        },
                        "qubitCount": 32,
                        "nativeGateSet": ["ccnot", "cy"],
                        "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
                    },
                    "deviceParameters": {},
                    "standardized": $props 
                }"""
        openqasm() = """{
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.rigetti.rigetti_device_capabilities",
                            "version": "1"
                        },
                        "service": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.device_service_properties",
                                "version": "1"
                            },
                            "executionWindows": [
                                {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                            ],
                            "shotsRange": [1, 10],
                            "deviceCost": {"price": 0.25, "unit": "minute"},
                            "deviceDocumentation": {
                                "imageUrl": "image_url",
                                "summary": "Summary on the device",
                                "externalDocumentationUrl": "exter doc link"
                            },
                            "deviceLocation": "us-east-1",
                            "updatedAt": "2020-06-16T19:28:02.869136"
                        },
                        "action": {
                            "braket.ir.openqasm.program": {
                                "actionType": "braket.ir.openqasm.program",
                                "version": ["1"],
                                "supportedOperations": ["x", "y"],
                                "supportedResultTypes": [
                                    {
                                        "name": "resultType1",
                                        "observables": ["observable1"],
                                        "minShots": 2,
                                        "maxShots": 4
                                    }
                                ],
                                "supportPhysicalQubits": false,
                                "supportedPragmas": ["braket_noise_bit_flip"],
                                "forbiddenPragmas": ["braket_unitary_matrix"],
                                "forbiddenArrayOperations": ["concatenation", "range", "slicing"],
                                "requireAllQubitsMeasurement": false,
                                "requireContiguousQubitIndices": false,
                                "supportsPartialVerbatimBox": true,
                                "supportsUnassignedMeasurements": true
                            }
                        },
                        "paradigm": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.gate_model_qpu_paradigm_properties",
                                "version": "1"
                            },
                            "qubitCount": 32,
                            "nativeGateSet": ["ccnot", "cy"],
                            "connectivity": {"fullyConnected": false, "connectivityGraph": {"1": ["2", "3"]}}
                        },
                        "deviceParameters": {}
                    }
                    """
        @testset for format in [jaqcd, openqasm]
            @test Braket.parse_raw_schema(format()) isa Braket.RigettiDeviceCapabilities
        end
    end
    @testset "Device parameters" begin
        ir_gen() = """{
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.rigetti.rigetti_device_parameters",
                            "version": "1"
                        },
                        "paradigmParameters": {
                            "braketSchemaHeader": {
                                "name": "braket.device_schema.gate_model_parameters",
                                "version": "1"
                            },
                            "qubitCount": 1
                        }
                    }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.RigettiDeviceParameters
    end
    @testset "Provider properties" begin
        ir_gen() = """{
                        "braketSchemaHeader": {
                            "name": "braket.device_schema.rigetti.rigetti_provider_properties",
                            "version": "1"
                        },
                        "specs": {
                            "1Q": {
                                "0": {
                                    "T1": 1.69308193540552e-05,
                                    "T2": 1.8719137150144e-05,
                                    "f1QRB": 0.995048041389577,
                                    "f1QRB_std_err": 0.000244061520274907,
                                    "f1Q_simultaneous_RB": 0.989821537688075,
                                    "f1Q_simultaneous_RB_std_err": 0.000699235456806402,
                                    "fActiveReset": 0.978,
                                    "fRO": 0.919
                                }
                            },
                            "2Q": {
                                "0-1": {
                                    "Avg_T1": 2.679913663417025e-05,
                                    "Avg_T2": 2.957247297939755e-05,
                                    "Avg_f1QRB": 0.9973200289413551,
                                    "Avg_f1QRB_std_err": 0.000219048562898114,
                                    "Avg_f1Q_simultaneous_RB": 0.9933270881335465,
                                    "Avg_f1Q_simultaneous_RB_std_err": 0.000400066119480196,
                                    "Avg_fActiveReset": 0.8425,
                                    "Avg_fRO": 0.9165000000000001,
                                    "fCZ": 0.843255182448229,
                                    "fCZ_std_err": 0.00806009046760912
                                }
                            }
                        }
                    }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.RigettiProviderProperties
    end
end

using Braket, JSON3, Test, StructTypes
using Braket: operator, target

@testset "IR Translation" begin
    @testset "Schema header translation" begin
        json_str = """{"name": "braket.ir.jaqcd.program", "version": "1"}"""
        @test JSON3.read(json_str, Braket.braketSchemaHeader) == Braket.braketSchemaHeader("braket.ir.jaqcd.program", "1")
        fi = open(joinpath(@__DIR__, "header.json"), "r")
        @test JSON3.read(fi, Braket.braketSchemaHeader) == Braket.braketSchemaHeader("braket.ir.jaqcd.program", "1")
    end

    @testset "Instruction translation" begin
        inst = Braket.Instruction(H(), 1)
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == H()
        inst = Braket.Instruction(H(), Qubit(1))
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == H()
        @test inst.target == QubitSet(Qubit(1))
        inst = Braket.Instruction(CNot(), [1, 2])
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == CNot()
        inst = Braket.Instruction(CNot(), Qubit.([1, 2]))
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == CNot()
        @test inst.target == QubitSet([Qubit(1), Qubit(2)])
        inst = Braket.Instruction(Rx(1.2), 1)
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == Rx(1.2)
        inst = Braket.Instruction(XX(1.2), [1, 2])
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == XX(1.2)
        inst = Braket.Instruction(CCNot(), [1, 2, 3])
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == CCNot()
        inst = Braket.Instruction(CCNot(), [3, 1, 4])
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == CCNot()
        inst = Braket.Instruction(CSwap(), [1, 2, 3])
        json_str = JSON3.write(inst)
        @test JSON3.read(json_str, Braket.Instruction) == inst
        @test operator(inst) == CSwap()
        json_str = """[{"target": 0, "type": "x"}, {"target": 0, "type": "z"}]"""
        @test JSON3.read(json_str, Vector{Braket.Instruction}) == [Braket.Instruction(X(), 0), Braket.Instruction(Z(), 0)]
    end

    @testset "Results translation" begin
        json_str = """[{"observable":["i"],"targets":[0],"type":"expectation"},{"observable":["z"],"targets":[0],"type":"expectation"}]"""
        parsed = JSON3.read(json_str, Vector{Braket.AbstractProgramResult})
        raw = Braket.AbstractProgramResult[Braket.IR.Expectation(convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, ["i"]), [0], "expectation"), Braket.IR.Expectation(convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, ["z"]), [0], "expectation")]
        for (e_r, e_p) in zip(raw, parsed)
            @test e_r == e_p
        end
        written_json = JSON3.write(raw)
        @test written_json == json_str
        json_str = "{\"observable\":[\"y\",\"z\",\"z\",\"z\",\"z\",\"z\",\"z\",\"z\",\"y\"],\"targets\":[0,1,2,3,4,5,6,7,8],\"type\":\"expectation\"}"
        parsed = JSON3.read(json_str, Braket.AbstractProgramResult)
        written_json = JSON3.write(parsed)
        @test written_json == json_str
    end

    @testset "Program translation" begin
        json_str = """{"braketSchemaHeader": {"name": "braket.ir.jaqcd.program", "version": "1"}, "instructions": [{"target": 0, "type": "x"}, {"target": 0, "type": "z"}], "results": [{"observable":["i"],"targets":[0],"type":"expectation"},{"observable":["z"],"targets":[0],"type":"expectation"}], "basis_rotation_instructions": []}"""
        parsed = Braket.parse_raw_schema(json_str)
        raw    = Braket.Program(Braket.braketSchemaHeader("braket.ir.jaqcd.program", "1"), [Braket.Instruction(X(), 0), Braket.Instruction(Z(), 0)], Braket.AbstractProgramResult[Braket.IR.Expectation(convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, ["i"]), [0], "expectation"), Braket.IR.Expectation(convert(Vector{Union{String, Vector{Vector{Vector{Float64}}}}}, ["z"]), [0], "expectation")], Braket.Instruction[])
        @test parsed.braketSchemaHeader == raw.braketSchemaHeader
        @test parsed.instructions       == raw.instructions
        @test parsed.results            == raw.results
        @test parsed.basis_rotation_instructions       == raw.basis_rotation_instructions
        @test Braket.parse_raw_schema(JSON3.write(raw)) == raw
        @test Braket.Program(Circuit(raw)) == raw
        @test ir(raw) == ir(Circuit(raw), Val(:JAQCD))

        noisy_json_str = """{"braketSchemaHeader": {"name": "braket.ir.jaqcd.program", "version": "1"}, "instructions": [{"target": 0, "type": "x"}, {"gamma": 0.1, "target": 0, "type": "amplitude_damping"}, {"target": 1, "type": "y"}, {"control": 0, "target": 2, "type": "cnot"}, {"gamma": 0.1, "target": 0, "type": "amplitude_damping"}, {"gamma": 0.1, "target": 2, "type": "amplitude_damping"}, {"target": 1, "type": "x"}, {"target": 2, "type": "z"}, {"gamma": 0.1, "target": 2, "type": "amplitude_damping"}], "results": [{"targets": null, "type": "probability"}, {"observable": ["z"], "targets": [0], "type": "expectation"}, {"targets": [0, 1], "type": "densitymatrix"}], "basis_rotation_instructions": []}"""

        parsed = Braket.parse_raw_schema(noisy_json_str)
        raw    = Braket.Program(Braket.braketSchemaHeader("braket.ir.jaqcd.program", "1"), [Braket.Instruction(X(), 0), Braket.Instruction(AmplitudeDamping(0.1), 0), Braket.Instruction(Y(), 1), Braket.Instruction(CNot(), [0, 2]), Braket.Instruction(AmplitudeDamping(0.1), 0), Braket.Instruction(AmplitudeDamping(0.1), 2), Braket.Instruction(X(), 1),  Braket.Instruction(Z(), 2), Braket.Instruction(AmplitudeDamping(0.1), 2)], Braket.AbstractProgramResult[Braket.IR.Probability(nothing, "probability"), Braket.IR.Expectation(["z"], [0], "expectation"), Braket.IR.DensityMatrix([0,1], "densitymatrix")], Braket.Instruction[])
        @test parsed.braketSchemaHeader == raw.braketSchemaHeader
        @test parsed.instructions       == raw.instructions
        @test parsed.results            == raw.results
        @test parsed.basis_rotation_instructions       == raw.basis_rotation_instructions
        @test Braket.parse_raw_schema(JSON3.write(raw)) == raw
        p = Braket.Program(Circuit(raw))
        @test qubit_count(p) == qubit_count(Circuit(raw))
        for (pix, rix) in zip(p.instructions, raw.instructions)
            @test pix == rix
        end
        for (prt, rrt) in zip(p.results, raw.results)
            @test prt == rrt
        end
        @test JSON3.read(JSON3.write(raw), Dict) == JSON3.read(JSON3.write(ir(Circuit(raw), Val(:JAQCD))), Dict)
    end

    @testset "enum translation" begin
        for e in [Braket.SafeUUID, Braket.PaymentCardBrand,
                Braket.Protocol, Braket.Extra, Braket.DeviceActionType,
                Braket.ExecutionDay, Braket.QubitDirection,
                Braket.PostProcessingType, Braket.ResultFormat,
                Braket.ProblemType, Braket.PersistedJobDataFormat]
            for inst in instances(e)
                @test string(inst) == inst
                @test inst == string(inst)
            end
        end
    end

    problem() = Braket.Problem(Braket.header_dict[Braket.Problem], Braket.ising, Dict(1=>3.14), Dict("(1, 2)"=>10.08))
    bell_qasm = """
    OPENQASM 3;

    qubit[2] q;
    bit[2] c;

    h q[0];
    cnot q[0], q[1];

    c = measure q;
    """
    oq3_program() = Braket.OpenQasmProgram(Braket.header_dict[Braket.OpenQasmProgram], bell_qasm, nothing)
    bb_program()  = Braket.BlackbirdProgram(Braket.header_dict[Braket.BlackbirdProgram], "Vac | q[0]")
    bell_circ()   = (c = Circuit([(H, 0), (CNot, 0, 1)]); return Braket.Program(c))
    @testset "AbstractProgram constructfrom" begin
        para_ps = Braket.GateModelSimulatorParadigmProperties(Braket.header_dict[Braket.GateModelSimulatorParadigmProperties], 1)
        input = JSON3.read(JSON3.write(para_ps))
        @testset for prog in (oq3_program, bb_program, problem, bell_circ)
            p = prog()
            raw = JSON3.read(JSON3.write(p))
            @test StructTypes.constructfrom(Braket.AbstractProgram, raw) == p
        end
    end
    @testset "ir fallbacks" begin
        @test ir(X(), 1) == ir(X(), 1, Val(Braket.IRType[]))
    end
end

const REGIONS = ("us-east-1", "us-west-1", "us-west-2", "eu-west-2")
const DEFAULT_SHOTS_QPU = 1000
const DEFAULT_SHOTS_SIMULATOR = 0
const DEFAULT_MAX_PARALLEL = 10

const _GET_DEVICES_ORDER_BY_KEYS = Set(("arn", "name", "type", "provider_name", "status"))

@enum AwsDeviceType SIMULATOR QPU
const AwsDeviceTypeDict = Dict("SIMULATOR"=>SIMULATOR, "QPU"=>QPU)

"""
    BraketDevice

An abstract type representing one of the devices available on Amazon Braket, which will automatically
generate its ARN when passed to the appropriate function.

# Examples
```jldoctest
julia> d = Braket.SV1();

julia> arn(d)
"arn:aws:braket:::device/quantum-simulator/amazon/sv1"
```
"""
abstract type BraketDevice end
for provider in (:AmazonDevice, :_XanaduDevice, :_DWaveDevice, :_OQCDevice, :IQMDevice, :QuEraDevice, :IonQDevice, :RigettiDevice)
    @eval begin
        abstract type $provider <: BraketDevice end
    end
end
arn(d::BraketDevice) = convert(String, d)

for (d, d_arn) in zip((:SV1, :DM1, :TN1), ("sv1", "dm1", "tn1"))
    @eval begin
        struct $d <: AmazonDevice end
        Base.convert(::Type{String}, d::$d) = "arn:aws:braket:::device/quantum-simulator/amazon/" * $d_arn
    end
end

for (d, d_arn) in zip((:_Advantage1, :_Advantage3, :_Advantage4, :_Advantage6, :_DW2000Q6),
                    ("arn:aws:braket:::device/qpu/d-wave/Advantage_system1",
                     "arn:aws:braket:::device/qpu/d-wave/Advantage_system2",
                     "arn:aws:braket:::device/qpu/d-wave/Advantage_system3",
                     "arn:aws:braket:us-west-2::device/qpu/d-wave/Advantage_system6",
                     "arn:aws:braket:::device/qpu/d-wave/DW_2000Q_6",
                    ))
    @eval begin
        struct $d <: _DWaveDevice end
        Base.convert(::Type{String}, d::$d) = $d_arn
    end
end

struct _Borealis <: _XanaduDevice end
Base.convert(::String, d::_Borealis) = "arn:aws:braket:us-east-1::device/qpu/xanadu/Borealis"

for (d, d_arn) in zip((:Harmony, :Aria1, :Aria2),
                      ("arn:aws:braket:us-east-1::device/qpu/ionq/Harmony",
                       "arn:aws:braket:us-east-1::device/qpu/ionq/Aria-1",
                       "arn:aws:braket:us-east-1::device/qpu/ionq/Aria-2",
                      ))
    @eval begin
        struct $d <: IonQDevice end
        Base.convert(::Type{String}, d::$d) = $d_arn
    end
end

struct Aquila <: QuEraDevice end
Base.convert(::Type{String}, d::Aquila) = "arn:aws:braket:us-east-1::device/qpu/quera/Aquila"

struct _Lucy <: _OQCDevice end
Base.convert(::Type{String}, d::_Lucy) = "arn:aws:braket:eu-west-2::device/qpu/oqc/Lucy"

struct Garnet <: IQMDevice end
Base.convert(::Type{String}, d::Garnet) = "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet"

for (d, d_arn) in zip((:_Aspen8, :_Aspen9, :_Aspen10, :_Aspen11, :_AspenM1, :_AspenM2, :AspenM3),
                      ("arn:aws:braket:::device/qpu/rigetti/Aspen-8",
                       "arn:aws:braket:::device/qpu/rigetti/Aspen-9",
                       "arn:aws:braket:::device/qpu/rigetti/Aspen-10",
                       "arn:aws:braket:::device/qpu/rigetti/Aspen-11",
                       "arn:aws:braket:us-west-1::device/qpu/rigetti/Aspen-M-1",
                       "arn:aws:braket:us-west-1::device/qpu/rigetti/Aspen-M-2",
                       "arn:aws:braket:us-west-1::device/qpu/rigetti/Aspen-M-3",
                      ))
    @eval begin
        struct $d <: RigettiDevice end
        Base.convert(::Type{String}, d::$d) = $d_arn
    end
end

"""
    AwsDevice <: Device

Struct representing an AWS managed device, either simulator or QPU.
"""
Base.@kwdef mutable struct AwsDevice <: Device
    _name::Union{Nothing, String}=nothing
    _status::Union{Nothing, String}=nothing
    _type::Union{Nothing, String}=nothing
    _provider_name::Union{Nothing, String}=nothing
    _properties::Any=nothing
    _topology_graph::Union{Nothing, DiGraph}=nothing
    _arn::Union{Nothing, String}=nothing
    _default_shots::Union{Nothing, Int}=nothing
    _config::AWSConfig=global_aws_config()
end
arn(d::AwsDevice) = d._arn
name(d::AwsDevice) = d._name
DataStructures.status(d::AwsDevice) = d._status
provider_name(d::AwsDevice) = d._provider_name
type(d::AwsDevice) = d._type
properties(d::AwsDevice) = d._properties

Base.convert(::Type{String}, d::AwsDevice) = d._arn
Base.show(io::IO, d::AwsDevice) = print(io, "AwsDevice(arn="*d._arn*")")
function (d::AwsDevice)(task_spec::Union{Circuit, AnalogHamiltonianSimulation, AbstractProgram}; s3_destination_folder=default_task_bucket(), shots=nothing, poll_timeout_seconds::Int=DEFAULT_RESULTS_POLL_TIMEOUT, poll_interval_seconds::Int=DEFAULT_RESULTS_POLL_INTERVAL, inputs=Dict{String, Float64}(), kwargs...)
    shots_ = isnothing(shots) ? d._default_shots : shots
    return AwsQuantumTask(d._arn, task_spec, s3_destination_folder=s3_destination_folder, shots=shots_, poll_timeout_seconds=poll_timeout_seconds, poll_interval_seconds=poll_interval_seconds, inputs=inputs, config=d._config, kwargs...)
end

# currently no batch support for AHS
function (d::AwsDevice)(task_specs::Vector{<:Union{Circuit, AbstractProgram}}; s3_destination_folder=default_task_bucket(), shots=nothing, max_parallel=nothing, poll_timeout_seconds::Int=DEFAULT_RESULTS_POLL_TIMEOUT, poll_interval_seconds::Int=DEFAULT_RESULTS_POLL_INTERVAL, inputs=Dict{String, Float64}(), config=d._config, kwargs...)
    shots_ = isnothing(shots) ? d._default_shots : shots
    return AwsQuantumTaskBatch(d._arn, task_specs; s3_destination_folder=s3_destination_folder, shots=shots_, poll_timeout_seconds=poll_timeout_seconds, poll_interval_seconds=poll_interval_seconds, inputs=inputs, config=config, kwargs...)
end

function _construct_topology_graph(d::AwsDevice)
    fns = fieldnames(typeof(d._properties))
    :paradigm ∉ fns && :provider ∉ fns && return nothing
    if :paradigm ∈ fns && d._properties.paradigm isa GateModelQpuParadigmProperties
        para = d._properties.paradigm
        para.connectivity.fullyConnected && return complete_digraph(para.qubitCount)
        adjacency_lists = para.connectivity.connectivityGraph
        edges = Edge[]
        for (i, js) in adjacency_lists
            append!(edges, [Edge(tryparse(Int, string(i)), tryparse(Int, j)) for j in js])
        end
        return SimpleDiGraphFromIterator(edges)
    elseif :provider ∈ fns && d._properties.provider isa DwaveProviderProperties
        edges = [Edge(i, j) for (i,j) in d._properties.provider.couplers]
        return SimpleDiGraphFromIterator(edges)
    end
end

"""
    queue_depth(d::AwsDevice)
"""
function queue_depth(d::AwsDevice)
    dev_name  = d._arn
    metadata  = parse(BRAKET.get_device(HTTP.escapeuri(dev_name), aws_config=d._config))
    queue_metadata = get(metadata, "deviceQueueInfo", nothing)
    queue_info = Dict{String, Any}()
    for response in queue_metadata
        queue_name = get(response, "queue", "")
        queue_priority = get(response, "queuePriority", "")
        queue_size = get(response, "queueSize", "")
        if queue_name == "QUANTUM_TASKS_QUEUE"
            priority_enum = QueueType(queue_priority)
            !haskey(queue_info, "quantum_tasks") && (queue_info["quantum_tasks"] = Dict{QueueType, String}())
            queue_info["quantum_tasks"][priority_enum] = queue_size
        else
            queue_info["jobs"] = queue_size
        end
    end
    return QueueDepthInfo(get(queue_info, "quantum_tasks", Dict{QueueType, String}()), get(queue_info, "jobs", ""))
end

"""
    refresh_metadata!(d::AwsDevice)

Refreshes information contained in the [`AwsDevice`](@ref) struct, for example
whether the device is currently online.
"""
function refresh_metadata!(d::AwsDevice)
    dev_name  = d._arn
    metadata  = parse(BRAKET.get_device(HTTP.escapeuri(dev_name), aws_config=d._config))
    d._name   = metadata["deviceName"]
    d._status = metadata["deviceStatus"]
    d._type   = metadata["deviceType"]
    d._provider_name = metadata["providerName"]
    qpu_properties = get(metadata, "deviceCapabilities", nothing)
    readable_qpu_props = qpu_properties isa String ? qpu_properties : JSON3.write(qpu_properties)
    d._properties = !isnothing(qpu_properties) ? parse_raw_schema(readable_qpu_props) : nothing
    d._topology_graph = _construct_topology_graph(d)
end

"""
    AwsDevice(device_arn::String; config::AWSConfig=global_aws_config()) -> AwsDevice

Encapsulates an AWS managed device with arn `device_arn` and
refreshes its metadata (see [`refresh_metadata!](@ref)) right away.
"""
function AwsDevice(device_arn::String; config::AWSConfig=global_aws_config())
    d = AwsDevice(_arn=device_arn)
    dev_region = String(split(device_arn, ":")[4])
    if isempty(dev_region)
        current_region = AWS.region(config)
        try
            refresh_metadata!(d)
            return d
        catch e
            e isa AWS.AWSExceptions.AWSException || e isa Downloads.RequestError || throw(e)
            !occursin("qpu", device_arn) && throw(ErrorException("Simulator $device_arn not found in '$current_region'"))

            for new_region in setdiff(REGIONS, current_region)
                try
                    region_config = AWSConfig(config.credentials, new_region, config.output)
                    d._config = region_config
                    refresh_metadata!(d)
                    return d
                catch e 
                    e isa AWS.AWSExceptions.AWSException || e isa Downloads.RequestError || throw(e)
                end
            end
            throw(ErrorException("QPU $device_arn not found"))
        end
    else
        conf = dev_region == AWS.region(config) ? config : AWSConfig(config.credentials, dev_region, config.output)
        d._config = conf
        refresh_metadata!(d)
        return d
    end
end
AwsDevice(d::BraketDevice; kwargs...) = AwsDevice(convert(String, d); kwargs...)

"""
    isavailable(d::AwsDevice) -> Bool

Is device `d` currently available to run tasks on.
"""
function isavailable(d::AwsDevice)
    d._status != "ONLINE" && return false

    is_available_result = false
    current_datetime = Dates.now(UTC)
    for execution_window in d._properties.service.executionWindows
        weekday = dayofweek(current_datetime)
        current_time_utc = current_datetime
        if hour(current_time_utc) < hour(execution_window.windowEndHour) < hour(execution_window.windowStartHour)
            weekday = mod(weekday - 1, 7)
        end
       
        execution_day = ExecutionDayDict[lowercase(execution_window.executionDay)]
        matched_day = execution_day == everyday
        matched_day = matched_day || (execution_day == weekdays && weekday < 5)
        matched_day = matched_day || (execution_day == weekends && weekday > 4)
        ordered_days = ( 
                monday,
                tuesday,
                wednesday,
                thursday,
                friday,
                saturday,
                sunday,
               )

        matched_day = matched_day || (execution_day in ordered_days && findfirst(execution_day, ordered_days) == weekday)
        matched_time = (
            execution_window.windowStartHour < execution_window.windowEndHour
            && hour(execution_window.windowStartHour) <= hour(current_time_utc) <= hour(execution_window.windowEndHour)
        ) || (
            execution_window.windowEndHour < execution_window.windowStartHour
            && (
                hour(current_time_utc) >= hour(execution_window.windowStartHour)
                || hour(current_time_utc) <= hour(execution_window.windowEndHour)
            )
        )
        is_available_result = is_available_result || (matched_day && matched_time)
    end
    return is_available_result
end

"""
    search_devices(; kwargs...) -> Vector{Dict{String, Any}}

Search all AWS managed devices and filter the results using `kwargs`.

Valid `kwargs` are:
  - `arns::Vector{String}`: ARNs of devices to search for.
  - `names::Vector{String}`: Names of devices to search for.
  - `types::Vector{String}`: Types of devices (e.g. QPU or simulator) to search for.
  - `statuses::Vector{String}`: Statuses of devices (e.g. `"ONLINE"` or `"OFFLINE"`) to search for.
  - `provider_names::Vector{String}`: Providers of devices to search for.
"""
function search_devices(; arns::Vector{String}=String[], names::Vector{String}=String[], types::Vector{String}=String[], statuses::Vector{String}=String[], provider_names::Vector{String}=String[], config::AWSConfig=global_aws_config())
    results  = []
    filters = Dict{String, Any}[]
    !isempty(arns) && push!(filters, Dict("name"=>"deviceArn", "values"=>arns))
    response = BRAKET.search_devices(filters, Dict("maxResponses"=>100), aws_config=config)
    for result in response["devices"]
        !isempty(names) && result["deviceName"] ∉ names && continue
        !isempty(types) && result["deviceType"] ∉ types && continue
        !isempty(statuses) && result["deviceStatus"] ∉ statuses && continue
        !isempty(provider_names) && result["providerName"] ∉ provider_names && continue
        # do some post-processing on result
        if haskey(result, "deviceCapabilities") && !isnothing(result["deviceCapabilities"]) && !isempty(result["deviceCapabilities"])
            result["deviceCapabilities"] = parse_raw_schema(result["deviceCapabilities"])
        end
        push!(results, result)
    end
    return results
end

"""
    get_devices(; kwargs...) -> Vector{AwsDevice}

Return all AWS Devices satisfying the filters in `kwargs`. The devices
have their properties populated and a region-appropriate `AWSConfig` attached.

Valid `kwargs` are:
  - `arns::Vector{String}`: ARNs of devices to search for.
  - `names::Vector{String}`: Names of devices to search for.
  - `types::Vector{String}`: Types of devices (e.g. QPU or simulator) to search for.
  - `statuses::Vector{String}`: Statuses of devices (e.g. `"ONLINE"` or `"OFFLINE"`) to search for.
  - `provider_names::Vector{String}`: Providers of devices to search for.
  - `order_by::String`: property used to sort the devices. Default is `"name"`.
"""
function get_devices(; arns::Vector{String}=String[], names::Vector{String}=String[], types::Vector{String}=collect(keys(AwsDeviceTypeDict)), statuses::Vector{String}=String[], provider_names::Vector{String}=String[], order_by::String="name")
    order_by ∉ _GET_DEVICES_ORDER_BY_KEYS && throw(ArgumentError("order_by $order_by must be in $_GET_DEVICES_ORDER_BY_KEYS"))
    device_map = Dict{String, AwsDevice}()
    global_config = global_aws_config()
    current_region = AWS.region(global_config)
    search_regions = types == ["SIMULATOR"] ? (current_region,) : REGIONS
    
    for region in search_regions
        config_for_region = region == current_region ? global_config : AWSConfig(global_config.credentials, region, global_config.output)
        # Simulators are only instantiated in the same region as the AWS session
        types_for_region = string.(sort(region == current_region ? types : setdiff(types, "SIMULATOR")))
        types_for_region = isnothing(types_for_region) ? Vector[] : types_for_region
        region_devices = search_devices(arns=arns, names=names,
                                        types=types_for_region,
                                        statuses=statuses,
                                        provider_names=provider_names,
                                        config=config_for_region
                                        )
        region_device_arns = [dev["deviceArn"] for dev in region_devices]
        add_arns = filter(arn->!haskey(device_map, arn), region_device_arns)
        merge!(device_map, Dict(arn=>AwsDevice(arn, config=config_for_region) for arn in add_arns))
    end
    return sort(collect(values(device_map)), by=(x->getproperty(x, Symbol("_"*order_by))))
end

mutable struct LocalJobContainer
    image_uri::String
    container_name::String
    container_code_path::String
    env::Dict{String, String}
    run_log::String
    config::AWSConfig
    function LocalJobContainer(image_uri::String, create_job_args; config::AWSConfig=global_aws_config(), container_name::String="", container_code_path::String="/opt/ml/code", force_update::Bool=false)
        c = new(image_uri, container_name, container_code_path, Dict{String, String}(), "", config)
        c = start_container!(c, force_update)
        return setup_container!(c, create_job_args)
    end
end
name(c::LocalJobContainer) = c.container_name

function get_env_creds(config::AWSConfig)
    creds = AWS.credentials(config)
    if isempty(creds.token)
        @info "Using the long-lived AWS credentials found in session"
        return Dict("AWS_ACCESS_KEY_ID"=>creds.access_key_id, "AWS_SECRET_ACCESS_KEY"=>creds.secret_key)
    end
    @warn "Using the short-lived AWS credentials found in session. They might expire while running."
    return Dict("AWS_ACCESS_KEY_ID"=>creds.access_key_id, "AWS_SECRET_ACCESS_KEY"=>creds.secret_key, "AWS_SESSION_TOKEN"=>creds.token)
end

function get_env_defaults(config::AWSConfig, args)
    job_name = args[:job_name]
    bucket, location = parse_s3_uri(args[:out_conf]["s3Path"])
    return Dict( 
        "AWS_DEFAULT_REGION"=>AWS.region(config),
        "AMZN_BRAKET_JOB_NAME"=>job_name,
        "AMZN_BRAKET_DEVICE_ARN"=>args[:dev_conf]["device"],
        "AMZN_BRAKET_JOB_RESULTS_DIR"=>"/opt/braket/model",
        "AMZN_BRAKET_CHECKPOINT_DIR"=>args[:params]["checkpointConfig"]["localPath"],
        "AMZN_BRAKET_OUT_S3_BUCKET"=>bucket,
        "AMZN_BRAKET_TASK_RESULTS_S3_URI"=>"s3://$bucket/jobs/$job_name/tasks",
        "AMZN_BRAKET_JOB_RESULTS_S3_PATH"=>joinpath(location, job_name, "output"),
       )
end

function get_env_script_mode_config(script_mode::OrderedDict{String, String})
    result = Dict("AMZN_BRAKET_SCRIPT_S3_URI"=>script_mode["s3Uri"], "AMZN_BRAKET_SCRIPT_ENTRY_POINT"=>script_mode["entryPoint"])
    if haskey(script_mode, "compressionType")
        result["AMZN_BRAKET_SCRIPT_COMPRESSION_TYPE"] = script_mode["compressionType"]
    end
    return result
end

get_env_hyperparameters() = Dict("AMZN_BRAKET_HP_FILE"=>"/opt/braket/input/config/hyperparameters.json")
get_env_input_data()      = Dict("AMZN_BRAKET_INPUT_DIR"=>"/opt/braket/input/data")

function copy_hyperparameters(c::LocalJobContainer, args)
    haskey(args[:params], "hyperParameters") || return false
    hyperparameters = args[:params]["hyperParameters"]
    mktempdir() do temp_dir
        file_path = joinpath(temp_dir, "hyperparameters.json")
        write(file_path, JSON3.write(hyperparameters))
        copy_to_container!(c, file_path, "/opt/ml/input/config/hyperparameters.json")
    end
    return true
end

function is_s3_dir(prefix::String, s3_keys)
    endswith(prefix, "/") && return true
    return all(key->startswith(key, prefix * "/"), s3_keys)
end

function download_input_data(config::AWSConfig, download_dir, input_data::Dict{String, Any})
    channel_name   = input_data["channelName"]
    s3_uri_prefix  = input_data["dataSource"]["s3DataSource"]["s3Uri"]
    bucket, prefix = parse_s3_uri(s3_uri_prefix)
    s3_keys        = collect(s3_list_keys(bucket, prefix))
    @debug "Channel name: $channel_name, S3 URI: $s3_uri_prefix, S3 keys: $s3_keys, bucket: $bucket, prefix: $prefix, all bucket keys: $(collect(s3_list_keys(bucket)))"
    top_level      = is_s3_dir(prefix, s3_keys) ? prefix : dirname(prefix)
    top_level      = isempty(top_level) ? prefix : top_level
    found_item     = false
    try
        mkdir(joinpath(download_dir, channel_name))
    catch e
        throw(ErrorException("Duplicate channel names not allowed for input data: $channel_name"))
    end
    for s3_key in s3_keys
        relative_key  = relpath(s3_key, top_level)
        relative_key  = relative_key == "." ? basename(prefix) : relative_key
        download_path = joinpath(download_dir, channel_name, relative_key)
        if !endswith(s3_key, "/")
            @debug "Getting file from S3: bucket $bucket, s3_key $s3_key, top level $top_level, relative_key $relative_key, download path $download_path"
            mkpath(dirname(download_path))
            s3_get_file(config, bucket, s3_key, download_path)
            found_item = true
        end
    end
    !found_item && throw(ErrorException("No data found for channel '$channel_name'"))
    return
end

function copy_input_data_list(c::LocalJobContainer, args)
    haskey(args[:params], "inputDataConfig") || return false
    input_data_list = args[:params]["inputDataConfig"]
    @debug "Input data list for copy: $input_data_list"
    mktempdir() do temp_dir
        foreach(input_data->download_input_data(c.config, temp_dir, input_data), input_data_list)
        # add dot to copy temp_dir's CONTENTS
        copy_to_container!(c, temp_dir * "/.", "/opt/ml/input/data/")
    end
    return !isempty(input_data_list)
end

function setup_container!(c::LocalJobContainer, create_job_args)
    @debug "Setting up container..."
    c_name = c.container_name
    # create expected paths for a Braket job to run
    @debug "Setting up container: creating expected paths"
    proc_out, proc_err, code = capture_docker_cmd(`docker exec $c_name mkdir -p /opt/ml/model`)
    local_path = create_job_args[:params]["checkpointConfig"]["localPath"]
    proc_out, proc_err, code = capture_docker_cmd(`docker exec $c_name mkdir -p $local_path`)

    @debug "Setting up container: creating environment variables"
    env_vars = Dict{String, String}()
    merge!(env_vars, get_env_creds(c.config))
    script_mode = create_job_args[:algo_spec]["scriptModeConfig"]
    merge!(env_vars, get_env_script_mode_config(script_mode))
    merge!(env_vars, get_env_defaults(c.config, create_job_args))
    @debug "Setting up container: copying hyperparameters"
    copy_hyperparameters(c, create_job_args) && merge!(env_vars, get_env_hyperparameters())
    @debug "Setting up container: copying input data list"
    copy_input_data_list(c, create_job_args) && merge!(env_vars, get_env_input_data())
    c.env = env_vars
    return c
end

function run_local_job!(c::LocalJobContainer)
    code_path = c.container_code_path
    c_name    = c.container_name
    @debug "Running local job: capturing entry point command"
    entry_point_cmd = `docker exec $c_name printenv SAGEMAKER_PROGRAM`
    entry_program, err, code = capture_docker_cmd(entry_point_cmd)
    (isnothing(entry_program) || isempty(entry_program)) && throw(ErrorException("Start program not found. The specified container is not setup to run Braket Jobs. Please see setup instructions for creating your own containers."))
    env_list  = String.(reduce(vcat, ["-e", k*"="*v] for (k,v) in c.env))
    cmd  = Cmd(["docker", "exec", "-w", String(code_path), env_list..., String(c_name), "python", String(entry_program)])
    @debug "Running local job: running full entry point command"
    proc_out, proc_err, code = capture_docker_cmd(cmd)
    if code == 0
        c.run_log *= proc_out 
    else
        err_str = "Run local job process exited with code: $code"
        c.run_log *= proc_out 
        c.run_log *= err_str * proc_err
    end
    return c
end

function login_to_ecr(account_id::String, ecr_uri::String, config::AWSConfig)
    @debug "Attempting to log in to ECR..."
    @debug "Getting authorization token"
    authorization_data_result = EcR.get_authorization_token(Dict("registryIds"=>[account_id]), aws_config=config)
    isnothing(authorization_data_result) && throw(ErrorException("unable to get permissions to access ECR in order to log in to docker. Please pull down the container before proceeding."))
    raw_token = base64decode(authorization_data_result["authorizationData"][1]["authorizationToken"])
    token = String(raw_token)
    token = replace(token, "AWS:"=>"")
    @debug "Performing docker login"
    proc_out, proc_err, code = capture_docker_cmd(`docker login -u AWS -p $token $ecr_uri`)
    @debug "docker login complete"
    code != 0 && throw(ErrorException("Unable to docker login to ECR with error $proc_err"))
    return
end

function pull_image(image_uri::String, config::AWSConfig)
    m = match(ECR_URI_PATTERN, image_uri)
    isnothing(m) && throw(ErrorException("The URI $image_uri is not available locally and does not seem to be a valid AWS ECR URI. Please pull down the container or specify a valid ECR URI before proceeding."))
    ecr_uri    = String(m[1])
    account_id = String(m[2])
    login_to_ecr(account_id, ecr_uri, config)
    @warn "Pulling docker image $image_uri. This may take a while."
    proc_out, proc_err, code = capture_docker_cmd(`docker pull $image_uri`)
    code != 0 && error(proc_err)
    return
end

function capture_docker_cmd(cmd::Cmd)
    out = Pipe()
    err = Pipe()
    proc = run(pipeline(ignorestatus(cmd), stdout=out, stderr=err))
    close(out.in)
    close(err.in)
    proc_out = String(read(out))
    proc_err = String(read(err))
    return chomp(proc_out), chomp(proc_err), proc.exitcode
end

function start_container!(c::LocalJobContainer, force_update::Bool)
    image_uri = c.image_uri
    get_image_name(image_uri) = capture_docker_cmd(`docker images -q $image_uri`)[1]
    @debug "Acquiring docker image for container start"
    image_name = get_image_name(image_uri)
    if isempty(image_name) || isnothing(image_name)
        try
            pull_image(image_uri, c.config)
            image_name = get_image_name(image_uri)
            (isempty(image_name) || isnothing(image_name)) && throw(ErrorException("The URI $(c.image_uri) is not available locally and cannot be pulled from Amazon ECR. Please pull down the container before proceeding."))
        catch ex
            throw(ErrorException("The URI $(c.image_uri) is not available locally and cannot be pulled from Amazon ECR due to $ex. Please pull down the container before proceeding."))
        end
    elseif force_update
        try
            pull_image(image_uri, c.config)
            image_name = get_image_name(image_uri)
        catch e
            @warn "Unable to update $(c.image_uri) with error $e"
        end
    end
    @debug "Launching container with docker run"
    container_name, err, code = capture_docker_cmd(`docker run -d --rm $image_name tail -f /dev/null`)
    code == 0 || throw(ErrorException(err))
    c.container_name = container_name
    return c 
end

function stop_container!(c::LocalJobContainer)
    # check that the container is still running
    cmd = `docker container ls -q`
    c_list, c_err, code = capture_docker_cmd(cmd)
    if code == 0 && occursin(first(c.container_name, 10), c_list)
        stop_out, stop_err, stop_code = capture_docker_cmd(Cmd(["docker", "stop", c.container_name]))
        if stop_code != 0
            error("unable to stop docker container $(c.contianer_name)! Error: $stop_err")
        end
    else
        error("unable to read docker container list! Error: $c_err")
    end
    return
end

function copy_from_container!(c::LocalJobContainer, src::String, dst::String)
    c_name = c.container_name
    cmd = `docker cp $c_name:$src $dst`
    proc_out, proc_err, code = capture_docker_cmd(cmd)
    if code == 0
        c.run_log *= proc_out
    else
        c.run_log *= proc_err
        throw(ErrorException(proc_err))
    end
    return c
end

function copy_to_container!(c::LocalJobContainer, src::String, dst::String)
    c_name = c.container_name
    dir_name = dirname(dst)
    cmd = `docker exec $c_name mkdir -p $dir_name`
    proc_out, proc_err, code = capture_docker_cmd(cmd) 
    if code == 0
        c.run_log *= proc_out 
    else
        c.run_log *= proc_err
        throw(ErrorException(proc_err))
    end
    cmd = `docker cp $src $c_name:$dst`
    proc_out, proc_err, code = capture_docker_cmd(cmd) 
    if code == 0
        c.run_log *= proc_out 
    else
        c.run_log *= proc_err
        throw(ErrorException(proc_err))
    end
    return c
end

"""
    LocalQuantumJob <: Job

Struct representing a Local Job.
"""
mutable struct LocalQuantumJob <: Job
    arn::String
    name::String
    run_log::String
    function LocalQuantumJob(arn::String; run_log::String="")
        !startswith(arn, "local:job/") && throw(ArgumentError("arn $arn is not a valid local job arn."))
        name = String(split(arn, "job/")[end])
        isempty(run_log) && !ispath(name) && throw(ErrorException("unable to find local job results for $name."))
        new(arn, name, run_log)
    end
end

function LocalQuantumJob(
    device::String,
    source_module::String,
    j_opts::JobsOptions;
    force_update::Bool=false,
    config::AWSConfig=global_aws_config()
    )
    image_uri = isempty(j_opts.image_uri) ? retrieve_image(BASE, config) : j_opts.image_uri
    args      = prepare_quantum_job(device, source_module, j_opts)
    algo_spec = args[:algo_spec]
    job_name  = args[:job_name]
    ispath(job_name) && throw(ErrorException("a local directory called $job_name already exists. Please use a different job name."))
    image_uri = haskey(algo_spec, "containerImage") ? algo_spec["containerImage"]["uri"] : retrieve_image(BASE, config)

    run_log = ""
    let local_job_container=LocalJobContainer(image_uri, args, force_update=force_update)
        local_job_container = run_local_job!(local_job_container)
        # copy results out
        copy_from_container!(local_job_container, "/opt/ml/model", job_name)
        !ispath(job_name) && mkdir(job_name)
        write(joinpath(job_name, "log.txt"), local_job_container.run_log)
        if haskey(args, :params) && haskey(args[:params], "checkpointConfig") && haskey(args[:params]["checkpointConfig"], "localPath")
            checkpoint_path = args[:params]["checkpointConfig"]["localPath"]
            copy_from_container!(local_job_container, checkpoint_path, joinpath(job_name, "checkpoints"))
        end
        run_log = local_job_container.run_log
        stop_container!(local_job_container)
    end
    return LocalQuantumJob("local:job/$job_name", run_log=run_log)
end

"""
    LocalQuantumJob(device::Union{String, BraketDevice}, source_module::String; kwargs...)

Create and launch a `LocalQuantumJob` which will use device `device` (a managed simulator, a QPU, or an [embedded simulator](https://docs.aws.amazon.com/braket/latest/developerguide/pennylane-embedded-simulators.html))
and will run the code (either a single file, or a Julia package, or a Python module) located at `source_module`. `device` can be either the device's ARN as a `String`, or a [`BraketDevice`](@ref). 
A *local* job
runs *locally* on your computational resource by launching the Job container locally using `docker`. The job will block
until it completes, replicating the `wait_until_complete` behavior of [`AwsQuantumJob`](@ref).

The keyword arguments `kwargs` control the launch configuration of the job.

# Keyword Arguments
  - `entry_point::String` - the function to run in `source_module` if `source_module` is a Python module/Julia package. Defaults to an empty string, in which case
    the behavior depends on the code language. In Python, the job will attempt to find a function called `main` in `source_module` and run it. In Julia,
    `source_module` will be loaded and run with Julia's [`include`](https://docs.julialang.org/en/v1/base/base/#Base.include).
  - `image_uri::String` - the URI of the Docker image in ECR to run the Job on. Defaults to an empty string, in which case the [base container](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-script-environment.html)
    is used.
  - `job_name::String` - the name for the job, which will be displayed in the [jobs console](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-first.html).
    The default is a combination of the container image name and the current time.
  - `code_location::String` - the S3 prefix URI to which code will be uploaded. The default is `default_bucket()/jobs/<job_name>/script`
  - `role_arn::String` - not used for `LocalQuantumJob`s.
  - `hyperparameters::Dict{String, Any}` - hyperparameters to provide to the job which will be available from an environment variable when the job is run.
    See the [Amazon Braket documentation](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-hyperparameters.html) for more.
  - `input_data::Union{String, Dict}` - information about the training/input data to provide to the job.
    A `Dict` should map channel names to local paths or S3 URIs. Contents found at any local paths encoded as `String`s will be uploaded to S3 at
    `s3://{default_bucket_name}/jobs/{job_name}/data/{channel_name}`. If a local path or S3 URI is provided, it will be given a default
    channel name `"input"`. The default is `Dict()`.
  - `instance_config::InstanceConfig` - not used for `LocalQuantumJob`s.
  - `distribution::String` - not used for `LocalQuantumJob`s.
  - `stopping_condition::StoppingCondition` - the maximum length of time, in seconds, that a job
    can run before being forcefully stopped. The default is `StoppingCondition(5 * 24 * 60 * 60)`.
  - `output_data_config::OutputDataConfig` - specifies the location for the output of the job.
    Any data stored here will be available to [`download_result`](@ref) and [`results`](@ref). The default is
    `OutputDataConfig("s3://{default_bucket_name}/jobs/{job_name}/data")`.
  - `copy_checkpoints_from_job::String` - specifies the job ARN whose checkpoint is to be used in the current job.
    Specifying this value will copy over the checkpoint data from `use_checkpoints_from_job`'s `checkpoint_config`
    S3 URI to the current job's `checkpoint_config` S3 URI, making it available at `checkpoint_config.localPath` during
    the job execution. The default is not to copy any checkpoints (an empty string).
  - `checkpoint_config::CheckpointConfig` - specifies the location where
    checkpoint data for *this* job is to be stored.
    The default is `CheckpointConfig("/opt/jobs/checkpoints", "s3://{default_bucket_name}/jobs/{job_name}/checkpoints")`.
  - `tags::Dict{String, String}` - specifies the key-value pairs for tagging this job.
"""
LocalQuantumJob(device::String, source_module::String; force_update::Bool=false, config::AWSConfig=global_aws_config(), kwargs...) = LocalQuantumJob(device, source_module, JobsOptions(; kwargs...); force_update=force_update, config=config)
LocalQuantumJob(device::BraketDevice, source_module::String; kwargs...) = LocalQuantumJob(convert(String, device), source_module; kwargs...)

"""
    arn(j::LocalQuantumJob)

Returns the ARN identifying the job `j`. This ARN can be used to
reconstruct the job after the session that launched it has exited.
"""
arn(j::LocalQuantumJob)      = j.arn
"""
    name(j::LocalQuantumJob)

Returns the name of the job `j`.
"""
name(j::LocalQuantumJob)     = j.name
run_log(j::LocalQuantumJob)  = j.run_log
"""
    state(j::LocalQuantumJob, ::Val{true})
    state(j::LocalQuantumJob, ::Val{false})
    state(j::LocalQuantumJob)

Fetch the state for job `j`. Local jobs block until they
complete, the `state` is always `"COMPLETED"`.
"""
state(j::LocalQuantumJob, v) = "COMPLETED"
state(j::LocalQuantumJob)    = "COMPLETED"
cancel(j::LocalQuantumJob)   = nothing
metadata(j::LocalQuantumJob, v) = nothing
metadata(j::LocalQuantumJob)    = nothing
download_result(j::LocalQuantumJob)    = nothing
"""
    logs(j::LocalQuantumJob; kwargs...)

Fetches the logs of job `j`.
"""
logs(j::LocalQuantumJob; kwargs...) = println(j.run_log)

"""
    metrics(j::LocalQuantumJob, metric_type=TIMESTAMP, statistic="MAX") 

Fetches the metrics for job `j`. Metrics are generated by [`log_metric`](@ref)
within the job script.
"""
function metrics(j::LocalQuantumJob; metric_type=TIMESTAMP, statistic="MAX")
    results = String.(filter(line -> startswith(line, "Metrics - "), split(j.run_log, "\n")))
    parsed_results = map(results) do r
        [Dict("field"=>"@timestamp", "value"=>time()),
         Dict("field"=>"@message", "value"=>String(r))]
    end
    return _parse_query_results(parsed_results, metric_type, statistic)
end

"""
    result(j::LocalQuantumJob; kwargs...)

Copy, extract, and deserialize the results of local job `j`.
"""
function result(j::LocalQuantumJob; kwargs...)
    try
        raw = read(joinpath(name(j), "results.json"), String)
        persisted_data    = parse_raw_schema(raw)
        @debug "Persisted data format: $(persisted_data.dataFormat)"
        deserialized_data = deserialize_values(persisted_data.dataDictionary, persisted_data.dataFormat)
        return deserialized_data
    catch
        throw(ErrorException("unable to find results in the local job directory $(name(j))."))
    end
end

### A Pluto.jl notebook ###
# v0.19.40

using Markdown
using InteractiveUtils

# ╔═╡ d928ee56-0f14-426c-b669-356627382f8f
using Braket, BraketSimulator

# ╔═╡ ab9771de-a268-4df8-811d-9310a12a7d79
using Plots

# ╔═╡ eefcfdb6-dc0f-4ec4-85a3-73bafc9e0177
md"
# Quantum Fourier Transform with Amazon Braket
"

# ╔═╡ e00258a8-e04e-4806-85ad-1ef5c4476dad
md"""
In this example, we show an implementation of the Quantum Fourier Transform (QFT) and its inverse. QFT is an important subroutine in many quantum algorithms, like Shor's algorithm and Quantum Phase Estimation. The QFT can be performed efficiently on a quantum computer, using only $\mathcal{O}(n^2)$ single-qubit Hadamard gates and two-qubit controlled phase shift gates, where $n$ is the number of qubits. First, we review the basics of the QFT circuit and how it relates to classical Fourier transforms. Then, we implement QFT in both recursive and non-recursive form, as well as its inverse.
"""

# ╔═╡ b5530b38-f3e1-4bd7-bf6e-b2052a44850b
md"""
## Background of QFT

The Quantum Fourier Transform is a quantum algorithm for applying a discrete Fourier transform to the amplitudes of a quantum state. It's the quantum analogue of the [classical discrete Fourier transform](https://en.wikipedia.org/wiki/Discrete_Fourier_transform). As a refresher, if we have a length $N$ vector $(x_0, x_1, \ldots, x_{N-1}) \in \mathbb{C}^N$, then the discrete Fourier transform of this vector is a length $N$ vector $(y_0, y_1, \ldots, y_{N-1}) \in \mathbb{C}^N$:

```math
y_j = \frac{1}{\sqrt{N}}\sum_{k=0}^{N-1} x_k \exp{\left\{\frac{2\pi i}{N} j k \right\}}
```

To develop the *quantum* analogue to this, we can consider an arbitrary state $|\mathtt{input}\rangle = \sum_{j=0}^{N-1} x_j |j\rangle$, and map it to an output state $|\mathtt{output}\rangle = \sum_{k=0}^{N-1} y_k |k\rangle$ such that:

```math
y_k = \frac{1}{\sqrt{N}} \sum_{\ell = 0}^{N-1} x_\ell \exp{\left\{ \frac{2\pi i}{N} \ell k \right\}}
```

As an example, let's examine the QFT of state $|0\rangle$ on 3 qubits, which we could also write as $|000\rangle$. We can calculate from the above formula for the coefficients $y_k$ that the output will be an equal superposition over all states:

```math
\begin{align*}
y_0 &= \frac{1}{\sqrt{2^3}} \\
y_1 &= \frac{1}{\sqrt{2^3}} \\
\ldots & \\
y_{N-1} &= \frac{1}{\sqrt{2^3}} \\
|\mathtt{output}\rangle &= \frac{1}{\sqrt{2^3}}\sum_{m=0}^{N-1} |m\rangle \\
\end{align*}
```

This state can be factored (you can multiply it out to check):
```math
\begin{align*}
|\mathtt{output}\rangle &= \frac{1}{\sqrt{2^3}} \left(|0\rangle + |1\rangle\right) \otimes \left(|0\rangle + |1\rangle\right) \otimes \left(|0\rangle + |1\rangle\right) \\
&= \otimes_{q=0}^{N-1} \left| + \right\rangle \\
\left| + \right\rangle &= \frac{1}{\sqrt{2}} \left(|0\rangle + |1\rangle\right) \\
\end{align*}
```

We can also implement the *inverse* QFT, which restores the original $|\mathtt{input}\rangle$ state. We will show the code for this below.
"""

# ╔═╡ d18db1cb-58b8-4949-b80a-67f36768e59c
md"""
### Implementing recursive QFT

In this section, we will implement the QFT algorithm using a recursive approach. The function `qft_no_swap` will apply all gates up to the final `SWAP`s, and `qft_recursive` will call it recursively then apply the `SWAP` gates.
"""

# ╔═╡ 608cf437-7493-494b-a4d7-1e852bcae8d9
"""
	qft_no_swap(qubits) -> Circuit

Subroutine of the QFT excluding the final `SWAP` gates, applied to the `qubits` argument.

"""
function qft_no_swap(qubits)
    # On a single qubit, the QFT is just a Hadamard.
    length(qubits) == 1 && return Circuit([(H, qubits)])
    
    # For more than one qubit, we define the QFT recursively
    qftcirc = Circuit()
	# First add a Hadamard gate
	qftcirc(H, first(qubits))
	# Then apply the controlled rotations, with weights (angles) defined by the distance to the control qubit.
	for (k, qubit) in enumerate(qubits[2:end])
		qftcirc(CPhaseShift, qubit, first(qubits), 2π/2^(k+1))
	end
	# Now apply the above gates recursively to the rest of the qubits
	qftcirc(qft_no_swap(qubits[2:end]))
    return qftcirc
end

# ╔═╡ 2c612fa4-1a8d-404a-8b3e-5e1907e20d84
"""
	qft_recursive(qubits)

Construct a circuit object corresponding to the Quantum Fourier Transform (QFT)
algorithm, applied to the argument `qubits`.
"""
function qft_recursive(qubits)
    qftcirc = Circuit()
    
    # First add the QFT subroutine above
    qftcirc(qft_no_swap(qubits))
    
    # Then add SWAP gates to reverse the order of the qubits:
    for i in 1:div(length(qubits), 2)
        qftcirc(Swap, qubits[i], qubits[end-i-1])
	end
    return qftcirc
end

# ╔═╡ ac3b8437-7f21-4e36-97bd-5af10d0eaf40
md"""
### Implementing non-recursive QFT

In this section, we write a function `qft` which implements the QFT algorithm non-recursively.
"""

# ╔═╡ 3ccc5bb1-16ec-4fd5-b82f-31da2734223e
"""
	qft(qubits)

Construct a circuit object corresponding to the Quantum Fourier Transform (QFT)
algorithm, applied to the argument `qubits`.  Does not use recursion to generate the QFT.
"""
function qft(qubits)   

    qftcirc = Circuit()
    
    # get number of qubits
    num_qubits = length(qubits)
    
    for k in 1:num_qubits
        # First add a Hadamard gate
        qftcirc(H, qubits[k])
        # Then apply the controlled rotations, with weights (angles) defined by the distance to the control qubit.
        # Start on the qubit after qubit k, and iterate until the end.  When num_qubits==1, this loop does not run.
        for j in 1:(num_qubits - k - 1)
            angle = 2π/2^(j+1)
            qftcirc(CPhaseShift, qubits[k+j], qubits[k], angle)
		end
	end
            
    # Then add SWAP gates to reverse the order of the qubits:
    for i in 1:div(num_qubits, 2)
        qftcirc(Swap, qubits[i], qubits[end-i])
	end
        
    return qftcirc
end

# ╔═╡ 25274ab6-b0a2-485f-baee-3a8a23c23834
md"""
### Inverse QFT

Finally, we can implement the inverse QFT algorithm.
"""

# ╔═╡ 55a3b85b-6d3c-43b9-9c89-5af3f5c57629
"""
	inverse_qft(qubits)

Construct a circuit object corresponding to the inverse Quantum Fourier Transform (QFT)
algorithm, applied to the argument `qubits`.  Does not use recursion to generate the circuit.
"""
function inverse_qft(qubits)

    # instantiate circuit object
    qftcirc = Circuit()
    
    # get number of qubits
    num_qubits = length(qubits)
    
    # First add SWAP gates to reverse the order of the qubits:
    for i in 1:div(num_qubits, 2)
        qftcirc(Swap, qubits[i], qubits[end-i+1])
	end
        
    # Start on the last qubit and work to the first.
    for k in reverse(1:num_qubits)
        # Apply the controlled rotations, with weights (angles) defined by the distance to the control qubit.
        # These angles are the negative of the angle used in the QFT.
        # Start on the last qubit and iterate until the qubit after k.  
        # When num_qubits==1, this loop does not run.
        for j in reverse(1:num_qubits - k)
            angle = -2π/2^(j+1)
            qftcirc(CPhaseShift, qubits[k+j], qubits[k], angle)
		end
        # Then add a Hadamard gate
        qftcirc(H, qubits[k])
	end
    return qftcirc
end

# ╔═╡ 52bf519d-806c-4d4c-915a-fa28be9b2fc2
md"""
## Running QFT on a simulator

With these routines defined, we can run QFT and its inverse on a simulator to develop more intuition. We'll use the Braket local simulator, which runs on hardware you control and is free to use.
"""

# ╔═╡ b3a750d1-7a2b-4de6-9e6c-166336ba6cec
device = LocalSimulator("braket_sv_v2")

# ╔═╡ 7127d624-fb0d-41b9-a8cd-6cae7d34d55f
"""
	prettify_state_vector(state_vector)

Rounds down small amplitudes in a given `state_vector` make it easier to analyse.
"""
function prettify_state_vector(state_vector)
	state_vec_pretty = complex.(trunc.(real.(state_vector), digits=3), trunc.(imag.(state_vector), digits=3))

	state_vec_pretty = map(ampl->abs(ampl)>1e-5 ? ampl : zero(ampl), state_vec_pretty)
	return state_vec_pretty
end

# ╔═╡ 83b78b1a-3935-4ca7-88f6-7a15cc523591
"""
	run_and_plot_qft(c::Circuit)

Runs a given `Circuit` `c` and plots the resulting state vector probabilities.
"""
function run_and_plot_qft(c::Circuit)
	num_qubits = qubit_count(c)
	bitstring_keys = [prod(string.(digits(ii, base=2, pad=num_qubits))) for ii in 0:(2^num_qubits)-1]
	# specify desired result types
	c(Braket.StateVector)
	c(Probability)

	# Run the task
	task = simulate(device, c, shots=0)
	res  = result(task)
	state_vector = res.values[1]
	probs_values = res.values[2]
	p = bar(bitstring_keys, probs_values, xlabel="bitstrings", ylabel="probability", legend=false)
	return p
end

# ╔═╡ 335e537b-c6f8-4c1b-a9b0-5e14c4f7323b
md"""
### Examining the effect of QFT on various states

Let's first run the QFT on the $|0\rangle$ state, which, as we showed above, should be mapped to an equal superposition over all states by the QFT:
"""

# ╔═╡ 256bb268-e2fc-4483-a6f7-4a76028fcf80
# check output for input |0,0,0> -> expect uniform distribution
run_and_plot_qft(qft(collect(0:2)))

# ╔═╡ 9bfd35b5-82cf-4c5e-8006-a3b2de15598a
md"""
We can also prepare by hand (using the formula above) the result of QFT on a particular state, say $|2\rangle = |010\rangle$, and apply the inverse QFT to recover the input state:
"""

# ╔═╡ 20cfa5e8-d4ad-4720-9d27-f7c161ea09e3
begin
	nqs1 = 3
	qbs1 = collect(0:nqs1-1)
	circ2 = Circuit([(H, qbs1)])
	for ii in 1:nqs1 - 1
	    circ2(Rz, ii, π/2^(ii-1))
	end
	# add iQFT circuit
	circ2(inverse_qft(qbs1))
	run_and_plot_qft(circ2)
end

# ╔═╡ ac34f36b-9ede-4bf0-9120-a5e0253d6f64
md"And we can verify that our code works on qubit counts larger than 3:"

# ╔═╡ 0508acef-1de0-42e4-9bbc-9127c2a162b5
begin
	# test that the iQFT circuit works for larger qubit counts
	nqs2 = 4
	qbs2 = collect(0:nqs2-1)
	circ3 = Circuit(vcat((H, qbs2), [(Rz, ii, π/2^(ii-1)) for ii in 1:nqs2-1]))
	# add iQFT circuit   
	circ3(inverse_qft(qbs2))
	run_and_plot_qft(circ3)
end

# ╔═╡ f584f456-c803-4fa8-99f5-cb9f87b13097
md"""
If we apply QFT and then its inverse, we should recover the input state. Let's verify this:
"""

# ╔═╡ ae77c39f-9f7e-4c45-8823-a16a38c33e0d
begin
	#test that the QFT and iQFT circuits cancel each other
	nqs3 = 3
	qbs3 = collect(0:nqs3-1)
	circ4 = qft(qbs3)
	circ4(inverse_qft(qbs3))
	
	run_and_plot_qft(circ4)
end

# ╔═╡ cc46be99-41e5-4b30-a158-bd5c8c961247
md"""
## Conclusion

In this example, we gave a brief introduction to the quantum Fourier transform, which is the quantum analogue of the classical discrete Fourier transform. This algorithm is an essential building block of many higher level quantum algorithms. We verified that QFT and iQFT are inverses of each other and that we see the expected output when running on simple test cases.
"""

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
Plots = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"

[compat]
Braket = "~0.1.0"
Plots = "~1.37.0"
PyBraket = "~0.1.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.4"
manifest_format = "2.0"
project_hash = "b388d13767d41625e15c8cccb513c918b35968c2"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "19ed52e8e3cc91a85c73c1bd514fd24a3e5bef06"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.78.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "e753f872313928ea3ecbc415ae99ab18c8de10bc"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.1.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "Tables", "Unicode", "WeakRefStrings"]
git-tree-sha1 = "873fb188a4b9d76549b81465b1f75c82aaf59238"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.4"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c6d890a52d2c4d55d326439580c3b8d0875a77d9"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.7"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "9c209fb7536406834aa938fb149964b985de6c83"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.1"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random", "SnoopPrecompile"]
git-tree-sha1 = "aa3edc8f8dea6cbfa176ee12f7c2fc82f0608ed3"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.20.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "600cc5508d66b78aae350f7accdb58763ac18589"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.10"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "fc08e5930ee9a4e03f84bfb5211cb54e7769758a"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.10"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "3ca828fe1b75fa84b021a7860bd039eaea84d2f2"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.3.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.5+0"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "341e3ce7ddd8d57dc7be27146bd1c072000d485a"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.14"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.DataAPI]]
git-tree-sha1 = "e8119c1a33d267e16108be441a287a6981ba1630"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.14.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
git-tree-sha1 = "9e2f36d3c96a820c678f2f1f1782582fcf685bae"
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"
version = "1.9.1"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "2fb1e02f2b635d0845df5d7c167fec4dd739b00d"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.3"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.EpollShim_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "8e9441ee83492030ace98f9789a654a6d0b1f643"
uuid = "2702e6a9-849d-5ed8-8c21-79e8b8f9ee43"
version = "0.0.20230411+0"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GR]]
deps = ["Artifacts", "Base64", "DelimitedFiles", "Downloads", "GR_jll", "HTTP", "JSON", "Libdl", "LinearAlgebra", "Pkg", "Preferences", "Printf", "Random", "Serialization", "Sockets", "TOML", "Tar", "Test", "UUIDs", "p7zip_jll"]
git-tree-sha1 = "9e23bd6bb3eb4300cb567bdf63e2c14e5d2ffdbc"
uuid = "28b8d3ca-fb5f-59d9-8090-bfdbd6d07a71"
version = "0.71.5"

[[deps.GR_jll]]
deps = ["Artifacts", "Bzip2_jll", "Cairo_jll", "FFMPEG_jll", "Fontconfig_jll", "GLFW_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Pixman_jll", "Pkg", "Qt5Base_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "aa23c9f9b7c0ba6baeabe966ea1c7d2c7487ef90"
uuid = "d2c73de3-f751-5644-a686-071e5b155ba9"
version = "0.71.5+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "5688002de970b9eee14b7af7bbbd1fdac10c9bbe"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.2"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "d3b3624125c1474292d0d8ed0f65554ac37ddb23"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "4abede886fcba15cd5fd041fef776b230d004cee"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.4.0"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "0cf92ec945125946352f3d46c96976ab972bde6f"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.3.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLFzf]]
deps = ["Pipe", "REPL", "Random", "fzf_jll"]
git-tree-sha1 = "f377670cda23b6b7c1c0b3893e37451c5c1a2185"
uuid = "1019f520-868f-41f5-a6de-eb00f4b6a39c"
version = "0.1.5"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "65edf3850efb9cb4ca3b0bf488e29c6c38a23d2d"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.11.1"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.Latexify]]
deps = ["Formatting", "InteractiveUtils", "LaTeXStrings", "MacroTools", "Markdown", "OrderedCollections", "Printf", "Requires"]
git-tree-sha1 = "2422f47b34d4b127720a18f86fa7b1aa2e141f29"
uuid = "23fbe1c1-3f47-55db-b15f-69d7ec21a316"
version = "0.15.18"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.4"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "8.4.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.11.0+1"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "6f73d1dd803986947b2c750138528a999a6c7733"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.6.0+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c7cb1f5d892775ba13767a87c7ada0b980ea0a71"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+2"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "Pkg", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "3eb79b0ca5764d4799c06699573fd8f533259713"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.4.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "946607f84feb96220f480e0422d3484c49c00239"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.19"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "5d4d2d9904227b8bd66386c1138cf4d5ffa826bf"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "0.4.9"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.2+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch"]
git-tree-sha1 = "b49f11c4f9272fcbd66816ab8c3128d39982966c"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.9"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "f66bdc5de519e8f8ae43bdc598782d35a25b1272"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.1.0"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["ExprTools"]
git-tree-sha1 = "748f6e1e4de814b101911e64cc12d83a6af66782"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.2"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "17eeb975b00de066fb343aa8d56884f51d4a651c"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.1"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+4"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "6503b77492fd7fcb9379bf73cd31035670e3c509"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.3"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+0"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "8175fc2b118a3755113c8e68084dc1a9e63c61ee"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.3"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pipe]]
git-tree-sha1 = "6842804e7867b115ca9de748a0cf6b364523c16d"
uuid = "b98c9c47-44ae-5843-9183-064241ee97a0"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.2"

[[deps.PlotThemes]]
deps = ["PlotUtils", "Statistics"]
git-tree-sha1 = "1f03a2d339f42dca4a4da149c7e15e9b896ad899"
uuid = "ccf2f8ad-2431-5c83-bf29-c5338b663b6a"
version = "3.1.0"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "5b7690dd212e026bbab1860016a6601cb077ab66"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.2"

[[deps.Plots]]
deps = ["Base64", "Contour", "Dates", "Downloads", "FFMPEG", "FixedPointNumbers", "GR", "JLFzf", "JSON", "LaTeXStrings", "Latexify", "LinearAlgebra", "Measures", "NaNMath", "Pkg", "PlotThemes", "PlotUtils", "Preferences", "Printf", "REPL", "Random", "RecipesBase", "RecipesPipeline", "Reexport", "RelocatableFolders", "Requires", "Scratch", "Showoff", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "UUIDs", "UnicodeFun", "Unzip"]
git-tree-sha1 = "dadd6e31706ec493192a70a7090d369771a9a22a"
uuid = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
version = "1.37.2"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PyBraket]]
deps = ["AWS", "Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "MicroMamba", "PythonCall", "StructTypes"]
git-tree-sha1 = "362553bc151177fbcbf71efe9e13221ba34d73b9"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.1.0"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "10b3f7d8e91b55754f6e614496104cc74ebd49fb"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.7"

[[deps.Qt5Base_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Fontconfig_jll", "Glib_jll", "JLLWrappers", "Libdl", "Libglvnd_jll", "OpenSSL_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libxcb_jll", "Xorg_xcb_util_image_jll", "Xorg_xcb_util_keysyms_jll", "Xorg_xcb_util_renderutil_jll", "Xorg_xcb_util_wm_jll", "Zlib_jll", "xkbcommon_jll"]
git-tree-sha1 = "0c03844e2231e12fda4d0086fd7cbe4098ee8dc5"
uuid = "ea2cea3b-5b76-57ae-a6ef-0a8af62496e1"
version = "5.15.3+2"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "261dddd3b862bd2c940cf6ca4d1c8fe593e457c8"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.3"

[[deps.RecipesPipeline]]
deps = ["Dates", "NaNMath", "PlotUtils", "RecipesBase", "SnoopPrecompile"]
git-tree-sha1 = "e974477be88cb5e3040009f3767611bc6357846f"
uuid = "01d81517-befc-4cb6-b9ec-a95719d0359c"
version = "0.6.11"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "c02bd3c9c3fc8463d3591a62a378f90d2d8ab0f3"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.17"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SnoopPrecompile]]
deps = ["Preferences"]
git-tree-sha1 = "e760a70afdcd461cf01a575947738d359234665c"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.3"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "a4ada03f999bd01b3a25dcaa30b2d929fe537e00"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.1.0"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "6954a456979f23d05085727adb17c4551c19ecd1"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.12"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+6"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "94f38103c984f89cf77c402f2a68dbd870f8165f"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.11"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.Unzip]]
git-tree-sha1 = "ca0969166a028236229f63514992fc073799bb78"
uuid = "41fe7b60-77ed-43a1-b4f0-825fd5a5650d"
version = "0.2.0"

[[deps.Wayland_jll]]
deps = ["Artifacts", "EpollShim_jll", "Expat_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "ed8d92d9774b077c53e1da50fd81a36af3744c1c"
uuid = "a2964d1f-97da-50d4-b82a-358c7fce9d89"
version = "1.21.0+0"

[[deps.Wayland_protocols_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4528479aa01ee1b3b4cd0e6faef0e04cf16466da"
uuid = "2381bf8a-dfd0-557d-9999-79630e7b1b91"
version = "1.25.0+0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "93c41695bc1c08c46c5899f4fe06d6ead504bb73"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.10.3+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_libxkbfile_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "926af861744212db0eb001d9e40b5d16292080b2"
uuid = "cc61e674-0454-545c-8b26-ed2c68acab7a"
version = "1.1.0+4"

[[deps.Xorg_xcb_util_image_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "0fab0a40349ba1cba2c1da699243396ff8e94b97"
uuid = "12413925-8142-5f55-bb0e-6d7ca50bb09b"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll"]
git-tree-sha1 = "e7fd7b2881fa2eaa72717420894d3938177862d1"
uuid = "2def613f-5ad1-5310-b15b-b15d46f528f5"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_keysyms_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "d1151e2c45a544f32441a567d1690e701ec89b00"
uuid = "975044d2-76e6-5fbe-bf08-97ce7c6574c7"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_renderutil_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "dfd7a8f38d4613b6a575253b3174dd991ca6183e"
uuid = "0d47668e-0667-5a69-a72c-f761630bfb7e"
version = "0.3.9+1"

[[deps.Xorg_xcb_util_wm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "e78d10aab01a4a154142c5006ed44fd9e8e31b67"
uuid = "c22f9ab0-d5fe-5066-847c-f4bb1cd4e361"
version = "0.4.1+1"

[[deps.Xorg_xkbcomp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxkbfile_jll"]
git-tree-sha1 = "4bcbf660f6c2e714f87e960a171b119d06ee163b"
uuid = "35661453-b289-5fab-8a00-3d9160c6a3a4"
version = "1.4.2+4"

[[deps.Xorg_xkeyboard_config_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xkbcomp_jll"]
git-tree-sha1 = "5c8424f8a67c3f2209646d4425f3d415fee5931d"
uuid = "33bec58e-1273-512f-9401-5d533626f822"
version = "2.27.0+4"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e45044cd873ded54b6a5bac0eb5c971392cf1927"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.2+0"

[[deps.fzf_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "868e669ccb12ba16eaf50cb2957ee2ff61261c56"
uuid = "214eeab7-80f7-51ab-84ad-2988db7cef09"
version = "0.29.0+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.8.0+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.52.0+1"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"

[[deps.xkbcommon_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Wayland_jll", "Wayland_protocols_jll", "Xorg_libxcb_jll", "Xorg_xkeyboard_config_jll"]
git-tree-sha1 = "9ebfc140cc56e8c2156a15ceac2f0302e327ac0a"
uuid = "d8fb68d0-12a3-5cfd-a85a-d49703b185fd"
version = "1.4.1+0"
"""

# ╔═╡ Cell order:
# ╟─eefcfdb6-dc0f-4ec4-85a3-73bafc9e0177
# ╠═d928ee56-0f14-426c-b669-356627382f8f
# ╟─e00258a8-e04e-4806-85ad-1ef5c4476dad
# ╟─b5530b38-f3e1-4bd7-bf6e-b2052a44850b
# ╟─d18db1cb-58b8-4949-b80a-67f36768e59c
# ╠═608cf437-7493-494b-a4d7-1e852bcae8d9
# ╠═2c612fa4-1a8d-404a-8b3e-5e1907e20d84
# ╟─ac3b8437-7f21-4e36-97bd-5af10d0eaf40
# ╠═3ccc5bb1-16ec-4fd5-b82f-31da2734223e
# ╟─25274ab6-b0a2-485f-baee-3a8a23c23834
# ╠═55a3b85b-6d3c-43b9-9c89-5af3f5c57629
# ╟─52bf519d-806c-4d4c-915a-fa28be9b2fc2
# ╠═b3a750d1-7a2b-4de6-9e6c-166336ba6cec
# ╠═7127d624-fb0d-41b9-a8cd-6cae7d34d55f
# ╠═ab9771de-a268-4df8-811d-9310a12a7d79
# ╠═83b78b1a-3935-4ca7-88f6-7a15cc523591
# ╟─335e537b-c6f8-4c1b-a9b0-5e14c4f7323b
# ╠═256bb268-e2fc-4483-a6f7-4a76028fcf80
# ╟─9bfd35b5-82cf-4c5e-8006-a3b2de15598a
# ╠═20cfa5e8-d4ad-4720-9d27-f7c161ea09e3
# ╟─ac34f36b-9ede-4bf0-9120-a5e0253d6f64
# ╠═0508acef-1de0-42e4-9bbc-9127c2a162b5
# ╟─f584f456-c803-4fa8-99f5-cb9f87b13097
# ╠═ae77c39f-9f7e-4c45-8823-a16a38c33e0d
# ╟─cc46be99-41e5-4b30-a158-bd5c8c961247
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

export Gate, AngledGate, H, I, X, Y, Z, S, Si, T, Ti, V, Vi, CNot, Swap, ISwap, CV, CY, CZ, ECR, CCNot, CSwap, Unitary, Rx, Ry, Rz, PhaseShift, PSwap, XY, CPhaseShift, CPhaseShift00, CPhaseShift01, CPhaseShift10, XX, YY, ZZ, GPi, GPi2, MS, PRx, U, GPhase
"""
    Gate <: QuantumOperator

Abstract type representing a quantum gate.
"""
abstract type Gate <: QuantumOperator end
StructTypes.StructType(::Type{Gate}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Gate}) = (angledgate=AngledGate, h=H, i=I, x=X, y=Y, z=Z, s=S, si=Si, t=T, ti=Ti, v=V, vi=Vi, cnot=CNot, swap=Swap, iswap=ISwap, cv=CV, cy=CY, cz=CZ, ecr=ECR, ccnot=CCNot, cswap=CSwap, unitary=Unitary, rx=Rx, ry=Ry, rz=Rz, phaseshift=PhaseShift, pswap=PSwap, xy=XY, cphaseshift=CPhaseShift, cphaseshift00=CPhaseShift00, cphaseshift01=CPhaseShift01, cphaseshift10=CPhaseShift10, xx=XX, yy=YY, zz=ZZ, gpi=GPi, gpi2=GPi2, ms=MS, prx=PRx, u=U, gphase=GPhase)

"""
    AngledGate{NA} <: Gate

Parametric type representing a quantum gate with `NA` `angle` parameters.
"""
abstract type AngledGate{NA} <: Gate end
StructTypes.StructType(::Type{AngledGate}) = StructTypes.AbstractType()
n_angles(::Type{<:Gate}) = 0
n_angles(::Type{<:AngledGate{N}}) where {N} = N
n_angles(g::G) where {G<:Gate} = n_angles(G)

for gate_def in (
                 (:Rx, :(IR.Rx), :1, :1, ("Rx(ang)",), "rx", :0, :1),
                 (:Ry, :(IR.Ry), :1, :1, ("Ry(ang)",), "ry", :0, :1),
                 (:Rz, :(IR.Rz), :1, :1, ("Rz(ang)",), "rz", :0, :1),
                 (:PSwap, :(IR.PSwap), :1, :2, ("PSWAP(ang)", "PSWAP(ang)"), "pswap", :0, :2),
                 (:PhaseShift, :(IR.PhaseShift), :1, :1, ("PHASE(ang)",), "phaseshift", :0, :1),
                 (:CPhaseShift, :(IR.CPhaseShift), :1, :2, ("C", "PHASE(ang)"), "cphaseshift", :1, :1),
                 (:CPhaseShift00, :(IR.CPhaseShift00), :1, :2, ("C", "PHASE00(ang)"), "cphaseshift00", :1, :1),
                 (:CPhaseShift01, :(IR.CPhaseShift01), :1, :2, ("C", "PHASE01(ang)"), "cphaseshift01", :1, :1),
                 (:CPhaseShift10, :(IR.CPhaseShift10), :1, :2, ("C", "PHASE10(ang)"), "cphaseshift10", :1, :1),
                 (:XX, :(IR.XX), :1, :2, ("XX(ang)", "XX(ang)"), "xx", :0, :2),
                 (:XY, :(IR.XY), :1, :2, ("XY(ang)", "XY(ang)"), "xy", :0, :2),
                 (:YY, :(IR.YY), :1, :2, ("YY(ang)", "YY(ang)"), "yy", :0, :2),
                 (:ZZ, :(IR.ZZ), :1, :2, ("ZZ(ang)", "ZZ(ang)"), "zz", :0, :2),
                 (:GPi, :(IR.GPi), :1, :1, ("GPi(ang)",), "gpi", :0, :1),
                 (:GPi2, :(IR.GPi2), :1, :1, ("GPi2(ang)",), "gpi2", :0, :1),
                 (:MS, :(IR.MS), :3, :2, ("MS(ang)", "MS(ang)"), "ms", :0, :2),
                 (:U, :(IR.UndefinedGate), :3, :1, ("U(ang)",), "U", :0, :1),
                 (:PRx, :(IR.UndefinedGate), :2, :1, ("PRx(ang)", "PRx(ang)"), "prx", :0, :1),
                )
    G, IR_G, n_angle, qc, c, lab_str, n_ctrls, n_targs = gate_def
    @eval begin
        @doc """
            $($G) <: AngledGate{$($n_angle)}
            $($G)(angles) -> $($G)
        
        $($G) gate.
        """
        struct $G <: AngledGate{$n_angle}
            angle::NTuple{$n_angle, Union{Real, FreeParameter}}
            $G(angle::T) where {T<:NTuple{$n_angle, Union{Real, FreeParameter}}} = new(angle)
        end
        chars(::Type{$G}) = $c
        ir_typ(::Type{$G}) = $IR_G
        qubit_count(::Type{$G}) = $qc
        label(::Type{$G}) = $lab_str
        n_controls(g::$G) = Val($n_ctrls)
        n_targets(g::$G) = Val($n_targs)
        n_controls(::Type{$G}) = Val($n_ctrls)
        n_targets(::Type{$G}) = Val($n_targs)
    end
end

for gate_def in (
                 (:H, :(IR.H), :1, ("H",), "h", :0, :1),
                 (:I, :(IR.I), :1, ("I",), "i", :0, :1),
                 (:X, :(IR.X), :1, ("X",), "x", :0, :1),
                 (:Y, :(IR.Y), :1, ("Y",), "y", :0, :1),
                 (:Z, :(IR.Z), :1, ("Z",), "z", :0, :1),
                 (:S, :(IR.S), :1, ("S",), "s", :0, :1),
                 (:Si, :(IR.Si), :1, ("Si",), "si", :0, :1),
                 (:T, :(IR.T), :1, ("T",), "t", :0, :1),
                 (:Ti, :(IR.Ti), :1, ("Ti",), "ti", :0, :1),
                 (:V, :(IR.V), :1, ("V",), "v", :0, :1),
                 (:Vi, :(IR.Vi), :1, ("Vi",), "vi", :0, :1),
                 (:CNot, :(IR.CNot), :2, ("C", "X"), "cnot", :1, :1),
                 (:Swap, :(IR.Swap), :2, ("SWAP", "SWAP"), "swap", :0, :2),
                 (:ISwap, :(IR.ISwap), :2, ("ISWAP", "ISWAP"), "iswap", :0, :2),
                 (:CV, :(IR.CV), :2, ("C", "V"), "cv", :1, :1),
                 (:CY, :(IR.CY), :2, ("C", "Y"), "cy", :1, :1),
                 (:CZ, :(IR.CZ), :2, ("C", "Z"), "cz", :1, :1),
                 (:ECR, :(IR.ECR), :2, ("ECR", "ECR"), "ecr", :0, :2),
                 (:CCNot, :(IR.CCNot), :3, ("C", "C", "X"), "ccnot", :2, :1),
                 (:CSwap, :(IR.CSwap), :3, ("C", "SWAP", "SWAP"), "cswap", :1, :2),
                )
    G, IR_G, qc, c, lab_str, n_ctrls, n_targs = gate_def
    @eval begin
        @doc """
            $($G) <: Gate
            $($G)() -> $($G)
        
        $($G) gate.
        """
        struct $G <: Gate end
        chars(::Type{$G}) = $c
        ir_typ(::Type{$G}) = $IR_G
        qubit_count(::Type{$G}) = $qc
        label(::Type{$G}) = $lab_str
        n_controls(g::$G) = Val($n_ctrls)
        n_targets(g::$G) = Val($n_targs)
        n_controls(::Type{$G}) = Val($n_ctrls)
        n_targets(::Type{$G}) = Val($n_targs)
    end
end
(::Type{G})(x::Tuple{}) where {G<:Gate} = G()
(::Type{G})(x::Tuple{}) where {G<:AngledGate} = throw(ArgumentError("angled gate must be constructed with at least one angle."))
(::Type{G})(x::AbstractVector) where {G<:AngledGate} = G(x...)
(::Type{G})(angle::T) where {G<:AngledGate{1}, T<:Union{Real, FreeParameter}} = G((angle,))
(::Type{G})(angle1::T1, angle2::T2) where {T1<:Union{Real, FreeParameter}, T2<:Union{Real, FreeParameter}, G<:AngledGate{2}} = G((angle1, angle2,))
(::Type{G})(angle1::T1, angle2::T2, angle3::T3) where {T1<:Union{Real, FreeParameter}, T2<:Union{Real, FreeParameter}, T3<:Union{Real, FreeParameter}, G<:AngledGate{3}} = G((angle1, angle2, angle3,))
qubit_count(g::G) where {G<:Gate}  = qubit_count(G)
angles(g::G) where {G<:Gate}       = ()
angles(g::AngledGate{N}) where {N} = g.angle
chars(g::G) where {G<:Gate}        = map(char->replace(string(char), "ang"=>join(string.(angles(g)), ", ")), chars(G))
ir_typ(g::G) where {G<:Gate}       = ir_typ(G)
label(g::G)  where {G<:Gate}       = label(G)
ir_str(g::G) where {G<:AngledGate} = label(g) * "(" * join(string.(angles(g)), ", ") * ")"
ir_str(g::G) where {G<:Gate}       = label(g)
targets_and_controls(g::G, target::QubitSet) where {G<:Gate} = targets_and_controls(n_controls(g), n_targets(g), target)
targets_and_controls(::Val{0}, ::Val{1}, target::QubitSet)           = ((), target[1])
targets_and_controls(::Val{0}, ::Val{N}, target::QubitSet) where {N} = ((), collect(target))
targets_and_controls(::Val{1}, ::Val{1}, target::QubitSet)           = (target[1], target[2])
targets_and_controls(::Val{1}, ::Val{N}, target::QubitSet) where {N} = (target[1], target[2:end])
targets_and_controls(::Val{NC}, ::Val{1}, target::QubitSet) where {NC} = (target[1:NC], target[NC+1])
targets_and_controls(::Val{NC}, ::Val{NT}, target::QubitSet) where {NC, NT} = (target[1:NC], target[NC+1:NC+NT])
function ir(g::G, target::QubitSet, ::Val{:JAQCD}; kwargs...) where {G<:Gate}
    t_c = targets_and_controls(g, target)
    if isempty(t_c[1])
        return ir_typ(g)(angles(g)..., t_c[2], label(g))
    else
        return ir_typ(g)(angles(g)..., t_c[1], t_c[2], label(g))
    end
end
function ir(g::G, target::QubitSet, ::Val{:OpenQASM}; serialization_properties=OpenQASMSerializationProperties()) where {G<:Gate}
    t = format_qubits(target, serialization_properties)
    ir_string = ir_str(g) * " " * t
    if occursin("#pragma", ir_string)
        return ir_string
    else
        return ir_string * ";"
    end
end
"""
    Unitary <: Gate
    Unitary(matrix::Matrix{ComplexF64}) -> Unitary

Arbitrary unitary gate.
"""
struct Unitary <: Gate
    matrix::Matrix{ComplexF64}
    Unitary(matrix::Matrix{<:Number}) = new(ComplexF64.(matrix))
end
Unitary(mat::Vector{Vector{Vector{T}}}) where {T} = Unitary(complex_matrix_from_ir(mat))
Base.:(==)(u1::Unitary, u2::Unitary) = u1.matrix == u2.matrix
qubit_count(g::Unitary) = convert(Int, log2(size(g.matrix, 1)))
chars(g::Unitary)       = ntuple(i->"U", qubit_count(g))
ir_typ(::Type{Unitary}) = IR.Unitary
label(::Type{Unitary})  = "unitary"
n_targets(g::Unitary)   = qubit_count(g)
n_controls(g::Unitary)  = 0

ir_str(g::Unitary) = "#pragma braket unitary(" * format_matrix(g.matrix) * ")"
function ir(g::Unitary, target::QubitSet, ::Val{:JAQCD}; kwargs...)
    mat = complex_matrix_to_ir(g.matrix) 
    return IR.Unitary(collect(target), mat, "unitary")
end

"""
    GPhase <: Gate
    GPhase(ϕ::Union{Real, FreeParameter}) -> GPhase

Global phase gate.
"""
struct GPhase <: Gate
    angle::NTuple{1, Union{Real, FreeParameter}}
    GPhase(angle::T) where {T<:NTuple{1, Union{Real, FreeParameter}}} = new(angle)
end
Base.:(==)(g1::GPhase, g2::GPhase) = g1.angle == g2.angle
qubit_count(g::GPhase) = 0
chars(g::GPhase)       = ("gphase(ang)",)
ir_typ(::Type{GPhase}) = IR.UndefinedGate
label(::Type{GPhase})  = "gphase"
n_targets(g::GPhase)   = 0 
n_controls(g::GPhase)  = 0
ir(g::GPhase, target::QubitSet, ::Val{:JAQCD}; kwargs...) = throw(MethodError(ir, (g, target, Val(:JAQCD))))
targets_and_controls(g::GPhase, target::QubitSet) = ((), tuple(target...)) 
StructTypes.StructType(::Type{<:Gate}) = StructTypes.Struct()

Parametrizable(g::AngledGate) = Parametrized()
Parametrizable(g::Gate)       = NonParametrized()
parameters(g::AngledGate)     = collect(filter(a->a isa FreeParameter, angles(g)))
parameters(g::Gate)           = FreeParameter[] 
bind_value!(g::G, params::Dict{Symbol, <:Number}) where {G<:Gate} = bind_value!(Parametrizable(g), g, params)
bind_value!(::NonParametrized, g::G, params::Dict{Symbol, <:Number}) where {G<:Gate} = g
function bind_value!(::Parametrized, g::G, params::Dict{Symbol, <:Number}) where {G<:AngledGate}
    new_angles = map(angles(g)) do angle
        angle isa FreeParameter || return angle
        return get(params, angle.name, angle)
    end
    return G(new_angles...)
end
ir(g::Gate, target::Int, args...) = ir(g, QubitSet(target), args...)
Base.copy(g::G) where {G<:Gate} = G((copy(getproperty(g, fn)) for fn in fieldnames(G))...)
Base.copy(g::G) where {G<:AngledGate} = G(angles(g))

using Braket, Braket.Observables, Braket.IR, Test, JSON3
using Braket: ResultTypeValue


exact_results = [(Probability(0), [0.5, 0.5]),
                 (StateVector(), [complex(0.70710678, 0), 0, 0, complex(0.70710678, 0)]),
                 (Expectation(Braket.Observables.Y(), 0), 0.0),
                 (Variance(Braket.Observables.Y(), 0), 0.1),
                 (Amplitude("00"), Dict("00"=>complex(0.70710678, 0))),
                 (AdjointGradient(2.0 * Observables.X() * Observables.X(), [0, 1], ["p_1", "p_2"]), Dict(:expectation=>0.1, :gradient=>Dict("p_1"=>0.2, "p_2"=>0.3)))]

zero_shots_result(task_mtd, add_mtd) = Braket.GateModelTaskResult(
    Braket.header_dict[Braket.GateModelTaskResult],
    nothing,
    nothing,
    map(r->ResultTypeValue(ir(r[1], Val(:JAQCD)), r[2]), exact_results),
    [0,1],
    task_mtd,
    add_mtd,
)

non_zero_shots_result(task_mtd, add_mtd) = Braket.GateModelTaskResult(
    Braket.header_dict[Braket.GateModelTaskResult],
    nothing,
    Dict("011000"=>0.9999999999999982),
    nothing,
    collect(0:5),
    task_mtd,
    add_mtd)

@testset "GateModelQuantumTaskResult" begin
    c = CNot(Circuit(), 0, 1)
    action = Braket.Program(c)
    @testset for (shots, result) in zip([0, 100], [zero_shots_result, non_zero_shots_result])
        task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", shots, "arn1", nothing, nothing, nothing, nothing, nothing)
        additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
        r = result(task_metadata, additional_metadata)
        g = Braket.format_result(r)
        @test g isa Braket.GateModelQuantumTaskResult
        @test sprint(show, g) == "GateModelQuantumTaskResult\n"
        if shots == 0
            for er in exact_results
                @test g[er[1]] == er[2]
            end
        end
    end
    task_metadata = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", 0, "arn1", nothing, nothing, nothing, nothing, nothing)
    additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    result = Braket.GateModelQuantumTaskResult(task_metadata, JSON3.read(JSON3.write(additional_metadata), Braket.AdditionalMetadata), nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    @test JSON3.read("{\"task_metadata\": $(JSON3.write(task_metadata)), \"additional_metadata\": $(JSON3.write(additional_metadata))}", Braket.GateModelQuantumTaskResult) == result
end

@testset "shots>0 results computation" begin
    measurements = [
        [0, 0, 1, 0],
        [1, 1, 1, 1],
        [1, 0, 0, 1],
        [0, 0, 1, 0],
        [1, 1, 1, 1],
        [0, 1, 1, 1],
        [0, 0, 0, 1],
        [0, 1, 1, 1],
        [0, 0, 0, 0],
        [0, 0, 0, 1],
    ]
    mat = [1 0; 0 -1]
    ho = Braket.Observables.HermitianObservable(mat)
    samp = ir(Braket.Sample(ho, Int[2]), Val(:JAQCD))
    action = Braket.Program(Braket.header_dict[Braket.Program],
                            [Braket.IR.CNot(0, 1, "cnot"), Braket.IR.CNot(2, 3, "cnot")],
                            [Braket.IR.Probability([1], "probability"),
                             Braket.IR.Expectation(["z"], nothing, "expectation"),
                             Braket.IR.Variance(["x", "x"], [0, 2], "variance"),
                             samp,
                             Braket.IR.Sample(["z"], [1], "sample"),
                             Braket.IR.Sample(["x", "y"], [1, 2], "sample"),
                             Braket.IR.Sample(["z"], nothing, "sample"),
                            ],
                            [])
    task_metadata_shots = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", length(measurements), "arn1", nothing, nothing, nothing, nothing, nothing)
    additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    task_result = Braket.GateModelTaskResult(Braket.header_dict[Braket.GateModelTaskResult],
        measurements,
        nothing,
        nothing,
        [0, 1, 2, 3],
        task_metadata_shots,
        additional_metadata,
    )
    quantum_task_result = Braket.format_result(task_result)
    @test quantum_task_result.values[1] ≈ [0.6, 0.4]
    @test quantum_task_result.values[2] ≈ [0.4, 0.2, -0.2, -0.4]
    @test quantum_task_result.values[3] ≈ 1.11111111111
    @test quantum_task_result.values[4] ≈ [1.0, 1.0, -1.0, 1.0, 1.0, 1.0, -1.0, 1.0, -1.0, -1.0]
    @test quantum_task_result.result_types[1].type == Braket.IR.Probability([1], "probability")
    @test quantum_task_result.result_types[2].type == Braket.IR.Expectation(["z"], nothing, "expectation")
    

    action = Braket.Program(Braket.header_dict[Braket.Program],
                            [Braket.IR.H(0, "h"), Braket.IR.H(1, "h"), Braket.IR.H(2, "h"), Braket.IR.H(3, "h")],
                            [Braket.IR.Sample("z", [1], "sample"),
                             Braket.IR.Sample(["x", "y"], [1, 2], "sample"),
                             Braket.IR.Sample("z", nothing, "sample"),
                            ],
                            [])
    task_metadata_shots = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", length(measurements), "arn1", nothing, nothing, nothing, nothing, nothing)
    additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
    task_result = Braket.GateModelTaskResult(Braket.header_dict[Braket.GateModelTaskResult],
        measurements,
        nothing,
        nothing,
        [0, 1, 2, 3],
        task_metadata_shots,
        additional_metadata,
    )
    quantum_task_result = Braket.format_result(task_result)
    @test quantum_task_result.values[1] ≈ [1, -1, 1, 1, -1, -1, 1, -1, 1, 1]
    @test quantum_task_result.values[2] ≈ [-1, 1, 1, -1, 1, 1, 1, 1, 1, 1]
    @test quantum_task_result.values[3] ≈ [[1, -1, -1, 1, -1, 1, 1, 1, 1, 1], [1, -1, 1, 1, -1, -1, 1, -1, 1, 1], [-1, -1, 1, -1, -1, -1, 1, -1, 1, 1], [1, -1, -1, 1, -1, -1, -1, -1, 1, -1]] 

    @testset "result without measurements or measurementProbabilities" begin
        task_metadata_shots = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", length(measurements), "arn1", nothing, nothing, nothing, nothing, nothing)
        additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
        task_result = Braket.GateModelTaskResult(Braket.header_dict[Braket.GateModelTaskResult],
            nothing,
            nothing,
            nothing,
            [0, 1, 2, 3],
            task_metadata_shots,
            additional_metadata,
        )
        @test_throws ErrorException Braket.format_result(task_result)
    end
    @testset "bad result type in results for shots > 0" begin
        action = Braket.Program(Braket.header_dict[Braket.Program], [Braket.IR.CNot(0, 1, "cnot"), Braket.IR.CNot(2, 3, "cnot")], [Braket.IR.DensityMatrix([1,3], "densitymatrix")], [])
        task_metadata_shots = Braket.TaskMetadata(Braket.header_dict[Braket.TaskMetadata], "task_arn", length(measurements), "arn1", nothing, nothing, nothing, nothing, nothing)
        additional_metadata = Braket.AdditionalMetadata(action, nothing, nothing, nothing, nothing, nothing, nothing, nothing, nothing)
        task_result = Braket.GateModelTaskResult(Braket.header_dict[Braket.GateModelTaskResult],
            measurements,
            nothing,
            nothing,
            [0, 1, 2, 3],
            task_metadata_shots,
            additional_metadata,
        )
        @test_throws ErrorException Braket.format_result(task_result)
    end
end

### A Pluto.jl notebook ###
# v0.19.22

using Markdown
using InteractiveUtils

# ╔═╡ 23aaba4e-3342-4581-a6bf-b039c390062e
using OrderedCollections, Braket, BraketSimulator, PyBraket, PyBraket.PythonCall, CondaPkg

# ╔═╡ ff4fad96-1970-4fb9-a43a-df02cd5dc643
using Plots

# ╔═╡ 2f49c108-9d9f-11ed-1a79-eb966fa5a322
md"""
# Quantum Chemistry Simulation with Amazon Braket and VQE
"""

# ╔═╡ 2e2c9fce-5d4f-411c-9951-0b5909111155
md"""
In this example, we show how to implement the variational quantum eigensolver using `Braket.jl` and use it to find the groundstate of a simple molecular Hamiltonian with the assistance of the Braket local simulator.

**Note**: This notebook uses the Python software [`pyscf`](https://pyscf.org/) to generate the molecular Hamiltonian and apply a Jordan-Wigner transformation to it.
If you are using OSX, you may need to set the environment variable `KMP_DUPLICATE_LIB_OK=true` in order to avoid `pyscf` segfaulting. See [this GitHub issue](https://github.com/dmlc/xgboost/issues/1715) for more information. You can set this environment variable in this script by adding a new cell with `ENV["KMP_DUPLICATE_LIB_OK"] = true`.
"""

# ╔═╡ 6ada7712-6f03-4f56-8254-085d878d61fc
md"""
## Formulation of the problem

In computational chemistry, we are commonly interested in finding the ground-state energy (i.e., lowest energy) of a molecule for a given configuration of atomic positions. This can be done by finding the smallest eigenvalue(s) and corresponding eigenstate(s) of the molecular Hamiltonian.

### Generating the molecular Hamiltonian

The Hamiltonian for a generic molecule can be written:

```math
H_{full} = - \frac{1}{2}\sum_i \nabla_i^2 - \sum_I \frac{\nabla_I^2}{2 M_I} - \sum_{i,I} \frac{Z_I}{|\mathbf{r}_i - \mathbf{R}_I|} + \frac{1}{2} \sum_{i \neq j} \frac{1}{|\mathbf{r}_i - \mathbf{r}_j|} + \frac{1}{2} \sum_{I \neq J} \frac{1}{|\mathbf{R}_I - \mathbf{R}_J|}
```

where $i$ labels the electrons and $I$ the nuclei. $\mathbb{r}_i$ denotes the $i$-th electron's position and $\mathbb{R}_I$ the position of the $I$-th nucleus. $Z_I$ is the $I$-th nuclear charge and $M_I$ the $I$-th nuclear mass.

The first two terms in $H_{full}$ represent the electronic and nuclear kinetic energies, and the others are Coulomb interactions: between the nuclei and electrons, then among the electrons, then among the nuclei.

Since our focus is on the **electronic** structure (which orbitals the electrons occupy), we'll use the [Born-Oppenheimer approximation](https://en.wikipedia.org/wiki/Born%E2%80%93Oppenheimer_approximation). The approximation is based on the fact that nuclei are over 1000x heavier than an electron and thus their kinetic energy contributes negligibly to the final solution and we can consider their positions fixed. This allows us to simplify $H_{full}$:

```math
H_{B-O} = - \frac{1}{2}\sum_i \nabla_i^2 - \sum_{i,I} \frac{Z_I}{|\mathbf{r}_i - \mathbf{R}_I|} + \frac{1}{2} \sum_{i \neq j} \frac{1}{|\mathbf{r}_i - \mathbf{r}_j|}
```

### Second quantization

**Note**: in this subsection, we give a brief overview of [second quantization](https://en.wikipedia.org/wiki/Second_quantization). For a more in-depth treatment, consider consulting a quantum mechanics or statistical physics textbook.

Finding the groundstate of this simplified Hamiltonian can be done, but there are further simplifications we can make which will make the problem significantly more tractable. We will rewrite this Hamiltonian, which is after all a linear operator, in a new basis of single electron *spin orbitals* $\{ \phi_p(\mathbf{x}_i) \}$, where $\mathbf{x}_i = (\mathbf{r}_i, s_i)$ represents the position and spin of the $i$-th electron.

The many-electron wavefunction is expressed as a [Slater determinant](https://en.wikipedia.org/wiki/Slater_determinant) of these single-electron basis functions, i.e., as an antisymmetrized product, so that the electrons automatically satisfy the [Pauli exclusion principle](https://en.wikipedia.org/wiki/Pauli_exclusion_principle). While the total number of single-electron basis functions, $M$, is typically larger than the total number of electrons, $N$, in the molecule, the electrons can only occupy $N < M$ of these orbitals in a Slater determinant. In other words, a Slater determinant contains only occupied orbitals. 

Since any Slater determinant of the basis functions is uniquely determined by which orbitals are occupied, a Slater determinant can be represented in an abstract vector space, called the Fock space, by an *occupation number vector* $|f\rangle = |f_{M-1}f_{M-2}\ldots f_1 f_0\rangle$ where each $f_i$ is either 0 or 1 depending on whether the $i$-th orbital is unoccupied (0) or occupied (1) in the Slater determinant.

Next, we introduce a set of operators $\{a_p, a^\dagger_p\}$, called the fermion annihilation and creation operators respectively, corresponding to each of the basis functions $\{ \phi_p(\mathbf{x}_i) \}$. These operators satisfy the [anticommutation](https://mathworld.wolfram.com/Anticommutator.html) relations:

```math
\begin{align*}
\{a_p, a_q\} =& 0 \\
\{a^\dagger_p, a^\dagger_q\} =& 0 \\
\{a_p, a^\dagger_q\} =& \delta_{p,q} \\
\end{align*}
```

Where $\delta_{p,q}$ is the [Kronecker delta](https://en.wikipedia.org/wiki/Kronecker_delta), which is 1-valued if and only if $p = q$, and 0-valued otherwise. These relations will enforce the Fermi-Dirac statistics of the electrons.

Using these operators, we can rewrite $H_{B-O}$ in second-quantized form. We define:

```math
\begin{align*}
h_{pq} =& \int d\mathbf{x}\phi_p^*(\mathbf{x}) \left( -\frac{\nabla^2}{2} - \sum_I \frac{Z_I}{|\mathbf{r} - \mathbf{R}_I|} \right) \phi_q(\mathbf{x}) \\
h_{pqrs} =& \int d\mathbf{x}_1 d\mathbf{x}_2 \frac{\phi_p^*(\mathbf{x}_1) \phi_q^*(\mathbf{x}_2)\phi_s(\mathbf{x}_1)\phi_r(\mathbf{x}_2)}{|\mathbf{r}_1 - \mathbf{r}_2|} \\
\end{align*}
```

And finally write the second quantized Hamiltonian:

```math
H_{sq} = \sum_{p,q} h_{pq} a_p^\dagger a_q + \frac{1}{2} \sum_{p,q,r,s} h_{pqrs} a_p^\dagger a_q^\dagger a_r a_s
```

This $H$ includes only 1- and 2-electron terms. In fact, higher order terms do contribute but can often be neglected, so we have made another approximation when writing down $H_{sq}$.

For a more detailed derivation of how this $H_{sq}$ is derived from $H_{B-O}$, see .

### Basis sets

So how does one decide on the specific $\{ \phi_p(\mathbb{x}_i) \}$? In the quantum chemistry literature, there are quite a few varieties that have been developed:

  - [STO-$n$G](https://en.wikipedia.org/wiki/STO-nG_basis_sets) (also called *minimal basis sets*)
  - [Split-valence](https://en.wikipedia.org/wiki/Basis_set_(chemistry))
  - [Correlation-consistent](https://en.wikipedia.org/wiki/Basis_set_(chemistry))
  - [Polarization-consistent](https://en.wikipedia.org/wiki/Basis_set_(chemistry))
  - [Plane-wave](https://en.wikipedia.org/wiki/Basis_set_(chemistry))

## Finding the groundstate Slater determinant: the Hartree-Fock method

The [Hartree-Fock](https://en.wikipedia.org/wiki/Hartree%E2%80%93Fock_method) method is a technique to find the most-dominant Slater determinant that best-approximates the groundstate wavefunction by optimizing the *spatial* form of the spin orbitals $\{\phi_p(\mathbb{x})\}$ in a *self consistent* fashion. The Slater determinant generated by the optimized spin orbitals (also known as canonical orbitals), which are computed by the HF method, is used as the reference state for post Hartree-Fock methods that try to correct for some of the approximations in the HF method itself.

There are a variety of post Hartree-Fock (post-HF) methods employed in classical computational chemistry to improve upon the accuracy of a simple HF computation to varying degrees [1], e.g.,

* [Configuration interaction and Full Configuration Interaction](https://en.wikipedia.org/wiki/Configuration_interaction)
* [Multi-configurational self-consistent field](https://en.wikipedia.org/wiki/Multi-configurational_self-consistent_field)
* [Coupled cluster](https://en.wikipedia.org/wiki/Coupled_cluster)
* [Perturbation theory](https://en.wikipedia.org/wiki/M%C3%B8ller%E2%80%93Plesset_perturbation_theory)

## Mapping the problem to a quantum computer

So far, the entire discussion has concerned *fermions*. We now want to map these fermionic states to *qubits* so that we can simulate them on a quantum computer. To do this, we will use the [Jordan-Wigner transformation](https://en.wikipedia.org/wiki/Jordan%E2%80%93Wigner_transformation). This is the simplest among many techniques for achieving the same end. In the Jordan-Wigner transformation, we store the occupation number of an orbital $f_i$ in the $i$-th qubit as either $|0\rangle$ or $|1\rangle$ depending on whether the orbital is unoccupied or occupied respectively. Correspondingly, the fermionic annihilation and creation operators are mapped to the qubit operators as:

```math
\begin{align*}
a_p =& Q_p \otimes Z_{p-1} \otimes \ldots \otimes Z_0 \\
a^\dagger_p &= Q^\dagger_p \otimes Z_{p-1} \otimes \ldots \otimes Z_0 \\
Q &= |0\rangle\langle 1 | \\
Q^\dagger &= |1\rangle\langle 0 | \\
Z &= |0\rangle\langle 0| - |1\rangle\langle 1| \\
\end{align*}
```

In this encoding, the occupation of an orbital is stored locally, in a single qubit, but the parity is stored non-locally. This makes the Jordan-Wigner transformation not as efficient compared to other encoding techniques, e.g., Bravyi-Kitaev encoding, but for small systems with a few qubits, the efficiency gap is not significant.

## Variational Quantum Eigensolver

Now that we have an approximation of the Hamiltonian that can be represented on a quantum computer, we need a way to find or at least approximate its groundstate (lowest-lying eigenvector). The variational quantum eigensolver (VQE) is a NISQ (noisy intermediate-scale quantum) algorithm, which uses the quantum computer only for a classically intractable subroutine and which has been shown to be robust against noise [2,4] and capable of finding ground-state energies of small molecules using low-depth quantum circuits.

VQE is based on the Raleigh-Ritz variational principle: for a trial wavefunction $|\psi(\vec{\theta})\rangle$, parameterized by a vector of parameters $\vec{\theta}$, for a system with Hamiltonian $H$ with lowest eigenvalue $E_0$,

```math
\left\langle \psi(\vec{\theta}) \right| H \left| \psi(\vec{\theta}) \right\rangle \geq E_0
```

So to approximate $E_0$ we have to optimize $\vec{\theta}$. We can prepare the state $|\psi(\vec{\theta})\rangle$ using some unitary circuit $U(\vec{\theta})$ also parametrized by $\vec{\theta}$:

```math
|\psi(\vec{\theta})\rangle = U(\vec{\theta}) | \psi_{ref} \rangle
```

Where $|\psi_{ref}\rangle$ is some reference state, for example a Hartree-Fock state. We use the quantum computer to prepare $|\psi(\vec{\theta})\rangle$ and compute $\left\langle \psi(\vec{\theta}) \right| H \left| \psi(\vec{\theta}) \right\rangle$, and the classical computer to update $\vec{\theta}$.

How to choose the gates in $U$? This is up to us, and an ongoing area of research, but a popular option is to use the unitary coupled cluster ansatz, truncating it to only consider *single* and *double* excitations (seem familar from our discussion of $H_{sq}$ above?). This ansatz is called UCCSD.

## UCCSD ansatz

The unitary coupled cluster (UCC) method is an extension of the coupled-cluster (CC) method, which is one of the most popular post-HF methods [2]. In the UCC method, the parameterized trial function $U(\vec{\theta})$ is given by:

```math
\begin{align*}
U(\vec{\theta}) =& \exp\{T - T^\dagger\} \\
T &= \sum_{i=1}^{N} T_i \\
T_1 &= \sum_{i \in virt, \alpha \in occ} \theta_{i\alpha} a^\dagger_i a_\alpha \\
T_2 &= \sum_{i,j \in virt, \alpha, \beta \in occ} \theta_{ij\alpha\beta} a^\dagger_ia^\dagger_j a_\alpha a_\beta \\
\end{align*}
```
Where $virt$ is the set of **unoccupied** orbitals and $occ$ is the set of **occupied** orbitals. $T_1$ is the sum of all **single** excitations and $T_2$ is the sum of all **double** excitations (and further with $T_3$, $T_4$, had we included them). By examining them closely you can see each term in $T_1$ excites **one** electron from an occupied orbital into an unoccupied one, and each term in $T_2$ excites **two** electrons.

## Molecular Hamiltonian for the hydrogen molecule

For simplicity, we will use the minimal basis set STO-3G for the $H_2$ molecule, which includes only the $\{1s\}$ orbital for each atom. Since each atom contributes one spin-orbital, and there are 2 possible spins for each orbital (up or down), this leads to a total of 4 single electron orbitals for $H_2$ in the STO-3G basis set [2]:

```math
|1s_{A\uparrow}\rangle, |1s_{A\downarrow}\rangle, |1s_{B\uparrow}\rangle, |1s_{B\downarrow}\rangle
```

where the subscripts $A$ and $B$ label the atom and $\uparrow, \downarrow$ label the electron spin respectively. These can be rewritten into the molecular orbital basis:

```math
\begin{align*}
|\sigma_{g\uparrow}\rangle &= \frac{1}{\sqrt{2}} \left(|1s_{A\uparrow}\rangle + |1s_{B\uparrow}\rangle\right) \\
|\sigma_{g\downarrow}\rangle &= \frac{1}{\sqrt{2}} \left(|1s_{A\downarrow}\rangle + |1s_{B\downarrow}\rangle\right) \\
|\sigma_{u\uparrow}\rangle &= \frac{1}{\sqrt{2}} \left(|1s_{A\uparrow}\rangle - |1s_{B\uparrow}\rangle\right) \\
|\sigma_{u\downarrow}\rangle &= \frac{1}{\sqrt{2}} \left(|1s_{A\downarrow}\rangle - |1s_{B\downarrow}\rangle\right) \\
\end{align*}
```

And we can write the Slater determinant with respect to these new states as:

```math
|\psi\rangle = |f_{u\downarrow}f_{u\uparrow}f_{g\downarrow}f_{g\uparrow}\rangle = |f_3f_2f_1f_0\rangle 
```

Now we can develop our Hamiltonian. In the second quantized basis (see our development of $H_{sq}$ above):

```math
\begin{align*}
H &= H_1 + H_2 + H_3 + H_4 \\
H_1 =& \sum_{i=0}^3 h_{ii}a^\dagger_ia_i \\
H_2 =& \sum_{i=0}^2 h_{i,i+1,i+1,i} a_i^\dagger a^\dagger_{i+1}a_{i+1}a_i \\
H_3 =& \sum_{i=0}^1 (h_{i,i+2,i+2,i} - h_{i,i+2,i,i+2} ) a_i^\dagger a^\dagger_{i+2}a_{i+2}a_i \\
H_4 =& h_{0132}\left(a_0^\dagger a^\dagger_{1}a_{3}a_2 + a_2^\dagger a^\dagger_{3}a_{1}a_0\right) + h_{0312}\left(a_0^\dagger a^\dagger_{3}a_{1}a_2 + a_2^\dagger a^\dagger_{1}a_{3}a_0\right) \\
\end{align*}
```

Applying the Jordan-Wigner transformation, we compute:
```math
\begin{align*}
H_{Q} &= H_{Q1} + H_{Q2} + H_{Q3} \\
H_{Q1} &= h_0 I + h_1 Z_0 + h_2Z_1 + h_3 Z_2 + h_4 Z_3 \\
H_{Q2} &= h_5 Z_0 Z_1 + h_6 Z_0Z_2 + h_7 Z_1Z_2 + h_8 Z_0Z_3 + h_9 Z_1Z_3 + h_{10}Z_2Z_3 \\
H_{Q3} &= h_{11} Y_0 Y_1 X_2 X_3 + h_{12}X_0 Y_1 Y_2 X_3 + h_{13}Y_0X_1X_2Y_3 + h_{14}X_0X_1Y_2Y_3 \\
\end{align*}
```
The specific $h_i$ values can be computed numerically from the positions of the atoms in $H_2$. We'll use `pyscf` to do this.

In the JW encoding, the HF state, which is taken as the reference state for the UCCSD ansatz for VQE, is given by $|\psi_{HF}\rangle = |0011\rangle$. This represents the orbitals $|\sigma_{g\uparrow}\rangle, |\sigma_{g\downarrow}\rangle$ being occupied and $|\sigma_{u\uparrow}\rangle, |\sigma_{u\downarrow}\rangle$ being unoccupied.

The most general wavefunction $|\psi\rangle$ for $H_2$ which preserves charge and spin multiplicity is:

```math
|\psi\rangle = \alpha |0011\rangle + \beta |1100\rangle + \gamma|1001\rangle + \delta |0110\rangle
```

And after some algebra (not shown) we can write the UCCSD ansatz $U(\theta) = \exp\{i\theta X_3X_2X_1Y_0\}$.
"""

# ╔═╡ 0280b99d-2769-4f21-9fa4-fcdf4f25fd58
md"""
## Execution on a quantum simulator

Finally we have all the pieces we need:
- an initial guess for the groundstate
- a quantum computer compatible representation of the molecular Hamiltonian
- an algorithm to optimize the initial guess

Now we will try to determine both the groundstate energy and most likely bond length of $H_2$. The bond length with minimal groundstate energy is most likely. To be more concrete, we will:

1. Use `openfermion` and `pyscf` to compute the coefficients $\{h_i\}$ of $H_Q$ for a particular bond length.
2. Implement the UCCSD ansatz in `Braket.jl`.
3. Use VQE to optimize the parameter in the ansatz and obtain a good approximation of $E_0$ for the bond length.
4. Plot the results to determine the most likely bond length.

First, let's write our generic UCCSD ansatz for $|\psi(\theta)\rangle$:
"""

# ╔═╡ af4a74c8-fa8d-4c9a-a29d-27476c80b5e5
function ansatz(θ)
	c = Circuit()
	c(H, 0)
	c(H, 1)
	c(X, 2)
	c(H, 2)
	c(X, 3)
	c(Rx, 3, π/2)
	c(CNot, 3, 2)
	c(CNot, 2, 1)
	c(CNot, 1, 0)
	c(Rz, 0, θ)
	c(CNot, 1, 0)
	c(CNot, 2, 1)
	c(CNot, 3, 2)
	c(Rx, 3, -π/2)
	c(H, 0)
	c(H, 1)
	c(H, 2)
	return c
end

# ╔═╡ 3c46d71a-7d49-4d91-b536-817333b8f284
md"""
Now we can install and load the necessary Python packages:
"""

# ╔═╡ 6626ac70-8fb2-4513-9443-5f90818f7ad4
#install Python packages
begin
	CondaPkg.add_pip("pennylane", version="==0.28.0")
	CondaPkg.add_pip("pyscf", version="==2.1.1")
	CondaPkg.add_pip("openfermion", version="==1.5.1")
	CondaPkg.add_pip("openfermionpyscf", version="==0.5")
end

# ╔═╡ 67b067f4-6375-42fe-aa9d-8b46f9483ed1
#import Python packages
begin
	pyscf = pyimport("pyscf")
	scf = pyimport("pyscf.scf")
	transforms = pyimport("openfermion.transforms")
	of = pyimport("openfermion")
	ofpyscf = pyimport("openfermionpyscf")
end

# ╔═╡ 738480aa-90d3-46e1-9796-340c30290a23
# set parameters for classical computations
begin
	total_charge = 0
	spin_mult = 1
	basis_set = pystr("sto-3g")
	# number of active electrons and orbitals to consider
	# for H2 we consider all electrons and orbitals as active for STO-3G
	occ_ind = nothing
	act_ind = nothing
end

# ╔═╡ 824ff10a-8bdc-4206-865a-facaa4b18824
# set of bond lengths to try to simulate ground-state of H2 (in Angstroms)
bond_lengths = range(start=0.24, stop=3.00, step=0.1)

# ╔═╡ 707da214-4ae6-41a7-94b3-7168f3b01f61
# number of shots to use in the simulator
n_shots = 0

# ╔═╡ e2d61370-0229-46a8-90e6-21fac0fb7056
# number of VQE parameter values to scan
n_theta = 24

# ╔═╡ cbbd1b17-e9e5-4e3e-8cc1-fc0c26b8e66f
dev = LocalSimulator("braket_sv_v2")

# ╔═╡ de771faa-96f7-44d0-801b-76fbb9dc8509
md"""
### Classical pre-computation of the electronic Hamiltonian of $H_2$
"""

# ╔═╡ 9617dc3a-49fe-4a0e-85b9-c88c6deb7caf
mol_data = OrderedDict{Number, Py}()

# ╔═╡ 2b291132-3415-49b5-a056-375f36bec59d
# generate OpenFermion MolecularData for each bond length
for rr in bond_lengths
	rounded_rr = round(rr, digits=2)
	@info "Computing molecular data for bond-length $rounded_rr Angstroms"
	geom = pylist([pytuple((pystr("H"), pytuple((0., 0., -rounded_rr/2.)))), pytuple((pystr("H"), pytuple((0., 0., rounded_rr/2.))))])
	desc = pystr("bondlength_"*string(rounded_rr)*"A")
    mol = of.MolecularData(geometry=geom, basis=basis_set, multiplicity=spin_mult,
        description=desc, filename=pystr(""),
        data_directory=pystr(pwd()))
	mol_data[rounded_rr] = mol 
end

# ╔═╡ e1369cc5-3f74-4399-adbd-8743c3cd67e1
mol_configs = OrderedDict{Number, Vector}()

# ╔═╡ 867967c4-a05b-4f17-ab61-17ceb76376e2
for (rounded_rr, dat) in mol_data
	@info "Running pyscf for bond-length $rounded_rr Angstroms"
	h2_molecule = ofpyscf.run_pyscf(molecule=dat, run_scf=true,
                            run_mp2=false, run_cisd=false,
                            run_ccsd=false, run_fci=true, verbose=false)
	mol_configs[rounded_rr] = Any[h2_molecule]
end

# ╔═╡ 0ae58b97-7f99-4ffe-9a7b-276f1fe0665d
for (rounded_rr, H) in mol_configs
	@info "Computing Hamiltonian for bond-length $rounded_rr Angstroms"
    h2_molecule = H[1]
    mol_H = h2_molecule.get_molecular_hamiltonian(occupied_indices=occ_ind, active_indices=act_ind)
    fermion_op = transforms.get_fermion_operator(mol_H)
    h2_qubit_hamiltonian = transforms.jordan_wigner(fermion_op)
    push!(mol_configs[rounded_rr], h2_qubit_hamiltonian)
end

# ╔═╡ c144939e-a80b-4c85-b991-271dc8a8b0db
md"""
### Computing the expectation value of $H_Q$

We compute the expectation value of each term in the Hamiltonian separately as they are not mutually commuting. This is inexpensive to do because the qubit count is small and we're using the local simulator.
"""

# ╔═╡ 3b4891c3-9e21-4bb0-9dac-62dfbcc390ab
"""
	calculate_observable_expectation(gates_and_inds::Vector{Tuple{Int, Braket.Observable}}, c::Circuit, dev, shots::Integer)

Calculates the expectation value of the given observable.
"""
function calculate_observable_expectation(gates_and_inds, θ, d::Device, shots::Integer)
	# this is the constant term of the Hamiltonian
    isempty(gates_and_inds) && return 1.0
    c_with_obs = ansatz(θ) 
    n_qubits = qubit_count(c_with_obs)
	# N.B.: Convert from OpenFermion's little-endian convention
	# to Braket's big-endian convention
    factors = Dict{Int, String}()
    for (ind, factor) in gates_and_inds
        qubit = n_qubits - 1 - pyconvert(Int, ind)
		factors[qubit] = pyconvert(String, factor)
	end
    qubits = sort(collect(keys(factors)))
    observable = Braket.Observables.TensorProduct([factors[qubit] for qubit in qubits])
    # initialize circuit and add expectation measurement
    c_with_obs(Expectation, observable, qubits)
    # compute expectation value
    res = result(d(c_with_obs, shots=shots))
	exp = first(res.values)
    return exp
end

# ╔═╡ ea391b9a-13fb-4952-80df-a590a23ea741
function exp_H(Hq, θ, d::Device, shots::Integer)
	E = 0.0
    for (gates_and_inds, term) in Hq.items()
        coeff = real(pyconvert(Float64, term))
        exp = calculate_observable_expectation(gates_and_inds, θ, d, shots)
		E += coeff * exp
	end
	return E
end

# ╔═╡ cddbf3ee-61fe-4ca8-a30d-a04fa10ff88c
# Now we can loop over all the possible bond lengths we want to try and compute the ground state energies:
for (r, v) in mol_configs
	@info "Computing ground-state energy for bond-length $r A"
	# Initialize energy guess
	push!(mol_configs[r], 1e5)
    for θ ∈ LinRange(-π, π, n_theta+1)
        # get expectation value of this config's Hamiltonian for this parameter value
        E_θ = exp_H(v[2].terms, θ, dev, n_shots)
        # if this expectation value is less than min found so far, update it
        if E_θ < mol_configs[r][end]
            mol_configs[r][end] = E_θ
        end
	end
	@info "min <H(R=$r A)> = $(mol_configs[r][end]) Ha"
end

# ╔═╡ be543735-ad3b-4c59-8203-a5799f9dc933
md"""
Now we can plot the energies we computed using VQE and compare with the results from HF and FCI.
"""

# ╔═╡ 08327003-60e4-4d10-9554-ebbc23a5cde7
begin
	p = plot()
	xs = collect(keys(mol_configs))
	hf_es = [pyconvert(Float64, val[1].hf_energy) for val in values(mol_configs)]
	fci_es = [pyconvert(Float64, val[1].fci_energy) for val in values(mol_configs)]
	plot!(p, xs, hf_es, label="HF")
	plot!(p, xs, fci_es, label="FCI")
	plot!(p, xs, [val[end] for val in values(mol_configs)], marker=:x, label="VQE")
	title!(p, "VQE computed ground-state energy of H2 \n vs bond-length for STO-3G basis vs HF and FCI")
	xlabel!(p, "Bond length of H2 [A]")
	ylabel!(p, "Ground-state energy for H2 [Ha]")
end

# ╔═╡ fbea5357-f2a8-4f7f-81e6-50e0855e6b67
md"""
We can see that the energy is minimized around ~0.74 A. This is in fact the [experimentally observed bond length](https://cccbdb.nist.gov/exp2x.asp?casno=1333740) for this molecule, so our simple procedure worked well to find the correct `θ` and bond length. For more complex molecules one can take a more sophisticated approach involving a classical optimization algorithm and the calculation of gradients.
"""

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
CondaPkg = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
OrderedCollections = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
Plots = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
PyBraket = "e85266a6-1825-490b-a80e-9b9469c53660"

[compat]
Braket = "~0.3.0"
CondaPkg = "~0.2.15"
OrderedCollections = "~1.4.1"
Plots = "~1.38.2"
PyBraket = "~0.3.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.0-beta3"
manifest_format = "2.0"
project_hash = "12fb0f992528b965e21985138650b6f99d6004fe"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "SHA", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "487d6835da9876e0362a83aec169e390872eba64"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.81.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "f116c78dbaab8141c121a41962e28f442908051c"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.3.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "SnoopPrecompile", "Tables", "Unicode", "WeakRefStrings", "WorkerUtilities"]
git-tree-sha1 = "c700cce799b51c9045473de751e9319bdd1c6e94"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.9"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c6d890a52d2c4d55d326439580c3b8d0875a77d9"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.7"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "9c209fb7536406834aa938fb149964b985de6c83"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.1"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random", "SnoopPrecompile"]
git-tree-sha1 = "aa3edc8f8dea6cbfa176ee12f7c2fc82f0608ed3"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.20.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "600cc5508d66b78aae350f7accdb58763ac18589"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.10"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "fc08e5930ee9a4e03f84bfb5211cb54e7769758a"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.10"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "00a2cccc7f098ff3b66806862d275ca3db9e6e5a"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.5.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.2+0"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pidfile", "Pkg", "TOML"]
git-tree-sha1 = "64dd885fa25c61fdf6b27e90d6adedf564ae363a"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.15"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.DataAPI]]
git-tree-sha1 = "e8119c1a33d267e16108be441a287a6981ba1630"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.14.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
git-tree-sha1 = "9e2f36d3c96a820c678f2f1f1782582fcf685bae"
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"
version = "1.9.1"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "2fb1e02f2b635d0845df5d7c167fec4dd739b00d"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.3"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GR]]
deps = ["Artifacts", "Base64", "DelimitedFiles", "Downloads", "GR_jll", "HTTP", "JSON", "Libdl", "LinearAlgebra", "Pkg", "Preferences", "Printf", "Random", "Serialization", "Sockets", "TOML", "Tar", "Test", "UUIDs", "p7zip_jll"]
git-tree-sha1 = "9e23bd6bb3eb4300cb567bdf63e2c14e5d2ffdbc"
uuid = "28b8d3ca-fb5f-59d9-8090-bfdbd6d07a71"
version = "0.71.5"

[[deps.GR_jll]]
deps = ["Artifacts", "Bzip2_jll", "Cairo_jll", "FFMPEG_jll", "Fontconfig_jll", "GLFW_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Pixman_jll", "Pkg", "Qt5Base_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "aa23c9f9b7c0ba6baeabe966ea1c7d2c7487ef90"
uuid = "d2c73de3-f751-5644-a686-071e5b155ba9"
version = "0.71.5+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "5688002de970b9eee14b7af7bbbd1fdac10c9bbe"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.2"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "d3b3624125c1474292d0d8ed0f65554ac37ddb23"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "eb5aa5e3b500e191763d35198f859e4b40fff4a6"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.7.3"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "9cc2baf75c6d09f9da536ddf58eb2f29dedaf461"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.4.0"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLFzf]]
deps = ["Pipe", "REPL", "Random", "fzf_jll"]
git-tree-sha1 = "f377670cda23b6b7c1c0b3893e37451c5c1a2185"
uuid = "1019f520-868f-41f5-a6de-eb00f4b6a39c"
version = "0.1.5"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "84b10656a41ef564c39d2d477d7236966d2b5683"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.12.0"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.Latexify]]
deps = ["Formatting", "InteractiveUtils", "LaTeXStrings", "MacroTools", "Markdown", "OrderedCollections", "Printf", "Requires"]
git-tree-sha1 = "2422f47b34d4b127720a18f86fa7b1aa2e141f29"
uuid = "23fbe1c1-3f47-55db-b15f-69d7ec21a316"
version = "0.15.18"

[[deps.LazyArtifacts]]
deps = ["Artifacts", "Pkg"]
uuid = "4af54fe1-eca0-43a8-85a7-787d91b784e3"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "6f73d1dd803986947b2c750138528a999a6c7733"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.6.0+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c7cb1f5d892775ba13767a87c7ada0b980ea0a71"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+2"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "Pkg", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "3eb79b0ca5764d4799c06699573fd8f533259713"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.4.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "946607f84feb96220f480e0422d3484c49c00239"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.19"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "cedb76b37bc5a6c702ade66be44f831fa23c681e"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "1.0.0"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch", "micromamba_jll"]
git-tree-sha1 = "a6a4771aba1dc8942bc0f44ff9f8ee0f893ef888"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.12"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "f66bdc5de519e8f8ae43bdc598782d35a25b1272"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.1.0"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["Compat", "ExprTools"]
git-tree-sha1 = "c272302b22479a24d1cf48c114ad702933414f80"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.5"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "90914795fc59df44120fe3fff6742bb0d7adb1d0"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.3"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "6503b77492fd7fcb9379bf73cd31035670e3c509"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.3"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+0"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "8175fc2b118a3755113c8e68084dc1a9e63c61ee"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.3"

[[deps.Pidfile]]
deps = ["FileWatching", "Test"]
git-tree-sha1 = "2d8aaf8ee10df53d0dfb9b8ee44ae7c04ced2b03"
uuid = "fa939f87-e72e-5be4-a000-7fc836dbe307"
version = "1.3.0"

[[deps.Pipe]]
git-tree-sha1 = "6842804e7867b115ca9de748a0cf6b364523c16d"
uuid = "b98c9c47-44ae-5843-9183-064241ee97a0"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.0"

[[deps.PlotThemes]]
deps = ["PlotUtils", "Statistics"]
git-tree-sha1 = "1f03a2d339f42dca4a4da149c7e15e9b896ad899"
uuid = "ccf2f8ad-2431-5c83-bf29-c5338b663b6a"
version = "3.1.0"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "daff8d21e3f4c596387867329be49b8c45f4f0f3"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.3"

[[deps.Plots]]
deps = ["Base64", "Contour", "Dates", "Downloads", "FFMPEG", "FixedPointNumbers", "GR", "JLFzf", "JSON", "LaTeXStrings", "Latexify", "LinearAlgebra", "Measures", "NaNMath", "Pkg", "PlotThemes", "PlotUtils", "Preferences", "Printf", "REPL", "Random", "RecipesBase", "RecipesPipeline", "Reexport", "RelocatableFolders", "Requires", "Scratch", "Showoff", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "UUIDs", "UnicodeFun", "Unzip"]
git-tree-sha1 = "a99bbd3664bb12a775cda2eba7f3b2facf3dad94"
uuid = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
version = "1.38.2"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PyBraket]]
deps = ["Braket", "CondaPkg", "DataStructures", "LinearAlgebra", "PythonCall", "Statistics", "StructTypes"]
git-tree-sha1 = "64f9f4e72ef170541eecbb9398906114a33b9a34"
uuid = "e85266a6-1825-490b-a80e-9b9469c53660"
version = "0.3.0"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "REPL", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "1052188e0a017d4f4f261f12307e1fa1b5b48588"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.10"

[[deps.Qt5Base_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Fontconfig_jll", "Glib_jll", "JLLWrappers", "Libdl", "Libglvnd_jll", "OpenSSL_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libxcb_jll", "Xorg_xcb_util_image_jll", "Xorg_xcb_util_keysyms_jll", "Xorg_xcb_util_renderutil_jll", "Xorg_xcb_util_wm_jll", "Zlib_jll", "xkbcommon_jll"]
git-tree-sha1 = "0c03844e2231e12fda4d0086fd7cbe4098ee8dc5"
uuid = "ea2cea3b-5b76-57ae-a6ef-0a8af62496e1"
version = "5.15.3+2"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "261dddd3b862bd2c940cf6ca4d1c8fe593e457c8"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.3"

[[deps.RecipesPipeline]]
deps = ["Dates", "NaNMath", "PlotUtils", "RecipesBase", "SnoopPrecompile"]
git-tree-sha1 = "e974477be88cb5e3040009f3767611bc6357846f"
uuid = "01d81517-befc-4cb6-b9ec-a95719d0359c"
version = "0.6.11"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "c02bd3c9c3fc8463d3591a62a378f90d2d8ab0f3"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.17"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SnoopPrecompile]]
deps = ["Preferences"]
git-tree-sha1 = "e760a70afdcd461cf01a575947738d359234665c"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.3"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "a4ada03f999bd01b3a25dcaa30b2d929fe537e00"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.1.0"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "6954a456979f23d05085727adb17c4551c19ecd1"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.12"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+0"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "94f38103c984f89cf77c402f2a68dbd870f8165f"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.11"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.Unzip]]
git-tree-sha1 = "ca0969166a028236229f63514992fc073799bb78"
uuid = "41fe7b60-77ed-43a1-b4f0-825fd5a5650d"
version = "0.2.0"

[[deps.Wayland_jll]]
deps = ["Artifacts", "Expat_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "ed8d92d9774b077c53e1da50fd81a36af3744c1c"
uuid = "a2964d1f-97da-50d4-b82a-358c7fce9d89"
version = "1.21.0+0"

[[deps.Wayland_protocols_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4528479aa01ee1b3b4cd0e6faef0e04cf16466da"
uuid = "2381bf8a-dfd0-557d-9999-79630e7b1b91"
version = "1.25.0+0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.WorkerUtilities]]
git-tree-sha1 = "cd1659ba0d57b71a464a29e64dbc67cfe83d54e7"
uuid = "76eceee3-57b5-4d4a-8e66-0e911cebbf60"
version = "1.6.1"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "93c41695bc1c08c46c5899f4fe06d6ead504bb73"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.10.3+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_libxkbfile_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "926af861744212db0eb001d9e40b5d16292080b2"
uuid = "cc61e674-0454-545c-8b26-ed2c68acab7a"
version = "1.1.0+4"

[[deps.Xorg_xcb_util_image_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "0fab0a40349ba1cba2c1da699243396ff8e94b97"
uuid = "12413925-8142-5f55-bb0e-6d7ca50bb09b"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll"]
git-tree-sha1 = "e7fd7b2881fa2eaa72717420894d3938177862d1"
uuid = "2def613f-5ad1-5310-b15b-b15d46f528f5"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_keysyms_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "d1151e2c45a544f32441a567d1690e701ec89b00"
uuid = "975044d2-76e6-5fbe-bf08-97ce7c6574c7"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_renderutil_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "dfd7a8f38d4613b6a575253b3174dd991ca6183e"
uuid = "0d47668e-0667-5a69-a72c-f761630bfb7e"
version = "0.3.9+1"

[[deps.Xorg_xcb_util_wm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "e78d10aab01a4a154142c5006ed44fd9e8e31b67"
uuid = "c22f9ab0-d5fe-5066-847c-f4bb1cd4e361"
version = "0.4.1+1"

[[deps.Xorg_xkbcomp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxkbfile_jll"]
git-tree-sha1 = "4bcbf660f6c2e714f87e960a171b119d06ee163b"
uuid = "35661453-b289-5fab-8a00-3d9160c6a3a4"
version = "1.4.2+4"

[[deps.Xorg_xkeyboard_config_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xkbcomp_jll"]
git-tree-sha1 = "5c8424f8a67c3f2209646d4425f3d415fee5931d"
uuid = "33bec58e-1273-512f-9401-5d533626f822"
version = "2.27.0+4"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e45044cd873ded54b6a5bac0eb5c971392cf1927"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.2+0"

[[deps.fzf_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "868e669ccb12ba16eaf50cb2957ee2ff61261c56"
uuid = "214eeab7-80f7-51ab-84ad-2988db7cef09"
version = "0.29.0+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.2.0+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.micromamba_jll]]
deps = ["Artifacts", "JLLWrappers", "LazyArtifacts", "Libdl", "Pkg"]
git-tree-sha1 = "80ddb5f510c650de288ecd548ebc3de557ffb3e2"
uuid = "f8abcde7-e9b7-5caa-b8af-a437887ae8e4"
version = "1.2.0+0"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"

[[deps.xkbcommon_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Wayland_jll", "Wayland_protocols_jll", "Xorg_libxcb_jll", "Xorg_xkeyboard_config_jll"]
git-tree-sha1 = "9ebfc140cc56e8c2156a15ceac2f0302e327ac0a"
uuid = "d8fb68d0-12a3-5cfd-a85a-d49703b185fd"
version = "1.4.1+0"
"""

# ╔═╡ Cell order:
# ╟─2f49c108-9d9f-11ed-1a79-eb966fa5a322
# ╟─2e2c9fce-5d4f-411c-9951-0b5909111155
# ╟─6ada7712-6f03-4f56-8254-085d878d61fc
# ╟─0280b99d-2769-4f21-9fa4-fcdf4f25fd58
# ╠═af4a74c8-fa8d-4c9a-a29d-27476c80b5e5
# ╟─3c46d71a-7d49-4d91-b536-817333b8f284
# ╠═23aaba4e-3342-4581-a6bf-b039c390062e
# ╠═6626ac70-8fb2-4513-9443-5f90818f7ad4
# ╠═67b067f4-6375-42fe-aa9d-8b46f9483ed1
# ╠═738480aa-90d3-46e1-9796-340c30290a23
# ╠═824ff10a-8bdc-4206-865a-facaa4b18824
# ╠═707da214-4ae6-41a7-94b3-7168f3b01f61
# ╠═e2d61370-0229-46a8-90e6-21fac0fb7056
# ╠═cbbd1b17-e9e5-4e3e-8cc1-fc0c26b8e66f
# ╟─de771faa-96f7-44d0-801b-76fbb9dc8509
# ╠═9617dc3a-49fe-4a0e-85b9-c88c6deb7caf
# ╠═2b291132-3415-49b5-a056-375f36bec59d
# ╠═e1369cc5-3f74-4399-adbd-8743c3cd67e1
# ╠═867967c4-a05b-4f17-ab61-17ceb76376e2
# ╠═0ae58b97-7f99-4ffe-9a7b-276f1fe0665d
# ╟─c144939e-a80b-4c85-b991-271dc8a8b0db
# ╠═3b4891c3-9e21-4bb0-9dac-62dfbcc390ab
# ╠═ea391b9a-13fb-4952-80df-a590a23ea741
# ╠═cddbf3ee-61fe-4ca8-a30d-a04fa10ff88c
# ╟─be543735-ad3b-4c59-8203-a5799f9dc933
# ╠═ff4fad96-1970-4fb9-a43a-df02cd5dc643
# ╠═08327003-60e4-4d10-9554-ebbc23a5cde7
# ╟─fbea5357-f2a8-4f7f-81e6-50e0855e6b67
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

const ALL_QUBITS = -1

"""
    Circuit

A representation of a quantum circuit that contains the instructions to be performed on a
quantum device and the requested result types.

See:
  - [Gates](@ref) for all of the supported gates. 
  - [Noises](@ref) for all of the supported noise operations.
  - [Compiler Directives](@ref) for all of the supported compiler directives.
  - [Results](@ref) for all of the supported result types.
"""
mutable struct Circuit
    moments::Moments
    instructions::Vector{Instruction{<:Operator}}
    result_types::Vector{Result}
    basis_rotation_instructions::Vector{Instruction{<:Operator}}
    qubit_observable_mapping::Dict{Int, Observables.Observable}
    qubit_observable_target_mapping::Dict{Int, Tuple}
    qubit_observable_set::Set{Int}
    parameters::Set{FreeParameter}
    observables_simultaneously_measureable::Bool
    has_compiler_directives::Bool
    measure_targets::Vector{Int} 

    @doc """
        Circuit()
    
    Construct an empty `Circuit`.
    """
    Circuit() = new(Moments(), [], [], [], Dict(), Dict(), Set{Int}(), Set(), true, false, Int[])
end
"""
    Circuit(m::Moments, ixs::Vector, rts::Vector{Result}, bri::Vector)

Construct a `Circuit` from a set of `Moments`, a vector of [`Instruction`](@ref)s,
a vector of [`Result`](@ref)s, and a vector of basis rotation instructions.
"""
function Circuit(m::Moments, ixs::Vector, rts::Vector{Result}, bri::Vector)
    c = Circuit()
    c.moments = deepcopy(m)
    c.instructions = Instruction.(deepcopy(ixs))
    c.basis_rotation_instructions = Instruction.(deepcopy(bri))
    foreach(rt->add_result_type!(c, rt), rts)
    return c
end
"""
    Circuit(v)

Construct a `Circuit` from a `Vector`-like `v` containing tuples of:
  - a [`Gate`](@ref), [`Noise`](@ref), or [`Result`](@ref)
  - the target qubits on which to apply the operator
  - any construction arguments to the operator, e.g. an angle or [`Observable`](@ref Braket.Observables.Observable)

# Examples
```jldoctest
julia> v = [(H, collect(0:10)), (Rx, 1, 0.2), (BitFlip, 0, 0.1)];

julia> Circuit(v);
```
"""
Circuit(v::AbstractVector) = (c = Circuit(); c(v); return c)
Base.show(io::IO, circ::Circuit) = print(io, "Circuit($(qubit_count(circ)) qubits)")

function build_blob!(lines::Vector{String}, strs, targets, hit_this_round::Set{Int}, qubit_lines, non_qubit_lines) 
    bar_qubits = collect(minimum(targets)+1:maximum(targets)-1)
    is_dis     = isdisjoint(hit_this_round, union(targets, bar_qubits))
    ix_lines   = [3 + targ * 2 for targ in targets]
    bar_lines  = [4 + q * 2 for q in minimum(targets):maximum(targets)-1]
    if !isdisjoint(hit_this_round, union(targets, bar_qubits))
        lines[ix_lines]        .*= "-"
        pad_width               = maximum(length, lines)
        lines[non_qubit_lines] .= (rpad(line, pad_width, " ") for line in lines[non_qubit_lines])
        lines[qubit_lines]     .= (rpad(line, pad_width, "-") for line in lines[qubit_lines])
    end
    lines[ix_lines] .*= strs
    # add | for multi qubit objects
    lines[bar_lines] .*= "|"
    union!(hit_this_round, targets)
    union!(hit_this_round, bar_qubits)
    return lines, hit_this_round
end

function update_border!(lines, header_str, border_lines)
    pad_width     = maximum(length, lines)
    border_length = length(lines[border_lines[1]])
    pad_diff = pad_width - border_length 
    half_pad = border_length + div(pad_width - border_length - length(header_str), 2)
    lines[border_lines] .= (rpad(line, half_pad) for line in lines[border_lines])
    lines[border_lines] .*= (header_str, header_str)
    lines[border_lines] .= (rpad(line, pad_width) for line in lines[border_lines])
    return lines
end


function build_slice!(lines::Vector{String}, strings_and_targets, line_groups, header::String, fallback)
    hit_this_round = Set{Int}()
    qubit_lines, non_qubit_lines, border_lines = line_groups
    for (op_strings, op_targets) in strings_and_targets
        targets = isempty(op_targets) ? fallback : op_targets
        lines, hit_this_round = build_blob!(lines, op_strings, targets, hit_this_round, qubit_lines, non_qubit_lines)
    end
    lines = update_border!(lines, header, border_lines)
    pad_width = maximum(length, lines)
    lines[non_qubit_lines] .= [rpad(line, pad_width) for line in lines[non_qubit_lines]]
    lines[qubit_lines]     .= [rpad(line, pad_width, "-") for line in lines[qubit_lines]]
    lines[border_lines]    .*= "|"
    lines[non_qubit_lines] .*= " "
    lines[qubit_lines]     .*= "-"
    return lines
end

function build_result_lines!(rts::Vector{Result}, lines::Vector{String}, line_groups, qc::Int)
    strings_and_targets = zip([chars(rt)[1] for rt in rts], [rt.targets for rt in rts])
    return build_slice!(lines, strings_and_targets, line_groups, "Result Types", collect(0:qc-1))
end

function build_left_column(qubit_count::Int)
    qlines = vcat("T", ["q$q" for q in 0:qubit_count-1], "T")
    nlines = ["" for line in qlines[1:end-1]]
    lines  = Vector{String}(undef, 2*length(qlines)-1)
    lines[1:2:end] = qlines[:]
    lines[2:2:end] = nlines[:]
    
    non_qubit_lines = 2:2:length(lines)
    qubit_lines     = 3:2:length(lines)-1
    border_lines    = [1, length(lines)]
    line_groups     = (qubit_lines, non_qubit_lines, border_lines)
    
    pad_width = maximum(length, lines)
    lines[:] .= (rpad(line, pad_width) for line in lines[:])
    lines[border_lines] .*= " : "
    lines[qubit_lines]  .*= " : "
    pad_width = maximum(length, lines)
    lines[:] .= (rpad(line, pad_width) for line in lines[:])

    lines[border_lines]    .*= "|"
    lines[non_qubit_lines] .*= " "
    lines[qubit_lines]     .*= "-"
    return lines, line_groups
end

function Base.show(io::IO, ::MIME"text/plain", circ::Circuit)
    lines, line_groups = build_left_column(qubit_count(circ))
    targeted_rts = filter(r->hasproperty(r, :targets), circ.result_types)
    non_targ_rts = filter(r->!hasproperty(r, :targets), circ.result_types)
    for (t, ixs) in time_slices(circ.moments)
        strings_and_targets = zip((chars(ix.operator) for ix in ixs), (ix.target for ix in ixs))
        lines = build_slice!(lines, strings_and_targets, line_groups, string(t), (0, qubit_count(circ)-1))
    end
    lines = build_result_lines!(targeted_rts, lines, line_groups, qubit_count(circ))

    circ_str = mapreduce(li->li*"\n", *, lines)
    if !isempty(non_targ_rts)
        circ_str *= "\nAdditional result types: "
        circ_str *= join((chars(rt)[1] for rt in non_targ_rts), ", ")
        circ_str *= "\n"
    end
    if !isempty(circ.parameters)
        circ_str *= "\nUnassigned parameters: "
        circ_str *= join((string(p) for p in circ.parameters), ", ") 
        circ_str *= "\n"
    end
    return print(io, circ_str)
end

function make_bound_circuit(c::Circuit, param_values::Dict{Symbol, Number})
    clamped_circ = Circuit()
    foreach(ix->add_instruction!(clamped_circ, bind_value!(ix, param_values)), c.instructions)
    clamped_circ.result_types = deepcopy(c.result_types)
    return clamped_circ
end

(c::Circuit)(::Type{T}, args...) where {T<:Gate}  = apply_gate!(T, c, args...)
(c::Circuit)(::Type{T}, args...) where {T<:Noise} = apply_noise!(T, c, args...)
(c::Circuit)(::Type{T}) where {T<:CompilerDirective} = add_instruction!(c, Instruction{T}(T()))
(c::Circuit)(::Type{Measure}, args...) = foreach(target->add_instruction!(c, Instruction{Measure}(Measure(), target)), args)
(c::Circuit)(g::QO, args...) where {QO<:QuantumOperator} = add_instruction!(c, Instruction(g, args...))
(c::Circuit)(g::CD) where {CD<:CompilerDirective} = add_instruction!(c, Instruction{CD}(g))
(c::Circuit)(v::AbstractVector) = foreach(vi->c(vi...), v)
(c::Circuit)(rt::Result, args...) = add_result_type!(c, rt, args...)
(c::Circuit)(::Type{T}, args...) where {T<:Result} = T(c, args...)
(c::Circuit)(sub_c::Circuit, args...) = (append!(c, sub_c, args...); return c)

"""
    (c::Circuit)(arg::Number; kwargs...)
    (c::Circuit)(; kwargs...)

Fix all [`FreeParameter`](@ref)s in `c` as specified in `kwargs`
and return a new circuit with the clamped parameters. `c`
is unmodified.

If `arg` is passed, the values of all `FreeParameter`s
*not* listed in `kwargs` will be set to `arg`.

# Examples
```jldoctest
julia> α = FreeParameter(:alpha);

julia> θ = FreeParameter(:theta);

julia> circ = Circuit();

julia> circ = H(circ, 0);

julia> circ = Rx(circ, 1, α);

julia> circ = Ry(circ, 0, θ);

julia> circ = Probability(circ);

julia> new_circ = circ(theta=2.0, alpha=1.0);
```
"""
function (c::Circuit)(arg::Number; kwargs...)
    parameter_values = Dict{Symbol, Number}()
    for param in c.parameters
        parameter_values[param.name] = arg
    end
    return make_bound_circuit(c, parameter_values)
end
function (c::Circuit)(; kwargs...)
    parameter_values = Dict{Symbol, Number}()
    for (k, v) in kwargs 
        parameter_values[Symbol(k)] = v
    end
    return make_bound_circuit(c, parameter_values)
end

"""
    depth(c::Circuit)

Returns the number of moments in `c`.
Also known as the "parallel gate depth".

# Examples
```jldoctest
julia> c = Circuit();

julia> H(c, 0);

julia> CNot(c, 0, 1);

julia> depth(c)
2
```
"""
depth(c::Circuit)       = length(c.moments)
"""
    qubits(c::Circuit) -> QubitSet

Returns a [`QubitSet`](@ref) containing all qubits
that `c` is defined on.

# Examples
```jldoctest
julia> c = Circuit();

julia> H(c, 0);

julia> CNot(c, 0, 1);

julia> qubits(c)
QubitSet with 2 elements:
  0
  1
```
"""
qubits(c::Circuit) = (qs = union!(copy(c.moments._qubits), c.qubit_observable_set); QubitSet(qs))
function qubits(p::Program)
    inst_qubits = mapreduce(ix->ix.target, union, p.instructions, init=Set{Int}())
    bri_qubits  = mapreduce(ix->ix.target, union, p.basis_rotation_instructions, init=Set{Int}())
    res_qubits  = mapreduce(ix->(hasproperty(ix, :targets) && !isnothing(ix.targets)) ? reduce(vcat, ix.targets) : Set{Int}(), union, p.results, init=Set{Int}())
    return union(inst_qubits, bri_qubits, res_qubits)
end
"""
    qubit_count(c::Circuit) -> Int

Returns the number of qubits that `c` is defined on.

# Examples
```jldoctest
julia> c = Circuit();

julia> H(c, 0);

julia> CNot(c, 0, 1);

julia> qubit_count(c)
2
```
"""
qubit_count(c::Circuit) = length(qubits(c))
qubit_count(p::Program) = length(qubits(p))

(rt::Result)(c::Circuit) = add_result_type!(c, rt)

Base.convert(::Type{Circuit}, p::Program) = Circuit(Moments(p.instructions), p.instructions, Result[StructTypes.constructfrom(Result, r) for r in p.results], p.basis_rotation_instructions)
Base.convert(::Type{Program}, c::Circuit) = (basis_rotation_instructions!(c); return Program(braketSchemaHeader("braket.ir.jaqcd.program" ,"1"), c.instructions, ir.(c.result_types, Val(:JAQCD)), c.basis_rotation_instructions))
Circuit(p::Program) = convert(Circuit, p)
Program(c::Circuit) = convert(Program, c)

function _add_measure!(c::Circuit, target_qubits::QubitSet)
    for (idx, target) in enumerate(target_qubits)
        num_qubits_measured = !isempty(c.measure_targets) && length(target_qubits) == 1 ? length(c.measure_targets) : 0
        add_instruction!(c, Instruction(Measure(idx - 1 + num_qubits_measured), target))
        push!(c.measure_targets, target)
    end
    return c
end
_add_measure!(c::Circuit, target_qubits::Vector{IntOrQubit}) = _add_measure!(c, QubitSet(target_qubits))
_add_measure!(c::Circuit, target_qubit::IntOrQubit) = _add_measure!(c, QubitSet(target_qubit))

"""
    measure(c::Circuit, target_qubits) -> Circuit

Add a [`Measure`](@ref) operator to `c`, ensuring only the targeted qubits are measured.
A `Measure` operation can **only** be applied if the circuit does **not** contain any result types.
If `c` has no qubits defined, or `target_qubits` are not within the qubit range of `c`,
an `ArgumentError` is raised. If the circuit `c` contains any result types, or any of the 
target qubits are already measured, an `ErrorException` is raised.

# Examples
```jldoctest
julia> circ = Circuit([(H, 0), (CNot, 0, 1)]);

julia> circ = measure(circ, 0);

julia> circ.instructions
3-element Vector{Braket.Instruction}:
 Braket.Instruction{H}(H(), QubitSet(0))
 Braket.Instruction{CNot}(CNot(), QubitSet(0, 1))
 Braket.Instruction{Measure}(Measure(0), QubitSet(0))

julia> circ = Circuit([(H, 0), (CNot, 0, 1), (StateVector,)]);

julia> circ = measure(circ, 0);
ERROR: a circuit cannot contain both measure instructions and result types.
[...]

julia> circ = Circuit([(H, 0), (CNot, 0, 1)]);

julia> circ = measure(circ, [0, 1, 0]);
ERROR: cannot repeat qubit(s) in the same measurement.
[...]
```
"""
function measure(c::Circuit, target_qubits)
    isempty(c.result_types) || error("a circuit cannot contain both measure instructions and result types.")
    # Check if there are repeated qubits in the same measurement
    allunique(target_qubits) || error("cannot repeat qubit(s) in the same measurement.")
    return _add_measure!(c, target_qubits)
end

function openqasm_header(c::Circuit, sps::SerializationProperties=OpenQASMSerializationProperties())
    ir_instructions = ["OPENQASM 3.0;"]
    for p in sort(string.(c.parameters))
        push!(ir_instructions, "input float $p;")
    end
    bit_count = isempty(c.measure_targets) ? qubit_count(c) : length(c.measure_targets)
    isempty(c.result_types) && push!(ir_instructions, "bit[$bit_count] b;")
    if sps.qubit_reference_type == VIRTUAL
        total_qubits = real(maximum(qubits(c))) + 1
        push!(ir_instructions, "qubit[$total_qubits] q;")
    end
    (sps.qubit_reference_type != PHYSICAL && sps.qubit_reference_type != VIRTUAL) && throw(ErrorException("invalid qubit reference type $(sps.qubit_reference_type) supplied."))
    return ir_instructions
end

"""
    ir(c::Circuit; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())

Convert a [`Circuit`](@ref) into IR that can be consumed by the
Amazon Braket service, whether local simulators, on-demand simulators, or QPUs.
The IR format to convert to by default is controlled by the global variable [`IRType`](@ref),
which can be modified. Currently `:JAQCD` and `:OpenQASM` are supported for `Circuit`s.
If writing to `OpenQASM` IR, optional [`OpenQASMSerializationProperties`](@ref) may be specified.
"""
ir(c::Circuit; serialization_properties::SerializationProperties=OpenQASMSerializationProperties()) = ir(c, Val(IRType[]), serialization_properties=serialization_properties)
function ir(c::Circuit, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    header = openqasm_header(c, serialization_properties)
    ixs = map(ix->ir(ix, Val(:OpenQASM); serialization_properties=serialization_properties), c.instructions)
    if !isempty(c.result_types)
        rts = map(rt->ir(rt, Val(:OpenQASM); serialization_properties=serialization_properties), c.result_types)
    elseif isempty(c.measure_targets) # measure all qubits if not explicitly specified
        rts = ["b[$(idx-1)] = measure $(format(Int(qubit), serialization_properties));" for (idx, qubit) in enumerate(qubits(c))]
    end
    return OpenQasmProgram(header_dict[OpenQasmProgram], join(vcat(header, ixs, rts), "\n"), nothing)
end
ir(c::Circuit, ::Val{:JAQCD}; kwargs...) = convert(Program, c)
ir(p::Program, ::Val{:JAQCD}; kwargs...) = p
ir(p::Program; kwargs...) = ir(p, Val(:JAQCD); kwargs...)

# convenience ctor for OpenQasmProgram
OpenQasmProgram(source::String; inputs::Union{Nothing, Dict}=nothing) = OpenQasmProgram(header_dict[OpenQasmProgram], source, inputs)

function Base.append!(c1::Circuit, c2::Circuit)
    foreach(ix->add_instruction!(c1, ix), c2.instructions)
    foreach(rt->add_result_type!(c1, rt), c2.result_types)
    return c1
end

Base.append!(c1::Circuit, c2::Circuit, target) = append!(c1, c2, Dict(q=>t for (q,t) in zip(sort(qubits(c2)), target)))

function Base.append!(c1::Circuit, c2::Circuit, target_mapping::Dict{<:Integer, <:Integer})
    foreach(ix->add_instruction!(c1, ix, target_mapping), c2.instructions)
    foreach(rt->add_result_type!(c1, rt, target_mapping), c2.result_types)
    return c1
end

extract_observable(rt::ObservableResult) = rt.observable
extract_observable(p::Probability) = Observables.Z()
extract_observable(rt::Result) = nothing 

function _encounter_noncommuting_observable!(c::Circuit)
    c.observables_simultaneously_measureable = false
    empty!(c.qubit_observable_mapping)
    empty!(c.qubit_observable_target_mapping)
    return c
end

function tensor_product_index_dict(o::Observables.TensorProduct, obs_targets::QubitSet)
    factors  = copy(o.factors)
    total    = qubit_count(first(factors))
    obj_dict = Dict{Int, Any}()
    i        = 0
    while length(factors) > 0
        if i >= total
            popfirst!(factors)
            if !isempty(factors)
                total += qubit_count(first(factors))
            end
        end
        if !isempty(factors)
            front = total - qubit_count(first(factors))
            obj_dict[i] = (first(factors), tuple([obs_targets[ii] for ii in front+1:total]...))
        end
        i += 1
    end
    return obj_dict
end

basis_rotation_gates(o::Observables.H) = (Ry(-π/4),)
basis_rotation_gates(o::Observables.X) = (H(),)
basis_rotation_gates(o::Observables.I) = ()
basis_rotation_gates(o::Observables.Z) = ()
basis_rotation_gates(o::Observables.Y) = (Z(), S(), H())
basis_rotation_gates(o::Observables.TensorProduct) = tuple(reduce(vcat, basis_rotation_gates.(o.factors))...)
basis_rotation_gates(o::Observables.HermitianObservable) = (Unitary(Matrix(adjoint(eigvecs(o.matrix)))),)


_observable_to_instruction(observable::Observables.Observable, target_list)::Vector{Instruction{<:Operator}} = [Instruction(gate, target_list) for gate in basis_rotation_gates(observable)]

"""
    basis_rotation_instructions!(c::Circuit)

Gets a list of basis rotation instructions and stores them in the circuit `c`.
These basis rotation instructions are added if result types are requested for
an observable other than Pauli-Z.

This only makes sense if all observables are simultaneously measurable;
if not, this method will return an empty list.
"""
function basis_rotation_instructions!(c::Circuit)
    # Note that basis_rotation_instructions can change each time a new instruction
    # is added to the circuit because `self._moments.qubits` would change
    basis_rotation_instructions = Instruction[]
    all_qubit_observable = get(c.qubit_observable_mapping, ALL_QUBITS, nothing)
    if !isnothing(all_qubit_observable)
        c.basis_rotation_instructions = reduce(vcat, _observable_to_instruction(all_qubit_observable, target) for target in qubits(c))
        return c
    end

    unsorted = collect(Set(values(c.qubit_observable_target_mapping)))
    target_lists = sort(unsorted)
    for target_list in target_lists
        observable = c.qubit_observable_mapping[first(target_list)]
        append!(basis_rotation_instructions, _observable_to_instruction(observable, target_list))
    end
    c.basis_rotation_instructions = basis_rotation_instructions
    return c
end

function add_to_qubit_observable_mapping!(c::Circuit, o::Observables.Observable, obs_targets::QubitSet)
    targets = length(obs_targets) > 0 ? obs_targets : collect(c.qubit_observable_set)
    all_qubits_observable = get(c.qubit_observable_mapping, ALL_QUBITS, nothing)
    id = Observables.I()
    for ii in 1:length(targets)
        target             = targets[ii]
        new_observable     = o
        current_observable = !isnothing(all_qubits_observable) ? all_qubits_observable : get(c.qubit_observable_mapping, target, nothing)
        add_observable     = isnothing(current_observable) || (current_observable == id && new_observable != id)
        !add_observable && current_observable != id && new_observable != id && new_observable != current_observable && return _encounter_noncommuting_observable!(c)
        if !isempty(obs_targets)
            new_targets = tuple(obs_targets...)
            if add_observable
                c.qubit_observable_target_mapping[target] = new_targets
                c.qubit_observable_mapping[target] = new_observable
            elseif qubit_count(new_observable) > 1
                current_target = get(c.qubit_observable_target_mapping, target, nothing)
                !isnothing(current_target) && current_target != new_targets && _encounter_noncommuting_observable!(c)
            end
        end
    end
    if isempty(obs_targets)
        !isnothing(all_qubits_observable) && all_qubits_observable != o && return _encounter_noncommuting_observable!(c)
        c.qubit_observable_mapping[ALL_QUBITS] = o
    end
    return c
end
add_to_qubit_observable_mapping!(c::Circuit, o::Observables.Observable, obs_targets::Nothing) = add_to_qubit_observable_mapping!(c, o, qubits(c))

function add_to_qubit_observable_mapping!(c::Circuit, o::Observables.TensorProduct, obs_targets::QubitSet)
    targets = length(obs_targets) != 0 ? obs_targets : collect(c.qubit_observable_set)
    all_qubits_observable = get(c.qubit_observable_mapping, ALL_QUBITS, nothing)
    tensor_product_dict = length(targets) > 0 ? tensor_product_index_dict(o, QubitSet(targets)) : Dict()
    id = Observables.I()
    for ii in 1:length(targets)
        target             = targets[ii]
        new_observable     = tensor_product_dict[ii-1][1]
        current_observable = !isnothing(all_qubits_observable) ? all_qubits_observable : get(c.qubit_observable_mapping, target, nothing)
        add_observable     = isnothing(current_observable) || (current_observable == id && new_observable != id)
        !add_observable && current_observable != id && new_observable != id && new_observable != current_observable && return _encounter_noncommuting_observable!(c)
        if !isempty(obs_targets)
            new_targets = tensor_product_dict[ii-1][2]
            if add_observable
                c.qubit_observable_target_mapping[target] = new_targets
                c.qubit_observable_mapping[target] = new_observable
            elseif qubit_count(new_observable) > 1
                current_target = get(c.qubit_observable_target_mapping, target, nothing)
                !isnothing(current_target) && current_target != new_targets && return _encounter_noncommuting_observable!(c)
            end
        end
    end
    if isempty(obs_targets)
        !isnothing(all_qubits_observable) && all_qubits_observable != o && return _encounter_noncommuting_observable!(c)
        c.qubit_observable_mapping[ALL_QUBITS] = o
    end
    return c
end
add_to_qubit_observable_mapping!(c::Circuit, o::Observables.Observable, obs_targets::Vector) = add_to_qubit_observable_mapping!(c, o, QubitSet(obs_targets))
add_to_qubit_observable_set!(c::Circuit, rt::ObservableResult) = union!(c.qubit_observable_set, Set(rt.targets))
add_to_qubit_observable_set!(c::Circuit, rt::AdjointGradient)  = union!(c.qubit_observable_set, Set(reduce(union, rt.targets)))
add_to_qubit_observable_set!(c::Circuit, rt::Result) = c.qubit_observable_set

function add_result_type!(c::Circuit, rt::Result)
    isempty(c.measure_targets) || error("cannot add a result type to a circuit which already contains a measure instruction.")
    rt_to_add = rt
    if rt_to_add ∉ c.result_types
        if rt_to_add isa AdjointGradient && any(rt_ isa AdjointGradient for rt_ in c.result_types)
            throw(ArgumentError("only one AdjointGradient result can be present on a circuit."))
        end
        obs = extract_observable(rt_to_add)
        if !isnothing(obs) && c.observables_simultaneously_measureable && !(rt isa AdjointGradient)
            add_to_qubit_observable_mapping!(c, obs, rt_to_add.targets)
        end
        add_to_qubit_observable_set!(c, rt_to_add)
        push!(c.result_types, rt_to_add)
    end
    return c
end
add_result_type!(c::Circuit, rt::Result, target) = add_result_type!(c, remap(rt, target))
add_result_type!(c::Circuit, rt::Result, target_mapping::Dict{<:Integer, <:Integer}) = add_result_type!(c, remap(rt, target_mapping))

function _check_if_qubit_measured(c::Circuit, qubit::Int)
    isempty(c.measure_targets) && return
    # check if there is a measure instruction on the targeted qubit(s)
    isempty(intersect(c.measure_targets, qubit)) || error("cannot apply instruction to measured qubits.")
end
_check_if_qubit_measured(c::Circuit, qubit::Qubit) = _check_if_qubit_measured(c, Int(qubit))
_check_if_qubit_measured(c::Circuit, qubits) = foreach(q->_check_if_qubit_measured(c, q), qubits)

function add_instruction!(c::Circuit, ix::Instruction{O}) where {O<:Operator}
    _check_if_qubit_measured(c, ix.target)
    to_add = [ix]
    if ix.operator isa QuantumOperator && Parametrizable(ix.operator) == Parametrized()
        for param in parameters(ix.operator)
            union!(c.parameters, (param,))
        end
    end
    push!(c.moments, to_add)
    push!(c.instructions, ix)
    return c
end

function add_instruction!(c::Circuit, @nospecialize(ix::Instruction{O}), target) where {O<:Operator}
    to_add = Instruction[]
    if qubit_count(ix.operator) == 1
        to_add = [remap(ix, q) for q in target]
    else
        to_add = [remap(ix, collect(target))]
    end
    foreach(ix->add_instruction!(c, ix), to_add)
    return c
end

function add_instruction!(c::Circuit, @nospecialize(ix::Instruction{O}), target_mapping::Dict{<:Integer, <:Integer}) where {O<:Operator}
    to_add = [remap(ix, target_mapping)]
    foreach(ix->add_instruction!(c, ix), to_add)
    return c
end

function add_verbatim_box!(c::Circuit, verbatim_circuit::Circuit, target_mapping::Dict{<:Integer, <:Integer}=Dict{Int, Int}())
    !isempty(verbatim_circuit.result_types) && throw(ErrorException("verbatim subcircuit is not measured and cannot have result types."))
    isempty(verbatim_circuit.measure_targets) || error("cannot measure a subcircuit inside a verbatim box.")
    isempty(verbatim_circuit.instructions) && return c
    c = add_instruction!(c, Instruction(StartVerbatimBox()))
    for ix in verbatim_circuit.instructions
        c = isempty(target_mapping) ? add_instruction!(c, ix) : add_instruction!(c, ix, target_mapping) 
    end
    c = add_instruction!(c, Instruction(EndVerbatimBox()))
    c.has_compiler_directives = true
    return c
end

function add_verbatim_box!(c::Circuit, verbatim_circuit::Circuit, target)
    sorted_qs = sort(collect(qubits(verbatim_circuit)))
    target_mapping = Dict(zip(sorted_qs, target))
    return add_verbatim_box!(c, verbatim_circuit, target_mapping)
end

function apply_noise_to_gates(noise::Vector{<:Noise}, target_qubits, instruction::Instruction, noise_index::Int, intersection, noise_applied::Bool, new_noise_ix::Vector)
    for noise_channel in noise
        if qubit_count(noise_channel) == 1
            for qubit in intersection
                noise_index += 1
                push!(new_noise_ix, (Instruction(noise_channel, qubit), noise_index))
                noise_applied = true
            end
        else
            if qubit_count(instruction.operator) == qubit_count(noise_channel) && instruction.target ⊆ target_qubits
                noise_index += 1
                push!(new_noise_ix, (Instruction(noise_channel, instruction.target), noise_index))
                noise_applied = true
            end
        end
    end
    return new_noise_ix, noise_index, noise_applied
end

function apply_gate_noise!(c::Circuit, noise::Vector{<:Noise}, target_gates::Vector{<:Gate}, target_qubits)
    qubit_count(c) == 0 && throw(ArgumentError("cannot apply noise to an empty circuit!"))
    t_gates       = unique(target_gates)
    new_moments   = Moments()
    noise_applied = false
    for moment_key in keys(c.moments)
        ix = c.moments[moment_key]
        if ix.operator isa Noise
            add_noise!(new_moments, ix, MomentType_tostr[moment_key.moment_type], moment_key.noise_index)
        else
            new_noise_ix = []
            noise_index = moment_key.noise_index
            if isempty(t_gates) || any(ix.operator isa typeof(g) for g in t_gates)
                overlap = intersect(ix.target, target_qubits)
                new_noise_ix, noise_index, noise_applied = apply_noise_to_gates(noise, target_qubits, ix, noise_index, overlap, noise_applied, new_noise_ix)
            end
            mt = ix.operator isa Gate ? mtGate : mtCompilerDirective
            push!(new_moments, [ix], mt, noise_index)
            for (nix, noise_index) in new_noise_ix
                add_noise!(new_moments, nix, "gate_noise", noise_index)
            end
        end
    end
    noise_applied == false && @warn "no noise applied" 
    c.moments = new_moments
    c.instructions = collect(values(c.moments._moments))
    return c
end
apply_gate_noise!(c::Circuit, noise::Noise, target_gates::Vector{<:Gate}, target_qubits) = apply_gate_noise!(c, [noise], target_gates, target_qubits)
apply_gate_noise!(c::Circuit, noise::Vector{<:Noise}, target_gates::Gate, target_qubits) = apply_gate_noise!(c, noise, [target_gates], target_qubits)
apply_gate_noise!(c::Circuit, noise::Noise, target_gates::Gate, target_qubits)           = apply_gate_noise!(c, [noise], [target_gates], target_qubits)
apply_gate_noise!(c::Circuit, noise::Noise, target_gates::Gate, target_qubit::IntOrQubit) = apply_gate_noise!(c, [noise], [target_gates], QubitSet(target_qubit))
apply_gate_noise!(c::Circuit, noise::Noise, target_gates::Gate) = apply_gate_noise!(c, [noise], [target_gates], qubits(c))
apply_gate_noise!(c::Circuit, noise, target_qubit) = apply_gate_noise!(c, noise, Gate[], target_qubit)
apply_gate_noise!(c::Circuit, noise) = apply_gate_noise!(c, noise, Gate[], qubits(c))

function apply_gate_noise!(c::Circuit, noise::Vector{<:Noise}, target_unitary::Matrix{<:Complex}, target_qubits)
    qubit_count(c) == 0 && throw(ArgumentError("cannot apply noise to an empty circuit!"))
    new_moments = Moments()
    noise_applied = false
    for moment_key in keys(c.moments)
        ix = c.moments[moment_key]
        if ix.operator isa Noise
            add_noise!(new_moments, ix, MomentType_tostr[moment_key.moment_type], moment_key.noise_index)
        else
            new_noise_ix = []
            noise_index = moment_key.noise_index
            if ix.operator isa Unitary && ix.operator.matrix ≈ target_unitary
                intersec = intersect(ix.target, target_qubits)
                new_noise_ix, noise_index, noise_applied = apply_noise_to_gates(noise, target_qubits, ix, noise_index, intersec, noise_applied, new_noise_ix)
            end
            push!(new_moments, [ix], moment_key.moment_type, noise_index)
            for (nix, noise_index) in new_noise_ix
                add_noise!(new_moments, nix, "gate_noise", noise_index)
            end
        end
    end
    noise_applied == false && @warn "no noise applied" 
    c.moments = new_moments
    c.instructions = collect(values(c.moments._moments))
    return c
end
apply_gate_noise!(c::Circuit, noise::Noise, target_unitary::Matrix{<:Complex}, target_qubits) = apply_gate_noise!(c, [noise], target_unitary, target_qubits)
apply_gate_noise!(c::Circuit, noise::Noise, target_unitary::Matrix{<:Complex}, target_qubit::IntOrQubit) = apply_gate_noise!(c, [noise], target_unitary, [target_qubit])
apply_gate_noise!(c::Circuit, noise, target_unitary::Matrix{<:Complex}) = apply_gate_noise!(c, noise, target_unitary, qubits(c))

function apply_noise_to_moments!(c::Circuit, noise::Vector{<:Noise}, target_qubits, ::Val{:readout})
    noise_ixs = []
    for noise_channel in noise
        if qubit_count(noise_channel) == 1
            new_ix = [Instruction(noise_channel, qubit) for qubit in target_qubits]
            append!(noise_ixs, new_ix)
        else
            append!(noise_ixs, [Instruction(noise_channel, target_qubits)])
        end
    end
    new_moments = Moments()
    for moment_key in keys(c.moments)
        ix = c.moments[moment_key]
        if ix.operator isa Noise
            push!(new_moments, ix, moment_key.moment_type, moment_key.noise_index)
        else
            push!(new_moments, [ix], moment_key.moment_type, moment_key.noise_index)
        end
    end
    for noise in noise_ixs
        add_noise!(new_moments, noise, "readout_noise")
    end
    c.moments = new_moments
    c.instructions = collect(values(c.moments._moments))
    return c
end

function apply_noise_to_moments!(c::Circuit, noise::Vector{<:Noise}, target_qubits, ::Val{:initialization})
    noise_ixs = []
    for noise_channel in noise
        if qubit_count(noise_channel) == 1
            new_ix = [Instruction(noise_channel, qubit) for qubit in target_qubits]
            append!(noise_ixs, new_ix)
        else
            append!(noise_ixs, [Instruction(noise_channel, target_qubits)])
        end
    end
    new_moments = Moments()
    for noise in noise_ixs
        add_noise!(new_moments, noise, "initialization_noise")
    end
    for moment_key in keys(c.moments)
        ix = c.moments[moment_key]
        if ix.operator isa Noise
            push!(new_moments, ix, moment_key.moment_type, moment_key.noise_index)
        else
            push!(new_moments, [ix], moment_key.moment_type, moment_key.noise_index)
        end
    end
    c.moments = sort_moments!(new_moments)
    c.instructions = collect(values(c.moments._moments))
    return c
end

apply_initialization_noise!(c::Circuit, noise::Vector{<:Noise}, target_qubits) = apply_noise_to_moments!(c, noise, target_qubits, Val(:initialization))
apply_initialization_noise!(c::Circuit, noise::Noise, target_qubits) = apply_initialization_noise!(c, [noise], target_qubits)
apply_initialization_noise!(c::Circuit, noise::Noise, target_qubit::Union{Int, Qubit}) = apply_initialization_noise!(c, [noise], [target_qubit])
apply_initialization_noise!(c::Circuit, noise::Vector{<:Noise}) = apply_initialization_noise!(c, noise, qubits(c))
apply_initialization_noise!(c::Circuit, noise::Noise) = apply_initialization_noise!(c, [noise], qubits(c))

apply_readout_noise!(c::Circuit, noise::Vector{<:Noise}, target_qubits) = apply_noise_to_moments!(c, noise, target_qubits, Val(:readout))
apply_readout_noise!(c::Circuit, noise::Noise, target_qubits) = apply_readout_noise!(c, [noise], target_qubits)
apply_readout_noise!(c::Circuit, noise::Noise, target_qubit::Union{Int, Qubit}) = apply_readout_noise!(c, [noise], [target_qubit])
apply_readout_noise!(c::Circuit, noise::Vector{<:Noise}) = apply_readout_noise!(c, noise, qubits(c))
apply_readout_noise!(c::Circuit, noise::Noise) = apply_readout_noise!(c, [noise], qubits(c))

obs_union = Union{String, Vector{String}, Observables.Observable}
for T in (:Expectation, :Variance, :Sample)
    @eval begin
        @doc """
            $($T)(c::Circuit, o, targets) -> Circuit
            $($T)(c::Circuit, o) -> Circuit
        
        Constructs a `$($T)` of an observable `o` on qubits `targets`
        and adds it as a result to [`Circuit`](@ref) `c`.
        
        `o` may be one of:
          - Any [`Observable`](@ref Braket.Observables.Observable)
          - A `String` corresponding to an `Observable` (e.g. \"x\")
          - A `Vector{String}` in which each element corresponds to an `Observable`

        `targets` may be one of:
          - A [`QubitSet`](@ref)
          - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
          - An `Int` or `Qubit`
          - Absent, in which case the observable `o` will be applied to all qubits provided it is a single qubit observable.

        # Examples
        ```jldoctest
        julia> c = Circuit();

        julia> c = H(c, collect(0:10));

        julia> c = $($T)(c, Braket.Observables.Z(), 0);

        julia> c = $($T)(c, Braket.Observables.X());
        ```
        """ $T(c::Circuit, o, targets) = add_result_type!(c, $T(o, targets))
        $T(c::Circuit, o, targets::Vararg{IntOrQubit}) = add_result_type!(c, $T(o, QubitSet(targets...)))
        $T(c::Circuit, o::obs_union) = add_result_type!(c, $T(o))
    end
end
"""
    Amplitude(c::Circuit, states) -> Circuit

Constructs an `Amplitude` measurement of `states`
and adds it as a result to [`Circuit`](@ref) `c`.

`states` may be of type:
  - `Vector{String}`
  - `String`
All elements of `states` must be `'0'` or `'1'`.

# Examples
```jldoctest
julia> c = Circuit();

julia> c = H(c, collect(0:3));

julia> c = Amplitude(c, "0000");
```
"""
Amplitude(c::Circuit, states) = (a = Amplitude(states); a(c))
"""
    Probability(c::Circuit, targets) -> Circuit
    Probability(c::Circuit) -> Circuit

Constructs a `Probability` measurement on qubits `targets`
and adds it as a result to [`Circuit`](@ref) `c`.

`targets` may be one of:
  - A [`QubitSet`](@ref)
  - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
  - An `Int` or `Qubit`
  - Absent, in which case the measurement will be applied to all qubits of `c`.

# Examples
```jldoctest
julia> c = Circuit();

julia> c = H(c, collect(0:3));

julia> c = Probability(c, 2);
```
"""
Probability(c::Circuit, targets) = (p = Probability(targets); p(c))
Probability(c::Circuit, targets::Vararg{IntOrQubit}) = (p = Probability(QubitSet(targets...)); p(c))
Probability(c::Circuit) = (p = Probability(); p(c))
"""
    DensityMatrix(c::Circuit, targets) -> Circuit

Constructs a `DensityMatrix` measurement on qubits `targets`
and adds it as a result to [`Circuit`](@ref) `c`.

`targets` may be one of:
  - A [`QubitSet`](@ref)
  - A `Vector` of `Int`s and/or [`Qubit`](@ref)s
  - An `Int` or `Qubit`
  - Absent, in which case the measurement will be applied to all qubits of `c`.

# Examples
```jldoctest
julia> c = Circuit();

julia> c = H(c, collect(0:3));

julia> c = DensityMatrix(c, 2);
```
"""
DensityMatrix(c::Circuit, targets) = (p = DensityMatrix(targets); p(c))
DensityMatrix(c::Circuit, targets::Vararg) = (p = DensityMatrix(QubitSet(targets...)); p(c))
DensityMatrix(c::Circuit) = (dm = DensityMatrix(); dm(c))
"""
    StateVector(c::Circuit) -> Circuit

Constructs a `StateVector` measurement on all qubits of `c`
and adds it as a result to [`Circuit`](@ref) `c`.

# Examples
```jldoctest
julia> c = Circuit();

julia> c = H(c, collect(0:3));

julia> c = StateVector(c);
```
"""
StateVector(c::Circuit) = (sv = StateVector(); sv(c))
        
"""
    AdjointGradient(c::Circuit, o::Observable, targets, parameters) -> Circuit

Constructs an `AdjointGradient` computation with respect to the expectation value of an observable `o`
on qubits `targets`, computing partial derivatives of `parameters`, and adds it as a result to [`Circuit`](@ref) `c`.

`o` may be any `Observable`. `targets` must be a `Vector` of `QubitSet`s (or a single `QubitSet`, if `o` is not a `Sum`),
each of which is the same length as the qubit count of the corresponding term in `o`.
`parameters` can have elements which are [`FreeParameter`](@ref)s or `String`s, or `["all"]`,
in which case the gradient is computed with respect to all parameters in the circuit.

# Examples
```jldoctest
julia> c = Circuit();

julia> α = FreeParameter("alpha");

julia> c = H(c, collect(0:10));

julia> c = Rx(c, collect(0:10), α);

julia> c = AdjointGradient(c, Braket.Observables.Z(), 0, [α]);
```
"""
AdjointGradient(c::Circuit, o::Observable, target::Vector{QubitSet}, parameters) = (ag = AdjointGradient(o, target, parameters); ag(c))
AdjointGradient(c::Circuit, o::Observable, target::Vector{Vector{T}}, parameters) where {T} = (ag = AdjointGradient(o, target, parameters); ag(c))
AdjointGradient(c::Circuit, o::Observable, target::Vector{<:IntOrQubit}, parameters) = (ag = AdjointGradient(o, target, parameters); ag(c))
AdjointGradient(c::Circuit, o::Observable, target::QubitSet, parameters) = (ag = AdjointGradient(o, [target], parameters); ag(c))
AdjointGradient(c::Circuit, o::Observable, target::IntOrQubit, parameters) = (ag = AdjointGradient(o, [target], parameters); ag(c))

function validate_circuit_and_shots(c::Circuit, shots::Int)
    isempty(c.instructions) && throw(ErrorException("Circuit must have instructions to run on a device."))
    shots==0 && isempty(c.result_types) && throw(ErrorException("Shots=0 without result types specified."))
    if shots > 0 && !isempty(c.result_types)
        !c.observables_simultaneously_measureable && throw(ErrorException("Observables cannot be measured simultaneously."))
        for rt in c.result_types
            (rt isa StateVector || rt isa Amplitude || rt isa AdjointGradient) && throw(ErrorException("StateVector or Amplitude cannot be specified when shots>0"))
            if rt isa Probability
                num_qubits = length(rt.targets) == 0 ? qubit_count(c) : length(rt.targets)
                num_qubits > 40 && throw(ErrorException("Probability target must be less than or equal to 40 qubits."))
            end
        end
    end
    return
end

Base.:(==)(c1::Circuit, c2::Circuit) = (c1.instructions == c2.instructions && c1.result_types == c2.result_types)
function Base.show(io::IO, program::OpenQasmProgram)
    print(io, "OpenQASM program")
end

using Test, Aqua, Braket, Braket.AWS, PyBraket

Aqua.test_all(PyBraket, ambiguities=false, unbound_args=false, piracies=false, persistent_tasks=false)
Aqua.test_ambiguities(PyBraket)

function set_aws_creds(test_type)
    if test_type == "unit"
        creds = Braket.AWS.AWSCredentials("", "")
        config = Braket.AWS.AWSConfig(creds, "", "")
        Braket.AWS.global_aws_config(config)
    elseif test_type == "integ"
        # should pickup correct creds from envvars 
        Braket.AWS.global_aws_config()
    else
        throw(ArgumentError("invalid test_type $test_type, must be one of 'integ' or 'unit'"))
    end
end

const GROUP = get(ENV, "GROUP", "PyBraket-unit")

groups = GROUP == "All" ? ["PyBraket-unit"] : [GROUP]

for group in groups
    @info "Testing $group"
    pkg_name  = String(split(group, "-")[1])
    test_type = String(split(group, "-")[2])

    set_aws_creds(test_type)

    if test_type == "unit"
        include(joinpath(@__DIR__, "ahs.jl"))
    end
end

export CompilerDirective, StartVerbatimBox, EndVerbatimBox

"""
    CompilerDirective <: Operator

Abstract type representing a directive to a device-specific compiler.
"""
abstract type CompilerDirective <: Operator end

"""
    StartVerbatimBox <: CompilerDirective

Directive to begin a region of "verbatim" instructions, which
will not be modified by any further compilation steps.
"""
struct StartVerbatimBox <: CompilerDirective end
"""
    EndVerbatimBox <: CompilerDirective

Directive to end a region of "verbatim" instructions, which
will not be modified by any further compilation steps.
"""
struct EndVerbatimBox <: CompilerDirective end
counterpart(s::StartVerbatimBox) = EndVerbatimBox()
counterpart(e::EndVerbatimBox)   = StartVerbatimBox()
ir(s::StartVerbatimBox, ::Val{:JAQCD}; kwargs...)    = IR.StartVerbatimBox("StartVerbatimBox", "start_verbatim_box")
ir(s::EndVerbatimBox,   ::Val{:JAQCD}; kwargs...)    = IR.EndVerbatimBox("EndVerbatimBox", "end_verbatim_box")
ir(s::StartVerbatimBox, ::Val{:OpenQASM}; kwargs...) = "#pragma braket verbatim\nbox{"
ir(s::EndVerbatimBox,   ::Val{:OpenQASM}; kwargs...) = "}"
ir(c::CompilerDirective; kwargs...)                  = ir(c, Val(IRType[]); kwargs...)
chars(s::StartVerbatimBox) = ("StartVerbatim","StartVerbatim")
chars(s::EndVerbatimBox)   = ("EndVerbatim","EndVerbatim")

StructTypes.subtypes(::Type{CompilerDirective}) = (start_verbatim_box=StartVerbatimBox, end_verbatim_box=EndVerbatimBox)

export Noise, Kraus, BitFlip, PhaseFlip, PauliChannel, AmplitudeDamping, PhaseDamping, Depolarizing, TwoQubitDephasing, TwoQubitDepolarizing, GeneralizedAmplitudeDamping, TwoQubitPauliChannel, MultiQubitPauliChannel
"""
    Noise <: QuantumOperator

Abstract type representing a quantum noise operation.
"""
abstract type Noise <: QuantumOperator end
StructTypes.StructType(::Type{Noise}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Noise}) = (noise=Noise, kraus=Kraus, bit_flip=BitFlip, phase_flip=PhaseFlip, pauli_channel=PauliChannel, amplitude_damping=AmplitudeDamping, phase_damping=PhaseDamping, depolarizing=Depolarizing, two_qubit_dephasing=TwoQubitDephasing, two_qubit_depolarizing=TwoQubitDepolarizing, generalized_amplitude_damping=GeneralizedAmplitudeDamping, multi_qubit_pauli_channel=MultiQubitPauliChannel)

const ProbabilityType = Union{Float64, FreeParameter}

"""
    Kraus <: Noise

Kraus noise operation.
"""
struct Kraus <: Noise
    matrices::Vector{Matrix{ComplexF64}}
end
Kraus(mats::Vector{Vector{Vector{Vector{Float64}}}}) = Kraus(complex_matrix_from_ir.(mats))
Base.:(==)(k1::Kraus, k2::Kraus) = k1.matrices == k2.matrices
ir(g::Kraus, target::QubitSet, ::Val{:JAQCD}; kwargs...) = IR.Kraus(collect(target), [complex_matrix_to_ir(mat) for mat in g.matrices], "kraus")
function ir(g::Kraus, target::QubitSet, ::Val{:OpenQASM}; serialization_properties::SerializationProperties=OpenQASMSerializationProperties())
    t   = format_qubits(collect(target), serialization_properties)
    ms  = join(format_matrix.(g.matrices), ", ")
    return "#pragma braket noise kraus($ms) $t"
end
qubit_count(g::Kraus) = convert(Int, log2(size(g.matrices[1], 1)))
chars(n::Kraus) = ntuple(i->"KR", qubit_count(n))

"""
    BitFlip <: Noise

BitFlip noise operation.
"""
struct BitFlip <: Noise
    probability::ProbabilityType
end
Parametrizable(g::BitFlip) = Parametrized()
n_targets(g::BitFlip) = Val(1)
n_targets(::Type{BitFlip}) = Val(1)
qubit_count(g::BitFlip) = 1
chars(n::BitFlip) = map(char->replace(string(char), "prob"=>string(n.probability)), ("BF(prob)",))
n_probabilities(::BitFlip)       = Val(1)
n_probabilities(::Type{BitFlip}) = Val(1)

"""
    PhaseFlip <: Noise

PhaseFlip noise operation.
"""
struct PhaseFlip <: Noise
    probability::ProbabilityType
end
Parametrizable(g::PhaseFlip) = Parametrized()
qubit_count(g::PhaseFlip) = 1
chars(n::PhaseFlip) = map(char->replace(string(char), "prob"=>string(n.probability)), ("PF(prob)",))
n_targets(g::PhaseFlip) = Val(1)
n_targets(::Type{PhaseFlip}) = Val(1)
n_probabilities(::PhaseFlip)       = Val(1)
n_probabilities(::Type{PhaseFlip}) = Val(1)

"""
    PauliChannel <: Noise

PauliChannel noise operation.
"""
struct PauliChannel <: Noise
    probX::ProbabilityType
    probY::ProbabilityType
    probZ::ProbabilityType
    PauliChannel(probX::TX, probY::TY, probZ::TZ) where {TX<:ProbabilityType, TY<:ProbabilityType, TZ<:ProbabilityType} = new(probX, probY, probZ)
end
n_targets(g::PauliChannel) = Val(1)
n_targets(::Type{PauliChannel}) = Val(1)
n_probabilities(::PauliChannel)       = Val(3)
n_probabilities(::Type{PauliChannel}) = Val(3)
Parametrizable(g::PauliChannel) = Parametrized()
qubit_count(g::PauliChannel) = 1
chars(n::PauliChannel) = map(char->replace(string(char), "prob"=>join([string(n.probX), string(n.probY), string(n.probX)], ", ")), ("PC(prob)",))

"""
    AmplitudeDamping <: Noise

AmplitudeDamping noise operation.
"""
struct AmplitudeDamping <: Noise
    gamma::ProbabilityType
end
n_targets(g::AmplitudeDamping) = Val(1)
n_targets(::Type{AmplitudeDamping}) = Val(1)
n_probabilities(::AmplitudeDamping)       = Val(1)
n_probabilities(::Type{AmplitudeDamping}) = Val(1)
Parametrizable(g::AmplitudeDamping) = Parametrized()
qubit_count(g::AmplitudeDamping) = 1
chars(n::AmplitudeDamping) = map(char->replace(string(char), "prob"=>string(n.gamma)), ("AD(prob)",))

"""
    PhaseDamping <: Noise

PhaseDamping noise operation.
"""
struct PhaseDamping <: Noise
    gamma::ProbabilityType
end
n_targets(g::PhaseDamping) = Val(1)
n_targets(::Type{PhaseDamping}) = Val(1)
n_probabilities(::PhaseDamping)       = Val(1)
n_probabilities(::Type{PhaseDamping}) = Val(1)
Parametrizable(g::PhaseDamping) = Parametrized()
qubit_count(g::PhaseDamping) = 1
chars(n::PhaseDamping) = map(char->replace(string(char), "prob"=>string(n.gamma)), ("PD(prob)",))

"""
    Depolarizing <: Noise

Depolarizing noise operation.
"""
struct Depolarizing <: Noise
    probability::ProbabilityType
end
n_targets(g::Depolarizing) = Val(1)
n_targets(::Type{Depolarizing}) = Val(1)
n_probabilities(::Depolarizing)       = Val(1)
n_probabilities(::Type{Depolarizing}) = Val(1)
Parametrizable(g::Depolarizing) = Parametrized()
qubit_count(g::Depolarizing) = 1
chars(n::Depolarizing) = map(char->replace(string(char), "prob"=>string(n.probability)), ("DEPO(prob)",))

"""
    TwoQubitDephasing <: Noise

TwoQubitDephasing noise operation.
"""
struct TwoQubitDephasing <: Noise
    probability::ProbabilityType
end
n_targets(g::TwoQubitDephasing) = Val(2)
n_targets(::Type{TwoQubitDephasing}) = Val(2)
n_probabilities(::TwoQubitDephasing)       = Val(1)
n_probabilities(::Type{TwoQubitDephasing}) = Val(1)
Parametrizable(g::TwoQubitDephasing) = Parametrized()
qubit_count(g::TwoQubitDephasing) = 2
chars(n::TwoQubitDephasing) = map(char->replace(string(char), "prob"=>string(n.probability)), ("DEPH(prob)", "DEPH(prob)"))

"""
    TwoQubitDepolarizing <: Noise

TwoQubitDepolarizing noise operation.
"""
struct TwoQubitDepolarizing <: Noise
    probability::ProbabilityType
end
n_targets(g::TwoQubitDepolarizing) = Val(2)
n_targets(::Type{TwoQubitDepolarizing}) = Val(2)
n_probabilities(::TwoQubitDepolarizing)       = Val(1)
n_probabilities(::Type{TwoQubitDepolarizing}) = Val(1)
Parametrizable(g::TwoQubitDepolarizing) = Parametrized()
qubit_count(g::TwoQubitDepolarizing) = 2
chars(n::TwoQubitDepolarizing) = map(char->replace(string(char), "prob"=>string(n.probability)), ("DEPO(prob)", "DEPO(prob)"))

"""
    GeneralizedAmplitudeDamping <: Noise

GeneralizedAmplitudeDamping noise operation.
"""
struct GeneralizedAmplitudeDamping <: Noise
    probability::ProbabilityType
    gamma::ProbabilityType
    GeneralizedAmplitudeDamping(probability::TP, gamma::TG) where {TP<:ProbabilityType, TG<:ProbabilityType} = new(probability, gamma) 
end
n_targets(g::GeneralizedAmplitudeDamping) = Val(1)
n_targets(::Type{GeneralizedAmplitudeDamping}) = Val(1)
n_probabilities(::GeneralizedAmplitudeDamping)       = Val(2)
n_probabilities(::Type{GeneralizedAmplitudeDamping}) = Val(2)
Parametrizable(g::GeneralizedAmplitudeDamping) = Parametrized()
qubit_count(g::GeneralizedAmplitudeDamping) = 1
chars(n::GeneralizedAmplitudeDamping) = map(char->replace(string(char), "prob"=>join([string(n.gamma), string(n.probability)], ", ")), ("GAD(prob)",))

"""
    MultiQubitPauliChannel{N} <: Noise

Pauli channel noise operation on `N` qubits.
"""
struct MultiQubitPauliChannel{N} <: Noise
    probabilities::Dict{String, Union{Float64, FreeParameter}}
end
"""
    TwoQubitPauliChannel <: Noise

Pauli channel noise operation on two qubits.
"""
TwoQubitPauliChannel = MultiQubitPauliChannel{2} 
qubit_count(g::MultiQubitPauliChannel{N}) where {N} = N
Parametrizable(g::MultiQubitPauliChannel) = Parametrized()
ir(g::MultiQubitPauliChannel{N}, target::QubitSet, ::Val{:JAQCD}; kwargs...) where {N} = IR.MultiQubitPauliChannel(g.probabilities, collect(target), "multi_qubit_pauli_channel")
function MultiQubitPauliChannel(probabilities::Dict{String, <:Union{Float64, FreeParameter}})
    N = length(first(keys(probabilities)))
    return MultiQubitPauliChannel{N}(probabilities)
end
Base.:(==)(c1::MultiQubitPauliChannel{N}, c2::MultiQubitPauliChannel{M}) where {N,M} = N == M && c1.probabilities == c2.probabilities
chars(n::TwoQubitPauliChannel) = ("PC2", "PC2")
n_controls(n::Noise) = Val(0)
targets_and_controls(n::N, target::QubitSet) where {N<:Noise} = targets_and_controls(n_controls(n), n_targets(n), target)
for (N, IRN, label) in zip((:BitFlip, :PhaseFlip, :PauliChannel, :AmplitudeDamping, :PhaseDamping, :Depolarizing, :TwoQubitDephasing, :TwoQubitDepolarizing, :GeneralizedAmplitudeDamping), (:(IR.BitFlip), :(IR.PhaseFlip), :(IR.PauliChannel), :(IR.AmplitudeDamping), :(IR.PhaseDamping), :(IR.Depolarizing), :(IR.TwoQubitDephasing), :(IR.TwoQubitDepolarizing), :(IR.GeneralizedAmplitudeDamping)), ("bit_flip", "phase_flip", "pauli_channel", "amplitude_damping", "phase_damping", "depolarizing", "two_qubit_dephasing", "two_qubit_depolarizing", "generalized_amplitude_damping"))
    @eval begin
        function ir(n::$N, target::QubitSet, ::Val{:JAQCD}; kwargs...)
            t_c = targets_and_controls(n, target)
            ir_args = (getproperty(n, fn) for fn in fieldnames($N))
            return $IRN(ir_args..., t_c[2], $label)
        end
        function ir(n::$N, target::QubitSet, ::Val{:OpenQASM}; serialization_properties=OpenQASMSerializationProperties())
            t   = format_qubits(target, serialization_properties)
            ir_args = join([repr(getproperty(n, fn)) for fn in fieldnames($N)], ", ")
            return "#pragma braket noise " * $label * "($ir_args) $t"
        end
    end
end
Parametrizable(g::Noise) = NonParametrized()
parameters(g::Noise) = parameters(Parametrizable(g), g)
parameters(::Parametrized, g::N) where {N<:Noise} = filter(x->x isa FreeParameter, [getproperty(g, fn) for fn in fieldnames(N)])
parameters(::NonParametrized, g::Noise) = FreeParameter[]
bind_value!(n::N, params::Dict{Symbol, <:Number}) where {N<:Noise} = bind_value!(Parametrizable(n), n, params)
bind_value!(::NonParametrized, n::N, params::Dict{Symbol, <:Number}) where {N<:Noise} = n
ir(g::Noise, target::Int, args...) = ir(g, QubitSet(target), args...)

function bind_value!(::Parametrized, g::N, params::Dict{Symbol, Number}) where {N<:Noise}
    new_args = OrderedDict(zip(fieldnames(N), (getproperty(g, fn) for fn in fieldnames(N)))) 
    for fp in findall(v->v isa FreeParameter, new_args)
        new_args[fp] = get(params, getproperty(g, fp).name, new_args[fp])
    end
    return N(values(new_args)...)
end
function Base.Dict(n::N) where {N<:Noise}
    type_dict = convert(Dict, StructTypes.subtypes(Noise))
    rev_type_dict = Dict(zip(values(type_dict), string.(keys(type_dict))))
    field_dict = Dict(string(fn)=>getproperty(n, fn) for fn in fieldnames(N))
    return merge(Dict("type"=>rev_type_dict[N]), field_dict)
end
function Noise(d::Dict{String})
    noise_t = StructTypes.subtypes(Noise)[Symbol(d["type"])]
    return noise_t([d[string(fn)] for fn in fieldnames(noise_t)]...)
end

import StructTypes

export AtomArrangementItem, AtomArrangement, TimeSeriesItem, TimeSeries, Field, DrivingField
export ShiftingField, Hamiltonian, AnalogHamiltonianSimulation, Pattern, vacant, filled, SiteType, discretize

"""
    Hamiltonian

Abstract type representing a term in the Hamiltonian to simulate.
"""
abstract type Hamiltonian end

@enum SiteType vacant filled
SiteTypeDict = Dict(string(inst)=>inst for inst in instances(SiteType))
Base.:(==)(x::SiteType, y::String) = string(x) == y
Base.:(==)(x::String, y::SiteType) = string(y) == x

"""
    AtomArrangementItem

Represents a coordinate and filling in a setup for neutral atom simulation.
"""
struct AtomArrangementItem
    coordinate::Tuple{Number, Number}
    site_type::SiteType
end

"""
    AtomArrangementItem(coord::Tuple{Number, Number}, site_type::SiteType=filled)

Create a coordinate with filling `site_type` (either `vacant` or `filled`). Default filling is `filled`.
"""
AtomArrangementItem(coord::Tuple{Number, Number}) = AtomArrangementItem(coord, filled)

"""
    TimeSeriesItem
    TimeSeriesItem(time::Number, value::Number)

Struct representing a `value` in a [`TimeSeries`](@ref) which occurs at `time`.
"""
struct TimeSeriesItem
    time::Number
    value::Number
end
Base.isless(ts1::TimeSeriesItem, ts2::TimeSeriesItem) = ts1.time < ts2.time

"""
    TimeSeries
    TimeSeries()

Struct representing a series of values in a neutral atom simulation.
"""
mutable struct TimeSeries
    series::OrderedDict{Number, TimeSeriesItem}
    sorted::Bool
    largest_time::Int
end
TimeSeries() = TimeSeries(OrderedDict{Number, TimeSeriesItem}(), true, -1)

StructTypes.defaults(::Type{TimeSeries}) = Dict{Symbol, Any}(:sorted => true, :series => OrderedDict{Number, TimeSeriesItem}(), :largest_time => -1)
struct Pattern
    series::Vector{Number}
end
"""
    Field
    Field(time_series::TimeSeries, [pattern::Pattern]) -> Field

Representation of a generic field in a [`Hamiltonian`](@ref).
"""
struct Field
    time_series::TimeSeries
    pattern::Union{Nothing, Pattern}
end
Field(ts::TimeSeries) = Field(ts, nothing) 

StructTypes.defaults(::Type{Field}) = Dict{Symbol, Any}(:pattern => nothing)
const AtomArrangement = Vector{AtomArrangementItem}

"""
    AnalogHamiltonianSimulation

Struct representing instructions for an analog Hamiltonian simulation on a neutral atom device.
"""
struct AnalogHamiltonianSimulation
    register::AtomArrangement
    hamiltonian::Vector{<:Hamiltonian}
end
"""
    AnalogHamiltonianSimulation(register::AtomArrangement, hamiltonian) -> AnalogHamiltonianSimulation

Constructs an `AnalogHamiltonianSimulation` on a specific atom
arrangement `register` and with [`Hamiltonian`](@ref) terms `hamiltonian`.
"""
AnalogHamiltonianSimulation(register::AtomArrangement, hamiltonian::Hamiltonian) = AnalogHamiltonianSimulation(register, [hamiltonian])

# 
"""
    DrivingField <: Hamiltonian
    DrivingField(amplitude::Union{Field, TimeSeries}, phase::Union{Field, TimeSeries}, detuning::Union{Field, TimeSeries}) -> DrivingField

Represents a driving field in a [`Hamiltonian`](@ref) which coherently transfers atoms
from the ground state to the Rydberg state in an [`AnalogHamiltonianSimulation`](@ref).


```math
H_{df}(t) = \\frac{1}{2} \\Omega(t)\\exp(i \\phi(t)) \\sum_k \\left( | g_k \\rangle\\langle r_k | + h.c.\\right) - \\Delta(t) \\sum_k| r_k \\rangle\\langle r_k |
```

Where ``\\left| g_k \\right\\rangle`` is the ground state of atom ``k`` and ``\\left| r_k \\right\\rangle`` is the Rydberg state of atom ``k``.

# Arguments
  - `amplitude` represents the global amplitude ``\\Omega(t)``. The time is in units of seconds, and the value is in radians/second.
  - `phase` represents the global phase ``\\phi(t)``. The time is in units of seconds, and the value is in radians/second.
  - `detuning` represents the global detuning ``\\Delta(t)``. The time is in units of seconds, and the value is in radians/second.
"""
struct DrivingField <: Hamiltonian
    amplitude::Field
    phase::Field
    detuning::Field
end
DrivingField(t1::TimeSeries, t2::TimeSeries, t3::TimeSeries) = DrivingField(Field(t1), Field(t2), Field(t3))

"""
    ShiftingField <: Hamiltonian
    ShiftingField(magnitude::Union{Field, TimeSeries}) -> ShiftingField

Represents a shifting field in a [`Hamiltonian`](@ref) which changes the energy of the Rydberg level in 
an [`AnalogHamiltonianSimulation`](@ref).

```math
H_{sf}(t) = - \\Delta(t) \\sum_k h_k \\left| r_k \\right\\rangle\\left\\langle r_k \\right|
```

Where ``\\left| r_k \\right\\rangle`` is the Rydberg state of atom ``k``, and ``h_k`` is the local pattern of
unitless real numbers between 0 and 1.

The argument `magnitude` represents the global magnitude time series ``\\Delta(t)``, where time is in units of seconds
and values are in units of radians / second.
"""
struct ShiftingField <: Hamiltonian
    magnitude::Field
end

Base.push!(aa::AtomArrangement, coord::Tuple{Number, Number}, site_type::SiteType=filled) = push!(aa, AtomArrangementItem(coord, site_type))

Base.issorted(ts::TimeSeries) = ts.sorted
function times(ts::TimeSeries)
    sort!(ts)
    return [t.time for t in values(ts.series)]
end

function Base.values(ts::TimeSeries)
    sort!(ts)
    return [t.value for t in values(ts.series)]
end

function Base.sort!(ts::TimeSeries)
    if !ts.sorted
        ts.series = OrderedDict(sort!(collect(ts.series)))
        ts.sorted = true
    end
    return ts
end

function Base.setindex!(ts::TimeSeries, value::Number, time::Number)
    if !haskey(ts.series, time) && time <= maximum(keys(ts.series), init=-1e7)
        ts.sorted = false
    end
    ts.series[time] = TimeSeriesItem(time, value)
    return ts    
end

StructTypes.StructType(::Type{TimeSeries}) = StructTypes.UnorderedStruct()
StructTypes.StructType(::Type{Field}) = StructTypes.UnorderedStruct()
StructTypes.StructType(::Type{H}) where {H<:Hamiltonian} = StructTypes.UnorderedStruct()
"""
    ir(ahs::AnalogHamiltonianSimulation)

Generate IR from an [`AnalogHamiltonianSimulation`](@ref) which can be run on
a neutral atom simulator or quantum device.
"""
ir(ahs::AnalogHamiltonianSimulation; kwargs...) = AHSProgram(header_dict[AHSProgram], IR.Setup(ir(ahs.register)), ir(ahs.hamiltonian))
ir(aa::AtomArrangement) = IR.AtomArrangement([collect(site.coordinate) for site in aa], [site.site_type == filled ? 1 : 0 for site in aa])
function ir(h::Vector{<:Hamiltonian})
    h_dict = Dict("drivingFields"=>[], "shiftingFields"=>[])
    for f in h
        f isa DrivingField  && push!(h_dict["drivingFields"],  ir(f))
        f isa ShiftingField && push!(h_dict["shiftingFields"], ir(f))
    end
    return IR.Hamiltonian(h_dict["drivingFields"], h_dict["shiftingFields"])
end

function ir(df::DrivingField)
    return IR.DrivingField(ir(df.amplitude), ir(df.phase), ir(df.detuning))
end

function ir(sf::ShiftingField)
    return IR.ShiftingField(ir(sf.magnitude))
end

function ir(f::Field)
    pat = isnothing(f.pattern) ? "uniform" : convert(Vector{Dec128}, f.pattern.series)
    return IR.PhysicalField(IR.TimeSeries(values(f.time_series), times(f.time_series)), pat)
end

struct DiscretizationProperties
    lattice
    rydberg
end

function discretize(aa::AtomArrangement, properties::DiscretizationProperties)
    position_res = properties.lattice.geometry.positionResolution
    discretized_arrangement = map(aa) do site
        new_coordinates = map(c->(round(Dec128(c) / position_res) * position_res), site.coordinate)
        return AtomArrangementItem(new_coordinates, site.site_type)
    end
    return discretized_arrangement
end

discretize(p::Pattern, resolution::Dec128) = Pattern(map(x->round(Dec128(x) / resolution) * resolution, p.series))

function discretize(ts::TimeSeries, time_resolution::Dec128, value_resolution::Dec128)
    discretized_ts = TimeSeries()
    for val in values(ts.series)
        d_tsi = round(Dec128(val.time) / time_resolution) * time_resolution
        d_val = round(Dec128(val.value) / value_resolution) * value_resolution
        discretized_ts[d_tsi] = d_val
    end
    return discretized_ts
end

function discretize(f::Field, time_resolution::Dec128, value_resolution::Dec128, pattern_resolution::Union{Nothing, Dec128}=nothing)
    discretized_time_series = discretize(f.time_series, time_resolution, value_resolution)
    !isnothing(f.pattern) && isnothing(pattern_resolution) && throw(ErrorException("$(f.pattern) is defined but has no pattern_resolution defined."))
    discretized_pattern = isnothing(f.pattern) ? nothing : discretize(f.pattern, pattern_resolution)
    return Field(discretized_time_series, discretized_pattern)
end

function discretize(sf::ShiftingField, properties::DiscretizationProperties)
    shifting_parameters = properties.rydberg.rydbergLocal
    discretized_magnitude = discretize(sf.magnitude,
        Dec128(shifting_parameters.timeResolution),
        Dec128(shifting_parameters.commonDetuningResolution),
        Dec128(shifting_parameters.localDetuningResolution),
    )
    return ShiftingField(discretized_magnitude)
end

function discretize(df::DrivingField, properties::DiscretizationProperties)
    driving_parameters    = properties.rydberg.rydbergGlobal
    time_resolution       = Dec128(driving_parameters.timeResolution)
    discretized_amplitude = discretize(df.amplitude, time_resolution, Dec128(driving_parameters.rabiFrequencyResolution))
    discretized_phase     = discretize(df.phase, time_resolution, Dec128(driving_parameters.phaseResolution))
    discretized_detuning  = discretize(df.detuning, time_resolution, Dec128(driving_parameters.detuningResolution))
    return DrivingField(discretized_amplitude, discretized_phase, discretized_detuning)
end

"""
    discretize(ahs::AnalogHamiltonianSimulation, device::Device)

Creates a new [`AnalogHamiltonianSimulation`](@ref) with all numerical values represented
as `Dec128` objects with fixed precision based on the capabilities of the `device`.
"""
function discretize(ahs::AnalogHamiltonianSimulation, device::Device)
    required_action_schema = "braket.ir.ahs.program"
    if !haskey(device._properties.action, required_action_schema) || device._properties.action[required_action_schema].actionType != required_action_schema
        throw(ErrorException("AwsDevice $device does not accept $required_action_schema action schema."))
    end
    properties = DiscretizationProperties(device._properties.paradigm.lattice, device._properties.paradigm.rydberg)
    return AnalogHamiltonianSimulation(
        discretize(ahs.register, properties), map(h->discretize(h, properties), ahs.hamiltonian)
    )
end

using InteractiveUtils

"""
    Instruction
    Instruction(o::Operator, target)

Represents a single operation applied to a [`Circuit`](@ref).
Contains an `operator`, which may be any subtype of [`Operator`](@ref),
and a `target` set of qubits to which the `operator` is applied.

# Examples
```jldoctest
julia> Braket.Instruction(H(), 1)
Braket.Instruction{H}(H(), QubitSet(1))

julia> Braket.Instruction(CNot(), [1, Qubit(4)])
Braket.Instruction{CNot}(CNot(), QubitSet(1, Qubit(4)))

julia> Braket.Instruction(StartVerbatimBox(), QubitSet())
Braket.Instruction{StartVerbatimBox}(StartVerbatimBox(), QubitSet())
```
"""
struct Instruction{O<:Operator}
    operator::O
    target::QubitSet
end
Instruction(o::O, target...) where {O<:Operator} = Instruction{O}(o, QubitSet(target...))
Instruction(o::O, target) where {O<:Operator} = Instruction{O}(o, QubitSet(target...))
Instruction{CD}(cd::CD) where {CD<:CompilerDirective} = Instruction{CD}(cd, QubitSet(Int[]))
Instruction(cd::CD) where {CD<:CompilerDirective} = Instruction{CD}(cd, Int[])
operator(ix::Instruction{O}) where {O<:Operator} = ix.operator
StructTypes.StructType(::Type{Instruction{O}}) where {O} = StructTypes.CustomStruct()
StructTypes.StructType(::Type{Instruction}) = StructTypes.CustomStruct()
StructTypes.lower(x::Instruction{O}) where {O<:Operator} = isempty(x.target) ? ir(x.operator, Val(:JAQCD)) : ir(x.operator, x.target, Val(:JAQCD))
ir(x::Instruction{O}, ::Val{:OpenQASM}; kwargs...) where {O<:Operator} = isempty(x.target) ? ir(x.operator, Val(:OpenQASM); kwargs...) : ir(x.operator, x.target, Val(:OpenQASM); kwargs...)

conc_types = filter(Base.isconcretetype, vcat(subtypes(AbstractIR), subtypes(CompilerDirective)))
nt_dict    = merge([Dict(zip(fieldnames(t), (Union{Nothing, x} for x in fieldtypes(t)))) for t in conc_types]...)
ks         = tuple(keys(nt_dict)...)
vs         = Tuple{values(nt_dict)...}
inst_typ   = NamedTuple{ks, vs}
StructTypes.lowertype(::Type{Instruction{O}}) where {O} = inst_typ
StructTypes.lowertype(::Type{Instruction}) = inst_typ
Instruction(x::Instruction{O}) where {O<:Braket.Operator} = x
function Instruction(x)
    sts    = merge(StructTypes.subtypes(Gate), StructTypes.subtypes(Noise), StructTypes.subtypes(CompilerDirective))
    o_type = sts[Symbol(x[:type])]
    (o_type <: CompilerDirective) && return Instruction(o_type(), Int[])
    if o_type <: AngledGate{1}
        o_fns  = (:angles, :angle)
        args   = (Float64(x[:angle]),)
        op     = o_type(args)
    elseif o_type <: AngledGate{2}
        o_fns  = (:angles, :angle1, :angle2) 
        args   = tuple([x[fn] for fn in [Symbol("angle$i") for i in 1:n_angles(o_type)]]...)
        op     = o_type(args)
    elseif o_type <: AngledGate{3}
        o_fns  = (:angles, :angle1, :angle2, :angle3) 
        args   = tuple([x[fn] for fn in [Symbol("angle$i") for i in 1:n_angles(o_type)]]...)
        op     = o_type(args)
    else
        o_fns  = fieldnames(o_type)
        args   = [x[fn] for fn in o_fns]
        op     = o_type(args...)
    end
    raw_target  = Int[]
    target_keys = collect(setdiff(keys(x), vcat(o_fns..., :type)))
    for k in sort(target_keys, by=(x->occursin("target", string(x))))
        v = get(x, k, nothing)
        !isnothing(v) && append!(raw_target, v)
    end
    target = reduce(vcat, raw_target)
    return Instruction(op, target)
end
Instruction(x::Dict{String, <:Any}) = Instruction(Dict(Symbol(k)=>v for (k,v) in x))
StructTypes.constructfrom(::Type{Instruction}, x::Union{Dict{Symbol, Any}, NamedTuple}) = Instruction(x)
Base.:(==)(ix1::Instruction{O}, ix2::Instruction{O}) where {O<:Operator} = (ix1.operator == ix2.operator && ix1.target == ix2.target)
qubits(ix::Instruction{O}) where {O<:Operator} = ix.target
qubit_count(ix::Instruction{O}) where {O<:Operator} = length(ix.target)
qubits(ixs::Vector{Instruction{O}}) where {O<:Operator}  = mapreduce(ix->ix.target, union!, ixs, init=Set{Int}())
qubits(ixs::Vector{Instruction}) = mapreduce(ix->ix.target, union!, ixs, init=Set{Int}())
qubit_count(ixs::Vector{Instruction{O}}) where {O<:Operator} = length(qubits(ixs)) 
qubit_count(ixs::Vector{Instruction}) = length(qubits(ixs)) 

bind_value!(ix::Instruction{O}, param_values::Dict{Symbol, Number}) where {O<:Operator} = Instruction{O}(bind_value!(ix.operator, param_values), ix.target)

remap(@nospecialize(ix::Instruction{O}), mapping::Dict{<:Integer, <:Integer}) where {O} = Instruction{O}(copy(ix.operator), [mapping[q] for q in ix.target])
remap(@nospecialize(ix::Instruction{O}), target::VecOrQubitSet) where {O} = Instruction{O}(copy(ix.operator), target[1:length(ix.target)])
remap(@nospecialize(ix::Instruction{O}), target::IntOrQubit) where {O} = Instruction{O}(copy(ix.operator), target)

function StructTypes.constructfrom(::Type{Program}, obj)
    new_obj = copy(obj)
    for (i, k) in enumerate(fieldnames(Program))
        if !haskey(new_obj, k) || (haskey(StructTypes.defaults(Program), k) && isnothing(new_obj[k]))
            new_obj[k] = StructTypes.defaults(Program)[k]
        end
    end
    new_obj[:instructions] = StructTypes.constructfrom(Vector{Instruction}, new_obj[:instructions])
    return StructTypes.constructfrom(StructTypes.StructType(Program), Program, new_obj)
end

using OrderedCollections

"""
    Qubit <: Integer

Wrapper `struct` representing a qubit.

# Examples
```jldoctest
julia> q = Qubit(0)
Qubit(0)

julia> q == 0
true
```
"""
struct Qubit <: Integer
    index::Int
    Qubit(q::Integer) = new(q)
    Qubit(q::AbstractFloat) = new(Int(q))
    Qubit(q::DecFP.DecimalFloatingPoint) = new(Int(q))
    Qubit(q::BigFloat) = new(Int(q))
end
Qubit(q::Qubit) = q
Base.:(==)(q::Qubit, i::T) where {T<:Integer} = q.index==i
Base.:(==)(i::T, q::Qubit) where {T<:Integer} = q.index==i
Base.:(==)(i::BigInt, q::Qubit) = big(q.index)==i
Base.:(==)(q::Qubit, i::BigInt) = big(q.index)==i
Base.:(==)(q1::Qubit, q2::Qubit) = q1.index==q2.index
# ambiguity fix
Base.:(==)(q::Qubit, cvi::CSV.SentinelArrays.ChainedVectorIndex) = (q.index == civ.i)
Base.:(==)(cvi::CSV.SentinelArrays.ChainedVectorIndex, q::Qubit) = (q.index == civ.i)

Base.convert(::Type{Int}, q::Qubit) = q.index
Base.Int(q::Qubit) = q.index
Base.hash(q::Qubit, h::UInt) = hash(q.index, h)
Base.show(io::IO, q::Qubit) = print(io, "Qubit($(q.index))")
const IntOrQubit    = Union{Int, Qubit}

"""
    QubitSet

An `OrderedSet`-like object which represents the qubits a
[`Circuit`](@ref), [`Instruction`](@ref), or [`Result`](@ref)
acts on and their ordering.
Elements may be `Int`s or [`Qubit`](@ref)s.

# Examples
```jldoctest
julia> QubitSet(1, Qubit(0))
QubitSet with 2 elements:
  1
  Qubit(0)

julia> QubitSet([2, 1])
QubitSet with 2 elements:
  2
  1

julia> QubitSet()
QubitSet()

julia> QubitSet(QubitSet(5, 1))
QubitSet with 2 elements:
  5
  1
```
"""
struct QubitSet <: AbstractSet{Int}
    dict::OrderedDict{IntOrQubit, Nothing}
    QubitSet()   = new(OrderedDict{IntOrQubit, Nothing}())
    QubitSet(xs) = (v = foldl(vcat, xs, init=Int[]); return union!(new(OrderedDict{IntOrQubit,Nothing}()), v))
    QubitSet(qs::Vararg{IntOrQubit}) = QubitSet(collect(qs))
    QubitSet(qs::QubitSet) = qs
    QubitSet(::Nothing) = QubitSet()
end
Base.convert(::Type{Vector{Int}}, qs::QubitSet) = convert.(Int, collect(qs))
Base.length(qs::QubitSet)   = length(qs.dict)
Base.lastindex(qs::QubitSet) = length(qs)
Base.isempty(qs::QubitSet)  = isempty(qs.dict)
Base.in(q, qs::QubitSet)    = haskey(qs.dict, q)
Base.push!(qs::QubitSet, q) = (qs.dict[q] = nothing; qs)
Base.copy(qs::QubitSet)     = QubitSet(qs[ii] for ii in 1:length(qs))
Base.popfirst!(qs::QubitSet) = (q = popfirst!(qs.dict); return q[1])
function Base.iterate(qs::QubitSet)::Union{Nothing, Tuple{IntOrQubit, Int}}
    qs.dict.ndel > 0 && OrderedCollections.rehash!(qs.dict)
    length(qs.dict.keys) < 1 && return nothing
    return (qs.dict.keys[1], 2)
end
function Base.iterate(qs::QubitSet, i)::Union{Nothing, Tuple{IntOrQubit, Int}}
    length(qs.dict.keys) < i && return nothing
    return (qs.dict.keys[i], i+1)
end
Base.:(==)(q1::QubitSet, q2::QubitSet) = (length(q1) == length(q2)) && all(q1[ii] == q2[ii] for ii in 1:length(q1))

function Base.getindex(qs::QubitSet, i::Int)
    qs.dict.ndel > 0 && OrderedCollections.rehash!(qs.dict)
    return qs.dict.keys[i]
end
Base.getindex(qs::QubitSet, ui::UnitRange) = QubitSet([qs[ii] for ii in ui])

function Base.intersect(qs1::QubitSet, qs2::QubitSet)
    qs = QubitSet()
    for q in qs1
        (q in qs2) && union!(qs, q)
    end
    return qs
end

function Base.show(io::IO, qs::QubitSet)
    print(io, "QubitSet(")
    print(io, join([sprint(show, q) for q in qs], ", "))
    print(io, ")")
end
Base.convert(::Type{QubitSet}, q::Integer) = QubitSet(q)
Base.convert(::Type{QubitSet}, v::Vector{<:Integer}) = QubitSet(v)
Base.sort(qs::QubitSet; kwargs...) = QubitSet(sort(collect(qs); kwargs...))

const VecOrQubitSet = Union{Vector, QubitSet}

using Braket, Test

RIGETTI_ARN = "arn:aws:braket:::device/qpu/rigetti/Aspen-M-3"
IONQ_ARN = "arn:aws:braket:us-east-1::device/qpu/ionq/Aria-1"
SIMULATOR_ARN = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"
IQM_ARN = "arn:aws:braket:eu-north-1::device/qpu/iqm/Garnet"

@testset "Device Creation" begin
    @testset for dev_arn in (RIGETTI_ARN, IONQ_ARN, IQM_ARN, SIMULATOR_ARN)
        device = AwsDevice(dev_arn)
        @test arn(device) == dev_arn
        @test !isnothing(name(device)) && !isempty(name(device))
        @test !isnothing(provider_name(device)) && !isempty(provider_name(device))
        @test !isnothing(status(device)) && !isnothing(status(device))
        @test !isnothing(type(device)) && !isnothing(type(device))
        @test !isnothing(properties(device))
    end
    @testset "get_devices" begin
        @testset for dev_arn in [RIGETTI_ARN, IONQ_ARN, IQM_ARN, SIMULATOR_ARN]
            results = get_devices(arns=[dev_arn])
            @test arn(first(results)) == dev_arn
        end
        @testset "others" begin
            provider_names = ["Amazon Braket"]
            types = ["SIMULATOR"]
            statuses = ["ONLINE"]
            results = get_devices(types=types, statuses=statuses)
            @test !isempty(results)
            for result in results
                @test provider_name(result) ∈ provider_names
                @test type(result) ∈ types
                @test status(result) ∈ statuses
            end
        end
        @testset "all" begin
            result_arns = arn.(get_devices())
            for dev_arn in [RIGETTI_ARN, IONQ_ARN, SIMULATOR_ARN, IQM_ARN]
                @test dev_arn ∈ result_arns
            end
        end
    end
end

using Braket, Test, Braket.IR

@testset "Dwave Device Schema" begin
    @testset "Provider level parameters" begin
        ir_gen(annealing_duration, max_results) = """
            {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.dwave.dwave_provider_level_parameters",
                    "version": "1"
                },
                "annealingOffsets": [3.67, 6.123],
                "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
                "annealingDuration": $annealing_duration,
                "autoScale": null,
                "beta": 123.456,
                "chains": [[0, 1, 5], [6]],
                "compensateFluxDrift": false,
                "fluxBiases": [1.1, 2.2, 3.3, 4.4],
                "initialState": [1, 3, 0, 1],
                "maxResults": $max_results,
                "postprocessingType": "sampling",
                "programmingThermalizationDuration": 625,
                "readoutThermalizationDuration": 256,
                "reduceIntersampleCorrelation": false,
                "reinitializeState": true,
                "resultFormat": "raw",
                "spinReversalTransformCount": 100
            }
            """
        @testset for annealing_duration in [1, 500], max_results in [1, 20]
            @test Braket.parse_raw_schema(ir_gen(annealing_duration, max_results)) isa Braket.DwaveProviderLevelParameters
        end
        # enable these when we have input verification
        #=
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(0, 1))
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(1, 0))
        =#
    end
    @testset "Provider properties" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.dwave.dwave_provider_properties",
                "version": "1"
            },
            "annealingOffsetStep": 1.45,
            "annealingOffsetStepPhi0": 1.45,
            "annealingOffsetRanges": [[1.45, 1.45], [1.45, 1.45]],
            "annealingDurationRange": [1.45, 2.45, 3],
            "couplers": [[1, 2, 3], [1, 2, 3]],
            "defaultAnnealingDuration": 1,
            "defaultProgrammingThermalizationDuration": 1,
            "defaultReadoutThermalizationDuration": 1,
            "extendedJRange": [1.1, 2.45, 3.45],
            "hGainScheduleRange": [1.11, 2.56, 3.67],
            "hRange": [1.4, 2.6, 3.66],
            "jRange": [1.67, 2.666, 3.666],
            "maximumAnnealingSchedulePoints": 1,
            "maximumHGainSchedulePoints": 1,
            "perQubitCouplingRange": [1.777, 2.567, 3.1201],
            "programmingThermalizationDurationRange": [1, 2, 3],
            "qubits": [1, 2, 3],
            "qubitCount": 1,
            "quotaConversionRate": 1.341234,
            "readoutThermalizationDurationRange": [1, 2, 3],
            "taskRunDurationRange": [1, 2, 3],
            "topology": {}
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.DwaveProviderProperties
    end
    @testset "Device parameters" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.dwave.dwave_device_parameters",
                "version": "1"
            },
            "providerLevelParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.dwave.dwave_provider_level_parameters",
                    "version": "1"
                }
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.DwaveDeviceParameters
    end
    @testset "Device capabilities" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.dwave.dwave_device_capabilities",
                "version": "1"
            },
            "provider": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.dwave.dwave_provider_properties",
                    "version": "1"
                },
                "annealingOffsetStep": 1.45,
                "annealingOffsetStepPhi0": 1.45,
                "annealingOffsetRanges": [[1.45, 1.45], [1.45, 1.45]],
                "annealingDurationRange": [1.45, 2.45, 3],
                "couplers": [[1, 2, 3], [1, 2, 3]],
                "defaultAnnealingDuration": 1,
                "defaultProgrammingThermalizationDuration": 1,
                "defaultReadoutThermalizationDuration": 1,
                "extendedJRange": [1, 2, 3],
                "hGainScheduleRange": [1, 2, 3],
                "hRange": [1, 2, 3],
                "jRange": [1, 2, 3],
                "maximumAnnealingSchedulePoints": 1,
                "maximumHGainSchedulePoints": 1,
                "perQubitCouplingRange": [1, 2, 3],
                "programmingThermalizationDurationRange": [1, 2, 3],
                "qubits": [1, 2, 3],
                "qubitCount": 1,
                "quotaConversionRate": 1,
                "readoutThermalizationDurationRange": [1, 2, 3],
                "taskRunDurationRange": [1, 2, 3],
                "topology": {}
            },
            "service": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.device_service_properties",
                    "version": "1"
                },
                "executionWindows": [
                    {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
                ],
                "shotsRange": [1, 10],
                "deviceCost": {"price": 0.25, "unit": "minute"},
                "deviceDocumentation": {
                    "imageUrl": "image_url",
                    "summary": "Summary on the device",
                    "externalDocumentationUrl": "exter doc link"
                },
                "deviceLocation": "us-east-1",
                "updatedAt": "2020-06-16T19:28:02.869136"
            },
            "action": {
                "braket.ir.annealing.problem": {
                    "actionType": "braket.ir.annealing.problem",
                    "version": ["1"]
                }
            },
            "paradigm": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.device_paradigm_properties",
                    "version": "1"
                }
            },
            "deviceParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.dwave.dwave_device_parameters",
                    "version": "1"
                },
                "providerLevelParameters": {
                    "braketSchemaHeader": {
                        "name": "braket.device_schema.dwave.dwave_provider_level_parameters",
                        "version": "1"
                    }
                }
            }
        }
        """
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.DwaveDeviceCapabilities
    end
    @testset "2000Q Device level parameters" begin
        ir_gen(annealing_duration, max_results) = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.dwave.dwave_2000Q_device_level_parameters",
                "version": "1"
            },
            "annealingOffsets": [3.67, 6.123],
            "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
            "annealingDuration": $annealing_duration,
            "autoScale": null,
            "compensateFluxDrift": false,
            "fluxBiases": [1.1, 2.2, 3.3, 4.4],
            "initialState": [1, 3, 0, 1],
            "maxResults": $max_results,
            "programmingThermalizationDuration": 625,
            "readoutThermalizationDuration": 256,
            "reduceIntersampleCorrelation": false,
            "reinitializeState": true,
            "resultFormat": "raw",
            "spinReversalTransformCount": 100
        }
        """
        @testset for annealing_duration in [1, 500], max_results in [1, 20]
            @test Braket.parse_raw_schema(ir_gen(annealing_duration, max_results)) isa Braket.Dwave2000QDeviceLevelParameters
        end
        # enable these when we have input verification
        #=
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(0, 1))
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(1, 0))
        =#
    end
    @testset "Advantage Device level parameters" begin
        ir_gen(annealing_duration, max_results) = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.dwave.dwave_advantage_device_level_parameters",
                "version": "1"
            },
            "annealingOffsets": [3.67, 6.123],
            "annealingSchedule": [[13.37, 10.08], [3.14, 1.618]],
            "annealingDuration": $annealing_duration,
            "autoScale": null,
            "compensateFluxDrift": false,
            "fluxBiases": [1.1, 2.2, 3.3, 4.4],
            "initialState": [1, 3, 0, 1],
            "maxResults": $max_results,
            "programmingThermalizationDuration": 625,
            "readoutThermalizationDuration": 256,
            "reduceIntersampleCorrelation": false,
            "reinitializeState": true,
            "resultFormat": "raw",
            "spinReversalTransformCount": 100
        }
        """
        @testset for annealing_duration in [1, 500], max_results in [1, 20]
            @test Braket.parse_raw_schema(ir_gen(annealing_duration, max_results)) isa Braket.DwaveAdvantageDeviceLevelParameters
        end
        # enable these when we have input verification
        #=
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(0, 1))
        @test_throws ArgumentError Braket.parse_raw_schema(ir_gen(1, 0))
        =#
    end
end

using Braket, Braket.JSON3, Test

num_containers() = length(split(read(`docker container ls`, String), "\n"))

@testset "Local Quantum Job" begin
    @testset "Completed" begin
        initial_containers = num_containers()
        absolute_source_module = joinpath(@__DIR__, "job_test_script.py")
        current_dir = pwd()
        cd(mktempdir()) do
            job = LocalQuantumJob(
                "arn:aws:braket:::device/quantum-simulator/amazon/sv1",
                absolute_source_module,
                entry_point="job_test_script:start_here",
                hyperparameters=Dict("test_case"=>"completed")
            )

            job_name = name(job)
            pattern = Regex("^local:job/$job_name")
            match(pattern, arn(job))

            @test state(job) == "COMPLETED"
            @test isdir(job_name)

            # Check results match the expectations.
            @test ispath("$job_name/results.json")
            res = result(job)
            @test res == Dict("converged"=>true, "energy"=>-0.2)

            # Validate checkpoint files and data
            @test ispath("$job_name/checkpoints/$job_name.json")
            @test ispath("$job_name/checkpoints/$(job_name)_plain_data.json")
            for (file_name, expected_data) in [
                (
                    "$job_name/checkpoints/$(job_name)_plain_data.json",
                    """{
                        "braketSchemaHeader": {
                            "name": "braket.jobs_data.persisted_job_data",
                            "version": "1"
                        },
                        "dataDictionary": {"some_data": "abc"},
                        "dataFormat": "plaintext"
                    }""",
                ),
                (
                    "$job_name/checkpoints/$(job_name).json",
                    """{
                        "braketSchemaHeader": {
                            "name": "braket.jobs_data.persisted_job_data",
                            "version": "1"
                        },
                        "dataDictionary": {"some_data": "gASVBwAAAAAAAACMA2FiY5Qu\n"},
                        "dataFormat": "pickled_v4"
                    }""",
                ),
            ]
                @test JSON3.read(read(file_name, String), Dict) == JSON3.read(expected_data, Dict)
            end
            # Capture logs
            @test ispath("$job_name/log.txt")
            mktempdir() do temp_dir
                redirect_stdio(stdout=joinpath(temp_dir, "out.txt"), stderr=joinpath(temp_dir, "err.txt")) do
                    logs(job)
                end
                log_data = read(joinpath(temp_dir, "out.txt"), String)
                errors = read(joinpath(temp_dir, "err.txt"), String)
                logs_to_validate = [
                    "Beginning Setup",
                    "Running Code As Process",
                    "Test job started!!!!!",
                    "Test job completed!!!!!",
                    "Code Run Finished",
                ]
    
                for data in logs_to_validate
                    @test occursin(data, log_data)
                end
            end
        end
        # test the container was shut down
        @test num_containers() == initial_containers 
    end
    @testset "Failed" begin
        initial_containers = num_containers()
        absolute_source_module = joinpath(@__DIR__, "job_test_script.py")
        current_dir = pwd()
        cd(mktempdir()) do
            job = LocalQuantumJob(
                "arn:aws:braket:::device/quantum-simulator/amazon/sv1",
                absolute_source_module,
                entry_point="job_test_script:start_here",
                hyperparameters=Dict("test_case"=>"failed")
            )

            job_name = name(job)
            pattern = Regex("^local:job/$job_name")
            match(pattern, arn(job))

            @test state(job) == "COMPLETED"
            @test isdir(job_name)

            # Check no files are populated in checkpoints folder.
            @test isempty(readdir("$(job_name)/checkpoints"))

            # Check results match the expectations.
            error_message = "unable to find results in the local job directory $(job_name)."
            @test_throws ErrorException(error_message) result(job) 

            # Capture logs
            @test ispath("$(job_name)/log.txt")
            mktempdir() do temp_dir
                redirect_stdio(stdout=joinpath(temp_dir, "out.txt"), stderr=joinpath(temp_dir, "err.txt")) do
                    logs(job)
                end
                log_data = read(joinpath(temp_dir, "out.txt"), String)
                errors = read(joinpath(temp_dir, "err.txt"), String)
                logs_to_validate = [
                    "Beginning Setup",
                    "Running Code As Process",
                    "Test job started!!!!!",
                    "Code Run Finished",
                ]
                for data in logs_to_validate
                    @test occursin(data, log_data)
                end
            end
        end
        # test the container was shut down
        # invoke GC to make sure finalizer has run
        GC.gc()
        sleep(5)
        @test num_containers() == initial_containers 
    end
end

using Dates, DecFP, Test, Braket
using Braket: TaskCreationEvent, TaskStatusEvent, TaskCompletionEvent, Tracker, quantum_task_statistics, receive!, simulator_tasks_cost, qpu_tasks_cost

CREATE_EVENTS = [
    TaskCreationEvent("task1:::region", 100, true, "qpu/foo"),
    TaskCreationEvent("task2:::region", 100, false, "qpu/foo"),
    TaskCreationEvent("job_sim_task:::region", 0, true, "simulator/bar"),
    TaskCreationEvent("notjob_sim_task:::region", 0, false, "simulator/bar"),
    TaskCreationEvent("task_fail:::region", 0, false, "simulator/tn1"),
    TaskCreationEvent("task_cancel:::region", 0, false, "simulator/baz"),
    TaskCreationEvent("2000qtask:::region", 100, false, "qpu/2000Qxyz"),
    TaskCreationEvent("adv_task:::region", 100, false, "qpu/Advantage_system123"),
    TaskCreationEvent("unfinished_sim_task:::region", 1000, false, "simulator/bar"),
    TaskCreationEvent("no_price:::region", 1000, false, "something_else")]

GET_EVENTS = [
    TaskStatusEvent("untracked_task:::region", "FOO"),
    TaskStatusEvent("task1:::region", "BAR"),
    TaskStatusEvent("task2:::region", "FAILED"),
]
COMPLETE_EVENTS = [
    TaskCompletionEvent("untracked_task:::region", "BAR", 999999),
    TaskCompletionEvent("task1:::region", "COMPLETED", nothing),
    TaskCompletionEvent("job_sim_task:::region", "COMPLETED", 123),
    TaskCompletionEvent("notjob_sim_task:::region", "COMPLETED", 1729),
    TaskCompletionEvent("task_fail:::region", "FAILED", 12345),
    TaskCompletionEvent("task_cancel:::region", "CANCELLED", nothing),
]

@testset "Cost tracker" begin
    tracker = Braket.Tracker()
    foreach(e->receive!(tracker, e), CREATE_EVENTS)
    foreach(e->receive!(tracker, e), GET_EVENTS)
    foreach(e->receive!(tracker, e), COMPLETE_EVENTS)

    @testset "quantum task statistics" begin
        stats = quantum_task_statistics(tracker)
        expected = Dict( 
            "qpu/foo"=>Dict("shots"=> 200, "tasks"=> Dict("COMPLETED"=> 1, "FAILED"=> 1)),
            "simulator/bar"=>Dict(
                "shots"=>1000,
                "tasks"=>Dict("COMPLETED"=> 2, "CREATED"=> 1),
                "execution_duration"=>(Second(1) + Microsecond(852000)),
                "billed_execution_duration"=> Second(6),
            ),
            "simulator/tn1"=> Dict(
                "shots"=> 0,
                "tasks"=> Dict("FAILED"=> 1),
                "execution_duration"=> (Second(12) + Microsecond(345000)),
                "billed_execution_duration"=> (Second(12) + Microsecond(345000)),
            ),
            "simulator/baz"=> Dict("shots"=> 0, "tasks"=> Dict("CANCELLED"=> 1)),
            "qpu/2000Qxyz"=> Dict("shots"=> 100, "tasks"=> Dict("CREATED"=> 1)),
            "qpu/Advantage_system123"=> Dict("shots"=> 100, "tasks"=> Dict("CREATED"=> 1)),
            "something_else"=> Dict("shots"=> 1000, "tasks"=> Dict("CREATED"=> 1)),
        )
        for (k, v) in expected
            @test v == stats[k]
        end
        @test stats == expected
    end
    @testset "simulator task cost" begin
        Braket.price_search(; kwargs...) = [Dict("Unit"=>"minutes", "PricePerUnit"=>"6.0", "Currency"=>"USD")]
        cost = simulator_tasks_cost(tracker)
        expected = Dec128("0.0001") * (3000 + 3000 + 12345)
        @test cost == expected
        Braket.price_search(; kwargs...) = []
        @test_throws ErrorException simulator_tasks_cost(tracker)
        Braket.price_search(; kwargs...) = [Dict("Unit"=>"minutes", "PricePerUnit"=>"6.0", "Currency"=>"BAD")]
        @test_throws ErrorException simulator_tasks_cost(tracker)
    end
    @testset "qpu task cost" begin
        function Braket.price_search(; kwargs...)
            haskey(kwargs, Symbol("Product Family")) && occursin("Shot", kwargs[Symbol("Product Family")]) && return [Dict("PricePerUnit"=>"0.001", "Currency"=>"USD")]
            return [Dict("PricePerUnit"=>"1.0", "Currency"=>"USD")]
        end
        @test qpu_tasks_cost(tracker) == Dec128("3.3")
        Braket.price_search(; kwargs...) = []
        @test_throws ErrorException qpu_tasks_cost(tracker)

        Braket.price_search(; kwargs...) = [[Dict()], [Dict(), Dict()]]
        @test_throws ErrorException qpu_tasks_cost(tracker)

        Braket.price_search(; kwargs...) = [Dict("Currency"=>"BAD")]
        @test_throws ErrorException qpu_tasks_cost(tracker)
    end
end

### A Pluto.jl notebook ###
# v0.19.20

using Markdown
using InteractiveUtils

# ╔═╡ 492616b4-0cea-41fe-8a8e-11c6d60200cb
using Braket, Plots, Optim, Graphs, SimpleWeightedGraphs, Distributions, GraphPlot, SparseArrays, LinearAlgebra

# ╔═╡ 471998e8-763b-11ed-0be4-e5293a2b29d4
md"
# Gradient computations using the adjoint differentiation method on Amazon Braket.

In this notebook, we'll introduce the adjoint differentiation method and show how you can use it to accelerate variational workflows running on Braket.
"

# ╔═╡ 5a45f736-f603-4f01-b3ca-1d415d7864c4
md"""
## Introduction to gradient computation

First we need to develop the concept of a \"gradient\". A [gradient](https://en.wikipedia.org/wiki/Gradient) refers to a vector derivative of a scalar-valued function of multiple variables. If we have a function $f(x)$, which depends only on $x$ and maps $x \to \mathbb{R}$ (maps $x$ to a single real number), then $f$'s gradient is just its derivative with respect to $x$: $\frac{df}{dx}$. The gradient is denoted $\nabla$, so that $\nabla f(x) = \frac{df}{dx}$. However, if $f$ is a function of multiple variables, mapping $\mathbb{R}^n \to \mathbb{R}$, we must take partial derivatives with respect to each variable. For example:

```math
\nabla f(x, y, z) = \left[\frac{\partial f}{\partial x}, \frac{\partial f}{\partial y}, \frac{\partial f}{\partial z}\right]
```

The gradient of \$f\$ is itself a function and can be evaluated on specific values of $x$, $y$, and $z$. In general, for a function $f$ of $n$ independent real variables, $\nabla f$ is a length $n$ vector.

Gradients are of interest to us because many quantum algorithms -- hybrid classical-quantum algorithms such as the quantum approximate optimization algorithm (QAOA) or the variational quantum eigensolver (VQE) especially -- can be formulated as a problem of optimizing parameters (i.e. variables) in a quantum circuit with respect to some cost function, for example an expectation value of a Hamiltonian. To efficiently perform this optimization it's common to use a gradient based optimization method, such as gradient descent (stochastic or not). An efficient means of computing gradients allows us to arrive at a good solution to the optimization problem in fewer circuit evaluations, and thus less cost.
"""

# ╔═╡ dfba9752-1545-4d51-94b6-739954d63afc
md"""
## Computing gradients of parameters in a quantum circuit

Let's make this a little more concrete. Suppose we have a quantum circuit which depends on a set of parameters $\vec{p}$. We can compactly represent this circuit as $U(\vec{p})$, where $U$ is the unitary that represents the action of all the gates in the circuit. Further suppose that after running this circuit, we will compute the expectation value of some operator $\hat{O}$ (for example, a Hamiltonian) and use the result to determine how good our choice of parameters $\vec{p}$ was. This situation arises often when running hybrid algorithms or quantum machine learning workflows. 


**Note:** Although, for the sake of simplicity, we will only discuss measuring expectation values to generate the function to differentiate, one can equally well compute variances or any other scalar valued function.

We can express this whole procedure as:
```math
f(\vec{p}) = \left\langle \psi \right| \hat{O} \left| \psi \right\rangle = \left\langle 0 U^\dagger(\vec{p}) \right| \hat{O} \left| U(\vec{p}) 0 \right\rangle
```


$f(\vec{p})$ is a scalar valued function and we can compute its gradient -- all its partial derivatives with respect to the parameters $\vec{p}$ -- in order to optimize those parameters. There are a variety of methods available to compute these derivatives, three of which will be discussed below. Of the three, the adjoint differentiation method is the fastest and most frugal in circuit executions and should be preferred when available, that is, when running on a state vector simulator in exact (`shots=0`) mode. We'll introduce these other two common approaches to better understand the benefit of using the adjoint differentiation method.
"""

# ╔═╡ a516549b-0418-4123-a654-fdd17359493e
md"""
### Finite differences

The [finite difference method](https://en.wikipedia.org/wiki/Finite_difference) is a common technique used to approximate derivatives. Suppose we have a function $f(\vec{p})$ and we want to compute the $i$-th partial derivative of $f$, $\frac{\partial f}{\partial p_i}$. We can do so by approximating:

```math
\frac{\partial f}{\partial p_i} \approx \frac{f(p_1, p_2, ..., p_i + h, ..., p_n) - f(p_1, p_2, ..., p_i, ..., p_n)}{h}
```

Where $h$ is some small real number. This formula might seem familiar from introductory calculus.  The smaller $h$ is the better approximated the derivative is. By keeping all other parameters fixed, we can approximate the partial derivative with respect to $p_i$, but as we can see, computing *each* partial derivative would require *two* full circuit executions (one to compute each value of $f$). Thus, the total number of circuit executions needed to compute the gradient of $f$ for *one* set of values $\vec{p}$ would be $2n$, if the length of $p$ is $n$.

For a quantum circuit there can be additional problems. On a real quantum device, we can't compute the exact expectation value (or variance) of a circuit. We can only run many shots, each of which is a full circuit execution, and approximate the expectation value from the measurement statistics that result. This means that for very small $h$, it may be very difficult to approximate the gradient accurately.
"""

# ╔═╡ 202ca719-465e-4f4f-b5b2-40f953857288
md"""
### Parameter shift rules

Let's return to our original formula for the gradient of $f$:

```math
\nabla f(\vec{p}) = \left(\frac{\partial f}{\partial p_1}, \ldots , \frac{\partial f}{\partial p_n}\right)
```

and examine one of the vector elements a little more closely:

```math
\frac{\partial f}{\partial p_i} = \frac{\partial}{\partial p_i} \left\langle 0 U^\dagger(\vec{p}) \right| \hat{O} \left| U(\vec{p}) 0 \right\rangle = \frac{\partial}{\partial p_i} \left\langle 0 \right| U^\dagger(\vec{p}) \hat{O} U(\vec{p}) \left| 0 \right\rangle
```

We can pull the derivative operator inside the expectation value so that:

```math
\frac{\partial f}{\partial p_i} = \left\langle 0 \left|\frac{\partial}{\partial p_i} \left( U^\dagger(\vec{p}) \hat{O} U(\vec{p})\right) \right| 0 \right\rangle
```

We'll assume that each gate depends on at most one parameter, and each parameter appears in only one gate. What if we have repeated parameters? We can write down a mapping of each repeated parameter to a unique copy and sum the derivatives of those copies at the end using the [product rule](https://en.wikipedia.org/wiki/Product_rule). But for now, for simplicity we will assume that each parameter appears only once and each gate has at most one parameter. Further we'll state that gate $i$ is associated with the $i$-th parameter (every gate has a parameter). If non-parametrized gates are present, we can contract them into parametrized gates to achieve this, or assign them constant parameters (remember, the derivative of a constant is always 0).

We can write that the overall circuit unitary $U$ is a product of individual gates:

```math
U(\vec{p}) = \otimes_{i=1}^N U_{i}(p_i)
```

if there are $N$ gates in the circuit.

Then, using the product rule, we can write:

```math
\frac{\partial f}{\partial p_i} = \left\langle 0 \left| \otimes_{j=1}^{i-1} U^\dagger_j \otimes \frac{\partial U^\dagger_i(p_i)}{\partial p_i} \otimes_{j=i+1}^{n} U^\dagger_j \hat{O} U(\vec{p}) + U^\dagger(\vec{p}) \hat{O}\otimes_{j=i+1}^{n} U_j \otimes \frac{\partial U_i(p_i)}{\partial p_i}\otimes_{j=1}^{i-1} U_j \right| 0 \right\rangle
```

We can absorb the non-differentiated products so that:

```math
\frac{\partial f}{\partial p_i} = \left\langle \phi \left| \frac{\partial U^\dagger_i(p_i)}{\partial p_i} \hat{\mathcal{O}}U_i(p_i) + U^\dagger_i(p_i)\hat{\mathcal{O}}\frac{\partial U_i(p_i)}{\partial p_i}\right| \phi \right\rangle
```

where

```math
\left|\phi\right\rangle = \otimes_{j=1}^{i-1} U_j \left| 0 \right\rangle
```

and 

```math
\hat{\mathcal{O}} = \otimes_{j=i+1}^{n} U^\dagger_j  \hat{O} \otimes_{j=i+1}^{n} U_j
```

Now we can see that

```math
\frac{\partial U^\dagger_i(p_i)}{\partial p_i} \hat{\mathcal{O}}U_i(p_i) + U^\dagger_i(p_i)\hat{\mathcal{O}}\frac{\partial U_i(p_i)}{\partial p_i} = \frac{\partial}{\partial p_i} \left( U_i^\dagger(p_i) \hat{\mathcal{O}} U_i(p_i)\right)
```

so, in sum:

```math
\frac{\partial f}{\partial p_i} = \left\langle \phi \left|\frac{\partial}{\partial p_i} \left( U_i^\dagger(p_i) \hat{\mathcal{O}} U_i(p_i)\right)\right| \phi \right\rangle
```

and in many cases (but not all!) we can define a *shift* $s$ such that:

```math
\frac{\partial}{\partial p_i} \left( U_i^\dagger(p_i) \hat{\mathcal{O}} U_i(p_i)\right) = U_i^\dagger(p_i + s) \hat{\mathcal{O}} U_i(p_i + s) - U_i^\dagger(p_i - s) \hat{\mathcal{O}} U_i(p_i - s)
```

Thus the name "parameter shift". What makes this different from the finite differences method is that $s$ is not necessarily small. Detailed guides to choosing shifts and identifying which gates support the method can be found in Refs. [1](https://arxiv.org/abs/1803.00745) and [2](https://arxiv.org/abs/1811.11184). If a gate does *not* support a parameter shift rule, we can always fall back to the finite difference method.

We can see that the parameter shift method *also* requires two circuit executions to compute the partial derivative of each parametrized gate. The advantage over finite difference is in numerical accuracy. Parameter shift can be used both when `shots=0` or when `shots>0`. Since the introduction of the method, many extensions and generalizations have been published, including Refs. [3](https://arxiv.org/abs/2107.12390), [4](https://arxiv.org/abs/2005.10299), and many more. 
"""

# ╔═╡ 42822b26-269e-4d9e-92a2-cd34ef2ca4be
md"""
### Adjoint differentiation

The two methods we've examined so far, finite differences and parameter shift, both require two full circuit executions per parameter to compute the gradient. This can become very expensive, in both time and charges, for deep circuits and/or circuits with many parameters. Is there a way to compute gradients in a more "execution-frugal" way? For `shots=0`, the answer is yes. First introduced in Ref. [5](https://arxiv.org/abs/2009.02823), the adjoint differentiation method allows us to compute all partial derivatives in "1+1" circuit executions. How does it work? Recall that:

```math
\frac{\partial f}{\partial p_i} = \left\langle 0 \left| \otimes_{j=1}^{i-1} U^\dagger_j \otimes \frac{\partial U^\dagger_i(p_i)}{\partial p_i} \otimes_{j=i+1}^{n} U^\dagger_j \hat{O} U(\vec{p}) + U^\dagger(\vec{p}) \hat{O}\otimes_{j=i+1}^{n} U_j \otimes \frac{\partial U_i(p_i)}{\partial p_i}\otimes_{j=1}^{i-1} U_j \right| 0 \right\rangle
```

In the adjoint method, we take a different approach to computing this derivative. We realize that:

```math
\left( \left \langle 0 \left| \otimes_{j=1}^{i-1} U^\dagger_j \otimes \frac{\partial U^\dagger_i(p_i)}{\partial p_i} \otimes_{j=i+1}^{n} U^\dagger_j \hat{O} U(\vec{p}) \right| 0 \right\rangle \right)^\dagger = \left \langle 0 \left| U^\dagger(\vec{p}) \hat{O}\otimes_{j=i+1}^{n} U_j \otimes \frac{\partial U_i(p_i)}{\partial p_i}\otimes_{j=1}^{i-1} U_j \right| 0 \right\rangle
```

and thus, because all the gates are unitaries and the operator $\hat{O}$ is Hermitian,

```math
\frac{\partial f}{\partial p_i} = 2\Re \left\langle 0 \left| U^\dagger(\vec{p}) \hat{O}\otimes_{j=i+1}^{n} U_j \otimes \frac{\partial U_i(p_i)}{\partial p_i}\otimes_{j=1}^{i-1} U_j \right| 0 \right\rangle
```

where $\Re$ denotes the real part. Now we can absorb some factors so that:

```math
\frac{\partial f}{\partial p_i} = 2\Re \left\langle b_i \left| \frac{\partial U_i(p_i)}{\partial p_i} \right| k_i \right\rangle
```

where

```math
\left\langle b_i \right| = \left\langle 0 \right| U^\dagger(\vec{p}) \hat{O}\otimes_{j=i+1}^{n} U_j(p_j)
```

and

```math
\left | k_i \right\rangle = \otimes_{j=1}^{i-1} U_j(p_j) \left| 0 \right\rangle
```

The basis of the adjoint method is realizing that we can iteratively compute each partial derivative by "back stepping" through the circuit after having applied all its gates once. This is very similar to classical back propagation, if you're familiar with that technique from classical machine learning. We first apply all gates to compute $\left| k_n \right\rangle = \otimes_{j=1}^{n} U_j \left| 0 \right\rangle$, copy the state and apply $\hat{O}$ to acquire:

```math
\left\langle b_n \right| = \left\langle 0 \right| U^\dagger(\vec{p}) \hat{O}
```

then compute $\frac{\partial f}{\partial p_n}$:

```math
\frac{\partial f}{\partial p_n} = \left\langle b_n \left|\frac{\partial U_n(p_n)}{\partial p_n}\right| k_n \right\rangle
```

In a moment we'll address how to find $\frac{\partial U_n(p_n)}{\partial p_n}$. Once we've computed the first partial derivative, we update $\left\langle b_n\right|$ and $\left| k_n \right\rangle$ to generate:

```math
\left\langle b_{n-1} \right| = \left\langle b_n \right| U_n(p_n) \\
\left | k_{n-1} \right\rangle =  U^\dagger_{n-1} \left| k_n \right\rangle
```

By iteratively updating these two states, we can compute all partial derivatives with only one circuit execution plus one "back step" execution, significantly less than what is required by finite differences or parameter shift. The cost is that there is additional memory overhead, as we have to store an additional state vector and compute a third in the expectation value $\left\langle b_i \left|\frac{\partial U_i(p_i)}{\partial p_i}\right| k_i \right\rangle$.

How do we compute the derivative $\frac{\partial U_i(p_i)}{\partial p_i}$? In many cases, if $U_i(p_i)$ is continually differentiable with respect to $p_i$, we can simply take a matrix derivative. In particular, many parametrizable gates can be written as exponentials of Paulis, so that:

```math
\frac{\partial U_i(p_i)}{\partial p_i} = \frac{\partial}{\partial p_i}\exp\left\{ i c p_i \hat{P}\right\} = i c \hat{P} \exp\left\{ i c p_i \hat{P}\right\}
```

where $c$ is some constant, $\hat{P}$ is some Pauli gate, and $i$ is the imaginary number $\sqrt{-1}$. This is easily generalizable to exponents of sums of Paulis through the [chain rule](https://en.wikipedia.org/wiki/Chain_rule). In cases where $U(p_i)$ is **not** continuously differentiable, the derivative can be computed numerically, e.g. through finite differences as discussed above.

**Note:** Because it is formulated **only** for exact computations, the adjoint method can only be used on simulators, such as SV1, when running with `shots=0`.


The adjoint differentiation method is available through the `AdjointGradient` result type on Amazon Braket, which we'll introduce in the next section. With this result type, all derivatives are computed using the adjoint differentiation method.
"""

# ╔═╡ df640675-a439-4074-a6d9-df4f8289e446
md"""
## The `AdjointGradient` result type

Amazon Braket now supports a result type, `AdjointGradient`, which allows you to conveniently compute gradients of free parameters with respect to the expectation value of some observable on your circuits.

**Note:** Currently, the `AdjointGradient` result type is **only** supported on SV1 when running in `shots=0` mode. All derivatives are computed using the adjoint differentiation method.

Let's see an example of this result type in action:
"""

# ╔═╡ a86cabc6-77ba-4991-a02f-613219e8984c
device_arn = "arn:aws:braket:::device/quantum-simulator/amazon/sv1"

# ╔═╡ 5e2dad4d-173a-474b-9fe7-f34048819ec9
md"""
**Note**: to run the code below, you'll need [valid AWS credentials](http://docs.aws.amazon.com/general/latest/gr/aws-security-credentials.html). You can paste them into the empty code block below if they are not already located in a file.
"""

# ╔═╡ 99a63307-966c-4057-88b2-0f1cf2f26f99
# Enter your AWS credential environment variables below, if needed:


# ╔═╡ 9a9f4565-f094-4352-b54d-fafd391a8e88
device = AwsDevice(device_arn)

# ╔═╡ d57a24ed-1b8d-4195-bdd6-7ab8969627bd
md"""
We can prepare a simple parametrized circuit and compute its gradient with respect to some observable. Note that you supply the observable to the `AdjointGradient` result type. Supported observables are:
  - Any of `Observables.Z()`, `Observables.X()`, `Observables.Y()`, `Observables.H()`, or `Observable.I()`
  - A `TensorProduct`
  - A `HermitianObservable`
  - A `Sum`
  
You can also supply the list of parameters to compute partial derivatives with respect to. If a parameter is present in the circuit, but not in the `parameters` argument to `adjoint_gradient`, its corresponding partial derivative will not be computed. If the list of `parameters` is empty, the gradient will be computed with respect to all free parameters present in the circuit.
"""

# ╔═╡ 8eea449b-2935-4aa4-9eaf-70d0c0af5c3d
begin
	θ = FreeParameter(:theta)
	γ = FreeParameter(:gamma)
	ag_circuit = Circuit([(H, 0), (CNot, 0, 1), (Rx, 0, θ), (Rx, 1, θ), (XX, 0, 1, γ)])
	# add the adjoint gradient result type

	# we can either explicitly provide a list of parameters
	#ag_circuit(AdjointGradient, Braket.Observables.Z() * Braket.Observables.Z(), [0, 1], [θ, γ])

	# or use the default of all
	ag_circuit(AdjointGradient, Braket.Observables.Z() * Braket.Observables.Z(), [0, 1], [])
end

# ╔═╡ 7621e93a-a14a-47e0-9d49-9ce24ce0b9e0
md"""
Now we can compute the gradient of the circuit with respect to our two free parameters for a given set of parameter values, which we supply to the `device` functor with the `inputs` argument:
"""

# ╔═╡ 59178e2e-707c-4e1f-b2ea-54c3aa718956
grad_1 = result(device(ag_circuit, shots=0, inputs = Dict("theta"=>0.1, "gamma"=>0.05))).values[1]

# ╔═╡ f1279ca2-26a3-4a3d-b50a-0ef6666eca5f
grad_2 = result(device(ag_circuit, shots=0, inputs = Dict("theta"=>0.2, "gamma"=>0.1))).values[1]

# ╔═╡ 12dc5ee9-1636-405b-b095-2a965d0ccaea
md"""
We can immediately see that although `θ` appears twice in the circuit (in two `Rx` gates), it only appears once in the result. `AdjointGradient` computes gradients **per parameter**, and **not** per-gate. We can also see that if `parameters` is empty, derivatives with respect to all free parameters will be computed. This is useful in cases when your circuit has a large number of free parameters.
"""

# ╔═╡ 4ab8a07d-da9b-4ccc-9bce-644f7da6de21
md"""
## Accelerating QAOA with `AdjointGradient`

Now we can see how using the `AdjointGradient` result type can improve performance for a hybrid algorithm such as QAOA. For an introduction to QAOA, see [its example notebook](https://github.com/aws/amazon-braket-examples/blob/main/examples/hybrid_quantum_algorithms/QAOA/QAOA_braket.ipynb). We'll create a `train` function to use `AdjointGradient` and determine a Jacobian, and compare this approach with the Jacobian-free method used in the QAOA notebook. Much of the code here is further explained in that notebook, so we strongly suggest you review it before proceeding. We'll run the entire QAOA workflow in `shots=0` mode so that we can compare with `AdjointGradient`, which means we can directly compute the cost (energy). First, we set up the problem and import the circuit generator and training functions:
"""

# ╔═╡ 4a29e5f3-5b28-41cd-af15-1a3e05ea6e83
begin
	# setup Erdos Renyi graph
	n = 10  # number of nodes/vertices
	m = 20  # number of edges
	seed = 2
	
	# define graph object
	G = SimpleWeightedGraph(erdos_renyi(n, m, seed=seed))
	
	# choose random weights
	weights_d = Uniform(0, 1)
	for edge in edges(G)
	    G.weights[edge.src, edge.dst] = rand(weights_d)
		G.weights[edge.dst, edge.src] = rand(weights_d)
	end
end

# ╔═╡ c3edb0ce-ecef-49a7-a799-b288a3c53d91
gplot(G)

# ╔═╡ ba3d585e-5118-480d-b09f-bbd2616022d3
# build Ising matrix corresponding to G
Jfull = triu(adjacency_matrix(G), 1)

# ╔═╡ f3afc1e5-b9ca-4938-9fd6-33c3a6a1fc87
n_qubits = size(Jfull, 1)

# ╔═╡ 8f0e6be9-440b-44af-8a4f-f8c4aefc2120
md"""
We can now specify hyperparameters for the training. We can choose the number of QAOA layers to use, the maximum iteration number, and the classical optimization algorithm to use.
"""

# ╔═╡ 29039bc9-f52f-4c3f-8457-8ad79a2ebc7a
DEPTH = 2  # circuit depth for QAOA

# ╔═╡ c4a122e2-a94e-4eaa-8c9b-44719b3be8d5
OPT_METHOD = BFGS()

# ╔═╡ 75d93548-30be-4ad7-8e65-de3a8556c224
optim_opts = Optim.Options(iterations = 30, show_trace=true, store_trace=true)

# ╔═╡ 3fe9dbbe-3ef2-44e2-9de8-a460eb06cdb8
md"""
We can also initialize the parameters and the initial guess for the energy (cost):
"""

# ╔═╡ 18d6f499-4c43-4448-ba1f-ccc70761c4cf
begin
	params_d = Uniform(0, 2π)
	γ_initial = rand(params_d, DEPTH)
	β_initial = rand(params_d, DEPTH)
	params_initial = vcat(γ_initial, β_initial)
	# initialize reference solution (simple guess)
	energy_init = 0.0
end

# ╔═╡ 301001e8-f48b-4198-aa70-d75b475dda5b
md"
Now we build up the QAOA circuit itself. For an introduction to QAOA, check out the main [Amazon Braket example notebook](https://github.com/aws/amazon-braket-examples/blob/main/examples/hybrid_quantum_algorithms/QAOA/QAOA_braket.ipynb).
"

# ╔═╡ a948c2fe-4c00-4b0d-a3fa-ae8ec0f02cff
"""
Returns circuit for driver Hamiltonian U(Hb, β)
"""
function driver(β, n_qubits)
	# instantiate circuit object
	circ = Circuit()
	# apply parametrized rotation around x to every qubit
	for qubit in 0:n_qubits-1
		circ(Rx, qubit, β)
	end
	return circ
end

# ╔═╡ fba6c5c9-d6af-4a04-8bfa-dd83a1ca99dc
"""
Returns circuit for evolution with cost Hamiltonian.
"""
function cost_circuit(γ, n_qubits, ising)
    # instantiate circuit object
    circ = Circuit()

    # get all non-zero entries (edges) from Ising matrix
    Is, Js, Vs = findnz(ising)
	edges = zip(Is, Js)

    # apply ZZ gate for every edge (with corresponding interaction strength)
    for (ii, qubit_pair) in enumerate(edges)
        circ(ZZ, qubit_pair[1], qubit_pair[2], γ[ii])
	end
    return circ
end

# ╔═╡ 8d011c5e-7924-455b-aac0-63afa674a562
"""
Returns full QAOA circuit of provided depth (inferred from length of `params` argument).
"""
function qaoa_builder(params, n_qubits, ising)
    # initialize qaoa circuit with first Hadamard layer:
	# for minimization start in |->
    circ = Circuit([(H, collect(0:n_qubits-1))])
	
    # setup two parameter families
    circuit_length = div(length(params), 2)
    γs = params[1:circuit_length]
    βs = params[circuit_length+1:end]

    # add QAOA circuit layer blocks
    for mm in 1:circuit_length
        append!(circ, cost_circuit(γs[mm], n_qubits, ising))
        append!(circ, driver(βs[mm], n_qubits))
	end
    return circ
end

# ╔═╡ f941586e-2b88-4f7e-8f5f-a0f93ebe8eee
"""
Builds a `Sum` observable representing the cost Hamiltonian.
"""
function cost_H(ising)
    Is, Js, Vs = findnz(ising)
	edges = collect(zip(Is, Js))

    H_terms = []
    # apply ZZ gate for every edge (with corresponding interaction strength)
    for qubit_pair in edges[2:end]
        # get interaction strength from Ising matrix
        int_strength = ising[qubit_pair[1], qubit_pair[2]]
        push!(H_terms, 2*int_strength * Braket.Observables.Z() * Braket.Observables.Z())
	end
    targets = [QubitSet([edge[1], edge[2]]) for edge in edges]
	H_0 = 2*ising[edges[1][1], edges[1][2]] * Braket.Observables.Z() * Braket.Observables.Z()
	sum_H = sum(H_terms, init=H_0)
    return sum_H, targets
end

# ╔═╡ 0656f232-f00e-4da8-a6a1-2c7156d9d840
"""
Applies the scaling terms to the raw derivatives provided by `AdjointGradient` in order to generate the correct Jacobian.
"""
function form_jacobian(n_params, gradient, ising)
    jac = zeros(Float64, n_params)
    Is, Js, Vs = findnz(ising)
    edges = collect(zip(Is, Js))
    split = div(n_params, 2)
    for i in 1:split
        # handle βs
        jac[split + i] += 2 * gradient[Symbol("beta_$i")]
        # handle γs
        for j in 1:length(edges)
			int_strength = ising[edges[j][1], edges[j][2]]
            jac[i] += 2 * int_strength * gradient[Symbol("gamma_$(i)_$(j)")]
		end
	end
    return jac
end

# ╔═╡ d9505af6-18c8-4381-9574-3c03645a8a11
"""
Creates the dictionary of parameter values to use when running the task.
"""
function form_inputs_dict(params, ising)
    n_params = length(params)
    params_dict = Dict{String, Float64}()
    Is, Js, Vs = findnz(ising)
    edges = collect(zip(Is, Js))
    split = div(n_params, 2)
    for i in 1:split
        params_dict["beta_$i"] = 2 * params[split + i]
        for j in 1:length(edges)
			int_strength = ising[edges[j][1], edges[j][2]]
            params_dict["gamma_$(i)_$(j)"] = 2 * int_strength * params[i]
		end
	end
    return params_dict
end

# ╔═╡ 14fa1f6d-2262-49f0-bc74-05e3974a29ca
md"
Now we have everything we need to define the objective function to pass to `optimize`.
"

# ╔═╡ a277af58-6d4b-4389-8821-5824cc6e71b0
begin 
	mutable struct AdjointClosure
		qaoa_circuit::Circuit
		ising::SparseMatrixCSC
		device::AwsDevice
	end
	"""
	Computes the cost and gradient in one call to SV1.
	"""
	function (oc::AdjointClosure)(F, G, params)
	    # create parameter dict
	    params_dict = form_inputs_dict(params, oc.ising) 
	    # classically simulate the circuit
	    # set the parameter values using the inputs argument
		timeout = 3 * 24 * 60 * 60
	    task = oc.device(oc.qaoa_circuit, shots=0, inputs=params_dict, poll_timeout_seconds=timeout)
	
	    # get result for this task
	    res = result(task)
	    gradient = res.values[1]
	    energy = gradient[:expectation]
	    jac = form_jacobian(length(params), gradient[:gradient], oc.ising)
	    if G != nothing
			copyto!(G, jac)
		end
		if F != nothing
			return energy
		end
	end
	Base.show(io::IO, ac::AdjointClosure) = print(io, "AdjointClosure")
end

# ╔═╡ 2c99922f-86cb-462d-84c4-a4d7793f0716
md"
We build a QAOA circuit which will use the `AdjointGradient` result type.
"

# ╔═╡ 22ebd728-520f-4c85-9198-1c15e1366058
begin
	γ_params = [[FreeParameter(Symbol("gamma_$(i)_$(j)")) for j in 1:nnz(Jfull)] for i in 1:DEPTH]
	β_params = [FreeParameter(Symbol("beta_$i")) for i in 1:DEPTH]
	params = vcat(γ_params, β_params)
	qaoa_circ = qaoa_builder(params, n_qubits, Jfull)
	
	Hamiltonian, targets = cost_H(Jfull)
    qaoa_circ(AdjointGradient, Hamiltonian, targets, [])
end

# ╔═╡ c9d8c32f-4980-4e8c-942a-dce5136b4ad2
ac = AdjointClosure(qaoa_circ, Jfull, device)

# ╔═╡ 591ae7b2-3fda-4301-b1d1-a97817246481
md"""
We can let `Optim.jl` know that we are able to compute the cost and gradient in one fell swoop by using [`only_fg!`](https://julianlsolvers.github.io/Optim.jl/stable/#user/tipsandtricks/#avoid-repeating-computations). Note that running the code below will submit tasks to an Amazon Braket on-demand simulator, and you may incur charges to your account. For that reason, the cell is disabled by default. Enable it if you wish to run the cell.
"""

# ╔═╡ 0da7d875-c157-4998-bb16-55b949039923
# ╠═╡ disabled = true
#=╠═╡
opt_trace = Optim.optimize(Optim.only_fg!(ac), params_initial, Optim.BFGS())
  ╠═╡ =#

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Braket = "19504a0f-b47d-4348-9127-acc6cc69ef67"
Distributions = "31c24e10-a181-5473-b8eb-7969acd0382f"
GraphPlot = "a2cc645c-3eea-5389-862e-a155d0052231"
Graphs = "86223c79-3864-5bf0-83f7-82e725a168b6"
LinearAlgebra = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"
Optim = "429524aa-4258-5aef-a3af-852621145aeb"
Plots = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
SimpleWeightedGraphs = "47aef6b3-ad0c-573a-a1e2-d07658019622"
SparseArrays = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[compat]
Braket = "~0.3.0"
Distributions = "~0.25.80"
GraphPlot = "~0.5.2"
Graphs = "~1.7.4"
Optim = "~1.7.4"
Plots = "~1.38.2"
SimpleWeightedGraphs = "~1.2.2"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.9.0-beta3"
manifest_format = "2.0"
project_hash = "869128a0a9cbe4801755582420a6cd0ddc69526f"

[[deps.AWS]]
deps = ["Base64", "Compat", "Dates", "Downloads", "GitHub", "HTTP", "IniFile", "JSON", "MbedTLS", "Mocking", "OrderedCollections", "Random", "SHA", "Sockets", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "487d6835da9876e0362a83aec169e390872eba64"
uuid = "fbe9abb3-538b-5e4e-ba9e-bc94f4f92ebc"
version = "1.81.0"

[[deps.AWSS3]]
deps = ["AWS", "ArrowTypes", "Base64", "Compat", "Dates", "EzXML", "FilePathsBase", "MbedTLS", "Mocking", "OrderedCollections", "Retry", "SymDict", "URIs", "UUIDs", "XMLDict"]
git-tree-sha1 = "04620168e20f9c922b738fc6b7d6cfb92973ebfb"
uuid = "1c724243-ef5b-51ab-93f4-b0a88ac62a95"
version = "0.10.2"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrayInterfaceCore]]
deps = ["LinearAlgebra", "SnoopPrecompile", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "e5f08b5689b1aad068e01751889f2f615c7db36d"
uuid = "30b0a656-2188-435a-8636-2ec0e6a096e2"
version = "0.1.29"

[[deps.ArrowTypes]]
deps = ["UUIDs"]
git-tree-sha1 = "a0633b6d6efabf3f76dacd6eb1b3ec6c42ab0552"
uuid = "31f734f8-188a-4ce0-8406-c8a06bd891cd"
version = "1.2.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.AxisArrays]]
deps = ["Dates", "IntervalSets", "IterTools", "RangeArrays"]
git-tree-sha1 = "1dd4d9f5beebac0c03446918741b1a03dc5e5788"
uuid = "39de3d68-74b9-583c-8d2d-e117c070f3a9"
version = "0.4.6"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitFlags]]
git-tree-sha1 = "43b1a4a8f797c1cddadf60499a8a077d4af2cd2d"
uuid = "d1d4a3ce-64b1-5f1a-9ba4-7e7e69966f35"
version = "0.1.7"

[[deps.Braket]]
deps = ["AWS", "AWSS3", "AxisArrays", "CSV", "Compat", "DataStructures", "Dates", "DecFP", "Distributed", "Downloads", "Graphs", "HTTP", "InteractiveUtils", "JSON3", "LinearAlgebra", "Logging", "Mocking", "NamedTupleTools", "OrderedCollections", "Random", "Statistics", "StructTypes", "Tar", "UUIDs"]
git-tree-sha1 = "f116c78dbaab8141c121a41962e28f442908051c"
uuid = "19504a0f-b47d-4348-9127-acc6cc69ef67"
version = "0.3.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "SnoopPrecompile", "Tables", "Unicode", "WeakRefStrings", "WorkerUtilities"]
git-tree-sha1 = "c700cce799b51c9045473de751e9319bdd1c6e94"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.9"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.Calculus]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f641eb0a4f00c343bbc32346e1217b86f3ce9dad"
uuid = "49dc2e85-a5d0-5ad3-a950-438e2897f1b9"
version = "0.5.1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "c6d890a52d2c4d55d326439580c3b8d0875a77d9"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.7"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "9c209fb7536406834aa938fb149964b985de6c83"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.1"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random", "SnoopPrecompile"]
git-tree-sha1 = "aa3edc8f8dea6cbfa176ee12f7c2fc82f0608ed3"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.20.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "600cc5508d66b78aae350f7accdb58763ac18589"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.10"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "fc08e5930ee9a4e03f84bfb5211cb54e7769758a"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.10"

[[deps.CommonSubexpressions]]
deps = ["MacroTools", "Test"]
git-tree-sha1 = "7b8a93dba8af7e3b42fecabf646260105ac373f7"
uuid = "bbf7d656-a473-5ed7-a52c-81e309532950"
version = "0.3.0"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "00a2cccc7f098ff3b66806862d275ca3db9e6e5a"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.5.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.0.2+0"

[[deps.Compose]]
deps = ["Base64", "Colors", "DataStructures", "Dates", "IterTools", "JSON", "LinearAlgebra", "Measures", "Printf", "Random", "Requires", "Statistics", "UUIDs"]
git-tree-sha1 = "d853e57661ba3a57abcdaa201f4c9917a93487a2"
uuid = "a81c6b42-2e10-5240-aca2-a61377ecd94b"
version = "0.9.4"

[[deps.ConstructionBase]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "fb21ddd70a051d882a1686a5a550990bbe371a95"
uuid = "187b0558-2788-49d3-abe0-74a17ed4e7c9"
version = "1.4.1"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.DataAPI]]
git-tree-sha1 = "e8119c1a33d267e16108be441a287a6981ba1630"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.14.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DecFP]]
deps = ["DecFP_jll", "Printf", "Random", "SpecialFunctions"]
git-tree-sha1 = "a8269e0a6af8c9d9ae95d15dcfa5628285980cbb"
uuid = "55939f99-70c6-5e9b-8bb0-5071ed7d61fd"
version = "1.3.1"

[[deps.DecFP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e9a8da19f847bbfed4076071f6fef8665a30d9e5"
uuid = "47200ebd-12ce-5be5-abb7-8e082af23329"
version = "2.0.3+1"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
git-tree-sha1 = "9e2f36d3c96a820c678f2f1f1782582fcf685bae"
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"
version = "1.9.1"

[[deps.DensityInterface]]
deps = ["InverseFunctions", "Test"]
git-tree-sha1 = "80c3e8639e3353e5d2912fb3a1916b8455e2494b"
uuid = "b429d917-457f-4dbc-8f4c-0cc954292b1d"
version = "0.4.0"

[[deps.DiffResults]]
deps = ["StaticArraysCore"]
git-tree-sha1 = "782dd5f4561f5d267313f23853baaaa4c52ea621"
uuid = "163ba53b-c6d8-5494-b064-1a9d43ac40c5"
version = "1.1.0"

[[deps.DiffRules]]
deps = ["IrrationalConstants", "LogExpFunctions", "NaNMath", "Random", "SpecialFunctions"]
git-tree-sha1 = "c5b6685d53f933c11404a3ae9822afe30d522494"
uuid = "b552c78f-8df3-52c6-915a-8e097449b14b"
version = "1.12.2"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.Distributions]]
deps = ["ChainRulesCore", "DensityInterface", "FillArrays", "LinearAlgebra", "PDMats", "Printf", "QuadGK", "Random", "SparseArrays", "SpecialFunctions", "Statistics", "StatsBase", "StatsFuns", "Test"]
git-tree-sha1 = "74911ad88921455c6afcad1eefa12bd7b1724631"
uuid = "31c24e10-a181-5473-b8eb-7969acd0382f"
version = "0.25.80"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "2fb1e02f2b635d0845df5d7c167fec4dd739b00d"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.3"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.DualNumbers]]
deps = ["Calculus", "NaNMath", "SpecialFunctions"]
git-tree-sha1 = "5837a837389fccf076445fce071c8ddaea35a566"
uuid = "fa6b7ba4-c1ee-5f82-b5fc-ecf0adba8f74"
version = "0.6.8"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.EzXML]]
deps = ["Printf", "XML2_jll"]
git-tree-sha1 = "0fa3b52a04a4e210aeb1626def9c90df3ae65268"
uuid = "8f5d6c58-4d21-5cfd-889c-e3ad7ee6a615"
version = "1.1.0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "e27c4ebe80e8699540f2d6c805cc12203b614f12"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.20"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FillArrays]]
deps = ["LinearAlgebra", "Random", "SparseArrays", "Statistics"]
git-tree-sha1 = "d3ba08ab64bdfd27234d3f61956c966266757fe6"
uuid = "1a297f60-69ca-5386-bcde-b61e274b549b"
version = "0.13.7"

[[deps.FiniteDiff]]
deps = ["ArrayInterfaceCore", "LinearAlgebra", "Requires", "Setfield", "SparseArrays", "StaticArrays"]
git-tree-sha1 = "04ed1f0029b6b3af88343e439b995141cb0d0b8d"
uuid = "6a86dc24-6348-571c-b903-95158fe2bd41"
version = "2.17.0"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.ForwardDiff]]
deps = ["CommonSubexpressions", "DiffResults", "DiffRules", "LinearAlgebra", "LogExpFunctions", "NaNMath", "Preferences", "Printf", "Random", "SpecialFunctions", "StaticArrays"]
git-tree-sha1 = "a69dd6db8a809f78846ff259298678f0d6212180"
uuid = "f6369f11-7733-5829-9624-2563aa707210"
version = "0.10.34"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GR]]
deps = ["Artifacts", "Base64", "DelimitedFiles", "Downloads", "GR_jll", "HTTP", "JSON", "Libdl", "LinearAlgebra", "Pkg", "Preferences", "Printf", "Random", "Serialization", "Sockets", "TOML", "Tar", "Test", "UUIDs", "p7zip_jll"]
git-tree-sha1 = "9e23bd6bb3eb4300cb567bdf63e2c14e5d2ffdbc"
uuid = "28b8d3ca-fb5f-59d9-8090-bfdbd6d07a71"
version = "0.71.5"

[[deps.GR_jll]]
deps = ["Artifacts", "Bzip2_jll", "Cairo_jll", "FFMPEG_jll", "Fontconfig_jll", "GLFW_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Pixman_jll", "Pkg", "Qt5Base_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "aa23c9f9b7c0ba6baeabe966ea1c7d2c7487ef90"
uuid = "d2c73de3-f751-5644-a686-071e5b155ba9"
version = "0.71.5+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.GitHub]]
deps = ["Base64", "Dates", "HTTP", "JSON", "MbedTLS", "Sockets", "SodiumSeal", "URIs"]
git-tree-sha1 = "5688002de970b9eee14b7af7bbbd1fdac10c9bbe"
uuid = "bc5e4493-9b4d-5f90-b8aa-2b2bcaad7a26"
version = "5.8.2"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "d3b3624125c1474292d0d8ed0f65554ac37ddb23"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+2"

[[deps.GraphPlot]]
deps = ["ArnoldiMethod", "ColorTypes", "Colors", "Compose", "DelimitedFiles", "Graphs", "LinearAlgebra", "Random", "SparseArrays"]
git-tree-sha1 = "5cd479730a0cb01f880eff119e9803c13f214cab"
uuid = "a2cc645c-3eea-5389-862e-a155d0052231"
version = "0.5.2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HTTP]]
deps = ["Base64", "CodecZlib", "Dates", "IniFile", "Logging", "LoggingExtras", "MbedTLS", "NetworkOptions", "OpenSSL", "Random", "SimpleBufferStream", "Sockets", "URIs", "UUIDs"]
git-tree-sha1 = "eb5aa5e3b500e191763d35198f859e4b40fff4a6"
uuid = "cd3eb016-35fb-5094-929b-558a96fad6f3"
version = "1.7.3"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.HypergeometricFunctions]]
deps = ["DualNumbers", "LinearAlgebra", "OpenLibm_jll", "SpecialFunctions", "Test"]
git-tree-sha1 = "709d864e3ed6e3545230601f94e11ebc65994641"
uuid = "34004b35-14d8-5ef3-9330-4cdb6864b03a"
version = "0.3.11"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IniFile]]
git-tree-sha1 = "f550e6e32074c939295eb5ea6de31849ac2c9625"
uuid = "83e8ac13-25f8-5344-8a64-a9f2b223428f"
version = "0.5.1"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "0cf92ec945125946352f3d46c96976ab972bde6f"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.3.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "16c0cc91853084cb5f58a78bd209513900206ce6"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.4"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLFzf]]
deps = ["Pipe", "REPL", "Random", "fzf_jll"]
git-tree-sha1 = "f377670cda23b6b7c1c0b3893e37451c5c1a2185"
uuid = "1019f520-868f-41f5-a6de-eb00f4b6a39c"
version = "0.1.5"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "SnoopPrecompile", "StructTypes", "UUIDs"]
git-tree-sha1 = "84b10656a41ef564c39d2d477d7236966d2b5683"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.12.0"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.Latexify]]
deps = ["Formatting", "InteractiveUtils", "LaTeXStrings", "MacroTools", "Markdown", "OrderedCollections", "Printf", "Requires"]
git-tree-sha1 = "2422f47b34d4b127720a18f86fa7b1aa2e141f29"
uuid = "23fbe1c1-3f47-55db-b15f-69d7ec21a316"
version = "0.15.18"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "6f73d1dd803986947b2c750138528a999a6c7733"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.6.0+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c7cb1f5d892775ba13767a87c7ada0b980ea0a71"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+2"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "Pkg", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "3eb79b0ca5764d4799c06699573fd8f533259713"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.4.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LineSearches]]
deps = ["LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "Printf"]
git-tree-sha1 = "7bbea35cec17305fc70a0e5b4641477dc0789d9d"
uuid = "d3d80556-e9d4-5f37-9878-2ab0fcc64255"
version = "7.2.0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "946607f84feb96220f480e0422d3484c49c00239"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.19"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoggingExtras]]
deps = ["Dates", "Logging"]
git-tree-sha1 = "cedb76b37bc5a6c702ade66be44f831fa23c681e"
uuid = "e6f89c97-d47a-5376-807f-9c37f3926c36"
version = "1.0.0"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS]]
deps = ["Dates", "MbedTLS_jll", "MozillaCACerts_jll", "Random", "Sockets"]
git-tree-sha1 = "03a9b9718f5682ecb107ac9f7308991db4ce395b"
uuid = "739be429-bea8-5141-9913-cc70e7f3736d"
version = "1.1.7"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.Measures]]
git-tree-sha1 = "c13304c81eec1ed3af7fc20e75fb6b26092a1102"
uuid = "442fdcdd-2543-5da2-b0f3-8c86c306513e"
version = "0.3.2"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "f66bdc5de519e8f8ae43bdc598782d35a25b1272"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.1.0"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["Compat", "ExprTools"]
git-tree-sha1 = "c272302b22479a24d1cf48c114ad702933414f80"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.5"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.10.11"

[[deps.NLSolversBase]]
deps = ["DiffResults", "Distributed", "FiniteDiff", "ForwardDiff"]
git-tree-sha1 = "a0b464d183da839699f4c79e7606d9d186ec172c"
uuid = "d41bc354-129a-5804-8e4c-c37616107c6c"
version = "7.8.3"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedTupleTools]]
git-tree-sha1 = "90914795fc59df44120fe3fff6742bb0d7adb1d0"
uuid = "d9ec5142-1e00-5aa0-9d6a-321866360f50"
version = "0.14.3"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.21+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL]]
deps = ["BitFlags", "Dates", "MozillaCACerts_jll", "OpenSSL_jll", "Sockets"]
git-tree-sha1 = "6503b77492fd7fcb9379bf73cd31035670e3c509"
uuid = "4d8831e6-92b7-49fb-bdf8-b643e874388c"
version = "1.3.3"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6e9dba33f9f2c44e08a020b0caf6903be540004"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.19+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Optim]]
deps = ["Compat", "FillArrays", "ForwardDiff", "LineSearches", "LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "PositiveFactorizations", "Printf", "SparseArrays", "StatsBase"]
git-tree-sha1 = "1903afc76b7d01719d9c30d3c7d501b61db96721"
uuid = "429524aa-4258-5aef-a3af-852621145aeb"
version = "1.7.4"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+0"

[[deps.PDMats]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "cf494dca75a69712a72b80bc48f59dcf3dea63ec"
uuid = "90014a1f-27ba-587c-ab20-58faa44d9150"
version = "0.11.16"

[[deps.Parameters]]
deps = ["OrderedCollections", "UnPack"]
git-tree-sha1 = "34c0e9ad262e5f7fc75b10a9952ca7692cfc5fbe"
uuid = "d96e819e-fc66-5662-9728-84c9c7592b0a"
version = "0.12.3"

[[deps.Parsers]]
deps = ["Dates", "SnoopPrecompile"]
git-tree-sha1 = "8175fc2b118a3755113c8e68084dc1a9e63c61ee"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.5.3"

[[deps.Pipe]]
git-tree-sha1 = "6842804e7867b115ca9de748a0cf6b364523c16d"
uuid = "b98c9c47-44ae-5843-9183-064241ee97a0"
version = "1.3.0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.9.0"

[[deps.PlotThemes]]
deps = ["PlotUtils", "Statistics"]
git-tree-sha1 = "1f03a2d339f42dca4a4da149c7e15e9b896ad899"
uuid = "ccf2f8ad-2431-5c83-bf29-c5338b663b6a"
version = "3.1.0"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "5b7690dd212e026bbab1860016a6601cb077ab66"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.2"

[[deps.Plots]]
deps = ["Base64", "Contour", "Dates", "Downloads", "FFMPEG", "FixedPointNumbers", "GR", "JLFzf", "JSON", "LaTeXStrings", "Latexify", "LinearAlgebra", "Measures", "NaNMath", "Pkg", "PlotThemes", "PlotUtils", "Preferences", "Printf", "REPL", "Random", "RecipesBase", "RecipesPipeline", "Reexport", "RelocatableFolders", "Requires", "Scratch", "Showoff", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "UUIDs", "UnicodeFun", "Unzip"]
git-tree-sha1 = "a99bbd3664bb12a775cda2eba7f3b2facf3dad94"
uuid = "91a5bcdd-55d7-5caf-9e0b-520d859cae80"
version = "1.38.2"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.PositiveFactorizations]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "17275485f373e6673f7e7f97051f703ed5b15b20"
uuid = "85a6dd25-e78a-55b7-8502-1745935b8125"
version = "0.2.4"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.Qt5Base_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Fontconfig_jll", "Glib_jll", "JLLWrappers", "Libdl", "Libglvnd_jll", "OpenSSL_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libxcb_jll", "Xorg_xcb_util_image_jll", "Xorg_xcb_util_keysyms_jll", "Xorg_xcb_util_renderutil_jll", "Xorg_xcb_util_wm_jll", "Zlib_jll", "xkbcommon_jll"]
git-tree-sha1 = "0c03844e2231e12fda4d0086fd7cbe4098ee8dc5"
uuid = "ea2cea3b-5b76-57ae-a6ef-0a8af62496e1"
version = "5.15.3+2"

[[deps.QuadGK]]
deps = ["DataStructures", "LinearAlgebra"]
git-tree-sha1 = "de191bc385072cc6c7ed3ffdc1caeed3f22c74d4"
uuid = "1fd47b50-473d-5c70-9696-f719f8f3bcdc"
version = "2.7.0"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RangeArrays]]
git-tree-sha1 = "b9039e93773ddcfc828f12aadf7115b4b4d225f5"
uuid = "b3c3ace0-ae52-54e7-9d0b-2c1406fd6b9d"
version = "0.3.2"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "261dddd3b862bd2c940cf6ca4d1c8fe593e457c8"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.3"

[[deps.RecipesPipeline]]
deps = ["Dates", "NaNMath", "PlotUtils", "RecipesBase", "SnoopPrecompile"]
git-tree-sha1 = "e974477be88cb5e3040009f3767611bc6357846f"
uuid = "01d81517-befc-4cb6-b9ec-a95719d0359c"
version = "0.6.11"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Retry]]
git-tree-sha1 = "41ac127cd281bb33e42aba46a9d3b25cd35fc6d5"
uuid = "20febd7b-183b-5ae2-ac4a-720e7ce64774"
version = "0.4.1"

[[deps.Rmath]]
deps = ["Random", "Rmath_jll"]
git-tree-sha1 = "bf3188feca147ce108c76ad82c2792c57abe7b1f"
uuid = "79098fc4-a85e-5d69-aa6a-4863f24498fa"
version = "0.7.0"

[[deps.Rmath_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "68db32dff12bb6127bac73c209881191bf0efbb7"
uuid = "f50d1b31-88e8-58de-be2c-1cc44531875f"
version = "0.3.0+0"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "c02bd3c9c3fc8463d3591a62a378f90d2d8ab0f3"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.17"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.Setfield]]
deps = ["ConstructionBase", "Future", "MacroTools", "StaticArraysCore"]
git-tree-sha1 = "e2cc6d8c88613c05e1defb55170bf5ff211fbeac"
uuid = "efcf1570-3423-57d1-acb7-fd33fddbac46"
version = "1.1.1"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SimpleBufferStream]]
git-tree-sha1 = "874e8867b33a00e784c8a7e4b60afe9e037b74e1"
uuid = "777ac1f9-54b0-4bf8-805c-2214025038e7"
version = "1.1.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SimpleWeightedGraphs]]
deps = ["Graphs", "LinearAlgebra", "Markdown", "SparseArrays", "Test"]
git-tree-sha1 = "a8d28ad975506694d59ac2f351e29243065c5c52"
uuid = "47aef6b3-ad0c-573a-a1e2-d07658019622"
version = "1.2.2"

[[deps.SnoopPrecompile]]
deps = ["Preferences"]
git-tree-sha1 = "e760a70afdcd461cf01a575947738d359234665c"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.3"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SodiumSeal]]
deps = ["Base64", "Libdl", "libsodium_jll"]
git-tree-sha1 = "80cef67d2953e33935b41c6ab0a178b9987b1c99"
uuid = "2133526b-2bfb-4018-ac12-889fb3908a75"
version = "0.1.1"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "a4ada03f999bd01b3a25dcaa30b2d929fe537e00"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.1.0"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "6954a456979f23d05085727adb17c4551c19ecd1"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.12"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.9.0"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StatsFuns]]
deps = ["ChainRulesCore", "HypergeometricFunctions", "InverseFunctions", "IrrationalConstants", "LogExpFunctions", "Reexport", "Rmath", "SpecialFunctions"]
git-tree-sha1 = "ab6083f09b3e617e34a956b43e9d51b824206932"
uuid = "4c63d2b9-4356-54db-8cca-17b64c39e42c"
version = "1.1.1"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "ca4bccb03acf9faaf4137a9abc1881ed1841aa70"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.10.0"

[[deps.SuiteSparse]]
deps = ["Libdl", "LinearAlgebra", "Serialization", "SparseArrays"]
uuid = "4607b0f0-06f3-5cda-b6b1-a6196a1729e9"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+0"

[[deps.SymDict]]
deps = ["Test"]
git-tree-sha1 = "0108ccdaea3ef69d9680eeafc8d5ad198b896ec8"
uuid = "2da68c74-98d7-5633-99d6-8493888d7b1e"
version = "0.3.0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "94f38103c984f89cf77c402f2a68dbd870f8165f"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.11"

[[deps.URIs]]
git-tree-sha1 = "ac00576f90d8a259f2c9d823e91d1de3fd44d348"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.1"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.UnPack]]
git-tree-sha1 = "387c1f73762231e86e0c9c5443ce3b4a0a9a0c2b"
uuid = "3a884ed6-31ef-47d7-9d2a-63182c4928ed"
version = "1.0.2"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.Unzip]]
git-tree-sha1 = "ca0969166a028236229f63514992fc073799bb78"
uuid = "41fe7b60-77ed-43a1-b4f0-825fd5a5650d"
version = "0.2.0"

[[deps.Wayland_jll]]
deps = ["Artifacts", "Expat_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "ed8d92d9774b077c53e1da50fd81a36af3744c1c"
uuid = "a2964d1f-97da-50d4-b82a-358c7fce9d89"
version = "1.21.0+0"

[[deps.Wayland_protocols_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4528479aa01ee1b3b4cd0e6faef0e04cf16466da"
uuid = "2381bf8a-dfd0-557d-9999-79630e7b1b91"
version = "1.25.0+0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.WorkerUtilities]]
git-tree-sha1 = "cd1659ba0d57b71a464a29e64dbc67cfe83d54e7"
uuid = "76eceee3-57b5-4d4a-8e66-0e911cebbf60"
version = "1.6.1"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "93c41695bc1c08c46c5899f4fe06d6ead504bb73"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.10.3+0"

[[deps.XMLDict]]
deps = ["EzXML", "IterTools", "OrderedCollections"]
git-tree-sha1 = "d9a3faf078210e477b291c79117676fca54da9dd"
uuid = "228000da-037f-5747-90a9-8195ccbf91a5"
version = "0.4.1"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_libxkbfile_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "926af861744212db0eb001d9e40b5d16292080b2"
uuid = "cc61e674-0454-545c-8b26-ed2c68acab7a"
version = "1.1.0+4"

[[deps.Xorg_xcb_util_image_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "0fab0a40349ba1cba2c1da699243396ff8e94b97"
uuid = "12413925-8142-5f55-bb0e-6d7ca50bb09b"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll"]
git-tree-sha1 = "e7fd7b2881fa2eaa72717420894d3938177862d1"
uuid = "2def613f-5ad1-5310-b15b-b15d46f528f5"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_keysyms_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "d1151e2c45a544f32441a567d1690e701ec89b00"
uuid = "975044d2-76e6-5fbe-bf08-97ce7c6574c7"
version = "0.4.0+1"

[[deps.Xorg_xcb_util_renderutil_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "dfd7a8f38d4613b6a575253b3174dd991ca6183e"
uuid = "0d47668e-0667-5a69-a72c-f761630bfb7e"
version = "0.3.9+1"

[[deps.Xorg_xcb_util_wm_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xcb_util_jll"]
git-tree-sha1 = "e78d10aab01a4a154142c5006ed44fd9e8e31b67"
uuid = "c22f9ab0-d5fe-5066-847c-f4bb1cd4e361"
version = "0.4.1+1"

[[deps.Xorg_xkbcomp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxkbfile_jll"]
git-tree-sha1 = "4bcbf660f6c2e714f87e960a171b119d06ee163b"
uuid = "35661453-b289-5fab-8a00-3d9160c6a3a4"
version = "1.4.2+4"

[[deps.Xorg_xkeyboard_config_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_xkbcomp_jll"]
git-tree-sha1 = "5c8424f8a67c3f2209646d4425f3d415fee5931d"
uuid = "33bec58e-1273-512f-9401-5d533626f822"
version = "2.27.0+4"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+0"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e45044cd873ded54b6a5bac0eb5c971392cf1927"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.2+0"

[[deps.fzf_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "868e669ccb12ba16eaf50cb2957ee2ff61261c56"
uuid = "214eeab7-80f7-51ab-84ad-2988db7cef09"
version = "0.29.0+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.2.0+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsodium_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "848ab3d00fe39d6fbc2a8641048f8f272af1c51e"
uuid = "a9144af2-ca23-56d9-984f-0d03f7b5ccf8"
version = "1.0.20+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"

[[deps.xkbcommon_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Wayland_jll", "Wayland_protocols_jll", "Xorg_libxcb_jll", "Xorg_xkeyboard_config_jll"]
git-tree-sha1 = "9ebfc140cc56e8c2156a15ceac2f0302e327ac0a"
uuid = "d8fb68d0-12a3-5cfd-a85a-d49703b185fd"
version = "1.4.1+0"
"""

# ╔═╡ Cell order:
# ╟─471998e8-763b-11ed-0be4-e5293a2b29d4
# ╟─5a45f736-f603-4f01-b3ca-1d415d7864c4
# ╟─dfba9752-1545-4d51-94b6-739954d63afc
# ╟─a516549b-0418-4123-a654-fdd17359493e
# ╟─202ca719-465e-4f4f-b5b2-40f953857288
# ╟─42822b26-269e-4d9e-92a2-cd34ef2ca4be
# ╟─df640675-a439-4074-a6d9-df4f8289e446
# ╠═492616b4-0cea-41fe-8a8e-11c6d60200cb
# ╠═a86cabc6-77ba-4991-a02f-613219e8984c
# ╟─5e2dad4d-173a-474b-9fe7-f34048819ec9
# ╠═99a63307-966c-4057-88b2-0f1cf2f26f99
# ╠═9a9f4565-f094-4352-b54d-fafd391a8e88
# ╟─d57a24ed-1b8d-4195-bdd6-7ab8969627bd
# ╠═8eea449b-2935-4aa4-9eaf-70d0c0af5c3d
# ╟─7621e93a-a14a-47e0-9d49-9ce24ce0b9e0
# ╠═59178e2e-707c-4e1f-b2ea-54c3aa718956
# ╠═f1279ca2-26a3-4a3d-b50a-0ef6666eca5f
# ╟─12dc5ee9-1636-405b-b095-2a965d0ccaea
# ╟─4ab8a07d-da9b-4ccc-9bce-644f7da6de21
# ╠═4a29e5f3-5b28-41cd-af15-1a3e05ea6e83
# ╠═c3edb0ce-ecef-49a7-a799-b288a3c53d91
# ╠═ba3d585e-5118-480d-b09f-bbd2616022d3
# ╠═f3afc1e5-b9ca-4938-9fd6-33c3a6a1fc87
# ╟─8f0e6be9-440b-44af-8a4f-f8c4aefc2120
# ╠═29039bc9-f52f-4c3f-8457-8ad79a2ebc7a
# ╠═c4a122e2-a94e-4eaa-8c9b-44719b3be8d5
# ╠═75d93548-30be-4ad7-8e65-de3a8556c224
# ╟─3fe9dbbe-3ef2-44e2-9de8-a460eb06cdb8
# ╠═18d6f499-4c43-4448-ba1f-ccc70761c4cf
# ╟─301001e8-f48b-4198-aa70-d75b475dda5b
# ╠═a948c2fe-4c00-4b0d-a3fa-ae8ec0f02cff
# ╠═fba6c5c9-d6af-4a04-8bfa-dd83a1ca99dc
# ╠═8d011c5e-7924-455b-aac0-63afa674a562
# ╠═f941586e-2b88-4f7e-8f5f-a0f93ebe8eee
# ╠═0656f232-f00e-4da8-a6a1-2c7156d9d840
# ╠═d9505af6-18c8-4381-9574-3c03645a8a11
# ╟─14fa1f6d-2262-49f0-bc74-05e3974a29ca
# ╠═a277af58-6d4b-4389-8821-5824cc6e71b0
# ╟─2c99922f-86cb-462d-84c4-a4d7793f0716
# ╠═22ebd728-520f-4c85-9198-1c15e1366058
# ╠═c9d8c32f-4980-4e8c-942a-dce5136b4ad2
# ╟─591ae7b2-3fda-4301-b1d1-a97817246481
# ╠═0da7d875-c157-4998-bb16-55b949039923
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

using Braket, Test

@testset "Gate model simulator device" begin
    @testset "Device capabilities" begin
        ir_gen() = """{
        "braketSchemaHeader": {
            "name": "braket.device_schema.simulators.gate_model_simulator_device_capabilities",
            "version": "1"
        },
        "service": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.device_service_properties",
                "version": "1"
            },
            "executionWindows": [
                {"executionDay": "Everyday", "windowStartHour": "11:00", "windowEndHour": "12:00"}
            ],
            "shotsRange": [1, 10],
            "deviceCost": {"price": 0.25, "unit": "minute"},
            "deviceDocumentation": {
                "imageUrl": "image_url",
                "summary": "Summary on the device",
                "externalDocumentationUrl": "exter doc link"
            },
            "deviceLocation": "us-east-1",
            "updatedAt": "2020-06-16T19:28:02.869136"
        },
        "action": {
            "braket.ir.jaqcd.program": {
                "actionType": "braket.ir.jaqcd.program",
                "version": ["1"],
                "supportedOperations": ["x", "y"],
                "supportedResultTypes": [
                    {
                        "name": "resultType1",
                        "observables": ["observable1"],
                        "minShots": 2,
                        "maxShots": 4
                    }
                ]
            },
            "braket.ir.openqasm.program": {
                "actionType": "braket.ir.openqasm.program",
                "version": ["1"],
                "supportedOperations": ["x", "y"],
                "supportedResultTypes": [
                    {
                        "name": "resultType1",
                        "observables": ["observable1"],
                        "minShots": 2,
                        "maxShots": 4
                    }
                ],
                "supportPhysicalQubits": false,
                "supportedPragmas": ["braket_noise_bit_flip", "braket_unitary_matrix"],
                "forbiddenPragmas": [],
                "forbiddenArrayOperations": ["concatenation", "range", "slicing"],
                "requireAllQubitsMeasurement": true,
                "requireContiguousQubitIndices": false,
                "supportsPartialVerbatimBox": true,
                "supportsUnassignedMeasurements": true
            }
        },
        "paradigm": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.simulators.gate_model_simulator_paradigm_properties",
                "version": "1"
            },
            "qubitCount": 32
        },
        "deviceParameters": {
            "braketSchemaHeader": {
                "name": "braket.device_schema.simulators.gate_model_simulator_device_parameters",
                "version": "1"
            },
            "paradigmParameters": {}
        }
    }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.GateModelSimulatorDeviceCapabilities
    end
    @testset "Device parameters" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.simulators.gate_model_simulator_device_parameters",
                "version": "1"
            },
            "paradigmParameters": {
                "braketSchemaHeader": {
                    "name": "braket.device_schema.gate_model_parameters",
                    "version": "1"
                },
                "qubitCount": 1
            }
        }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.GateModelSimulatorDeviceParameters
    end
    @testset "Paradigm properties" begin
        ir_gen() = """{
            "braketSchemaHeader": {
                "name": "braket.device_schema.simulators.gate_model_simulator_paradigm_properties",
                "version": "1"
            },
            "qubitCount": 32
        }"""
        @test Braket.parse_raw_schema(ir_gen()) isa Braket.GateModelSimulatorParadigmProperties
    end
end

@enum MomentType_enum mtGate mtCompilerDirective mtInitializationNoise mtGateNoise mtNoise mtReadoutNoise
const MomentType_tostr = LittleDict{MomentType_enum, String}(mtCompilerDirective=>"compiler_directive", mtGate=>"gate", mtNoise=>"noise", mtInitializationNoise=>"initialization_noise", mtGateNoise=>"gate_noise", mtReadoutNoise=>"readout_noise")
const MomentType_toenum = LittleDict(zip(values(MomentType_tostr), keys(MomentType_tostr)))

struct MomentKey
    time::Int
    qubits::QubitSet
    moment_type::MomentType_enum
    noise_index::Int
end
Base.:(==)(k1::MomentKey, k2::MomentKey) = (k1.time == k2.time && k1.qubits == k2.qubits && k1.moment_type == k2.moment_type && k1.noise_index == k2.noise_index)

mutable struct Moments <: AbstractDict{MomentKey,Instruction}
    _moments::OrderedDict{MomentKey, Instruction}
    _max_times::Dict{Int, Int}
    _qubits::QubitSet
    _depth::Int
    _time_all_qubits::Int
    Moments() = new(OrderedDict{MomentKey, Instruction}(), Dict{Int, Int}(), QubitSet(), 0, -1)
end
Base.get(m::Moments, mk::MomentKey, default) = get(m._moments, mk, default)

function Moments(ixs::Vector{Instruction})
    m = Moments()
    foreach(ix->push!(m, ix), ixs)
    return m
end

Base.keys(m::Moments)   = keys(m._moments)
Base.values(m::Moments) = values(m._moments)
Base.length(m::Moments) = m._depth

function Base.show(io::IO, m::Moments)
    println(io, "Circuit moments:")
    println(io, "Max times: ", m._max_times)
end

function Base.push!(m::Moments, ix::Instruction{O}, mt::MomentType_enum=mtGateNoise, noise_index::Int=0) where {O<:CompilerDirective}
    qubits = QubitSet(keys(m._max_times))
    time   = _update_qubit_time!(m, qubits)
    key    = MomentKey(time, QubitSet(), mtCompilerDirective, 0)
    m._moments[key] = ix
    m._depth = max(m._depth, time+1)
    m._time_all_qubits = time
end

function Base.push!(m::Moments, ix::Instruction{O}, mt::MomentType_enum=mtGateNoise, noise_index::Int=0) where {O<:Noise}
    add_noise!(m, ix, "noise", noise_index)
    return m
end

function Base.push!(m::Moments, ix::Instruction{O}, mt::MomentType_enum=mtGateNoise, noise_index::Int=0) where {O}
    qubits = QubitSet(ix.target)
    time   = _update_qubit_time!(m, qubits)
    key    = MomentKey(time, qubits, mtGate, noise_index)
    m._moments[key] = ix
    union!(m._qubits, qubits)
    m._depth = max(m._depth, time+1)
    return m
end
Base.push!(m::Moments, ixs::Vector{Instruction{O}}, mt::MomentType_enum=mtGateNoise, noise_index::Int=0) where {O} = (foreach(ix->push!(m, ix, mt, noise_index), ixs); return m)

function add_noise!(m::Moments, ix::Instruction{O}, input_type::String="noise", noise_index::Int=0) where {O}
    qubits = QubitSet(ix.target)
    time   = max(0, prod(get(m._max_times, q, -1) for q in qubits, init=1))
    if MomentType_toenum[input_type] == mtInitializationNoise
        time = 0
    end
    search_key = MomentKey(time, qubits, MomentType_toenum[input_type], noise_index)
    while any(k == search_key for k in keys(m._moments)) # cannot use haskey because of hashing! 
        noise_index += 1
        search_key = MomentKey(time, qubits, MomentType_toenum[input_type], noise_index)
    end
    key = MomentKey(time, qubits, MomentType_toenum[input_type], noise_index)
    m._moments[key] = ix
    union!(m._qubits, qubits)
    return m
end

function _update_qubit_time!(m::Moments, qubits::QubitSet)
    current_max_times = vcat([get!(m._max_times, q, -1) for q in qubits], m._time_all_qubits)
    time = maximum(current_max_times) + 1
    for q in qubits
        m._max_times[q] = time
    end
    return time
end

function sort_moments!(m::Moments)
    moment_copy    = OrderedDict{MomentKey, Instruction}()
    sorted_moments = OrderedDict{MomentKey, Instruction}()
    readout_keys   = MomentKey[]
    init_keys      = MomentKey[]
    # GATE, NOISE, GATE_NOISE
    noise_keys     = MomentKey[]
    for (key, ix) in m._moments
        if key.moment_type == mtInitializationNoise
            push!(init_keys, key)
        elseif key.moment_type == mtReadoutNoise
            push!(readout_keys, key)
        else
            push!(noise_keys, key)
        end
        moment_copy[key] = ix
    end
    for key in init_keys
        sorted_moments[key] = moment_copy[key]
    end
    for key in noise_keys
        sorted_moments[key] = moment_copy[key]
    end
    max_time = max(length(m) - 1, 0)
    for key in readout_keys
        new_key = MomentKey(max_time, key.qubits, mtReadoutNoise, key.noise_index)
        sorted_moments[new_key] = moment_copy[key]
    end
    m._moments = sorted_moments
    return m
end

function time_slices(m::Moments)
    m = sort_moments!(m)
    time_slices = OrderedDict{Int, Vector{Instruction}}()
    for (k, ix) in m._moments
        ixs = get!(time_slices, k.time, [])
        push!(ixs, ix)
        time_slices[k.time] = ixs
    end
    return time_slices
end

# Noises 

```@docs
Noise
Kraus
BitFlip
PhaseFlip
PauliChannel
AmplitudeDamping
PhaseDamping
Depolarizing
TwoQubitDephasing
TwoQubitDepolarizing
GeneralizedAmplitudeDamping
TwoQubitPauliChannel
MultiQubitPauliChannel
```

# AWS

This section describes functions which are generic over several types which represent various workflows running on AWS - whether jobs, tasks, or something else.

```@docs
arn
metadata
state
cancel
result
```

# PyBraket 

`PyBraket.jl` is used to interface with the Python BDK to provide functionality that is not yet implemented in Julia.
Currently, there are two such features:

- Local simulation of analog Hamiltonian simulators (the `"braket_ahs"` local simulator)
- Unpickling of results from Amazon Braket Hybrid Jobs

```@docs
```

# Circuits 

The [`Circuit`](@ref) struct is used to represent a gate-based quantum computation on qubits. `Circuit`s can be built up iteratively by 
applying them as functors to operations like so:

```julia-repl
julia> c = Circuit();

julia> c(H, Qubit(0));

julia> α = FreeParameter(:alpha);

julia> c(Rx, Qubit(1), α);

julia> c(Probability); # measures probability on all qubits
```

This functor syntax can also be used to set the value of free parameters:

```julia-repl
julia> α = FreeParameter(:alpha);

julia> θ = FreeParameter(:theta);

julia> circ = Circuit([(H, 0), (Rx, 1, α), (Ry, 0, θ), (Probability,)]);

julia> new_circ = circ(theta=2.0, alpha=1.0);

julia> new_circ2 = circ(0.5); # sets the value of all FreeParameters to 0.5
```

```@docs
Circuit
Circuit()
Circuit(::Braket.Moments, ::Vector, ::Vector{Result}, ::Vector)
Circuit(::AbstractVector)
Qubit
QubitSet
Braket.Operator
Braket.QuantumOperator
FreeParameter
depth
qubits
qubit_count
measure
Measure
```

## Output to IR
`Braket.jl` provides several functions to transform a `Circuit` into IR which
will be transmitted to Amazon managed QPUs or simulators. Currently, two output
formats supported are [OpenQASM](https://docs.aws.amazon.com/braket/latest/developerguide/braket-openqasm.html),
and JAQCD (an Amazon Braket native IR). You can control how IR translation is done
through the global variable [`IRType`](@ref) and, if using OpenQASM,
[`OpenQASMSerializationProperties`](@ref).

```@docs
Braket.Instruction
ir
IRType
OpenQASMSerializationProperties
```

# Analog Hamiltonian Simulation

```@docs
AnalogHamiltonianSimulation
AnalogHamiltonianSimulation(::Braket.AtomArrangement, ::Braket.Hamiltonian)
discretize
Hamiltonian
AtomArrangementItem
AtomArrangementItem(::Tuple{Number, Number})
TimeSeriesItem
TimeSeries
Field
ShiftingField
DrivingField
ir(::AnalogHamiltonianSimulation)
```

# Gates 

The gates are used to represent various gate operations on qubits.
Gates should implement the following functions:

```julia
label
qubit_count
n_angles
angles
chars
ir_typ
ir_str
targets_and_controls
```

- `label` is used to generate the gate's representation in OpenQASM3.
- `chars` is used when pretty-printing the gate as part of a `Circuit`.
- `n_angles` is the number of angles present in the gate and `angles` is an accessor method for those angles -- gates without angles should return an empty tuple `()`.
- `ir_typ` is a mapping to the gate's sibling in the `IR` submodule.
- `ir_str` is the gate's full OpenQASM3 representation.
- `targets_and_controls` should accept the gate and a `QubitSet` of qubits to apply it to, and generate from this the list of control qubits and target qubits.  

New gates with angle parameters should be subtypes of `AngledGate{N}`, where `N` is the number of angle parameters. They should have one member, `angle::NTuple{N, Union{Float64, FreeParameter}}`.

```@docs
Gate
AngledGate
H
I
X
Y
Z
PhaseShift
Rx
Ry
Rz
V
Vi
T
Ti
S
Si
CNot
CV
CY
CZ
XX
XY
YY
ZZ
ECR
CPhaseShift
CPhaseShift00
CPhaseShift01
CPhaseShift10
Swap
PSwap
ISwap
CSwap
CCNot
Unitary
```

# Amazon Braket Hybrid Jobs 

Amazon Braket Hybrid Jobs allow you to easily run hybrid classical-quantum workflows on AWS managed infrastructure by submitting your own scripts which run in a Docker container, either one provided by Amazon Braket or one that is made available to you through Amazon ECR. To learn more about Amazon Braket Hybrid Jobs, see the [Developer Guide](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs.html), and to learn how to provide your own Docker images, see the [Bring Your Own Container (BYOC) guide](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-byoc.html).

You can also run a [`LocalJob`](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-local-mode.html), which runs the container and your script on your compute hardware (your laptop, or an EC2 instance, for example), using `LocalQuantumJob`. This can be useful for debugging and performance tuning purposes.

```@docs
Job
AwsQuantumJob
LocalQuantumJob
AwsQuantumJob(::String, ::String)
LocalQuantumJob(::String, ::String)
log_metric
metrics
logs
download_result
@hybrid_job
```

# Tasks

"Tasks" are units of work that run on AWS managed devices, such as managed simulators and QPUs. See the Braket documentation about [how tasks work](https://docs.aws.amazon.com/braket/latest/developerguide/braket-how-it-works.html) and [submitting tasks](https://docs.aws.amazon.com/braket/latest/developerguide/braket-submit-tasks.html) for more information.

```@docs
AwsQuantumTask
AwsQuantumTask(::String, ::Union{Braket.AbstractProgram, Circuit, AnalogHamiltonianSimulation})
AwsQuantumTaskBatch
AwsQuantumTaskBatch(::String, ::Vector{<:Union{Braket.AbstractProgram, Circuit}})
results(::AwsQuantumTaskBatch)
```

# Observables 

```@docs
Braket.Observables.Observable
Braket.Observables.X
Braket.Observables.Y
Braket.Observables.Z
Braket.Observables.H
Braket.Observables.I
Braket.Observables.TensorProduct
Braket.Observables.HermitianObservable
Braket.Observables.Sum
```

# Results
```@docs
Braket.Result
AdjointGradient
AdjointGradient(::Observable, ::Vector{QubitSet}, ::Vector) 
AdjointGradient(::Circuit, ::Observable, ::Vector{QubitSet}, ::Vector{String}) 
Expectation
Expectation(::Any, ::Any)
Expectation(::Circuit, ::Any, ::Any)
Variance
Variance(::Any, ::Any)
Variance(::Circuit, ::Any, ::Any)
Sample
Sample(::Any, ::Any)
Sample(::Circuit, ::Any, ::Any)
Amplitude
Amplitude(::String)
Amplitude(::Circuit, ::Any)
Probability
Probability(::Any)
Probability(::Circuit, ::Any)
DensityMatrix
DensityMatrix(::Any)
DensityMatrix(::Circuit, ::Any)
StateVector
StateVector(::Circuit)
```

# Braket.jl Documentation

**Braket.jl is not an officially supported AWS product.**

## Introduction

This is the documentation for the `Braket.jl` package, a Julia reimplementation of the [`Amazon Braket SDK`](https://github.com/aws/amazon-braket-sdk-python).
Please also refer to the documentation of that package and the [`official Amazon Braket documentation`](https://docs.aws.amazon.com/braket/) - if your question
isn't answered here, it may be at one of those two locations.

This is *experimental* software, and support may be discontinued in the future. For a fully supported SDK, please use
the [Python SDK](https://github.com/aws/amazon-braket-sdk-python). We may change, remove, or deprecate parts of the API when making new releases.
Please review the [CHANGELOG](https://github.com/awslabs/Braket.jl/blob/main/CHANGELOG.md) for information about changes in each release. 

## What is Amazon Braket?

Amazon Braket is a fully-managed AWS service that helps researchers, scientists, and developers get started with quantum computing. Quantum computing has the potential to solve computational problems that are beyond the reach of classical computers because it harnesses the laws of quantum mechanics to process information in new ways.

## Is `Braket.jl` the same thing as Amazon Braket?

No. `Braket.jl` is a "software development kit" (SDK) written in [Julia](https://julialang.org/) which allows you to interact with the Amazon Braket service in a similar way to the [Python SDK](https://github.com/aws/amazon-braket-sdk-python). You can build gate-based quantum circuits, analog Hamiltonian simulations, and other constructs and then submit them to the Amazon Braket service to run on AWS managed devices/infrastructure or run them locally. 

## Quick start

In order to use most features of Amazon Braket, you will *not* need a Python installation or to install the Python SDK or any of its dependencies.
There are some exceptions - if you want to run a [`LocalJob`](https://docs.aws.amazon.com/braket/latest/developerguide/braket-jobs-local-mode.html)
or run a task on one of the [`Braket local simulators`](https://github.com/aws/amazon-braket-default-simulator-python) you will need to use the Python
interoperability package `PyBraket.jl`, which comes with `Braket.jl` as a sub-package in the same repo. Refer to the `PyBraket.jl` `README` for more information.

If you want to run tasks or Amazon Braket Hybrid Jobs on AWS managed devices, you will need to have an AWS account and to [`onboard to Braket`](https://docs.aws.amazon.com/braket/latest/developerguide/braket-enable-overview.html).

## Examples and tutorials

Many examples of quantum workflows are available at the [Amazon Braket Examples repo](https://github.com/aws/amazon-braket-examples/). These tutorials cover most aspects of the service and are written in Python, but a conversion to Julia is usually straightforward. There are also examples provided in the `examples` folder of this repository.

# Local Simulators

Local simulators allow you to *classically* simulate your [`Circuit`](@ref) or `OpenQasmProgram`
on local hardware, rather than sending it to the cloud for on-demand execution. Local simulators
can run task *batches* in parallel using multithreading. Gate-based simulators are provided in the
[`BraketSimulator.jl`](https://github.com/amazon-braket/braketsimulator.jl) package.

Developers wishing to implement their own `LocalSimulator` should extend the `simulate` function.
New simulator backends must be subtypes of the `AbstractLocalSimulator` type.
Additionally, new simulators should "register" themselves in `Braket._simulator_devices` in their
parent module's `__init__` function so that they can be referred to by name, like so:

```julia
module NewLocalSimulator

using Braket

struct NewSimulator <: Braket.AbstractLocalSimulator 
# implementation of a new local simulator backend
# with name "new_simulator"
end

function Braket.simulate()
    # simulation implementation here
end

function __init__()
    Braket._simulator_devices[]["new_simulator"] = NewLocalSimulator()
end

end
```

Then users can use the new simulator like so:

```julia
using NewLocalSimulator, Braket

dev = LocalSimulator("new_simulator")
simulate(dev, task_specification, args...; kwargs...)
```

```@docs
Braket._simulator_devices
Braket.LocalQuantumTask
Braket.LocalQuantumTaskBatch
LocalSimulator
simulate
```
